// BackQuote `
// ©2011-23 by Alex Glebe
# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include "backquote/private.h"

_Atomic ( size_t ) PLOBackQuote_constrstat = 0 ;

# endif // LISP2D_CONSTRSTAT

# include "backquote/public.h"

# ifdef  LISP2D_CONSTRSTAT

void  PLOBackQuote_constrstat_Inc  ( void  ) {
  ++  PLOBackQuote_constrstat  ;
}

size_t  PLOBackQuote_constrstat_Value  ( void  ) {
  return  PLOBackQuote_constrstat  ;
}

# endif // LISP2D_CONSTRSTAT

# include "symbolc.h"

# define  PLOBackQuote_staticTypeOf Lisp2D_PLOBackQuote_staticTypeOf
ParaLispObject  * PLOBackQuote_staticTypeOf ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  & plosbackquote  . plo  ;
}

# include "sharedc.h"
# include "backquote/struct.h"
# include "backquote/inline.h"
# include "plostream/public.h"

# define  PLOBackQuote_item PLOBackQuote_item_pub
  
# define  PLOBackQuote_Cout Lisp2D_PLOBackQuote_Cout
static  void  PLOBackQuote_Cout  ( PLOBackQuote * const me ,
  FuncCoutToInterpretHuman  funccout , PLOStream  const * const  sp ,
  bool  flag2p  , Vector ( StackPLOP ) * const lookingp  ) {
  bool  flagp  = flag2p  ;
  if  ( Printed3Points  ( & me -> plo , sp , & flagp ,  lookingp ) )  
    return  ;
  PLOStreamPushWChar  ( sp  , L'`' ) ;
  Vector_PushByValue ( StackPLOP ) (  lookingp , & me -> plo ) ;
  funccout ( me -> item ,  sp , &  flagp  ,  lookingp ) ;
  VectorPop(StackPLOP) (  lookingp ) ;
}

bool  PLOBackQuote_staticisBADCopyPrivate ( ParaLispObject const * const  me , 
  ParaLispObject  * * const resultp  ) {
  { PLOBackQuote * const  res  = aligned_alloc ( _Alignof ( PLOBackQuote ) , sizeof ( PLOBackQuote ) ) ;
    if  ( res ) {
      PLOBackQuote_Init(res);
      PLOBackQuote_SetItem ( res ,
        ParaLispObjectToPLOBackQuoteConst(me) -> item ) ;
      ParaLispObject_virtualPushAsNew (&res ->  plo ) ;
      ( * resultp )  = &res->plo ;
      return  false ;
    }
  }
  return  true  ; 
}

void  PLOBackQuote_staticGCDeclareContent ( ParaLispObject * const me ) {
  ParaLispObject_virtualDeclareForGC (     ParaLispObjectToPLOBackQuote(me)->item) ;
}

# include "nilc.h"

void  PLOBackQuote_Init( PLOBackQuote * const me ) {
  me->item = &  plonil.plo ;
  { VirtualTypePointer  vtp = { . addr = { . p = me } , . type = TypeGlobalListMemberBackQuotePrivate } ;
    ParaLispObject_InitVTP(&me->plo ,vtp );
  }
# ifdef  LISP2D_CONSTRSTAT
  PLOBackQuote_constrstat_Inc ( ) ;
# endif
}

void  PLOBackQuote_staticCoutToInterpret ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector  ( StackPLOP ) * const h ) {
  PLOBackQuote_Cout  ( ParaLispObjectToPLOBackQuote ( ( ParaLispObject * ) me  ) ,
    ParaLispObject_CoutToInterpret , s , flag2pprinted , h ) ;
}

void  PLOBackQuote_staticCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector  ( StackPLOP )  * const h ) {
  PLOBackQuote_Cout  ( ParaLispObjectToPLOBackQuote ( ( ParaLispObject * ) me  ) ,
    ParaLispObject_CoutToHuman , s , flag2pprinted , h ) ;
}

# include "cons/inline.h"
# include "stcl/classc.h"
# include "stcl/public.h"
# include "stcl/inline.h"

// 'backquote newobject (2 + 2) -> `4
TaskForThread Lisp2Dbimbackquotebackquote2  ( StackClusterPrivate  * const stclpp  ) {
  PLOBackQuote  * const mep  =ParaLispObjectToPLOBackQuote ( StackClusterPrivate_ThisTop(stclpp))  ;
  PLOBackQuote_SetItem ( mep , CCAR ( StackClusterPrivate_ArgTop(stclpp)) ) ;
  StackClusterPrivate_SetResult (stclpp,& mep -> plo  ) ;
  return  TaskForThread_Analyse ;
}

// backquote setf backquote
TaskForThread Lisp2Dbimbackquotesetf2 ( StackClusterPrivate * const stclpp ) {
  PLOBackQuote  * const mep  =ParaLispObjectToPLOBackQuote ( StackClusterPrivate_ThisTop(stclpp))  ;
  ParaLispObject  * const argp =  CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  if  ( not  IsNotBackQuote (  stclpp  ,  argp ) ) {
    PLOBackQuote_Set (  mep , ParaLispObjectToPLOBackQuote ( argp ) ) ;
    StackClusterPrivate_SetResult (stclpp ,& mep -> plo  ) ;
  }
  return  TaskForThread_Analyse ;
}

// backquote swap backquote
TaskForThread Lisp2Dbimbackquoteswap2 ( StackClusterPrivate * const stclpp ) {
  PLOBackQuote  * const mep = ParaLispObjectToPLOBackQuote (
    StackClusterPrivate_ThisTop(stclpp))  ;
  ParaLispObject  * const argp = CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  if  ( not  IsNotBackQuote (  stclpp  ,  argp ) ) {
    if  ( IsConst (   stclpp ,  argp ) )
      return  TaskForThread_Analyse ;
    PLOBackQuote_Swap  (  mep , ParaLispObjectToPLOBackQuote ( argp ) ) ;
    StackClusterPrivate_SetResult (stclpp ,& mep->plo  ) ;
  }
  return  TaskForThread_Analyse ;
}

# include "boolean.h"

TaskForThread Lisp2Dbimnilbackquotep2 ( StackClusterPrivate * const stclpp ) {
  ParaLispObject  * const xp = CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  StackClusterPrivate_SetResult (stclpp ,( BackQuoteP (  xp )  ?
    xp :
    &  plofalse.plo )) ;
  return  TaskForThread_Analyse ;
}

# include "newobject.h"

bool  IsNotBackQuote  ( StackClusterPrivate  * const stclp  , ParaLispObject * const  xp ) {
  tUniversalIsNotType ar  = {
    . stclp = stclp ,
    . xp  = xp  ,
    . typetype  = TypeGlobalListMemberBackQuotePrivate  ,
    . res = false ,
  } ;
  UniversalIsNotTypess  ( & ar  ) ;
  return  ar  . res ;
} 

ParaLispObject  * PLOBackQuote_staticClassDef  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  ploclassdefBackQuote  ;
}

ParaLispObject  * PLOBackQuote_staticClassParents  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return   ploclassparentsBackQuote  ;
}

void  PLOBackQuote_Destr ( PLOBackQuote * const me ) {
  ParaLispObject_staticDestr(&me->plo);
}

void  PLOBackQuote_Swap  ( PLOBackQuote * const me , PLOBackQuote * const xp  ) {
  if ( me not_eq xp ) {
    ParaLispObject  * const myitem  = me -> item ;
    me -> item = xp -> item ;
    xp -> item = myitem ;
  }
}

void  PLOBackQuote_staticDestr  ( ParaLispObject * const me ) {
  PLOBackQuote_Destr  ( ParaLispObjectToPLOBackQuote ( me  ) ) ;
}

# include "shared/inline.h"
