// Lisp2D - Build-in method
// ©2011-23 by Alex Glebe
# include "define.h"
# include "bimc.h"
# include "errorstra.h"

# ifdef LISP2D_CONSTRSTAT
  _Atomic ( size_t  ) NSBIF_constrstat = 0 ;

  size_t  NSBIF_constrstat_Value ( void  ) {
    return  NSBIF_constrstat ;
  }

  void  NSBIF_constrstat_Inc ( void  ) {
    ++  NSBIF_constrstat ;
  }
# endif

void  BIFPrivateInit ( BIFPrivate * const me , int const at ,
  wchar_t volatile const * const na , int const ct , BoolCheckThis const fcheckthis ,
  BoolThisIsConst const flagthisconst ) {
  me -> classtype = ct ;
  me -> argumtype = at  ;
  me -> flagToCheckThisType = fcheckthis ;
  me -> flagThisConst = flagthisconst ;
  StringConstrCStr ( WideChar ) ( & me  ->  wname , na , true ) ;
  me  ->  symbolClassName = NULL  ;
  me  ->  funcbining1 = NULL  ;
  ParaLispObject_InitCVTP ( & me  ->  plo , true , ( VirtualTypePointer ) {
    . addr = { . p = me } , . type = TypeGlobalListMemberBIFPrivate } ) ;
# ifdef LISP2D_BIMSTAT    
  Lisp2DStatisticsConstructor  ( & me -> statstatc ) ;  
# endif    
  me  ->  flagExtraThread = false ;
}

void  BIFPrivateDestr ( BIFPrivate * const me ) {
  StringDestr ( WideChar  ) ( & me -> wname ) ;
# ifdef  LISP2D_BIMSTAT  
  Lisp2DStatisticsDestructor  ( & me -> statstatc ) ;
# endif  
  ParaLispObject_staticDestr  ( & me  ->  plo ) ;
}

// ! to make static PLOBIF..

PLOBIF  *   plobimcomplexmultiply = NULL ;
PLOBIF  *   plobimcomplexmultiplysetf = NULL ;
PLOBIF  *   plobimcomplexplus = NULL ;
PLOBIF  *   plobimvectormult  = NULL ;
PLOBIF  *   plobimvectormultsetf  = NULL ;
PLOBIF  *   plobimstringplussetf  = NULL ;
PLOBIF  *   plobimcomplexplussetf = NULL ;
PLOBIF  *   plobimcomplexminussetf  = NULL ;
PLOBIF  *   plobimnilprogn  = NULL ;  

bool  BIFp ( ParaLispObject const * const xp  ) {
  return   ParaLispObject_Type  ( xp  ) == TypeGlobalListMemberBIFPrivate ;
}

ParaLispObject  * PLOBIF_staticTypeOf ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  & plosbif . plo ;
}
  
# include "plostream/public.h"
  
void  PLOBIF_staticCoutToInterpret ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool  _ __attribute__ ((unused)) , Vector  ( StackPLOP ) * _2 __attribute__ ((unused)) ) {
  PLOStreamPushWideCharArray  ( s , (PArray_wchar_c) { (wchar_t const(*)[])&L"BIM("});
  PLOBIF const * const meb = ParaLispObjectToPLOBIFConst  ( me  ) ;
  if  ( meb ->  base  . symbolClassName ) 
    PLOStreamPushWideCharArray  ( s , StringCArr  ( WideChar  ) ( PLOSymbolCValue  ( meb -> base. symbolClassName ) ) ) ;
  else  
    PLOStreamPushWChar(s,L'?');
  PLOStreamPushWChar(s,L',');
  PLOStreamPushWideCharArray  ( s , (PArray_wchar_c) { (  wchar_t const ( * ) [ ] ) (
    StringCStr ( WideChar ) ( & meb -> base. wname ) ) } ) ;
  PLOStreamPushWChar(s,L')');
}

void  PLOBIF_Destr(PLOBIF * const me ){
  BIFPrivateDestr ( & me -> base ) ;
}

void  PLOBIF_staticCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool flag2pprinted  , Vector ( StackPLOP )  * const h ) {
  PLOBIF_staticCoutToInterpret (  me ,     s ,  flag2pprinted  ,  h ) ;
}

ParaLispObject  * PLOBIF_staticClassDef  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  ploclassdefbif  ;
}

ParaLispObject  * PLOBIF_staticClassParents  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  ploclassparentsbif  ;
}

void  PLOBIF_Init  ( t_PLOBIF_Init const arg ) {
  BIFPrivateInit  ( & arg . me -> base , arg .  at , arg . na , arg . ct , arg . fcheckthis , arg . flagthisconst ) ;
# ifdef  LISP2D_CONSTRSTAT
  NSBIF_constrstat_Inc  ( ) ;
# endif
# ifdef  LISP2D_BIMSTAT
  if  ( Lisp2DStatisticsIsBADInit ( & arg . me -> base.statstatc , 2 ) )
    ErrorStra  ((PArray_wchar_c){(wchar_t const (*)[])&
      L"PLOBIF_Init:statstat.isBADInit(ss)" }) ;
# endif
}

void  PLOBIF_staticGCDeclareContent ( ParaLispObject * const me ) {
  PLOBIF * const b = ParaLispObjectToPLOBIF(me);
  if  ( b->base.symbolClassName )
    PLOSymbolDeclareForGC((ParaLispObject * )( &b->base.symbolClassName->plo));
}

# include "stcl/classc.h"
# include "boolean.h"
# include "cons/inline.h"
# include "stcl/public.h"
# include "stcl/inline.h"

// nil bifp
TaskForThread bimnilbifp ( StackClusterPrivate * const stclpp  ) {
  ParaLispObject  * const xp = CCAR ( StackClusterPrivate_ArgTop ( stclpp ) ) ;
  StackClusterPrivate_SetResult ( stclpp ,
    ( BIFp  ( xp ) ?
      xp :
      & plofalse . plo ) ) ;
  return  TaskForThread_Analyse ;
}

void PLOBIF_staticDestr  ( ParaLispObject * const me ) {
  PLOBIF_Destr  ( ParaLispObjectToPLOBIF ( me  )  ) ;
}
# include "widestring/inline.h"
