// Lisp2D 
// ©2020-3 by Alex Glebe
# include "define.h"
# ifdef  LISP2D_BIMSTAT
# include "bimc.h"
# include "bimstatshow.h"
# include "random/stat.h"
# include "sharedc.h"
# include "shared/inline.h"

typedef struct  Lisp2D_structbimstat structbimstat ;
struct  Lisp2D_structbimstat {
  wchar_t volatile const * bimclassname  ;
  wchar_t volatile const * bimmethodwnamep ;
  Statistics_t * pcstat2 ;
} ;

# define  structbimstatless Lisp2D_structbimstatless
static  int structbimstatless ( void  const * const l , void  const * const r ) {
  return  ( Lisp2DStatisticsCLess ( ( ( structbimstat const * ) l ) -> pcstat2 ,
    ( ( structbimstat const * ) r ) ->  pcstat2 ) ? 1 : -1 ) ; 
}

# include "stack-define.h"

LISP2DSTACKSTRUCTTYPE ( structbimstat )
LISP2DSTACKSTRUCT ( structbimstat , structbimstat )
static  LISP2DSTACKPUSHBYVALUE  ( structbimstat , structbimstat , )
LISP2D_PROTO_STACK_FREE ( structbimstat )
static  LISP2DSTACKDESTRUCTOR ( structbimstat , structbimstat )
LISP2D_STACK_FREE ( structbimstat , structbimstat )
inline  LISP2DSTACKCONSTRUCTORDEFAULT ( structbimstat )
static  LISP2DSTACKCEND ( structbimstat , structbimstat )

# define  PushBimStat Lisp2D_PushBimStat
static  void  PushBimStat ( Vector  ( structbimstat ) * const vp ,
  structbimstat * const ep )  {
  if  ( Lisp2DStatisticsCount ( ep -> pcstat2 ) )
    Vector_PushByValue  ( structbimstat ) ( vp , * ep ) ;  
}

typedef struct  Lisp2D_structmutexstat structmutexstat ;
struct  Lisp2D_structmutexstat {
  wchar_t const * mutexnamec  ;
  size_t  f ;
  size_t  w ;
} ;

# include <cast.h>

# define  structmutexstatless Lisp2D_structmutexstatless
static  int structmutexstatless ( void  const * const l0 ,
  void  const * const r0 ) {
  structmutexstat const * const l = ( structmutexstat const * ) l0  ;
  structmutexstat const * const r = ( structmutexstat const * ) r0  ;
  return
    ( ( ( size_cast_longdouble ( l ->  f ) /
          size_cast_longdouble ( l ->  f + ( l ->  w ) ) )  <
        ( size_cast_longdouble ( r ->  f ) /
          size_cast_longdouble ( r ->  f + ( r ->  w ) ) ) ) ? 1 : -1 ) ;
}

LISP2DSTACKSTRUCTTYPE ( structmutexstat )
LISP2DSTACKSTRUCT ( structmutexstat , structmutexstat )
static  LISP2DSTACKPUSHBYVALUE  ( structmutexstat , structmutexstat , )
LISP2D_PROTO_STACK_FREE ( structmutexstat )
static  LISP2DSTACKDESTRUCTOR ( structmutexstat , structmutexstat )
LISP2D_STACK_FREE ( structmutexstat , structmutexstat )
inline  LISP2DSTACKCONSTRUCTORDEFAULT ( structmutexstat )
static  LISP2DSTACKCEND ( structmutexstat , structmutexstat )

# define  PushMutexStat Lisp2D_PushMutexStat
static  void  PushMutexStat ( Vector  ( structmutexstat ) * const vp  , structmutexstat * const ep ) {
  if  ( ep -> f + ep -> w > 0 )
    Vector_PushByValue  ( structmutexstat ) ( vp  , * ep ) ; 
}
    
# include "cons/private.h"
# include "complex/inline.h"
# include <stdlib.h>
# include "env/public.h"
# include "inner-history/public.h"

void  BIMStatShow ( void  ) {
  fputws  ( L"\n---BIM Stat---\n" , stderr  ) ;
  {
    
// ! to Stack ?
    
    Vector  ( structbimstat ) allbifstatc ;
    VectorInit  ( structbimstat ) ( & allbifstatc , false ) ;
    { ParaLispObject  * i = ParaLispObjectFromMember (
        GlobalListFirst ( & GlobalListOfObjects ) ) ;
      while (  i  ) {
        if  ( BIFp  ( i ) and
          Lisp2DStatisticsCount ( PLOBIF_CStatistc  (
              ParaLispObjectToPLOBIF  ( i ) ) ) ) {
          PLOSymbol const * const  symbolclassname =
            PLOBIF_CSymbolClassName ( ParaLispObjectToPLOBIF ( i ) ) ;
          if(symbolclassname){
            structbimstat const el  = { StringCStr  ( WideChar  ) (
                PLOSymbolCValue  ( symbolclassname ) ) ,
              StringCStr  ( WideChar  ) ( PLOBIF_Name ( ParaLispObjectToPLOBIF ( i ) ) )  ,
              PLOBIF_Statistc ( ParaLispObjectToPLOBIF ( i ) ) } ;
            Vector_PushByValue  ( structbimstat ) ( & allbifstatc , el  ) ; 
          } 
        }
        i  = ParaLispObjectFromMember ( GlobalListMemberNext(&  i -> base ) ) ;
      } 
    } // i
  // ! dont use local strings: only global
  
  { structbimstat el  = { L" " , L"GC" , & GCstat } ;
    PushBimStat(&allbifstatc,&el ) ; 
  }

  { structbimstat el = { L" " , L"GCSymbols" , & GCstatSymbols};
    PushBimStat(&allbifstatc,&el ) ;
  }

  { structbimstat el  = { L" " ,  L"CreateLinks" ,
    & statCreateLinks2};
    PushBimStat(&allbifstatc,&el ) ;
  }

  { structbimstat el  = { L"ULong"  , L"Square" , & statULongSquare } ;
    PushBimStat ( & allbifstatc , & el  ) ;
  }

  { structbimstat el = { L"Complex" , L"Complex_AddConst" , & statComplexOperatorPlusEq      };
    PushBimStat(&allbifstatc,&el ) ;
  }

  { structbimstat el = { L"Complex" , L"operator  *=(Complex const  &  x)&" , & statComplexOperatorMulEq};
    PushBimStat(&allbifstatc,&el ) ;
  }

  { structbimstat el={ L"Complex" , L"operator  /=(Complex const  &  x)&" , & statComplexOperatorDivEq};
    PushBimStat(&allbifstatc,&el ) ;
  }

  { structbimstat el = { L"PLOComplex" , L"operator  delete(void*)" , & statComplexDelete } ;
    PushBimStat( &allbifstatc  , &el  ) ;
  }

  { structbimstat el={ L"ULong" , L"DivWithOstBig(ULong const &  ulongl,ULong  & ulongost)&" , & statULongDivWithOstBig };
    PushBimStat(&allbifstatc ,&el ) ;
  }
    { structbimstat el = { L"ULong" , L"DivWithOstBigFast(ULong const *  ulongl,ULong  & ulongost)&" ,
        & statULongDivWithOstBigFast  } ;
      PushBimStat( &allbifstatc  , &el  ) ;
    }
    { structbimstat el = { L"ULong" , L"DivWithOstBig(ULong &&  ulongl,ULong  & ulongost)&" ,
        & statULongDivWithOstBig2      };
      PushBimStat(&allbifstatc ,&el ) ;
    }
    // ! dont use local strings: only global
    qsort ( VectorBegin ( structbimstat ) ( & allbifstatc ) ,
      VectorSizeCopy  ( structbimstat ) ( & allbifstatc ) , sizeof  ( structbimstat ) , structbimstatless ) ;
    structbimstat const * j = VectorCBegin ( structbimstat ) ( & allbifstatc )  ;
    structbimstat const * const je = VectorCEnd ( structbimstat ) ( & allbifstatc )  ;
    for ( ; j not_eq  je  ; ++  j ) {
      size_t  const   scount  = Lisp2DStatisticsCount ( j ->  pcstat2  ) ;
      long  double  const fulltime  = StatisticsPointerSumX ( j ->  pcstat2  ) ;
      fputws  ( L"BIM(" , stderr  ) ;
      fputws  ( wcharconstvolatp_cast_wcharconstp ( j ->  bimclassname ) , stderr ) ;
      fputws  ( L"," , stderr  ) ;
      fputws  ( wcharconstvolatp_cast_wcharconstp ( j ->  bimmethodwnamep ) , stderr ) ;
      fwprintf  ( stderr , L") n=%lu fulltime=%.3Lg M=%.3Lg" , scount , fulltime ,
        StatisticsPointerAverage  ( j ->  pcstat2  ) ) ;
      fwprintf  ( stderr  , L" σ=%.3Lg" , StatisticsPointerDeviation  ( j ->  pcstat2  ) ) ;
      fputws  ( L" (" , stderr  ) ;
      // Dispersy = (1/(n-1))*(Sum(x^2)-Aver(x)*Summ(x))
      { size_t const  js = Lisp2DStatisticsSize  ( j ->  pcstat2 ) ;
        for(size_t  i=0;i  < js;++  i){
          struct Lisp2DStatisticsSection  * ss = 0 ;
          if(Lisp2DStatisticsIsBADElt(j->pcstat2, i ,&ss))
            fputws  ( L" BAD , " , stderr  ) ;
          else  {
            size_t  const   counti  = Lisp2DStatisticsSectionCount ( ss ) ;
            long  double  av2  =  Lisp2DStatisticsSectionCalcAverage ( ss ) ;
            long  double  dev2 = StatisticsSectionCalcDeviation ( ss  , av2 ) ;
            fwprintf  ( stderr  , L" n=%lu ( %.3Lg% ) M=%.3Lg σ=%.3Lg" , counti , ( ( long double ) ( counti ) /
              ( long double ) ( scount ) ) * 100.0L , av2 , dev2 ) ;
            if(i  not_eq  (js  - 1))
              fputws  ( L" , " , stderr  ) ;
          } // if not StatisticsIsBADElt
        }  // for i
      } // js
      fputws  ( L" ) mutexstat = " , stderr  ) ;
      Lisp2D_atomic_mutex const * m = Lisp2DStatisticsCMutex ( j ->  pcstat2 ) ;
      size_t const  f = atomic_mutex_StatFast(m);
      size_t const  w = atomic_mutex_StatWait(m);
      fwprintf  ( stderr  , L"%lu/%lu=%.3Lg%\n" , f , f + w , ( ( long double ) ( f ) * 100.0L ) / ( long double ) ( f + w ) ) ;
    }  // for j
    Vector_Destr  ( structbimstat ) ( & allbifstatc ) ;
  } // allbifstat
        
  Vector ( structmutexstat ) allmutexstatc ;
  VectorInit  ( structmutexstat ) ( & allmutexstatc , false ) ;
  
  { structmutexstat el  = {L"mutexQueueAtomicStClFirst",
     Lisp2DMutexStatFast  (&Lisp2DMutexQueueAtomicStClFirstC),
     Lisp2DMutexStatWait  (&Lisp2DMutexQueueAtomicStClFirstC) };
    PushMutexStat(&allmutexstatc ,&el);
  }
    
  { structmutexstat el  = {L"mutexQueueAtomicStClLast",
     Lisp2DMutexStatFast  (  & Lisp2DMutexQueueAtomicStClLastC ) ,
     Lisp2DMutexStatWait  (  & Lisp2DMutexQueueAtomicStClLastC) };
    PushMutexStat(&allmutexstatc ,&el);
  }
    
  { structmutexstat el  = {L"GlobalListOfComplex",
    GlobalListStatFast(& GlobalListOfComplex),
    GlobalListStatWait(&GlobalListOfComplex)};
    PushMutexStat(&allmutexstatc ,&el);
  }

  { structmutexstat el  = {L"GlobalListOfComplexGarbage",
      GlobalListStatFast(&GlobalListOfComplexGarbage),
      GlobalListStatWait(&GlobalListOfComplexGarbage)};
    PushMutexStat(&allmutexstatc ,&el);
  }

  { structmutexstat el={L"globalRandom",RandomStatFast(),
      RandomStatWait()};
    PushMutexStat(&allmutexstatc ,&el);
  }
  
  { structmutexstat el  = {L"GlobalListOfObjects",
      GlobalListStatFast(&GlobalListOfObjects),
      GlobalListStatWait(&GlobalListOfObjects)};
    PushMutexStat(&allmutexstatc ,&el);
  }
  
  { structmutexstat el  = {L"GlobalListOfObjectsGarbage",
    GlobalListStatFast(&GlobalListOfObjectsGarbage),
    GlobalListStatWait(&GlobalListOfObjectsGarbage)};
    PushMutexStat(&allmutexstatc ,&el);
  }
  
  { structmutexstat el  = {L"GlobalListOfLayer",
    GlobalListStatFast(&GlobalListOfLayer),
      GlobalListStatWait(&GlobalListOfLayer)};
    PushMutexStat(&allmutexstatc ,&el);
  }
  
  { structmutexstat el  = {L"GlobalListOfLayerGarbage",
    GlobalListStatFast(&GlobalListOfLayerGarbage),
      GlobalListStatWait(&GlobalListOfLayerGarbage)};
    PushMutexStat(&allmutexstatc ,&el ) ;
  }
    
# ifndef  LISP2D_DONTUSEX11        

  { structmutexstat el  = {L"GlobalListOfWindows",
    GlobalListStatFast ( & GlobalListOfWindows),
    GlobalListStatWait(&GlobalListOfWindows)};
    PushMutexStat(&allmutexstatc ,&el);
  }
  
  { structmutexstat el  = {L"GlobalListOfWindowsGarbage",GlobalListStatFast(&
     GlobalListOfWindowsGarbage),
     GlobalListStatWait(&GlobalListOfWindowsGarbage)};
    PushMutexStat(&allmutexstatc ,&el ) ;
  }
    
# endif    
  
  { structmutexstat el  = {L"GlobalListOfConsPairs",
    GlobalListStatFast(&GlobalListOfConsPairs),
      GlobalListStatWait(&GlobalListOfConsPairs)};
    PushMutexStat(&allmutexstatc ,&el);
  }
  
  { structmutexstat el  = {L"GlobalListOfConsPairsGarbage",
    GlobalListStatFast(&GlobalListOfConsPairsGarbage),
      GlobalListStatWait(&GlobalListOfConsPairsGarbage)};
    PushMutexStat(&allmutexstatc ,&el);
  }
    
  { structmutexstat el  = {L"GlobalListOfSymbolsGarbage",
    GlobalListStatFast(&GlobalListOfSymbolsGarbage),
    GlobalListStatWait(&GlobalListOfSymbolsGarbage)};
    PushMutexStat(&allmutexstatc ,&el);
  }
  
  { structmutexstat el  = {L"GlobalListOfStackClustersGarbage",
    GlobalListStatFast(&GlobalListOfStackClustersGarbage2),
    GlobalListStatWait(&GlobalListOfStackClustersGarbage2)};
    PushMutexStat(&allmutexstatc ,&el);
  }

  { structmutexstat el  = { L"Lisp2DmutexGenTemp" ,
      Mutex2StatFast  ( & Lisp2DmutexGenTemp ) ,
      Mutex2StatWait  ( & Lisp2DmutexGenTemp ) } ;
    PushMutexStat( &allmutexstatc   , &el  ) ;
  }

  { structmutexstat el  = { L"Lisp2Dmutex2ManagerTasks" ,
      Mutex2StatFast  ( & Lisp2Dmutex2ManagerTasks ) ,
      Mutex2StatWait ( & Lisp2Dmutex2ManagerTasks ) } ;
    PushMutexStat(&allmutexstatc ,&el);
  }
  
  { structmutexstat el  = { L"Lisp2DmutexNameSpace" ,
      Mutex2StatFast  ( & Lisp2DmutexNameSpace  ) , Mutex2StatWait  (
        & Lisp2DmutexNameSpace ) } ;
    PushMutexStat(&allmutexstatc ,&el);
  }
    
  { structmutexstat el  = { L"averageStackClustermutexTask" ,
    averageStackClustermutex_TaskStatFast_Value ( ) ,
    averageStackClustermutex_TaskStatWait_Value ( ) } ;
    PushMutexStat( &allmutexstatc   , &el  ) ;
  }
  
  { structmutexstat el  = {
    L"averageStackClustermutexException" ,
    averageStackClustermutex_ExceptionStatFast_Value  ( ) ,
    averageStackClustermutex_ExceptionStatWait_Value  ( ) } ;
    PushMutexStat(&allmutexstatc ,&el);
  }
    
# ifdef LISP2D_INNERHISTORY    

  { structmutexstat el  = {L"innerHistoryMutex",
    atomic_mutex_StatFast(InnerHistoryMutex(&Lisp2DinnerHistory)),
      atomic_mutex_StatWait(InnerHistoryMutex(&Lisp2DinnerHistory))};
    PushMutexStat(&allmutexstatc ,&el);
  }
    
# endif

  qsort ( VectorBegin ( structmutexstat ) ( & allmutexstatc  ) ,
    VectorSizeCopy  ( structmutexstat ) ( & allmutexstatc  ) ,
    sizeof  ( structmutexstat ) , structmutexstatless ) ;
  fputws ( L"\n---Mutex=FreeCross/Quantity---\n" , stderr ) ;
  structmutexstat const * j = VectorCBegin ( structmutexstat ) ( & allmutexstatc  )  ;
  structmutexstat const * const je =
    VectorCEnd ( structmutexstat ) ( & allmutexstatc  )  ;
  for ( ; j not_eq  je  ; ++  j ) {
    fputws ( j -> mutexnamec , stderr ) ;
    fwprintf ( stderr , L" = %lu / %lu = %.3Lg%\n" , j -> f , (j->f) + (j->w) , (
      size_cast_longdouble ( j -> f ) * 100.0L ) / size_cast_longdouble (
        ( j -> f ) + ( j -> w ) ) ) ;
  }
  Vector_Destr  ( structmutexstat ) ( & allmutexstatc  ) ;
}

# include "inner-history/inline.h"
# include "castb.h"
# include "widestring/inline.h"
# else
  static  char  const space __attribute__ ((unused)) = ' ' ;
# endif // LISP2D_BIMSTAT
