// Lisp2D - ByteDeque #[]
// ©2014-23 by Alex Glebe
# include "bytedeque/public.h"
# include "plostream/public.h"

void  PLOByteDeque_staticCoutToInterpret ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool _ __attribute__ ((unused)) ,
  Vector  ( StackPLOP )  * const _2 __attribute__ ((unused)) ) {
  StreamPushWCharArray(&s->str,(PArray_wchar_c){(wchar_t const (*)[])(L"#[")});
  PLOByteDeque const * const meb = ParaLispObjectToPLOByteDequeConst(me);
  { DequeConstIterator ( Byte  ) j = Deque_CBegin ( Byte  ) ( & meb ->  dqbyte ) ;
    DequeConstIterator ( Byte  ) const  jend = Deque_CEnd ( Byte  ) ( & meb  ->  dqbyte ) ;
    if  ( Deque_ConstIterator_NotEq ( Byte ) ( j , jend  ) ) {
      PLOStreamPushUInt ( s , * Deque_ConstIterator_Place ( Byte ) ( j ) ) ;
      Deque_ConstIterator_Inc ( Byte  ) ( & j ) ;
      while ( Deque_ConstIterator_NotEq ( Byte )  ( j , jend  ) ) {
        PLOStreamPushWChar(s,L' ');
        PLOStreamPushUInt ( s , * Deque_ConstIterator_Place ( Byte ) ( j ) )  ;
        Deque_ConstIterator_Inc ( Byte  ) ( & j ) ;
      }
    }
  }
  PLOStreamPushWChar(s,L']');
}

void  PLOByteDeque_staticCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool flag2pprinted  , Vector ( StackPLOP )  * const h ) {
  PLOByteDeque_staticCoutToInterpret ( me ,    s , flag2pprinted  , h ) ;
}

bool  PLOByteDeque_staticisBADCopyPrivate  ( ParaLispObject const  * me , ParaLispObject  * * const resultp  ) {
  { PLOByteDeque  * const res  = aligned_alloc ( _Alignof ( PLOByteDeque ) , sizeof  ( PLOByteDeque ) ) ;
    if ( not res )
      return  true  ;
    PLOByteDeque_InitCopy ( res , ParaLispObjectToPLOByteDequeConst ( me  ) ) ;
    ParaLispObject_virtualPushAsNew(&res->plo);
    (*resultp)  = &res->plo;
    return  false;
  }
}

# include "symbolc.h"

ParaLispObject  * PLOByteDeque_staticTypeOf ( ParaLispObject const * const _ __attribute__ ((unused)) ) {
  return  & plosbytedeque . plo ;
}

ParaLispObject  * PLOByteDeque_staticClassDef  ( ParaLispObject const * const _ __attribute__ ((unused)) ) {
  return   ploclassdefbytedeque ;
}

ParaLispObject  * PLOByteDeque_staticClassParents  ( ParaLispObject const * const _ __attribute__ ((unused)) ) {
  return   ploclassparentsbytedeque ;
}

bool  PLOByteDeque_PushBack2(PLOByteDeque * const me ,uint8_t  const  x2) {
  jmp_buf jump_buffer ;
  jmp_buf * oldjb = Lisp2DJBglobal  ;
  Lisp2DJBglobal = &  jump_buffer ;
  int const volatile exctype = setjmp  ( jump_buffer ) ;
  if  ( exctype ) {
    Lisp2DJBglobal = oldjb  ;
    return  true  ;
  }
  Deque_Push_back ( Byte ) ( & me -> dqbyte , x2 ) ;
  Lisp2DJBglobal = oldjb  ;
  bytevector_length_inc ( ) ;
  return  false;
}

bool  PLOByteDeque_PushFront2(PLOByteDeque * const me ,uint8_t  const x2) {
  jmp_buf jump_buffer ;
  jmp_buf * oldjb = Lisp2DJBglobal  ;
  Lisp2DJBglobal = &  jump_buffer ;
  int const volatile exctype = setjmp  ( jump_buffer ) ;
  if  ( exctype ) {
    Lisp2DJBglobal = oldjb  ;
    return  true  ;
  }
  Deque_Push_front  ( Byte ) ( & me -> dqbyte , x2 ) ;
  Lisp2DJBglobal = oldjb  ;
  bytevector_length_inc ( ) ;
  return  false;
}

bool  PLOByteDeque_PopBack2(PLOByteDeque * const me ,uint8_t  * const res2){
  if  ( Deque_Empty ( Byte ) ( & me -> dqbyte ) )
    return  true  ;
  ( * res2 ) = Deque_Pop_back  ( Byte  ) ( & me->dqbyte  ) ;
  bytevector_length_dec ( ) ;
  return  false;
}

bool  PLOByteDeque_PopFront2 ( PLOByteDeque * const me , uint8_t  * const res2 ) {
  if  ( Deque_Empty ( Byte ) ( & me -> dqbyte ) )  
    return  true  ;
  ( * res2  )  = Deque_Pop_front ( Byte  ) ( & me -> dqbyte  ) ;
  bytevector_length_dec ( ) ;
  return  false;
}

bool  PLOByteDeque_Back2(PLOByteDeque const * const me , uint8_t  * const res2) {
  if  ( Deque_Empty ( Byte ) ( & me -> dqbyte ) ) 
    return  true  ;
  ( * res2  ) = * Deque_BackConst ( Byte  ) ( & me -> dqbyte  ) ;
  return  false;
}

bool  PLOByteDeque_Front2 ( PLOByteDeque const * const me ,  uint8_t  * const res2 ) {
  if  ( Deque_Empty ( Byte ) ( & me -> dqbyte ) ) 
    return  true  ;
  ( * res2  ) = * Deque_FrontConst ( Byte  ) ( & me -> dqbyte  ) ;
  return  false;
}

bool  ByteVectorp ( ParaLispObject const * const x  ) {
  return  ParaLispObject_Type ( x ) ==  TypeGlobalListMemberPLOByteDeque  ;
}

# include "boolean.h"
# include "cons/public.h"
# include "stcl/public.h"
# include "stcl/inline.h"

// nil byte-vectorp
TaskForThread Lisp2DbimnilbytevectorP2( StackClusterPrivate  * const stclpp ){
  ParaLispObject  * const x = CCAR  ( StackClusterPrivate_ArgTop(stclpp ));
  StackClusterPrivate_SetResult ( stclpp , ( ByteVectorp ( x ) ?
    x :
    & plofalse  . plo ) ) ;
  return  TaskForThread_Analyse;
}

//  byte-vector setf byte-vector
TaskForThread Lisp2DbimbytedequeSetf2( StackClusterPrivate  * const stclpp ){
  ParaLispObject * const arg  = CCAR  ( StackClusterPrivate_ArgTop(stclpp ));
  if  ( IsNotByteDeque  ( stclpp ,  arg ) ) 
    return  TaskForThread_Analyse;
  PLOByteDeque * const me = ParaLispObjectToPLOByteDeque(StackClusterPrivate_ThisTop(stclpp ));
  PLOByteDeque_Set  ( me  , ParaLispObjectToPLOByteDeque  ( arg ) ) ;
  StackClusterPrivate_SetResult(stclpp ,&me->plo);
  return  TaskForThread_Analyse;
}

# include "newobject.h"

bool  IsNotByteDeque( StackClusterPrivate  * const  stclp , ParaLispObject * const  x ) {
  tUniversalIsNotType ar  = {
    . stclp = stclp ,
    . xp  = x ,
    . typetype  = TypeGlobalListMemberPLOByteDeque ,
    . res = false ,
  } ;
  UniversalIsNotTypess  ( & ar  ) ;
  return  ar  . res ;
}

# include "string/public.h"
# include "string/struct.h"
# include "sharedc.h"
# include "shared/inline.h"
# include "inerrors.h"
# include "passage/public.h"
# include "nilc.h"

bool  IsNotByteDequeLockGC( StackClusterPrivate  * const stclp , ParaLispObject * const  x){
  if  ( ByteVectorp (  x ) ) 
    return  false ;
  wchar_t const (*wcp)[] =(wchar_t const(*)[]) & L" is not Byte-Vector";  
  if(stclp){    
    PassagePassIn ( passageGCCPub ) ;
    jmp_buf jump_buffer ;
    jmp_buf * oldjb = Lisp2DJBglobal  ;
    Lisp2DJBglobal = &  jump_buffer ;
    int const volatile exctype = setjmp  ( jump_buffer ) ;
    if  ( exctype ) {
      Lisp2DJBglobal = oldjb  ;
      StackClusterPrivate_ExceptionSet(stclp ,&plonil.plo);
    } else {
      ParaLispObject  * list [ ] = {  x,  & PLOString_NewCopy(*wcp)->plo,
        NULL } ;
      StackClusterPrivate_ExceptionSet(stclp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list})); 
      Lisp2DJBglobal = oldjb  ; 
    }
    PassagePassOut ( passageGCCPub )  ;  
  } else  
    inErrorS(
      PLOStreamPushPLO(& Lisp2Dferr , x );
      PLOStreamPushWideCharArray  ( & Lisp2Dferr ,
        ( PArray_wchar_c ) { wcp } );   )
  return  true  ;
}

//  byte-vector clear
TaskForThread Lisp2Dbimbytedequeclear2( StackClusterPrivate  * const stclpp ) {
  ParaLispObject * const me = StackClusterPrivate_ThisTop(stclpp ) ;
  PLOByteDeque_Clear(ParaLispObjectToPLOByteDeque(me))  ;
  StackClusterPrivate_SetResult(stclpp ,me);
  return   TaskForThread_Analyse ;
}

//  byte-vector empty
TaskForThread Lisp2Dbimbytedequeempty2( StackClusterPrivate  * const stclpp ){
  PLOByteDeque  * const me =
    ParaLispObjectToPLOByteDeque(StackClusterPrivate_ThisTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,(PLOByteDeque_Empty(me) ? &me->plo  :
      & plonil.plo ));
  return   TaskForThread_Analyse ;
}

void  PLOByteDeque_staticDeclareForGC ( ParaLispObject * const me ) {
  if(not  me -> flagGCPassed){
    me -> flagGCPassed =true;
    GlobalListPopNotLock(&GlobalListOfObjectsGarbage  , & me -> base ) ; 
    GlobalListPushNotLock(&GlobalListOfObjects, & me -> base ) ;
    bytevector_length_add ( Deque_Size ( Byte ) (
      & ParaLispObjectToPLOByteDeque  ( me  ) ->  dqbyte  ) ) ;
  }
}

void  PLOByteDeque_Clear ( PLOByteDeque * const me ) {
  bytevector_length_sub ( Deque_Size ( Byte ) ( & me -> dqbyte  ) ) ;
  Deque_Clear ( Byte )  ( & me -> dqbyte  ) ;
}

void  PLOByteDeque_Resize2  ( PLOByteDeque * const me  ,
  size_t const  s  , uint8_t  const v2 ) {
  bytevector_length_sub ( Deque_Size ( Byte ) ( & me -> dqbyte  ) ) ;
  bytevector_length_add ( s ) ;
  Deque_ResizeVal ( Byte ) ( & me -> dqbyte , s , v2 ) ;
}

void  PLOByteDeque_Set  ( PLOByteDeque * const me ,
  PLOByteDeque  const * const x ) {
  if(me not_eq    x){
    bytevector_length_sub ( Deque_Size ( Byte ) ( & me -> dqbyte  ) ) ;
    bytevector_length_add ( Deque_Size ( Byte ) ( & x -> dqbyte  ) ) ;
    Deque_Set ( Byte ) ( & me -> dqbyte , & x -> dqbyte ) ;
  }
}

# include "cast.h"

// e <= v.size , this not_eq v
void  PLOByteDeque_SubSeq ( PLOByteDeque * const me ,
  PLOByteDeque const * const v ,  size_t const indexfirst , size_t const e ) {
  if(indexfirst < e){
    { size_t  const  news = (e - indexfirst);
      PLOByteDeque_Resize ( me  , news  ) ;
    }
    DequeIterator ( Byte  ) j2  = Deque_Begin ( Byte  ) ( & me -> dqbyte  ) ;
    DequeConstIterator ( Byte  ) i2  = Deque_ConstIterator_Add ( Byte ) (
      Deque_CBegin  ( Byte  ) ( & v -> dqbyte  ) , size_cast_ptrdiff ( indexfirst  ) ) ;
    DequeConstIterator ( Byte  ) const  je2 = Deque_CEnd  ( Byte  ) ( & me -> dqbyte  ) ;
    do  {
      ( * Deque_Iterator_Place  ( Byte  ) ( j2  ) ) =
        ( * Deque_ConstIterator_Place ( Byte  ) ( i2  ) ) ;
      Deque_Iterator_Inc ( Byte  )  ( & j2  ) ;
      Deque_ConstIterator_Inc ( Byte ) ( & i2 ) ;
    } while ( Deque_ConstIterator_NotEqIterator ( Byte )  ( je2 , j2  ) ) ;
  }
}

# include "define.h"

void  PLOByteDeque_InitFrom ( PLOByteDeque * const me , PLOByteDeque const * const v  , size_t  const indexfirst  ) {
  ParaLispObject_InitVTP  ( & me -> plo , ( VirtualTypePointer ) { . addr = { . p = me } ,
    . type = TypeGlobalListMemberPLOByteDeque } ) ;
  Deque_Init  ( Byte ) ( & me -> dqbyte ) ;
  size_t  const   e = Deque_Size ( Byte ) ( & v -> dqbyte ) ;
  PLOByteDeque_SubSeq ( me , v , indexfirst , e ) ;
# ifdef  LISP2D_CONSTRSTAT
  PLOByteDeque_constrstat_inc ( ) ;
# endif
}

# include "minmaxint.h"

void  PLOByteDeque_InitFromTo ( t_PLOByteDeque_InitFromTo const * const arg ) {
  ParaLispObject_InitVTP  ( & arg -> me -> plo ,
    ( VirtualTypePointer ) { . addr = { . p =arg -> me } , . type =  TypeGlobalListMemberPLOByteDeque } ) ;
  Deque_Init  ( Byte ) ( & arg -> me -> dqbyte ) ;
  size_t  const   e  = Lisp2DMinSize ( arg ->  indexend  , Deque_Size ( Byte )  ( & arg -> vp -> dqbyte ) ) ;
  PLOByteDeque_SubSeq ( arg -> me  , arg -> vp , arg -> indexfirst  , e ) ;
# ifdef  LISP2D_CONSTRSTAT
  PLOByteDeque_constrstat_inc ( ) ;
# endif
}

void  PLOByteDeque_SetFrontNotCheckNotResize  ( PLOByteDeque * const  me , uint8_t const * p, size_t  const s ) {
  DequeIterator  ( Byte ) i2 = Deque_Begin ( Byte ) ( & me -> dqbyte ) ;
  for(size_t  j = s ;j  > 0;--  j,Deque_Iterator_Inc ( Byte )(&  i2),++  p)
    ( * Deque_Iterator_Place( Byte )(i2))  = ( * p);
}

void  PLOByteDeque_Destr ( PLOByteDeque * const me ) {
  Deque_Destr ( Byte ) ( & me -> dqbyte ) ;
  ParaLispObject_staticDestr ( & me -> plo ) ;
}

void  PLOByteDeque_SwapDeque  ( PLOByteDeque * const me ,
  Deque ( Byte ) * const x ) {
  if  ( ( & me -> dqbyte ) not_eq  x ) {
    bytevector_length_sub ( Deque_Size ( Byte ) ( & me -> dqbyte  ) ) ;
    Deque_Swap ( Byte ) ( & me -> dqbyte , x ) ;
    bytevector_length_add ( Deque_Size ( Byte ) ( & me -> dqbyte  ) ) ;
  }
}

void  PLOByteDeque_InitSize  ( PLOByteDeque * const me ,
  size_t const fullsize ) {
  Deque_InitSize  ( Byte ) ( & me -> dqbyte , fullsize ) ;
  ParaLispObject_InitVTP  ( & me -> plo , ( VirtualTypePointer ) { . addr = { . p = me } ,
    . type = TypeGlobalListMemberPLOByteDeque } ) ;
}

void  PLOByteDeque_Init ( PLOByteDeque * const me ) {
  Deque_Init  ( Byte ) ( & me -> dqbyte ) ;
  ParaLispObject_InitVTP  ( & me  ->  plo , ( VirtualTypePointer ) { . addr = { . p = me } ,
    . type = TypeGlobalListMemberPLOByteDeque  } ) ;
# ifdef  LISP2D_CONSTRSTAT
  PLOByteDeque_constrstat_inc ( ) ;
# endif
}    
  
# include "complex/inline.h"
# include "plocomplex/public.h"

# define  PLOByteDeque_AssignSubSeq2  Lisp2D_PLOByteDeque_AssignSubSeq2
static  PLOByteDeque  * PLOByteDeque_AssignSubSeq2  ( PLOByteDeque *  ,
  PLOByteDeque *  , PLOComplex  * , PLOComplex  * , StackClusterPrivate  * ) ;

# define  PLOByteDeque_AssignSubSeq Lisp2D_PLOByteDeque_AssignSubSeq
static  PLOByteDeque  * PLOByteDeque_AssignSubSeq  ( PLOByteDeque * ,
  PLOByteDeque * , PLOComplex  * , StackClusterPrivate  * ) ;
  
/*('byte-vector  defmethod byte-vector(x  c)
  (nil  cond
    ((nil numberp x)
      (this setf  (x  make-byte-vector c)))
    ((nil byte-vectorp x)
      (this setf  x)))
  this)*/
TaskForThread Lisp2Dbimbytevectorbytevector2(
  StackClusterPrivate  * const stclpp ){
  PLOByteDeque * const me = ParaLispObjectToPLOByteDeque  (
    StackClusterPrivate_ThisTop ( stclpp )  ) ;
  ParaLispObject const * const arglist = 
    StackClusterPrivate_ArgTop  ( stclpp )  ;
  ParaLispObject * const x  = CCAR  ( arglist ) ;
  switch(ParaLispObject_Type(x)){
  case  TypeGlobalListMemberPLOComplex:
    if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
          ParaLispObjectToPLOComplexConst(x))),0U)){
      jmp_buf jump_buffer ;
      jmp_buf * const oldjb = Lisp2DJBglobal  ;
      Lisp2DJBglobal = &  jump_buffer ;
      int const volatile exctype = setjmp  ( jump_buffer ) ;
      if  ( exctype  ) {
        Lisp2DJBglobal = oldjb  ;
        StackClusterPrivate_ExceptionSet(stclpp ,& plonil . plo ); }
      else {
        ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L" the size ")
          ->plo,
          x,& PLOString_NewCopy (L"<0")->plo, NULL } ;
        StackClusterPrivate_ExceptionSet(stclpp ,
          ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
        Lisp2DJBglobal = oldjb  ; 
      }
      return   TaskForThread_Analyse ;
    }
    { size_t  us;
      if( FractionIsBadSizeValue(
          Complex_CRe(PLOComplexToComplexConst(
            ParaLispObjectToPLOComplexConst(x))), &us))
        return   TaskForThread_Analyse ;
      ParaLispObject  * const cp= CCAR  ( CCDR  ( arglist));
      PLOByteDeque_Clear(me);
      
        switch(ParaLispObject_Type(cp)){
        case  TypeGlobalListMemberPLOComplex:
          { FractionPub const * const crp=Complex_CRe(
              PLOComplexToComplexConst(
              ParaLispObjectToPLOComplexConst(cp)));
            if(not  FractionIntegerP(crp)) {
                ParaLispObject  * list [ ] = { &  PLOString_NewCopy (
                  L" the value ")
                  ->plo, cp,& PLOString_NewCopy (L" is not integer")->plo,
                  NULL } ;
                StackClusterPrivate_ExceptionSet(stclpp ,
                  ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list})); 
              return   TaskForThread_Analyse ; 
            }
            if(FractionLessUInt(crp,0U)){
              ParaLispObject  * list [ ] = { &  PLOString_NewCopy (
                L" the value ")
                ->plo, cp,& PLOString_NewCopy (L"<0")->plo, NULL } ;
              StackClusterPrivate_ExceptionSet(stclpp ,
                ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
              return   TaskForThread_Analyse ; 
            }
             if(FractionMoreEqUInt(crp,0x100U)){
                ParaLispObject  * list [ ] = { &  PLOString_NewCopy (
                  L" the value ")->plo, cp,& PLOString_NewCopy (L">=0x100")
                  ->plo, NULL } ;
                StackClusterPrivate_ExceptionSet(stclpp ,
                  ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
                return   TaskForThread_Analyse ;
            }
            { uint8_t  v;
              if(FractionIsBADByteValue(crp,&v)){
                ParaLispObject  * list [ ] = { &  PLOString_NewCopy (
                  L" the value ")->plo, cp,& PLOString_NewCopy (
                    L" is not byte") ->plo, NULL } ;
                StackClusterPrivate_ExceptionSet(stclpp ,
                  ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
                return   TaskForThread_Analyse ; }
              else
                PLOByteDeque_Resize2  ( me , us  , v  ) ; } } // crp
          break;
        case  TypeGlobalListMemberPLONil:          
          PLOByteDeque_Resize2  ( me  , us  , 0 ) ;
          break;
        default:
          { ParaLispObject  * list [ ] = { &  PLOString_NewCopy (
            L" the argument ")
              ->plo, cp,& PLOString_NewCopy (L" is not valid")->plo, NULL } ;
            StackClusterPrivate_ExceptionSet(stclpp ,
              ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
            return   TaskForThread_Analyse ;
          }
        }
    }
    break;
    
  case  TypeGlobalListMemberPLOByteDeque:
    { ParaLispObject  * const arg2p= CCDR  ( arglist);
      ParaLispObject  * const indp= CCAR  ( arg2p);
      if(Numberp(indp)){
        ParaLispObject  * const endp= CCAR  ( CCDR  ( arg2p));
        if(Numberp(endp))
          PLOByteDeque_AssignSubSeq2(me,ParaLispObjectToPLOByteDeque(x),
            ParaLispObjectToPLOComplex(indp),
            ParaLispObjectToPLOComplex(endp),  stclpp );
        else
          PLOByteDeque_AssignSubSeq(me,ParaLispObjectToPLOByteDeque(x),
            ParaLispObjectToPLOComplex(indp), stclpp );}
      else
        PLOByteDeque_Set  ( me  , ParaLispObjectToPLOByteDeque  ( x ) ) ; 
    }
    break;
    
  default:;    
    // make an empty byte-vector
  }  // switch
  StackClusterPrivate_SetResult(stclpp , & me -> plo ) ;
  return  TaskForThread_Analyse ; 
}

static  PLOByteDeque  * PLOByteDeque_AssignSubSeq2  (
  PLOByteDeque * const mep , PLOByteDeque * const vp ,
  PLOComplex  * const indp , PLOComplex  * const endp ,
  StackClusterPrivate * const stp ) {
  if(not  Complex_Integerp(PLOComplexToComplexConst(indp))){
    ParaLispObject  * list [ ] = { &  indp->plo,& PLOString_NewCopy(
      L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return  mep; }
  if(not  Complex_Integerp(PLOComplexToComplexConst(endp))){
    ParaLispObject  * list [ ] = { &  endp->plo,& PLOString_NewCopy(
      L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return  mep; 
  }
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    indp)) ,0U)){
    ParaLispObject  * list [ ] = { &  indp->plo,& PLOString_NewCopy(L" < 0")
      ->plo,  NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return  mep;
  }
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    endp)) ,0U)){
    ParaLispObject  * list [ ] = { &  endp->plo,& PLOString_NewCopy(L" < 0")
      ->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return  mep;
  }
  //if(end.Re() < ind.Re())
  if(FractionLess(Complex_CRe(PLOComplexToComplexConst(endp)),
    Complex_CRe(PLOComplexToComplexConst(indp)))  ==
    Lisp2DBoolTrue){
    ParaLispObject  * list [ ] = { &  endp->plo, &  PLOString_NewCopy(L" < ")
      ->plo, & indp->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return  mep;
  }
  if(mep ==  vp){
    // me=[0..ind-1,ind,ind+1..s-1] -> [ind,..,end-1]
    if(FractionIs0(Complex_CRe(PLOComplexToComplexConst(
      indp)))){
      // me=[0..ind-1,ind,ind+1..s-1] -> [0,..,end-1]
      size_t  end2;
      if( FractionIsBadSizeValue(Complex_CRe(
        PLOComplexToComplexConst(endp)),        &end2))
        return mep;
      PLOByteDeque_Resize2  ( mep  , end2  , 0 ) ;
      return  mep; 
    }
    size_t  const   dqbs = Deque_Size( Byte )(&mep->dqbyte);  
    size_t  ind2;
    if(  FractionIsBadSizeValue(Complex_CRe(
      PLOComplexToComplexConst(indp)),      &ind2)){
      ParaLispObject  * list [ ] = { &  indp->plo,
        &  PLOString_NewCopy(L" is bad")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
        (ParaLispObject*(*)[])&list}));
      return  mep; 
    }
    size_t  end2;
    if(  FractionIsBadSizeValue(Complex_CRe(
      PLOComplexToComplexConst( endp)),  &end2)){
      ParaLispObject  * list [ ] = { &  endp->plo,
        &  PLOString_NewCopy(L" is bad")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
        (ParaLispObject*(*)[])&list}));
      return  mep;
    }
    size_t  const  newsize = end2 - ind2;
    if(FractionMoreEqUSize(Complex_CRe(PLOComplexToComplexConst(
      indp)),  dqbs)){
      PLOByteDeque_Clear(mep);
      PLOByteDeque_Resize2  ( mep  , newsize , 0 ) ;
      return  mep; 
    }
    if(newsize  > dqbs)
      PLOByteDeque_Resize2  ( mep  , newsize , 0 ) ;
    DequeIterator  ( Byte ) jtarget2 = Deque_Begin ( Byte ) ( & mep->dqbyte ) ;
    DequeIterator  ( Byte ) jsource2 = Deque_Iterator_Add ( Byte ) ( jtarget2 ,
      size_cast_ssize ( ind2 ) ) ;
    do{
      (* Deque_Iterator_Place( Byte )( jtarget2))  =
        (* Deque_Iterator_Place( Byte ) (jsource2));
      Deque_Iterator_Inc ( Byte )(&  jtarget2);
      Deque_Iterator_Inc ( Byte )(&  jsource2);
      ++  ind2;
    }while((ind2 < dqbs)  and (ind2  < end2));
    PLOByteDeque_Resize ( mep  , newsize ) ;
    return  mep;
  } // this == v
  size_t  const   vs = Deque_Size( Byte )(&vp->dqbyte);
  size_t  ind2;
  if(  FractionIsBadSizeValue(Complex_CRe(
    PLOComplexToComplexConst( indp)), &ind2)){
    ParaLispObject  * list [ ] = { &  indp->plo,
      &  PLOString_NewCopy(L" is bad")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return  mep;
  }
  size_t  end2;
  if(  FractionIsBadSizeValue(Complex_CRe(
    PLOComplexToComplexConst( endp)), &end2)){
    ParaLispObject  * list [ ] = { &  endp->plo,
      &  PLOString_NewCopy(L" is bad")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return  mep; 
  }
  PLOByteDeque_Clear(mep);
  { size_t  const  newsize=end2 - ind2;
    PLOByteDeque_Resize2  ( mep  , newsize , 0 ) ; 
  }
  if(ind2 >=  vs)   
    return  mep;
  DequeIterator  ( Byte ) jtarget2 = Deque_Begin ( Byte ) ( & mep->dqbyte ) ;
  DequeIterator  ( Byte ) jsource2 = Deque_Iterator_Add ( Byte ) (
    Deque_Begin ( Byte ) ( &vp->dqbyte ) , size_cast_ssize ( ind2 ) ) ;
  while((ind2 < vs) and (ind2  < end2)){
    (* Deque_Iterator_Place( Byte )( jtarget2))  =
      (* Deque_Iterator_Place( Byte )( jsource2));
    Deque_Iterator_Inc ( Byte )(&  jtarget2);
    Deque_Iterator_Inc ( Byte )(&  jsource2);
    ++  ind2;
  }
  return  mep;
}  

static  PLOByteDeque  * PLOByteDeque_AssignSubSeq ( PLOByteDeque * const mep ,
  PLOByteDeque * const vp ,
  PLOComplex  * const indp , StackClusterPrivate  * const stp )  {
  if(not  Complex_Integerp(PLOComplexToComplexConst(indp))){
    ParaLispObject  * list [ ] = { &  indp->plo,& PLOString_NewCopy(
      L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return  mep;
  }
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    indp)) ,0U)){
    ParaLispObject  * list [ ] = { &  indp->plo,& PLOString_NewCopy(L" < 0")
      ->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return  mep;
  }
  size_t const  vdqbs=Deque_Size( Byte )(&vp->dqbyte);  
  if(FractionMoreUSize(Complex_CRe(PLOComplexToComplexConst(
    indp)) , vdqbs)){    
    PLOComplex  * const  res= NewComplexBareExc (  );
    Complex_SetUSize  ( PLOComplexToComplex( res),vdqbs);
    { ParaLispObject  * list [ ] = { &  indp->plo,
        &  PLOString_NewCopy(L" > ")->plo,&res->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
        (ParaLispObject*(*)[])&list}));
    }
    return  mep; 
  }
  if(mep ==    vp){
    // me=[0..ind-1,ind,ind+1..s-1] -> [ind,..,end-1]
    if(FractionIs0(Complex_CRe(PLOComplexToComplexConst( indp))))
      // me=[0..ind-1,ind,ind+1..s-1] -> [0,..,end-1]
      return  mep;
    size_t  ind2;
    if(  FractionIsBadSizeValue(Complex_CRe(
      PLOComplexToComplexConst(indp)),    &ind2)){
      ParaLispObject  * list [ ] = { &  indp->plo,
        &  PLOString_NewCopy(L" is bad")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
        (ParaLispObject*(*)[])&list}));
      return  mep;
    }    
    if(FractionMoreEqUSize(Complex_CRe(
      PLOComplexToComplexConst(indp)), vdqbs)){
      PLOByteDeque_Clear(mep);
      return  mep;
    }
    size_t  const  newsize=vdqbs - ind2;
    DequeIterator  ( Byte ) jtarget2 = Deque_Begin ( Byte ) (
      & mep -> dqbyte ) ;
    DequeIterator  ( Byte ) jsource2 = Deque_Iterator_Add ( Byte ) ( jtarget2 ,
      size_cast_ssize ( ind2 ) ) ;
    do{
      (* Deque_Iterator_Place( Byte )( jtarget2))  =
        (* Deque_Iterator_Place( Byte )( jsource2));
      Deque_Iterator_Inc ( Byte )(&  jtarget2);
      Deque_Iterator_Inc ( Byte )(&  jsource2);
      ++  ind2;
    }while(ind2 < vdqbs);
    PLOByteDeque_Resize ( mep  , newsize ) ;
    return  mep;
  } // this == v
  size_t  ind2;
  if(  FractionIsBadSizeValue(Complex_CRe(
    PLOComplexToComplexConst(indp)),  &ind2)){
    ParaLispObject  * list [ ] = { &  indp->plo,
      &  PLOString_NewCopy(L" is bad")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return  mep;
  }
  PLOByteDeque_Clear(mep);
  { size_t  const  newsize=vdqbs - ind2;  
    PLOByteDeque_Resize2  ( mep  , newsize , 0 ) ; 
  }
  DequeIterator  ( Byte ) jtarget2 = Deque_Begin ( Byte ) ( & mep -> dqbyte ) ;
  DequeIterator  ( Byte ) jsource2 = Deque_Iterator_Add ( Byte ) (
    Deque_Begin ( Byte ) ( &vp->dqbyte ) , size_cast_ssize ( ind2 ) ) ;
  while(ind2 < vdqbs){
    (* Deque_Iterator_Place( Byte )( jtarget2))  = 
      (* Deque_Iterator_Place( Byte )( jsource2));
    Deque_Iterator_Inc ( Byte )(&  jtarget2);
    Deque_Iterator_Inc ( Byte )(&  jsource2);
    ++  ind2;
  }
  return  mep;
}

# define  PLOByteDeque_SwapInd  Lisp2D_PLOByteDeque_SwapInd
static  PLOByteDeque * PLOByteDeque_SwapInd ( PLOByteDeque * ,
  PLOComplex *  , PLOComplex  * , StackClusterPrivate * ) ;
  
// byte-vector swap i j
// byte-vector swap byte-vector
TaskForThread Lisp2DbimbytedequeSwap2( StackClusterPrivate  * const stclpp ){
  PLOByteDeque * const  me = 
    ParaLispObjectToPLOByteDeque(StackClusterPrivate_ThisTop(stclpp ));
  ParaLispObject  * const arglistp=StackClusterPrivate_ArgTop(stclpp );
  ParaLispObject  * const ip= CCAR  ( arglistp);
  if  ( ByteVectorp ( ip ) ) {
    // byte-vector swap byte-vector
    if(IsConst(  stclpp ,ip)) 
      return  TaskForThread_Analyse;
    PLOByteDeque_Swap ( me  , ParaLispObjectToPLOByteDeque  ( ip ) ) ;
    StackClusterPrivate_SetResult(stclpp ,&me->plo);
    return  TaskForThread_Analyse; }
  if( IsNotNumber(  stclpp ,ip)) 
    return  TaskForThread_Analyse;
  ParaLispObject  * const jp= CCAR  ( CCDR  ( arglistp));
  if( IsNotNumber(  stclpp ,jp)) 
    return  TaskForThread_Analyse;
  StackClusterPrivate_SetResult(stclpp ,
    &PLOByteDeque_SwapInd( me,ParaLispObjectToPLOComplex(ip),
             ParaLispObjectToPLOComplex(jp), stclpp )->plo);
  return  TaskForThread_Analyse; 
}

static  PLOByteDeque *  PLOByteDeque_SwapInd ( PLOByteDeque  * const me ,
  PLOComplex * const ip , PLOComplex  * const jp ,
  StackClusterPrivate  * const stp ) {
  if( ip  ==    jp) 
    return  me  ;
  if(not  Complex_Integerp(PLOComplexToComplexConst(ip))){
    ParaLispObject  * list [ ] = { &  ip->plo,
      & PLOString_NewCopy(L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return  me;
  }
  if(not  Complex_Integerp(PLOComplexToComplexConst(jp))){
    ParaLispObject  * list [ ] = { &  jp->plo,
      & PLOString_NewCopy(L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return  me; 
  }   
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    ip)) ,0U)){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy(L"index ")->plo,
      & ip->plo,& PLOString_NewCopy(L"<0")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return  me; 
  }
  size_t s = Deque_Size ( Byte ) ( & me -> dqbyte  ) ;
  if  ( ULongMoreOrEqSizet  ( FractionCNump  ( Complex_CRe (
    PLOComplexToComplexConst  ( ip  ) ) ) , s ) ) {
    PLOComplex  * const  res =NewComplexBareExc();
    Complex_SetUSize  ( PLOComplexToComplex( res),s);    
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy(L"index ")->plo,
      & ip->plo,& PLOString_NewCopy(L">=")->plo,&res->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return  me; 
  }
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    jp)) ,0U)){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy(L"index ")->plo,
      & jp->plo,& PLOString_NewCopy(L"<0")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return  me; 
  }
  if  ( ULongMoreOrEqSizet ( FractionCNump  (  Complex_CRe (
    PLOComplexToComplexConst  ( jp  ) ) ) , s ) ) {
    PLOComplex  * const  res = NewComplexBareExc(  );    
    Complex_SetUSize  ( PLOComplexToComplex( res),s);    
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy(L"index ")->plo,
      & jp->plo,& PLOString_NewCopy(L">=")->plo,&res->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return  me; 
  }
  { size_t  ui;
    ULongIsBADSizeValue  ( FractionCNump  (
      Complex_CRe  (PLOComplexToComplexConst(ip) ) ) ,
      & ui  ) ; // always good
    size_t  uj;
    ULongIsBADSizeValue ( FractionCNump  (
      Complex_CRe  (PLOComplexToComplexConst(jp) ) ) ,
      & uj  ) ; // always good
    uint8_t const tmp = * Deque_AtFast ( Byte ) ( & me -> dqbyte  , ui  ) ;
    * Deque_AtFast ( Byte ) ( & me -> dqbyte  , ui  ) =
      * Deque_AtConst ( Byte ) ( & me -> dqbyte  , uj  ) ;
    * Deque_AtFast ( Byte ) ( & me -> dqbyte  , uj  ) = tmp ; 
  }
  return  me; 
}

//  byte-vector size
TaskForThread Lisp2Dbimbytedequesize2( StackClusterPrivate  * const stclpp ){
  size_t  s;
  { PLOByteDeque * const  mep=ParaLispObjectToPLOByteDeque(
      StackClusterPrivate_ThisTop(stclpp ));
    s=PLOByteDeque_Size(mep);
  }
  PLOComplex  * const  res= NewComplexBareExc (  );
  Complex_SetUSize  ( PLOComplexToComplex( res),s);
  StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  return  TaskForThread_Analyse;
}
  
# include "cons/inline.h"

//  byte-vector elt indx [numberresultplace]
TaskForThread Lisp2DbimbytedequeElt2( StackClusterPrivate * const stclpp ){
  PLOByteDeque const * const  mep=ParaLispObjectToPLOByteDeque(
    StackClusterPrivate_ThisTop(stclpp ));
  ParaLispObject  * const ploindp= CCAR  ( StackClusterPrivate_ArgTop(
    stclpp ));
  if( IsNotNumber(  stclpp ,ploindp))
    return   TaskForThread_Analyse ;
  if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(
        ParaLispObjectToPLOComplexConst(ploindp))))){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"index ")->plo,
      ploindp,&  PLOString_NewCopy (L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(ploindp))),0U)){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"index ")->plo,
      ploindp,&  PLOString_NewCopy (L"<0")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  size_t  s;
  if  ( ULongIsBADSizeValue  ( FractionCNump  (
     Complex_CRe  (PLOComplexToComplexConst(
       ParaLispObjectToPLOComplexConst ( ploindp  )) ) ) ,  & s ) ) {
    ParaLispObject  * list [ ] = { ploindp,
      &  PLOString_NewCopy (L" is very big")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  size_t const mes = PLOByteDeque_Size ( mep  ) ;
  if(s  >=  mes){
    StackClusterPrivate_SetResult(stclpp ,& plonil .plo);
    return   TaskForThread_Analyse ;
  }
  { ParaLispObject  * const arg2p  = ClassCons_Rest  ( &
    ParaLispObjectToPLOCons (
    StackClusterPrivate_ArgTop  ( stclpp ) )->cc ) ;
    if(CConsp(arg2p)){
      ParaLispObject  * const resultplacep=
       ClassCons_First(&ParaLispObjectToPLOCons(arg2p)->cc);
      if( IsNotNumber(  stclpp ,resultplacep))      
        return  TaskForThread_Analyse;
      if(IsConst(  stclpp ,resultplacep))       
        return  TaskForThread_Analyse;
      Complex_SetUInt ( PLOComplexToComplex( ParaLispObjectToPLOComplex  (
        resultplacep )) ,
        PLOByteDeque_AtValue  ( mep  , s ) ) ;
      StackClusterPrivate_SetResult(stclpp ,resultplacep);
      return  TaskForThread_Analyse;
    }
  }
  PLOComplex  * const  res= NewComplexBareExc (  );
  Complex_SetUInt ( PLOComplexToComplex( res),
    PLOByteDeque_AtValue  ( mep  , s ) ) ;
  StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  return  TaskForThread_Analyse;
}

//  byte-vector setelt [indx [value]]
TaskForThread Lisp2DbimbytedequeSetelt2( StackClusterPrivate * const stclpp ){
  PLOByteDeque  * const mep=ParaLispObjectToPLOByteDeque(
    StackClusterPrivate_ThisTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  if(not  CConsp(StackClusterPrivate_ArgTop(stclpp )))
    return   TaskForThread_Analyse ;
  ParaLispObject  * const ploindp=ClassCons_First(&ParaLispObjectToPLOCons(
    StackClusterPrivate_ArgTop(stclpp ))->cc);
  if( IsNotNumber(  stclpp ,ploindp))
    return   TaskForThread_Analyse ;
  if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(
        ParaLispObjectToPLOComplexConst(ploindp))))){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"index ")->plo,
      ploindp,&  PLOString_NewCopy (L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return  TaskForThread_Analyse;
  }
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(ploindp))),0U)){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"index ")->plo,
      ploindp,&  PLOString_NewCopy (L"<0")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return  TaskForThread_Analyse;
  }
  { size_t const mes2 = PLOByteDeque_Size(mep);
    if ( ULongMoreOrEqSizet ( FractionCNump (
      Complex_CRe ( PLOComplexToComplexConst  (
      ParaLispObjectToPLOComplexConst ( ploindp ) ) ) ) , mes2  ) ) {
      PLOComplex  * const  res= NewComplexBareExc (  );
      Complex_SetUSize  ( PLOComplexToComplex( res),mes2);
      {  ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"index ")->plo,
        ploindp,& PLOString_NewCopy (L">=")->plo, &res->plo, NULL } ;
        StackClusterPrivate_ExceptionSet(stclpp ,
          ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list})); 
      }
      return  TaskForThread_Analyse;      
    }
  }
  ParaLispObject  * const arg2p  = ClassCons_Rest  ( &ParaLispObjectToPLOCons (
    StackClusterPrivate_ArgTop  ( stclpp ) )->cc ) ;
  if(not  CConsp(arg2p)){
    { size_t  i;
      ULongIsBADSizeValue  ( FractionCNump  (
           Complex_CRe  (PLOComplexToComplexConst(
             ParaLispObjectToPLOComplexConst ( ploindp  ) ) ) ) , & i ) ;
      // always good
      PLOByteDeque_SetAt  ( mep  , i , 0 ) ; 
    } // i
    return  TaskForThread_Analyse;
  }
  ParaLispObject  * const newvaluep=ClassCons_First(
    &ParaLispObjectToPLOCons(arg2p)->cc);
  if( IsNotNumber(  stclpp ,newvaluep))
    return  TaskForThread_Analyse;
  if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        newvaluep))))){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"new value ")->plo,
      newvaluep,&  PLOString_NewCopy (L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(newvaluep))),0U)){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"new value ")->plo,
      newvaluep,&  PLOString_NewCopy (L"<0")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  size_t  i;
  ULongIsBADSizeValue  ( FractionCNump  (
       Complex_CRe  (PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst (
         ploindp  ) ) ) ) , & i ) ;
  // always good
  { uint8_t  ucnew2;
    if  ( ULongisBADByteValue ( FractionCNump  (
      Complex_CRe ( PLOComplexToComplexConst  (
      ParaLispObjectToPLOComplexConst ( newvaluep  ) ) ) ) ,
      & ucnew2  ) ) {
      ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"new value ")->plo,
        newvaluep, & PLOString_NewCopy (L">=0x100")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return   TaskForThread_Analyse ; 
    }
    PLOByteDeque_SetAt  ( mep  , i , ucnew2  ) ; 
  }
  return   TaskForThread_Analyse ; 
}

//  byte-vector resize [newsize [newvalue]]
TaskForThread Lisp2Dbimbytedequeresize2( StackClusterPrivate * const stclpp ){
  PLOByteDeque * const  mep=ParaLispObjectToPLOByteDeque(
    StackClusterPrivate_ThisTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  if(not  CConsp(StackClusterPrivate_ArgTop(stclpp )))
    // nothing to do
    return   TaskForThread_Analyse ;
  ParaLispObject  * const newsizep=ClassCons_First(&ParaLispObjectToPLOCons(
    StackClusterPrivate_ArgTop(stclpp ))->cc);
  if( IsNotNumber(  stclpp ,newsizep))
    return   TaskForThread_Analyse ;
  if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        newsizep))))){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"size ")->plo,
      newsizep,& PLOString_NewCopy (L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(newsizep))),0U)){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"newsize ")->plo,
      newsizep,& PLOString_NewCopy (L"<0")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  { uint8_t    ucnewvalue2=0;
    { ParaLispObject  const * const argrestp = ClassCons_Rest  ( &
      ParaLispObjectToPLOCons (
        StackClusterPrivate_ArgTop  ( stclpp )  )->cc ) ;
      if(CConsp(argrestp)){
        ParaLispObject  * const newvaluep=ClassCons_First(
          &ParaLispObjectToPLOConsConst(argrestp)->cc);
        if( IsNotNumber(  stclpp ,newvaluep))
          return   TaskForThread_Analyse ;
        if(not  FractionIntegerP(
            Complex_CRe(PLOComplexToComplexConst(
              ParaLispObjectToPLOComplexConst( newvaluep)))) ){
          ParaLispObject  * list [ ] = { &
            PLOString_NewCopy (L"new value ")->plo, newvaluep,
            &  PLOString_NewCopy (L" is not integer")->plo, NULL } ;
          StackClusterPrivate_ExceptionSet(stclpp ,
            ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
          return   TaskForThread_Analyse ;
        }
        if(FractionLessUInt(
          Complex_CRe(PLOComplexToComplexConst(
            ParaLispObjectToPLOComplex(newvaluep))),    0U)){
          ParaLispObject  * list [ ] = { &  
            PLOString_NewCopy (L"new value ")->plo, newvaluep,
            &  PLOString_NewCopy (L"<0")->plo, NULL } ;
          StackClusterPrivate_ExceptionSet(stclpp ,
            ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
          return   TaskForThread_Analyse ;
        }
        if  ( ULongisBADByteValue ( FractionCNump  (
          Complex_CRe ( PLOComplexToComplexConst  (
            ParaLispObjectToPLOComplexConst ( newvaluep  ) ) ) ) ,
            & ucnewvalue2 ) ) {
            ParaLispObject  * list [ ] = { &
              PLOString_NewCopy (L"new value ")->plo, newvaluep,
              & PLOString_NewCopy (L">=0x100")->plo, NULL } ;
            StackClusterPrivate_ExceptionSet(stclpp ,
              ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
            return   TaskForThread_Analyse ; 
        } 
      } 
    }
    { size_t    snewsize=0;
      if  ( ULongIsBADSizeValue  ( FractionCNump  (
             Complex_CRe  (PLOComplexToComplexConst( 
             ParaLispObjectToPLOComplex (
               newsizep ))) ) , & snewsize  ) ) {
        ParaLispObject  * list [ ] = { newsizep,& PLOString_NewCopy (
          L" is very big")->plo, NULL } ;
        StackClusterPrivate_ExceptionSet(stclpp ,
          ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
        return   TaskForThread_Analyse ;
      }
      PLOByteDeque_Resize2  ( mep  , snewsize  , ucnewvalue2 ) ;
    } 
  }
  return   TaskForThread_Analyse ; 
}

//  byte-vector push-back  [value]
TaskForThread Lisp2Dbimbytedequepushback2( 
  StackClusterPrivate * const stclpp ){
  PLOByteDeque  * const mep=ParaLispObjectToPLOByteDeque(
    StackClusterPrivate_ThisTop(stclpp ));
  if(not  CConsp(StackClusterPrivate_ArgTop(stclpp ))){
    if(PLOByteDeque_PushBack2(mep,0)) {
      OutOfMemory( stclpp );
      return   TaskForThread_Analyse ; }
    StackClusterPrivate_SetResult(stclpp ,&mep->plo);
    return   TaskForThread_Analyse ;
  }
  ParaLispObject  * const newvaluep=ClassCons_First(&ParaLispObjectToPLOCons(
    StackClusterPrivate_ArgTop(stclpp ))->cc);
  if( IsNotNumber(  stclpp ,newvaluep))
    return   TaskForThread_Analyse ;
  if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        newvaluep      ))))){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"new value ")->plo,
      newvaluep,&  PLOString_NewCopy (L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(newvaluep))),0U)){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"new value ")->plo,
      newvaluep,&  PLOString_NewCopy (L"<0")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  { uint8_t  ucnew2;
    if  ( ULongisBADByteValue ( FractionCNump  (
      Complex_CRe (PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst (
        newvaluep  )  ) ) ) , & ucnew2  ) ) {
      ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"new value ")->plo,
        newvaluep,& PLOString_NewCopy (L">=0x100")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return   TaskForThread_Analyse ;}
    if(PLOByteDeque_PushBack2(mep,ucnew2)){
      OutOfMemory( stclpp );
      return   TaskForThread_Analyse ;
    }
  }
  StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  return   TaskForThread_Analyse ;
}

//  byte-vector push-front  [value]
TaskForThread Lisp2Dbimbytedequepushfront2( 
  StackClusterPrivate * const stclpp ){
  PLOByteDeque  * const mep=ParaLispObjectToPLOByteDeque(
    StackClusterPrivate_ThisTop(stclpp ));
  if(not  CConsp(StackClusterPrivate_ArgTop(stclpp ))){
    if(PLOByteDeque_PushFront2(mep,0)){
      OutOfMemory( stclpp );
      return   TaskForThread_Analyse ;}
    StackClusterPrivate_SetResult(stclpp ,&mep->plo);
    return   TaskForThread_Analyse ;
  }
  ParaLispObject  * const newvaluep=ClassCons_First(&ParaLispObjectToPLOCons(
    StackClusterPrivate_ArgTop(stclpp ))->cc);
  if(IsNotNumber(  stclpp ,newvaluep))
    return   TaskForThread_Analyse ;
  if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        newvaluep))))){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"new value ")->plo,
      newvaluep,&  PLOString_NewCopy (L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(newvaluep))),0U)){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"new value ")->plo,
      newvaluep,&  PLOString_NewCopy (L"<0")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  { uint8_t  ucnew2;
    if  ( ULongisBADByteValue ( FractionCNump  (
      Complex_CRe ( PLOComplexToComplexConst  (
        ParaLispObjectToPLOComplexConst (
        newvaluep  ) ) ) ) , & ucnew2 ) ) {
      ParaLispObject  * list [ ] = { &  PLOString_NewCopy (L"new value ")->plo,
        newvaluep,& PLOString_NewCopy (L">=0x100")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return   TaskForThread_Analyse ;
    }
    if(PLOByteDeque_PushFront2(mep,ucnew2)){
      OutOfMemory( stclpp );
      return   TaskForThread_Analyse ;
    }
  }
  StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  return   TaskForThread_Analyse ; 
}

//  byte-vector pop-back [number-result]
TaskForThread Lisp2Dbimbytedequepopback2( StackClusterPrivate  * const stclpp ){
  PLOByteDeque  * const mep= ParaLispObjectToPLOByteDeque(StackClusterPrivate_ThisTop(stclpp ));
  if(CConsp(StackClusterPrivate_ArgTop(stclpp ))){
    ParaLispObject  * const resp=
      ClassCons_First(&ParaLispObjectToPLOCons(
        StackClusterPrivate_ArgTop(stclpp ))->cc);
    if(IsNotNumber(  stclpp ,resp))
      return   TaskForThread_Analyse ;
    if(IsConst(   stclpp ,resp))
      return   TaskForThread_Analyse ;
    { uint8_t  ucresult2;
      if  ( PLOByteDeque_PopBack2 ( mep  , & ucresult2 ) ) {
        StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
        return   TaskForThread_Analyse ;
      }
      Complex_SetUInt ( PLOComplexToComplex( ParaLispObjectToPLOComplex(resp)), ucresult2);
    }
    StackClusterPrivate_SetResult(stclpp ,resp);
    return  TaskForThread_Analyse;
  }
  uint8_t  res2;
  if  ( PLOByteDeque_PopBack2 ( mep  , & res2  ) ) 
    StackClusterPrivate_SetResult(stclpp ,& plonil .plo);
  else{
    PLOComplex  * const  res= NewComplexBareExc (  );
    Complex_SetUInt ( PLOComplexToComplex( res),res2);
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  }
  return  TaskForThread_Analyse;
}

//  byte-vector pop-front [number-result]
TaskForThread Lisp2Dbimbytedequepopfront2( StackClusterPrivate * const stclpp ){
  PLOByteDeque  * const mep=
    ParaLispObjectToPLOByteDeque(StackClusterPrivate_ThisTop(stclpp ));
  if(CConsp(StackClusterPrivate_ArgTop(stclpp ))){
    ParaLispObject  * const resp= ClassCons_First(&ParaLispObjectToPLOCons(
        StackClusterPrivate_ArgTop(stclpp ))->cc);
    if(IsNotNumber(  stclpp ,resp))
      return   TaskForThread_Analyse ;
    if(IsConst(   stclpp ,resp))
      return   TaskForThread_Analyse ;
    { uint8_t  ucresult2;
      if  ( PLOByteDeque_PopFront2  ( mep  , & ucresult2 ) ) {
        StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
        return   TaskForThread_Analyse ;
      }
      Complex_SetUInt ( PLOComplexToComplex( ParaLispObjectToPLOComplex(resp)), ucresult2);
    }
    StackClusterPrivate_SetResult(stclpp ,resp);
    return  TaskForThread_Analyse;
  }
  uint8_t  res2;
  if  ( PLOByteDeque_PopFront2  ( mep  , & res2  ) )
    StackClusterPrivate_SetResult(stclpp ,& plonil .plo);
  else{
    PLOComplex  * const  res= NewComplexBareExc (  );
    Complex_SetUInt ( PLOComplexToComplex( res),res2);
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  }
  return  TaskForThread_Analyse;
}

//  byte-vector back [number-result]
TaskForThread Lisp2Dbimbytedequeback2( StackClusterPrivate * const stclpp ){
  PLOByteDeque  * const mep= ParaLispObjectToPLOByteDeque(StackClusterPrivate_ThisTop(stclpp ));
  if(CConsp(StackClusterPrivate_ArgTop(stclpp ))){
    ParaLispObject  * const resp=
      ClassCons_First(&ParaLispObjectToPLOCons(
        StackClusterPrivate_ArgTop(stclpp ))->cc);
    if(IsNotNumber(  stclpp ,resp))
      return   TaskForThread_Analyse ;
    if(IsConst(    stclpp ,resp))
      return   TaskForThread_Analyse ;
    { uint8_t  ucresult2;
      if  ( PLOByteDeque_Back2  ( mep  , & ucresult2 ) ) {
        StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
        return   TaskForThread_Analyse ;
      }
      Complex_SetUInt ( PLOComplexToComplex( ParaLispObjectToPLOComplex(resp)), ucresult2);
    }
    StackClusterPrivate_SetResult(stclpp ,resp);
    return  TaskForThread_Analyse;
  }
  uint8_t  res2;
  if  ( PLOByteDeque_Back2  ( mep  , & res2  ) )  
    StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
  else{
    PLOComplex  * const  res= NewComplexBareExc ();
    Complex_SetUInt ( PLOComplexToComplex( res),res2);
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  }
  return  TaskForThread_Analyse;
}

//  byte-vector front [number-result]
TaskForThread Lisp2Dbimbytedequefront2( StackClusterPrivate  * const stclpp ){
  PLOByteDeque  * const mep= ParaLispObjectToPLOByteDeque(StackClusterPrivate_ThisTop(stclpp ));
  if(CConsp(StackClusterPrivate_ArgTop(stclpp ))){
    ParaLispObject  * const resp=ClassCons_First(&ParaLispObjectToPLOCons(
      StackClusterPrivate_ArgTop(stclpp ))->cc);
    if(IsNotNumber(  stclpp ,resp))
      return   TaskForThread_Analyse ;
    if(IsConst(   stclpp ,resp))
      return   TaskForThread_Analyse ;
    { uint8_t  ucresult2;
      if  ( PLOByteDeque_Front2 ( mep  , & ucresult2 ) ) {
        StackClusterPrivate_SetResult(stclpp ,& plonil .plo);
        return   TaskForThread_Analyse ;
      }
      Complex_SetUInt ( PLOComplexToComplex( ParaLispObjectToPLOComplex(resp)), ucresult2);
    }
    StackClusterPrivate_SetResult(stclpp ,resp);
    return  TaskForThread_Analyse;
  }
  uint8_t  res2;
  if  ( PLOByteDeque_Front2 ( mep  , & res2  ) )  
    StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
  else {
    PLOComplex  * const  res= NewComplexBareExc (  );
    Complex_SetUInt ( PLOComplexToComplex( res),res2);
  }
  return  TaskForThread_Analyse;
}
  
# include "vector/public.h"
# include "newobject.h"

//  byte-vector vector [vector-result]
TaskForThread Lisp2DbimbytedequeVector2( StackClusterPrivate * const stclpp ){
  PLOByteDeque  const * const mep=ParaLispObjectToPLOByteDeque( StackClusterPrivate_ThisTop(stclpp ));
  PLOVector * vectorresult;
  size_t  s2=PLOByteDeque_Size(mep);
  if(CConsp(StackClusterPrivate_ArgTop(stclpp ))){
    ParaLispObject  * const firstargp=ClassCons_First(&ParaLispObjectToPLOCons(
      StackClusterPrivate_ArgTop(stclpp ))->cc);
    if  ( IsNotType ( vector  ) (  stclpp , firstargp ) )
      return   TaskForThread_Analyse ;
    if(IsConst(  stclpp ,firstargp))
      return   TaskForThread_Analyse ;
    vectorresult  =   ParaLispObjectToPLOVector(firstargp);
    PLOVector_ResizeFill(vectorresult,s2, &plonil.plo );
  } else{
    vectorresult = aligned_alloc ( _Alignof ( PLOVector ) , sizeof  ( PLOVector ) ) ;
    if ( not vectorresult ) {
      OutOfMemory( stclpp );
      return  TaskForThread_Analyse;
    }
    PLOVector_InitSizeFill(vectorresult,s2,& plonil.plo);
    PLOVector_staticPushAsNew(&vectorresult->plo);
  }
  for(;s2 > 0;--  s2){
    size_t  const  iminus1=s2  - 1;
    PLOComplex  * const  elt= NewComplexBareExc ();
    Complex_SetUInt ( PLOComplexToComplex( elt) ,
      PLOByteDeque_AtValue  ( mep  , iminus1 ) ) ;
    PLOVector_SetElt(vectorresult,iminus1, & elt->plo);
  }
  StackClusterPrivate_SetResult(stclpp ,&  vectorresult->plo);
  return   TaskForThread_Analyse ;
}

//  byte-vector list
TaskForThread Lisp2DbimbytedequeList2( StackClusterPrivate * const stclpp ){
  PLOByteDeque  const * const me = 
    ParaLispObjectToPLOByteDeque(StackClusterPrivate_ThisTop(stclpp ));
  size_t  i=PLOByteDeque_Size(me);
  if(i ==  0){
    StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
    return  TaskForThread_Analyse;
  }
  ParaLispObject  *   listresult=& plonil .plo;
  do{
    --  i;
    PLOComplex  * const  res= NewComplexBareExc (  );
    Complex_SetUInt ( PLOComplexToComplex( res) ,
      PLOByteDeque_AtValue  ( me  , i ) ) ;
    listresult  = &(  NewCons( & res->plo ,  listresult))->plo; 
  }while(i  > 0);
  StackClusterPrivate_SetResult(stclpp ,  listresult);
  return   TaskForThread_Analyse ;
}

// byte-vector subseq [indexfirst [indexend]] => [first..end-1]
TaskForThread Lisp2Dbimbytedequesubseq2( StackClusterPrivate * const stclpp ){
  PLOByteDeque  * const mep=ParaLispObjectToPLOByteDeque(
    StackClusterPrivate_ThisTop(stclpp ));
  ParaLispObject  * const arglistp=StackClusterPrivate_ArgTop(stclpp );
  if(not  CConsp(arglistp)){
    ParaLispObject  * result;
    if  ( ParaLispObject_isBADCopy ( & mep->plo  , & result  ) ) 
      OutOfMemory(   stclpp );      
    else   
      StackClusterPrivate_SetResult(stclpp , result);
    return  TaskForThread_Analyse;
  }
  ParaLispObject  * const indp=ClassCons_First(&ParaLispObjectToPLOCons(
    arglistp)->cc);
  if(IsNotNumber(  stclpp ,indp)) 
    return   TaskForThread_Analyse ;
  if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        indp))))){
    ParaLispObject  * list [ ] = { indp,
      & PLOString_NewCopy (L" is not integer")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
    if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(indp))),0U)){      
      ParaLispObject  * list [ ] = { indp,& PLOString_NewCopy (L" < 0")->plo,
        NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return   TaskForThread_Analyse ;
  }
  size_t  ind1;
  if(  FractionIsBadSizeValue(
    Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
      indp))), &ind1)){
    ParaLispObject  * list [ ] = { indp,
      & PLOString_NewCopy (L" is too big")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));
    return   TaskForThread_Analyse ;
  }
  ParaLispObject  * const arglist2p  = ClassCons_Rest  (
    &ParaLispObjectToPLOCons ( arglistp )->cc ) ;
  if(CConsp(arglist2p)){
    ParaLispObject  * const indendp=ClassCons_First(&
      ParaLispObjectToPLOCons(arglist2p)->cc);
    if(IsNotNumber(  stclpp ,indendp))
      return   TaskForThread_Analyse ;
    if(not  FractionIntegerP(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
          indendp))))){
      ParaLispObject  * list [ ] = { indendp,&  PLOString_NewCopy (
        L" is not integer")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return   TaskForThread_Analyse ;
    }
    if(FractionLess(Complex_CRe(PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(indendp))),
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        indp))))  ==  Lisp2DBoolTrue){
      ParaLispObject  * list [ ] = { indendp,&  PLOString_NewCopy (L" < ")
        ->plo, indp, NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return   TaskForThread_Analyse ;
    }
    size_t  ind2;
    if(  FractionIsBadSizeValue(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst( indendp))), &ind2)){
      ParaLispObject  * list [ ] = { indendp,& PLOString_NewCopy (L" is too big")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp , ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return   TaskForThread_Analyse ;
    }
    PLOByteDeque  * const res2 = aligned_alloc ( _Alignof ( PLOByteDeque ) , sizeof  ( PLOByteDeque ) ) ;
    if ( not res2 ) {
      OutOfMemory ( stclpp )  ;
      return  TaskForThread_Analyse ; 
    }
    t_PLOByteDeque_InitFromTo const arg = {
      . me  = res2  ,
      . vp  = mep ,
      . indexfirst  = ind1  ,
      . indexend  = ind2  ,
    } ;
    //PLOByteDeque_InitFromTo ( res2  , mep  , ind1  , ind2  ) ;
    PLOByteDeque_InitFromTo ( & arg ) ;
    ParaLispObject_virtualPushAsNew ( & res2  ->  plo ) ;
    StackClusterPrivate_SetResult ( stclpp ,  & res2  ->  plo ) ;      
    return  TaskForThread_Analyse ;
  }
  PLOByteDeque  * const res2 = aligned_alloc ( _Alignof ( PLOByteDeque ) , sizeof  ( PLOByteDeque ) ) ;
  if ( not res2 ) {
    OutOfMemory ( stclpp )  ;
    return  TaskForThread_Analyse ; 
  }
  PLOByteDeque_InitFrom ( res2 , mep , ind1 ) ;
  ParaLispObject_virtualPushAsNew ( & res2  ->  plo ) ;
  StackClusterPrivate_SetResult ( stclpp ,  &  res2 ->  plo ) ;    
  return  TaskForThread_Analyse ; 
}

# include "stringbim.h"
# include "string/public.h"
# include "stack/public.h"

//  byte-vector string [string-result]
// ! to get any answer with count of bytes translated ?
TaskForThread Lisp2DbimbytedequeString2( StackClusterPrivate * const stclpp ){
  PLOByteDeque  const * const me = ParaLispObjectToPLOByteDeque( StackClusterPrivate_ThisTop(stclpp ));
  PLOStringPub * stringresult ;
  size_t const s2 = PLOByteDeque_Size ( me ) ;
  if  ( CConsp  ( StackClusterPrivate_ArgTop  ( stclpp ) ) ) {
    ParaLispObject  * const firstargp=ClassCons_First(&ParaLispObjectToPLOCons(
      StackClusterPrivate_ArgTop(stclpp ))->cc);
    if(IsNotString(  stclpp ,firstargp))
      return   TaskForThread_Analyse ;
    if(IsConst(  stclpp ,firstargp))
      return   TaskForThread_Analyse ;
    stringresult  =   ParaLispObjectToPLOString ( firstargp ) ;
  } else
    stringresult  = PLOString_New ( ) ;
  ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
  String  ( Char ) * const strtmpc = StackNew_StringChar ( ) ;
  String_Init ( Char  ) ( strtmpc , true ) ;
  for ( size_t  i = 0  ; i < s2 ; ++  i ) {
    String_AddChar  ( Char  ) ( strtmpc , uint8_cast_char ( PLOByteDeque_AtValue  ( me  , i ) ) ) ;
  }
  String  ( WideChar ) * const wstrtmpc = StackNew_StringWideChar ( ) ;
  String_Init ( WideChar  ) ( wstrtmpc , true ) ;
// ! to get any answer with count of bytes translated ?
  if  ( isBADReadCStringToWString2 ( strtmpc , wstrtmpc ) )
    StackClusterPrivate_SetResult (stclpp ,& plonil.plo  ) ;
  else  {
    StringSetArray( WideChar )(PLOString_Value2 (stringresult ) ,
      StringCStr ( WideChar ) ( wstrtmpc ) ) ;
    StackClusterPrivate_SetResult (stclpp ,&   stringresult ->plo) ;
  }
  Lisp2D_StackFree  ( oldstack ) ;
  return   TaskForThread_Analyse ;
}

# include "char/public.h"
  
// byte-vector char
TaskForThread Lisp2Dbimbytevectorchar ( StackClusterPrivate  * const stclpp  ) {
  { PLOByteDeque  * const mep  =  ParaLispObjectToPLOByteDeque  ( StackClusterPrivate_ThisTop( stclpp ) ) ;
    size_t  mes = PLOByteDeque_Size ( mep ) ;
    if  ( mes > 6 )
      mes = 6 ;
    wchar_t y ;
    { ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
      String  ( Char ) * const xc = StackNew_StringChar ( ) ;
      String_Init ( Char  ) ( xc , true ) ;
      for ( size_t  i = 0 ; i < mes ; ++  i )
        String_AddChar  ( Char  ) ( xc , ( char ) ( PLOByteDeque_AtValue  ( mep  , i ) ) ) ;
      { char  const * xic2 = String_CBegin  ( Char  ) ( xc  ) ;
        char  const * const xendc2 = String_CEnd  ( Char  ) ( xc  ) ;
        if  ( isBADReadStringToOneWChar ( xendc2 , & xic2 , & y ) )  {
          Lisp2D_StackFree  ( oldstack ) ;
          StackClusterPrivate_SetResult (stclpp , & plonil .  plo ) ;
          return   TaskForThread_Analyse  ;
        }
      }
      Lisp2D_StackFree  ( oldstack ) ;
    } // xc
    PLOCharPriv * const v2 = aligned_alloc ( _Alignof ( PLOCharPriv ) , sizeof  ( PLOCharPriv ) ) ;
    if  ( not v2 ) {
      OutOfMemory (  stclpp ) ;
      return   TaskForThread_Analyse  ;
    }
    PLOChar_Init  ( v2  ) ;
    ParaLispObject_virtualPushAsNew ( & v2  -> pub . plo ) ;
    PLOChar_SetValue ( & v2 -> pub , y ) ;
    StackClusterPrivate_SetResult ( stclpp ,  &  v2 ->  pub . plo  ) ;
  } // me
  return   TaskForThread_Analyse  ;
}

void  PLOByteDeque_InitCopy ( PLOByteDeque * const me , PLOByteDeque const * const xp ) {
  VirtualTypePointer const vtp = { . addr = { . p = me } , . type = TypeGlobalListMemberPLOByteDeque } ;
  ParaLispObject_InitVTP  ( & me  ->  plo , vtp ) ;
  Deque ( Byte ) * const medq = & me -> dqbyte ;
  Deque ( Byte ) const * const xpdq = & xp -> dqbyte ;
  Deque_InitCopy ( Byte ) ( medq , xpdq ) ;
# ifdef  LISP2D_CONSTRSTAT
  PLOByteDeque_constrstat_inc ( ) ;
# endif
}

void PLOByteDeque_staticDestr  ( ParaLispObject * const me ) {
  PLOByteDeque_Destr (  ParaLispObjectToPLOByteDeque  ( me  ) ) ;
}

uint8_t  * PLOByteDeque_SetAt ( PLOByteDeque * const me , size_t  const index , uint8_t const val ) {
  uint8_t  * const pl = Deque_At  ( Byte  ) ( & me  -> dqbyte , index ) ;
  ( * pl ) = val ;
  return pl ;
}

uint8_t PLOByteDeque_AtValue ( PLOByteDeque const * const me , size_t const index ) {
  return * Deque_AtConst  ( Byte  ) ( & me -> dqbyte , index ) ;
}

void  PLOByteDeque_Swap  ( PLOByteDeque  * const me , PLOByteDeque  * const x ) {
// ! to check or not to check ?
  if  ( me  not_eq  x )
    Deque_Swap ( Byte ) ( & me -> dqbyte , & x -> dqbyte ) ;
}

# include "castb.h"
# include "widestring/inline.h"
