// Lisp2D - ByteDeque #[] Vector Length
// ©2014-23 by Alex Glebe

# include "bytedeque/vectorlength.h"

_Atomic ( size_t  ) gcbytevectorslength = 0 ;

# ifdef  LISP2D_CONSTRSTAT

_Atomic ( size_t  ) PLOByteDeque_constrstat = 0 ;

# endif // LISP2D_CONSTRSTAT

// ! don't inline : increased code size !

size_t  bytevector_length_value ( void  ) {
  return  gcbytevectorslength ;
}

void  bytevector_length_inc ( void ) {
  ++ gcbytevectorslength  ;
}

void  bytevector_length_dec ( void ) {
  -- gcbytevectorslength  ;
}

void  bytevector_length_add ( size_t const d  ) {
  gcbytevectorslength += d ;
}

void  bytevector_length_sub ( size_t const d  ) {
  gcbytevectorslength -= d ;
}

void  bytevector_length_clear ( void ) {
  gcbytevectorslength = 0 ;
}

# ifdef  LISP2D_CONSTRSTAT

void  PLOByteDeque_constrstat_inc ( void ) {
  ++  PLOByteDeque_constrstat ;
}

size_t  PLOByteDeque_constrstat_value ( void ) {
  return  PLOByteDeque_constrstat ;
}

# endif // LISP2D_CONSTRSTAT
