// Lisp2D StackCluster
// ©2003-23 by Alex Glebe
# include "define.h"
# include "stcl/classc.h"
# include "stcl/constructoraftergarbage.h"
# include "sharedc.h"
# include "shared/inline.h"
# include "addrforreturn/public.h"
# include "thread.h"
# include "stcl/queue.h"
# include "parray.h"

# ifdef  LISP2D_BIMSTAT

# define  s_averageStackClustermutex  Lisp2D_s_averageStackClustermutexMoMJ
# define  t_averageStackClustermutex  Lisp2D_t_averageStackClustermutexnV0W
typedef struct  s_averageStackClustermutex {
  _Atomic ( size_t  ) TaskStatFast  ;
  _Atomic ( size_t  ) TaskStatWait  ;
  _Atomic ( size_t  ) ExceptionStatFast ;
  _Atomic ( size_t  ) ExceptionStatWait ;
} t_averageStackClustermutex  ;

# define  averageStackClustermutex  Lisp2D_averageStackClustermutexQxEn
t_averageStackClustermutex  averageStackClustermutex  = {
  . TaskStatFast  = 0 , . TaskStatWait  = 0 ,
  . ExceptionStatFast = 0 , . ExceptionStatWait = 0 ,
} ;

size_t  averageStackClustermutex_TaskStatFast_Value ( void ) {
  return  averageStackClustermutex  . TaskStatFast  ;
}

void  averageStackClustermutex_TaskStatFast_Add ( size_t  d ) {
  averageStackClustermutex  . TaskStatFast  +=  d ;
}

size_t  averageStackClustermutex_TaskStatWait_Value ( void ) {
  return  averageStackClustermutex  . TaskStatWait  ;
}

void  averageStackClustermutex_TaskStatWait_Add ( size_t  d ) {
  averageStackClustermutex  . TaskStatWait  +=  d ;
}

size_t  averageStackClustermutex_ExceptionStatFast_Value ( void ) {
  return  averageStackClustermutex  . ExceptionStatFast  ;
}

void  averageStackClustermutex_ExceptionStatFast_Add ( size_t  d ) {
  averageStackClustermutex  . ExceptionStatFast  +=  d ;
}

size_t  averageStackClustermutex_ExceptionStatWait_Value ( void ) {
  return  averageStackClustermutex  . ExceptionStatWait  ;
}

void  averageStackClustermutex_ExceptionStatWait_Add ( size_t  d ) {
  averageStackClustermutex  . ExceptionStatWait  +=  d ;
}

  # undef averageStackClustermutexTaskStatFast
# endif

# ifdef LISP2D_CONSTRSTAT
  _Atomic ( size_t  ) StackCluster_constrstat = 0 ;

  size_t  StackCluster_constrstat_Value ( void  ) {
    return  StackCluster_constrstat ; 
  }

  void  StackCluster_constrstat_Inc ( void  ) {
    ++  StackCluster_constrstat ; 
  }
# endif

# include "nilc.h"
# include "env/public.h"

void  StackClusterPrivateInitHistory ( StackClusterPrivate * const s , size_t const myhs ) {
  s ->  sonscount = 0 ;
  s ->  result  = & plonil.plo  ;
  s ->  resultplace = ((void*)0)  ;
  s ->  resultplaceforgc  = ((void*)0) ;
  s ->  scFatherp  = ((StackClusterPrivate*)0) ;
  s ->  whole =  & plonil.plo ;
  s ->  TaskForManager2 = TaskRun ;
  s ->  exceptionvalue  = &  plonil.plo ;
  s ->  exceptionhistory  = &  plonil.plo ;
  s ->  flagApply = false ;
  s ->  exceptionnotprocessed = false ;
  s ->  wanttobeingarbage = false ;
  s ->  handtoqueue = ((void*)0) ;
# ifdef  LISP2D_DEBUG
  s ->  mutexTask . state = Lisp2DStructNotConstructed ;
  s ->  mutexExceptionC . state = Lisp2DStructNotConstructed ;
# endif
  Environment_Init  ( & s ->  envLocal ) ;
  Environment_Init  ( & s ->  envExternal ) ;
  { VirtualTypePointer  vtp = { . addr = { . p = s } , . type = TypeGlobalListMemberStClPriv } ;
    GlobalListMemberConstrFB  ( & s ->  base , vtp ) ;
  }
  jmp_buf jump_buffer ;
  jmp_buf * jump_buffer_backup ;
  jmp_buf * jump_buffer_backup2 ;
  StackClusterHistoryConstructor ( & s ->  myHistory2 , myhs ) ;
  jump_buffer_backup = Lisp2DJBglobal ;
  Lisp2DJBglobal = & jump_buffer ;
  int const volatile ex = setjmp  ( jump_buffer  ) ;
  if  ( ex ) {
    Lisp2DJBglobal = jump_buffer_backup ;
    goto HD  ;
  }
  Lisp2DMutexConstructor  ( & s ->  mutexTask ) ;
  Lisp2DJBglobal = jump_buffer_backup ; 
  jump_buffer_backup2 = Lisp2DJBglobal ;
  Lisp2DJBglobal = & jump_buffer ;
  int const volatile ex2 = setjmp  ( jump_buffer  ) ;
  if  ( ex2 ) {
    Lisp2DJBglobal = jump_buffer_backup2 ;
    Lisp2DMutexDestructor  ( & s ->  mutexTask ) ;
HD  :    
    Lisp2DStackClusterHistoryDestructor  ( & s ->  myHistory2 ) ;
    Lisp2DExcOutOfMemoryGlobal . value =
      L"StackClusterPrivate2 ( size_t myhs , VirtualTypePointer fb )" ;
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ;
  }
  Lisp2DMutexConstructor  ( & s ->  mutexExceptionC ) ;
  Lisp2DJBglobal = jump_buffer_backup2 ; 
  Lisp2DAddrForReturn2ConstructorDefault  ( & s ->  flagcont  ) ;
  VectorInit  ( StackPLOP ) ( & s ->  stackc  , false ) ;
  VectorInit  ( StackPLOP ) ( & s ->  stackcThis  , false ) ;
  VectorInit  ( StackPLOP ) ( & s ->  stackcMethod  ,false ) ;
  VectorInit  ( StackPLOP ) ( & s ->  stackcproArg  ,false ) ;
  VectorInit  ( StackAddrForReturn  ) ( & s ->  stackAddr  , false ) ;
}

StackClusterPrivate * new_StackClusterPrivateInitHistory ( size_t const myhs ) {
  StackClusterPrivate * const s = aligned_alloc ( _Alignof ( StackClusterPrivate ) , sizeof ( StackClusterPrivate ) ) ;
  if ( not s ) {
    Lisp2DExcOutOfMemoryGlobal . value =
      L"new_StackClusterPrivateInitHistory:out of memory" ;
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ;
  }
  StackClusterPrivateInitHistory ( s , myhs ) ;
  return  s ;
}

void  StackClusterPrivateInitPoint ( StackClusterPrivate * const s ) {
  s ->  sonscount = 0 ;
  s ->  result  = & plonil.plo  ;
  s ->  resultplace = 0 ;
  s ->  resultplaceforgc  = 0 ;
  s ->  scFatherp  = 0 ;
  s ->  whole =  & plonil.plo ;
  s ->  TaskForManager2 = TaskRun ;
  s ->  exceptionvalue  = &  plonil.plo ;
  s ->  exceptionhistory  = &  plonil.plo ;
  s ->  flagApply = false ;
  s ->  exceptionnotprocessed = false ;
  s ->  wanttobeingarbage = false ;
  s ->  handtoqueue = 0 ;
# ifdef  LISP2D_DEBUG
  s ->  mutexTask . state = Lisp2DStructNotConstructed ;
  s ->  mutexExceptionC . state = Lisp2DStructNotConstructed ;
# endif
  Environment_Init  ( & s ->  envLocal ) ;
  Environment_Init  ( & s ->  envExternal ) ;
  { VirtualTypePointer  vtp = { . addr = { . p = s } , . type = TypeGlobalListMemberStClPriv } ;
    GlobalListMemberConstrFB  ( & s ->  base , vtp ) ;
  }
  jmp_buf * jb_backup = Lisp2DJBglobal ;
  jmp_buf jb ;
  Lisp2DJBglobal = & jb ;
  int const volatile ex = setjmp  ( jb  ) ;
  if  ( ex ) {
    Lisp2DJBglobal = jb_backup ;
    goto EX ;
  }
  Lisp2DMutexConstructor  ( & s ->  mutexTask ) ;
  int const volatile ex2 = setjmp  ( jb  ) ;
  if  ( ex2 ) {
    Lisp2DJBglobal = jb_backup ;
    Lisp2DMutexDestructor  ( & s ->  mutexTask ) ;
EX :    
    Lisp2DExcOutOfMemoryGlobal . value =
      L"StackClusterPrivate2 ( VirtualTypePointer fb )" ;
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ;
  }
  Lisp2DMutexConstructor  ( & s ->  mutexExceptionC ) ;
  Lisp2DJBglobal = jb_backup ;
  Lisp2DStackClusterHistoryConstructorDefault  ( & s ->  myHistory2 ) ;
  Lisp2DAddrForReturn2ConstructorDefault(&s ->  flagcont);
  VectorInit  ( StackPLOP ) ( & s ->  stackc  , false ) ;
  VectorInit  ( StackPLOP ) ( & s ->  stackcThis  , false ) ;
  VectorInit  ( StackPLOP ) ( & s ->  stackcMethod  , false ) ;
  VectorInit  ( StackPLOP ) ( & s ->  stackcproArg  , false ) ;
  VectorInit  ( StackAddrForReturn  ) ( & s ->  stackAddr  , false ) ;
}

StackClusterPrivate * new_StackClusterPrivateInitPoint ( void ) {
  StackClusterPrivate * const s = aligned_alloc ( _Alignof ( StackClusterPrivate ) , sizeof ( StackClusterPrivate ) ) ;
  if ( not s ) {
    Lisp2DExcOutOfMemoryGlobal . value =
      L"new_StackClusterPrivateInitPoint:out of memory" ;
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ;
  }
  StackClusterPrivateInitPoint ( s ) ;
  return  s ;
}

void  StackClusterPrivate_Destructor  ( StackClusterPrivate * const s ) {
  Vector_Destr  ( StackPLOP ) ( & s -> stackc  ) ;
  Vector_Destr  ( StackPLOP ) ( & s -> stackcThis  ) ;
  Vector_Destr  ( StackPLOP ) ( & s -> stackcMethod  ) ;
  Vector_Destr  ( StackPLOP ) ( & s -> stackcproArg  ) ;
  Vector_Destr  ( StackAddrForReturn  ) ( & s -> stackAddr  ) ;
  Lisp2DStackClusterHistoryDestructor ( & s -> myHistory2 ) ;
  Lisp2DMutexDestructor  ( & s -> mutexTask ) ;
  Lisp2DMutexDestructor  ( & s -> mutexExceptionC ) ;
  ConsAtomicPointerFree ( s ->  handtoqueue ) ;
}

StackClusterPrivate  * StackClusterConstructorAfterGarbage ( StackClusterPrivate  * const me  , size_t  const myhs  ) {
  Environment_Init  ( & me -> envLocal  ) ;
  Environment_Init  ( & me -> envExternal  ) ;
  me -> sonscount = 0 ;
  me -> result  = ( & plonil .plo ) ;
  me ->resultplace = NULL ;
  me ->resultplaceforgc  = NULL ;
  me ->scFatherp  = NULL ;
  me ->flagcont . inBIM  = false  ;
  Lisp2DEvalAddrClear ( &  me  -> flagcont   . addr . pub ) ;
  me ->whole = ( & plonil.plo  ) ;
  me ->TaskForManager2 =  TaskRun ;
  me ->exceptionvalue  = ( &  plonil .plo) ;
  me ->exceptionhistory  = ( &  plonil .plo) ;
  me ->flagApply = false ;
  me ->exceptionnotprocessed = false ;
  Lisp2DStackClusterHistoryInit_ExcStrMem ( & me  -> myHistory2 , myhs ) ;    
  return me ;
}

void  StackClusterPrivate_SetflagCont ( StackClusterPrivate  * const stclp  , Lisp2DEvalAddrCont2 const a ) {
  EvalAddrSetCont ( & ( stclp -> flagcont . addr . pub ) , a ) ;
}

// returns flagCont was here and clear it to zero
Lisp2DEvalAddrCont2 StackClusterPrivate_ClearflagCont  ( StackClusterPrivate  * const stclp  ) {
  if  ( Lisp2DEvalAddrValue ( & stclp -> flagcont . addr . pub )  == Lisp2DEvalAddrContZero2  )
    return    Lisp2DEvalAddrContZero2   ;
  Lisp2DEvalAddrCont2 res = Lisp2DEvalAddrContZero2  ;
  Lisp2DEvalAddrSwapByte  ( & stclp  -> flagcont . addr . pub , &  res ) ;
  return  res ;
}

ParaLispObject * StackClusterPrivate_NamespaceProplist ( StackClusterPrivate const * const stclcp ) {
  return Environment_NamespacePropList ( & stclcp -> envLocal ) ;
}

Lisp2DMutex Lisp2DMutexQueueAtomicStClFirstC
# ifdef LISP2D_DEBUG
 = { .state = Lisp2DStructNotConstructed }
# endif
 ;

Lisp2DMutex Lisp2DMutexQueueAtomicStClLastC
# ifdef LISP2D_DEBUG
 = { .state = Lisp2DStructNotConstructed }
# endif
 ;

# include "globallista/public.h"
# include "mutex2/public.h"
# include "cast.h"
// ! argenv:=env
void  StackClusterPrivate_CreateTask  ( StackClusterPrivate * const st , ParaLispObject * const  iop  ) {
  Vector_PushByValue ( StackPLOP ) ( & st ->  stackc  , iop ) ;
  { struct  Lisp2DAddrForReturn2  a ;
    t_AddrForReturn2ConstructorFlagInBIM ar = {
      . me = & a , . addr = Lisp2DEvalAddrContProcessFinish2 , . inbim = false } ;
    AddrForReturn2ConstructorFlagInBIM  ( & ar ) ;
    Vector_PushByValue ( StackAddrForReturn ) ( & st ->  stackAddr  , a ) ;
  }
  //  AddrForReturn2  a
  // atomic
  if  ( st -> scFatherp )
    ++  (  st -> scFatherp ->  sonscount )  ;
// ? to find slow Pushing - it's very fast function
  GlobalListAtomicPushLockNoFreeze ( & Lisp2DGlobalListOfStackClusters2 , & st -> base ) ;
  TaskQueuePush ( st ) ;
  Mutex2Lock  ( & Lisp2Dmutex2ManagerTasks ) ;
// debugging..........    
// manager's work        
  if  ( int_cast_uint ( runpthcount_Value ( ) ) < maxCountThreads ) {
    StackClusterPrivate  * newtaskp ;
    if  ( isOKTaskQueuePopPrivate  ( & newtaskp ) ) {
      RunningPthArgs  * rpi = runpthargs ;
      for ( unsigned  int i = maxCountThreads ; i  >  0 ; ++ rpi  ) {
        --  i ;
        if  ( rpi -> taskp ==  NULL ) {
          rpi -> taskp  = newtaskp  ;
          runpthcount_Inc ( ) ;
          rpi ->  flagWaitSignal = false  ;
          if(pthread_cond_signal(&rpi ->  condrunning2)){
            Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
            Lisp2DExcMutexGlobal . value = 
              L"Lisp2DStackCluster  ::  CreateTask:pthread_cond_signal("
              L"&rpi -> condrunning2)" ;
            longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeMutex ) ;
          }
          break ;
        }
      } // for i
    } // if  ( isOKTaskQueuePop  ( newtask ) )
  } // if runpthcount  < maxCountThreads
  Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
}

bool  isOKTaskQueuePopPrivate  ( StackClusterPrivate * * const resultp  ) {
  Lisp2DMutexLock ( & Lisp2DMutexQueueAtomicStClFirstC  ) ;
  { StackClusterPrivate * const tmp = ( StackClusterPrivate * ) (
      ConsAtomicPointerFirst ( queueAtomicStClPrivFirst  ) ) ;
    if  ( tmp ) {
      ( * resultp )  = tmp ;
      queueAtomicStClPrivFirst  = ConsAtomicPointerRest  ( queueAtomicStClPrivFirst  ) ;
      Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClFirstC ) ;
      return  true  ;
    }
  }
  Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClFirstC ) ;
  return  false ;
}

void  TaskQueuePush ( StackClusterPrivate * const me ) {
  StackClusterClearHandToQueue  ( me ) ;
  { ConsAtomicPointe * myhandwas = StackClusterMyHand  ( me ) ;
    Lisp2DMutexLock ( & Lisp2DMutexQueueAtomicStClLastC )  ;
    StackClusterSwapHandToQueue ( me , & queueAtomicStClPrivLast ) ;
    Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClLastC )  ;
    StackClusterSetNextQueue  ( me  , myhandwas ) ;
  } // myhandwas
  // if first was atomic pointer may be to dont lock
  Lisp2DMutexLock ( & Lisp2DMutexQueueAtomicStClFirstC );
  StackClusterSetFirstQueue ( me ) ; 
  Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClFirstC );
}

void  StackClusterPrivate_EnvNewLevel2  ( StackClusterPrivate * const stp ) {
// ! create from garbage:   PLOEnvironmentLayer
  Environment_NewLevel ( & stp ->  envLocal , & NewEnvironmentLayer ( ) -> plo ) ;
}

void  StackClusterPrivate_ExceptionSet  ( StackClusterPrivate  * const stp ,
  ParaLispObject * const  xp ) {
  if  ( not  StackClusterPrivate_exceptionnotprocessed  ( stp ) ) {
    // protection from history loss
    ParaLispObject  * const hp = StackClusterPrivate_ListOfEvalHistory ( stp ) ;
    StackClusterPrivate_setexceptionvalue ( stp , xp ) ;
    StackClusterPrivate_setexceptionhistory ( stp , hp ) ;
    StackClusterPrivate_setexceptionnotprocessed  ( stp , true ) ;
  }
}

void  StackClusterAddrPush ( StackClusterPrivate * const stclpp , struct Lisp2DAddrForReturn2 a ) {
  Vector_PushByValue ( StackAddrForReturn ) ( StackClusterPrivate_stackAddrp  ( stclpp ) , a ) ;
}

StackClusterPrivate * StackClusterConstructorHistorySize  ( size_t const myhs ) {
  StackClusterPrivate * const basep1 = new_StackClusterPrivateInitHistory  ( myhs ) ;
  StackClusterPrivate_flagcontp ( basep1 ) -> inBIM = false ;
  Lisp2DEvalAddrClear ( & StackClusterPrivate_flagcontp ( basep1 ) -> addr . pub ) ;
# ifdef  LISP2D_CONSTRSTAT
  StackCluster_constrstat_Inc ( ) ;
# endif  
  StackClusterPrivate_sethandtoqueue  ( basep1 , NewConsAtomicPointer ( ) ) ;
  return  basep1  ;
}

StackClusterPrivate  * StackClusterPrivate_NewStCl4  ( StackClusterPrivate  * const stcp ) {
  StackClusterPrivate * newstclp  = NULL ;
  GlobalListMember *   newgloballistmem = NULL ;
  { size_t  const  mhms = Lisp2DStackClusterHistoryMemorySize  (
      StackClusterPrivate_myHistoryC  ( stcp ) ) ;
    if  ( not  GlobalListisOKTryPopFirst ( & GlobalListOfStackClustersGarbage2 ,
          & newgloballistmem ) )
      newstclp  = StackClusterConstructorHistorySize  ( mhms  ) ;
    else  {
      newstclp = GlobalListMemberToStackClusterPrivate ( newgloballistmem  ) ;
      StackClusterConstructorAfterGarbage ( GlobalListMemberToStackClusterPrivate (
          newgloballistmem ) , mhms  ) ;
    }
  } // mhms
  StackClusterPrivate_setscFatherp ( newstclp , stcp ) ;
// ! to make     newstcl.env2=argenv2;
//  with another name: NewStCl5()
// sons did'not see proprietary environment
  Environment_SetCopy ( StackClusterPrivate_envLocal  ( newstclp ) ,
    StackClusterPrivate_envLocalc ( stcp ) ) ;
  Environment_SetEnv  ( StackClusterPrivate_envExternal ( newstclp ) ,
    Environment_Env ( StackClusterPrivate_envExternalc  ( stcp ) ) ) ;
  StackClusterPrivate_setexceptionnotprocessed  ( newstclp ,
    StackClusterPrivate_exceptionnotprocessed ( stcp ) ) ;
  StackClusterPrivate_setexceptionvalue ( newstclp ,
    StackClusterPrivate_exceptionvalue ( stcp ) ) ;
  StackClusterPrivate_setexceptionhistory ( newstclp ,
    StackClusterPrivate_exceptionhistory ( stcp ) ) ;
  return  newstclp ;
}

StackClusterPrivate  * NewStClOrphan  ( size_t const myhs ) {
  GlobalListMember *   newgllist = NULL ;
  if  ( not  ( GlobalListisOKTryPopFirst  (
    & GlobalListOfStackClustersGarbage2  , & newgllist ) ) ) {
    StackClusterPrivate * const newstclp  =
      StackClusterConstructorHistorySize  ( myhs ) ;
    return  newstclp  ;
  }
  StackClusterConstructorAfterGarbage (
    GlobalListMemberToStackClusterPrivate ( newgllist ) ,
    myhs  ) ;
  return  GlobalListMemberToStackClusterPrivate ( newgllist ) ;
}

bool  isOKTaskQueuePop  ( StackClusterPrivate  * * const resultpp ) {
  Lisp2DMutexLock ( & Lisp2DMutexQueueAtomicStClFirstC  );
  StackClusterPrivate * const tmp = ConsAtomicPointerFirst ( queueAtomicStClPrivFirst  ) ;
  if  ( tmp ) {
    ( * resultpp )  = tmp ;
    queueAtomicStClPrivFirst  = ConsAtomicPointerRest  ( queueAtomicStClPrivFirst  ) ;
    Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClFirstC );
    return  true  ;
  } else  {
    Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClFirstC );
    return  false ;
  }
}

void  SetNamespaceProplist  ( StackClusterPrivate * const stclpp , ParaLispObject * const  lp ) {
  Environment_SetNamespacePropList  ( StackClusterPrivate_envLocal( stclpp)  , lp ) ;
}    

void  SetResultPlace  ( StackClusterPrivate * const stclpp , ParaLispObject * * const  p  , ParaLispObject  * const  p2  )  {
  StackClusterPrivate_setresultplace  ( stclpp  , p ) ;
  StackClusterPrivate_setresultplaceforgc ( stclpp , p2 ) ;
}

# include "inner-history/inline.h"

TaskForThread StackClusterPrivate_StackCleaning ( StackClusterPrivate  * const stpp ) {
  if  ( StackClusterPrivate_TaskForManager  ( stpp ) not_eq   TaskRun  ) {
# ifdef  LISP2D_INNERHISTORY
    static  wchar_t  const  Lisp2Dwsih_pthsc1[]  = L"StackCluster::StackCleaning:End1."   ;
    Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , Lisp2Dwsih_pthsc1 ) ;
# endif    
    // simply wait
    return  TaskForThread_Analyse ;
  }
  EvalAddrPrivat const tmpe = StackClusterPrivate_flagcont ( stpp ) . addr ;
  if  ( not EvalAddrisZero  ( & tmpe . pub ) ) {
    StackClusterPrivate_setresult ( stpp , & plonil .  plo ) ;
    // to kill garbage
    Vector_PushByValue ( StackAddrForReturn ) ( StackClusterPrivate_stackAddrp  (
      stpp ) , StackClusterPrivate_flagcont  ( stpp ) ) ;
    Lisp2DEvalAddrClear ( & StackClusterPrivate_flagcontp  ( stpp ) -> addr . pub ) ;
# ifdef  LISP2D_INNERHISTORY
    static  wchar_t  const  Lisp2Dwsih_pthsc2[]  = L"StackCluster::StackCleaning:End2."   ;
    Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , Lisp2Dwsih_pthsc2  ) ;
# endif    
    return  TaskForThread_Analyse ;
  }
  VectorPop(StackPLOP) ( StackClusterPrivate_stackcMethodp ( stpp ) ) ;
  VectorPop(StackPLOP) ( StackClusterPrivate_stackcproArgp ( stpp ) ) ;
  VectorPop(StackPLOP) ( StackClusterPrivate_stackcThisp ( stpp ) ) ;
  StackClusterPrivate_setflagApply  ( stpp , false ) ;
  { struct Lisp2DStackClusterHistoryStep  st = 
      { StackClusterPrivate_result ( stpp ) , NULL , NULL
# ifdef  LISP2D_DEBUGENV
      , StackClusterPrivate_Env( stpp) , StackClusterPrivate_ExtEnv( stpp)
# endif
      } ;
    Lisp2DStackClusterHistoryPush  ( StackClusterPrivate_myHistory  ( stpp ) , & st ) ;
  }
  StackClusterPrivate_setflagcontv ( stpp , VectorBackCopy  ( StackAddrForReturn ) (
      StackClusterPrivate_stackAddrp  ( stpp ) ) ) ;
  VectorPop(StackAddrForReturn) ( StackClusterPrivate_stackAddrp  ( stpp ) ) ;
  EvalAddrPrivat const tmpea = StackClusterPrivate_flagcont  ( stpp ) . addr ;
  if  ( EvalAddrisZero  ( & tmpea . pub ) and ( not  (  StackClusterPrivate_flagcont  ( stpp ) . inBIM ) ) )
    StackClusterPrivate_setTaskForManager ( stpp , TaskTerminate ) ;
  return  TaskForThread_Analyse ;
}

# include "deque/public-wchar.h"

// ! to return bool isBAD...    
void  FreeBuf ( size_t const i0  , Deque ( WChar ) * const dqbufp ) {
  if  ( i0  ) {
    { size_t  const   dqbufsize = Deque_Size ( WChar ) ( dqbufp ) ;
      if  ( i0  > dqbufsize ) {
        Lisp2DExceptionStringGlobal . str = (wchar_t const(*)[])& 
          L"FreeBuf:i0  > dqbufsize" ; 
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
      } // if i0  > dqbufsize
      if  ( i0 ==  dqbufsize  ) {
        Deque_Clear ( WChar ) (  dqbufp ) ;
        return  ;
      }
    }
    DequeConstIterator ( WChar ) const b = Deque_CBegin ( WChar ) ( dqbufp ) ;
    DequeConstIterator ( WChar ) const b2 = Deque_ConstIterator_Add ( WChar ) ( b ,
      ( ptrdiff_t ) ( i0  ) ) ;
    Deque_Erase ( WChar ) ( dqbufp , b , b2 ) ;
  }
}

# include "string/public.h"
# include "string/struct.h"
# include "inerrors.h"

void  VariableHaveNoLinks ( StackClusterPrivate  * const stclp  ,
  ParaLispObject * const vp  ) {
  static  wchar_t const wc  [ ] = L" variable have no links"  ;
  if  ( stclp  ) {
    ParaLispObject  * list [ ] = {  vp , & PLOString_NewCopy ( wc  ) ->plo,
      NULL } ;
    StackClusterPrivate_ExceptionSet(stclp,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list})); 
  } else
    inErrorS  (
      PLOStreamPushPLO(& Lisp2Dferr , vp );
      PLOStreamPushWideCharArray  ( &Lisp2Dferr ,
        ( PArray_wchar_c ) { (wchar_t const(*)[])&wc});)
}

TaskForThread SetResultErrnoLockGC  ( StackClusterPrivate * const stclp ) {
  PLOSymbol * const sp = SymbolErrno  ( ) ;   
  PassagePassIn ( passageGCCPub ) ;
  StackClusterPrivate_SetResult (stclp,& sp -> plo ) ; 
  PassagePassOut ( passageGCCPub ) ;    
  return  TaskForThread_Analyse ; 
}    

TaskForThread SetResultErrnoNotLockGC  ( StackClusterPrivate  * const stclp ) {
  PLOSymbol * const sp = SymbolErrno  ( ) ;
  StackClusterPrivate_SetResult (stclp,& sp -> plo ) ;
  return  TaskForThread_Analyse ; 
}

void  BadStringN( StackClusterPrivate  * const stclpp ) {
  StackClusterPrivate_ExceptionSet(
    stclpp,& PLOString_NewCopy(L"Bad string")->plo);
}

# include "errorstra.h"

bool  StackClusterIsBADClearBeforeGarbage  ( StackClusterPrivate * const stclp ) {
# ifdef  LISP2D_DEBUG
  if  ( StackClusterPrivate_sonscount ( stclp ) ) {
    PArray_wchar_c  pa = { ( wchar_t const ( * ) [ ] ) &
      L"StackClusterIsBADClearBeforeGarbage:sonscount <> 0" } ;
    ErrorStra  ( pa ) ;
    return  true ;
  }
# endif  
   Lisp2DStackPLOPClear ( StackClusterPrivate_stackcp ( stclp ) ) ;
   Lisp2DStackPLOPClear ( StackClusterPrivate_stackcThisp ( stclp ) ) ;
   Lisp2DStackPLOPClear ( StackClusterPrivate_stackcMethodp ( stclp ) ) ;
   Lisp2DStackPLOPClear ( StackClusterPrivate_stackcproArgp ( stclp ) ) ;
   Lisp2DStackAddrForReturnClear  ( StackClusterPrivate_stackAddrp  ( stclp ) ) ;
# ifdef LISP2D_BIMSTAT
  { size_t  const   sf  = Lisp2DMutexStatFast ( StackClusterPrivate_mutexTask (
      stclp ) )   ;
    size_t  const   sw  = Lisp2DMutexStatWait ( StackClusterPrivate_mutexTask (
      stclp ) )   ;
    averageStackClustermutex_TaskStatFast_Add ( sf  ) ;
    averageStackClustermutex_TaskStatWait_Add ( sw  ) ;
  }
  Lisp2DMutexClearStat  ( StackClusterPrivate_mutexTask ( stclp ) ) ;
  { size_t  const   sf  =
      Lisp2DMutexStatFast ( StackClusterPrivate_mutexExceptionC ( stclp ) )   ;
    size_t  const   sw  =
      Lisp2DMutexStatWait ( StackClusterPrivate_mutexExceptionC ( stclp ) )   ;
    averageStackClustermutex_ExceptionStatFast_Add  ( sf  ) ;
    averageStackClustermutex_ExceptionStatWait_Add  ( sw  ) ;
  }
  Lisp2DMutexClearStat  ( StackClusterPrivate_mutexExceptionC ( stclp ) ) ;
# endif
  Lisp2DStackClusterHistoryClear ( StackClusterPrivate_myHistory  ( stclp ) ) ;
  return false ;
}

# include "stcl/oneitemforevalhistory.h"
# include "cons/public.h"
# include "cons/struct.h"

ParaLispObject  * StackClusterPrivate_ListOfEvalHistory ( StackClusterPrivate * const stp ) {
  ParaLispObject  *   resul = & plonil .plo  ;
  StackClusterPrivate  const * mep  = stp  ;
  do  {
    if  ( Lisp2DStackClusterHistoryIsFull  ( StackClusterPrivate_myHistoryC ( mep ) ) ) {
      size_t  const ip  = Lisp2DStackClusterHistoryIndexPush ( StackClusterPrivate_myHistoryC ( mep ) ) ;
      size_t  i = ip  ;
      while ( i > 0 ) {
        --  i ;
        tOneItemForEvalHistoryP ar  = { . mepp  = mep , . restp = resul , . i = i , . res = 0 } ;
        OneItemForEvalHistoryPs ( & ar ) ;
        resul = ar  . res ;
      } // while i > 0
      i = Lisp2DStackClusterHistoryMemorySize  ( StackClusterPrivate_myHistoryC  ( mep ) )  ;
      while ( i > ip  ) {
        --  i ;
        tOneItemForEvalHistoryP ar  = { . mepp  = mep , . restp = resul , . i = i , . res = 0 } ;
        OneItemForEvalHistoryPs ( & ar ) ;
        resul = ar  . res ;
      } // while i > ip
      if  ( Lisp2DStackClusterHistoryHaveLostData  ( StackClusterPrivate_myHistoryC  ( mep ) ) )
        resul  = & ( NewCons  ( & plosthreepoints . plo ,  resul ) -> plo ) ;
    } else  { // if is full
      size_t  i = Lisp2DStackClusterHistoryIndexPush ( StackClusterPrivate_myHistoryC  ( mep ) ) ;
      while ( i > 0 ) {
        --  i ;
        tOneItemForEvalHistoryP ar  = { . mepp  = mep , . restp = resul , . i = i , . res = 0 } ;
        OneItemForEvalHistoryPs ( & ar ) ;
        resul = ar  . res ;
      } // while i > 0
    }  // else if is not full
    mep  = StackClusterPrivate_scFatherp ( mep ) ;
  } while ( mep ) ;
  // resul = List( ["..."] task .. task ) + List( .. ) + ..
  return  resul ;
}

void  OneItemForEvalHistoryPs ( tOneItemForEvalHistoryP * const arg ) {
  struct  Lisp2DStackClusterHistory const * const mh2 = StackClusterPrivate_myHistoryC ( arg -> mepp )  ;
  struct  Lisp2DStackClusterHistoryStep  * const hs2  = Lisp2DStackClusterHistoryStepAt  ( mh2 , arg -> i ) ;
  ParaLispObject  * const t2 =  ( hs2 ->  This  ) ;
  ParaLispObject * const  m = ( hs2 -> Meth ) ;
  if  ( m ) {
    ParaLispObject * const  a = ( hs2 -> Arg )  ;
    if  ( a ) {
      PLOCons * const ma  = NewCons (  m ,  a ) ;
      PLOCons * const tma = NewCons (  t2 , & ma -> plo ) ;
      PLOCons * const tmarest = NewCons ( & tma ->  plo ,  arg -> restp  ) ;
      // arg
      arg ->  res = & tmarest ->  plo ;
      return  ;
    }
    PLOCons * const tm  = NewCons ( t2 ,  m ) ;
    PLOCons * const tmrest  = NewCons ( & tm  ->  plo  ,  arg -> restp  ) ;
    // met
    arg ->  res = & tmrest  ->  plo  ;
    return  ;
  } else  { // not meth
    PLOCons * const trest = NewCons ( t2 ,  arg -> restp  ) ;
    arg ->  res = & trest ->  plo ;
    return  ;
  }
  arg ->  res = & plonil  . plo ;
  return ;
}

# include "bytedeque/public.h"

bool  LoadVectorOfBytes ( StackClusterPrivate * const stclp ,
  PLOByteDeque  * const dqrp , Stream * fn , Deque ( WChar ) * const dqbufp ) {
  do  {
    if  ( not  LoadSpace  ( fn  , dqbufp ) )
      return  true  ;
    if  ( ( * Deque_FrontConst  ( WChar ) ( dqbufp ) ) ==  L']' ) {
      FreeBuf ( 1U  , dqbufp ) ;
      return  true  ;
    }
    { uint8_t  dop  ;
      if  ( not  LoadByte2  ( stclp ,&dop , fn  , dqbufp ) )
        return  false ;
      PLOByteDeque_PushBack2 ( dqrp , dop ) ;
    } // dop
  } while ( true  ) ;
}

# include "cons/inline.h"

bool  LoadList  ( StackClusterPrivate * const stclp , ParaLispObject * * const rp  ,
  Stream * fn , Deque ( WChar ) * const dqbufp  ) {
  ParaLispObject  *   dop2  = & plonil .plo ;
  ParaLispObject  *   dopprev = &  plonil.plo ;
  ParaLispObject  *   dop = &  plonil .plo ;
  FreeBuf ( 1U ,  dqbufp ) ;
  bool    flagnew = true ;
  ParaLispObject  *   doplast = &  plonil.plo ;
  do  {
    if  ( not  LoadSpace  ( fn  , dqbufp ) ) {
      if  ( doplast  ==  (  &  plonil.plo ) ) { //  Null
        *rp = ( &  plonil .plo) ;
        return  true  ;
      }
      ClassCons_SetRest(&ParaLispObjectToPLOCons ( doplast )->cc ,& plonil .plo ) ;
      *rp = dop ;
      return  true  ;
    }
    if  ( ( * Deque_FrontConst  ( WChar ) ( dqbufp ) )  ==  L')'  ) {
      FreeBuf ( 1U , dqbufp ) ;
      if  ( doplast  ==  (  &  plonil.plo ) ) { //  Null
        *rp = ( &  plonil .plo) ;
        return  true  ; }
      ClassCons_SetRest(&ParaLispObjectToPLOCons ( doplast )->cc ,& plonil .plo ) ;
      *rp = dop ;
      return  true  ;
    } // if  ( dqbuf . front ( )  ==  ')'  )
    if  ( ( * Deque_FrontConst  ( WChar ) ( dqbufp ) )  ==  L'.'  ) {
      FreeBuf ( 1U , dqbufp ) ;
      if  ( not  StackClusterPrivate_LoadObjectS  (stclp, &dop2  , fn  , dqbufp ) )
        dop2  = ( &  plonil .plo) ; 
      if  ( CConsp (   doplast  ) )
        ClassCons_SetRest(&ParaLispObjectToPLOCons ( doplast )->cc ,  dop2 ) ;
      else  
        dop = &(  NewCons  ( &plonil.plo  ,  dop2  )->plo ) ;   
      LoadSpace ( fn  , dqbufp ) ;
      if  ( ( * Deque_FrontConst  ( WChar ) ( dqbufp ) )  ==  L')'  )
        FreeBuf ( 1U , dqbufp ) ;
      *rp = dop ;
      return  true ;
    }  // if  dqbuf . front ( )  ==  '.'
    doplast =  & NewCons  ( &plonil.plo  , &plonil .plo )->plo  ;
    if  ( flagnew ) {
      dop = doplast ;
      dopprev = dop ;
      flagnew = false ;
    } else  {
      ClassCons_SetRest(&ParaLispObjectToPLOCons ( dopprev )->cc ,  doplast  ) ;
      dopprev = doplast ;
    }
    if  ( Deque_Empty ( WChar ) ( dqbufp ) ) {
      if  ( fn ==  NULL ) {
        *rp = ( &  plonil .plo) ;
        return  false ;
      }
      if  ( StreamEof ( fn ) ) {
        *rp = ( &  plonil .plo) ;
        return  false ;
      }
      wchar_t buf ;
      if  ( StreamisBADReadWChar  ( fn , & buf ) ) {
        *rp = ( &  plonil .plo) ;
        return  false ;
      }
      Deque_Clear ( WChar ) ( dqbufp ) ;
      Deque_Push_back ( WChar ) ( dqbufp , buf ) ;
    }
    if  ( not  StackClusterPrivate_LoadObjectS  (stclp, &dop2  , fn  , dqbufp ) ) {
      *rp = ( &  plonil.plo ) ;
      return  false ;
    }
    ClassCons_SetFirst(&ParaLispObjectToPLOCons ( doplast ) ->  cc, dop2  ) ;
  } while ( true  ) ;
}

bool  StackClusterPrivate_LoadObjectS  ( StackClusterPrivate * const stpp ,
  ParaLispObject * * const rp  , Stream * fn , Deque ( WChar ) * const dqbufp  ) {
  if  ( Deque_Empty ( WChar ) ( dqbufp ) and  ( not ( StreamGood  ( fn ) ) ) ) {
    *rp = ( &  plonil.plo ) ;
    return  false ;
  }
  if  ( not  LoadSpace  ( fn  , dqbufp ) ) {
    *rp = ( &  plonil .plo) ;
    return  false ;
  }
  if  ( Deque_Empty ( WChar ) ( dqbufp ) ) {
    if  ( fn ==  NULL ) {
      *rp = ( &  plonil .plo) ;
      return  false ;
    }
    if  ( not ( StreamGood ( fn ) ) ) {
      *rp = ( &  plonil .plo) ;
      return  false ;
    }
    if  ( StreamEof ( fn ) ) {
      *rp = ( &  plonil .plo) ;
      return  false ;
    }
    { wchar_t buf ;
      if  ( StreamisBADReadWChar  ( fn , & buf ) ) {
        *rp = ( &  plonil .plo) ;
        return  false ;
      }
      Deque_Push_back ( WChar ) ( dqbufp , buf ) ; }
    if  ( StreamEof ( fn ) ) {
      *rp = ( &  plonil .plo) ;
      return  false ;
    }
  }
  return  ( ( ( * Deque_ConstIterator_Place ( WChar ) (
          Deque_CBegin ( WChar ) ( dqbufp ) ) )  ==  L'('  )  ?
    LoadList ( stpp ,rp , fn  , dqbufp )  : 
    LoadAtom ( stpp,rp , fn  , dqbufp ) ) ;
}

# include "bimc.h"
# include "stack/public.h"

ParaLispObject  * LoadProgram ( StackClusterPrivate * const stclpp , Stream  * const fnp  ) {
  ParaLispObject  * j = & NewCons  (  & ( plobimnilprogn->base.plo)  , &plonil.plo  )-> plo  ;
  PLOCons * const cache2 = NewCons  ( &plonil.plo  ,  j )  ;
  ParaLispObject  *   dop = & plonil.plo ;
  ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
  Deque ( WChar ) *  const dqcl = Lisp2D_StackVar ( StackType ( Deque_WChar  ) )  ;
  Deque_Init ( WChar ) ( dqcl ) ;
  while ( not ( StreamEof  ( fnp ) ) ) {
    if  ( not ( StreamGood  ( fnp ) ) )
      break ;
    if  ( StackClusterPrivate_LoadObjectS  ( stclpp , & dop ,  fnp  , dqcl ) ) {
      PLOCons * const next2 = NewCons  (   dop  , &plonil.plo  )  ;
      if  ( CConsp (   j  ) )
        ClassCons_SetRest(&ParaLispObjectToPLOCons ( j )->cc , & next2->plo ) ;
      j = &next2->plo ;
    } else 
      break ;
  } // while  not  fn  . Eof
  Lisp2D_StackFree  ( oldstack ) ;
  if  ( IsNotEnvironmentLayer (  stclpp ,  CCAR ( Environment_Env (
    StackClusterPrivate_envLocal( stclpp ) ) ) ))
    return & plonil.plo  ;
  if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (
        CCAR ( Environment_Env (
            StackClusterPrivate_envLocal( stclpp ) ) ) ) -> envlay ,
              & plomain . plo , & cache2  ->  plo , true  ) )
    HasConstLink  (  stclpp ,  & plomain . plo  ) ;
  return  & cache2->plo  ; 
}

# include "consiter/public.h"
# include "consiter/struct.h"
# include "consiter/private.h"

ParaLispObject  * StackClusterPrivate_ObjectDDAssocMethod2  (
  StackClusterPrivate * const stcp , ParaLispObject const * const classdefp ,
  PLOSymbol  * const  methodnamep  ) {
// ! kill PLOCons, check for PLOEnvironmentLayer, 
//  use PLOEnvironmentLayer::Assoc
  PLOCons con ;
  PLOCons_InitC(&con,ClassGetMethods (  classdefp  ) , & plonil.plo);
  { ParaLispObject * const  localmeth2 = Assoc ( &methodnamep -> plo  , & con.plo  , stcp ) ;
    if  ( localmeth2 )  {
      PLOCons_Destr ( & con ) ;
      return  localmeth2  ; 
    }
  }
// !! TaskPause
  { ThreadStackPointerType const oldstack_j = Lisp2DThreadSP ( ) ; 
    CConsIteratorPub * const j = NewStackCConsIterator ( ) ;
    CConsIteratorInit ( j , ClassGetParents (  classdefp  ) ) ;
    while ( CConsIteratorHaveItem  ( j ) ) {
      { ParaLispObject  * const parentmeth = 
          StackClusterPrivate_ObjectDDAssocMethod2  ( stcp ,
            CCDR (  GetPropPair (
                 Environment_NamespacePropList ( 
                  StackClusterPrivate_envLocal  ( stcp ) ) ,
                 CConsIteratorItem  ( j ) , & plossystemclass . plo ,
                stcp ) ) , methodnamep  ) ;
        if  ( parentmeth ){
          PLOCons_Destr ( & con ) ;
          Lisp2D_StackFree  ( oldstack_j ) ;
          return  parentmeth  ; 
        }
      }
      CConsIteratorNext  ( j ) ; 
    }
    Lisp2D_StackFree  ( oldstack_j ) ;
  }
  PLOCons_Destr ( & con ) ;
  return  0 ;
}

# include <sys/stat.h>
  
ParaLispObject  * StackClusterPrivate_LoadProgramS  (
  StackClusterPrivate * const stpp , wchar_t volatile const * const nmp ) {
  ThreadStackPointerType const oldstack_a = Lisp2DThreadSP ( ) ;
  String  ( Char  ) * const strtmpc = StackNew_StringChar ( ) ;
  String_Init ( Char  ) ( strtmpc , true ) ;
  if  ( isBADReadWCharToCharString  ( nmp , strtmpc ) ) {
    Lisp2D_StackFree  ( oldstack_a ) ;
    BadStringN (  stpp  ) ;
    return & plonil . plo ;
  }
  { FILE  * const fp  = fopen ( StringCStr  ( Char  ) ( strtmpc ) , "r" ) ;
    if ( not  fp  ) {
      Lisp2D_StackFree  ( oldstack_a ) ;
      PLOSymbol * const sp = SymbolErrno ( ) ;
      ParaLispObject  * list [ ] = {
        & PLOString_NewCopy ( L"LoadProgram: can't from path : "  )->plo ,
        & PLOString_NewCopy ( nmp )->plo ,
        & PLOString_NewCopy ( L" : " )->plo , & sp->plo , NULL } ;
      StackClusterPrivate_ExceptionSet  ( stpp  ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return & plonil.plo  ;
    }
    int const fn = fileno  ( fp  ) ;
    enum  { FILENOERROR = -1  } ;
    if ( fn == FILENOERROR ) {
      Lisp2D_StackFree  ( oldstack_a ) ;
      PLOSymbol * const sp = SymbolErrno ( ) ;
      fclose  ( fp  ) ;
      ParaLispObject  * list [ ] = {
        & PLOString_NewCopy ( L"LoadProgram: bad fileno : "  )->plo ,
        & PLOString_NewCopy ( nmp )->plo ,
        & PLOString_NewCopy ( L" : " )->plo , & sp->plo , NULL } ;
      StackClusterPrivate_ExceptionSet  ( stpp  ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return & plonil.plo  ;
    }
    struct  stat  fileInfo  ;
    enum  { FSTATERROR = -1  } ;
    if ( fstat ( fn , & fileInfo  ) == FSTATERROR ) {
      Lisp2D_StackFree  ( oldstack_a ) ;
      PLOSymbol * const sp = SymbolErrno ( ) ;
      fclose  ( fp  ) ;
      ParaLispObject  * list [ ] = {
        & PLOString_NewCopy ( L"LoadProgram: bad fstat : "  )->plo ,
        & PLOString_NewCopy ( nmp )->plo ,
        & PLOString_NewCopy ( L" : " )->plo , & sp->plo , NULL } ;
      StackClusterPrivate_ExceptionSet  ( stpp  ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return & plonil.plo  ;
    }
    if  ( S_ISDIR ( fileInfo  . st_mode ) ) {
      Lisp2D_StackFree  ( oldstack_a ) ;
      fclose  ( fp  ) ;
      ParaLispObject  * list [ ] = {
        & PLOString_NewCopy ( L"LoadProgram: can't from directory : "  )->plo ,
        & PLOString_NewCopy ( nmp )->plo , NULL } ;
      StackClusterPrivate_ExceptionSet  ( stpp  ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      return & plonil.plo  ;
    }
  }
  int const readmode  = O_RDONLY  ;  
  int const fd  = open ( StringCStr  ( Char  ) ( strtmpc ) , readmode ) ;
  Lisp2D_StackFree  ( oldstack_a ) ;
  enum  { OPENERROR = -1  } ;
  if  ( fd == OPENERROR ) {
    ParaLispObject  * list [ ] = { & PLOString_NewCopy (
      L"LoadProgram: Could not open file "  )->plo ,
      & PLOString_NewCopy ( nmp )->plo , NULL } ;
    StackClusterPrivate_ExceptionSet  ( stpp  ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    return & plonil.plo  ;
  }
  Stream s ;
  StreamInitFD  ( & s , false , fd , readmode ) ;
  jmp_buf jump_buffer ;
  jmp_buf * const oldjb = Lisp2DJBglobal  ;
  Lisp2DJBglobal = & jump_buffer ;
  int const volatile sj = setjmp  ( jump_buffer ) ;
  ParaLispObject  * rp ;
  if ( sj == 0 )
    rp = LoadProgram ( stpp , & s ) ;
  else {
    Lisp2DJBglobal = oldjb  ;
    StreamDestr ( & s ) ;
    longjmp ( * Lisp2DJBglobal  , sj ) ;
  }
  Lisp2DJBglobal = oldjb  ;
  StreamDestr ( & s ) ;
  return  rp ;
}

// fn may be nullptr
bool  LoadSpace ( Stream * const fn , Deque ( WChar ) * const dqbufp  ) {
  do  {
    if  ( Deque_Empty ( WChar ) ( dqbufp ) ) {
      if  ( not fn  )
        goto  RetFal  ; 
      if  ( not ( StreamGood ( fn ) ) )
        goto  RetFal  ;
      if  ( StreamEof ( fn ) )
        goto  RetFal  ;
      wchar_t buf ;
      if  ( StreamisBADReadWChar  ( fn , & buf ) )
        goto  RetFal  ;
      Deque_Push_back ( WChar ) ( dqbufp  , buf ) ;
    }
    //  remarks
    if  ( ( * Deque_FrontConst  ( WChar ) ( dqbufp ) ) ==  L';'  ) {
      size_t  i ;
      { DequeConstIterator  ( WChar ) j = Deque_CBegin ( WChar ) ( dqbufp ) ;
        Deque_ConstIterator_Inc ( WChar ) ( & j ) ;
        i = 1 ;
        for ( ; i < Deque_Size ( WChar ) ( dqbufp ) ; ++ i  ,
          Deque_ConstIterator_Inc ( WChar ) ( & j ) )
          if  ( ( ( * Deque_ConstIterator_Place ( WChar ) ( j ) )  ==  L'\n' ) or
            ( ( * Deque_ConstIterator_Place ( WChar ) ( j ) )  ==  L'\r' ) )
            break ;
      } // iterator j
      if  ( i  ==  Deque_Size ( WChar ) ( dqbufp ) ) {
        wchar_t c ;
        do  {
          if  ( not fn  )
            goto  ClearAndRetFalse  ;
          if  (  StreamEof ( fn ) )
            goto  ClearAndRetFalse  ;            
          if  ( StreamisBADReadWChar  ( fn , & c ) )
            goto  ClearAndRetFalse  ;
        } while ( ( c not_eq  L'\n'  ) and ( c  not_eq  L'\r' ) ) ;
        if  ( StreamEof ( fn ) )
          goto  ClearAndRetFalse  ;
        { wchar_t buf ;
          if  ( StreamisBADReadWChar  ( fn , & buf ) ) 
            goto  ClearAndRetFalse  ;
          Deque_Clear ( WChar ) ( dqbufp ) ;
          Deque_Push_back ( WChar ) ( dqbufp  , buf ) ;
        }
      } else // if  ( i  ==  (  dqbuf . size  ( ) ) )
        FreeBuf ( i , dqbufp ) ;
    } // if  ( dqbuf . front ( )  ==  ';'  )
    // spaces & tabs & new lines
    size_t    i = 0 ;
    DequeConstIterator ( WChar ) j = Deque_CBegin ( WChar ) ( dqbufp ) ;
    DequeConstIterator ( WChar ) const dqbufend = Deque_CEnd ( WChar ) ( dqbufp ) ;
    for ( ; Deque_ConstIterator_Place ( WChar ) ( j )  not_eq 
      Deque_ConstIterator_Place ( WChar ) ( dqbufend ) ; ++ i  ,
      Deque_ConstIterator_Inc ( WChar ) ( & j ) ) {
      wchar_t const * const jp = Deque_ConstIterator_Place ( WChar ) ( j ) ;
      if  ( not  (  ( ( *  jp  )  ==  L' '  )  or  (  ( * jp )  ==  L'\t' ) or
          ( ( * jp )  ==  L'\n' ) or  ( ( * jp )  ==  L'\r' ) ) )
        break ;
    }
    if  ( Deque_ConstIterator_Place ( WChar ) ( j )  ==
      Deque_ConstIterator_Place ( WChar ) ( dqbufend ) ) {
      wchar_t c ;
      do  {
        if  ( not fn  )
          goto  ClearAndRetFalse  ;
        if  ( StreamEof ( fn ) )
          goto  ClearAndRetFalse  ;
        if  ( StreamisBADReadWChar  ( fn , & c ) ) 
          goto  ClearAndRetFalse  ;
      } while ( ( c ==  L' ' )  or  (  c  ==  L'\n' ) or  ( c  ==  L'\r' ) or ( c  ==  L'\t' ) ) ;
      Deque_Clear ( WChar ) ( dqbufp  ) ;
      Deque_Push_back ( WChar ) ( dqbufp  , c ) ;
    } else  // if  ( j  ==  dqbufend )
      if  ( i ) 
         FreeBuf ( i , dqbufp ) ; 
  //remarks
  } while ( ( * Deque_FrontConst ( WChar ) ( dqbufp ) ) ==  L';' ) ;
  return   true   ; 
ClearAndRetFalse  :  
  Deque_Clear ( WChar ) ( dqbufp  ) ;
RetFal  :
  return   false ;
}
  
# include "string/public.h"
# include "quote/public.h"
# include "backquote/inline.h"
# include "comma/public.h"
# include "vector/public.h"
# include "bytedeque/public.h"
# include "char/public.h"
# include "char.h"
# include "plocomplex/public.h"
# include <wctype.h>  
# include "unquotesplicing/struct.h"
# include "unquotesplicing/public.h"
# include "boolean.h" // bool_xor
  
bool  LoadAtom  ( StackClusterPrivate * const stclp , ParaLispObject * * const rp  ,
  Stream * const  fn , Deque ( WChar ) * const dqbufp  ) {
  ParaLispObject  *   dop = &  plonil.plo ;
  wchar_t buf ;
  size_t    i = 0 ;
  // check the buffer 1st
  { DequeConstIterator  ( WChar ) j = Deque_CBegin ( WChar ) ( dqbufp ) ;
    for ( ; i  < Deque_Size ( WChar ) ( dqbufp ) ; ++ i  ,
      Deque_ConstIterator_Inc ( WChar ) ( & j ) ) {
      wchar_t const * const jp  = Deque_ConstIterator_Place ( WChar ) ( j ) ;
// ! to check for ';'
      if  ( ( ( * jp ) ==  L' ' ) or ( ( * jp ) ==  L'\t'  ) or
        ( ( * jp ) ==  L'\n'  ) or ( ( * jp ) ==  L'\r'  ) or
        ( ( * jp ) ==  L'(' ) or  ( ( * jp ) ==  L')' ) )
        break ;
    }
  }  // iterator   j
  // buffer is not enough
  if  ( i  == Deque_Size ( WChar ) ( dqbufp ) ) {
    wchar_t buf2last  ;
    do  {
      if  ( fn == (Stream*)0 ) 
        goto LoadAtom_False ; 
      if  ( StreamEof ( fn ) ) 
        goto LoadAtom_False ; 
      if  ( StreamisBADReadWChar  ( fn , & buf ) )
        goto LoadAtom_False ;
      Deque_Push_back ( WChar ) ( dqbufp , buf ) ;
      buf2last  = * Deque_BackConst ( WChar ) ( dqbufp ) ;
// ! to check for ';'      
    } while ( ( buf2last  not_eq  L' ' ) and ( buf2last not_eq  L'\t' ) and
      ( buf2last not_eq  L'\n' ) and
      ( buf2last not_eq  L'\r' ) and ( buf2last not_eq  L'('  )  and
      (  buf2last not_eq  L')'  ) ) ;
    i = Deque_Size ( WChar ) ( dqbufp ) ;
  } else // if  i  ==   dqbuf . size
    ++  i ; // string must have one spare letter
  if  ( * Deque_FrontConst ( WChar ) ( dqbufp ) ==  L'\"' ) {
    i = 0 ;
    do  {
      bool  const   flagsharp = ( ( * Deque_AtFastConst ( WChar ) ( dqbufp , i ) ) == L'\\' ) ;
      ++  i ;
      if  ( i  >=  Deque_Size ( WChar ) ( dqbufp ) ) {
        if  ( fn == (Stream*)0 ) {
          -- i  ;
          break ;
        }
        if  ( StreamEof ( fn ) ) {
          --  i ;
          break ;
        }
        if  ( StreamisBADReadWChar  ( fn , & buf ) ) {
          --  i ;
          break ;
        }
        Deque_Push_back ( WChar ) ( dqbufp , buf ) ;
      } // if  i  >=  dqbuf . size
      if  ( flagsharp ) {
        // once again
        ++  i ;
        if  ( i  >=  Deque_Size ( WChar ) ( dqbufp ) ) {
          if  ( fn == (Stream*)0 ) {
            -- i  ;
            break ;
          }
          if  ( StreamEof ( fn ) ) {
            --  i ;
            break ;
          }
          if  ( StreamisBADReadWChar  ( fn , & buf ) ) {
            --  i ;
            break ;
          }
          Deque_Push_back ( WChar ) ( dqbufp , buf ) ;
        }
      } // if  flagsharp
    } while ( ( * Deque_AtFastConst ( WChar ) ( dqbufp , i ) ) not_eq  L'\"'  ) ;
    PLOStringPub  * const rsp = PLOString_New ( ) ;
    * rp = & rsp -> plo ;
    // symbol a must have <=l chars and '0x00' symbol on the end
    bool  flagsharp = false ;
// !! insert this in up cycle
    { DequeConstIterator  ( WChar ) j  = Deque_CBegin ( WChar ) ( dqbufp ) ;
      Deque_ConstIterator_Inc ( WChar ) ( & j ) ;
      size_t j2 = 0 ;
      for ( ; ( * Deque_ConstIterator_Place ( WChar ) ( j ) ) and ( j2 < (  i  - 1  ) ) ;
           ++  j2  , Deque_ConstIterator_Inc ( WChar ) ( & j ) ) {
        if  ( flagsharp ) {
          String_AddChar  ( WideChar  ) ( PLOString_Value2 ( rsp ) ,
            ( * Deque_ConstIterator_Place ( WChar ) ( j ) ) ) ;
          flagsharp = false ;
        } else  {
          flagsharp  = ( ( * Deque_ConstIterator_Place ( WChar ) ( j ) )  ==  L'\\' ) ;
          if  ( not  flagsharp )
            String_AddChar  ( WideChar  ) ( PLOString_Value2 ( rsp ) , ( * Deque_ConstIterator_Place ( WChar ) ( j ) ) ) ;
        }
      }
    }
    // iterator   j
    FreeBuf ( i + 1 , dqbufp ) ;
    goto LoadAtom_True ;
  } // if  dqbuf . front ( )  ==  '\"'
  // quote
  if  ( ( * Deque_FrontConst ( WChar ) ( dqbufp ) ) ==  L'\'' ) {
    FreeBuf ( 1U  , dqbufp ) ;
    if  ( StackClusterPrivate_LoadObjectS (stclp, &dop , fn  , dqbufp ) ) {
      // quote(dop)
      PLOQuote * const q = aligned_alloc ( _Alignof ( PLOQuote ) , sizeof ( PLOQuote ) ) ;
      if  ( q ) {
        PLOQuote_Init ( q ) ;
        PLOQuote_SetItem ( q , dop ) ;
        * rp = & q ->  plo ;
        ParaLispObject_virtualPushAsNew ( *rp ) ;
      } else  {
        * rp = 0 ;
        OutOfMemory (  stclp  ) ;
        goto LoadAtom_False ;
      }
      goto LoadAtom_True ;
    }
    *rp = ( & plonil.plo  ) ;
    goto LoadAtom_False ;
  } // if  dqbuf . front ( )  ==  '\''
  // backquote
  if  ( ( * Deque_FrontConst ( WChar ) ( dqbufp ) ) ==  L'`'  ) {
    FreeBuf ( 1U  , dqbufp ) ;
    if  ( StackClusterPrivate_LoadObjectS ( stclp , &dop , fn  , dqbufp ) ) {
      // backquote(dop)
      PLOBackQuote * const bq = aligned_alloc ( _Alignof ( PLOBackQuote ) , sizeof ( PLOBackQuote ) ) ;
      if  ( bq ) {
        PLOBackQuote_Init ( bq ) ;
        *rp = & bq -> plo ;
        PLOBackQuote_SetItem  ( bq  , dop ) ;
        ParaLispObject_virtualPushAsNew ( *rp ) ;
      } else  {
        *rp = 0 ;
        OutOfMemory (  stclp  ) ;
        goto LoadAtom_False ;
      }
      goto LoadAtom_True ;
    } else  {  // if  LoadObjectS ( dop , fn  , dqbuf )
      * rp = ( & plonil .plo ) ;
      goto LoadAtom_False ;
    }
  } // if  dqbuf . front ( )  ==  '`'
  // unquote
  if  ( ( * Deque_FrontConst ( WChar ) ( dqbufp ) ) ==  L',' ) {
    if  ( Deque_Size ( WChar ) ( dqbufp ) < 2U  ) {
      if  ( fn == (Stream*)0 ) {
        * rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
      if  ( StreamEof ( fn ) ) {
        *rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
      if  ( StreamisBADReadWChar  ( fn , & buf ) ) {
        *rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
      Deque_Push_back ( WChar ) ( dqbufp , buf ) ;
    } // if  dqbuf . size  ( ) < 2U
    // unquote-splicing
    if  ( ( * Deque_AtFastConst ( WChar ) ( dqbufp , 1 ) ) ==  L'@' ) {
      FreeBuf ( 2U  , dqbufp ) ;
      if  ( StackClusterPrivate_LoadObjectS (stclp, &dop , fn  , dqbufp ) ) {
        PLOUnQuoteSplicing  * const uq = aligned_alloc ( _Alignof ( PLOUnQuoteSplicing ) , sizeof ( PLOUnQuoteSplicing ) ) ;
        if  ( uq ) {
          PLOUnQuoteSplicing_Init(uq);
          *rp = & uq -> plo ;
          PLOUnQuoteSplicing_SetItem(uq,dop);
          ParaLispObject_virtualPushAsNew ( *rp) ;
        } else  {
          *rp = 0 ;
          OutOfMemory (  stclp  ) ;
          goto LoadAtom_False ;
        }
        goto LoadAtom_True ;
      } else  {  // if  LoadObjectS ( dop , fn  , dqbuf )
        *rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
    } else  {  // if  dqbuf [ 1 ] ==  '@'
      FreeBuf ( 1U  , dqbufp ) ;
      if  ( StackClusterPrivate_LoadObjectS (stclp,& dop , fn  , dqbufp ) ) {
        PLOComma * const co = aligned_alloc ( _Alignof ( PLOComma ) , sizeof ( PLOComma ) ) ;
        if  ( co ) {
          PLOComma_Init(co);
          *rp = & co -> plo ;
          PLOComma_SetItem(co,dop);
          ParaLispObject_virtualPushAsNew (*rp ) ;
        } else  {
          OutOfMemory (  stclp ) ;
          goto LoadAtom_False ;
        }
        goto LoadAtom_True ;
      } else  {  // if  LoadObjectS ( dop , fn  , dqbuf )
        *rp = ( & plonil.plo  ) ;
        goto LoadAtom_False ;
      }
    }
  } // if  dqbuf . front ( ) ==  ','
  if  ( ( * Deque_FrontConst ( WChar ) ( dqbufp ) ) ==  L'#' ) {
    if  ( Deque_Size ( WChar ) ( dqbufp ) < 2U  ) {
      if  ( fn ==  (Stream*)0 ) {
        *rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
      if  ( StreamEof ( fn ) ) {
        *rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
      if  ( StreamisBADReadWChar  ( fn , & buf ) ) {
        *rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
      Deque_Push_back ( WChar ) ( dqbufp , buf ) ;
    }
    if  ( ( * Deque_AtFastConst ( WChar ) ( dqbufp , 1 ) ) ==  L'(' ) {
      // it is unknown the length of vector so I use loadlist first
      FreeBuf ( 1U  , dqbufp ) ;
// !! #(1 . 2) - w/o error
// !! to write LoadListForVector and returns SIZE
      if  ( LoadList  ( stclp,&dop , fn  , dqbufp ) ) {
        if  ( dop ==  ( & plonil .plo ) ) { //  Null
          PLOVector * const rpv = aligned_alloc ( _Alignof ( PLOVector ) , sizeof ( PLOVector ) ) ;
          if ( not  rpv ) {
            OutOfMemory (  stclp  ) ;
            *rp = ( & plonil .plo ) ;
            goto LoadAtom_False ;
          }
          PLOVector_Init(rpv);
          *rp = &( rpv )->plo ; 
          PLOVector_staticPushAsNew ( *rp) ;
        } else  // if  dop ==  & plonil
          if  ( CConsp (  dop ) ) {
            // list have no cycle
            size_t    ls  = 0 ;
            for ( ParaLispObject  * j = dop ; CConsp (  j ) ; j  = ( CCDR ( j ) ) )
              ++  ls  ;
            PLOVector * const rpv = aligned_alloc ( _Alignof ( PLOVector ) , sizeof ( PLOVector ) ) ;
            if ( not  rpv ) {
              OutOfMemory (  stclp  ) ;
              *rp = ( & plonil .plo ) ;
              goto LoadAtom_False ;
            }
              
            // ! to catch exception
            PLOVector_InitSize(rpv,ls);
            
            *rp = &(rpv->plo);
            PLOVector_staticPushAsNew ( *rp) ; 
              
            ParaLispObject  * j = dop ;
            for ( size_t    in  = 0 ; in < ls ; ++ in ) {
              PLOVector_SetElt  ( ParaLispObjectToPLOVector ( *rp ) , in  , CCAR ( j ) ) ;
              j = CCDR ( j ) ;
            }
          } else  { // if  Consp ( * dop )
            *rp = ( & plonil .plo ) ;
            goto LoadAtom_False ;
          }
        goto LoadAtom_True ;
      } else  {  // if  LoadList  ( dop , fn  , dqbuf )
        *rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
    }  // if  dqbuf [ 1U  ] ==  '('
    if  ( ( * Deque_AtFastConst ( WChar ) ( dqbufp , 1 ) ) ==  L'[' ) {
      FreeBuf ( 2U  , dqbufp ) ;
      PLOByteDeque * const bdq = aligned_alloc ( _Alignof ( PLOByteDeque ) , sizeof ( PLOByteDeque ) ) ;
      if ( not bdq ) {
        OutOfMemory (  stclp  ) ;
        *rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
      *rp = & bdq -> plo ;
      PLOByteDeque_Init (bdq);
      ParaLispObject_virtualPushAsNew (*rp ) ;
      // " byte byte .. byte ]"
      if  ( not LoadVectorOfBytes ( stclp, ParaLispObjectToPLOByteDeque (  *rp ) , fn  , dqbufp ) ) {
        *rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
      goto LoadAtom_True ;
    }  // if  dqbuf [ 1U  ] ==  '['
    // characters
    if  ( * Deque_AtFastConst ( WChar ) ( dqbufp , 1 ) ==  L'\\'  ) {
      FreeBuf ( 2U  , dqbufp ) ;
      ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
      String  ( WideChar ) * const charnamep = StackNew_StringWideChar ( ) ;
      String_Init ( WideChar  ) ( charnamep , true ) ;
      int   iname = 0 ;
      while ( not ( Deque_Empty ( WChar ) ( dqbufp ) ) ) {
        wchar_t const firstchar =( * Deque_FrontConst  ( WChar ) ( dqbufp ) ) ;
        if  ( iname )
// ! to check for ';'          
          if  ( ( firstchar ==  L' ' )  or  (  firstchar  ==  L'\t' ) or
            ( firstchar  ==  L'\n' ) or
            ( firstchar  ==  L'\r' ) or  ( firstchar  ==  L'('  )  or
            (  firstchar  ==  L')'  ) )
            break ;
        String_AddChar  ( WideChar  ) ( charnamep , firstchar ) ;
        ++  iname ;
        FreeBuf ( 1U  , dqbufp ) ;
      } // while  not dqbuf . empty
      PLOCharPriv * const dopc2 = aligned_alloc ( _Alignof ( PLOCharPriv ) , sizeof ( PLOCharPriv ) ) ;
      if ( not dopc2 ) {
        Lisp2D_StackFree  ( oldstack ) ;
        * rp = ( & plonil .plo ) ;
        goto LoadAtom_False ;
      }
      PLOChar_Init ( dopc2 ) ;
      ParaLispObject_virtualPushAsNew ( & dopc2 -> pub . plo ) ;
      if  ( iname  ==  0  ) {
        Lisp2D_StackFree  ( oldstack ) ;
        * rp = &  dopc2 ->  pub . plo ;
        goto LoadAtom_True ;
      }
      // simple char
      if  ( iname  ==  1  ) {
        PLOChar_SetValue ( & dopc2 -> pub , * String_CBegin ( WideChar ) ( charnamep ) ) ;
        Lisp2D_StackFree  ( oldstack ) ;
        *rp = & dopc2 ->  pub . plo ;
        goto LoadAtom_True ;
      }
      // complex char
      { wchar_t volatile * i2 = String_Begin ( WideChar ) ( charnamep ) ;
        wchar_t volatile const * const iend = String_CEnd ( WideChar ) ( charnamep ) ;
        while ( i2  not_eq  iend  ) {
          * i2 = wint_cast_wchar ( towlower ( wchar_cast_wint ( * i2  ) ) ) ;
          ++  i2  ;
        }
      }
      size_t  const mapsize = MapPubSize ( SetCharNameValue  ) ( mapPubCharNameValue  ) ;
      size_t  const find  = MapPubFind ( SetCharNameValue  ) ( mapPubCharNameValue  ,
        StringCStr  ( WideChar  ) ( charnamep ) ) ;
      if ( find not_eq  mapsize ) {
        Lisp2D_StackFree  ( oldstack ) ;
        PLOChar_SetValue ( & dopc2 -> pub , MapPubCAt ( SetCharNameValue  ) (
          mapPubCharNameValue  , find ) -> value ) ;  
        * rp = &  dopc2 -> pub . plo ;
        goto LoadAtom_True ;
      }
      String  ( WideChar ) * const ctmp = StackNew_StringWideChar ( ) ;
      StringConstrCStr  ( WideChar  ) ( ctmp ,
        L"StackCluster::LoadAtom:character name not supported : " , true ) ;
      StringAddString ( WideChar  ) ( ctmp , charnamep ) ;
      PLOStringPub * const newstr2  = PLOString_NewMoveString ( ctmp ) ;
      StackClusterPrivate_ExceptionSet  ( stclp , & newstr2 ->  plo ) ;
      Lisp2D_StackFree  ( oldstack ) ;
      * rp = ( & plonil . plo ) ;
      goto LoadAtom_False ;
    }
  } // if  dqbuf . front ( ) ==  '#'
  { wchar_t const f = ( * Deque_FrontConst  ( WChar ) ( dqbufp ) ) ;
    if  ( ( f ==  L')' )  or  (  f  ==  L'.'  ) ) {
      *rp = ( & plonil .plo ) ;
      FreeBuf ( 1U  , dqbufp ) ;
      goto LoadAtom_True ;
    }
  } // wchar_t f
  { ThreadStackPointerType const oldstack_wsp = Lisp2DThreadSP ( ) ; 
    String  ( WideChar  ) * const wsp = StackNew_StringWideChar ( ) ;
    String_Init ( WideChar ) (  wsp , true ) ;
    // symbol must have <=l chars and '0x00' symbol on the end
    size_t    partsize  = 0 ;
    { DequeConstIterator  ( WChar ) dqbufj = Deque_CBegin ( WChar ) ( dqbufp ) ;
      for ( ; ( * Deque_ConstIterator_Place ( WChar ) ( dqbufj  ) ) and
        ( partsize < (  i  - 1  ) ) ; ++  partsize  ,
        Deque_ConstIterator_Inc ( WChar ) (  & dqbufj  ) ) {
        if  ( ( * Deque_ConstIterator_Place ( WChar ) ( dqbufj  )  ) ==  L'\"'  or
          (  * Deque_ConstIterator_Place ( WChar ) ( dqbufj  ) ) ==  L';' )
          break ;
        String_AddChar ( WideChar ) ( wsp , * Deque_ConstIterator_Place ( WChar ) ( dqbufj  ) ) ;
      }
// ! to make ss after cycle, don't add chars in cycle
    } // iterator dqbufj
    if  ( String_Empty ( WideChar  ) ( wsp ) ) {
      *rp = ( & plonil .plo ) ;
      Lisp2D_StackFree  ( oldstack_wsp ) ;
      goto LoadAtom_True ;
    }
  { bool    flagNegative  = false ;
    size_t    j = 0 ;
    if  ( ( * StringCStr ( WideChar ) ( wsp )  ) ==  L'-' ) {
      flagNegative  = true  ;
      j = 1 ;
    } else  if  ( ( * StringCStr ( WideChar ) ( wsp )  ) ==  L'+' )
      j = 1 ;
    PLOComplex  * const compl1 = PLOComplex_newraw();
    if ( not compl1 ) {
      *rp = &  plonil .plo ;
      Lisp2D_StackFree  ( oldstack_wsp ) ;
      goto LoadAtom_False ;
    }

    PLOComplex_InitUnDef ( compl1  ) ;

    // for LoadComplex, next LoadComplex adding
    Complex_Set0  ( PLOComplexToComplex( compl1) ) ;
// ! rewrite start-value: lerr=true -> lerr=false
    bool    flagErr = false ;
    bool    flagIm  = false ;

    LoadComplexFromString ( ( t_LoadComplexFromString ) {  . wsp = wsp   , . jp = & j , . complxp = compl1  , . flagErrp = & flagErr ,
      . flagImp = & flagIm  , . partsizep = & partsize  , . flagNegative = flagNegative } ) ;
    if  ( flagErr )
      PLOComplex_delete ( compl1  ) ;
    else  {
      bool    flagErr2  = false ;
      if  ( j  not_eq  partsize ) {
        bool    flagNegative2 = false ;
        { wchar_t  ssj  = String_EltCopy ( WideChar ) ( wsp , j ) ;
          if  ( ssj  ==  L'-'  ) {
            flagNegative2 = true  ;
            ++  j ;
          } else if  ( ssj  ==  L'+'  )
            ++  j ;
          else
            flagErr2  = true  ;
        } // ssj2
        if  ( not  flagErr2 ) {
// ! rewrite start-value: lerr=true -> lerr=false
          bool    flagIm2 = false ;

          LoadComplexFromString ( ( t_LoadComplexFromString ) { . wsp = wsp   , . jp = & j , . complxp =  compl1  ,
            . flagErrp = & flagErr2  , . flagImp = & flagIm2 , . partsizep = & partsize  , . flagNegative = flagNegative2 } ) ;
          if  ( flagErr2  )
            PLOComplex_delete ( compl1  ) ;
          else  if  ( j not_eq  partsize  ) {  // many symbols
              flagErr2  = true;
              PLOComplex_delete ( compl1  ) ;
          } else  // (Im & Re) or (!Re & !Im)
            if  ( not bool_xor  ( flagIm  , flagIm2 ) ) {
                flagErr2  = true  ;
                PLOComplex_delete ( compl1  ) ;
            }
          }
                // not  lerr2
        } // j!=partsize
        if  ( not  flagErr2 ) {
          GlobalListPush ( & GlobalListOfComplex , & compl1 -> plo.base  ) ;
          *rp = &compl1 ->plo ;
          FreeBuf ( partsize  , dqbufp ) ;
          Lisp2D_StackFree  ( oldstack_wsp ) ;
          goto LoadAtom_True ;
        }
      }
    }  // flagNegative
    // then it's a symbol
    *rp = StringWideCharToSymbol  ( wsp ) ;
    FreeBuf ( partsize  , dqbufp ) ;
    Lisp2D_StackFree  ( oldstack_wsp ) ;
  } // wsp
LoadAtom_True :    
  return  true  ;
LoadAtom_False :
  return  false ;
}

bool  LoadByte2 ( StackClusterPrivate * const stclp , uint8_t  * const chr2p ,
  Stream * const fn , Deque ( WChar ) * const dqbufp  ) {
  { wchar_t const x = ( * Deque_FrontConst  ( WChar ) ( dqbufp ) ) ;
    if  ( ( x < '0' )  or  (  x  > '9'  ) ) {
      ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
      String  ( WideChar ) * const wep = StackNew_StringWideChar ( ) ;
      String_Init ( WideChar  ) ( wep , true ) ;
      String_AddChar ( WideChar  ) ( wep ,  x ) ;
      StringAddCharArray ( WideChar  ) ( wep ,  L" is not number while loading byte" ) ;
      { PLOStringPub * const newstr = PLOString_NewMoveString ( wep ) ;
        Lisp2D_StackFree  ( oldstack ) ;
        StackClusterPrivate_ExceptionSet  (stclp,&  newstr->plo  ) ;
      }
      return  false ;
    }
    *chr2p = int_cast_uint8 ( x - '0' ) ;
  } // wchar_t x
  FreeBuf ( 1U  , dqbufp ) ;
  if  ( Deque_Empty ( WChar ) ( dqbufp ) ) {
    if  ( not fn )
      return  true  ;
    if  ( StreamEof ( fn ) ) 
      return  true  ;
    wchar_t buf ;
    if  ( StreamisBADReadWChar  ( fn , & buf ) ) 
      return  true  ;
    Deque_Push_back ( WChar ) ( dqbufp , buf ) ;
  } //  if  dqbuf . empty
  { wchar_t const x = ( * Deque_FrontConst  ( WChar ) ( dqbufp ) ) ;
    if  ( ( x < L'0' ) or  ( x  > L'9'  ) ) 
      return  true  ;
    { unsigned  int dop = *chr2p ;
      dop *=  10U ;
      *chr2p = uint_cast_uint8 ( dop ) ;
      dop = *chr2p  ;
      dop +=  int_cast_uint8 ( x  - L'0'  ) ;
      *chr2p = uint_cast_uint8 ( dop ) ;
    }
  } // wchar_t x
  FreeBuf ( 1U  , dqbufp ) ;
  if  ( Deque_Empty ( WChar ) ( dqbufp ) ) {
    if  ( fn ==  (Stream *)0 )
      return  true  ;
    if  ( StreamEof ( fn ) )
      return  true  ;
    wchar_t buf ;
    if  ( StreamisBADReadWChar  ( fn , & buf ) )
      return  true  ;
    Deque_Push_back ( WChar ) ( dqbufp , buf ) ;
  } // if  dqbuf . empty
  { wchar_t const x = ( * Deque_FrontConst  ( WChar ) ( dqbufp ) ) ;
    if  ( ( x < L'0' ) or  ( x  > L'9'  ) )
      return  true  ;
    { unsigned  int dop = *chr2p ;
      dop *=  10U ;
      if  ( dop  >=  0x100U ) {
        PLOStringPub * const newstr  = PLOString_NewCopy ( L"StackCluster::LoadByte:too big" ) ;
        if  ( newstr )
          StackClusterPrivate_ExceptionSet  (stclp,&  newstr ->plo ) ;
        else
          OutOfMemory (  stclp ) ;
        return  false ;
      }
      *chr2p = uint_cast_uint8 ( dop ) ;
      dop = *chr2p  ;
      dop +=  int_cast_uint8 ( x  - '0'  ) ;
      if  ( dop  >=  0x100U ) {
        PLOStringPub * const newstr  = PLOString_NewCopy ( L"StackCluster::LoadByte:too big" ) ;
        if  ( newstr )
          StackClusterPrivate_ExceptionSet  (stclp,&  newstr ->plo ) ;
        else 
          OutOfMemory (  stclp  ) ;
        return  false ;
      }
      *chr2p = uint_cast_uint8 ( dop ) ;
    }
  } // wchar_t x
  FreeBuf ( 1U  , dqbufp ) ;
  if  ( Deque_Empty ( WChar ) ( dqbufp ) ) {
    if  ( fn ==  (Stream *)0 ) 
      return  true  ;
    if  ( StreamEof ( fn ) )
      return  true  ;
    wchar_t buf ;
    if  ( StreamisBADReadWChar  ( fn , & buf ) )
      return  true  ;
    Deque_Push_back ( WChar ) ( dqbufp , buf ) ;
  }
  return  true  ;
}

void  StackClusterPrivate_CreateTaskForBackquote ( StackClusterPrivate * const stcp , ParaLispObject  * const lp ,
  Vector ( StackPLOP ) * const bufp2 ) {
  // switch of enum will have MANY items
  switch  (    ParaLispObject_Type  (lp )  ) {
  case  TypeGlobalListMemberPLOCons  :
    { size_t  const  bufs0  = VectorSizeCopy  ( StackPLOP ) ( bufp2 ) ;
      ParaLispObject  *  i  =  lp ;
      ParaLispObject  *  iold =  lp ;
      do  {
        { ParaLispObject  * * j2  = VectorBegin ( StackPLOP ) ( bufp2 ) ;
          ParaLispObject  * * const bufpend = VectorEnd ( StackPLOP ) ( bufp2 ) ;
          while ( j2  not_eq bufpend  ) {
            if  ( ( * j2 ) ==  i ) {
              Vector_Resize ( StackPLOP ) ( bufp2 , bufs0 ) ;
              return  ;
            }
            ++  j2  ;
          }
        }
        Vector_PushByValue  ( StackPLOP ) ( bufp2 , i ) ;
        ParaLispObject  * const xp = ClassCons_First(&ParaLispObjectToPLOCons ( i )->cc ) ;
        // switch of enum will have MANY items
        switch  (   ParaLispObject_Type  ( xp )  ) {
        case  TypeGlobalListMemberPLOCons  :
          StackClusterPrivate_CreateTaskForBackquote ( stcp, xp , bufp2 ) ;
          break ;
        case  TypeGlobalListMemberPLOQuote :
          StackClusterPrivate_CreateTaskForBackquote (stcp, xp , bufp2 ) ;
          break ;
        case  TypeGlobalListMemberPLOComma :
          { StackClusterPrivate * const  dopstclp = StackClusterPrivate_NewStCl4  ( stcp ) ;
            SetResultPlace  (  dopstclp ,
              ClassCons_PFirst ( &ParaLispObjectToPLOCons ( i )->cc ) , i ) ;
            StackClusterPrivate_CreateTask (dopstclp ,
              PLOComma_Item(ParaLispObjectToPLOComma( xp ) ) ) ;
          }
          break ;
        case  TypeGlobalListMemberPLOUnquoteSplicing :
          { StackClusterPrivate * const  dopstclp = StackClusterPrivate_NewStCl4  (stcp ) ;
            SetResultPlace  (  dopstclp ,
              ClassCons_PFirst ( &ParaLispObjectToPLOCons ( i )->cc ) , i ) ;
            StackClusterPrivate_CreateTask (dopstclp ,
              PLOUnQuoteSplicing_Item(ParaLispObjectToPLOUnQuoteSplicing ( xp ) ) ) ;
          }
          break ;
        default : ;
        }  // switch
        iold  = i ;
        i = ClassCons_Rest ( &ParaLispObjectToPLOCons ( i )->cc ) ;
      } while ( CConsp (  i ) ) ;
      // tail analysing
      // switch of enum will have MANY items
      switch  (   ParaLispObject_Type  ( i)  ) {
      case  TypeGlobalListMemberPLOComma :
        // `(a b . ,x)
        { StackClusterPrivate * const  dopstclp = StackClusterPrivate_NewStCl4  (stcp ) ;
          SetResultPlace  (  dopstclp ,
            ClassCons_PRest ( &ParaLispObjectToPLOCons ( iold  )->cc ) , iold  ) ;
          StackClusterPrivate_CreateTask (dopstclp ,
            PLOComma_Item(ParaLispObjectToPLOComma( i ) ) ) ;
        }
        break ;
      case  TypeGlobalListMemberPLOUnquoteSplicing :
        // `(a b . ,@x)
        { StackClusterPrivate * const dopstclp = StackClusterPrivate_NewStCl4  (stcp ) ;
          SetResultPlace  (  dopstclp ,
            ClassCons_PRest ( &ParaLispObjectToPLOCons ( iold  )->cc ) , iold  ) ;
          StackClusterPrivate_CreateTask ( dopstclp ,
            PLOUnQuoteSplicing_Item(ParaLispObjectToPLOUnQuoteSplicing ( i ) ) ) ;
        }
        break ;
      default :
        StackClusterPrivate_CreateTaskForBackquote (stcp, i , bufp2 ) ;
      } // switch
      Vector_Resize ( StackPLOP ) ( bufp2 , bufs0 ) ;
    }
    // size_t  bufs0, ParaLispObject  *  i , iold
    break ;
  case  TypeGlobalListMemberPLOQuote :
    { ParaLispObject  * * j2  = VectorBegin ( StackPLOP ) ( bufp2 ) ;
      ParaLispObject  * * const bufpend = VectorEnd ( StackPLOP ) ( bufp2 ) ;
      while ( j2 not_eq bufpend ) {
        if  ( ( * j2 ) ==  lp )
          return  ;
        ++  j2 ;
      }
    }
    Vector_PushByValue  ( StackPLOP ) ( bufp2 , lp ) ;
    { ParaLispObject  * const xp = PLOQuote_Item  ( ParaLispObjectToPLOQuote( lp ) ) ;
      // switch of enum will have MANY items
      switch  ( ParaLispObject_Type  ( xp ) ) {
      case  TypeGlobalListMemberPLOCons  :
        break ;
      case  TypeGlobalListMemberBackQuotePrivate :
        VectorPop ( StackPLOP ) ( bufp2 ) ;
        return  ;
      case  TypeGlobalListMemberPLOComma :
        // `(.. ',x ..)
        { StackClusterPrivate * const dopstclp = StackClusterPrivate_NewStCl4  (stcp )  ;
          SetResultPlace  (  dopstclp , PLOQuote_PItem ( ParaLispObjectToPLOQuote ( lp ) ) ,  lp ) ;
          StackClusterPrivate_CreateTask (dopstclp ,
            PLOComma_Item(ParaLispObjectToPLOComma( xp ) ) ) ;
        }
        VectorPop ( StackPLOP ) ( bufp2 ) ;
        return  ;
      case  TypeGlobalListMemberPLOUnquoteSplicing :
        // `(.. ',@x ..)
        { StackClusterPrivate * const dopstclp = StackClusterPrivate_NewStCl4  (stcp )  ;
          SetResultPlace  (  dopstclp , PLOQuote_PItem ( ParaLispObjectToPLOQuote  (  lp ) ) ,  lp ) ;
          StackClusterPrivate_CreateTask (dopstclp ,
            PLOUnQuoteSplicing_Item(ParaLispObjectToPLOUnQuoteSplicing( xp ) ) ) ;
        }
        VectorPop ( StackPLOP ) ( bufp2 ) ;
        return  ;
      default : ;
      }  // switch  x
    } // ParaLispObject  & x
    VectorPop ( StackPLOP ) ( bufp2 ) ;
    StackClusterPrivate_CreateTaskForBackquote ( stcp,
      PLOQuote_Item  ( ParaLispObjectToPLOQuote( lp ) ) , bufp2 ) ;
    break ;
# ifdef  LISP2D_DEBUG
  case  TypeGlobalListMemberPLOComma :    
    StackClusterPrivate_ExceptionSet  (stcp,
      & PLOString_NewCopy ( L"CreateTaskForBackquote: l is Comma" )->plo ) ;
    break ;
  case  TypeGlobalListMemberPLOUnquoteSplicing :
    StackClusterPrivate_ExceptionSet  (stcp,
      & PLOString_NewCopy ( L"CreateTaskForBackquote: l is UnquoteSplicing" )-> plo ) ;
    break ;
# endif
  default : ;
  }  // switch
}

void  StackClusterClearHandToQueue  ( StackClusterPrivate * const me ) {
  if  ( StackClusterPrivate_handtoqueue ( me  ) )
    ConsAtomicPointerClear ( StackClusterPrivate_handtoqueue  ( me  ) ) ;
}

void  StackClusterSetNextQueue  ( StackClusterPrivate * const me , ConsAtomicPointe * const x ) {
  if  ( StackClusterPrivate_handtoqueue ( me  ) )
    ConsAtomicPointerSetRest ( StackClusterPrivate_handtoqueue  ( me  ) , x ) ;
}

void  StackClusterSetFirstQueue ( StackClusterPrivate * const me ) {
  if  ( StackClusterPrivate_handtoqueue ( me  ) )
    ConsAtomicPointerSetFirst  ( StackClusterPrivate_handtoqueue  ( me  ) , me ) ;
}

# include "castb.h"

void  StackClusterPrivate_Pop ( StackClusterPrivate * const stp , ParaLispObject * * const resultargp  ) {
  ( * resultargp  ) = Lisp2DStackPLOPPopValue  ( & stp ->  stackc  ) ;
}

size_t  StackClusterPrivate_sonscount ( StackClusterPrivate const  * const s ) {
  return  s ->  sonscount ;
}

void  StackClusterPrivate_sonscountdec ( StackClusterPrivate * const s ) {
  --  (  s ->  sonscount )  ;
}
# include "widestring/inline.h"
# include "char/inline.h"
# include "stclhistory/inline.h"

void  OutOfMemory ( StackClusterPrivate  * const stclp  ) {
# ifdef  LISP2D_INNERHISTORY
  Lisp2DInnerHistoryShow  ( & Lisp2DinnerHistory  ) ;
# endif
  if  ( stclp )
    StackClusterPrivate_ExceptionSet  ( stclp , & plosoutofmemory . plo ) ;
  else
    ErrorStrav ( ( PArray ( _wchar_cv ) ) {
      ( wchar_t const volatile  ( * ) [ ] ) ( StringCStr ( WideChar ) ( PLOSymbolCValue ( & plosoutofmemory ) ) ) } ) ;
}

void  AddrForReturn2ConstructorFlagInBIM  ( t_AddrForReturn2ConstructorFlagInBIM const * const p ) {
  EvalAddrSetCont ( & p -> me ->  addr . pub , p -> addr ) ;
  p -> me  -> inBIM =  p -> inbim ;
}

# include "stcl/inline.h"
