// comma ,
// ©2011-23 by Alex Glebe
# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include <stddef.h>

_Atomic ( size_t ) PLOComma_constrstat = 0 ;

# endif // LISP2D_CONSTRSTAT

# include "comma/public.h"

# ifdef  LISP2D_CONSTRSTAT

void  PLOComma_constrstat_Inc  ( void  ) {
  ++  PLOComma_constrstat  ;
}

size_t  PLOComma_constrstat_Value  ( void  ) {
  return  PLOComma_constrstat  ;
}

# endif // LISP2D_CONSTRSTAT

# include "symbolc.h"

# define  PLOComma_staticTypeOf Lisp2D_PLOComma_staticTypeOf
ParaLispObject  * PLOComma_staticTypeOf ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  & ploscomma  . plo  ;
}

# include "sharedc.h"
# include "shared/inline.h"
# include "plostream/public.h"

// ? pass arg as struct ?
# define  PLOComma_Cout Lisp2D_PLOComma_Cout
static  void  PLOComma_Cout  ( PLOComma * const me , FuncCoutToInterpretHuman  funccout , PLOStream  const * const  sp ,
  bool  flag2p  , Vector ( StackPLOP ) * const lookingp  ) {
  bool  flagp  = flag2p  ;
  if  ( Printed3Points  ( & me -> plo , sp , & flagp ,  lookingp ) )  
    return  ;
  PLOStreamPushWChar  ( sp  , L',' ) ;
  Vector_PushByValue ( StackPLOP ) (  lookingp , & me -> plo ) ;
  funccout ( me -> item ,  sp , &  flagp  ,  lookingp ) ;
  VectorPop(StackPLOP) (  lookingp ) ;
}

bool  PLOComma_staticisBADCopyPrivate ( ParaLispObject const * const  me , ParaLispObject  * * const resultp  ) {
  { PLOComma * const  res  = aligned_alloc ( _Alignof ( PLOComma ) , sizeof ( PLOComma ) ) ;
    if  ( res ) {
      PLOComma_Init(res);
      PLOComma_SetItem ( res , ParaLispObjectToPLOCommaConst ( me ) -> item ) ;
      ParaLispObject_virtualPushAsNew (&res ->  plo ) ;
      ( * resultp )  = &res->plo ;
      return  false ;
    }
  }
  return  true  ; 
}

void  PLOComma_staticGCDeclareContent ( ParaLispObject * const me ) {
  ParaLispObject_virtualDeclareForGC (     ParaLispObjectToPLOComma(me) -> item ) ;
}

# include "nilc.h"

void  PLOComma_Init( PLOComma * const me ) {
  me -> item = &  plonil.plo ;
  { VirtualTypePointer  vtp = { . addr = { . p = me } , . type = TypeGlobalListMemberPLOComma } ;
    ParaLispObject_InitVTP(&me->plo ,vtp );
  }
# ifdef  LISP2D_CONSTRSTAT
  PLOComma_constrstat_Inc ( ) ;
# endif
}

void  PLOComma_staticCoutToInterpret ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector  ( StackPLOP ) * const h ) {
  PLOComma_Cout  ( ParaLispObjectToPLOComma  ( ( ParaLispObject * ) me  ) ,
    ParaLispObject_CoutToInterpret , s , flag2pprinted , h ) ;
}

void  PLOComma_staticCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector  ( StackPLOP )  * const h ) {
  PLOComma_Cout  ( ParaLispObjectToPLOComma  ( ( ParaLispObject * ) me  ) ,
    ParaLispObject_CoutToHuman , s , flag2pprinted , h ) ;
}

# include "cons/inline.h"
# include "stcl/public.h"
# include "stcl/inline.h"

// 'comma newobject (2 + 2) -> ,4
TaskForThread Lisp2Dbimcommacomma2  ( StackClusterPrivate  * const stclpp  ) {
  PLOComma  * const mep  =ParaLispObjectToPLOComma ( StackClusterPrivate_ThisTop(stclpp))  ;
  PLOComma_SetItem ( mep , CCAR ( StackClusterPrivate_ArgTop(stclpp)) ) ;
  StackClusterPrivate_SetResult (stclpp,& mep -> plo  ) ;
  return  TaskForThread_Analyse ;
}

// comma setf comma
TaskForThread Lisp2Dbimcommasetf2 ( StackClusterPrivate * const stclpp ) {
  PLOComma  * const mep  =ParaLispObjectToPLOComma ( StackClusterPrivate_ThisTop(stclpp))  ;
  ParaLispObject  * const argp =  CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  if  ( not  IsNotComma (  stclpp  ,  argp ) ) {
    PLOComma_Set (  mep , ParaLispObjectToPLOComma ( argp ) ) ;
    StackClusterPrivate_SetResult (stclpp ,& mep -> plo  ) ;
  }
  return  TaskForThread_Analyse ;
}

// comma swap comma
TaskForThread Lisp2Dbimcommaswap2 ( StackClusterPrivate * const stclpp ) {
  PLOComma  * const mep = ParaLispObjectToPLOComma (
    StackClusterPrivate_ThisTop(stclpp))  ;
  ParaLispObject  * const argp = CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  if  ( not  IsNotComma (  stclpp  ,  argp ) ) {
    if  ( IsConst (   stclpp ,  argp ) )
// ! to exception
      return  TaskForThread_Analyse ;
    PLOComma_Swap  (  mep , ParaLispObjectToPLOComma ( argp ) ) ;
    StackClusterPrivate_SetResult (stclpp ,& mep->plo  ) ;
  }
  return  TaskForThread_Analyse ;
}

# include "boolean.h"

TaskForThread Lisp2Dbimnilcommap2 ( StackClusterPrivate * const stclpp ) {
  ParaLispObject  * const xp = CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  StackClusterPrivate_SetResult (stclpp ,( CommaP (  xp )  ?
    xp :
    &  plofalse.plo )) ;
  return  TaskForThread_Analyse ;
}

# include "newobject.h"

bool  IsNotComma  ( StackClusterPrivate  * const stclp  , ParaLispObject * const  xp ) {
  tUniversalIsNotType ar  = {
    . stclp = stclp ,
    . xp  = xp  ,
    . typetype  = TypeGlobalListMemberPLOComma ,
    . res = false ,
  } ;
  UniversalIsNotTypess  ( & ar  ) ;
  return  ar  . res ;
  //return  UniversalIsNotType  ( stclp , xp ,  TypeGlobalListMemberPLOComma ) ;
} 

ParaLispObject  * PLOComma_staticClassDef  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  ploclassdefComma  ;
}

ParaLispObject  * PLOComma_staticClassParents  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return   ploclassparentsComma  ;
}

void  PLOComma_Destr ( PLOComma * const me ) {
  ParaLispObject_staticDestr(&me->plo);
}

void PLOComma_staticDestr  ( ParaLispObject * const me ) {
  PLOComma_Destr  ( ParaLispObjectToPLOComma ( me  ) ) ;
}

void  PLOComma_Swap  ( PLOComma * const me , PLOComma * const xp  ) {
  if ( me not_eq xp ) {
    ParaLispObject  * const myitem  = me -> item ;
    me -> item = xp -> item ;
    xp -> item = myitem ;
  }
}
