// number arg
// (C)2023
# include "complexbim.h"
# include "plocomplex/public.h"
# include "stcl/public.h"
# include "stcl/classc.h"
# include "stcl/inline.h"
# include "complex/inline.h"
# include <math.h> // atan2l
# include "stack/public.h"

// !! to write function : Arg(Complex,Fraction & result)

TaskForThread bimcomplexarg ( StackClusterPrivate  * const stclpp ) {
  PLOComplex const * const mep  = ParaLispObjectToPLOComplexConst ( StackClusterPrivate_ThisTop ( stclpp )  ) ;
  if  ( ULongIs0  ( FractionCNump ( Complex_CIm ( PLOComplexToComplexConst  ( mep ) ) ) ) )
    goto  ImNumIs0  ;
  else
    goto  NotImNumIs0 ;
ImNumIs0  :
  if  ( ULongIs0  ( FractionCDenomp( Complex_CIm(PLOComplexToComplexConst(mep))))) {
      // 0/0
      PLOComplex  * const  res= NewComplexBareExc ( );
      Complex_SetFraction ( PLOComplexToComplex( res), Complex_CIm(PLOComplexToComplexConst(mep)));
      StackClusterPrivate_SetResult(stclpp ,&  res->plo);
      // real
    } else {
      if( ULongIs0(FractionCNump( Complex_CRe(PLOComplexToComplexConst(mep))))) {
        ThreadStackPointerType const oldstack_nullp = Lisp2DThreadSP ( ) ;
        FractionPub * const nullp = NewStackFraction ( ) ;
        FractionInit ( nullp ) ;
        PLOComplex  * const  res= NewComplexBareExc ( );
        Complex_SwapFraction  ( PLOComplexToComplex ( res ) , nullp ) ;
        StackClusterPrivate_SetResult(stclpp ,&  res->plo);
        Lisp2D_StackFree  ( oldstack_nullp ) ;
      } else { // 0/0
        if(FractionIsNegative( Complex_CRe(PLOComplexToComplexConst(mep)))) {
          // pi
          PLOComplex  * const  res= NewComplexBareExc ( );
          Complex_SetFraction ( PLOComplexToComplex( res),FractionCToPub(
            Fraction_toCPrivate(FractionploConstPiPub) )) ;
          StackClusterPrivate_SetResult(stclpp ,&  res->plo);
        } else {
          PLOComplex  * const  resp= NewComplexBareExc ();
          Complex_Set0  ( PLOComplexToComplex( resp));
          StackClusterPrivate_SetResult(stclpp ,&  resp->plo);
        }
      }
    }
  goto  Return  ;
NotImNumIs0  :
  if( ULongIs0(FractionCDenomp( Complex_CIm(PLOComplexToComplexConst(mep))))) {
      // im=+-1/0
      if(FractionIsNegative( Complex_CIm( PLOComplexToComplexConst(mep)))) {
        // im=-1/0
        if( ULongIs0(FractionCDenomp( Complex_CRe(PLOComplexToComplexConst(mep))))) {
          // re=1/0 or 0/0
          ThreadStackPointerType const oldstack_nullp = Lisp2DThreadSP ( ) ;
          FractionPub * const nullp = NewStackFraction ( ) ;
          FractionInit ( nullp ) ;
          PLOComplex  * const  res= NewComplexBareExc ( );
          Complex_SwapFraction  ( PLOComplexToComplex ( res ) , nullp ) ;
          StackClusterPrivate_SetResult(stclpp ,&  res->plo);
          Lisp2D_StackFree  ( oldstack_nullp ) ;
        } else { // 0/0
          PLOComplex  * const  pres= NewComplexBareExc ( );
          Complex_SetFraction ( PLOComplexToComplex( pres),FractionCToPub(
            Fraction_toCPrivate(FractionploConstHalfPiPub )) );
          FractionSetFlagNegative ( Complex_Re  (PLOComplexToComplex( pres) ) ,
            not (FractionIsNegative(Complex_CRe(
            PLOComplexToComplexConst( pres))))) ;
          StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
        }
      } else { // -pi/2
        // im=+1/0
        if( ULongIs0(FractionCDenomp( Complex_CRe(PLOComplexToComplexConst(mep))))) {
          // re=1/0 or 0/0
          ThreadStackPointerType const oldstack_nullp = Lisp2DThreadSP ( ) ;
          FractionPub * const nullp = NewStackFraction ( ) ;
          FractionInit ( nullp ) ;
          PLOComplex  * const  res= NewComplexBareExc ( );
          Complex_SwapFraction  ( PLOComplexToComplex ( res ) , nullp ) ;
          StackClusterPrivate_SetResult(stclpp ,&  res->plo);
          Lisp2D_StackFree  ( oldstack_nullp ) ;
        } else {  // 0/0
          PLOComplex  * const  pres= NewComplexBareExc ( );
          Complex_SetFraction ( PLOComplexToComplex( pres),FractionCToPub(
            Fraction_toCPrivate(FractionploConstHalfPiPub) ));
          StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
        }
      }
    } else { // pi/2
      // im=real
      if( ULongIs0(FractionCNump( Complex_CRe(PLOComplexToComplexConst(mep))))) {
        if( ULongIs0(FractionCDenomp( Complex_CRe(PLOComplexToComplexConst(mep))))) {
          PLOComplex  * const  pres = NewComplexBareExc ( ) ;
          ThreadStackPointerType const oldstack_nullp = Lisp2DThreadSP ( ) ;
          FractionPub * const nullp = NewStackFraction ( ) ;
          FractionInit ( nullp ) ;
          Complex_SwapFraction  ( PLOComplexToComplex ( pres ) , nullp ) ;
          Lisp2D_StackFree  ( oldstack_nullp ) ;
          StackClusterPrivate_SetResult ( stclpp ,  & pres  ->  plo ) ;
        } else { // 0/0
          // re=0
          if(FractionIsNegative( Complex_CIm(PLOComplexToComplexConst(mep)))) {
            PLOComplex  * const  pres= NewComplexBareExc ( );
            Complex_SetFraction ( PLOComplexToComplex( pres),FractionCToPub(
            Fraction_toCPrivate(FractionploConstHalfPiPub) ));
            FractionSetFlagNegative ( Complex_Re  (PLOComplexToComplex(pres) )
              , not (FractionIsNegative( Complex_CRe(PLOComplexToComplexConst(pres)))));
            StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
          } else { // -pi/2
            PLOComplex  * const  pres= NewComplexBareExc ( );
            Complex_SetFraction ( PLOComplexToComplex( pres),FractionCToPub(
              Fraction_toCPrivate(FractionploConstHalfPiPub) ));
            StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
          }
        }
      } else { // pi/2
        long  double  lx = FractionLDValueConst ( Complex_CIm(PLOComplexToComplexConst(mep)));
        long  double const ly = FractionLDValueConst ( Complex_CRe(PLOComplexToComplexConst(mep)));
        lx  = atan2l(lx,ly);
        { PLOComplex  * const pres = NewComplexBareExc (  );
          Complex_SetExactFromLD  ( PLOComplexToComplex( pres),lx);
          StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
        }
      }
    }
  goto  Return  ;
Return  :
  return  TaskForThread_Analyse ;
}
