// Complex Bim
// 2023
# include <math.h> // asinl
# include <complex.h> // casinl

// clang
# ifndef CMPLXL
# define CMPLXL(x, y) ((long double complex)((long double)(x) + \
                      _Complex_I * (long double)(y)))
# endif

# include "complexbim.h"
# include "cons/public.h"
# include "complex/public.h"
# include "boolean.h"
# include "stcl/public.h"
# include "stcl/inline.h"

//  nil numberp x
TaskForThread bimnilnumberp ( StackClusterPrivate  * const stclpp ) {
  ParaLispObject  * const xp = CCAR(StackClusterPrivate_ArgTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,( Numberp( xp) ?
    xp :
    & plofalse.plo ));
  return   TaskForThread_Analyse ; 
}

# include "plocomplex/public.h"
# include "complex/inline.h"

// nil complex 
/*('complex defmethod complex (x  y)
  (nil  if  x
    (nil  if y
      this=(x y)
      this=x))
  this)*/
TaskForThread bimcomplexcomplex ( StackClusterPrivate  * const stclpp ){
  PLOComplex  * const mep =ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  ParaLispObject  * const arglistp =StackClusterPrivate_ArgTop(stclpp );
  ParaLispObject  * const xp=CCAR(arglistp);
  if( Numberp(xp)){
    ParaLispObject  * const yp=CCAR(CCDR(arglistp));
    if( Numberp(yp)){
      FractionSetFraction  ( Complex_Re  ( PLOComplexToComplex (
        mep ) ) ,  Complex_CRe ( PLOComplexToComplexConst  (
        ParaLispObjectToPLOComplex  ( xp  ) ) ) ) ;
      FractionSetFraction  ( Complex_Im  ( PLOComplexToComplex (
        mep ) ) ,  Complex_CRe  ( PLOComplexToComplexConst  (
        ParaLispObjectToPLOComplex  ( yp  ) ) ) )  ;
    } else   
      Complex_Set ( PLOComplexToComplex( mep),  PLOComplexToComplexConst(
        ParaLispObjectToPLOComplex(xp)));
  }
  return   TaskForThread_Analyse ;
}

//  complex realp
TaskForThread bimcomplexrealp( StackClusterPrivate  * const  stclpp ) {
  ParaLispObject  * const xp = StackClusterPrivate_ThisTop(stclpp );
  StackClusterPrivate_SetResult(stclpp ,
    Complex_isReal(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst( xp)))  ?
      xp :
      & plofalse.plo );
  return   TaskForThread_Analyse ; 
}

# include "sharedc.h"
# include "shared/inline.h" // maxListItemProcessing
# include "cons/inline.h"

//  complex + [{complex}]
TaskForThread bimcomplexplus( StackClusterPrivate * const stclpp ){
  ParaLispObject  * j;
  PLOComplex  * me;
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) ) {
    me  = ParaLispObjectToPLOComplex(StackClusterPrivate_PopValue( stclpp ));
    j=StackClusterPrivate_PopValue(stclpp );
    goto  Next;
  }
  { ParaLispObject  * const arglistp =StackClusterPrivate_ArgTop(stclpp );
    if(not  CConsp(arglistp)){
      StackClusterPrivate_SetResult(stclpp ,StackClusterPrivate_ThisTop( stclpp ));
      return  TaskForThread_Analyse;
    }
    j =   arglistp;
  }
  me  =  NewComplexBareExc ( );
  Complex_Set ( PLOComplexToComplex( me), PLOComplexToComplexConst( ParaLispObjectToPLOComplexConst(
      StackClusterPrivate_ThisTop(stclpp ))));
  StackClusterPrivate_SetResult(stclpp ,&  me->plo);
Next  :
  for ( unsigned  int tasks = maxListItemProcessing ;
    ( tasks  > 0  ) and CConsp (   j  ) ;
    j  = ClassCons_Rest (& ParaLispObjectToPLOCons ( j )->cc ) , --  tasks ) {
    ParaLispObject  * const xp =ClassCons_First(&ParaLispObjectToPLOCons(j) ->cc);
    if(IsNotNumber(   stclpp ,xp)) 
      return  TaskForThread_Analyse;
    Complex_AddConst ( PLOComplexToComplex( me), PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(xp))); 
  }
  if(CConsp(   j)){
    StackClusterPrivate_setTaskForManager ( stclpp , TaskPause ) ;
    StackClusterPrivate_SetflagCont ( stclpp , 1U  ) ;
    StackClusterPrivate_Push(stclpp ,   j);
    StackClusterPrivate_Push(stclpp ,&  me->plo);
  }
  return  TaskForThread_Analyse;
}

//  complex += [{complex}]
// res : complex + [{complex}] 
// new number is protection from : x += x x   Must to be : x*3  , NOT x*4
// this : setf or swap (res)
TaskForThread bimcomplexplussetf( StackClusterPrivate * const stclpp ){
  TaskForThread   res=bimcomplexplus( stclpp );
  ParaLispObject  * const nresp = StackClusterPrivate_result  ( stclpp );
  if( Numberp(nresp)){
    PLOComplex  * const mep = ParaLispObjectToPLOComplex(StackClusterPrivate_ThisTop(stclpp ));
    Complex_Swap  ( PLOComplexToComplex( mep),  PLOComplexToComplex(
      ParaLispObjectToPLOComplex(nresp)));
    StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  }
  return  res ; 
}

//  complex - [{complex}]
TaskForThread bimcomplexminus( StackClusterPrivate  * const stclpp ){
  ParaLispObject  * j;
  PLOComplex  * me;
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) ) {
    me  = ParaLispObjectToPLOComplex(StackClusterPrivate_PopValue(stclpp )); 
    j=StackClusterPrivate_PopValue(stclpp );
    goto  Next;
  }  
  me  =  NewComplexBareExc ( );
  Complex_Set ( PLOComplexToComplex( me),
    PLOComplexToComplexConst( ParaLispObjectToPLOComplexConst(
      StackClusterPrivate_ThisTop(stclpp ))));
  StackClusterPrivate_SetResult(stclpp ,&   me->plo);
  { ParaLispObject  * const arglistp =StackClusterPrivate_ArgTop(stclpp );
    if(not  CConsp(arglistp)) {
      Complex_TurnSign  ( PLOComplexToComplex( me));
      return  TaskForThread_Analyse; 
    }
    j =    arglistp; 
  }
Next  :
  for ( unsigned  int tasks = maxListItemProcessing  ; ( tasks  > 0  ) and
    CConsp (  j ) ;
      j  = ClassCons_Rest ( &ParaLispObjectToPLOCons ( j )->cc ) ,
    --  tasks ) {
    ParaLispObject  * const xp=ClassCons_First(&ParaLispObjectToPLOCons(j)
      ->cc);
    if( IsNotNumber(   stclpp ,xp))
      return  TaskForThread_Analyse;
    Complex_Subtract  ( PLOComplexToComplex( me), PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(xp)) ); 
  }
  if(CConsp(   j)){
    StackClusterPrivate_setTaskForManager ( stclpp , TaskPause ) ;
    StackClusterPrivate_SetflagCont (  stclpp , 1U  ) ;
    StackClusterPrivate_Push(stclpp , j);
    StackClusterPrivate_Push(stclpp ,&  me->plo);
  }
  return  TaskForThread_Analyse;
}

// complex -= [{complex}]
TaskForThread bimcomplexminussetf( StackClusterPrivate  * const stclpp ){
  PLOComplex  * me;
  ParaLispObject  * arglist;
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) ) {
    me  = ParaLispObjectToPLOComplex(StackClusterPrivate_PopValue(
      stclpp ));
    arglist=StackClusterPrivate_PopValue(stclpp );
    goto  Next;
  }
  arglist =  StackClusterPrivate_ArgTop(stclpp ) ;
  { PLOComplex  * const me0p=
      ParaLispObjectToPLOComplex(StackClusterPrivate_ThisTop(stclpp ));
    StackClusterPrivate_SetResult(stclpp ,&me0p->plo);
    if(not  CConsp(   arglist)) {
      Complex_TurnSign  ( PLOComplexToComplex( me0p));
      return  TaskForThread_Analyse; 
    }
    if  ( not  CConsp (
        ClassCons_Rest  ( &ParaLispObjectToPLOCons ( arglist )->cc ) ) ) {
      // one argument
      ParaLispObject  * const xp=
        ClassCons_First(&ParaLispObjectToPLOCons(arglist)->cc);
      if(not  IsNotNumber(   stclpp ,xp))
        Complex_Subtract (  PLOComplexToComplex( me0p),
          PLOComplexToComplexConst( ParaLispObjectToPLOComplexConst(xp)) );
      return  TaskForThread_Analyse;
    }
    me  =  NewComplexBareExc ( );
    Complex_Set ( PLOComplexToComplex( me), PLOComplexToComplexConst( me0p)); 
  } // me0
Next  :
  for ( unsigned  int tasks = maxListItemProcessing ; ( tasks  > 0  ) and 
      CConsp (  arglist ) ;
    arglist = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( arglist )->cc ) ,
        --  tasks ) {
    ParaLispObject  * const xp=
      ClassCons_First(&ParaLispObjectToPLOCons(arglist)->cc);
    if( IsNotNumber(   stclpp ,xp))    
      return  TaskForThread_Analyse;
    Complex_Subtract  ( PLOComplexToComplex( me), PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(xp)) ); 
  }
  if(CConsp(   arglist)){
    StackClusterPrivate_setTaskForManager ( stclpp , TaskPause ) ;
    StackClusterPrivate_SetflagCont (  stclpp , 1U  ) ;
    StackClusterPrivate_Push(stclpp ,   arglist);
    StackClusterPrivate_Push(stclpp ,&  me->plo);
    return  TaskForThread_Analyse;
  }
  Complex_Swap( PLOComplexToComplex(
      ParaLispObjectToPLOComplex(StackClusterPrivate_ThisTop(
      stclpp ))),
    PLOComplexToComplex( me));
  return  TaskForThread_Analyse;
}

//  complex / [{complex}]
TaskForThread bimcomplexdivide( StackClusterPrivate * const stclpp ){
  ParaLispObject  * j;
  PLOComplex  * me;
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) ) {
    me  = ParaLispObjectToPLOComplex(StackClusterPrivate_PopValue(stclpp ));
    j=StackClusterPrivate_PopValue(stclpp );
    goto  Next;
  }
  me  =  NewComplexBareExc ( );
  Complex_Set ( PLOComplexToComplex( me),
    PLOComplexToComplexConst( ParaLispObjectToPLOComplexConst(
      StackClusterPrivate_ThisTop(stclpp ))));
  StackClusterPrivate_SetResult(stclpp ,&   me->plo);
  { ParaLispObject  * const arglistp=StackClusterPrivate_ArgTop(stclpp );
    if(not  CConsp(arglistp)){
      Complex_OneDivide ( PLOComplexToComplex( me));  // 1/this
      return  TaskForThread_Analyse;
    }
    j =    arglistp;
  }
Next  :
  for ( unsigned  int tasks = maxListItemProcessing ; ( tasks  > 0  ) and
    CConsp (  j ) ;
      j  = ClassCons_Rest ( &ParaLispObjectToPLOCons ( j )->cc ) ,
    --  tasks ) {
    ParaLispObject  * const xp=ClassCons_First(&ParaLispObjectToPLOCons(j)
      ->cc);
    if( IsNotNumber(  stclpp ,xp))    
      return  TaskForThread_Analyse;
    Complex_Div ( PLOComplexToComplex( me), PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(xp))); 
  }
  if(CConsp(  j)){
    StackClusterPrivate_setTaskForManager ( stclpp , TaskPause ) ;  
    StackClusterPrivate_SetflagCont (  stclpp , 1U  ) ;
    StackClusterPrivate_Push(stclpp , j);
    StackClusterPrivate_Push(stclpp ,& me->plo);
  }
  return  TaskForThread_Analyse;
}

// complex /= [{complex}]
TaskForThread bimcomplexdividesetf( StackClusterPrivate * const stclpp ){
  PLOComplex  * me;
  ParaLispObject  * arglist;
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) ) {
    me  = ParaLispObjectToPLOComplex(StackClusterPrivate_PopValue(stclpp ));
    arglist=StackClusterPrivate_PopValue(stclpp );
    goto  Next;
  }
  arglist =   StackClusterPrivate_ArgTop(stclpp );
  { PLOComplex  * const me0p=
      ParaLispObjectToPLOComplex(StackClusterPrivate_ThisTop(stclpp ));
    StackClusterPrivate_SetResult(stclpp ,&me0p->plo);
    if(not  CConsp(   arglist)){
      Complex_OneDivide ( PLOComplexToComplex( me0p));  // 1/this
      return  TaskForThread_Analyse;
    }
    if  ( not  CConsp (
        ClassCons_Rest  ( &ParaLispObjectToPLOCons ( arglist )->cc ) ) ) {
      // one argument
      ParaLispObject  * const xp=ClassCons_First(&ParaLispObjectToPLOCons(arglist)->cc);
      if(not  IsNotNumber(   stclpp ,xp))     
        Complex_Div ( PLOComplexToComplex( me0p) , PLOComplexToComplexConst(
          ParaLispObjectToPLOComplexConst(xp)));
      return  TaskForThread_Analyse;
    }
    me  =  NewComplexBareExc ( );
    Complex_Set ( PLOComplexToComplex( me), PLOComplexToComplexConst( me0p));
  } // me0
Next  :
  for ( unsigned  int tasks = maxListItemProcessing ; ( tasks  > 0  ) and 
    CConsp (   arglist  ) ;
    arglist = ClassCons_Rest  ( &
      ParaLispObjectToPLOCons ( arglist )->cc ) , --  tasks ) {
    ParaLispObject * const xp=ClassCons_First(&ParaLispObjectToPLOCons(arglist)->cc);
    if( IsNotNumber(  stclpp ,xp))     
      return  TaskForThread_Analyse;
    Complex_Div ( PLOComplexToComplex( me), PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(xp)));
  }
  if(CConsp(  arglist)){
    StackClusterPrivate_setTaskForManager (
      stclpp , TaskPause ) ;  
    StackClusterPrivate_SetflagCont (  stclpp , 1U  ) ;
    StackClusterPrivate_Push(stclpp , arglist);
    StackClusterPrivate_Push(stclpp ,& me->plo);
    return  TaskForThread_Analyse;
  }
  Complex_Swap(
    PLOComplexToComplex( ParaLispObjectToPLOComplex(StackClusterPrivate_ThisTop(
      stclpp ))),
    PLOComplexToComplex( me));
  return  TaskForThread_Analyse;
}

//  complex * [{complex}]
TaskForThread bimcomplexmultiply( StackClusterPrivate * const stclpp ){
  ParaLispObject  * j;
  PLOComplex  * me;
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) ) {
    me  = ParaLispObjectToPLOComplex(StackClusterPrivate_PopValue( stclpp ));
    j=StackClusterPrivate_PopValue(stclpp );
    goto  Next;
  }
  { ParaLispObject  * const arglistp=StackClusterPrivate_ArgTop(stclpp );
    if(not  CConsp(arglistp)){
      StackClusterPrivate_SetResult(stclpp ,StackClusterPrivate_ThisTop(stclpp ));
      return  TaskForThread_Analyse;
    }
    j =  arglistp;
  }
  me  =  NewComplexBareExc ( );
  Complex_Set ( PLOComplexToComplex( me), PLOComplexToComplexConst( ParaLispObjectToPLOComplexConst(
      StackClusterPrivate_ThisTop(stclpp ))));
  StackClusterPrivate_SetResult(stclpp ,&   me->plo);
Next  :
  for ( unsigned  int tasks = maxListItemProcessing ; ( tasks  > 0  ) and CConsp (  j ) ;
      j = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( j )->cc ) , --  tasks ) {
    ParaLispObject  * const xp=ClassCons_First(&ParaLispObjectToPLOCons(j)->cc);
    if( IsNotNumber(   stclpp ,xp))     
      return  TaskForThread_Analyse;
    Complex_Mul ( PLOComplexToComplex( me), PLOComplexToComplexConst( ParaLispObjectToPLOComplexConst(xp)));
  }
  if(CConsp(   j)){
    StackClusterPrivate_setTaskForManager ( stclpp , TaskPause ) ;
    StackClusterPrivate_SetflagCont (  stclpp , 1U  ) ;
    StackClusterPrivate_Push(stclpp , j);
    StackClusterPrivate_Push(stclpp ,& me->plo);
  }
  return  TaskForThread_Analyse;
}

// complex *= [{complex}]
TaskForThread bimcomplexmultiplysetf( StackClusterPrivate * const stclpp ){
  PLOComplex  * me;
  ParaLispObject  * arglist;
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) ) {
    me  = ParaLispObjectToPLOComplex(StackClusterPrivate_PopValue(
      stclpp ));
    arglist=StackClusterPrivate_PopValue(stclpp );
    goto  Next;
  }
  arglist = StackClusterPrivate_ArgTop(stclpp );
  { PLOComplex  * const me0p=
      ParaLispObjectToPLOComplex(StackClusterPrivate_ThisTop(stclpp ));
    StackClusterPrivate_SetResult(stclpp ,&me0p->plo);
    if(not  CConsp(   arglist))     
      return  TaskForThread_Analyse;
    if  ( not  CConsp (
        ClassCons_Rest  (& ParaLispObjectToPLOCons ( arglist )->cc ) ) ) {
      // one argument
      ParaLispObject * const xp=ClassCons_First(&ParaLispObjectToPLOCons(arglist)->cc);
      if(not  IsNotNumber(   stclpp ,xp))
        Complex_Mul ( PLOComplexToComplex( me0p) , PLOComplexToComplexConst(
          ParaLispObjectToPLOComplexConst(xp)));
      return  TaskForThread_Analyse;
    }
    me  =  NewComplexBareExc ( );
    Complex_Set ( PLOComplexToComplex( me), PLOComplexToComplexConst( me0p));
  } // me0
Next  :
  for ( unsigned  int tasks = maxListItemProcessing ; ( tasks  > 0  ) and
    CConsp (   arglist  ) ;
    arglist = ClassCons_Rest  (
      &ParaLispObjectToPLOCons ( arglist )->cc ) , --  tasks ) {
    ParaLispObject  * const xp=ClassCons_First(&ParaLispObjectToPLOCons(arglist)->cc);
    if( IsNotNumber(   stclpp ,xp))   
      return  TaskForThread_Analyse;
    Complex_Mul ( PLOComplexToComplex( me), PLOComplexToComplexConst(
      ParaLispObjectToPLOComplex(xp)));
  }
  if(CConsp(  arglist)){
    StackClusterPrivate_setTaskForManager ( stclpp , TaskPause ) ;
    StackClusterPrivate_SetflagCont (  stclpp , 1U  ) ;
    StackClusterPrivate_Push(stclpp , arglist);
    StackClusterPrivate_Push(stclpp ,& me->plo);
    return  TaskForThread_Analyse;
  }
  Complex_Swap(
    PLOComplexToComplex( ParaLispObjectToPLOComplex(StackClusterPrivate_ThisTop(
      stclpp ))),
    PLOComplexToComplex( me));
  return  TaskForThread_Analyse;
}

// complex = [{x}]
# define  ComplexEq Lisp2DComplexEq5Osj
static  Lisp2DBoolType ComplexEq  ( ParaLispObject * const xp  ,
  ParaLispObject * const yp  ) {
  if  ( not  Numberp  ( yp ) )   
    return   Lisp2DBoolFalse  ;
  if  ( Complex_NotEq(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst  ( xp )),
    PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst ( yp)) ) )
    return   Lisp2DBoolFalse  ;
  return   Lisp2DBoolTrue   ;
}

# include "eqnoteq.h"

TaskForThread bimcomplexequal ( StackClusterPrivate * const stclpp  ) {
  return   bimUniversalEqNotEq(  & ComplexEq  ,  stclpp  )  ;
}

// complex <> [{x}]
# define  ComplexNotEq  Lisp2DComplexNotEqz57v
static  Lisp2DBoolType ComplexNotEq  ( ParaLispObject * const xp  ,
  ParaLispObject * const yp  ) {
  if  ( not  Numberp  ( yp ) )  
    return   Lisp2DBoolTrue   ;
  if  ( Complex_Eq(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst  ( xp )),
    PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst ( yp ))) )
    return   Lisp2DBoolFalse  ;
  return   Lisp2DBoolTrue   ;
}

TaskForThread bimcomplexnotequal ( StackClusterPrivate * const stclpp  ) {
  return   bimUniversalEqNotEq(  & ComplexNotEq  ,  stclpp  )  ;
}

//  complex setf complex
TaskForThread bimcomplexsetf( StackClusterPrivate * const stclpp ){
  ParaLispObject  * const xp=CCAR(StackClusterPrivate_ArgTop(stclpp ));
  if( IsNotNumber(  stclpp ,xp))
    return   TaskForThread_Analyse ;
  PLOComplex  * const mep=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  Complex_Set ( PLOComplexToComplex( mep),  PLOComplexToComplexConst(
    ParaLispObjectToPLOComplex(xp)));
  StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  return   TaskForThread_Analyse ;
}

//  complex swap complex
TaskForThread bimcomplexswap( StackClusterPrivate * const stclpp ){
  ParaLispObject  * const xp=CCAR(StackClusterPrivate_ArgTop(stclpp ));
  if(IsNotNumber(  stclpp ,xp))   
    return  TaskForThread_Analyse;
  if(IsConst(  stclpp ,xp))  
    return  TaskForThread_Analyse;
  PLOComplex  * const mep=
    ParaLispObjectToPLOComplex(StackClusterPrivate_ThisTop(stclpp ));
  Complex_Swap  ( PLOComplexToComplex( mep), PLOComplexToComplex( 
    ParaLispObjectToPLOComplex(xp)));
  StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  return  TaskForThread_Analyse;
}

// ? to calc with epsil !          
// ? complex abs [eps]
//
//  complex abs
TaskForThread bimcomplexabs( StackClusterPrivate  * const stclpp ){
  PLOComplex  * const  me2  = NewComplexBareExc ( );
  Complex_Set ( PLOComplexToComplex( me2),
    PLOComplexToComplexConst( ParaLispObjectToPLOComplex(
      StackClusterPrivate_ThisTop(stclpp ))));
  StackClusterPrivate_SetResult(stclpp ,&  me2->plo);
  FractionPub * const rep=Complex_Re(PLOComplexToComplex(me2));
  FractionPub * const imp=Complex_Im(PLOComplexToComplex(me2));
  if( ULongIs0(FractionCDenomp(rep))){
    if( ULongIs0(FractionCNump(rep))){
      // re is 0/0
      if( ULongIs0(FractionCDenomp(imp)))
        if(not  ( ULongIs0(FractionCNump(imp))))          
          // im is +-inf
          FractionSetInf  (rep);    
    } else      // re is +-inf
      // return +inf
      FractionAbs (rep);
    FractionSet0  (imp);    
  } else
    // re is finite
    if( ULongIs0(FractionCDenomp(imp))) {
      if( ULongIs0(FractionCNump(imp))) 
        // im is 0/0
        FractionSetNaN  (rep);
      else        // im is +-inf
        FractionSetInf  (rep);
      FractionSet0  (imp);
    } else
      // im is finite
      if(not  (FractionIs0(rep))) {
        if(not  (FractionIs0(imp))){
          FractionSquare  ( rep ) ;
          FractionSquare  ( imp ) ;
          FractionAddMoveFraction(rep,imp);
// ? to calc with epsil !          
          FractionSqrt (rep);
        } else          // im=0
          FractionAbs (rep); 
        FractionSet0(imp);        
      } else {       // re=0
        if(not  (FractionIs0(imp))) {
          FractionSwapFraction ( rep , imp ) ;
          FractionAbs (rep);
          FractionSet0(imp);
        }
      }
  return  TaskForThread_Analyse;
}

// is this is complex ( Im NotEq 0 ) -> SetResult( NIL ) , returns  true 
# define  CheckThisComplexP Lisp2DCheckThisComplexPpsHW
static  bool  CheckThisComplexP( StackClusterPrivate * const  stclpp){
  if(not  (FractionIs0( Complex_CIm(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(
    StackClusterPrivate_ThisTop(stclpp))))))){
    StackClusterPrivate_SetResult(stclpp,&plonil.plo);
    return   true ;
  }
  return   false ;
}

# include "lessmore.h"

// is argument is not number then exception , returns  false 
// is number is Complex -> result( NIL ) , returns  false 
// is number , Real return  true 
# define  CheckArgumentIsNumberAndNotComplex  \
  Lisp2DCheckArgumentIsNumberAndNotComplexiA06
static  bool  CheckArgumentIsNumberAndNotComplex(
  StackClusterPrivate  * const stclpp , ParaLispObject * const yp){
  if(IsNotNumber(  stclpp ,yp))
    return  false;
  if(not  (FractionIs0( Complex_CIm(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(yp)))))){
    StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
    return   false ;
  }
  return   true ;
}

# define  ComplexLess Lisp2DComplexLessFGv6
static  Lisp2DBoolType ComplexLess(ParaLispObject * const xp,
  ParaLispObject * const yp, StackClusterPrivate  * const stclpp){
  if(not CheckArgumentIsNumberAndNotComplex(  stclpp ,yp))
    return   Lisp2DBoolUndef ;
  return  FractionLess(
    Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(xp)))
    , Complex_CRe(PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(yp))));
}

// complex < [{complex}]
// Re < Re
TaskForThread bimcomplexless( StackClusterPrivate * const stclpp ){
  if(CheckThisComplexP(  stclpp ))
    return   TaskForThread_Analyse ;
  return  bimUniversalLessMore(  & ComplexLess ,  stclpp );
}

# define  ComplexMore Lisp2DComplexMoreCGgg
static  Lisp2DBoolType ComplexMore(ParaLispObject * const xp,
  ParaLispObject * const yp,
  StackClusterPrivate  * const stclpp){
  if(not CheckArgumentIsNumberAndNotComplex(  stclpp ,yp))
    return   Lisp2DBoolUndef ;
  return  FractionLess(
    Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(yp)))
      , Complex_CRe(PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(xp))));
}

// complex > [{complex}]
// Re > Re
TaskForThread bimcomplexmore( StackClusterPrivate * const stclpp ){
  if(CheckThisComplexP(  stclpp ))
    return   TaskForThread_Analyse ;
  return  bimUniversalLessMore(  & ComplexMore ,  stclpp );
}  

# define  ComplexLessEq Lisp2DComplexLessEquglx
static  Lisp2DBoolType ComplexLessEq(ParaLispObject * const xp,
  ParaLispObject * const yp,
  StackClusterPrivate  * const stclpp ){
  if(not CheckArgumentIsNumberAndNotComplex(  stclpp ,yp)) 
    return   Lisp2DBoolUndef ;
  return  Lisp2DBoolNot(FractionLess(
    Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(yp)))
    ,Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(xp)) )));
}

// complex <= [{complex}]
// Re <= Re
TaskForThread bimcomplexlessoreq( StackClusterPrivate * const stclpp ){
  if(CheckThisComplexP(  stclpp ))
    return   TaskForThread_Analyse ;
  return  bimUniversalLessMore(  &  ComplexLessEq ,  stclpp );
}

# define  ComplexMoreEq Lisp2DComplexMoreEqbZu9
static  Lisp2DBoolType ComplexMoreEq(ParaLispObject * const xp,
  ParaLispObject * const yp,
  StackClusterPrivate  * const stclpp){
  if(not CheckArgumentIsNumberAndNotComplex(  stclpp ,yp))
    return  Lisp2DBoolUndef;
  return  Lisp2DBoolNot(FractionLess(
    Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(xp)))
    ,Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(yp)))));
}

// complex >= [{complex}]
// Re >= Re
TaskForThread bimcomplexmoreoreq( StackClusterPrivate * const stclpp ){
  if(CheckThisComplexP(  stclpp ))
    return   TaskForThread_Analyse ;
  return  bimUniversalLessMore(  &  ComplexMoreEq ,  stclpp );
}
  
# include "minmax.h"

// number min [{number}]
// Im = 0
TaskForThread bimcomplexmin( StackClusterPrivate * const stclpp ){
  if(CheckThisComplexP(  stclpp ))
    return   TaskForThread_Analyse ;
  return  bimUniversalMinMax(  &  ComplexLess ,  stclpp );
}

// number max [{number}]
// Im = 0
TaskForThread bimcomplexmax( StackClusterPrivate * const stclpp ){
  if(CheckThisComplexP(  stclpp )) 
    return  TaskForThread_Analyse;
  return  bimUniversalMinMax(  & ComplexMore ,  stclpp );
}  

// complex infp
TaskForThread bimcomplexinfp( StackClusterPrivate * const stclpp ){
  PLOComplex  * const mep=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,
    Complex_IsInf(PLOComplexToComplexConst(mep))  ?
      & mep->plo  :
      & plofalse.plo );
  return   TaskForThread_Analyse ;
}

//  complex trunc [complex]
TaskForThread bimcomplextrunc ( StackClusterPrivate  * const stclpp  ) {
  PLOComplex  * const res = NewComplexBareExc  (   )  ;
  Complex_Set ( PLOComplexToComplex( res),
    PLOComplexToComplexConst( ParaLispObjectToPLOComplex(
      StackClusterPrivate_ThisTop(stclpp ))) ) ;
  StackClusterPrivate_SetResult (stclpp ,&  res->plo ) ;
  { ParaLispObject  * x = StackClusterPrivate_ArgTop(stclpp ) ;
    if  ( CConsp (  x ) ) {
      x = ClassCons_First(&ParaLispObjectToPLOCons ( x )->cc ) ;
      if  ( IsNotNumber (  stclpp , x ) )
        goto  Exit  ;
      Complex_TruncDiv  ( PLOComplexToComplex( res),
        PLOComplexToComplexConst( ParaLispObjectToPLOComplex (  x )));
      goto  Exit  ; 
    }
  }
  Complex_Trunc ( PLOComplexToComplex( res) ) ;
Exit  :
  return  TaskForThread_Analyse ; 
}

//  complex ceil [complex]
TaskForThread bimcomplexceil ( StackClusterPrivate * const stclpp  ) {
  PLOComplex  * const  me2  = NewComplexBareExc  (   )  ;
  Complex_Set ( PLOComplexToComplex( me2) ,
    PLOComplexToComplexConst( ParaLispObjectToPLOComplex(
      StackClusterPrivate_ThisTop(stclpp ))) ) ;
  StackClusterPrivate_SetResult (stclpp ,&  me2->plo ) ;
  { ParaLispObject  * x = StackClusterPrivate_ArgTop(stclpp ) ;
    if  ( CConsp (  x ) ) {
      x = ClassCons_First(&ParaLispObjectToPLOCons ( x )->cc ) ;
      if  ( IsNotNumber (  stclpp , x ) )
        goto  Exit  ;
      Complex_CeilDiv  (  PLOComplexToComplex( me2),
        PLOComplexToComplexConst( ParaLispObjectToPLOComplex (  x )) ) ;
      goto  Exit  ; 
    } 
  }
  Complex_Ceil ( PLOComplexToComplex(  me2)) ;
Exit  :  
  return  TaskForThread_Analyse ; 
}

//  complex floor [complex]
TaskForThread bimcomplexfloor  ( StackClusterPrivate  * const stclpp  ) {
  PLOComplex  * const  me2  = NewComplexBareExc  (   )  ;
  Complex_Set ( PLOComplexToComplex( me2) ,
    PLOComplexToComplexConst( ParaLispObjectToPLOComplex(
      StackClusterPrivate_ThisTop(stclpp ))) ) ;
  StackClusterPrivate_SetResult (stclpp ,&  me2->plo ) ;
  { ParaLispObject  * x = StackClusterPrivate_ArgTop(stclpp ) ;
    if  ( CConsp (  x ) ) {
      x = ClassCons_First(&ParaLispObjectToPLOCons ( x )->cc ) ;
      if  ( IsNotNumber (  stclpp , x ) ) 
        goto  Exit  ;
      Complex_FloorDiv ( PLOComplexToComplex( me2),
        PLOComplexToComplexConst( ParaLispObjectToPLOComplex( x )) ) ;
      goto  Exit  ; 
    } 
  }
  Complex_Floor ( PLOComplexToComplex( me2)) ;
Exit  :  
  return  TaskForThread_Analyse ; 
}

// ! to optymise for 2 3 4 etc  ...  
// complex % [complex]
TaskForThread bimcomplexmod  ( StackClusterPrivate  * const stclpp  ) {
  { PLOComplex  * result  ;
    { ParaLispObject  const * const  arglistp  =
        StackClusterPrivate_ArgTop(stclpp ) ;
      if  ( CConsp ( arglistp ) ) {
        ParaLispObject * const dp  = ClassCons_First  (
          &ParaLispObjectToPLOConsConst ( arglistp )->cc  ) ;
        if  ( IsNotNumber (   stclpp , dp ) ) 
          goto  Exit  ;
        result  =   NewComplexBareExc  (   ) ;
        Complex_Set ( PLOComplexToComplex( result) , PLOComplexToComplexConst(
          ParaLispObjectToPLOComplexConst  (
          StackClusterPrivate_ThisTop ( stclpp ) ) ) ) ;
        Complex_ModEq ( PLOComplexToComplex( result),
          PLOComplexToComplexConst( ParaLispObjectToPLOComplexConst( dp )));
      } else  {
        result  =   NewComplexBareExc (   ) ;
        Complex_Set ( PLOComplexToComplex( result) , PLOComplexToComplexConst( 
          ParaLispObjectToPLOComplexConst( StackClusterPrivate_ThisTop(stclpp )))) ;
        Complex_Mod ( PLOComplexToComplex( result) ) ; 
      } 
    }
    StackClusterPrivate_SetResult (stclpp ,& result->plo  ) ; 
  }
Exit  :    
  return  TaskForThread_Analyse ; 
}

# include "consiter/public.h"
# include "stack/public.h"

//  complex gcd [{complex}]
TaskForThread bimcomplexgcd( StackClusterPrivate  * const stclpp ){
  ParaLispObject  const * const carap=StackClusterPrivate_ThisTop(stclpp );
  if(not  FractionIntegerP( Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst( carap))))){
    PLOComplex  * const  res= NewComplexBareExc ( );
    Complex_Set0  ( PLOComplexToComplex( res));  
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);
    return  TaskForThread_Analyse;
  } //  0
  if  ( ULongIs0  (  FractionCNump  ( Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst( carap)))))){
    PLOComplex  * const  res= NewComplexBareExc ( );
    Complex_Set0  ( PLOComplexToComplex( res));  
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);
    return  TaskForThread_Analyse;
  } //  0
  // stops only on 0
  ThreadStackPointerType const oldstack_d = Lisp2DThreadSP ( ) ;
  ULongPub * const d = StackNew_ULong ( ) ;
  ULong_ConstrCopy ( d , FractionCNump  ( Complex_CRe (
    PLOComplexToComplexConst  ( ParaLispObjectToPLOComplexConst ( carap ) ) ) ) ) ;
// !! TaskPause
  { ThreadStackPointerType const oldstack_c = Lisp2DThreadSP ( ) ; 
    CConsIteratorPub * const c = NewStackCConsIterator ( ) ;
    CConsIteratorInit ( c , StackClusterPrivate_ArgTop  ( stclpp  ) ) ;
    for( ;CConsIteratorHaveItem( c);CConsIteratorNext( c)){
      ParaLispObject  * const cadrap= CConsIteratorItem( c);
      if(IsNotNumber(  stclpp ,cadrap))     {
        Lisp2D_StackFree  ( oldstack_d ) ;
        return  TaskForThread_Analyse;
      }
      if(not  FractionIntegerP( Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex( cadrap))))){
        PLOComplex  * const  res= NewComplexBareExc ( );
        Complex_Set0  ( PLOComplexToComplex( res));
        StackClusterPrivate_SetResult(stclpp ,&  res->plo);
        Lisp2D_StackFree  ( oldstack_d ) ;
        return  TaskForThread_Analyse;
      } //  0
      if  ( ULongIs0  (  FractionCNump  (
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst( cadrap)))))){
        PLOComplex  * const  res= NewComplexBareExc ( );
        Complex_Set0  ( PLOComplexToComplex( res));
        StackClusterPrivate_SetResult(stclpp ,&  res->plo);
        Lisp2D_StackFree  ( oldstack_d ) ;
        return  TaskForThread_Analyse;
      } //  0
      // stops only on 0
      ULongGCD ( d , FractionCNump  (
        Complex_CRe ( PLOComplexToComplexConst  (
        ParaLispObjectToPLOComplexConst ( cadrap  ) ) ) ) ) ;
    } // for c
    Lisp2D_StackFree  ( oldstack_c ) ;
  } // cp_
  { PLOComplex  * const  res= NewComplexBareExc (  );
    Complex_MoveULong ( PLOComplexToComplex( res ) , d ) ;
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);   
  }
  Lisp2D_StackFree  ( oldstack_d ) ;
  return  TaskForThread_Analyse;
}

//  complex arcsin
TaskForThread bimcomplexarcsin( StackClusterPrivate * const stclpp ){
  // arcsin(x)=-i*ln(i*x+sqrt(1-x^2))
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  ximp= Complex_CIm(PLOComplexToComplexConst(xp));
  PLOComplex  * const  pres= NewComplexBareExc (  );
  if(FractionIs0(ximp)) 
    // x -> arcsin(x)
    Complex_SetExactFromLD  ( PLOComplexToComplex( pres) ,
      asinl(FractionLDValueConst ( Complex_CRe(
        PLOComplexToComplexConst(xp))))); 
  else 
    Complex_SetLDComplex(PLOComplexToComplex(pres),casinl(
        CMPLXL(FractionLDValueConst (
          Complex_CRe(PLOComplexToComplexConst(xp))),
          FractionLDValueConst (ximp))));
  StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
  return  TaskForThread_Analyse;
}

//  complex arccos
TaskForThread bimcomplexarccos( StackClusterPrivate * const stclpp ){
  // arccos(x)=-i*ln(x+sqrt(x^2-1))
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  xim= Complex_CIm(PLOComplexToComplexConst(xp));
  PLOComplex  * const pres =  NewComplexBareExc (  );
  if(FractionIs0(xim)){
    // x -> arccos(x)
    long  double  lx = FractionLDValueConst ( Complex_CRe(
      PLOComplexToComplexConst(xp)));
    lx  = acosl(lx);
    Complex_SetExactFromLD ( PLOComplexToComplex( pres),lx);  
  } else 
    Complex_SetLDComplex  ( PLOComplexToComplex ( pres  ) , cacosl  ( CMPLXL  (
      FractionLDValueConst ( Complex_CRe (  
      PLOComplexToComplexConst ( xp  )
      ) ) , FractionLDValueConst ( xim ) ) ) ) ;
  StackClusterPrivate_SetResult(stclpp ,&  pres->plo); 
  return  TaskForThread_Analyse; 
}

//  complex arctan
TaskForThread bimcomplexarctan( StackClusterPrivate * const stclpp ){
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  xim = Complex_CIm(PLOComplexToComplexConst(xp));
  PLOComplex  * const  pres = NewComplexBareExc (  );
  if  ( FractionIs0  ( xim) )
    // x -> arctan(x)
    Complex_SetExactFromLD  ( PLOComplexToComplex ( pres  ) , atanl (
      FractionLDValueConst ( Complex_CRe (
        PLOComplexToComplexConst ( xp  ) ) ) ) ) ; 
  else 
    Complex_SetLDComplex  ( PLOComplexToComplex ( pres  ) , catanl  ( CMPLXL  (
      FractionLDValueConst ( Complex_CRe ( 
      PLOComplexToComplexConst ( xp ) )
      ) , FractionLDValueConst (xim) ) ) ) ;
  StackClusterPrivate_SetResult ( stclpp ,  &  pres ->  plo ) ;
  return  TaskForThread_Analyse; 
}

//  complex cos [eps]
TaskForThread bimcomplexcos( StackClusterPrivate  * const stclpp ){
  // cos(x+iy)=cos(x)*cosh(y)-i*sin(x)*sinh(y)
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  xim= Complex_CIm(PLOComplexToComplexConst(xp));
  PLOComplex  * const  pres= NewComplexBareExc ( );
  if(FractionIs0(xim)){
    // x -> cos(x)
    PLOComplex_Set (  pres ,  xp ) ;
    ParaLispObject  const * const  e = CCAR (
        StackClusterPrivate_ArgTop ( stclpp ) ) ;
    if  ( ( not  Numberp  (  e  ) ) or
      ULongIs0  (
        FractionCNump (
          Complex_CRe ( PLOComplexToComplexConst(
            ParaLispObjectToPLOComplexConst (  e )) ) ) ) or
      ULongIs0  (
        FractionCDenomp (
          Complex_CRe ( PLOComplexToComplexConst(
            ParaLispObjectToPLOComplexConst (  e ) ) ) ) ) ) {
      ThreadStackPointerType const oldstack_rp = Lisp2DThreadSP ( ) ;
      // ; (2 ^ -64) = 5.421e-20
      FractionPub * const f64p =NewStackFraction ( ) ;
      FractionPub * const d64p = NewStackFraction ( ) ;
      FractionConstrUInt ( f64p , 2U )  ;  
      FractionConstrUInt ( d64p , 64U )  ;
      FractionPower ( f64p , d64p ) ;
      FractionOverTurn  ( f64p) ;
      Fraction_Cos_Eps  ( Complex_Re ( PLOComplexToComplex(pres)) , f64p ) ;
      Lisp2D_StackFree  ( oldstack_rp ) ;
    } else
      Fraction_Cos_Eps  ( Complex_Re ( PLOComplexToComplex(pres) ) ,
        Complex_CRe ( PLOComplexToComplexConst(
          ParaLispObjectToPLOComplexConst (  e ) ) ) ) ;
  } else 
    
// ! not round eps => to round
    
    Complex_SetLDComplex  ( PLOComplexToComplex ( pres  ) , ccosl ( CMPLXL  (
      FractionLDValueConst ( Complex_CRe ( 
      PLOComplexToComplexConst ( xp ) )
      ) , FractionLDValueConst ( xim ) ) ) ) ; 
  StackClusterPrivate_SetResult(stclpp ,&  pres->plo);      
  return  TaskForThread_Analyse; 
}

//  complex sin [ eps ]
TaskForThread bimcomplexsin( StackClusterPrivate  * const stclpp ){
  // sin(x+iy)=sin(x)*cosh(y)+i*cos(x)*sinh(y)
  PLOComplex  const * const  xp =ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  xim= Complex_CIm(PLOComplexToComplexConst(xp));
  PLOComplex  * const  pres= NewComplexBareExc (  );
  if(FractionIs0(xim)){
    // x -> sin(x)
    PLOComplex_Set ( pres ,  xp ) ;
    ParaLispObject  const * const  e = CCAR (
        StackClusterPrivate_ArgTop ( stclpp ) ) ;
    ThreadStackPointerType const oldstack_rp = Lisp2DThreadSP ( ) ;
    FractionPub * const sinresp = NewStackFraction ( ) ;
    FractionInit ( sinresp ) ;
    if  ( ( not  Numberp  (  e  ) ) or
      ULongIs0  (
        FractionCNump (
          Complex_CRe ( PLOComplexToComplexConst(
            ParaLispObjectToPLOComplexConst ( e )) ) ) ) or
      ULongIs0  (
        FractionCDenomp (
          Complex_CRe ( PLOComplexToComplexConst(
            ParaLispObjectToPLOComplexConst ( e )) ) ) ) ) {
      // ; (2 ^ -64) = 5.421e-20
      FractionPub * const f64p = NewStackFraction ( ) ;
      FractionPub * const d64p = NewStackFraction ( ) ;
      FractionConstrUInt ( f64p , 2U )  ;  
      FractionConstrUInt ( d64p , 64U )  ;
      FractionPower ( f64p , d64p ) ;
      FractionOverTurn  ( f64p) ;
      Fraction_CosSin_Eps  ( Complex_Re (
        PLOComplexToComplex(pres) ) , sinresp , f64p ) ;        
    } else
      Fraction_CosSin_Eps  ( Complex_Re (
        PLOComplexToComplex(pres) ) , sinresp ,
        Complex_CRe ( PLOComplexToComplexConst(
          ParaLispObjectToPLOComplexConst (  e )) ) ) ;
    Complex_SwapFraction  ( PLOComplexToComplex ( pres) , sinresp ) ;  
    Lisp2D_StackFree  ( oldstack_rp ) ;
    // !! quality of argument loosed
  } else
    Complex_SetLDComplex  ( PLOComplexToComplex ( pres  ) , csinl ( CMPLXL  (
      FractionLDValueConst ( Complex_CRe ( 
      PLOComplexToComplexConst  ( xp  )
      ) ) , FractionLDValueConst ( xim ) ) ) ) ;
  StackClusterPrivate_SetResult(stclpp ,&  pres->plo);  
  return   TaskForThread_Analyse ;
}

//  complex tan
// !! to use good functions SIN & COS
TaskForThread bimcomplextg( StackClusterPrivate * const stclpp ){
  PLOComplex  const * const xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  xim= Complex_CIm(PLOComplexToComplexConst(xp));
  PLOComplex  * const  pres= NewComplexBareExc (  );
  if(FractionIs0(xim)){
    // x -> tg(x)
    Complex_SetExactFromLD  ( PLOComplexToComplex ( pres  ) , tanl  (
      FractionLDValueConst (  Complex_CRe (
        PLOComplexToComplexConst ( xp  ) ) ) ) ) ; 
  } else {
    Complex_SetLDComplex  ( PLOComplexToComplex ( pres  ) , ctanl ( CMPLXL  (
      FractionLDValueConst ( Complex_CRe ( PLOComplexToComplexConst
          ( xp  ) ) ) , FractionLDValueConst ( xim ) ) ) ) ; 
  }
  StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
  return  TaskForThread_Analyse; 
}

# include "define.h"
# include "inner-history/inline.h"

//  complex sinh
// !! to use good function Exp(negative)
TaskForThread bimcomplexsinh( StackClusterPrivate * const stclpp ){
# ifdef  LISP2D_INNERHISTORY
  static  wchar_t  const  bimcomplexsinh  [ ] = 
    L"void  Lisp2Dbimcomplexsinh( StackClusterPrivate *  stclp )" ;
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , bimcomplexsinh  ) ;
# endif
  // sinh(x)=(e^x-e^-x)/2=(1/(e^-x)-e^-x)/2
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex( StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  xre= Complex_CRe(PLOComplexToComplexConst(xp));
  FractionPub  const * const  xim= Complex_CIm(PLOComplexToComplexConst(xp));
# ifdef  LISP2D_INNERHISTORY
  static  wchar_t  const bimcomplexsinh3 [ ] = 
    L"void  Lisp2Dbimcomplexsinh( StackClusterPrivate *  stclp ):Return" ;
# endif  
  if(FractionIs0(xim)){
    // x -> sinh(x)+0i
# ifdef  LISP2D_INNERHISTORY    
    static  wchar_t  const bimcomplexsinh4 [ ] = 
      L"void  Lisp2Dbimcomplexsinh( StackClusterPrivate *  stclp ):"
      L"RealLongDoubleReady" ;
    Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , bimcomplexsinh4  ) ;
# endif
    { PLOComplex  * const pres =  NewComplexBareExc (  );
      Complex_SetExactFromLD  ( PLOComplexToComplex ( pres  ) , sinhl (
        FractionLDValueConst ( xre ) ) ) ;
      StackClusterPrivate_SetResult(stclpp ,&  pres->plo);          
    }
# ifdef  LISP2D_INNERHISTORY
    Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , bimcomplexsinh3  ) ;
# endif  
    return  TaskForThread_Analyse; 
  }
  if(FractionIs0(xre)) {
    // sinh(iy) -> i*sin(y)
    PLOComplex  * const  res= NewComplexBareExc (  );
    FractionSetUInt ( Complex_Re  (PLOComplexToComplex(res) ) , 0 ) ;
    FractionSetExactLDouble ( Complex_Im  (
      PLOComplexToComplex(
      res) ) , sinl ( FractionLDValueConst (xim) ) ) ;
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);
    return  TaskForThread_Analyse; 
  }
  _Complex long double cx  = csinhl ( CMPLXL  ( FractionLDValueConst (
    xre ) , FractionLDValueConst ( xim ) ) ) ;
# ifdef  LISP2D_INNERHISTORY
  static  wchar_t  const  bimcomplexsinh2  [ ] = 
    L"void  Lisp2Dbimcomplexsinh( StackClusterPrivate *  stclp ):"
    L"cx  = csinhl(cx);OK" ;
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , bimcomplexsinh2  ) ;
# endif
  { PLOComplex  * const  res= NewComplexBareExc (  );
    Complex_SetLDComplex ( PLOComplexToComplex(res),cx);
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);        
  }
# ifdef  LISP2D_INNERHISTORY
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , bimcomplexsinh3  ) ;
# endif  
  return  TaskForThread_Analyse; 
}

//  complex cosh
// !! to use good function Exp(negative)
TaskForThread bimcomplexcosh( StackClusterPrivate * const stclpp ){
  // cosh(x)=(e^x+e^-x)/2=(1/(e^-x)+e^-x)/2
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  xre= Complex_CRe(PLOComplexToComplexConst(xp));
  FractionPub  const * const  xim= 
    Complex_CIm(PLOComplexToComplexConst(xp));
  PLOComplex  * const pres =  NewComplexBareExc (  );
  StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
  if(FractionIs0(xim)){
    // x -> cosh(x)+0i
    long  double  lx = FractionLDValueConst (xre);
    lx  = coshl(lx);
    Complex_SetExactFromLD  ( PLOComplexToComplex( pres),lx); 
  } else
  if(FractionIs0(xre)) {
    // cosh(iy) -> cos(y)
    long  double  lx = FractionLDValueConst (xim);
    lx  = cosl(lx);
    Complex_SetExactFromLD  ( PLOComplexToComplex( pres),lx); 
  } else  {
    long  double const lx = FractionLDValueConst (xre);
    long  double const ly = FractionLDValueConst (xim);  
    Complex_SetLDComplex(PLOComplexToComplex(pres),ccoshl(CMPLXL(lx,ly)));  
  }
  return  TaskForThread_Analyse; 
}

//  complex arsinh
TaskForThread bimcomplexarsinh( StackClusterPrivate * const stclpp ){
  // arsinh(x)=ln(x+sqrt(x^2+1))
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop( stclpp ));
  PLOComplex  * const  res= NewComplexBareExc (  );  
  Complex_SetLDComplex  ( PLOComplexToComplex ( res ) , casinhl ( CMPLXL  (
        FractionLDValueConst ( Complex_CRe (
            PLOComplexToComplexConst  ( xp  ) ) ) ,
        FractionLDValueConst (
          Complex_CIm ( PLOComplexToComplexConst  ( xp  ) ) ) ) ) ) ;
  StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  return  TaskForThread_Analyse; 
}

//  complex arcosh
TaskForThread bimcomplexarcosh( StackClusterPrivate * const stclpp ){
  // arcosh(x)=ln(x+sqrt(x^2-1))
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(      stclpp ));
  PLOComplex  * const  res= NewComplexBareExc (  );
  Complex_SetLDComplex  ( PLOComplexToComplex ( res ) , cacoshl ( CMPLXL  (
        FractionLDValueConst ( Complex_CRe (
            PLOComplexToComplexConst  ( xp  ) ) ) ,
        FractionLDValueConst (
          Complex_CIm ( PLOComplexToComplexConst  ( xp  ) ) ) ) ) ) ;
  StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  return  TaskForThread_Analyse; 
}

//  complex tanh
TaskForThread bimcomplextanh( StackClusterPrivate * const stclpp ){
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  xim= Complex_CIm(PLOComplexToComplexConst(xp));
  PLOComplex  * const pres =  NewComplexBareExc (  );
  if(FractionIs0(xim)) {
    // x -> tanh(x)
    Complex_SetExactFromLD  ( PLOComplexToComplex ( pres  ) , tanhl (
      FractionLDValueConst ( Complex_CRe (
        PLOComplexToComplexConst ( xp  ) ) ) ) ) ; 
  } else {
    Complex_SetLDComplex  ( PLOComplexToComplex ( pres  ) , ctanhl  ( CMPLXL  (
      FractionLDValueConst ( Complex_CRe (
        PLOComplexToComplexConst
          ( xp ) ) ) , FractionLDValueConst ( Complex_CIm (
              PLOComplexToComplexConst  ( xp  ) ) ) ) ) ) ; 
  }
  StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
  return  TaskForThread_Analyse; 
}

# define  ldoub_cast_ldoubcomplex Lisp2D_ldoub_cast_ldoubcomplex
inline  long double _Complex ldoub_cast_ldoubcomplex ( long double d ) ;

//  complex coth
// coth(x)=1/tanh(x)
TaskForThread bimcomplexcoth( StackClusterPrivate * const stclpp ){
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  xim= Complex_CIm(PLOComplexToComplexConst(xp));
  PLOComplex  * const  pres= NewComplexBareExc ( );
  StackClusterPrivate_SetResult(stclpp ,&  pres->plo);    
  if(FractionIs0(xim)) {
    ThreadStackPointerType const oldstack_resp = Lisp2DThreadSP ( ) ;
    FractionPub * const res = NewStackFraction ( ) ;
    FractionConstrZero ( res);
    FractionSetExactLDouble ( res , tanhl  (
      FractionLDValueConst (
      Complex_CRe ( PLOComplexToComplexConst(xp))) ) ) ;
    FractionOverTurn  ( res );
    Complex_SwapFraction  ( PLOComplexToComplex ( pres  ) , res ) ;
    Lisp2D_StackFree  ( oldstack_resp ) ;
    return  TaskForThread_Analyse ;
  }
  Complex_SetLDComplex  ( PLOComplexToComplex ( pres  ) ,
    ( ldoub_cast_ldoubcomplex (  1.0L  ) ) /
    ctanhl  ( CMPLXL  ( FractionLDValueConst ( Complex_CRe (
            PLOComplexToComplexConst  ( xp  ) ) ) ,
      FractionLDValueConst ( xim ) ) ) ) ;
  return  TaskForThread_Analyse; 
}

//  complex cot
// cot(x)=1/tan(x)
TaskForThread bimcomplexcot( StackClusterPrivate  * const stclpp ){
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  FractionPub  const * const  xim= Complex_CIm(PLOComplexToComplexConst(xp));
  PLOComplex  * const  pres= NewComplexBareExc ( );
  StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
  if(FractionIs0(xim)) {
    ThreadStackPointerType const oldstack_resp = Lisp2DThreadSP ( ) ;
    FractionPub * const res = NewStackFraction ( ) ;
    FractionConstrZero  (res);
    FractionSetExactLDouble ( res , tanl (
      FractionLDValueConst (
      Complex_CRe ( PLOComplexToComplexConst(xp))) ) ) ;
    FractionOverTurn  (res);
    Complex_SwapFraction  ( PLOComplexToComplex ( pres  ) , res ) ;
    Lisp2D_StackFree  ( oldstack_resp ) ;
    return  TaskForThread_Analyse ;
  }
  Complex_SetLDComplex (PLOComplexToComplex(pres),
    ldoub_cast_ldoubcomplex (  1.0L  ) /
      ctanl(CMPLXL(FractionLDValueConst ( Complex_CRe(
    PLOComplexToComplexConst(xp))),FractionLDValueConst ( xim))));
  return  TaskForThread_Analyse; 
}

//  complex artanh
TaskForThread bimcomplexartanh( StackClusterPrivate * const stclpp ) {
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  PLOComplex  * const  res= NewComplexBareExc (  );
  Complex_SetLDComplex(PLOComplexToComplex(res),catanhl(CMPLXL(
    FractionLDValueConst ( Complex_CRe(
    PLOComplexToComplexConst(xp))),FractionLDValueConst (
    Complex_CIm( PLOComplexToComplexConst(xp))))));
  StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  return  TaskForThread_Analyse; 
}

//  complex exp
TaskForThread bimcomplexexp( StackClusterPrivate  * const stclpp ){
  PLOComplex  const * const  xp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop( stclpp ));
  PLOComplex  * const  resp= NewComplexBareExc ( );
  StackClusterPrivate_SetResult(stclpp ,&  resp->plo);
  if(Complex_isReal(PLOComplexToComplexConst(xp))) {
    Complex_Set0  ( PLOComplexToComplex( resp));
    FractionExp( Complex_CRe(PLOComplexToComplexConst(xp)),
      Complex_Re(PLOComplexToComplex(resp))); 
  } else {
    Complex_SetLDComplex  ( PLOComplexToComplex ( resp ) , cexpl ( CMPLXL  (
      FractionLDValueConst ( Complex_CRe(
      PLOComplexToComplexConst(xp))),FractionLDValueConst (
      Complex_CIm( PLOComplexToComplexConst(xp)))))); 
  }
  return   TaskForThread_Analyse ; 
}

//  complex cbrt [ ep ]
TaskForThread bimcomplexcbrt ( StackClusterPrivate * const stclpp  ) {
  { PLOComplex  * const pres  = NewComplexBareExc  (   )  ;
    Complex_Set ( PLOComplexToComplex( pres) , PLOComplexToComplexConst(
      ParaLispObjectToPLOComplex( StackClusterPrivate_ThisTop(stclpp ))) ) ;
    ParaLispObject  const * const  e= CCAR ( StackClusterPrivate_ArgTop ( stclpp ) )  ;
    if  ( not  Numberp  (  e  ) ) {
      ThreadStackPointerType const oldstack_rp = Lisp2DThreadSP ( ) ;
      // ; (2 ^ -64) = 5.421e-20
      FractionPub * const f64p = NewStackFraction  ( ) ;
      FractionPub * const d64p = NewStackFraction  ( ) ;
      FractionConstrUInt ( f64p , 2U )  ;  
      FractionConstrUInt ( d64p , 64U )  ;
      FractionPower ( f64p , d64p ) ;
      FractionOverTurn  ( f64p) ;
      Complex_Cbrt  ( PLOComplexToComplex( pres) , f64p ) ;
      Lisp2D_StackFree  ( oldstack_rp ) ;
    } else 
      Complex_Cbrt  ( PLOComplexToComplex( pres) , Complex_CRe (
          PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst (  e )) ) ) ;
    StackClusterPrivate_SetResult ( stclpp ,  &  pres ->  plo ) ; 
  }
  return  TaskForThread_Analyse ; 
}

# include "bimc.h" // plobimnilprogn

// complex-real-natural for i {body}
// i has const link
TaskForThread bimcomplexfor( StackClusterPrivate  * const stclpp ){
  PLOComplex  * j4;
  ParaLispObject  * varB;
  ParaLispObject  * varD2;
  { unsigned int const c  = StackClusterPrivate_ClearflagCont (
      stclpp )  ;
  if  ( c ) {
    switch ( c ) {
    case  1:
      StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
      return  TaskForThread_Analyse;
    default :
      varD2=StackClusterPrivate_PopValue(stclpp );
      j4  = ParaLispObjectToPLOComplex(StackClusterPrivate_PopValue(stclpp ));
      varB=StackClusterPrivate_PopValue(stclpp );
      if( StackClusterPrivate_exceptionnotprocessed  ( stclpp )){        
        StackClusterPrivate_setTaskForManager (
          stclpp , TaskWaitSonsAlmost ) ;
        StackClusterPrivate_SetflagCont (  stclpp , 1U  ) ;
        return  TaskForThread_Analyse;
      }
      goto  TaskNext;
      }
    }
  }
  varB  = StackClusterPrivate_ArgTop(stclpp );
  varD2 = CCAR(  varB);
  if(IsNotSymbol(  stclpp ,  varD2)) 
    return  TaskForThread_Analyse;
  { PLOComplex  const * const  me2p=
      ParaLispObjectToPLOComplex(StackClusterPrivate_ThisTop(stclpp ));
    if( ULongIs0(FractionCDenomp(
      Complex_CRe(PLOComplexToComplexConst(me2p))))) {
      StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
      return  TaskForThread_Analyse; 
    }
    j4  = NewComplexBareExc ( );
    Complex_Set ( PLOComplexToComplex( j4), PLOComplexToComplexConst( me2p)); 
  }
  Complex_Floor ( PLOComplexToComplex( j4));
  if(FractionMoreUInt( Complex_CRe(
    PLOComplexToComplexConst(j4)),0U)){
    FractionSub1  ( Complex_Re(PLOComplexToComplex(j4)));
    varB  = CCDR( varB);
    if(CConsp(CCDR(  varB))) {
      varB  = &  NewCons(  & plobimnilprogn->base.plo ,  varB)->plo; 
      varB  = &  NewCons(& plonil.plo , varB)->plo; 
    } else 
      varB  = CCAR( varB);
TaskNext:
// !! 1000000 for i (locks progn (s += i))
//    1000000 tasks: wait locks -> MEMORY VERY BIG for tasks
//    create 4 tasks & wait
//    create 4 tasks & wait
//    tasks number is (4 * task-complexity) < 1000000
    { unsigned int tasks = maxTasksCreate ;
    for(;(tasks  > 0) and (FractionMoreEqUInt( Complex_CRe(
          PLOComplexToComplexConst(j4)),0U));
        FractionSub1( Complex_Re(PLOComplexToComplex(j4)))
        ,-- tasks ) {
      StackClusterPrivate  * const dopstclp =
        StackClusterPrivate_NewStCl4(stclpp );
      StackClusterPrivate_EnvNewLevel2(dopstclp);
      ParaLispObject  * const envlp=CCAR(StackClusterPrivate_Env(dopstclp));
      if(IsNotEnvironmentLayer(   stclpp ,envlp)){
        StackClusterPrivate_EnvCDR(dopstclp);
        goto  Out;
      }
      PLOComplex  * const j4c =  NewComplexBareExc ( );
      Complex_Set ( PLOComplexToComplex( j4c), PLOComplexToComplexConst( j4));
      if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (
            envlp  ) -> envlay , varD2 , & j4c ->  plo ,false  ) ) {
        HasConstLink(  stclpp ,  varD2);
        return  TaskForThread_Analyse; 
      }
      StackClusterPrivate_CreateTask(dopstclp , varB); 
      } // for tasks
    } // tasks
    if(FractionMoreEqUInt( Complex_CRe(
      PLOComplexToComplexConst(j4)),0U)){
      StackClusterPrivate_setTaskForManager (
        stclpp , TaskPause ) ;
      StackClusterPrivate_SetflagCont (  stclpp , 2U  ) ;
      StackClusterPrivate_Push(stclpp , varB);
      StackClusterPrivate_Push(stclpp ,& j4->plo);
      StackClusterPrivate_Push(stclpp , varD2); 
    // j>=0
    } else { // j<0
Out:
      StackClusterPrivate_setTaskForManager (
        stclpp , TaskWaitSonsAlmost ) ;
      StackClusterPrivate_SetflagCont ( stclpp , 1U  ) ; 
    } // j<0
    return  TaskForThread_Analyse; 
  }  // j>0
  StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
  return  TaskForThread_Analyse; 
}

// ! argument [eps] -> required
//  complex log [complex]
TaskForThread bimcomplexlog( StackClusterPrivate  * const stclpp ){
  { PLOComplex const * const xp=ParaLispObjectToPLOComplexConst(
      StackClusterPrivate_ThisTop(stclpp ));
    ParaLispObject  const * const  yp=CCAR(StackClusterPrivate_ArgTop(
      stclpp ));
    long double _Complex cx = CMPLXL(FractionLDValueConst (
      Complex_CRe(PLOComplexToComplexConst(xp))
      ),FractionLDValueConst (
      Complex_CIm(PLOComplexToComplexConst(xp))));
    if(not  Numberp(yp)) {
      cx  = clogl(cx);
      PLOComplex  * const  res= NewComplexBareExc (  );
      Complex_SetLDComplex(PLOComplexToComplex(res),cx);
      StackClusterPrivate_SetResult(stclpp ,&  res->plo);
      return   TaskForThread_Analyse ; 
    }
    cx  = clogl ( cx  ) / clogl ( CMPLXL  ( FractionLDValueConst (
       Complex_CRe  ( PLOComplexToComplexConst  ( 
     ParaLispObjectToPLOComplexConst (
       yp  ) ) ) ) , FractionLDValueConst (
      Complex_CIm(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(yp)
      ))))); 
    PLOComplex  * const  res= NewComplexBareExc (  );
    Complex_SetLDComplex(PLOComplexToComplex(res),cx);
    StackClusterPrivate_SetResult(stclpp ,&  res->plo); 
  } // xp
  return   TaskForThread_Analyse ; 
}

/*
if x < 0 
  ln ( - x ) := ln ( x ) + ⅈ * ( ℼ ± 2ℼ )
*/  
  
//  complex ln [eps]
TaskForThread bimcomplexln  ( StackClusterPrivate * const stclpp )  {
  PLOComplex const * const tthis = ParaLispObjectToPLOComplexConst(
      StackClusterPrivate_ThisTop(stclpp ));
  PLOComplex  * const  me =  NewComplexBareExc ( ) ;
  Complex_Set ( PLOComplexToComplex( me), PLOComplexToComplexConst( tthis) ) ;
  ParaLispObject  const * const eps = CCAR(StackClusterPrivate_ArgTop(
    stclpp )) ;  
  if(not Numberp(eps)) {
    ThreadStackPointerType const oldstack_rp = Lisp2DThreadSP ( ) ;
    // ; (2 ^ -64) = 5.421e-20
    FractionPub * const f64p = NewStackFraction  ( ) ;
    FractionPub * const d64p = NewStackFraction  ( ) ;
    FractionConstrUInt ( f64p , 2U )  ;  
    FractionConstrUInt ( d64p , 64U )  ;
    FractionPower ( f64p , d64p ) ;
    FractionOverTurn  ( f64p) ;
    if  ( FractionIs0  (  Complex_CIm ( PLOComplexToComplexConst  (  me  ) ) ) ) {
      bool  const was_negative  = FractionIsNegative(Complex_CRe (
        PLOComplexToComplexConst(me) ) ) and
        ( not FractionIs0  (  Complex_CRe ( PLOComplexToComplexConst( me) ) ) ) ;
      Fraction_Ln_Eps ( Complex_Re (PLOComplexToComplex(me) ) , f64p ) ;
      if ( was_negative ) 
        FractionSetFraction ( Complex_Im ( PLOComplexToComplex (
          me  ) ) , FractionploConstPiPub ) ;
    } else
      Complex_Ln  ( PLOComplexToComplexConst( tthis) , PLOComplexToComplex( me)  ) ;
    Lisp2D_StackFree  ( oldstack_rp ) ;
  } else {
    if  ( FractionIs0  (  Complex_CIm ( PLOComplexToComplexConst(me) ) ) ) {
      bool  const was_negative  = FractionIsNegative( Complex_CRe (
        PLOComplexToComplexConst(me) ) ) and
        ( not FractionIs0  (  Complex_CRe (
          PLOComplexToComplexConst( me) ) ) ) ;
      Fraction_Ln_Eps ( Complex_Re (PLOComplexToComplex(me) ) ,
         Complex_CRe (PLOComplexToComplexConst(
           ParaLispObjectToPLOComplexConst ( eps )) ) ) ;
      if ( was_negative ) 
        FractionSetFraction ( Complex_Im ( PLOComplexToComplex (
          me  ) ) , FractionploConstPiPub ) ;
      } else
        Complex_Ln  ( PLOComplexToComplexConst( tthis) ,
          PLOComplexToComplex( me)  ) ;
  }
  StackClusterPrivate_SetResult ( stclpp ,  & me ->  plo ) ;
  return   TaskForThread_Analyse ; 
}

// complex for* symbol {body}
// symbol has const link
TaskForThread bimcomplexforcons ( StackClusterPrivate  * const stclpp ) {
  ParaLispObject  * varC  ;
  PLOComplex  * vari2 ;
  PLOComplex  * const me3p = ParaLispObjectToPLOComplex  (
    StackClusterPrivate_ThisTop ( stclpp ) ) ;
  ParaLispObject  * const varD2p  = CCAR  ( StackClusterPrivate_ArgTop  (
      stclpp ) ) ;
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) )
    goto  Next  ;
  if  ( IsNotSymbol ( stclpp ,  varD2p  ) )
    return  TaskForThread_Analyse ;
  if  ( FractionLessEqUInt ( Complex_CRe (
    PLOComplexToComplexConst  ( me3p  ) ) , 0U  ) ) {
    StackClusterPrivate_SetResult ( stclpp ,  & plonil  . plo ) ;
    return  TaskForThread_Analyse ; 
  }
  vari2 = NewComplexBareExc ( ) ;
  Complex_Set0  ( PLOComplexToComplex ( vari2 ) ) ;  
  StackClusterPrivate_EnvNewLevel2  ( stclpp )  ;
  do {
    if  ( IsNotEnvironmentLayer ( stclpp ,  CCAR  ( StackClusterPrivate_Env (
            stclpp ) ) ) ) {
      StackClusterPrivate_EnvCDR  ( stclpp  ) ;
      return  TaskForThread_Analyse ; }
    { PLOComplex  * const  vari2c  = NewComplexBareExc ( ) ;
      Complex_Set ( PLOComplexToComplex ( vari2c  ) , PLOComplexToComplexConst
        ( vari2 ) ) ;
      if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (
            CCAR (  StackClusterPrivate_Env ( stclpp ) ) ) -> envlay , varD2p ,
          & vari2c  ->  plo , false ) ) {
        HasConstLink  ( stclpp , varD2p ) ;
        StackClusterPrivate_EnvCDR  ( stclpp  ) ;
        return  TaskForThread_Analyse ; 
      }
    }
    StackClusterPrivate_Push  ( stclpp ,  & vari2 ->  plo ) ;
    varC  = CCDR  ( StackClusterPrivate_ArgTop  ( stclpp ) ) ;
    while ( CConsp ( varC  ) ) {
      StackClusterPrivate_Push (  stclpp , varC  ) ;
      StackClusterPrivate_Push  ( stclpp , ClassCons_First ( &
          ParaLispObjectToPLOCons ( varC  ) ->  cc  ) ) ;
      StackClusterPrivate_SetflagCont ( stclpp , 1U  ) ;
      return  TaskForThread_Analyse ;
Next  :
      varC  = StackClusterPrivate_PopValue  ( stclpp )  ;
      if  ( StackClusterPrivate_exceptionnotprocessed  ( stclpp ) ) {
        StackClusterPrivate_Popn  ( stclpp ) ; // vari2
        StackClusterPrivate_EnvCDR  ( stclpp ) ;
        return  TaskForThread_Analyse ; 
      }
# ifdef LISP2D_DEBUG
      if  ( not CConsp ( varC  ) )  {
        Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) &
          L"number::for* : not CConsp ( varC  )" ;
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; 
      }
# endif
      varC  = ClassCons_Rest  ( & ParaLispObjectToPLOCons ( varC  ) ->  cc ) ;
    } // while consp varC
    vari2 = ParaLispObjectToPLOComplex  ( StackClusterPrivate_PopValue  ( stclpp ) ) ;
    FractionAdd1 (  Complex_Re  ( PLOComplexToComplex ( vari2 ) ) ) ;
  } while ( FractionLess ( Complex_CRe ( PLOComplexToComplexConst  ( vari2 ) ) ,
      Complex_CRe ( PLOComplexToComplexConst  ( me3p  ) ) ) == Lisp2DBoolTrue  ) ;
  //old environment restoring
  StackClusterPrivate_EnvCDR  ( stclpp )  ;
  return  TaskForThread_Analyse ; 
}

# include "string/public.h"

//  complex string [integer]
TaskForThread bimcomplexstring  ( StackClusterPrivate * const stclpp )  {
  PLOStringPub  * const strp = PLOString_New ( ) ;
  ParaLispObject  * const arg1p = CCAR  ( StackClusterPrivate_ArgTop  ( stclpp )  ) ;
  { ThreadStackPointerType const oldstack_ws = Lisp2DThreadSP ( ) ; 
    String ( WideChar ) * const wsp = StackNew_StringWideChar ( ) ;
    String_Init ( WideChar ) ( wsp , true ) ;
    if  ( Numberp ( arg1p ) ) {
      Complex_ToStringForHuman  ( PLOComplexToComplexConst  (
          ParaLispObjectToPLOComplexConst ( StackClusterPrivate_ThisTop ( stclpp ) )  ) , wsp ,
        ( FractionMoreUInt  ( Complex_CRe ( PLOComplexToComplexConst  (
             ParaLispObjectToPLOComplexConst  ( arg1p ) ) ) , 0U  ) ?
          FractionUIValue ( Complex_CRe ( PLOComplexToComplexConst  (
                 ParaLispObjectToPLOComplexConst  ( arg1p ) ) ) ) :
           Complex_CoutDefaultDepth  )  ) ;
    } else
      // exact with fraction style
      Complex_ToStringForInterpret  ( PLOComplexToComplexConst  (
        ParaLispObjectToPLOComplexConst ( StackClusterPrivate_ThisTop ( stclpp )  ) ) , wsp , 0U  ) ;
    StringAddString ( WideChar )  ( PLOString_Value2 ( strp ) , wsp ) ;
    Lisp2D_StackFree  ( oldstack_ws ) ;
  }
  StackClusterPrivate_SetResult ( stclpp ,  &  strp  -> plo ) ;
  return  TaskForThread_Analyse ;
}

// complex round [complex] -> complex +- (complex OR 1/2+1/2i)
TaskForThread bimcomplexround ( StackClusterPrivate  * const stclpp ) {
  PLOComplex  * const mep = ParaLispObjectToPLOComplex  ( StackClusterPrivate_ThisTop ( stclpp  ) ) ;
  ParaLispObject  * const qp=CCAR(StackClusterPrivate_ArgTop(stclpp ));
  PLOComplex  * const  ret2  = NewComplexBareExc ( );
  Complex_Set ( PLOComplexToComplex( ret2), PLOComplexToComplexConst( mep));
  StackClusterPrivate_SetResult(stclpp ,&  ret2->plo);
  if(not Numberp(qp)) {
    ThreadStackPointerType const oldstack_halfp = Lisp2DThreadSP ( ) ;
    FractionPub * const half = NewStackFraction ( ) ;
    FractionInit ( half ) ;
    FractionSetUIntUInt ( half , 1U  , 2U  ) ;
    FractionRoundStaticMethod (
      Complex_Re  ( PLOComplexToComplex ( ret2  ) ) , half  ) ;
    FractionRoundStaticMethod (
      Complex_Im  ( PLOComplexToComplex ( ret2  ) ) , half  ) ;
    Lisp2D_StackFree  ( oldstack_halfp ) ;
    return  TaskForThread_Analyse ;
  }
  FractionRoundStaticMethod ( Complex_Re  (
    PLOComplexToComplex ( ret2  ) ) ,
     Complex_CRe  ( PLOComplexToComplexConst  (
       ParaLispObjectToPLOComplexConst  ( qp  ) ) ) ) ;
  if ( FractionIs0 ( Complex_CIm ( PLOComplexToComplexConst  (
    ParaLispObjectToPLOComplexConst  ( qp  ) ) ) ) )
    // x round Real => x round Real+i*Real
    FractionRoundStaticMethod ( Complex_Im  ( PLOComplexToComplex ( ret2  ) ) ,
      Complex_CRe ( PLOComplexToComplexConst  (
       ParaLispObjectToPLOComplexConst  ( qp  ) ) ) ) ;
  else
    // x round Re+i*Im
    FractionRoundStaticMethod ( Complex_Im  ( PLOComplexToComplex ( ret2  ) ) ,
      Complex_CIm ( PLOComplexToComplexConst  (
        ParaLispObjectToPLOComplexConst ( qp  ) ) ) ) ;
  return  TaskForThread_Analyse ;
}

// complex integerp
TaskForThread bimcomplexintegerp( StackClusterPrivate * const  stclpp ) {
  PLOComplex  * const mep=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,Complex_Integerp(
    PLOComplexToComplexConst(mep)) ?
      & mep->plo  :
      & plofalse.plo );
  return  TaskForThread_Analyse; 
}

// !x=x * !(x-1)
// Factorial !(x+iy)=Gamma(x+iy+1)
// Gamma(z)=Integral(t^(z-1)*exp(-t),t=0..inf)
// !c=Integral((t^c)*exp(-t),t=0..inf)
// !(-n-1/2)=sqrt(pi)*!n*((-4)^n)/!(2n)
// !(-1.5)=-sqrt(pi)*2
// !(-0.5)=sqrt(pi)
// !(0.5)=sqrt(pi)/2
// !(1.5)=sqrt(pi)*3/4
// !(n-1/2)=sqrt(pi)*!(2n)/!n/(4^n)
// x!≈sqrt(2 * Pi * x) * ((x / E)^x)
// diff(x!,dx)=(!x)*(1/(2x)+ln(x))≈(!x)*ln(x)
// diff((x+1)!,dx)≈(x+1)*(!x)*ln(x+1)

// number !
TaskForThread bimcomplexfactorial( StackClusterPrivate  * const stclpp ) {
  PLOComplex  * const  mec  = NewComplexBareExc ( );  
  Complex_Set ( PLOComplexToComplex( mec),
    PLOComplexToComplexConst( ParaLispObjectToPLOComplexConst(
      StackClusterPrivate_ThisTop(stclpp ))));
  Complex_Factorial ( PLOComplexToComplex( mec));
  StackClusterPrivate_SetResult(stclpp ,&  mec->plo);
  return  TaskForThread_Analyse; 
}

# include "char/public.h"
  
//  integer char
TaskForThread bimcomplexchar  ( StackClusterPrivate * const stclpp )  {
// !? to make WCharValue(number)
  PLOCharPriv * const res = aligned_alloc ( _Alignof ( PLOCharPriv ) , sizeof ( PLOCharPriv ) ) ;
  if ( not res )
    StackClusterPrivate_ExceptionSet  ( stclpp  , & PLOString_NewCopy ( L"OutOfMemory : complex char" ) ->  plo ) ;
  else {
    PLOChar_InitInt ( res , Complex_IValue ( PLOComplexToComplexConst  (
          ParaLispObjectToPLOComplexConst ( StackClusterPrivate_ThisTop ( stclpp ) ) ) ) ) ;
    StackClusterPrivate_SetResult ( stclpp , ParaLispObject_virtualPushAsNew ( & res -> pub . plo ) ) ;
  }
  return  TaskForThread_Analyse ;
}

// complex nanp
TaskForThread bimcomplexnanp( StackClusterPrivate * const stclpp ) {
  PLOComplex  * const mep=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(      stclpp ));
  StackClusterPrivate_SetResult(stclpp ,((FractionIsNaN(
     Complex_CRe(PLOComplexToComplexConst(mep)))  or 
    FractionIsNaN ( Complex_CIm(PLOComplexToComplexConst(mep)))) ?
      &mep->plo  :
      ( &plofalse.plo )));
  return  TaskForThread_Analyse; 
}

// complex finitep
TaskForThread bimcomplexfinitep( StackClusterPrivate  * const stclpp ) {
  PLOComplex  * const mep=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,(
    (FractionFiniteP( Complex_CRe(PLOComplexToComplexConst(
      mep)))  and
      FractionFiniteP( Complex_CIm(PLOComplexToComplexConst(
      mep)))) ?
    &mep->plo  :
    ( &plofalse.plo )));
  return  TaskForThread_Analyse; 
}

# include <unistd.h> // setuid

//  complex setuid
TaskForThread bimcomplexsetuid( StackClusterPrivate * const stclpp ) {
  StackClusterPrivate_SetResult(stclpp ,
    (setuid(FractionUIValue(
           Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
             StackClusterPrivate_ThisTop(
            stclpp ))))))  ?
    &  plofalse.plo :
    &  plotrue.plo ));
  return   TaskForThread_Analyse ; 
}

//  complex seteuid
TaskForThread bimcomplexseteuid( StackClusterPrivate  * const stclpp ) {
  StackClusterPrivate_SetResult(stclpp , (
    seteuid(FractionUIValue(
           Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
             StackClusterPrivate_ThisTop(
            stclpp ))))))  ?
    & plofalse.plo  :
    &  plotrue .plo));
  return   TaskForThread_Analyse ; 
}

//  complex setgid
TaskForThread bimcomplexsetgid( StackClusterPrivate * const stclpp ) {
  StackClusterPrivate_SetResult(stclpp , 
    (setgid(FractionUIValue(
           Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
             StackClusterPrivate_ThisTop(
            stclpp ))))))  ?
    &  plofalse.plo  :
    &  plotrue.plo ));
  return   TaskForThread_Analyse ; 
}

//  complex setegid
TaskForThread bimcomplexsetegid( StackClusterPrivate  * const stclpp ) {
  StackClusterPrivate_SetResult(stclpp , 
    (setegid(FractionUIValue(
           Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
             StackClusterPrivate_ThisTop(
            stclpp ))))))  ?
    &  plofalse.plo  :
    &  plotrue.plo ));
  return  TaskForThread_Analyse; 
}

TaskForThread bimcomplexevenp( StackClusterPrivate  * const stclpp ) {
  PLOComplex  * const mep=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  if(not  (FractionIs0( Complex_CIm(
    PLOComplexToComplexConst(mep)) ))) {
    StackClusterPrivate_SetResult(stclpp ,& plofalse.plo );
    return  TaskForThread_Analyse; 
  }
  { FractionPub  const * const merep  = Complex_CRe (
      PLOComplexToComplexConst  ( mep ) ) ;
    if  ( not  ULongIs1 ( FractionCDenomp ( merep ) ) ) {
      StackClusterPrivate_SetResult(stclpp ,& plofalse.plo );
      return  TaskForThread_Analyse; 
    }
    if  ( ULongOddP (  FractionCNump ( merep ) ) ) {
      StackClusterPrivate_SetResult(stclpp ,& plofalse.plo );
      return  TaskForThread_Analyse; 
    } 
  }
  StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  return  TaskForThread_Analyse; 
}

TaskForThread bimcomplexoddp( StackClusterPrivate * const stclpp ) {
  PLOComplex  * const mep=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  if(not  (FractionIs0( Complex_CIm(
    PLOComplexToComplexConst(mep)) ))) {
    StackClusterPrivate_SetResult(stclpp ,& plofalse.plo );
    return  TaskForThread_Analyse; 
  }
  { FractionPub  const * const merep=
      Complex_CRe(PLOComplexToComplexConst(mep));
    if  ( not  ULongIs1 ( FractionCDenomp  ( merep ) ) ) {
      StackClusterPrivate_SetResult(stclpp ,& plofalse.plo );
      return  TaskForThread_Analyse; 
    }
    if  ( ULongEvenP  ( FractionCNump  ( merep ) ) ) {
      StackClusterPrivate_SetResult(stclpp ,& plofalse.plo );
      return  TaskForThread_Analyse; 
    } 
  }
  StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  return  TaskForThread_Analyse; 
}

# include <pwd.h> // getpwuid
  
TaskForThread bimcomplexgid ( StackClusterPrivate  * const stclpp ) {
  struct passwd  const * const pas =
    getpwuid  ( FractionUIValue  (
       Complex_CRe  ( PLOComplexToComplexConst  ( ParaLispObjectToPLOComplex  (
         StackClusterPrivate_ThisTop  ( stclpp  ) ) ) ) ) ) ;
  if ( pas ) {
    PLOComplex  * const  rp = NewComplexBareExc ( )  ;
    Complex_Set0  ( PLOComplexToComplex ( rp  ) ) ;  // Im = 0
    enum { bs = ( sizeof ( pas -> pw_gid ) <<  3 ) } ;
    FractionSetFromBits  ( Complex_Re  ( PLOComplexToComplex (
      rp  ) ) , & ( pas ->  pw_gid  ) , bs  ) ;
    StackClusterPrivate_SetResult ( stclpp ,  & rp  ->  plo ) ; 
  } else  
    StackClusterPrivate_SetResult ( stclpp ,  & plonil  . plo ) ;
  return  TaskForThread_Analyse ; 
}

TaskForThread bimcomplexdegrees( StackClusterPrivate  * const stclpp ){
  PLOComplex  * const  ret2  = NewComplexBareExc ( );
  Complex_Set ( PLOComplexToComplex( ret2),
    PLOComplexToComplexConst( ParaLispObjectToPLOComplexConst(
      StackClusterPrivate_ThisTop(stclpp ))));
  // this*180/pi
  Complex_MulUInt ( PLOComplexToComplex( ret2),180U);
  Complex_DivFraction ( PLOComplexToComplex( ret2 ) ,
    FractionploConstPiPub ) ;
// ! to simplify: ret %= 360  
  StackClusterPrivate_SetResult(stclpp ,&  ret2->plo);
  return  TaskForThread_Analyse;
}

TaskForThread bimcomplexradians( StackClusterPrivate  * const stclpp ){
  PLOComplex  * const  ret2  = NewComplexBareExc ( );
  Complex_Set ( PLOComplexToComplex( ret2),
    PLOComplexToComplexConst( ParaLispObjectToPLOComplexConst(
      StackClusterPrivate_ThisTop(stclpp ))));
  // this/180*pi
// ! to simplify: ret %= 360    
  Complex_DivUInt ( PLOComplexToComplex( ret2),180U);
  Complex_MulFraction ( PLOComplexToComplex ( ret2  ) ,
    FractionploConstPiPub ) ;
  StackClusterPrivate_SetResult(stclpp ,&  ret2->plo);
  return  TaskForThread_Analyse ;
}

TaskForThread bimcomplexnum( StackClusterPrivate  * const stclpp ){
  PLOComplex  * const  res= NewComplexBareExc (  );
  Complex_SetULong  ( PLOComplexToComplex( res),  FractionCNump(
       Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
         StackClusterPrivate_ThisTop( stclpp ))))));
  StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  return  TaskForThread_Analyse;
}

TaskForThread bimcomplexdenom( StackClusterPrivate  * const stclpp ){
  PLOComplex  * const  res= NewComplexBareExc (  );
  Complex_SetULong  ( PLOComplexToComplex( res),  FractionCDenomp(
       Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
         StackClusterPrivate_ThisTop( stclpp ))))));
  StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  return  TaskForThread_Analyse;
}

TaskForThread bimcomplexnice( StackClusterPrivate * const stclpp ){
  int tmp ;
  if(FractionIsBADIntValue(
     Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
       StackClusterPrivate_ThisTop(
        stclpp )))),&tmp)){
    StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
    return  TaskForThread_Analyse;
  }
  int const  res = nice(tmp) ;
  if(res < 0)  
// ! to return symbol ?    
    StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
  else{
    PLOComplex  * const  cres= NewComplexBareExc ( );
    Complex_SetInt  ( PLOComplexToComplex( cres),res);
    StackClusterPrivate_SetResult(stclpp ,&  cres->plo);
  }
  return  TaskForThread_Analyse;
}

TaskForThread bimcomplexreal( StackClusterPrivate * const stclpp ){
  PLOComplex * const mep=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  if(Complex_isReal(PLOComplexToComplexConst(mep)))  // x+0i
    StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  else{
    PLOComplex  * const  pres= NewComplexBareExc ( );
    Complex_SetFraction ( PLOComplexToComplex( pres),
      Complex_CRe(PLOComplexToComplexConst(mep)));
    StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
  }
  return  TaskForThread_Analyse;
}

TaskForThread bimcompleximag( StackClusterPrivate * const stclpp ){
  PLOComplex  * const  pres= NewComplexBareExc ( );
  Complex_SetFraction ( PLOComplexToComplex( pres),
     Complex_CIm(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        StackClusterPrivate_ThisTop(stclpp )))));
  StackClusterPrivate_SetResult(stclpp ,&  pres->plo);
  return  TaskForThread_Analyse;
}

TaskForThread bimcomplexconj( StackClusterPrivate * const stclpp ){
  PLOComplex  * const mep=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  if( ULongIs0(FractionCNump( Complex_CIm(
    PLOComplexToComplexConst(mep)))))
    // x+0i or x+0/0i
    StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  else{
    PLOComplex  * const  mec  = NewComplexBareExc ( );
    Complex_Set ( PLOComplexToComplex( mec),  PLOComplexToComplexConst( mep));
    Complex_Conj  ( PLOComplexToComplex( mec));
    StackClusterPrivate_SetResult(stclpp ,&  mec->plo);    
  }
  return  TaskForThread_Analyse;
}

// abs polar arg
TaskForThread bimcomplexpolar( StackClusterPrivate  * const stclpp ){
  PLOComplex * const absp=ParaLispObjectToPLOComplex(
    StackClusterPrivate_ThisTop(stclpp ));
  ParaLispObject  * const argp=CCAR(StackClusterPrivate_ArgTop(stclpp ));
  if(IsNotNumber(  stclpp ,argp))
    return  TaskForThread_Analyse;
  FractionPub  const * const absrep=
    Complex_CRe(PLOComplexToComplexConst(absp));
  FractionPub  const * const argrep= Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(argp)));
  if( ULongIs0(FractionCDenomp(argrep))){
    if( ULongIs0(FractionCNump(argrep)))
      if( ULongIs0(FractionCDenomp(absrep))) {
        PLOComplex  * const  res= NewComplexBareExc ( );
    FractionSetFraction  ( Complex_Re  ( PLOComplexToComplex (
      res ) ) , argrep ) ;
    FractionSetFraction  ( Complex_Im  ( PLOComplexToComplex (
      res ) ) , argrep ) ;
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);
      } else // x/0 polar 0/0 -> 0/0+0/0i
        if( ULongIs0(FractionCNump(absrep)))
          if(FractionIs0( Complex_CIm(
            PLOComplexToComplexConst(absp)) ))
            // 0 polar 0/0 -> 0
            StackClusterPrivate_SetResult(stclpp , &absp->plo);
          else{
            PLOComplex  * const  resp= NewComplexBareExc ( );
            Complex_Set0  ( PLOComplexToComplex( resp));  
            StackClusterPrivate_SetResult(stclpp ,&  resp->plo);
          } else{
          PLOComplex  * const  res= NewComplexBareExc (  );
      FractionSetFraction  ( Complex_Re  ( PLOComplexToComplex (
        res ) ) , argrep ) ;
      FractionSetFraction  ( Complex_Im  ( PLOComplexToComplex (
        res ) ) , argrep ) ;
      StackClusterPrivate_SetResult(stclpp ,&  res->plo);
        } else { // 1 polar 0/0 -> 0/0+0/0i
      if( ULongIs0(FractionCDenomp(absrep))){
        PLOComplex  * const  res= NewComplexBareExc (  );
        StackClusterPrivate_SetResult(stclpp ,&  res->plo);
      } else 
      // x/0 polar +-1/0 -> 0/0+0/0i
        if( ULongIs0(FractionCNump(absrep)))
          if(FractionIs0( Complex_CIm(
            PLOComplexToComplexConst(absp)) ))  
            // 0 polar +-1/0 -> 0
            StackClusterPrivate_SetResult(stclpp , &absp->plo);
          else{
            PLOComplex  * const  resp= NewComplexBareExc ( );
            Complex_Set0  ( PLOComplexToComplex( resp));  
            StackClusterPrivate_SetResult(stclpp ,&  resp->plo);
          }
        else  {
          PLOComplex  * const  res= NewComplexBareExc (  );
          StackClusterPrivate_SetResult(stclpp ,&  res->plo);
        }
      } 
          // 1 polar +-1/0 -> 0/0+0/0i
    return  TaskForThread_Analyse;
  }
  if( ULongIs0(FractionCNump(argrep))){
    if(FractionIs0( Complex_CIm(
      PLOComplexToComplexConst(absp))))
      // x+0i polar 0 -> x+0i
      StackClusterPrivate_SetResult(stclpp , &absp->plo);  
    else{
      // x+yi polar 0 -> x
      PLOComplex  * const  res= NewComplexBareExc ( );
      Complex_SetFraction ( PLOComplexToComplex( res),absrep);
      StackClusterPrivate_SetResult(stclpp ,&  res->plo);
    }
    return  TaskForThread_Analyse;
  }
  if( ULongIs0(FractionCDenomp(absrep))){  
    // x/0 polar y -> 0/0+0/0i
    
    PLOComplex  * const  res= NewComplexBareExc (  );
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);
         
// ?  1/0 polar 1 -> ?    
      
      // 1/0 polar pi/2 -> 1/0i
      // 1/0 polar -pi -> -1/0
      // 1/0 polar -pi/2 -> -1/0i
      
    return  TaskForThread_Analyse;
  }
  if( ULongIs0(FractionCNump(absrep))){  // 0 polar y -> 0
    if(FractionIs0( Complex_CIm( PLOComplexToComplexConst(absp))))
      StackClusterPrivate_SetResult(stclpp , &absp->plo);
    else{      
      PLOComplex  * const  resp= NewComplexBareExc ( );
      Complex_Set0  ( PLOComplexToComplex( resp));  
      StackClusterPrivate_SetResult(stclpp ,&  resp->plo);
    }
    return  TaskForThread_Analyse;
  }
  long  double const ldargre = FractionLDValueConst (argrep);
  PLOComplex  * const  res= NewComplexBareExc (  );
  FractionSetExactLDouble ( Complex_Re  (PLOComplexToComplex(res)
    ) ,    cosl ( ldargre ) ) ;
  FractionSetExactLDouble ( Complex_Im ( PLOComplexToComplex (
    res ) ) , sinl ( ldargre ) ) ;
  Complex_MulFraction ( PLOComplexToComplex ( res ) , absrep ) ;
  StackClusterPrivate_SetResult(stclpp ,&  res->plo);
  return  TaskForThread_Analyse ;
}

// !! to write ISQRT -> to calc with unlimited precision

// 31219-1.pdf
// !! sqrt(x) result will be (a,b,(c,d))=a+1/(b+1/(c+1/(d+1/(c+1/(d+...)))))
// !! to make function with <eps limit
// sqrt(5)=(2,(4))
// a1=2 sqrt(5)=2+1/a2
// a2=1/(sqrt(5)-2)=(sqrt(5)+2)/1=4+1/a3
// ...
// sqrt(32)=(5,(1,1,1,10))
// a1=5 sqrt(32)=5+1/a2
// a2=1/(sqrt(32)-5)=(sqrt(32)+5)/7=1+1/a3
// a3=...
// sqrt(n)=q0,(q1,q2,...,q2,q1,2*q0) - symmetry !
// real sqrt [eps]

TaskForThread bimcomplexerf( StackClusterPrivate * const stclpp ){
  long  double  merld = FractionLDValueConst (
     Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
       StackClusterPrivate_ThisTop( stclpp )))));
  if(fabsl(merld)  < 0.5L) {
    merld  = erfl(merld);
    { PLOComplex  * const pres =  NewComplexBareExc (  );
      Complex_SetExactFromLD  ( PLOComplexToComplex( pres),merld);
      StackClusterPrivate_SetResult(stclpp ,&  pres->plo);    
    }  
  } else{
    PLOComplex  * const  pone= NewComplexBareExc ( );
    Complex_SetUInt ( PLOComplexToComplex( pone),1U);
// ? zero    
    ThreadStackPointerType const oldstack_dopp = Lisp2DThreadSP ( ) ;
    FractionPub * const dop = NewStackFraction ( ) ;
    FractionInit ( dop ) ;
    if(merld  > 0){
      FractionSetExactLDouble ( dop , erfcl (  merld  ) ) ;
      FractionSubtractMove  ( Complex_Re(PLOComplexToComplex(pone) ) ,  dop ) ;
    } else{
      FractionSetExactLDouble ( dop , erfcl ( - merld ) ) ;
      FractionSubtractMove  ( Complex_Re(PLOComplexToComplex(pone) ) , dop ) ;
      FractionSetFlagNegative ( Complex_Re(PLOComplexToComplex(pone)) ,true);
    }
    Lisp2D_StackFree  ( oldstack_dopp ) ;
    StackClusterPrivate_SetResult(stclpp ,&  pone->plo);
  }
  return  TaskForThread_Analyse;
}      

# include <errno.h>
  
//  complex sleep
TaskForThread bimcomplexsleep( StackClusterPrivate  * const stclpp ){
  struct  timespec  req = { . tv_sec  = 0 , . tv_nsec = 0 } ;
  { ThreadStackPointerType const oldstack_secp = Lisp2DThreadSP ( ) ;
    FractionPub * const sec = NewStackFraction  ( ) ;
    FractionConstrCopy ( sec , Complex_CRe ( PLOComplexToComplexConst  (
        ParaLispObjectToPLOComplex  (
        StackClusterPrivate_ThisTop ( stclpp )  ) ) ) ) ;
    req.tv_sec = FractionLValue(sec);
    if((req.tv_sec) < 0) {
      Lisp2D_StackFree  ( oldstack_secp ) ;
      PLOStringPub * const newstr  = PLOString_NewCopy ( L" < 0" )  ;
      if  ( newstr ) {
        ParaLispObject  * list [ ] = { StackClusterPrivate_ThisTop ( stclpp ) ,
          &newstr->plo , 0 } ;
        StackClusterPrivate_ExceptionSet(stclpp ,
          ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));      
      } else 
        OutOfMemory (  stclpp ) ;
      return  TaskForThread_Analyse ;
    }
    FractionMod (sec);
    FractionMultULInt ( sec ,  1000000000UL ) ; 
    FractionRound (sec);
    req.tv_nsec = FractionLValue(sec);
    Lisp2D_StackFree  ( oldstack_secp ) ;
    if((req.tv_nsec)  ==  1000000000L){
      ++  (req.tv_sec);
      (req.tv_nsec) = 0;
    }  
  } // sec
  struct  timespec  rem={0,0};
// ! to return SymbolErrno
  if(nanosleep( & req,  & rem)){
    int ie=errno;
    switch(ie){
    case  EFAULT:       
      PassagePassIn ( passageGCCPub ) ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        & PLOString_NewCopy (L"FAULT")->plo);
      PassagePassOut ( passageGCCPub ) ;        
      return  TaskForThread_Analyse;
    case  EINTR:       
      PassagePassIn ( passageGCCPub ) ;
// ! to write : return remaining time from REM with nsec
      { PLOComplex  * const  one= NewComplexBareExc (  );
        Complex_SetLInt ( PLOComplexToComplex( one),rem.tv_sec);    
        StackClusterPrivate_SetResult(stclpp ,&  one->plo);  
      }
      PassagePassOut ( passageGCCPub ) ;        
      return  TaskForThread_Analyse;
    case  EINVAL:       
      PassagePassIn ( passageGCCPub ) ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        & PLOString_NewCopy (L"INVAL")->plo);
      PassagePassOut ( passageGCCPub ) ;        
      return  TaskForThread_Analyse;
    default:       
      PassagePassIn ( passageGCCPub ) ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        & PLOString_NewCopy (L"?")->plo);
      PassagePassOut ( passageGCCPub ) ;      
      return  TaskForThread_Analyse;
    }
  }   
  PassagePassIn ( passageGCCPub ) ;    
  PLOComplex  * const  zero= NewComplexBareExc ( );
  Complex_Set0  ( PLOComplexToComplex( zero));
  StackClusterPrivate_SetResult(stclpp ,&  zero->plo);
  PassagePassOut ( passageGCCPub ) ;    
  return  TaskForThread_Analyse;  
}

# include <sys/io.h> // iopl

//  complex iopl
TaskForThread bimcomplexiopl  ( StackClusterPrivate  * const stclpp  ) {
  ThreadStackPointerType const oldstack_levelp = Lisp2DThreadSP ( ) ;
  FractionPub * const level = NewStackFraction ( ) ;
  FractionConstrCopy ( level , Complex_CRe  (
    PLOComplexToComplexConst  ( ParaLispObjectToPLOComplex  (
      StackClusterPrivate_ThisTop ( stclpp ) ) ) ) ) ;
  int ilevel  = 0  ;
  if  ( FractionIsBADIntValue ( level , & ilevel  ) ) {
    Lisp2D_StackFree  ( oldstack_levelp ) ;
    StackClusterPrivate_SetResult (stclpp ,& plotrue.plo ) ;
    return   TaskForThread_Analyse  ; 
  }
  Lisp2D_StackFree  ( oldstack_levelp ) ;
// ! Permissions are inherited by fork(2) and execve(2).    
// ? how to make it useful
  if  ( iopl  ( ilevel  ) ) 
    return SetResultErrnoNotLockGC(  stclpp );
  StackClusterPrivate_SetResult (stclpp ,& plofalse .plo ) ;
  return   TaskForThread_Analyse  ; 
}

// ! to do : inb , outb , ioperm , ...        
  
# define  IsBADIOPermPort Lisp2DIsBADIOPermPortVIGq
static  bool  IsBADIOPermPort ( StackClusterPrivate  * const stclpp  , 
  unsigned  short int * const  sportp  ) {
  if  ( FractionIsBADUShortValue  (
       Complex_CRe  (PLOComplexToComplexConst(ParaLispObjectToPLOComplex  (
        StackClusterPrivate_ThisTop ( stclpp ) )) ) , sportp ) ) {     
    PassagePassIn ( passageGCCPub ) ;
    StackClusterPrivate_SetResult (stclpp ,& plotrue.plo ) ;
    PassagePassOut ( passageGCCPub ) ;      
    return   true   ; 
  }
// ? to use iopl(3)    
  if (  ioperm  ( *sportp  , 1  , 1 ) )  {
    SetResultErrnoLockGC(  stclpp );
    return   true  ; 
  }
  return   false  ; 
}

# define  FuncInByte  Lisp2DFuncInByte5Equ
typedef unsigned  char  (FuncInByte)(unsigned short int p)  ;

# define  bimcomplexinbyteU Lisp2DbimcomplexinbyteUgbdT
//  complex-port in-byte | in-byte-pause
static  TaskForThread bimcomplexinbyteU  (
  StackClusterPrivate  * const stclpp , FuncInByte * const f ) {
  unsigned  short int sport = 0  ;
  if  ( IsBADIOPermPort ( stclpp  , &sport ) ) 
    return   TaskForThread_Analyse  ;
  unsigned char const res = f ( sport )  ;
  ioperm  ( sport  , 1  , 0 ) ;
  PassagePassIn ( passageGCCPub ) ;
  PLOComplex * cres =  NewComplexBareExc (   )  ; 
  PassagePassOut ( passageGCCPub ) ;    
  Complex_SetUInt ( PLOComplexToComplex( cres) , ( uint8_t ) res ) ;         
  PassagePassIn ( passageGCCPub ) ;
  StackClusterPrivate_SetResult (stclpp ,&  cres ->plo ) ;
  PassagePassOut ( passageGCCPub ) ; 
  return  TaskForThread_Analyse; 
} 

//  complex-port in-byte
TaskForThread bimcomplexinbyte  ( StackClusterPrivate  * const stclpp  ) {
  return   bimcomplexinbyteU (  stclpp  , &inb )  ; 
}

//  complex-port in-byte-pause
TaskForThread bimcomplexinbytepause  ( StackClusterPrivate  * const stclpp  ) {
  return   bimcomplexinbyteU (  stclpp  , &inb_p )  ; 
}  

# define  FuncOutByte Lisp2DFuncOutByteap6w
typedef void  (FuncOutByte)( unsigned char val ,  unsigned short int port )  ;

# define  bimcomplexoutbyteU  Lisp2DbimcomplexoutbyteUpOF8
//  complex-port out-byte|out-byte-pause value
static  TaskForThread bimcomplexoutbyteU  (
  StackClusterPrivate  * const stclpp , FuncOutByte * const f ) {
  unsigned  short int sport = 0  ;
  if  ( IsBADIOPermPort ( stclpp  , &sport ) )  
    return   TaskForThread_Analyse  ;
  ParaLispObject * const valp  =CCAR (StackClusterPrivate_ArgTop(stclpp ))  ;
    if  ( IsNotNumberLockGC(   stclpp , valp  ) )     
      return   TaskForThread_Analyse  ;
  { unsigned  char ucval = 0  ;
    if( Complex_isBADUCharValue(PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(  valp )) ,
        &ucval ) ) {       
      PassagePassIn ( passageGCCPub ) ;
      ParaLispObject  * list [ ] = {  valp,& PLOString_NewCopy(
        L" is wrong byte value")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,ListOfPLO((PArrayPLOP){
        (ParaLispObject*(*)[])&list}));
      PassagePassOut ( passageGCCPub ) ;        
      return   TaskForThread_Analyse  ; 
    }
    f ( ucval , sport  )  ; 
  }
  ioperm  ( sport  , 1  , 0 ) ;   
  PassagePassIn ( passageGCCPub ) ;
  StackClusterPrivate_SetResult (stclpp ,& plonil.plo ) ; 
  PassagePassOut ( passageGCCPub ) ;    
  return  TaskForThread_Analyse; 
}  

//  complex-port out-byte|out-byte-vector val|byte-vector
TaskForThread bimcomplexoutbyte  ( StackClusterPrivate  * const stclpp  ) {
  return   bimcomplexoutbyteU (  stclpp  , outb )  ; 
}

//  complex-port out-byte-pause val
TaskForThread bimcomplexoutbytepause  ( StackClusterPrivate  * const stclpp  ) {
  return   bimcomplexoutbyteU (  stclpp  , outb_p )  ; 
}

# include "bytedeque/public.h"

//  complex-port out-byte-vector byte-vector
TaskForThread bimcomplexoutbytevector  ( StackClusterPrivate  * const stclpp  ) {
  unsigned  short int sport = 0  ;
  if  ( IsBADIOPermPort (  stclpp  ,& sport ) )  
    return   TaskForThread_Analyse  ;
  ParaLispObject * const valp  =CCAR (StackClusterPrivate_ArgTop(stclpp ))  ;
  if  ( IsNotByteDequeLockGC  ( stclpp ,  valp ) )   
    return   TaskForThread_Analyse  ;
  { size_t const bvs = PLOByteDeque_Size( ParaLispObjectToPLOByteDeque( valp )) ;
    uint8_t  * const vectorcopy = malloc ( bvs ) ;
    if  ( not vectorcopy  ) {
      OutOfMemory (  stclpp ) ;
      return   TaskForThread_Analyse  ; 
    }
    { uint8_t  * i = vectorcopy    ;
      for ( size_t  j =  0   ; j  < bvs  ; ++ j , ++ i  )
        ( * i ) = PLOByteDeque_AtValue  ( 
          ParaLispObjectToPLOByteDeque  (  valp ) , j ) ;
    }
    outsb (  sport , vectorcopy , bvs  )  ;
    free (  vectorcopy )  ; 
  }
  ioperm  (  sport  , 1  , 0 ) ;   
  PassagePassIn ( passageGCCPub ) ;
  StackClusterPrivate_SetResult (stclpp ,& plonil.plo ) ; 
  PassagePassOut ( passageGCCPub ) ;    
  return  TaskForThread_Analyse; 
}

//  complex-port in-byte-vector byte-vector|number
TaskForThread bimcomplexinbytevector  ( StackClusterPrivate  * const stclpp  ) {
  unsigned  short int sport = 0  ;
  if  ( IsBADIOPermPort (  stclpp  ,& sport ) ) 
    return   TaskForThread_Analyse  ;
  ParaLispObject * const arglistp  =StackClusterPrivate_ArgTop(stclpp ) ;
  if  ( not CConsp ( arglistp ) ) {    
    PassagePassIn ( passageGCCPub ) ;
    StackClusterPrivate_ExceptionSet  (stclpp ,& PLOString_NewCopy (
      L"no arguments" )->plo ) ;
    PassagePassOut ( passageGCCPub ) ;
    return   TaskForThread_Analyse  ; 
  }
  ParaLispObject * volatile vec = 
    ClassCons_First(&ParaLispObjectToPLOCons( arglistp )->cc ) ;
  size_t size = 0  ;
  if  ( not ( ByteVectorp ( vec ) ) ) {
    if  ( not ( Numberp ( vec ) ) ) {      
      PassagePassIn ( passageGCCPub ) ;
      ParaLispObject  * list [ ] = { vec , & PLOString_NewCopy (
        L" is not number nor byte-vector" )->plo , NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      PassagePassOut ( passageGCCPub ) ;
      return   TaskForThread_Analyse  ; 
    }
    if  ( Complex_IsBadSizeValue  ( PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst ( vec )) , & size  ) ) {
      PassagePassIn ( passageGCCPub ) ;    
      ParaLispObject  * list [ ] = { vec , & PLOString_NewCopy (
        L" has bad size value" )->plo , NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp , ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      PassagePassOut ( passageGCCPub ) ;
      return   TaskForThread_Analyse  ;
    } 
    // if not ( ByteVectorp ( * vec ) )
  } else 
    size = PLOByteDeque_Size(ParaLispObjectToPLOByteDeque( vec ) ) ;
  { void  * const rawmemory = malloc ( size ) ;
    if  ( not rawmemory ) {
      OutOfMemory ( stclpp  ) ;
      return   TaskForThread_Analyse  ;
    }
    insb  ( sport , rawmemory , size  )  ;
    if  ( Numberp ( vec ) ) {
      PLOByteDeque * const newbytevector = aligned_alloc ( _Alignof ( PLOByteDeque ) , sizeof ( PLOByteDeque ) ) ;
      if ( not newbytevector ) {
        free (  rawmemory )  ;
        OutOfMemory ( stclpp  ) ;
        return   TaskForThread_Analyse  ;
      }
      PLOByteDeque_InitSize ( newbytevector , size ) ;
      PassagePassIn ( passageGCCPub ) ;
      ParaLispObject_virtualPushAsNew ( & newbytevector ->  plo ) ;
      PassagePassOut ( passageGCCPub ) ;              
      vec = & newbytevector ->  plo ;
    }
    { uint8_t  * i = ( uint8_t * ) ( rawmemory )   ;
      for ( size_t  j =  0   ; j  < size  ; ++ j , ++ i  )
        PLOByteDeque_SetAt  ( ParaLispObjectToPLOByteDeque  ( vec ) , j , * i ) ;
    }
    free (  rawmemory )  ;  
  }  // void  * rawmemory   
  PassagePassIn ( passageGCCPub ) ;
  StackClusterPrivate_SetResult (stclpp , vec ) ; 
  PassagePassOut ( passageGCCPub ) ;    
  return  TaskForThread_Analyse; 
}

# include <grp.h>  // getgrgid
  
TaskForThread bimcomplexgname ( StackClusterPrivate  * const stclpp ) {
  struct group const * const grp = getgrgid ( FractionUIValue  (
     Complex_CRe  ( PLOComplexToComplexConst  ( ParaLispObjectToPLOComplex  (
      StackClusterPrivate_ThisTop ( stclpp  ) ) ) ) ) ) ;
  if  ( grp ) {
    ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
    String  ( WideChar ) * const wan2 = StackNew_StringWideChar ( ) ;
    String_Init ( WideChar  ) ( wan2 , true ) ;
    { String  ( Char ) * const strcresp = StackNew_StringChar ( ) ;
      StringConstrCStr ( Char  ) ( strcresp , grp -> gr_name , true ) ;
      if ( isBADReadCStringToWString2 ( strcresp , wan2 ) ) {
        Lisp2D_StackFree  ( oldstack ) ;
        BadStringN (  stclpp ) ;
        return  TaskForThread_Analyse ; 
      } 
    }
    { PLOStringPub * const  res2 = PLOString_NewMoveString ( wan2 ) ;
      StackClusterPrivate_SetResult ( stclpp ,  & res2 -> plo ) ;
    }
    Lisp2D_StackFree  ( oldstack ) ;
  } else 
    StackClusterPrivate_SetResult ( stclpp , & plonil . plo ) ;
  return  TaskForThread_Analyse ; 
}

TaskForThread bimcomplexuname( StackClusterPrivate  * const stclpp ){
  struct passwd  const * const pas =
    getpwuid(
      FractionUIValue( Complex_CRe(
        PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
        StackClusterPrivate_ThisTop(          stclpp ))))));
  if ( pas ) {
    ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
    String  ( WideChar ) * const wan2 = StackNew_StringWideChar ( ) ;
    String_Init ( WideChar  ) ( wan2 , true ) ;
    { String  ( Char ) * const strcresp = StackNew_StringChar ( ) ;
      StringConstrCStr ( Char  ) ( strcresp , pas->pw_name , true ) ;
      if ( isBADReadCStringToWString2 ( strcresp , wan2 ) ) {
        Lisp2D_StackFree  ( oldstack ) ;
        BadStringN(  stclpp );
        return  TaskForThread_Analyse ; 
      } 
    }
    { PLOStringPub * const  res2 = PLOString_NewMoveString ( wan2 ) ;
      StackClusterPrivate_SetResult ( stclpp ,&res2->plo);
    }
    Lisp2D_StackFree  ( oldstack ) ;
  } else
    StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
  return  TaskForThread_Analyse; 
}

TaskForThread bimcomplexhome( StackClusterPrivate * const stclpp ){
  struct passwd  const * const pas =
    getpwuid(
      FractionUIValue( Complex_CRe(
        PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
        StackClusterPrivate_ThisTop(          stclpp ))))));
  if  ( pas ) {
    ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
    String  ( WideChar ) * const wan2 = StackNew_StringWideChar ( ) ;
    String_Init ( WideChar  ) ( wan2 , true ) ;
    { String  ( Char ) * const strcresp = StackNew_StringChar ( ) ;
      StringConstrCStr ( Char  ) ( strcresp , pas->pw_dir , true ) ;
      if ( isBADReadCStringToWString2 ( strcresp , wan2 ) ) {
        Lisp2D_StackFree  ( oldstack ) ;
        BadStringN(  stclpp );
        return  TaskForThread_Analyse ; 
      } 
    }
    { PLOStringPub * const  res2 = PLOString_NewMoveString ( wan2 ) ;
      StackClusterPrivate_SetResult ( stclpp , &res2->plo);
    }
    Lisp2D_StackFree  ( oldstack ) ;
  } else  
    StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
  return  TaskForThread_Analyse ; 
}

TaskForThread bimcomplexshell( StackClusterPrivate  * const stclpp ){
  struct passwd  const * const pas =
    getpwuid(
      FractionUIValue( Complex_CRe(
        PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        StackClusterPrivate_ThisTop(          stclpp ))))));
  if  ( pas ) {
    ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
    String  ( WideChar ) * const wan2 = StackNew_StringWideChar ( ) ;
    String_Init ( WideChar  ) ( wan2 , true ) ;
    { String  ( Char ) * const strcresp = StackNew_StringChar ( ) ;
      StringConstrCStr ( Char  ) ( strcresp , pas->pw_shell , true ) ;
      if ( isBADReadCStringToWString2 ( strcresp , wan2 ) ) {
        Lisp2D_StackFree  ( oldstack ) ;
        BadStringN(  stclpp );
        return  TaskForThread_Analyse ; 
      } 
    }
    { PLOStringPub * const  res2 = PLOString_NewMoveString ( wan2 ) ;
      StackClusterPrivate_SetResult ( stclpp ,&res2->plo);
    }
    Lisp2D_StackFree  ( oldstack ) ;
  } else  
    StackClusterPrivate_SetResult(stclpp ,& plonil.plo );
  return  TaskForThread_Analyse ; 
}

TaskForThread bimcomplexgmem  ( StackClusterPrivate * const stclpp )  {
  errno = 0 ;
  struct group const * const grp = getgrgid(FractionUIValue(
         Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
           StackClusterPrivate_ThisTop ( stclpp ))))));
  if  ( grp ) {
    ParaLispObject  * res=& plonil.plo ;
    ParaLispObject  * reslast=& plonil.plo ;
    ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
    String  ( WideChar ) * const wan2 = StackNew_StringWideChar ( ) ;
    String_Init ( WideChar  ) ( wan2 , true ) ;
    for ( char  * * grmemi  = grp ->  gr_mem  ; * grmemi  ; ++ grmemi ) {
      ParaLispObject  * plomemi ;
      { String  ( Char ) * const strcresp = StackNew_StringChar ( ) ;
        StringConstrCStr ( Char  ) ( strcresp , * grmemi , true ) ;
        StringClear ( WideChar  ) ( wan2 ) ;
        if ( isBADReadCStringToWString2 ( strcresp , wan2 ) ) {
          Lisp2D_StackFree  ( oldstack ) ;
          BadStringN(  stclpp );
          return  TaskForThread_Analyse ; 
        } 
      }
      PLOStringPub * const  plomemis2 = PLOString_NewMoveString ( wan2 ) ;
      plomemi = & plomemis2 -> plo ;
      ParaLispObject  * const x2 = &  NewCons(  plomemi,& plonil.plo )->plo; 
      if(res  ==  & plonil.plo )
        res = x2;
      else
        ClassCons_SetRest(&ParaLispObjectToPLOCons(reslast)->cc,  x2);
      reslast = x2 ; 
    } // for grmemi
    Lisp2D_StackFree  ( oldstack ) ;
    StackClusterPrivate_SetResult(stclpp ,  res ) ; 
  } else {
    int const er = errno ;
    if ( er )
      StackClusterPrivate_SetResult ( stclpp , & SymbolFromIntErrno  ( er ) -> plo ) ;
    else
      StackClusterPrivate_SetResult ( stclpp , & plonil.plo ) ; 
  }
  return  TaskForThread_Analyse ;
}
# include "widestring/inline.h"
inline  long double _Complex ldoub_cast_ldoubcomplex ( long double const d ) {
  return  ( long double _Complex ) d ;
}
