// Lisp2D - consequent of atomic pointer
// ©2015-23 by Alex Glebe

# include <setjmp.h>
# include <iso646.h> // not
# include "consatomic/public.h"
# include "excc.h"
# include <stdlib.h> // aligned_alloc
  
// returns pointer to new struct or long jump
ConsAtomicPointe * NewConsAtomicPointer ( void ) {
  ConsAtomicPointerPrivat * const me  = aligned_alloc ( _Alignof ( ConsAtomicPointerPrivat ) , sizeof  ( ConsAtomicPointerPrivat ) ) ;
  if  ( not me  ) {
    Lisp2DExcOutOfMemoryGlobal . value = 
      L"Lisp2DNewConsAtomicPointer:aligned_alloc ( sizeof  "
      L"( Lisp2DConsAtomicPointerPrivate ) )" ;
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ;
  }
  ConsAtomicPointerConstructor ( & me -> pub ) ;
  return  & me -> pub ;
}

ConsAtomicPointe * queueAtomicStClPrivFirst  ;

ConsAtomicPointe * queueAtomicStClPrivLast  ;

void  ConsAtomicPointerFree ( ConsAtomicPointe * const me ) {
  free ( ConsAtomicPointer_cast_Private ( me ) ) ;
}
