// Lisp2D - Cons Iterator
// ©2010-23 by Alex Glebe

# include "define.h"
# include "consiter/public.h"

# ifdef  LISP2D_CONSTRSTAT

# define  ConsIteratorconstrstat  Lisp2D_ConsIteratorconstrstat
_Atomic ( size_t ) ConsIteratorconstrstat = 0 ;

size_t  ConsIteratorconstrstatValue ( void  ) {
  return  ConsIteratorconstrstat  ; 
}

void  ConsIteratorconstrstatInc ( void  ) {
  ++  ConsIteratorconstrstat  ; 
}

# endif // LISP2D_CONSTRSTAT

# include "cons/inline.h"
# include "consiter/struct.h"
# include "consiter/private.h"

void CConsIteratorInit ( CConsIteratorPub * const ip , ParaLispObject  * const x ) {
  CConsIterator * const i = CConsIterator_toPrivate ( ip ) ;
  i -> current = x ;
  i -> fast = x ;
  i -> end = & plonil . plo ;
# ifdef  LISP2D_CONSTRSTAT
  ConsIteratorconstrstatInc ( ) ;
# endif
}

bool  CConsIteratorHaveItem  ( CConsIteratorPub const * const me ) {
  return  CConsp ( CConsIterator_toCPrivate ( me ) -> current ) ;
}
  
void  CConsIteratorNext  ( CConsIteratorPub * const mep ) {
  CConsIterator * const me = CConsIterator_toPrivate ( mep ) ;
  if  ( CConsp  ( me -> current ) ) {

    //ClassCons_RestTo  ( & ParaLispObjectToPLOCons(me -> current)->cc, &me -> current);
    me -> current = ClassCons_Rest ( & ParaLispObjectToPLOCons  ( me -> current ) ->  cc  ) ;
/*
    t_ClassCons_RestPtr arg = { . me = & ParaLispObjectToPLOCons  ( me -> current ) ->  cc , . rest = & plonil . plo } ;
    ClassCons_RestPtr  ( & arg ) ;
    me -> current = arg . rest ;
*/
    if ( ( not CConsp  ( me -> current ) ) or me -> current == me -> end) {
      me -> current = & plonil . plo ;
      return  ; 
    }
    if ( not CConsp  ( me -> end ) ) {
      if ( CConsp ( me -> fast ) )
        me -> fast = ClassCons_Rest  ( & ParaLispObjectToPLOCons ( me -> fast ) -> cc  ) ;
      if ( CConsp ( me -> fast ) )
        me -> fast = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( me -> fast )->cc ) ;
      if ( me -> fast == me -> current )
        me -> end = me -> current ; 
    }
  }
}
    
ParaLispObject * CConsIteratorItem  ( CConsIteratorPub const * const mep ) {
  { ParaLispObject  * const c = CConsIterator_toCPrivate ( mep ) -> current ;
    if ( CConsp ( c ) )
      return ClassCons_First  (&ParaLispObjectToPLOConsConst(c)->cc); 
  }
  return  & plonil  . plo  ; 
}

# include "stack/public.h"

CConsIteratorPub * NewStackCConsIterator (  void  ) {
  CConsIterator * const ci = Lisp2D_StackVar ( StackType ( CConsIterator ) ) ;
  return  & ci ->  pub ;
}
