// endian type check
// (C)2018-23 Lisp2D

# include <stdio.h>
# include <stdint.h>
# include <setjmp.h>
# include <stdatomic.h>
# include <stdbool.h>

# ifdef __STDC_NO_ATOMICS__
# error __STDC_NO_ATOMICS__
# endif

# ifndef  ATOMIC_INT_LOCK_FREE
# error not ATOMIC_INT_LOCK_FREE
# endif

# ifndef  ATOMIC_LONG_LOCK_FREE
# error not ATOMIC_LONG_LOCK_FREE
# endif

volatile  uint16_t  const v16 = 0x0102  ;
volatile  uint8_t const * pv8 = ( volatile uint8_t const  * ) ( & v16 ) ;

static  jmp_buf jmpbuffer ;

# define  fputse Lisp2Dfputse9275

static  void fputse  ( char  const * stri , FILE * stre )  ;

int main  ( )  {
  int const volatile  ex  = setjmp  ( jmpbuffer ) ;
  if  ( ex  )
    goto Exc ;
  fputse ( "// (C)2018-23 Lisp2D this file is auto assembled, modify endianc.c\n" , stdout ) ;
  fputse ( "# ifndef  LISP2D_ENDIANC_H\n" , stdout ) ;
  fputse ( "# define  LISP2D_ENDIANC_H\n" , stdout ) ;
  switch  ( sizeof  ( int ) ) {
  case  4 :
    fputse ( "# define  LISP2D_INT_SIZE_4\n" , stdout ) ;
    break ;
  case  2 :
    fputse ( "# define  LISP2D_INT_SIZE_2\n" , stdout ) ;
    break ;
  case  8 :
    fputse ( "# define  LISP2D_INT_SIZE_8\n" , stdout ) ;
    break ;
  default :
    goto Exc ;
  }
  fputse ( "# define  LISP2D_ATOMIC_INT_SIZE  " , stdout ) ;
  if ( fprintf ( stdout , "%li\n" , sizeof  ( _Atomic int ) ) == EOF )
    goto Exc ;
  fputse ( "# define  LISP2D_ATOMIC_SIZE_T_SIZE " , stdout ) ;
  if ( fprintf ( stdout , "%li\n" , sizeof  ( _Atomic size_t ) ) == EOF )
    goto Exc ;
  fputse ( "# define  LISP2D_ATOMIC_FLAG_SIZE " , stdout ) ;
  if ( fprintf ( stdout , "%li\n" , sizeof  ( atomic_flag ) ) == EOF )
    goto Exc ;
  { bool const little_endian = ( (  * pv8 ) == 0x02 ) ;
    bool const big_endian = ( ( * pv8 ) == 0x01 ) ;
    fputse ( "# define  " , stdout )  ;
    fputse ( ( little_endian ? "LISP2D_LITTLE_ENDIAN\n" : "LISP2D_BIG_ENDIAN\n" ) , stdout ) ;
    fputse ( "# define  Lisp2D_little_endian  " , stdout ) ;
    fputse ( little_endian ? "1" : "0" , stdout )  ;
    fputse ( "\n" , stdout ) ;
    fputse ( "# define  Lisp2D_big_endian " , stdout )  ;
    fputse ( big_endian ? "1" : "0" , stdout )  ;
    fputse ( "\n" , stdout )  ;
    fputse ( "# endif // LISP2D_ENDIANC_H\n" , stdout ) ;
  }
  return 0 ;
Exc :
  return 1 ;
}

static  void fputse  ( char  const * const  stri , FILE * const stre ) {
  if  ( fputs ( stri  , stre  ) ==  EOF )
    longjmp ( jmpbuffer , 1 ) ;
}
