// Eval function of Lisp2D
// ©2003-23 Alex Glebe
# include "define.h"
# include "bimc.h"
# include "boolean.h"
# include "sharedc.h"
# include "shared/inline.h"
# include "errorstra.h"

# define inEval3( object  , addrtoreturn  ) { \
  Vector_PushByValue ( StackPLOP ) ( StackClusterPrivate_stackcp  ( \
    stclp ) , Environment_Env ( StackClusterPrivate_envExternalc  ( stclp ) ) ) ;  \
  Vector_PushByValue ( StackPLOP ) ( StackClusterPrivate_stackcp  ( stclp ) , & object  ) ;  \
  { AddrForReturn _inEval3byhv ; \
    t_AddrForReturn2ConstructorFlagInBIM ar = { \
      . me = & _inEval3byhv , . addr = addrtoreturn , . inbim = false } ; \
    AddrForReturn2ConstructorFlagInBIM  ( & ar ) ; \
    Vector_PushByValue ( StackAddrForReturn ) ( StackClusterPrivate_stackAddrp  ( stclp ) , _inEval3byhv ) ; \
  } \
  goto  Exit  ; \
EvalCont ## addrtoreturn : \
  Environment_SetEnv  ( StackClusterPrivate_envExternal ( stclp ) , StackClusterPrivate_PopValue ( stclp ) ) ; \
}
    
// ! to make: StackCluster  & Eval() -> enum Eval()
// ! OR                   -> void Eval(RunningPthArgs  * rpt)
// ! to return different value to pthEval2()
// ! if StackCluster in Queue was again twice:
// ! first Thread: make extraThread, extraThread Push(stcl) in Queue
// ! second Thread: stcl processed and make TaskForManagerToQuit or Run or Else
// ! first Thread: MUST to IGNORE stcl.TaskForManager and get NEXT
//   task from the queue 
typedef struct  Lisp2D_sToRunExtraThread Lisp2D_tToRunExtraThread ;
typedef Lisp2D_tToRunExtraThread tToRunExtraThread ;
struct  Lisp2D_sToRunExtraThread {
  PLOBIF * bif ;
  StackClusterPrivate * stclp ;
} ;
# define  ToRunExtraThread  Lisp2D_ToRunExtraThread_7XS
static  void * ToRunExtraThread ( void * ) ;

# define  CreateLinks Lisp2D_CreateLinks_u2C
static  StackClusterPrivate  * CreateLinks ( StackClusterPrivate * me ,
  ParaLispObject  * form  , ParaLispObject * fact0 , PLOEnvironmentLayer * envlayer ) ;

# include "quote/public.h"
# include "string/public.h"
# include "backquote/inline.h"
# include "cons/inline.h"
# include "env/public.h"
# include "stcl/public.h"
# include "stcl/inline.h"
# include "inner-history/inline.h"

//stack must contain an object,addr - return point, usually 0 or 12
// !!! returns with PML(&mutexBoss)
TaskForThread StackClusterPrivate_Eval2 ( StackClusterPrivate * const stclp ) {
  ParaLispObject  * meth = 0 ;
  ParaLispObject  * ploj;
  ParaLispObject  * me = &  plonil.plo ;
  ParaLispObject  * arglist = & plonil.plo ;
  // !! retype -> PLOCons*
  ParaLispObject  * argevallast;
  ParaLispObject  * argevalfront;
  ParaLispObject * arglistslow  ;
  bool  tocheck ;
  bool  calculated; // argeval
  volatile  bool  flagWaitSons; // argeval
  ParaLispObject  * varD2;  // argeval
  ParaLispObject  * consPlaceForFirstResult ; // argeval
  ParaLispObject  * firstArgCalcYourSelf  ; // argeval
  ParaLispObject  * methfirst ;
  ParaLispObject  * varB ;
  //-------------start-------------
  { EvalAddrPrivat const eatmp = StackClusterPrivate_flagcont  ( stclp ) . addr ;
    EvalAddrCont2 const addrcontinue2 = Lisp2DEvalAddrValue ( & eatmp . pub ) ;
  if  ( addrcontinue2 ) {
    // continue task from the middle
    if  ( StackClusterPrivate_flagcont  ( stclp ) . inBIM ) {
      
      meth = VectorBackCopy  ( StackPLOP ) (
        StackClusterPrivate_stackcMethodcp  ( stclp ) ) ;

# ifdef  LISP2D_DEBUG
      if  ( BIFp  ( meth  ) ) {
        if  ( PLOBIF_HaveMethod ( ParaLispObjectToPLOBIF ( meth ) ) )
          goto  BIMEval ;
        else{
          ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
            L"flagcont -> funcbining=nullptr"});
          return  TaskForThread_Analyse ;
        }
      } else{
        ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
          L"flagcont -> Method is not BIM"});
        return  TaskForThread_Analyse ;
      }
# else
      goto  BIMEval;
# endif
    } // if flagcont2.inBIM
    
    Lisp2DEvalAddrClear ( & StackClusterPrivate_flagcontp ( stclp ) -> addr . pub ) ;
    
    switch( addrcontinue2){
    case  Lisp2DEvalAddrContTopProcessFinish2: 
      goto EvalCont1;  //EvalMainReturn
    case  Lisp2DEvalAddrContProcessFinish2:   
      goto  EvalCont2;  //EvalTaskReturn
    case  Lisp2DEvalAddrContg32:     
      goto  EvalCont3;
    case  Lisp2DEvalAddrContBackQuote2: 
      goto  BackQuote2;
    case  Lisp2DEvalAddrContg62:    
      goto  EvalCont6;
    case  Lisp2DEvalAddrContg72:   
      goto  EvalCont7;
    case  Lisp2DEvalAddrContg82:   
      goto  EvalCont8;
    case  Lisp2DEvalAddrContg92:     
      goto  EvalCont9;
    case  Lisp2DEvalAddrContZero2  :
    default : ;
# ifdef  LISP2D_DEBUG
      fwprintf(stderr,L"138:addrcontinue2 = %hhu\n",addrcontinue2);
      StackClusterPrivate_Popn  ( stclp ) ; 
      StackClusterPrivate_setresult ( stclp , & plonil  . plo ) ;
      // to kill garbage
      goto  EvalReturnNotTouchEnvNotPopStack;
# endif
    } //switch
    } // if  addrcontinue2
  } // addrcontinue
  StackClusterPrivate_setresult ( stclp , & plonil  . plo ) ;
  // to kill garbage
  /*
  stack = Full task
  stackMethod = empty
   */
  varB = StackClusterPrivate_PopValue(stclp );  
    StackClusterPrivate_setwhole  ( stclp , varB )  ;

    // is atom
    switch(ParaLispObject_Type(varB)){
    case  TypeGlobalListMemberPLOCons:  
      break ;
    case  TypeGlobalListMemberPLOSymbol:
      // is symbol
      { ParaLispObject * const  symbolassoc = Assoc ( varB  ,
        Environment_Env ( StackClusterPrivate_envLocalc ( stclp ) ) ,
            stclp  ) ;
        if  ( symbolassoc ) {
          StackClusterPrivate_setresult ( stclp , symbolassoc ) ;
          goto  EvalReturnNotTouchEnvNotPopStack;
        }
      }
      VariableHaveNoLinks ( stclp , varB  ) ;
      StackClusterPrivate_setresult ( stclp , & plonil  . plo )  ;
      goto  EvalReturnNotTouchEnvNotPopStack;
    case  TypeGlobalListMemberPLOQuote:
      StackClusterPrivate_setresult ( stclp , 
        PLOQuote_Item  ( ParaLispObjectToPLOQuote ( varB ) ) ) ;
      goto  EvalReturnNotTouchEnvNotPopStack;
    case  TypeGlobalListMemberBackQuotePrivate:
      bimnilbackquote23 ( stclp ,
        PLOBackQuote_Item ( ParaLispObjectToPLOBackQuote ( varB  ) ) ) ;
      switch  ( FlagCont  ( stclp ) ) {
      case  0:
        StackClusterPrivate_setresult ( stclp ,
          PLOBackQuote_Item ( ParaLispObjectToPLOBackQuote  ( varB  ) ) ) ;
        goto  EvalReturnNotTouchEnvNotPopStack;
      case  1:
        StackClusterPrivate_SetflagCont ( stclp ,
          Lisp2DEvalAddrContZero2   ) ;
        goto  Exit;
      case  2:
        // is 2 in list `(..  ..) and flag WaitSons
        StackClusterPrivate_SetflagCont  ( stclp ,
          Lisp2DEvalAddrContBackQuote2   ) ;
        Vector_PushByValue ( StackPLOP )  (  StackClusterPrivate_stackcp (
            stclp ) , varB ) ; 
        StackClusterPrivate_flagcontp ( stclp )  -> inBIM = false ;
        goto  Exit  ;
      default : ;
# ifdef  LISP2D_DEBUG        
        fwprintf  ( stderr  , L"eval:BackQuote: flagCont() = %hhu\n" ,
          FlagCont  ( stclp ) ) ;
# endif        
      }  // switch flagcont
BackQuote2  :
      varB  = StackClusterPrivate_PopValue  ( stclp ) ;
      StackClusterPrivate_SetflagCont ( stclp , 2U  ) ;  
      bimnilbackquote23 ( stclp  ,
        PLOBackQuote_Item ( ParaLispObjectToPLOBackQuote ( varB  ) ) ) ;
      goto  EvalReturnNotTouchEnvNotPopStack  ;
    default :
      // returns itself
      StackClusterPrivate_setresult ( stclp , varB  ) ;
      goto  EvalReturnNotTouchEnvNotPopStack;
    }
    // switch(static_cast<int>(varB->Type()))
    // varB is Cons
    // (this method arguments)
    // 1. this local eval
    // 2. check method type
    // 3. arguments parallel eval
    // 4. wait all arguments result
    // 5. apply this to arguments
    if  ( not  StackClusterPrivate_flagApplystate ( stclp ) ) {
      // first list element is simple atom - to calc yourself
      switch(ParaLispObject_Type(ClassCons_First(& ParaLispObjectToPLOCons(varB)->cc))){
      case  TypeGlobalListMemberPLOCons:  
        break;
      case  TypeGlobalListMemberPLOSymbol:
        { ParaLispObject * const  symbolassoc = Assoc (
            ClassCons_First ( &ParaLispObjectToPLOCons ( varB  )->cc ) ,
            Environment_Env ( StackClusterPrivate_envLocalc ( stclp ) ) , stclp ) ;
          if  ( symbolassoc ) {
            StackClusterPrivate_setresult ( stclp , symbolassoc ) ;
            goto  AfterCalcAtomObject;
          }
        }
        VariableHaveNoLinks ( stclp  , ClassCons_First ( & ParaLispObjectToPLOCons ( varB  )->cc ) ) ;
        StackClusterPrivate_setresult ( stclp , & plonil  . plo  ) ;
        goto  AfterCalcAtomObject ;
      case  TypeGlobalListMemberPLOQuote:
        StackClusterPrivate_setresult ( stclp , 
          PLOQuote_Item  ( ParaLispObjectToPLOQuote ( ( ParaLispObject * )
              ( GlobalListMemberVirt  ( & ClassCons_First ( &
                ParaLispObjectToPLOCons ( varB  ) -> cc ) -> base  ) . addr . p ) ) ) ) ;
        goto  AfterCalcAtomObject;
      case  TypeGlobalListMemberBackQuotePrivate:   
        break;
      default:
        // returns yourself
        StackClusterPrivate_setresult ( stclp , ClassCons_First (
          &ParaLispObjectToPLOCons ( varB )->cc ) ) ;
        goto  AfterCalcAtomObject ;
      }
      Vector_PushByValue ( StackPLOP )  ( StackClusterPrivate_stackcp  ( stclp ) , varB ) ;
      Vector_PushByValue ( StackPLOP )  ( StackClusterPrivate_stackcp  (
        stclp ) , StackClusterPrivate_whole ( stclp ) ) ;
      inEval3(*ClassCons_First(&ParaLispObjectToPLOCons ( varB )->cc ),9) 
      StackClusterPrivate_Pop ( stclp, StackClusterPrivate_wholep ( stclp ) ) ;
      varB=StackClusterPrivate_PopValue(stclp) ;
      if(StackClusterPrivate_exceptionnotprocessed  ( stclp )){
# ifdef  LISP2D_INNERHISTORY
        static  wchar_t const  Lisp2Dwsih_eval6[]  = L"StackCluster::Eval2():This calcs returns exception"  ;
        Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , Lisp2Dwsih_eval6  ) ;
# endif        
        goto  EvalReturnNotTouchEnvNotPopStack;
      }
AfterCalcAtomObject :
      me  = StackClusterPrivate_result  ( stclp ) ;        
      Vector_PushByValue ( StackPLOP )  (  StackClusterPrivate_stackcThisp ( stclp ) , me  ) ;
      varB  = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( varB  )->cc ) ;
      // varB is (method arguments)
      // an error while calc THIS
      // not flagapply
    } else { // flagapply
      me = ClassCons_First ( &ParaLispObjectToPLOCons ( varB )->cc ) ;
      Vector_PushByValue ( StackPLOP )  (  StackClusterPrivate_stackcThisp ( stclp ) , me   ) ;
      varB = ClassCons_Rest ( &  ParaLispObjectToPLOCons ( varB )  ->  cc ) ;
    }
    // flagapply
    // varB is (method arguments) or atom
    if  ( CConsp ( varB  ) ) {
      StackClusterPrivate_setresult ( stclp , & plonil  . plo ) ;
      // to kill garbage , object placed in stackThisTop (was a BUG ,
      //  empty function returns THIS)
      meth = ClassCons_First ( &ParaLispObjectToPLOCons ( varB )->cc ) ;
      arglist = ClassCons_Rest ( &  ParaLispObjectToPLOCons ( varB )  ->  cc ) ;
      Vector_PushByValue ( StackPLOP )  (  StackClusterPrivate_stackcproArgp ( stclp ) , arglist  ) ;
    } else // (obj) -> eval(obj)
      goto  EvalReturnNotTouchEnvNotPopStackMA ;
  // meth is defined
  // arglist is defined
  // definition
  { ParaLispObject * const cldefp=ParaLispObject_virtualClassDef(me);
# ifdef LISP2D_DEBUG
    if( cldefp  ==  (&  plonil.plo)){  //  Null
      ParaLispObject  * list [ ] = { & PLOString_NewCopy(L"class for ")->plo ,
        me , & PLOString_NewCopy(L" is not defined")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stclp,ListOfPLO( (PArrayPLOP){(ParaLispObject*(*)[])&list}));
      Vector_PushByValue ( StackPLOP )  (  StackClusterPrivate_stackcMethodp ( stclp ) , meth  ) ;
      goto  EvalReturnNotTouchEnv;
    }
# endif
    // loading method
    if(SymbolP ( meth)){
      ParaLispObject * const fass2  =
        StackClusterPrivate_ObjectDDAssocMethod2  ( stclp , cldefp , ParaLispObjectToPLOSymbol ( meth  ) ) ;
      if  ( fass2 ) {       
        meth  = fass2 ; 
        Vector_PushByValue ( StackPLOP ) ( StackClusterPrivate_stackcMethodp ( stclp ) , meth  ) ;
      }
      else { // fass2=nullptr
        Vector_PushByValue ( StackPLOP ) (  StackClusterPrivate_stackcMethodp ( stclp ) , meth  ) ;
        ParaLispObject  * list [ ] = { & PLOString_NewCopy(L"Method ")
          ->plo,meth, & PLOString_NewCopy(L" is not defined for class ")->plo,
          ParaLispObject_virtualTypeOf(me), NULL } ;
        StackClusterPrivate_ExceptionSet(stclp,ListOfPLO((PArrayPLOP){ (ParaLispObject*(*)[])&list}));
        StackClusterPrivate_setresult ( stclp , StackClusterPrivate_ThisTop ( stclp ) ) ;
        if  ( not  StackClusterPrivate_result ( stclp ) ) {
          StackClusterPrivate_setresult ( stclp , & plonil  . plo ) ; //  ?
          goto Exit ;
        }
        goto  EvalReturnNotTouchEnv;
      }
      // symbolp method
    } else
      Vector_PushByValue ( StackPLOP )  ( StackClusterPrivate_stackcMethodp ( stclp ) , meth  ) ;
  } // cldef
  //--------------lambda/macro calls-----------------
  // ! method to store is stack while calc. To dismiss stack method.
  if(CConsp(  meth)) {
    methfirst = ClassCons_First(&ParaLispObjectToPLOCons ( meth )->cc );
    if  ( ( methfirst  ==  & plolambdanotmod2 . plo ) or  ( methfirst ==  & plolambdaw  . plo ) ) {
      // eq lambda or λ
      StackClusterPrivate_EnvNewLevel2(stclp);
      goto  ArgEval;
LambdaEval:
      StackClusterPrivate_setflagApply  ( stclp , false ) ;
      Vector_PushByValue ( StackPLOP )  ( StackClusterPrivate_stackcp  ( stclp )  ,
        Environment_Env ( StackClusterPrivate_envLocal  ( stclp ) ) ) ;
      Vector_PushByValue ( StackPLOP )  ( StackClusterPrivate_stackcp  ( stclp )  ,
        Environment_Env ( StackClusterPrivate_envExternal ( stclp ) ) ) ;
      Environment_SetEnv  ( StackClusterPrivate_envLocal  ( stclp )  ,
        Environment_Env ( StackClusterPrivate_envExternal ( stclp ) ) ) ;
      { ParaLispObject  * cldef2 = StackClusterPrivate_ThisTop(stclp);
        if(not  cldef2 )
          goto Exit ;
        cldef2  =  ParaLispObject_virtualClassDef(cldef2);
        // static variables
        
        { jmp_buf jump_buffer ;
          jmp_buf * const oldjb = Lisp2DJBglobal  ;
          Lisp2DJBglobal = &  jump_buffer ;
          int const volatile  ex  = setjmp  ( jump_buffer ) ;
          if  ( ex  ) {
            Lisp2DJBglobal = oldjb  ;
            
            OutOfMemory(stclp);
            { ParaLispObject * x = StackClusterPrivate_PopValue(stclp);
              Environment_SetEnv  ( StackClusterPrivate_envExternal ( stclp ) , x ) ;
              x=StackClusterPrivate_PopValue(stclp);
              Environment_SetEnv  ( StackClusterPrivate_envLocal  ( stclp ) , x ) ;
            }
            StackClusterPrivate_setresult ( stclp , StackClusterPrivate_ThisTop( stclp ) ) ;
            if  ( not  StackClusterPrivate_result ( stclp ) ) {
              StackClusterPrivate_setresult ( stclp , & plonil  . plo ) ; // ?
              goto Exit ;
            }
            goto  EvalReturn;
          }
        
          Environment_NewLevel  ( StackClusterPrivate_envLocal  ( stclp ) , ClassGetStatic  (  cldef2  ) ) ;
          
          Lisp2DJBglobal = oldjb  ;
        }
          
        // local vars
        { ParaLispObject * const meContextp = ParaLispObject_virtualContext  (me ) ;
          if( meContextp not_eq  (& plonil.plo)){
            
            { jmp_buf jump_buffer ;
              jmp_buf * const oldjb = Lisp2DJBglobal  ;
              Lisp2DJBglobal = &  jump_buffer ;
              int const volatile  ex  = setjmp  ( jump_buffer ) ;
              if  ( ex ) {
                Lisp2DJBglobal = oldjb  ;
                OutOfMemory(stclp);
                { ParaLispObject * x = StackClusterPrivate_PopValue(stclp);
                  Environment_SetEnv  ( StackClusterPrivate_envExternal ( stclp ) , x ) ;
                  x=StackClusterPrivate_PopValue(stclp);
                  Environment_SetEnv  ( StackClusterPrivate_envLocal  ( stclp ) , x ) ;
                }
                StackClusterPrivate_setresult ( stclp , StackClusterPrivate_ThisTop( stclp ) ) ;
                if  ( not  StackClusterPrivate_result ( stclp ) ) {
                  StackClusterPrivate_setresult ( stclp , & plonil . plo ) ;
                  goto Exit ;
                }
                goto  EvalReturn;
              }
            
              Environment_NewLevel ( StackClusterPrivate_envLocal ( stclp )  ,
                meContextp ) ;
              Lisp2DJBglobal = oldjb  ;
            }
          }
        }  // meContext
      } // cldef2
      StackClusterPrivate_EnvNewLevel2(stclp);
      { ParaLispObject * const envLocalEnvCARp  = CCAR (
          Environment_Env ( StackClusterPrivate_envLocalc ( stclp ) ) ) ;
        if(IsNotEnvironmentLayer(stclp,envLocalEnvCARp)){
          { ParaLispObject *  x = StackClusterPrivate_PopValue(stclp);
            Environment_SetEnv  ( StackClusterPrivate_envExternal ( stclp ) , x ) ;
            x=StackClusterPrivate_PopValue(stclp);
            Environment_SetEnv  ( StackClusterPrivate_envLocal  ( stclp ) , x ) ;
          }
          goto  ArgEval;
        }
        // ('this set "?") -> error
        if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer
          ( envLocalEnvCARp ) -> envlay , & plosthis  . plo , me , true  ) ) {
          ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
            L"envLocalEnvCAR.isBADPush(*plosthis)"});
          goto Exit ;
        }
      }
      // envLocalEnvCAR
      { jmp_buf jb2 ;
        jmp_buf * const oldjb = Lisp2DJBglobal  ;
        Lisp2DJBglobal  = & jb2 ;
        int const volatile  jbn2 = setjmp  ( jb2  ) ;
        if  ( not ( jbn2 ) ) {
          CreateLinks ( stclp , CCAR ( ClassCons_Rest ( &
                ParaLispObjectToPLOCons ( meth )->cc ) ) , arglist ,
            ParaLispObjectToPLOEnvironmentLayer ( CCAR (
                Environment_Env ( StackClusterPrivate_envLocalc ( stclp ) ) ) ) ) ;
          Lisp2DJBglobal  = oldjb ;
        } else {
          Lisp2DJBglobal = oldjb ;
          OutOfMemory(stclp);
          { ParaLispObject * x = StackClusterPrivate_PopValue(stclp);
            Environment_SetEnv  ( StackClusterPrivate_envExternal ( stclp ) , x ) ;
            x=StackClusterPrivate_PopValue(stclp) ;
            Environment_SetEnv  ( StackClusterPrivate_envLocal  ( stclp ) , x ) ;
          }
          goto  ToCalc;
        }
      } // jb2
      ploj  = CCDR ( ClassCons_Rest ( &ParaLispObjectToPLOCons ( meth  )->cc ) ) ;
      // base part for lambda processing
      for(;  CConsp(  ploj);
        ploj  = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( ploj  )->cc ) ) {
          Vector_PushByValue ( StackPLOP )  (  StackClusterPrivate_stackcp (
            stclp ) , ploj   ) ;
          inEval3(*ClassCons_First(&ParaLispObjectToPLOCons(ploj)->cc),7) 
        ploj=StackClusterPrivate_PopValue(stclp);
        if(StackClusterPrivate_exceptionnotprocessed  ( stclp ))      
          break;
      }
      { ParaLispObject * x=StackClusterPrivate_PopValue(stclp);
        Environment_SetEnv  ( StackClusterPrivate_envExternal ( stclp ) , x ) ;
        x=StackClusterPrivate_PopValue(stclp);
        Environment_SetEnv  ( StackClusterPrivate_envLocal  ( stclp ) , x ) ;
      }
ToCalc:
      // meth is out by inEval
      
      methfirst =  VectorBackCopy ( StackPLOP ) (
        StackClusterPrivate_stackcMethodcp  ( stclp ) ) ;
      methfirst = CCAR ( methfirst );
      if  ( methfirst  ==  & plomacronotmod  . plo ) {
        VectorPop ( StackPLOP ) ( StackClusterPrivate_stackcMethodp ( stclp ) ) ;
        VectorPop ( StackPLOP )  ( StackClusterPrivate_stackcproArgp ( stclp ) ) ;
        VectorPop ( StackPLOP )  ( StackClusterPrivate_stackcThisp ( stclp ) ) ;
        { ParaLispObject * const x=StackClusterPrivate_PopValue(stclp);
          Environment_SetEnv  ( StackClusterPrivate_envLocal  ( stclp ) , x ) ;
        }
        inEval3 ( * StackClusterPrivate_result  ( stclp ) , 3 )
        goto  EvalReturnNotTouchEnvNotPopStack;
      }  // methodtopcar
      goto  EvalReturn;
    }  // eq lambda
    if  ( methfirst  == & plomacronotmod  . plo ) {  // eq macro or macroconst
//    const::obj macro args -> OK
//    obj macro args -> OK
      Vector_PushByValue ( StackPLOP )  ( StackClusterPrivate_stackcp  (
        stclp ) , Environment_Env ( StackClusterPrivate_envLocalc ( stclp ) ) ) ;
      StackClusterPrivate_EnvNewLevel2(stclp);
      { jmp_buf * const oldjb = Lisp2DJBglobal  ;
        jmp_buf jb2 ;
        Lisp2DJBglobal  = & jb2 ;
        int const volatile jbn2 = setjmp  ( jb2  ) ;
        if  ( not ( jbn2 ) ) {
          arglist =  StackClusterPrivate_ArgTop( stclp);
          Lisp2DJBglobal  = oldjb ;
        } else {
          Lisp2DJBglobal = oldjb ;
          ErrorStra((PArray_wchar_c){(wchar_t const (*)[])& L"eq macro: ArgTop is empty"});
          StackClusterPrivate_Popn(stclp );
          goto Exit ;
        }
      } // oldjb
      goto  LambdaEval  ;
    }
    ParaLispObject  * list [ ] = { meth,
      &  PLOString_NewCopy(L" is not lambda nor macro call")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclp,ListOfPLO((PArrayPLOP){
      (ParaLispObject*(*)[])&list}));  
    StackClusterPrivate_setresult ( stclp ,
      StackClusterPrivate_ThisTop ( stclp ) ) ;
    if  ( not  StackClusterPrivate_result ( stclp ) ) {
      StackClusterPrivate_setresult ( stclp , & plonil  . plo ) ; // ?
      goto Exit ;
    }
    goto  EvalReturnNotTouchEnv;
  } // Consp method
  //--------------args for build-in functions-----------------
  if  ( BIFp  ( meth  ) ) {
    if  ( PLOBIF_Argumtype  ( ParaLispObjectToPLOBIF ( meth ) ) ==
      NSBIF_ParaCalc ) {
// !! ArgList remove to delet_edlists
//  &rest -> CopyList(ArgList)
// turn out incredible GC call
// meth is MethodTop
ArgEval :
      if  ( not  StackClusterPrivate_flagApplystate ( stclp ) ) {
        if(CConsp(  arglist)){
          // paracalc
          flagWaitSons  = false;
          argevalfront  = & plonil.plo; // front
          argevallast = 0 ;  // last
          firstArgCalcYourSelf  = &  plonil.plo;
          consPlaceForFirstResult = &  plonil.plo;
          // create some tasks & wait, ...
          tocheck = false ;
          arglistslow = arglist ;
          do  {
            varD2 = ClassCons_First ( &ParaLispObjectToPLOCons ( arglist )->cc ) ;
            // if varD is atom -> dont make dirty work of NewStCl4
            // cycles protected by tasks limit control
            // ( .. 1 1 1 .. ) -> calculated with pauses
            // if all arguments are simple (obj fun 1 2 3) ->
            // thread will execute this task at once
            calculated  = false;
            switch(ParaLispObject_Type(varD2)){
            case  TypeGlobalListMemberPLOCons: 
              break;
            case  TypeGlobalListMemberPLOSymbol:
              // is symbol
              // speed up CreateTask : n=79.1% time=76.2%
              { ParaLispObject * const symbolassoc  = Assoc (
                varD2 , Environment_Env (  StackClusterPrivate_envLocalc  ( stclp ) ) , stclp ) ;
                if  ( symbolassoc )
                  varD2  = symbolassoc  ;
                else  {
                  ParaLispObject  * list [ ] = { & PLOString_NewCopy(L"Symbol ")
                    ->plo,varD2,& PLOString_NewCopy(L" have no value")->plo,
                    NULL } ;
                  StackClusterPrivate_ExceptionSet(stclp,ListOfPLO((PArrayPLOP){
                    (ParaLispObject*(*)[])&list}));
                  goto  EvalReturnNotTouchEnv;
                }
              }
              calculated  = true;
              break;
            case  TypeGlobalListMemberPLOQuote:
              varD2  =  PLOQuote_Item(ParaLispObjectToPLOQuote(varD2));
              calculated  = true;
              break;
            case  TypeGlobalListMemberBackQuotePrivate:           
              break;
            default:
              // returns itself
              // speed up CreateTask : n=91.42% time=96.4%
              calculated  = true  ;
            }  // switch
            if  ( argevallast ) {
              { jmp_buf jb2 ;
                jmp_buf * const oldjb = Lisp2DJBglobal  ;
                Lisp2DJBglobal  = & jb2 ;
                int const volatile jbn2 = setjmp  ( jb2  ) ;
              if  ( not ( jbn2 ) ) {
                PLOCons * const next3=NewCons(   varD2,&plonil.plo);
                  ClassCons_SetRest ( & ParaLispObjectToPLOCons ( argevallast ) ->  cc  ,
                    & next3 ->  plo ) ;
                  argevallast = & next3 ->  plo ;
                Lisp2DJBglobal  = oldjb ;
              } else {
                Lisp2DJBglobal = oldjb ;
                OutOfMemory(stclp);
                goto  EvalReturnNotTouchEnv ;
              }
              } // jb2
              // argevallast
            } else { // argevallast=nullptr
              { jmp_buf jb2 ;
            jmp_buf * const oldjb = Lisp2DJBglobal  ;
            Lisp2DJBglobal  = & jb2 ;
            int const volatile jbn2 = setjmp  ( jb2  ) ;
            if  ( not ( jbn2 ) ) {
              argevalfront  = (argevallast  =
                  &( NewCons(   varD2,&plonil.plo))->plo);
              Lisp2DJBglobal  = oldjb ;
            } else {
              Lisp2DJBglobal = oldjb ;
              OutOfMemory(stclp);
                goto  EvalReturnNotTouchEnv;
            }
            } // jb2
            }  // argevallast=nullptr
            if(not  calculated){
              // cons, backquote
              if(firstArgCalcYourSelf ==  (&  plonil.plo)){
                // was not
                firstArgCalcYourSelf  = varD2;
                // place for result
                consPlaceForFirstResult = argevallast;
              } else { // firstArgCalcYourSelf exist
                StackClusterPrivate  * const dopstclp =
                  StackClusterPrivate_NewStCl4  ( stclp ) ;
                StackClusterPrivate_setresultplace  ( dopstclp ,
                  ClassCons_PFirst (
                    &ParaLispObjectToPLOCons ( argevallast )->cc ) ) ;                    
                StackClusterPrivate_CreateTask ( dopstclp , varD2  ) ;
                flagWaitSons  = true  ;
              }
            }  // not calculated
            arglist = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( arglist )
              ->cc ) ;
            if ( tocheck ) {
              arglistslow = ClassCons_Rest  (
                & ParaLispObjectToPLOCons ( arglistslow ) -> cc ) ;
              if ( arglistslow == arglist )
                break ;
              tocheck = false ;
            } else
              tocheck = true ;            
          } while ( CConsp  ( arglist ) ) ;
          StackClusterPrivate_ReplaceArg  ( stclp , argevalfront ) ;
          if  ( firstArgCalcYourSelf not_eq  (  &  plonil.plo ) ) {
              Vector_PushByValue ( StackPLOP )  (
                StackClusterPrivate_stackcp ( stclp ) ,
                ( flagWaitSons ? 
                  & plotrue.plo  : & plofalse.plo ) ) ;
              Vector_PushByValue ( StackPLOP )  (
                StackClusterPrivate_stackcp ( stclp ) ,
                consPlaceForFirstResult ) ;
              inEval3 ( *  firstArgCalcYourSelf , 6 ) 
            consPlaceForFirstResult=StackClusterPrivate_PopValue (stclp )  ;
            { ParaLispObject * const x =StackClusterPrivate_PopValue (stclp) ;
              flagWaitSons  = ( x  ==  (  & plotrue.plo ) ) ;
            }
            ClassCons_SetFirst(&ParaLispObjectToPLOCons ( consPlaceForFirstResult )
              ->cc, StackClusterPrivate_result  ( stclp ) ) ;
          }
          // if firstArgCalcYourSelf not_eq  (&  plonil)
          if  ( flagWaitSons  ) {
            StackClusterPrivate_setTaskForManager ( stclp , TaskWaitSonsAlmost ) ;
            EvalAddrSetCont ( & StackClusterPrivate_flagcontp ( stclp )
              ->  addr . pub , Lisp2DEvalAddrContg82 ) ;
            StackClusterPrivate_flagcontp ( stclp ) -> inBIM = false ;
# ifdef  LISP2D_INNERHISTORY
            static wchar_t const  Lisp2Dwsih_eval15[] =
              L"StackCluster::Eval2():723:WaitingSonsBeforeEvalCont8:"  ;
            Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , Lisp2Dwsih_eval15  ) ;
# endif                                        
            goto  Exit  ; 
EvalCont8 :

            if(StackClusterPrivate_exceptionnotprocessed  ( stclp )){
# ifdef  LISP2D_INNERHISTORY
              static  wchar_t const  Lisp2Dwsih_eval7 [] =
                L"StackCluster::Eval2():flagWaitSons&Exception"  ;
              Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory ,
                Lisp2Dwsih_eval7  ) ;
# endif                        
              StackClusterPrivate_setresult ( stclp ,
                StackClusterPrivate_ThisTop( stclp ) ) ;
              if  ( not  StackClusterPrivate_result ( stclp ) ) {
                StackClusterPrivate_setresult ( stclp , & plonil  . plo ) ;
                goto Exit ;
              }
              goto  EvalReturnNotTouchEnv;
            }
          }
        }  // Consp(*arglist)
      } // not flagapply
      if(not  (me = StackClusterPrivate_ThisTop(stclp))) // not nullptr
        goto Exit ;
      
      { jmp_buf jb2 ;
            jmp_buf * const oldjb = Lisp2DJBglobal  ;
            Lisp2DJBglobal  = & jb2 ;
            int const volatile jbn2 = setjmp  ( jb2  ) ;
            if  ( not ( jbn2 ) ) {
              arglist =  StackClusterPrivate_ArgTop( stclp);
              Lisp2DJBglobal  = oldjb ;
            } else {
              Lisp2DJBglobal = oldjb ;
              ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
                L"Arguments calculated and ArgTop is empty"});
              goto Exit ;
            }
      } // jb2
      
      // meth is out by inWaitSons
      
      meth = VectorBackCopy  ( StackPLOP ) (
        StackClusterPrivate_stackcMethodcp  ( stclp ) ) ;
      if(CConsp(  meth))
        goto  LambdaEval; // use variable    me
    } // ParaCalc
    StackClusterPrivate_setflagApply  ( stclp , false ) ;
    //build-in functions applying
    if  ( PLOBIF_HaveMethod ( ParaLispObjectToPLOBIF ( meth  )  ) ) {
      // meth is MethodTop()
       StackClusterPrivate_flagcontp  ( stclp ) -> inBIM = true ;
BIMEval :
// !! new variable in StCl: This=me; ArgList=arglist;
// !! lesser code size
// ?? rewrite using: return bim..(..);
      { bool    flagRun=true;
        if  ( PLOBIF_isToCheckThisType  ( ParaLispObjectToPLOBIF ( meth  ) ) )
        { ParaLispObject  * const thistop = StackClusterPrivate_ThisTop ( stclp ) ;
          if ( not  thistop  ) {
            ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
              L"Eval:Stack of This is empty"});
            goto Exit ;
          }
          EvalAddrPrivat const tmpe = StackClusterPrivate_flagcont  ( stclp ) . addr ;
          if  ( EvalAddrisZero  ( & tmpe . pub ) )
            if(ParaLispObject_Type(thistop)  not_eq PLOBIF_ClassType  ( ParaLispObjectToPLOBIF ( meth ) ) ) {
              // type => name ?
              
// ! static classname is NIL !
              
              StackClusterPrivate_ExceptionSet  (stclp, & PLOString_NewCopy ( L"Type mismatch" )->plo ) ;
              
              flagRun = false;
              StackClusterPrivate_setresult ( stclp , thistop ) ;
            }
        }
              // if(static_cast<PLOBIF *>(meth)->ToCheckThisType())
//    const::obj methodconst args -> OK
//    const::obj method args -> ERROR    
//    obj methodconst args -> OK
//    obj method args -> OK        
        if  ( not  PLOBIF_FlagThisConst ( ParaLispObjectToPLOBIF ( meth ) ) ) {
          ParaLispObject  * const  thistop= StackClusterPrivate_ThisTop(
            stclp);
          if  ( thistop -> flagConst ) {
            
            ParaLispObject  * list [ ] = { thistop,& PLOString_NewCopy(
              L" is const and ")->plo,meth ,
              & PLOString_NewCopy(L" may modify object")->plo, NULL } ;
            StackClusterPrivate_ExceptionSet(stclp,ListOfPLO((PArrayPLOP){
              (ParaLispObject*(*)[])&list}));
            
            
            flagRun = false ;
          }
        }
        // StackThis is NOT empty
        if(flagRun){
// ! to make LISP2D_BIMSTATINDIVIDUAL
// ! to check BIM time for BIM with flagCheckTime
// ! to print result only for those BIM
          TaskForThread tft = TaskForThread_Analyse ;
          if  ( PLOBIF_IsExtraThread  ( ParaLispObjectToPLOBIF  ( meth  ) ) ) {
            countExtraThreads2_Inc  ( ) ;
            { tToRunExtraThread * const args = aligned_alloc ( _Alignof  ( tToRunExtraThread ) , sizeof  ( tToRunExtraThread ) ) ;
              if ( not args ) {
                Lisp2DExcOutOfMemoryGlobal . value =
                  L"Eval:aligned_alloc ( sizeof ( tToRunExtraThread ) )" ;
                longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ;
              }
              args -> bif = ParaLispObjectToPLOBIF ( meth ) ;
              args -> stclp = stclp ;
              pthread_t thr ;
              int const e = pthread_create ( & thr , 0 , & ToRunExtraThread , args ) ;
              if ( e ) {
                countExtraThreads2_Dec  ( ) ;
                ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
                  L"Eval: can't create extra thread"});
              } else {
                int const e2 = pthread_detach ( thr ) ;
                if ( e2 )
                  ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
                    L"Eval: can't detach extra thread"}); 
                tft = TaskForThread_Wait ;
              }
            }
          } else  { // not IsExtraThread
# ifdef  LISP2D_BIMSTAT
            struct  timespec  timeBegin;
            clock_gettime ( CLOCK_REALTIME  , & timeBegin ) ;
# endif            
            { jmp_buf jb2 ;
              jmp_buf * const oldjb = Lisp2DJBglobal  ;
              Lisp2DJBglobal  = & jb2 ;
              int const volatile jbn2 = setjmp  ( jb2  ) ;
              if  ( not ( jbn2 ) ) {
                tft = ( * PLOBIF_Method ( ParaLispObjectToPLOBIF  ( meth  ) ) ) ( stclp ) ;
                Lisp2DJBglobal  = oldjb ;
              } else {
                Lisp2DJBglobal = oldjb ;
                if ( jbn2 == Lisp2DExcTypeOutOfMemory )
                  StackClusterPrivate_ExceptionSet  ( stclp , & plosoutofmemory . plo ) ;
                else
                  StackClusterPrivate_ExceptionSet  ( stclp ,
                    & PLOString_NewCopy ( L"Eval: BIMethod crashed" ) -> plo ) ;
              }
            } // jb2
# ifdef  LISP2D_BIMSTAT
            struct  timespec  timeEnd ;
            clock_gettime ( CLOCK_REALTIME  , &  timeEnd  ) ;
            IncreaseStat5  ( &  timeBegin , & timeEnd , PLOBIF_Statistc ( ParaLispObjectToPLOBIF  ( meth  ) ) ) ;
# endif
          } // not IsExtraThread
          if  ( tft  ==  TaskForThread_Wait )
            return  TaskForThread_Wait  ;
        } // if flagRun
      } // flagRun
// !! This=plonil; ArgList=plonil;

// ! to make: void BIM() -> enum BIM()
// ! OR                   -> void BIM(RunningPthArgs  * rpt)
// ! to return different value to pthEval2()
// ! if StackCluster in Queue was again twice:
// ! first Thread: make extraThread, extraThread Push(stcl) in Queue
// ! second Thread: stcl processed and make TaskForManagerToQuit or Run or Else
// ! first Thread: MUST to IGNORE stcl.TaskForManager and
//   get NEXT task from the queue  

// ! dont check TaskForManager: if Method returns IGNORE and call ExtraThread
// ! simply returns
      if  ( StackClusterPrivate_TaskForManager  ( stclp ) not_eq  TaskRun )
        // simply wait
        goto Exit ;
      EvalAddrPrivat const tmpe = StackClusterPrivate_flagcont ( stclp ) . addr ;
      if  ( Lisp2DEvalAddrisZero  ( & tmpe . pub ) )
        goto  EvalReturnNotTouchEnv ;
      StackClusterPrivate_setresult ( stclp , & plonil  . plo ) ;
      // to kill garbage
      Vector_PushByValue ( StackAddrForReturn  ) (
        StackClusterPrivate_stackAddrp  ( stclp ) ,
        StackClusterPrivate_flagcont  ( stclp ) ) ;
      Lisp2DEvalAddrClear ( & StackClusterPrivate_flagcontp ( stclp ) -> addr . pub ) ;
      goto Exit ;
      // Have Method
    } else  {
      ParaLispObject  * list [ ] = { meth,&  PLOString_NewCopy(
        L" is not defined")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stclp,ListOfPLO((PArrayPLOP){
        (ParaLispObject*(*)[])&list}));
            
      StackClusterPrivate_setresult ( stclp , StackClusterPrivate_ThisTop( stclp )) ;
      if  ( not  StackClusterPrivate_result ( stclp ) ) {
        StackClusterPrivate_setresult ( stclp , & plonil  . plo ) ;
        goto Exit ;
      }
      goto  EvalReturnNotTouchEnv;
    }
    // BIFp
  } else{ // not BIFp
    // unknown function
    ParaLispObject  * list [ ] = { meth,&  PLOString_NewCopy(
      L" is not a function")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclp,ListOfPLO(
      (PArrayPLOP){(ParaLispObject*(*)[])&list}));
      
    StackClusterPrivate_setresult ( stclp , StackClusterPrivate_ThisTop(
      stclp) ) ;
    if  ( not  StackClusterPrivate_result ( stclp ) ) {
      StackClusterPrivate_setresult ( stclp , & plonil  . plo ) ;
      goto Exit ;
    }
    goto  EvalReturnNotTouchEnv ;
  }
EvalCont1 :
  //main process ending
  envtop2 = Environment_Env ( StackClusterPrivate_envLocalc ( stclp ) ) ;
EvalCont2 :
  //synchronisation for parallel program returning
  //for threads SetReady must be _after_ setting flags
  if  ( StackClusterPrivate_resultplace ( stclp ) )  
    ( * StackClusterPrivate_resultplace ( stclp ) ) =
      StackClusterPrivate_result  ( stclp ) ;
# ifdef LISP2D_DEBUG    
  if  ( StackClusterPrivate_sonscount ( stclp ) )
    ErrorStra ( (PArray_wchar_c ) {
      (wchar_t const (*)[])&L"eval::EvalCont2:sonscount<>0"});
  else
# endif        
    StackClusterPrivate_setTaskForManager ( stclp , TaskTerminate ) ;
  goto Exit ;
EvalReturn:
  Environment_ReleaseLevel  ( StackClusterPrivate_envLocal ( stclp ) ) ;
EvalReturnNotTouchEnv :
  
  VectorPop ( StackPLOP )  ( StackClusterPrivate_stackcMethodp ( stclp ) ) ;
  
  VectorPop ( StackPLOP )  ( StackClusterPrivate_stackcproArgp ( stclp ) ) ;
EvalReturnNotTouchEnvNotPopStackMA :
  
  VectorPop ( StackPLOP )  ( StackClusterPrivate_stackcThisp ( stclp ) ) ;
EvalReturnNotTouchEnvNotPopStack  :
  StackClusterPrivate_setflagApply  ( stclp , false ) ;
  
  StackClusterPrivate_setflagcontv ( stclp , 
    VectorBackCopy  ( StackAddrForReturn  ) ( StackClusterPrivate_stackAddrcp ( stclp ) ) ) ;
  
  VectorPop ( StackAddrForReturn  ) ( StackClusterPrivate_stackAddrp  ( stclp ) ) ;
  EvalAddrPrivat const tmpe = StackClusterPrivate_flagcont  ( stclp ) . addr ;
  if  ( EvalAddrisZero  ( & tmpe . pub )
    and ( not (  StackClusterPrivate_flagcont ( stclp ) . inBIM ) ) ){
# ifdef LISP2D_DEBUG    
    if  ( StackClusterPrivate_sonscount ( stclp ) )
      ErrorStra((PArray_wchar_c){(wchar_t const (*)[])
        &L"eval::EvalReturnNotTouchEnvNotPopStack:sonscount<>0"});
    else
# endif      
      StackClusterPrivate_setTaskForManager ( stclp , TaskTerminate ) ;
  }
Exit  :
  return  TaskForThread_Analyse ;
}

# include "mutex2/public.h"

# define  WakeUpAndMinusExtraThreads  Lisp2DWakeUpAndMinusExtraThreads_g8D
static  void  WakeUpAndMinusExtraThreads  ( StackClusterPrivate * const stclp ) {
  TaskQueuePush ( stclp ) ;
  Mutex2Lock  ( & Lisp2Dmutex2ManagerTasks ) ;
  if  ( flagManagerWaitSignal ) {
    flagManagerWaitSignal = false ;
    jmp_buf jb ;
    jmp_buf * const oldjb = Lisp2DJBglobal  ;
    Lisp2DJBglobal  = & jb ;
    int const volatile jbn = setjmp  ( jb  ) ;
    if  ( jbn ) {
      Lisp2DJBglobal  = oldjb ;
      Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
      longjmp ( * Lisp2DJBglobal  , jbn ) ;
    }
    ConditionSignal ( & Lisp2DsignalManager ) ;
    Lisp2DJBglobal  = oldjb ;
  }
  countExtraThreads2_Dec  ( ) ;
  Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
}

# include "stack/private.h"

void * ToRunExtraThread  ( void * const args ) {
  tToRunExtraThread * const targs = args ;
  PLOBIF * const bif = targs -> bif ;
  StackClusterPrivate * const stclp = targs -> stclp ;
  free ( args ) ;
  Lisp2DThreadStack = malloc ( Lisp2DThreadStackSIZE ) ;
  if (  not Lisp2DThreadStack ) {
    Lisp2DExcOutOfMemoryGlobal . value = 
      L"ToRunExtraThread:Lisp2DThreadStack = "
      L"malloc ( (size_t)Lisp2DThreadStackSIZE )" ;
    longjmp ( * Lisp2DJBglobal ,  Lisp2DExcTypeOutOfMemory ) ;
  }
# ifdef  LISP2D_INNERHISTORY    
  static  wchar_t  const Lisp2Dwsih_extrathread[] =
    L"void  ToRunExtraThread(PLOBIF  *  bif,StackCluster  * stcl):Start." ;
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , Lisp2Dwsih_extrathread  ) ;
# endif    
# ifdef  LISP2D_BIMSTAT
  { struct  timespec  timeBegin;
    clock_gettime(CLOCK_REALTIME,&  timeBegin);
# endif  
    { TaskForThread t = ( * PLOBIF_Method ( bif ) ) ( stclp ) ;
# ifdef  LISP2D_BIMSTAT
      { struct  timespec  timeEnd;
        clock_gettime(CLOCK_REALTIME, &  timeEnd);
        IncreaseStat5  ( &timeBegin , &timeEnd ,
           PLOBIF_Statistc ( bif ) ) ;
      }
# endif
      if(t  ==  TaskForThread_Wait){
        // ManagerTask.Lock needed only while countExtraThreads is near 1->0
        Mutex2Lock ( & Lisp2Dmutex2ManagerTasks ) ;
        countExtraThreads2_Dec  ( ) ;
        Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
        goto Exit ;
      }
    }
# ifdef  LISP2D_BIMSTAT    
  }
# endif  
  StackClusterPrivate_StackCleaning ( stclp ) ;
  WakeUpAndMinusExtraThreads  ( stclp ) ;
Exit : 
  free  ( Lisp2DThreadStack ) ;
  return  0 ; 
}
   
# include "consiter/public.h"
# include "consiter/struct.h"
# include "stack/public.h"
   
// ! to return bool flagerror
      
//  envlayer - destination
// in eval only
// variable link has free access
StackClusterPrivate * CreateLinks ( StackClusterPrivate * const mep ,
  ParaLispObject * const formp , ParaLispObject * const fact0p , PLOEnvironmentLayer  * const envlayerp ) {
# ifdef  LISP2D_BIMSTAT
  struct  timespec  timeBegin ;
  clock_gettime ( CLOCK_REALTIME  , & timeBegin ) ;
# endif
  ParaLispObject * fact  = fact0p  ;
// !! TaskPause
  //values setting
  { ThreadStackPointerType const oldstack_jo = Lisp2DThreadSP ( ) ; 
    CConsIteratorPub * const jo = NewStackCConsIterator ( ) ;
    CConsIteratorInit ( jo , formp ) ;
  for ( ; CConsIteratorHaveItem  ( jo ) ; CConsIteratorNext  ( jo ) ) {
    ParaLispObject  *   v =  CConsIteratorItem  ( jo ) ;
    //  &whole
    if  ( v  == & ploandwhole . plo ) {
      CConsIteratorNext  ( jo ) ;
      if  ( not  (  CConsIteratorHaveItem  ( jo ) ) )
        break ;
      v = CConsIteratorItem  ( jo ) ;
      if  ( not  IsNotSymbol  ( mep , v ) ) {
        if  ( EnvironmentLayerisBADPush ( & envlayerp -> envlay  , v , StackClusterPrivate_whole ( mep ) , false ) ) {
          HasConstLink  ( mep , v ) ;
          break ; 
        } 
      }
      continue  ; 
    }
    // &rest
    if  ( v  == & ploandrest . plo ) {  // eq
      CConsIteratorNext  ( jo ) ;
      if  ( not  (  CConsIteratorHaveItem  ( jo ) ) )
        break ;
      v = CConsIteratorItem  ( jo ) ;
      if  ( not  IsNotSymbol  ( mep , v ) ) {
        if  ( EnvironmentLayerisBADPush ( & envlayerp -> envlay , v , fact  , false ) ) {
          HasConstLink  ( mep ,  v ) ;
          break ; 
        } 
      }      
      continue  ; 
    }
    //  &const
    if  ( v  == & ploandconst . plo ) {
      CConsIteratorNext  ( jo ) ;
      if  ( not  (  CConsIteratorHaveItem  ( jo ) ) )
        break ;
      v = CConsIteratorItem  ( jo );
      if  ( not  IsNotSymbol  ( mep , v ) ) {
        if  ( EnvironmentLayerisBADPush ( & envlayerp -> envlay , v , CCAR ( fact  ) , true  ) ) {
          HasConstLink  ( mep , v ) ;
          break ; 
        } 
      }
      fact  = CCDR ( fact  ) ;
      continue  ; 
    }
      if  ( not  IsNotSymbol  ( mep , v ) ) {
        if  ( EnvironmentLayerisBADPush ( & envlayerp -> envlay , v , CCAR ( fact  ) , false ) ) {
          HasConstLink  ( mep ,  v ) ;
          break ;
        }
      }
      fact  = CCDR ( fact  ) ;
    } // for ConsIterator  jop
    Lisp2D_StackFree  ( oldstack_jo ) ;
  } // jop
# ifdef  LISP2D_BIMSTAT
  struct  timespec  timeEnd ;
  clock_gettime ( CLOCK_REALTIME  , & timeEnd ) ;
  IncreaseStat5  (& timeBegin ,& timeEnd , &statCreateLinks2  ) ;
# endif
  return  mep  ;
}
