// Fraction_CosSin_Eps
// ©2023 by Alex Glebe
# include "fraction/public.h"
# include "stack/public.h"

/*
;sin(2x)=2*sinx*cosx
;cos(2x)=2*((cosx)^2)-1
;sin(x)=x-(x^3)/3!+O((x^5)/5!)
;cos(x)=1-(x^2)/2+O((x^4)/4!)
('number defmethod sincoseps (eps)
  (nil  let ((this412 ((this ^ 4) / 12)))
    (nil if (eps < this412)
      (nil  let ((sc  ((this / 2) sincoseps (eps / 5))))
        (nil  list
          ((2 * (sc first) (sc second)) round (eps / 5))
          (((((sc second) ^ 2) * 2) - 1) round (eps / 5) )))
      (nil list
        ((this * (1 - ((this ^ 2) / 6))) round
          (eps  - ((this412 * this) / 10)))
        ((1 - ((this ^ 2) / 2)) round (eps - (this412 / 2))) ))))
*/

// me -> me := cos(me) , mysin := sin(me)
// eps > 0
void  Fraction_CosSin_Eps ( FractionPub * const mep , FractionPub * const mysinp , FractionPub  const * const epsp ) {
  if  ( ULongIs0  ( FractionCDenomp ( mep ) ) ) {
    FractionSetNaN ( mep ) ;
    return  ;
  }
  if ( FractionIs0 ( mep) ) {
    FractionSet0 ( mysinp) ;
    FractionSet1 ( mep) ;
    return ;
  }
  Fraction2 * const me  = Fraction_toPrivate  ( mep ) ;
  bool const meneg = me  -> flagNegative ;
  me  -> flagNegative = false ;
  ThreadStackPointerType const oldstack_epsp = Lisp2DThreadSP ( ) ;
  FractionPub * const eps2p = NewStackFraction ( ) ;
  FractionConstrCopy ( eps2p , epsp ) ;
  // abs ( eps2 )
  Fraction_toPrivate  ( eps2p ) -> flagNegative = false ;
  FractionPub * const this412p = NewStackFraction ( ) ;
  FractionConstrCopy ( this412p , mep ) ;
  // (this ^ 2)
  FractionMultConstFraction ( this412p , mep ) ;
  // (this ^ 4)
  FractionSquare  ( this412p ) ;
  // ((this ^ 4) / 12)
  FractionDivUInt ( this412p , 12U ) ;
  unsigned  int depth = 0 ;
  // (eps < this412)
  while ( FractionLess ( eps2p, this412p )  == Lisp2DBoolTrue ) {
    ++  depth ;
    // (this / 2)
    FractionDiv2 ( mep ) ;
    // (eps / 5)
    FractionDivUInt ( eps2p , 5U ) ;
    // (this /= 2) of ((this ^ 4) / 12)
    FractionDivUInt ( this412p , 16U ) ;
  }
  // sin x = x
  FractionSetFraction  ( mysinp , mep ) ;
  FractionPub * const mesp = NewStackFraction ( ) ;
  FractionConstrCopy ( mesp , mep ) ;
  // (this ^ 2)
  FractionMultConstFraction ( mesp , mep ) ;
  // ((this ^ 2) / 2)
  FractionDiv2 ( mesp ) ;
  FractionSetFraction  ( mep , mesp ) ;
  // (1 - ((this ^ 2) / 2))
  FractionSub1 ( mep ) ;
  me -> flagNegative = not (  me -> flagNegative  ) ;
  // (this412 / 2)
  FractionDiv2 ( this412p ) ;
  // (eps  - (this412 / 2))
  { ThreadStackPointerType const oldstack_eps3p = Lisp2DThreadSP ( ) ;
    FractionPub * const eps3p = NewStackFraction ( ) ;
    FractionConstrCopy ( eps3p , eps2p ) ;
    FractionSubtractConst ( eps3p , this412p ) ;
    // (this round (eps  - (this412 / 2)))
    FractionRoundStaticMove ( mep , eps3p ) ;
    Lisp2D_StackFree  ( oldstack_eps3p ) ;
  }
  // (this412 /= 5) : (this412 / 2) -> (this33 / 10)
  FractionDivUInt ( this412p , 5U ) ;
  // (this412 / 10) => ((this * this412) / 10)
  FractionMultConstFraction ( this412p ,  mysinp ) ;
  // (eps - ((this * this412) / 10))
  FractionSubtractConst ( this412p , eps2p ) ;
  { Fraction2 * const this412 = Fraction_toPrivate ( this412p ) ;
    this412 -> flagNegative = not (  this412 -> flagNegative  ) ;
  }
  // ((this ^ 2) / 2) => // ((this ^ 2) / 6)
  FractionDivUInt ( mesp , 3U ) ;
  // (1 - ((this ^ 2) / 6))
  FractionSub1 ( mesp ) ;
  { Fraction2 * const mes = Fraction_toPrivate ( mesp ) ;
    mes -> flagNegative = not (  mes -> flagNegative  ) ;
  }
  // (this * (1 - ((this ^ 2) / 6)))
  FractionMultConstFraction ( mysinp , mesp ) ;
  // ((this * (1 - ((this ^ 2) / 6))) round (eps - ((this * this412) / 10)))
  FractionRoundStaticMove ( mysinp , this412p ) ;
  while ( depth ) {
    --  depth ;
    // (2 * (sc first) (sc second))
    FractionMultConstFraction ( mysinp ,  mep ) ;
    FractionMul2 ( mysinp ) ;
    // ((2 * (sc first) (sc second)) round (eps / 5))
    FractionRoundStaticConst ( mysinp , eps2p ) ;
    // ((sc second) ^ 2)
    FractionSquare  ( mep ) ;
    // (((sc second) ^ 2) * 2)
    FractionMul2 ( mep ) ;
    // ((((sc second) ^ 2) * 2) - 1)
    FractionSub1 ( mep ) ;
    // (((((sc second) ^ 2) * 2) - 1)  round (eps / 5))
    FractionRoundStaticConst ( mep , eps2p ) ;
    // eps *= 5
    FractionMulUInt  ( eps2p , 5U  ) ;
  }
  if  ( meneg ) {
    Fraction2 * const mysin  = Fraction_toPrivate  ( mysinp ) ;
    mysin -> flagNegative = not (  mysin -> flagNegative  ) ;
  }
  Lisp2D_StackFree  ( oldstack_epsp ) ;
}
