// Lisp2D - Universal method Less , More , LessEq , MoreEq
//            for many Types
// ©2017-23 by Alex Glebe

# include "lessmore.h"
# include "boolean.h"
# include "sharedc.h"
# include "shared/inline.h"
# include "string/public.h"
# include "cons/inline.h"
# include "define.h"
# include "stcl/public.h"
# include "stcl/inline.h"

TaskForThread bimUniversalLessMore  ( FuncComparisonP const f , StackClusterPrivate * const stclpp ) {
  ParaLispObject  * j ;
  ParaLispObject  * left  ;
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) ) {
    StackClusterPrivate_Pop ( stclpp ,  & left  ) ;
    StackClusterPrivate_Pop ( stclpp ,  & j ) ;
    goto  Next  ;
  }
  left  =  StackClusterPrivate_ThisTop (  stclpp ) ;
  j =  StackClusterPrivate_ArgTop ( stclpp ) ;
Next  :
  for ( unsigned  int tasks = maxListItemProcessing ; ( tasks  > 0 ) and CConsp  (  j ) ;
    j = ClassCons_Rest  ( & ParaLispObjectToPLOCons ( j ) ->  cc ) , -- tasks  ) {
    ParaLispObject  * const xp  = ClassCons_First ( & ParaLispObjectToPLOCons ( j ) ->  cc )  ;
    switch  ( ( * f ) ( left  , xp  , stclpp  ) ) {
    case  Lisp2DBoolUndef :
    case  Lisp2DBoolConflict  :
      StackClusterPrivate_SetResult ( stclpp ,  & plonil  . plo ) ;
      goto Exit  ;
    case  Lisp2DBoolFalse :
      StackClusterPrivate_SetResult ( stclpp ,  & plofalse  . plo ) ;
      goto Exit  ;
    case  Lisp2DBoolTrue  :
      left  =    xp ;
      break ;
    default :
# ifdef  LISP2D_DEBUG
      StackClusterPrivate_ExceptionSet  ( stclpp ,  & PLOString_NewCopy (
        L"bimUniversalLessMore:switch enum reached default" ) ->  plo ) ;
      goto Exit  
# endif
      ;
    }
  }
  if  ( CConsp  (  j  ) ) {
    StackClusterPrivate_Push  ( stclpp , j  ) ;
    StackClusterPrivate_Push  ( stclpp ,   left ) ;
    StackClusterPrivate_setTaskForManager ( stclpp , TaskPause ) ;
    StackClusterPrivate_SetflagCont ( stclpp , 1U  ) ;
    goto Exit  ;
  }
  StackClusterPrivate_SetResult ( stclpp ,  StackClusterPrivate_ThisTop ( stclpp )  ) ;
Exit  :
  return  TaskForThread_Analyse ;
}
