// Lisp2D color math
// ©2007-23 by Alex Glebe

# include <stdint.h>
# include <math.h>
# include "lightmem/public.h"

# define  maxbyte Lisp2Dmaxbyte
static  long  double  const maxbyte = 255.0L  ;

long  double  Lisp2DmemorytolightLDouble ( long  double const x ) {
  if  ( x <=  4.0L )
    return x / ( maxbyte * 4.5L ) ;
  long  double  const res = powl ( ( ( x / maxbyte ) + 0.099L  ) / 1.099L , 1.0L  / 0.45L ) ;
  return ( res < 1.0L ) ? res : 1.0L ;
}

# include "cast.h"

# define  onehalf Lisp2Donehalf
static  long  double  const onehalf = 0.5L  ;

# define  multy Lisp2Dmulty
static  long  double  const multy = 4.5L  * 255.0L  ;

# define  maxcolor  Lisp2Dmaxcolor
static  uint8_t const maxcolor  = 0xffU ;

uint8_t Lisp2DlighttomemoryLDouble ( long  double  const  x ) {
  if  ( x < 0.018L  ) {
    long  double  const res = floorl ( ( x * multy ) + onehalf ) ;
    return  ( res < 0.0L ) ?
      0 :
      longdouble_cast_uint8 ( res ) ;
  }
  long  double  const res = floorl ( ( ( (  powl ( x , 0.45L ) * 1.099L  ) - 0.099L ) * maxbyte ) + onehalf ) ;
  return  ( res < maxcolor ) ?
    longdouble_cast_uint8 ( res ) :
    maxcolor ;
}

# include "lightmem/struct.h"

// ypart=0 : x
// ypart=1 : y
uint8_t  Lisp2DColorMerge  ( Lisp2DByteXY const xy , long double const ypart  ) {
  long  double  lx = Lisp2DmemorytolightLDouble ( uint8_cast_longdouble ( xy  . x ) ) ;
  { long  double  const ly = Lisp2DmemorytolightLDouble ( uint8_cast_longdouble ( xy  . y ) ) ;
    lx  += ( ( ly  - lx  ) * ypart ) ;
  }
  return  Lisp2DlighttomemoryLDouble (  lx  ) ;
}

# include "castb.h"
