// Lisp2D - Lock
// ©2021-3 by Alex Glebe
# include <stdlib.h>
# include "define.h"
# include "lock/public.h"
# ifdef  LISP2D_CONSTRSTAT  
_Atomic  ( size_t  ) PLOLockconstrstat = 0 ;

size_t  PLOLockConstrStatValue  ( void  ) {
  return  PLOLockconstrstat ;
}

void  PLOLockAddConstrStatFunc  ( void  ) {
  ++  PLOLockconstrstat ;
}
# endif

# include "plostream/public.h"

void  PLOLock_staticCoutToInterpret ( ParaLispObject const * _1 __attribute__ ((unused)) ,
  PLOStream  const * const s , bool _2 __attribute__ ((unused)) , Vector  ( StackPLOP )  * _3 __attribute__ ((unused)) ) {
  PLOStreamPushWideCharArray  ( s , ( PArray_wchar_c ) { (wchar_t const(*)[])&L"Lock"});
}

void  PLOLock_staticCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector ( StackPLOP ) * const h ) {
  PLOLock_staticCoutToInterpret ( me , s , flag2pprinted  , h ) ;
}

ParaLispObject  * PLOLock_staticTypeOf ( ParaLispObject const * _ __attribute__ ((unused)) )  {
  return  & ploslock . plo  ;
}

ParaLispObject  * PLOLock_staticClassParents  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return   ploclassparentslock ;
}

ParaLispObject  * PLOLock_staticClassDef  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return   ploclassdeflock ;
}

# include "lock/private.h"
# include "lock/struct.h"
  
PLOLockPri  * PLOLock_to_Private  ( PLOLock * const p ) {
  return  ( PLOLockPri  * ) ( ( uint8_t * ) ( p ) - offsetof  ( PLOLockPri  , pub ) ) ;
}

void PLOLock_Destr ( PLOLock * const me ) {
  PLOLockPri * const mep =  PLOLock_to_Private ( me ) ;
  QueueDestructor ( VoidP ) ( & mep -> queueMyStClPC . pub )  ;
  pthread_mutex_destroy ( & mep -> mutexQueue2  ) ; 
  ParaLispObject_staticDestr  ( & mep -> pub . plo  ) ;
}

# include "sharedc.h"
# include "shared/inline.h"
# include "stcl/public.h"
# include "stcl/inline.h"
# include "mutex2/public.h"

  // !! must be locked=true
  // returns error: not locked
bool  PLOLock_isBADUnLock ( PLOLock * const mep ) {
  PLOLockPri * const me =  PLOLock_to_Private ( mep ) ;
  if(pthread_mutex_lock(&me->mutexQueue2))
    return true;
  if  ( QueueEmpty  ( VoidP ) ( & me  ->  queueMyStClPC . pub ) ) {
# ifdef  LISP2D_DEBUG        
    { bool  oldlocked = true ;
      if ( not ( atomic_compare_exchange_weak ( &  me  ->  locked2 , & oldlocked , false ) ) ) {
        // error
        if(pthread_mutex_unlock(&me->mutexQueue2))
          return true;  
        goto Tru ;
      }
    }
# else
    if  ( not  me -> locked2  ) {
      if(pthread_mutex_unlock(&me->mutexQueue2))
        return true;  
      goto Tru ;
    }
    me -> locked2 = false ;
# endif
    if(pthread_mutex_unlock(&me->mutexQueue2)) 
      return true;  
    goto Fals ;
  }
  { void  * nextstclp3 ;
    { bool  const  flagerror = QueueIsBadPop ( VoidP ) ( & me  ->  queueMyStClPC . pub , & nextstclp3 ) ;
      if(pthread_mutex_unlock(&me->mutexQueue2))
        return true;  
      if  ( flagerror )
        goto Tru ;
    }
    StackClusterPrivate_setTaskForManager ( ( StackClusterPrivate  * ) ( nextstclp3 ) , TaskRun ) ;
    TaskQueuePush ( ( StackClusterPrivate  * ) ( nextstclp3 ) ) ;
  } //  nextstcl3
  Mutex2Lock  ( & Lisp2Dmutex2ManagerTasks  ) ;
  if  ( flagManagerWaitSignal ) {
    flagManagerWaitSignal = false ;
    jmp_buf jb2 ;
    jmp_buf * const oldjb = Lisp2DJBglobal  ;
    Lisp2DJBglobal  = & jb2 ;
    int const volatile  jbn = setjmp  ( jb2 ) ;
    if  ( jbn ) {
      Lisp2DJBglobal  = oldjb ;
      Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
      longjmp ( * Lisp2DJBglobal  , jbn ) ;
    }
    ConditionSignal ( & Lisp2DsignalManager ) ;
    Lisp2DJBglobal  = oldjb ;
    
    // nobody didnot signaling as flagManagerWaitSignal=false
    // manager will little wait
  }
  Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
Fals  :
  return  false ;
Tru :
  return  true  ;
}
  
# include "string/public.h"
# include "string/struct.h"
  
// returns true=can lock , false= cant
// if can lock -> not touch taskqueue, thread evaluate stclp yourself
bool  PLOLock_isOKTryLock3  ( PLOLock * const mep , StackClusterPrivate * const stclp  ) {
  PLOLockPri * const me =  PLOLock_to_Private ( mep ) ;
  { bool  oldlocked = false ;
    if  ( atomic_compare_exchange_weak ( & me -> locked2 , & oldlocked , true  ) ) {
      // can lock
      StackClusterPrivate_setTaskForManager ( stclp , TaskRun ) ;
      goto  RetTru  ;
    }
  }
  // still locked
  
  if(pthread_mutex_lock(&me->mutexQueue2))
    return true;  
  
  // try again to lock
  { bool  oldlocked = false ;
    if  ( atomic_compare_exchange_weak ( & me->locked2 , & oldlocked , true  ) ) {
      // queue is not needed
      if(pthread_mutex_unlock(&me->mutexQueue2))
        return true;  
      // can lock
      StackClusterPrivate_setTaskForManager ( stclp , TaskRun ) ;
      goto  RetTru  ;
    }
  }
  // now push in queue
  bool const bad = QueueIsBadPushByValue ( VoidP ) ( & me -> queueMyStClPC . pub , stclp ) ;
  if  ( pthread_mutex_unlock  ( & me  ->  mutexQueue2 ) )
    return true ;
  if ( bad )
    StackClusterPrivate_ExceptionSet  (stclp ,& PLOString_NewCopy (
      L"PLOLock::TryLock3:queueMyStCl.Push(&  stclp);" )  ->  plo ) ;
  return  false ;
RetTru  :
  return  true  ;
}
  
bool  PLOLock_isOKTryLock ( PLOLock * const mep ) {
  PLOLockPri * const me =  PLOLock_to_Private ( mep ) ;
  bool  oldlocked = false ;
  return  atomic_compare_exchange_weak ( & me -> locked2 , & oldlocked , true  ) ;
}

void PLOLock_Init ( PLOLock * const mep ) {
  PLOLockPri * const me =  PLOLock_to_Private ( mep ) ;
  ParaLispObject_InitVTP  ( & me  ->  pub . plo ,
    ( VirtualTypePointer ) { . addr = { . p = me } , . type = TypeGlobalListMemberPLOLock } ) ;
  QueueConstructorDefault ( VoidP ) ( & me  ->  queueMyStClPC . pub ) ;
  pthread_mutex_init  ( & me -> mutexQueue2 , 0 ) ;
  me -> locked2 = false ;
# ifdef  LISP2D_CONSTRSTAT
  PLOLockAddConstrStatFunc  ( ) ;
# endif  
}

PLOLock * PLOLock_malloc ( void  ) {
  PLOLockPri * const r = aligned_alloc ( _Alignof ( PLOLockPri ) , sizeof  ( PLOLockPri ) ) ;
  if ( r )
    return  & r -> pub ;
  Lisp2DExcOutOfMemoryGlobal . value = L"PLOLock_malloc" ; 
  longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ;
}

# include "newobject.h"
  
bool  IsNotLock ( StackClusterPrivate  * const stclp  , ParaLispObject * const xp ) {  
  tUniversalIsNotType ar  = {
    . stclp = stclp ,
    . xp  = xp  ,
    . typetype  = TypeGlobalListMemberPLOLock ,
    . res = false ,
  } ;
  UniversalIsNotTypess  ( & ar  ) ;
  return  ar  . res ;
}

// if mutexQueue is locked then thread->trylock3
// else check now and here
  
bool  Lockp ( ParaLispObject const * const xp ) {
  return ParaLispObject_Type(xp)==TypeGlobalListMemberPLOLock;
}
  
void PLOLock_staticDestr  ( ParaLispObject * const me ) {
  PLOLock_Destr ( ParaLispObjectToPLOLock ( me )  ) ;
}  

# include "cons/public.h"
  
// lock try lockedtask freetask
TaskForThread Lisp2Dbimlocktry2 ( StackClusterPrivate * const stclpp ) {
  PLOLock * const mep  =ParaLispObjectToPLOLock  (
    StackClusterPrivate_ThisTop(stclpp))  ;
  Lisp2DEvalAddrCont2 const  addr = StackClusterPrivate_ClearflagCont  (
    stclpp ) ;
  if  ( addr ) {
    switch  ( addr  ) {
    case  1 :
      goto  Exit  ;
    case  2 :
      goto  Next2 ;
    default :
# ifdef  LISP2D_DEBUG
      fwprintf ( stderr  , L"lock try: addr=%u\n" , (unsigned int)addr )
# endif
      ;
    }
  }
  if  ( not ( PLOLock_isOKTryLock ( mep ) ) ) {
    // cant
    StackClusterPrivate_Push (stclpp , CCAR ( CCDR ( StackClusterPrivate_ArgTop(stclpp )) ) ) ;
    StackClusterPrivate_SetflagCont ( stclpp , 1U  ) ; 
    goto  Exit  ;
  }
  // locked
  StackClusterPrivate_Push (stclpp , CCAR ( StackClusterPrivate_ArgTop(stclpp )) ) ;
  StackClusterPrivate_SetflagCont  ( stclpp , 2U  ) ; 
  goto  Exit  ;
Next2 :
  if  ( PLOLock_isBADUnLock ( mep ) ) 
    StackClusterPrivate_ExceptionSet  (stclpp , & PLOString_NewCopy ( L"Lock was not locked"  )->plo ) ;
Exit  :
  return  TaskForThread_Analyse ;
}

# include "nilc.h"

// lock unlock
TaskForThread Lisp2Dbimlockunlock2  ( StackClusterPrivate  * const stclpp  ) {
  if  ( PLOLock_isBADUnLock ( ParaLispObjectToPLOLock  ( StackClusterPrivate_ThisTop(stclpp)) ) )
    StackClusterPrivate_ExceptionSet  (stclpp ,& PLOString_NewCopy ( L"Lock was not locked"  )->plo ) ;
  else 
    StackClusterPrivate_SetResult (stclpp ,& plonil.plo  ) ;
  return  TaskForThread_Analyse ;
}

// lock set
TaskForThread Lisp2Dbimlockset2 ( StackClusterPrivate * const stclpp ) {
  if  ( StackClusterPrivate_ClearflagCont  ( stclpp ) )
    goto Exit ;
  { PLOLock * const mep  =ParaLispObjectToPLOLock ( StackClusterPrivate_ThisTop(stclpp))  ;
    if  ( not  ( PLOLock_isOKTryLock ( mep ) ) ) {
      // cant
      StackClusterPrivate_SetflagCont ( stclpp , 1U  ) ; 
      StackClusterPrivate_setTaskForManager ( stclpp , TaskWaitUnLock2 ) ;
      StackClusterPrivate_Push (stclpp ,& mep->plo  ) ;
      goto  Retu  ;
    }
  }
Exit  :
  StackClusterPrivate_SetResult (stclpp ,& plonil.plo  ) ;
Retu :
  return  TaskForThread_Analyse ;
}

# include "cons/inline.h"

// lock progn {body}
TaskForThread Lisp2Dbimlockprogn2 ( StackClusterPrivate * const stclpp ) {
  ParaLispObject  * varC  ;
  PLOLock * const mep  =ParaLispObjectToPLOLock ( StackClusterPrivate_ThisTop(stclpp))  ;
  Lisp2DEvalAddrCont2 const addr  = StackClusterPrivate_ClearflagCont  ( stclpp ) ;
  if  ( addr ) {
    switch  ( addr  ) {
    case  1 :
      goto  Next1 ;
    case  2 :
      goto  Next2 ;
    default :
# ifdef  LISP2D_DEBUG
      fwprintf ( stderr  , L"lock progn: addr=%u\n" , (unsigned int)addr )
# endif
      ;
    }
  } // if addr
  if  ( not ( PLOLock_isOKTryLock ( mep ) ) ) {
    // cant
    StackClusterPrivate_SetflagCont ( stclpp , 1U  ) ; 
    StackClusterPrivate_setTaskForManager ( stclpp , TaskWaitUnLock2 ) ;
    StackClusterPrivate_Push (stclpp ,& mep ->plo ) ;
    goto  Exit  ;
  }
Next1 :
  varC  = StackClusterPrivate_ArgTop(stclpp) ;
  for ( ; CConsp (  varC  ) ;
    varC  = ClassCons_Rest  ( &ParaLispObjectToPLOCons  ( varC  )->cc ) ) {
    StackClusterPrivate_Push (stclpp , varC  ) ;
    StackClusterPrivate_Push (stclpp , ClassCons_First(&ParaLispObjectToPLOCons ( varC  )->cc ) ) ;
    StackClusterPrivate_SetflagCont ( stclpp , 2U  ) ; 
    goto  Exit  ;
Next2 :
    StackClusterPrivate_Pop ( stclpp ,&varC  ) ;
    if  ( StackClusterPrivate_exceptionnotprocessed  ( stclpp ) ) {
      if  ( PLOLock_isBADUnLock ( mep ) )
        StackClusterPrivate_ExceptionSet  (stclpp ,& PLOString_NewCopy ( L"Lock was not locked"  )->plo ) ;
      goto  Exit  ;
    }
  } // for varC
  if  ( PLOLock_isBADUnLock ( mep ) )
    StackClusterPrivate_ExceptionSet  (stclpp ,& PLOString_NewCopy ( L"Lock was not locked"  )->plo ) ;
Exit  :
  return  TaskForThread_Analyse ;
}

# include "boolean.h"
  
// nil lockp obj
TaskForThread Lisp2Dbimnillockp2  ( StackClusterPrivate  * const stclpp  ) {
  ParaLispObject  * result  ;
  { ParaLispObject  * const xp = CCAR ( StackClusterPrivate_ArgTop(stclpp)) ;
    if  ( Lockp ( xp ) ) {
      result  = xp ;
      goto  Exit  ;
    }
  }
  result  =  & plofalse.plo  ;
Exit  :
  StackClusterPrivate_SetResult (stclpp , result  ) ;
  return  TaskForThread_Analyse ;
}

bool  PLOLock_staticisBADCopyPrivate ( ParaLispObject const * _ __attribute__ ((unused)) ,
  ParaLispObject  * * const resultp ) {
  PLOLock * const res = PLOLock_malloc ( ) ;
  if ( not res )
    return  true  ;
  PLOLock_Init  ( res ) ;
  ParaLispObject_virtualPushAsNew ( &res -> plo) ;
  ( * resultp )  = &  res ->  plo ;
  return  false ;
}
