// Lisp2D main
// ©2003-23 by Alex Glebe

# include <setjmp.h> // jmp_buf
# include <locale.h> // setlocale
# include <stdlib.h> // free
# ifndef  LISP2D_DONTUSEX11  
# include <X11/Xlib.h>  // XSupportsLocale
# endif
# include <string.h>  // memcpy
# include <sys/types.h> // umask
# include <sys/stat.h>
# include <sys/sysinfo.h> // get_nprocs
# include <stdio.h> // stderr
# include <iso646.h> // not
# include <errno.h>
# include <unistd.h>  // STDOUT_FILENO
# include "main.h"
# include "excc.h"
# ifndef  LISP2D_DONTUSEX11  
# include "window.h"
# endif
# include "sharedc.h"
# include "shared/inline.h"
# include "random/class.h"
# include "nilc.h"
# include "boolean.h"
# include "ulong/struct.h"

ULong ulongGentempsymbolindex ;

# define  ExcXSupportsLocale_castfrom_voidp Lisp2DExcXSupportsLocale_castfrom_voidp
inline  Lisp2DExcXSupportsLocale  * ExcXSupportsLocale_castfrom_voidp ( void  * const p ) {
  return  ( Lisp2DExcXSupportsLocale  * ) p ; 
}

# include "plostream/public.h"
# include <fcntl.h>
# include "ulong/public.h"
# include "cast.h"
# include "define.h"
# include "ulong/inline.h"
# include "stack/private.h"
# include "mutex2/public.h"
# include "stack/public.h"
# include "nil/inline.h"

int main  ( int const argc , char * * const argv ) {
  maxCountThreads = int_cast_uint ( get_nprocs ( ) ) ;
  
# ifdef LISP2D_DEBUG  
  char * waslocale =
# endif
    setlocale ( LC_ALL  , 0 ) ;
  char * nowlocale ;
  if  ( not ( nowlocale = setlocale ( LC_ALL  , "en_US.UTF-8" ) ) )
    nowlocale = setlocale ( LC_ALL  , "" ) ;
  //setlocale ( LC_ALL  , "C.utf8" ) ;//  windows cant XOpenIM
# ifdef LISP2D_DEBUG
  fputws  ( L"main:waslocale = " , stdout ) ;
  wprintf (
# ifdef _WIN32
    L"%S"
# else
    L"%s"
# endif  
    , waslocale ) ;
  if ( nowlocale ) {
    fputws  ( L" ; nowlocale = " , stdout ) ;  
    wprintf (
# ifdef _WIN32
      L"%S"
# else
      L"%s"
# endif  
      , nowlocale ) ; 
  }
  fputws  ( L"\n" , stdout ) ;  
# endif    
  //myLocale  = newlocale ( LC_ALL_MASK , nowlocale , (locale_t)0);
  jmp_buf jump_buffer ;
  jmp_buf * const oldjb = Lisp2DJBglobal  ;
  Lisp2DJBglobal = &  jump_buffer ;
  int volatile exctype = setjmp  ( jump_buffer ) ;
  if  (  exctype  ) {
    if ( fwprintf  ( stderr  , L"main:exctype = №%d\n"  , exctype ) < 0 )
      exit  ( exctype ) ;
    if ( fwprintf  ( stderr  , L"main:exctypename = \"%ls\"\n"  , Lisp2DExcTypeName [ exctype ] ) < 0 )
      exit  ( exctype ) ;
    switch  ( exctype  ) {
      case  Lisp2DExcTypeNULL :
        fputws ( L"main:exc value = NULL\n" , stderr ) ;
        break ;
      case  Lisp2DExcTypeString :
        fwprintf ( stderr , L"main:exc string = \"%ls\"\n" ,
          *Lisp2DExceptionStringGlobal . str ) ;
        break ;
      case  Lisp2DExcTypeXSupportsLocale :
        fputws ( L"main:" , stderr ) ;
        fputws ( * ( ( ExcXSupportsLocale_castfrom_voidp ( Lisp2Dexception . valp )
          ) -> whata ) , stderr ) ;
        if  ( ( ExcXSupportsLocale_castfrom_voidp ( Lisp2Dexception . valp ) ) -> locold  )
          wprintf (
# ifdef _WIN32
            L"%S\n"
# else
            L"%s\n"
# endif
            , ( ExcXSupportsLocale_castfrom_voidp ( Lisp2Dexception . valp ) ) -> locold  ) ;
        else
          fputws ( L"NULL" , stderr  ) ;
        free  ( Lisp2Dexception . valp  ) ;
        break ;
      case  Lisp2DExcTypeOutOfMemory :
        fwprintf ( stderr , L"main:Out of memory = \"%ls\"\n" , Lisp2DExcOutOfMemoryGlobal . value ) ;
        break ;
      case  Lisp2DExcTypeMutex :
        fwprintf ( stderr , L"main:Lisp2DExcTypeMutex = \"%ls\"\n" , Lisp2DExcMutexGlobal . value ) ;
        break ;
      default :
        fwprintf  ( stderr  , L"main:JMPexception  №%d\n"  , exctype ) ;
    }
    Lisp2Dexception . valp  = NULL  ;
    Lisp2DJBglobal = oldjb  ;
    exit  ( exctype ) ; 
  }
# ifndef  LISP2D_DONTUSEX11  
  if  ( not XSupportsLocale ( ) ) {
    Lisp2Dexception . valp  = aligned_alloc ( _Alignof ( Lisp2DExcXSupportsLocale ) , sizeof  ( Lisp2DExcXSupportsLocale ) ) ;
    if ( Lisp2Dexception . valp ) {
      memcpy  ( Lisp2Dexception . valp  , & vLisp2DExcXSupportsLocale , sizeof  ( Lisp2DExcXSupportsLocale  ) ) ;
      ExcXSupportsLocale_castfrom_voidp ( Lisp2Dexception . valp ) -> locold = setlocale ( LC_ALL  , NULL ) ;
      longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeXSupportsLocale ) ;
    } else {
      Lisp2DExcOutOfMemoryGlobal . value =
        L"not XSupportsLocale:Lisp2Dexception . valp  = "
        L"aligned_alloc  ( sizeof  ( Lisp2DExcXSupportsLocale  ) )" ;
      longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ;
    }
  }
# endif

  umask ( 0 ) ; // for mkdir & open
  PLOBoolean_Init ( & plofalse  ) ;
  ParaLispObject_SetFlagStaticTrue  ( & plofalse  . plo ) ;
  PLOBoolean_Init ( & plotrue ) ; 
  ParaLispObject_SetFlagStaticTrue  ( & plotrue . plo ) ;
  PLONilConstr  ( & plonil  ) ;
  ParaLispObject_SetFlagStaticTrue  ( & plonil  . plo ) ;
  PLOStreamInitFD ( & Lisp2Dferr , true , STDERR_FILENO  , O_WRONLY ) ;
  ParaLispObject_SetFlagStaticTrue  ( & Lisp2Dferr  . plo ) ;
  PLOStreamInitFD ( & Lisp2Dfout , true , STDOUT_FILENO  , O_WRONLY ) ;
  ParaLispObject_SetFlagStaticTrue  ( & Lisp2Dfout  . plo ) ;
  PLOStreamInitFD ( & Lisp2Dfin , true , STDIN_FILENO  , O_RDONLY ) ;
  ParaLispObject_SetFlagStaticTrue  ( & Lisp2Dfin . plo ) ;
  VectorInit  ( NameSpaceDefC ) ( & namespacedefc , false ) ;
  GlobalListConstructor ( & GlobalListOfObjects ) ;
  GlobalListConstructor ( & GlobalListOfObjectsGarbage ) ;
  Mutex2Constructor  ( & Lisp2Dmutex2ManagerTasks , NULL  ) ;
  ConditionConstructor  ( & Lisp2DsignalManager , NULL  ) ;
# ifndef  LISP2D_DONTUSEX11
  ConditionConstructor  ( & Lisp2DsignalWindowsExit , NULL ) ;
  Mutex2Constructor  ( & Lisp2DmutexWindowsExit , NULL) ;
# endif
  Mutex2Constructor  ( & Lisp2DmutexNameSpace , NULL  ) ;
  Mutex2Constructor  ( & Lisp2DmutexGenTemp , NULL  ) ;
  Mutex2Constructor  ( & Lisp2DMutexTreeSymbols , NULL  ) ;
  Lisp2DRandomInit  ( ) ;

  Lisp2DThreadStack = aligned_alloc ( _Alignof ( uint8_t ) , sizeof ( uint8_t ) * Lisp2DThreadStackSIZE ) ;
  if (  not Lisp2DThreadStack ) {
    Lisp2DExcOutOfMemoryGlobal . value = 
      L"main:Lisp2DThreadStack = aligned_alloc ( Lisp2DThreadStackSIZE )";
    longjmp ( * Lisp2DJBglobal ,  Lisp2DExcTypeOutOfMemory ) ;
  }
  StackTypesInit ( ) ;
  ULong_Init  ( ULongToPub ( & ulongGentempsymbolindex ) ) ;
  
  mainCPP  ( & argc , argv , & exctype ) ;
  
  ULongDestrPub ( ULongToPub  ( & ulongGentempsymbolindex ) ) ;
  free  ( Lisp2DThreadStack ) ;
  
  Lisp2DRandomDestr  ( ) ;
  Mutex2Destructor  ( & Lisp2DMutexTreeSymbols ) ;
  Mutex2Destructor  ( & Lisp2DmutexGenTemp ) ;
  Mutex2Destructor  ( & Lisp2DmutexNameSpace ) ;
# ifndef  LISP2D_DONTUSEX11
  ConditionDestructor  ( & Lisp2DsignalWindowsExit ) ;
  Mutex2Destructor  ( & Lisp2DmutexWindowsExit ) ;
# endif
  ConditionDestructor ( & Lisp2DsignalManager ) ;
  Mutex2Destructor  ( & Lisp2Dmutex2ManagerTasks ) ;
  Lisp2DJBglobal = oldjb  ;

  GlobalListDestructor ( & GlobalListOfObjectsGarbage ) ;


  // fwprintf  ( stderr  , L"& GlobalListOfObjects = %p\n" , & GlobalListOfObjects ) ;
  { ParaLispObject * objectsi  = GlobalListMemberVirt ( GlobalListFirst ( & GlobalListOfObjects  ) ) . addr . p ;
    while ( objectsi ) {
      // fwprintf  ( stderr  , L"p = %p " , objectsi ) ; fflush ( stderr ) ;
      // fwprintf  ( stderr  , L"v = %p " , GlobalListMemberNext ( & objectsi -> base  ) ) ; fflush ( stderr ) ;
      GlobalListMember  * const mp  = GlobalListMemberNext ( & objectsi -> base  ) ;
      ParaLispObject * const next = ( mp ? GlobalListMemberVirt ( mp ) . addr . p : 0 ) ;
      //fwprintf  ( stderr  , L"n = %p " , next ) ; fflush ( stderr ) ;
      bool  const wasStatic = ParaLispObject_IsStatic ( objectsi  ) ;
      ParaLispObject_virtualDestr  ( objectsi ) ;
      // removing NOT ParaLispObject,
      // BUT full object with private members and .plo field
      // fwprintf  ( stderr  , L"p -> vaddr . addr = %p " , objectsi -> vaddr . addr ) ; fflush ( stderr ) ;
      if  ( not wasStatic )
        free  ( objectsi -> vaddr . addr . p ) ;
    // !? to free or not to free ?!
      // p -> vaddr . addr = 0x4c5b40 free(): invalid pointer

      objectsi  = next  ;
    }
  }
  GlobalListDestructor ( & GlobalListOfObjects ) ;
  Vector_Destr  ( NameSpaceDefC ) ( & namespacedefc ) ;
  return  exctype ; 
}

# include "castb.h"
