// Lisp2D - Main task manager
// ©2004-23 by Alex Glebe
# include "thread.h"
# include "inerrors.h"
# include "gc.h"
# include "manager.h"
# include "define.h"
# include "sharedc.h"
# include "errorstra.h"
# include "stcl/classc.h"
# include "stcl/inline.h"
# include "globallista/public.h"
# include "inner-history/inline.h"
# include "mutex2/public.h"

// !!! to make: All threads must have Father's low
// kill Manager
void  Manager ( void  ) {
  jmp_buf jb ;
# ifdef  LISP2D_INNERHISTORY
  { jmp_buf * const oldjb = Lisp2DJBglobal ;
    Lisp2DJBglobal  = & jb ;
    int const volatile  jbn = setjmp  ( jb  ) ;
    if  ( jbn ) {
      Lisp2DJBglobal  = oldjb ;
      fwprintf  ( stderr , L"Manager:Lisp2DInnerHistoryPush:crash error=%d\n" , jbn ) ;
      return  ;
    }
    # define  wsih_manager  Lisp2Dwsih_managerrNhz
    static  wchar_t  const wsih_manager[]  = L"void  Manager()"  ;      
    Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager ) ;
    Lisp2DJBglobal  = oldjb ; 
  } // oldjb
# endif  
  StackClusterPrivate  * currclusterp = 
    GlobalListMemberToStackClusterPrivate (
      GlobalListAtomicFirst ( & Lisp2DGlobalListOfStackClusters2 )  )  ;
# ifdef  LISP2D_DEBUG  
  if  ( StackClusterPrivate_wanttobeingarbage  ( currclusterp ) ) {
    ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
      L"Manager:currclusterp->WantToBeInGarbage"});
    return  ;
  }
  if  ( not currclusterp  ) {
    ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
      L"Manager: currclusterp==nullptr"});
    return;
  }
# endif  
  bool    ststclisempty = false ;
# ifdef  LISP2D_INNERHISTORY
# define  wsih_manager4 Lisp2Dwsih_manager4OnmQ
  static  wchar_t  const wsih_manager4[] = L"void  Manager():prepare to lock"  ;  
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager4  ) ;
# endif  
  Mutex2Lock  ( & Lisp2Dmutex2ManagerTasks  ) ;
# ifdef  LISP2D_INNERHISTORY
# define  wsih_manager3 Lisp2Dwsih_manager3QFaB
  static  wchar_t  const wsih_manager3[] = L"void  Manager():inside lock";  
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager3  ) ;
# endif    
  do{
    //check for GC
    //to debuging close
CheckForGC:
    if(Lisp2DTimeToGC()){
# ifdef  LISP2D_INNERHISTORY
# define  wsih_manager5 Lisp2Dwsih_manager5QskO
  static  wchar_t  const wsih_manager5[] = L"void  Manager():TimeToGC" ;      
      Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager5  ) ;
# endif            
      // waiting for all tasks finished
      flagStopToGC  = true;
      if( flagThreadsShutDown ){
        Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
        return ;
      }
# ifdef  LISP2D_INNERHISTORY
# define  wsih_manager7 Lisp2Dwsih_manager75lPC
      static  wchar_t  const wsih_manager7[] =
        L"void  Manager():TimeToGC:not flagThreadsShutDown" ;
      Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager7  ) ;
# endif                      
      while ( runpthcount_Value ( ) > 0 ) {
# ifdef  LISP2D_INNERHISTORY
# define  wsih_manager6 Lisp2Dwsih_manager6TVq1
        static  wchar_t  const wsih_manager6[] =
          L"void  Manager():stoptoGC:while(runpthcount2  > 0)"  ;
          Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager6  ) ;
# endif                       
        flagManagerWaitSignal = true  ;
        { jmp_buf jb2 ;
          jmp_buf * const oldjb = Lisp2DJBglobal  ;
          Lisp2DJBglobal  = & jb2 ;
          int const volatile  jbn2  = setjmp  ( jb2 ) ;
          if  ( jbn2 ) {
            Lisp2DJBglobal  = oldjb ;
            Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
            longjmp ( * Lisp2DJBglobal  , jbn2 ) ;
          }
          ConditionWait ( & Lisp2DsignalManager , & Lisp2Dmutex2ManagerTasks ) ;
          Lisp2DJBglobal  = oldjb ;
        }
        if  ( flagThreadsShutDown ) {
          Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
# ifdef  LISP2D_INNERHISTORY
# define  wsih_manager12 Lisp2Dwsih_manager12YsFX
          static  wchar_t  const wsih_manager12[] =
            L"void  Manager():Lisp2DTimeToGC,while( Lisp2D :: runpthcount >"
            L"0),flagThreadsShutDown"  ;
          Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager12 ) ;
# endif            
          return  ;
        }
      }
      { jmp_buf jb3 ;
        jmp_buf * const oldjb3 = Lisp2DJBglobal  ;
        Lisp2DJBglobal  = & jb3 ;
        int const volatile  jbn3 = setjmp  ( jb3 ) ;
        switch  ( jbn3  ) {
        case  0 :
          GarbageCollector  ( ) ;
          Lisp2DJBglobal  = oldjb3 ;
          break ;
        default :
          Lisp2DJBglobal  = oldjb3 ;
          ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
            L"Manager() GC-crashed"});
          goto  Quit  ;
        }
      }
      goto  Next;
Quit:
      flagThreadsShutDown = true;
      Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
# ifdef  LISP2D_DEBUG
  # ifdef  LISP2D_INNERHISTORY
      static  wchar_t  const wsih_manager75[]  =
        L"void  Manager():QuitFromGCCrash"  ;
      Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager75  ) ;
  # endif
# endif // LISP2D_DEBUG
      return;
Next:        
      flagStopToGC  = false;
      // don't sleep
      // full lock - thread's new task not accepted
# ifdef  LISP2D_INNERHISTORY
# define  wsih_manager8 Lisp2Dwsih_manager8Xk2D
      static  wchar_t  const wsih_manager8[] =
        L"void  Manager():AfterGC:start threads"  ;
      Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager8  ) ;
# endif                              
      Lisp2DMutexLock ( & Lisp2DMutexQueueAtomicStClLastC )  ;
      { jmp_buf jb2 ;
        jmp_buf * const oldjb = Lisp2DJBglobal  ;
        Lisp2DJBglobal = & jb2 ;
        int const volatile  jbn2  = setjmp  ( jb2 ) ;
        if  ( jbn2 ) {
          Lisp2DJBglobal = oldjb ;
          Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClLastC )  ;
          longjmp(jb,jbn2);
        }
        Lisp2DMutexLock ( & Lisp2DMutexQueueAtomicStClFirstC ) ;
      if  ( ConsAtomicPointerFirst ( queueAtomicStClPrivFirst  ) ) {
        unsigned  int imax  = maxCountThreads ;
        RunningPthArgs  * runpthargsi =  runpthargs ;
        do {
          runpthargsi -> taskp = ( StackClusterPrivate * ) (
            ConsAtomicPointerFirst ( queueAtomicStClPrivFirst  ) ) ;
          runpthcount_Inc ( ) ;
          runpthargsi ->  flagWaitSignal = false  ;
          if  ( pthread_cond_signal ( & runpthargsi ->  condrunning2  ) ) {
            Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClLastC )  ;
            Lisp2DExceptionStringGlobal . str = (wchar_t const(*)[])& 
              L"Manager:pthread_cond_signal(&runpthargsi->condrunning2)" ; 
            longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
          }
          ++  runpthargsi ;
          queueAtomicStClPrivFirst  = ConsAtomicPointerRest  ( queueAtomicStClPrivFirst  ) ;
          // was last  
          if  ( not ConsAtomicPointerFirst ( queueAtomicStClPrivFirst  ) )
            break ;
          --  imax  ;
        } while ( imax > 0 ) ;
      } else {
# ifdef  LISP2D_INNERHISTORY        
        static  wchar_t  const wsih_manager10[]  =
          L"void  Manager():AfterGC:queue is empty" ;
        Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager10  ) ;
# endif                                                
      }
        int const volatile  jbn3 = setjmp  ( jb2  ) ;
        if  ( jbn3 ) {
          Lisp2DJBglobal = oldjb ;
          Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClLastC )  ;
          longjmp ( jb  , jbn3  ) ;
        }
        Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClFirstC );
        Lisp2DJBglobal = oldjb ;
      } // jb2
      
      Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClLastC )  ;
# ifdef  LISP2D_INNERHISTORY
      static  wchar_t  const wsih_manager9[] =
        L"void  Manager():AfterGC:start threads finished" ;
      Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager9  ) ;
# endif                                      
    }  //  if TimeToGC
    if  ( ( unsigned int ) ( runpthcount_Value ( ) ) ==  maxCountThreads ) {
# ifdef  LISP2D_INNERHISTORY
      static  wchar_t  const wsih_manager15[]  =
        L"void  Manager():after if(Lisp2DTimeToGC()):static_cast<unsigned int>( "
        L"Lisp2D :: runpthcount ) ==  Lisp2D :: maxCountThreads" ;
      Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager15 ) ;
# endif            
      if( flagThreadsShutDown ){
        Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
        return ;
      }
      flagManagerWaitSignal  = true ;
# ifdef  LISP2D_INNERHISTORY
      static  wchar_t  const wsih_manager11[]  = L"void  Manager():wait task"  ;
      Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager11  ) ;
# endif               
    { jmp_buf jb2 ;
      jmp_buf * const oldjb = Lisp2DJBglobal  ;
      Lisp2DJBglobal  = & jb2 ;
      int const volatile  jbn2 = setjmp  ( jb2  ) ;
      if  ( jbn2 ) {
        Lisp2DJBglobal  = oldjb ;
        Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
        longjmp ( * Lisp2DJBglobal  , jbn2 ) ;
      }
      ConditionWait ( & Lisp2DsignalManager , & Lisp2Dmutex2ManagerTasks ) ;
      Lisp2DJBglobal  = oldjb ;
    }
# ifdef  LISP2D_INNERHISTORY
      static  wchar_t  const wsih_manager13[]  =
        L"void  Manager():signal received"  ;
      Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager13  ) ;
# endif               
      if( flagThreadsShutDown ) {
        Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
        return ;
      }
      goto  CheckForGC ;
    } // if maxCount
    // don't sleep
    // full lock
    Lisp2DMutexLock ( & Lisp2DMutexQueueAtomicStClFirstC ) ;
    if  ( ConsAtomicPointerFirst ( queueAtomicStClPrivFirst  ) ) {
# ifdef  LISP2D_INNERHISTORY
      static  wchar_t  const wsih_manager143[]  =
        L"if  ( ConsAtomicPointerFirst ( queueAtomicStClPrivFirst  ) )" ;
      Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_manager143 ) ;
# endif      
      currclusterp = ( StackClusterPrivate * ) (
        ConsAtomicPointerFirst ( queueAtomicStClPrivFirst  ) ) ;
      queueAtomicStClPrivFirst  = ConsAtomicPointerRest ( queueAtomicStClPrivFirst  ) ;
      Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClFirstC );
    } else {
      // empty
      // ! to make ONE countAnotherThreads=Summ(win+sys+readchar)
      if  ( ( runpthcount_Value ( ) ==  0 )
# ifndef  LISP2D_DONTUSEX11        
        and ( CountWindowsThreads2  ( ) ==  0) 
# endif        
        and ( countExtraThreads2Value ( ) ==  0 ) ) {
        // !?         
        Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClFirstC );
        break ;
      } // count == 0
      Lisp2DMutexUnLock ( & Lisp2DMutexQueueAtomicStClFirstC );
      if  ( GlobalListAtomicEmpty ( & Lisp2DGlobalListOfStackClusters2  ) ) {
        Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
        return ;
      }
      flagManagerWaitSignal  = true ;
      { jmp_buf jb2 ;
        jmp_buf * const oldjb = Lisp2DJBglobal  ;
        Lisp2DJBglobal  = & jb2 ;
        int const volatile  jbn2 = setjmp  ( jb2  ) ;
        if  ( jbn2 ) {
          Lisp2DJBglobal  = oldjb ;
          Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
          longjmp ( * Lisp2DJBglobal  , jbn2 ) ; 
        }
        ConditionWait ( & Lisp2DsignalManager , & Lisp2Dmutex2ManagerTasks ) ;
        Lisp2DJBglobal  = oldjb ;
      }
      if( flagThreadsShutDown ){
        Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
        return ;
      }
      goto  CheckForGC ;
    }
# ifdef  LISP2D_DEBUG
    { bool  running = false ;
# endif
    { RunningPthArgs  * rpi = runpthargs ;
      for ( unsigned  int i = maxCountThreads ; i  >  0 ; ++ rpi  ) {
        --  i;
        if  ( not ( rpi ->  taskp ) ) {
          rpi->taskp  = currclusterp ;
          runpthcount_Inc ( ) ;
# ifdef  LISP2D_DEBUG
          running  = true ;
# endif
# ifdef  LISP2D_DEBUG
          if(rpi->flagWaitSignal){
# endif
            rpi->flagWaitSignal = false;
            if(pthread_cond_signal(&rpi->condrunning2)){
              Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
              Lisp2DExceptionStringGlobal . str = (wchar_t const(*)[])& 
                L"Manager:pthread_cond_signal(&rpi->condrunning2)" ; 
              longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
            }
# ifdef  LISP2D_DEBUG
          } else
            ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
              L"manager: 2. thread don't want signal"});
# endif
          break;
        }
      }
    } // rpi
# ifdef  LISP2D_DEBUG
    if(not  running ){
      Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
      { int const tmp = runpthcount_Value ( ) ;
        inErrorS(
          PLOStreamPushWideCharArray  ( &Lisp2Dferr ,
            ( PArray_wchar_c ) { (wchar_t const(*)[])&
              L"Manager: have not found task==nullptr runpthcount="});
        PLOStreamPushInt(&Lisp2Dferr,tmp);) 
      } // tmp
      TaskQueuePush ( currclusterp ) ;
      return;
    }
    } // running
# endif
    // ! to make ONE countAnotherThreads=Summ(win+sys+readchar)
    ststclisempty = ( ( countStackClusterWantToBeInGarbage_Value ( ) ==  
          GlobalListAtomicSize ( & Lisp2DGlobalListOfStackClusters2  )  )
# ifndef  LISP2D_DONTUSEX11    
      and ( CountWindowsThreads2  ( ) ==  0  )  
# endif      
      and ( countExtraThreads2Value ( ) ==  0  ) ) ;
  } while((not ststclisempty)  and (not  flagThreadsShutDown ));
  Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
} // Manager
# include "shared/inline.h"
