// Lisp2D - Universal method Min , Max
//            for many Types
// ©2017-23 by Alex Glebe

# include "minmax.h"
# include "sharedc.h"
# include "shared/inline.h"
# include "cons/inline.h"
# include "stcl/public.h"
# include "stcl/inline.h"
  
TaskForThread bimUniversalMinMax  ( FuncComparisonP const f , StackClusterPrivate * const stclpp ) {
  ParaLispObject  * res ;
  { ParaLispObject  * j ;
    unsigned  int tasks = maxListItemProcessing  ;
    if  ( StackClusterPrivate_ClearflagCont ( stclpp ) ) {
      StackClusterPrivate_Pop ( stclpp ,  & res ) ;
      StackClusterPrivate_Pop ( stclpp ,  & j ) ;
      goto  Next  ;
    }
    res =  StackClusterPrivate_ThisTop  ( stclpp )  ;
    j = StackClusterPrivate_ArgTop  ( stclpp )  ;
    while ( CConsp  ( j ) ) {
Next  :
      { ParaLispObject  * const xp  = ClassCons_First ( & ParaLispObjectToPLOCons ( j ) ->  cc  ) ;
        switch  ( (  * f  ) (  res  , xp  , stclpp  ) ) {
        case  Lisp2DBoolTrue  :
          break ;
        case  Lisp2DBoolFalse :
          res = xp ;
          break ;
        case  Lisp2DBoolUndef :
        case  Lisp2DBoolConflict  :
          StackClusterPrivate_SetResult ( stclpp  , & plonil  . plo ) ;
          goto  Exit  ;
        default : ; 
        }
      }
      j = ClassCons_Rest  ( & ParaLispObjectToPLOCons ( j ) ->  cc ) ;
      if  ( ( --  tasks )  ==  0  ) {
        if  ( CConsp  (  j  ) ) {
          StackClusterPrivate_Push  ( stclpp , j  ) ;
          StackClusterPrivate_Push  ( stclpp , res  ) ;
          StackClusterPrivate_setTaskForManager ( stclpp , TaskPause ) ;
          StackClusterPrivate_SetflagCont ( stclpp , 1U  ) ;
          goto  Exit  ;
        }
        break ;
      } 
    } 
  }
  StackClusterPrivate_SetResult ( stclpp ,  res ) ;
Exit  :
  return  TaskForThread_Analyse ; 
}
