// Lisp2D - users objects
// ©2006-23 by Alex Glebe
# include "define.h"
# include "object/inline.h"
# ifdef  LISP2D_CONSTRSTAT
_Atomic ( size_t ) PLOObject_constrstat = 0 ;

void  PLOObject_constrstat_Inc  ( void  ) {
  ++  PLOObject_constrstat  ;
}

size_t  PLOObject_constrstat_Value  ( void  ) {
  return  PLOObject_constrstat  ;
}
# endif // LISP2D_CONSTRSTAT

void  PLOObject_Destr ( PLOObject * const me  ) {
  ParaLispObject_staticDestr  ( & me  ->  plo ) ;
}

void PLOObject_staticDestr  ( ParaLispObject * const  me  ) {
  PLOObject_Destr ( ParaLispObjectToPLOObject ( me  ) ) ;
}

ParaLispObject  * PLOObject_staticContext ( ParaLispObject const * const me ) {
  PLOEnvironmentLayer * const c = ParaLispObjectToPLOObjectConst  ( me  ) -> pri . context ;
  return  ( c  ?  ( & c ->  plo ) : & plonil.plo  ) ;
}

# include "object/bim.h"
# include "stcl/classc.h"
# include "boolean.h"
# include "cons/inline.h"
# include "stcl/public.h"
# include "stcl/inline.h"

// nil objectp
TaskForThread Lisp2Dbimnilobjectp2  ( StackClusterPrivate  * const stclpp  ) {
  ParaLispObject  * const xp = CCAR ( StackClusterPrivate_ArgTop  ( stclpp ) )  ;
  StackClusterPrivate_SetResult ( stclpp , ( Objectp ( xp ) ? xp : & plofalse  . plo ) ) ;
  return  TaskForThread_Analyse ;
}

# include "gc.h"
# include "sharedc.h"
# include "shared/inline.h"

void  PLOObject_staticGCDeclareContent ( ParaLispObject * const me ) {
  PLOObject * const o = ParaLispObjectToPLOObject ( me  ) ;
  PLOSymbolDeclareForGC ( & o -> pri . classname -> plo ) ;
  UniversalDeclareForGC  ( & o -> pri . context -> plo ) ;
  ParaLispObject_virtualDeclareForGC ( o -> pri . parents ) ;
  ParaLispObject_virtualDeclareForGC ( o -> pri . classdef ) ;
}

# include "env/public.h"

bool  PLOObject_staticisBADCopyPrivate ( ParaLispObject const * const me , ParaLispObject  * * const resultp  ) {
  { PLOObject * const  res  = aligned_alloc ( _Alignof ( PLOObject ) , sizeof ( PLOObject ) ) ;
    if  ( res ) {
      PLOObject_Init  ( res ) ;
      ParaLispObject_virtualPushAsNew (&res -> plo ) ;
      PLOObject const * ome = ParaLispObjectToPLOObjectConst ( me ) ;
      PLOObject_SetClassName  ( res , & ome -> pri . classname -> plo ) ;
      if  ( not ( ome -> pri . context ) ) {
        ( * resultp ) = & res ->  plo ;
        return  false ;
      }
      { ParaLispObject  * rescon  ;
        if  ( ParaLispObject_isBADCopy ( & ome -> pri . context -> plo , & rescon  ) )
          return  true  ;
        PLOObject_SetNewContext ( res , PLOEnvironmentLayer_FromMember ( & rescon  ->  base  ) ) ;
      }
      if  ( not ( EnvironmentLayerisOKTryChangeValueIgnoreWasConst  ( & (
            PLOEnvironmentLayer_FromMember ( &
              PLOObject_staticContext  (
                & res -> plo ) -> base ) -> envlay )  , & plosthis . plo  ,
                &  res -> plo , true  ) ) )
        return  true  ;
      ( * resultp ) = & res -> plo ;
      return  false ;
    } // if res
  } // res
  return  true  ;
}

void  PLOObject_SetNewContext ( PLOObject * const me , PLOEnvironmentLayer * const lp ) {
  me -> pri . context = lp ;
}

ParaLispObject  * PLOObject_staticClassDef  ( ParaLispObject const * const me ) {
  return  ParaLispObjectToPLOObjectConst  ( me  ) -> pri . classdef ;
}

ParaLispObject  * PLOObject_staticClassParents  ( ParaLispObject const * const me ) {
  return  ParaLispObjectToPLOObjectConst  ( me  ) -> pri . parents ;
}

ParaLispObject  * PLOObject_staticTypeOf ( ParaLispObject const * const me ) {
  return  & ParaLispObjectToPLOObjectConst ( me  ) -> pri . classname -> plo ;
}

# include "plostream/public.h"
    
# define  PLOObjectCout Lisp2D_PLOObjectCout_vWQF
// ! to remove CONST from PLOStream    
static  void  PLOObjectCout  ( PLOObject * const me , FuncCoutToInterpretHuman funccout  ,
  PLOStream  const * const osp , bool flagpprinted , Vector  ( StackPLOP ) * const lookingp ) {
  if  ( Printed3Points  ( & me -> plo ,  osp  , & flagpprinted ,  lookingp ) )
    return  ;
  Vector_PushByValue  ( StackPLOP ) ( lookingp , & me -> plo ) ;
  funccout  ( & me -> pri . classname -> plo ,  osp  , &  flagpprinted   ,  lookingp ) ;
# ifdef  LISP2D_DEBUG  
  PLOStreamPushWChar  (  osp ,  L'('  ) ;
  if  ( me -> pri . context )
    funccout  ( & me -> pri . context -> plo ,  osp  , &  flagpprinted  , lookingp ) ;
  PLOStreamPushWChar  (  osp  , L')'  ) ;
# endif                        
  VectorPop ( StackPLOP ) ( lookingp ) ;
}

void  PLOObject_staticCoutToInterpret ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector ( StackPLOP )  * const h ) {
  PLOObjectCout  (  ParaLispObjectToPLOObject ( ( ParaLispObject * ) me  ) ,
    ParaLispObject_CoutToInterpret , s , flag2pprinted , h ) ;
}

void  PLOObject_staticCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector ( StackPLOP )  * const h ) {
  PLOObjectCout  (  ParaLispObjectToPLOObject ( ( ParaLispObject * ) me  ) ,
    ParaLispObject_CoutToHuman , s , flag2pprinted ,  h ) ;
}

# include "inerrors.h"
  
void  PLOObject_SetClassName  ( PLOObject * const me , ParaLispObject  * const cnp  ) {
  switch  ( ParaLispObject_Type  ( cnp ) ) {
  case  TypeGlobalListMemberPLONil :
    me -> pri . classname = & plosnil ;
    break ;
  case  TypeGlobalListMemberPLOBoolean :
    me -> pri . classname = & plosboolean ;
    break ;
  case  TypeGlobalListMemberPLOSymbol  :
    me -> pri . classname = ParaLispObjectToPLOSymbol (  cnp  )  ;
    break ;
  default :
    inErrorS  (
      PLOStreamPushWideCharArray  ( & Lisp2Dferr ,
        ( PArray_wchar_c ) { (wchar_t const(*)[])&
          L"PLOObject_SetClassName:  " });
      PLOStreamPushPLO(& Lisp2Dferr , cnp);
      PLOStreamPushWideCharArray  ( & Lisp2Dferr , ( PArray_wchar_c ) {
        (wchar_t const(*)[])&L" is not symbol" }  ) ; )
  }
}

void  PLOObject_Init ( PLOObject * const me ) {
  me -> pri . classname = & plosnil ;
  me -> pri . context = 0 ;
  me -> pri . parents = &  plonil . plo ;
  me -> pri . classdef = & plonil . plo ;
  VirtualTypePointer const vtp = { . addr = { . p = me } , . type = TypeGlobalListMemberPLOObject } ;
  ParaLispObject_InitVTP ( & me -> plo , vtp ) ;
# ifdef  LISP2D_CONSTRSTAT
  PLOObject_constrstat_Inc  ( ) ;
# endif
}
