// Lisp2D 2022-3 Parallel Lisp Object
# include <stdio.h>
# include "plo/struct.h"
# include "nilc.h"
# include "globallistp/struct.h"

//  ParaLispObject*
GlobalList  GlobalListOfObjects ;
GlobalList  GlobalListOfObjectsGarbage  ;

# include "define.h"

# ifdef LISP2D_DEBUG
void  ParaLispObject_staticDestr  ( ParaLispObject * const me ) {
  if  ( me -> objstate not_eq Lisp2DObjectStateConstructed )  {
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) &
      L"~ ParaLispObject:objstate not_eq  Lisp2DObjectStateConstructed\n" ;
    fputws  ( * Lisp2DExceptionStringGlobal . str , stderr ) ;
    longjmp ( * Lisp2DJBglobal  , Lisp2DExcTypeString ) ;
  }
  me -> objstate = Lisp2DObjectStateDestructed ;
}
# else
void  ParaLispObject_staticDestr  ( ParaLispObject * const _ __attribute__ ((unused)) ) {
}
# endif //  LISP2D_DEBUG
  
void ( * ParaLispObjectvirttableDestr  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject * ) ;
    
void ParaLispObject_virtualDestr ( ParaLispObject * const me ) {
  ParaLispObjectvirttableDestr [ me ->  vaddr . type ]  ( me ) ;
}

# include "globallistm/inline.h"
  
void ( * ParaLispObjectvirttableGCDeclareContent [  TypeGlobalListMemberSIZE ] ) ( ParaLispObject * ) ;

void  ParaLispObject_virtualGCDeclareContent  ( ParaLispObject * const me ) {
// ! to check for NULL method pointer , when dismiss empty methods
  ParaLispObjectvirttableGCDeclareContent  [ me ->  vaddr . type ]  ( me ) ;
}

void  ParaLispObject_GCDeclareContent ( ParaLispObject * const _ __attribute__ ((unused)) ) {
}

ParaLispObject  * ( * ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject const * ) ;

ParaLispObject  * ParaLispObject_virtualTypeOf ( ParaLispObject const * const me ) {
  return  ParaLispObjectvirttableTypeOf [ me  ->  vaddr . type ]  ( me ) ;
}

// ! dont virtual => to make check for type : Object  
ParaLispObject  * ( * ParaLispObjectvirttableContext  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject const * ) ;
  
ParaLispObject  * ParaLispObject_virtualContext  ( ParaLispObject const * const me ) {
  return  ParaLispObjectvirttableContext [ me ->  vaddr . type ]  ( me ) ;
}

ParaLispObject  * ( * ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject const * ) ;
  
ParaLispObject  * ParaLispObject_virtualClassDef  ( ParaLispObject const * const me ) {
  return  ParaLispObjectvirttableClassDef [ me  ->  vaddr . type ]  ( me ) ;
}

ParaLispObject  * ( * ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject const * ) ;
  
ParaLispObject  * ParaLispObject_virtualClassParents  ( ParaLispObject const * const me ) {
  return  ParaLispObjectvirttableClassParents  [ me ->  vaddr . type ]  ( me ) ;
}

void ( * ParaLispObjectvirttableDeclareForGC [  TypeGlobalListMemberSIZE ] ) ( ParaLispObject * ) ;
  
void  ParaLispObject_virtualDeclareForGC ( ParaLispObject * const me ) {
  ParaLispObjectvirttableDeclareForGC  [ me ->  vaddr . type ]  ( me ) ;
}

ParaLispObject * ( * ParaLispObject_virttablePushAsNew   [ TypeGlobalListMemberSIZE ] ) (  ParaLispObject  * ) ;
  
ParaLispObject  *  ParaLispObject_virtualPushAsNew  ( ParaLispObject  * const me  ) {
  return  ParaLispObject_virttablePushAsNew  [ me ->  vaddr . type ]  ( me ) ;
}

bool  ParaLispObject_isOKSetFlagConstFalse ( ParaLispObject * const me ) {
  me -> flagConst = false ;
  return  true ;
}

bool  ParaLispObject_isBADSetFlagConstFalse ( ParaLispObject * const _ __attribute__ ((unused)) ) {
  return  false ;
}

bool  ParaLispObject_isBADCopyPrivate ( ParaLispObject const * const me , ParaLispObject  * * const resultp ) {
  ( * resultp ) = ( ( ParaLispObject * ) me ) ;
  return  false ;
}

bool  ( * ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberSIZE ] ) (
  ParaLispObject const * , ParaLispObject  * * ) ;  
  
bool  ( * ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject * ) ;
  
void  ( * ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberSIZE ] ) (
  ParaLispObject const * , PLOStream  const * , bool flag2pprinted  , Vector(StackPLOP)  * ) ;

void  ParaLispObject_CoutToInterpret  ( ParaLispObject  const * const me  ,
  PLOStream const * const s , bool  const * const flag2pprinted , Vector  ( StackPLOP ) * const historyp ) {
  ParaLispObjectPrivatevirtualCoutToInterpret  ( me ,  s , * flag2pprinted , historyp ) ;  
}
  
void  ParaLispObject_CoutToHuman ( ParaLispObject  const * const me  ,
  PLOStream const * const s , bool  const * const flag2pprinted , Vector  ( StackPLOP ) * const historyp ) {
  ParaLispObjectPrivatevirtualCoutToHuman ( me , s , flag2pprinted , historyp ) ;
}
  
ParaLispObject  * ParaLispObject_PushAsNew  ( ParaLispObject  * const me  ) {
  GlobalListPush  ( & GlobalListOfObjects , & me -> base ) ;
  return  me ;
}
  
void  ParaLispObject_DeclareForGC ( ParaLispObject * const me ) {
  if  ( not  me -> flagGCPassed ) {
    me -> flagGCPassed =  true  ;
    GlobalListPopNotLock  ( & GlobalListOfObjectsGarbage , & me -> base ) ;
    GlobalListPushNotLock ( & GlobalListOfObjects , & me -> base ) ;
  }
}

ParaLispObject  * ParaLispObject_Context ( ParaLispObject const * _ __attribute__ ((unused)) )  {
  return  & plonil .  plo ;
}

ParaLispObject  *   ploclassdefenvlayer = & plonil.plo;
ParaLispObject  *   ploclassparentsenvlayer = & plonil.plo  ;
ParaLispObject  *   ploclassdefbif = & plonil.plo ;
ParaLispObject  *   ploclassparentsbif = & plonil.plo ;
ParaLispObject  *   ploclassdefsignal = & plonil  . plo  ;
ParaLispObject  *   ploclassparentssignal = & plonil.plo ;
ParaLispObject  *   ploclassdeftime = & plonil.plo ;
ParaLispObject  *   ploclassparentstime = & plonil.plo ;
ParaLispObject  *   ploclassdefdir = & plonil . plo ;
ParaLispObject  *   ploclassparentsdir = & plonil . plo ;
ParaLispObject  * ploclassdefQuote  = & plonil.plo   ;
ParaLispObject  * ploclassparentsQuote  = &  plonil.plo  ;
# ifndef  LISP2D_DONTUSEX11  
  ParaLispObject  *   ploclassparentswindow = & plonil.plo;
# endif
  ParaLispObject  *   ploclassparentslock = & plonil.plo;
  ParaLispObject  *   ploclassparentsBackQuote = &  plonil.plo ;
  ParaLispObject  *   ploclassparentsComma = &  plonil.plo ;
  ParaLispObject  *   ploclassparentsUnquoteSplicing = &  plonil.plo ;
  ParaLispObject  *   ploclassparentscomplex = &  plonil.plo ;
  ParaLispObject  *   ploclassparentscomplexirr2 = &  plonil.plo  ;
  ParaLispObject  *   ploclassparentsbytedeque = &  plonil.plo ;
  ParaLispObject  *   ploclassparentssocket = & plonil.plo ;
  ParaLispObject  *   ploclassparentsstat = & plonil.plo   ;
  ParaLispObject  *   ploclassdefstream = & plonil.plo;
  ParaLispObject  *   ploclassparentsstream = & plonil.plo;
  ParaLispObject  *   ploclassparentscons = & plonil.plo ;
  ParaLispObject  *   ploclassparentsvector = & plonil.plo ;
  ParaLispObject  *   ploclassparentsstring = & plonil.plo ;
  ParaLispObject  *   ploclassparentschar = & plonil.plo ;
ParaLispObject  *   ploclassdefcons = & plonil.plo ;
  ParaLispObject  *   ploclassdefvector = & plonil.plo ;
  ParaLispObject  *   ploclassdefstring = & plonil.plo ;
  ParaLispObject  *   ploclassdefchar = & plonil.plo ;
#ifndef  LISP2D_DONTUSEX11  
  ParaLispObject  *   ploclassdefwindow = & plonil.plo ;
#endif  
  ParaLispObject  *   ploclassdeflock = & plonil.plo ;
  ParaLispObject  *   ploclassdefBackQuote = & plonil.plo ;
  ParaLispObject  *   ploclassdefComma = & plonil.plo ;
  ParaLispObject  *   ploclassdefUnquoteSplicing = & plonil.plo ;
  ParaLispObject  *   ploclassdefcomplex = & plonil.plo ;
  ParaLispObject  *   ploclassdefcomplexirr2 = & plonil.plo  ;
  ParaLispObject  *   ploclassdefbytedeque = &  plonil.plo ;
  ParaLispObject  *   ploclassdefsocket = & plonil.plo ;
  ParaLispObject  *   ploclassdefstat = & plonil.plo   ;
  ParaLispObject  * globalresult2 ;
// ! ? envtop2 : Eval2 - modifies variable at exit  
  ParaLispObject  * envtop2 ;
  
void ( * ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberSIZE ] ) (
  ParaLispObject const * , PLOStream  const * , bool flag2pprinted  , Vector  ( StackPLOP ) * ) ;

# include "plo/public.h"

void  ParaLispObject_InitVTP ( ParaLispObject * const me , VirtualTypePointer const fb ) {
  ParaLispObject_InitCVTP ( me  , false , fb  ) ;
}

void  ParaLispObject_InitCVTP ( ParaLispObject * const me , bool flagconst , VirtualTypePointer fb ) {
# ifdef LISP2D_DEBUG
  me  ->  objstate = Lisp2DObjectStateConstructed  ;
# endif
  me  ->  flagGCPassed  = false ;
  me  ->  vaddr = fb  ;
  me  ->  flagConst = flagconst ;
  me  ->  flagStatic  = false ;
  VirtualTypePointer fb2 ;
  fb2 . addr . p = me ;
  fb2 . type = TypeGlobalListMemberParaLispObject ;
  GlobalListMemberConstrFB  ( & me  ->  base  , fb2  ) ;
}

bool  ParaLispObject_virtualisOKSetFlagConstFalse  ( ParaLispObject * const me ) {
  return  ( ParaLispObject_virttableisOKSetFlagConstFalse  [ me -> vaddr.type ] ( me ) ) ;
}

// ! to make an array of true/false , but not a function's
bool  ParaLispObjectPrivatevirtualisBADCopyPrivate ( ParaLispObject const * const me ,
  ParaLispObject  * * const resultp  ) {
  return ParaLispObject_virttableisBADCopyPrivate  [ me ->  vaddr . type ]  ( me , resultp ) ;
}

void  ParaLispObjectPrivatevirtualCoutToInterpret ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector  ( StackPLOP )  * const t ) {
  ParaLispObject_virttableCoutToInterpret  [ me ->  vaddr . type ]  ( me , s , flag2pprinted , t ) ;
}

void  ParaLispObjectPrivatevirtualCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool flag2pprinted  , Vector  ( StackPLOP )  * const t ) {
  ParaLispObject_virttableCoutToHuman  [ me ->  vaddr . type ]  ( me , s , flag2pprinted , t ) ;
}
