// Thread for PLOWindow
// ©2007-23 by Alex Glebe
# ifndef  LISP2D_DONTUSEX11
# include <time.h>
# include "window.h"
# include "char/inline.h"
# include "define.h"
# include "sharedc.h"
# include "shared/inline.h"
# include "char/public.h"
# include "char/struct.h"
# include "cons/inline.h"
# include "symbolc.h"
# include "plocomplex/public.h"
# include "passage/public.h"
# include "inner-history/inline.h"
# include "mutex2/public.h"
# include "window/public.h"
# include "window/private.h"

// arg type is WindowPrivate
void * pthWindow  ( void  * const arg ) {
  // Lisp2DpthWindow - is new thread and
  // Lisp2DJBglobal - is NULL 
  jmp_buf jump_buffer0 ;
  jmp_buf * const oldjb0 = Lisp2DJBglobal  ;
  Lisp2DJBglobal = &  jump_buffer0 ;
  int const volatile  exctype = setjmp  ( jump_buffer0  ) ;
  if  ( exctype ) {
    if ( fwprintf  ( stderr  , L"Lisp2DpthWindow:exctype = №%d\n"  , exctype ) < 0 )
      exit  ( exctype ) ;
    if ( fwprintf  ( stderr  , L"Lisp2DpthWindow:exctypename = \"%ls\"\n"  ,
        Lisp2DExcTypeName [ exctype ] ) < 0 )
      exit  ( exctype ) ;
    switch  ( exctype  ) {
    case  Lisp2DExcTypeNULL :
      fputws ( L"Lisp2DpthWindow:exc value = NULL\n" , stderr ) ;
      break ;
    case  Lisp2DExcTypeString :
      fwprintf ( stderr , L"Lisp2DpthWindow:exc string = \"%ls\"\n" ,
        &((*Lisp2DExceptionStringGlobal . str)[0]) ) ;
      break ;
    case  Lisp2DExcTypeXSupportsLocale :
      fputws ( L"Lisp2DpthWindow:" , stderr ) ;
      fputws ( *  ( ( ( Lisp2DExcXSupportsLocale * ) Lisp2Dexception . valp ) ->  whata ) , stderr ) ;
      if  ( ( ( Lisp2DExcXSupportsLocale * ) Lisp2Dexception . valp ) ->  locold  )
        wprintf (
# ifdef _WIN32
          L"%S\n"
# else
          L"%s\n"
# endif
          , ( ( Lisp2DExcXSupportsLocale * ) Lisp2Dexception . valp ) -> locold  ) ;
      else
        fputws ( L"NULL" , stderr  ) ;
      free  ( Lisp2Dexception . valp  ) ;
      break ;
    default :
      fwprintf  ( stderr  , L"Lisp2DpthWindow:JMPexception  №%d\n"  , exctype ) ;
    } // switch  ( exctype  )
    Lisp2Dexception . valp  = 0 ;
    Lisp2DJBglobal = oldjb0  ;
    exit  ( exctype ) ;
  } // if  ( ( exctype = setjmp  ( jump_buffer0 ) ) )
  
# ifdef  LISP2D_INNERHISTORY
  # define  wsih_pthwindow  Lisp2Dwsih_pthwindowBtvC
  static  wchar_t  const  wsih_pthwindow[] = L"pthWindow(void  * arg):Start."  ;
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_pthwindow  ) ;
#endif    
  
  // event Expose=12 ok
  //             =22 crashed
  // arg will be delet_ed automatic
  /*PLOWindow * const plow2 = ( PLOWindow * ) ( arg ) ;
  PLOWindow_pri * const plowp = PLOWindow_to_pri  ( plow2 ) ;*/
  PLOWindow_pri * const plowp = arg ;
  PLOWindow * const plow2 = & plowp -> pub ;
  bool    ret = false ;
  XEvent event;
  
  // This returns the FD of the X11 display (or something like that)
  
  do{
    if(plowp->flagclose)   
      goto  Close;
    { bool    findevent = false ;
      do{
        XLockDisplay(plowp->dpy);
        
        if(XPending(plowp->dpy)) {
          // Handle XEvents and flush the input 
          XNextEvent(plowp->dpy,& event);
          XUnlockDisplay(plowp->dpy);
          findevent = true;
        } else {
          XUnlockDisplay(plowp->dpy);
          if(plowp->flagclose)        
            goto  Close;
          struct timespec t;
          t.tv_sec  = 0;
          t.tv_nsec = 100000000L; // 0.1sec
          nanosleep(& t,0);
        } // not XPending
      } while(not  findevent);
    } // findevent
    if(plowp->flagclose)    
      goto  Close;
    
    switch(event.type){
    case  Expose:
# ifdef  LISP2D_INNERHISTORY
      {
        # define  wsih_pthwindow3  Lisp2Dwsih_pthwindow3hwNv
        static  wchar_t  const  wsih_pthwindow3[]  =
          L"pthWindow(void  * arg):case  Expose:" ;
        Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_pthwindow3  ) ;
      }
# endif      
      XLockDisplay(plowp->dpy);
      { unsigned  long  int colorxy ;
        for(int  ix =event.xexpose.width  - 1;ix >=  0;--  ix)
          for(int  iy =event.xexpose.height - 1;iy >=  0;--  iy){
            int const  x2=event.xexpose.x + ix;
            int const  y2=event.xexpose.y + iy;
            if(not  PLOWindow_isOKOSColor2(plow2,(IntXY){x2,y2},&colorxy))
              colorxy = 0 ;
            XSetForeground(plowp->dpy,plowp->gc,colorxy );
            XDrawPoint(plowp->dpy,plowp->win,plowp->gc,
                     event.xexpose.x  + ix,event.xexpose.y  + iy);
          }
      } // colorxy
      XFlush(plowp->dpy);
      XUnlockDisplay(plowp->dpy);
      break;      
    case  KeyPress:
    case  KeyRelease:
# ifdef  LISP2D_INNERHISTORY
      {
        # define  wsih_pthwindow4  Lisp2Dwsih_pthwindow4G05N
        static  wchar_t  const  wsih_pthwindow4 [] =
          L"pthWindow(void  * arg):case  KeyPress,KeyRelease:" ;
        Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_pthwindow4  ) ;
      }
# endif            
      { KeySym key;
        wchar_t wtext[2]={0,0};
        XLockDisplay(plowp->dpy);
        { Status  status_return;
          XwcLookupString( plowp->xic,& (event.xkey), wtext,1,& key,&  status_return);
          XUnlockDisplay(plowp->dpy);
          
          bool  flagNone=false;
          bool  flagKeysym=false;
          
          switch(status_return){
          case  XBufferOverflow:
            fputws(L"XBufferOverflow:",stderr);
            fflush(stderr);
            flagNone =  true;
            break;
          case  XLookupNone:
            flagNone = true;
            // button release
            break;
          case  XLookupChars:         
            break;
          case  XLookupKeySym:
            flagKeysym = true;
            break;
          case  XLookupBoth:
            break;
          default:;
          }
          // make an event as list (key-press char|integer) or (key-release nil)
          PassagePassIn ( passageGCCPub ) ;
          if  ( flagNone )  {
            ParaLispObject  * const sendevent2 = & NewCons ( ( ( event . type  ==  KeyPress  ) ?
                  & ploskeypress  . plo :
                  & ploskeyrelease  .  plo ) , & plonil  . plo ) ->  plo ;
            PLOWindow_MakeEvent ( plow2 , sendevent2  ) ;
          } else  {
            ParaLispObject * ar ;
            if  ( flagKeysym ) {
              PLOComplex  * const pkey= NewComplexBareExc();
              Complex_SetULInt  ( PLOComplexToComplex( pkey),key);
              ar = &pkey->plo ;
            } else {
              PLOCharPriv * const ch = aligned_alloc ( _Alignof ( PLOCharPriv ) , sizeof  ( PLOCharPriv ) ) ;
              if ( not ch ) {
                Lisp2DExcOutOfMemoryGlobal . value = L"pthWindow:aligned_alloc(PLOCharPriv )" ;
                longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; 
              }
              PLOChar_InitValue ( ch  , wtext [ 0 ] ) ;
              ar =  ParaLispObject_virtualPushAsNew ( & ch -> pub . plo ) ;
            }
            ParaLispObject  * list [ ] = { ((event.type ==  KeyPress)  ?
              &  ploskeypress . plo :
              & ploskeyrelease . plo ) , ar , NULL } ;
            ParaLispObject  * const sendeventp = ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list});
            PLOWindow_MakeEvent ( plow2 , sendeventp ) ; 
          }
          PassagePassOut ( passageGCCPub ) ; 
        } 
      } // key
      break;
    case  ButtonPress:
    case  ButtonRelease:
      { IntXY xy  ;
        PLOWindow_QueryPointer  ( plow2 , & xy  ) ;
        { PLOComplex  * const  px = NewComplexBareExc();  
          Complex_SetInt  ( PLOComplexToComplex( px),xy.x);
          PLOComplex  * const  py= NewComplexBareExc();
          Complex_SetInt  ( PLOComplexToComplex( py),xy.y);
          PLOComplex  * const  eb= NewComplexBareExc();
          Complex_SetUInt ( PLOComplexToComplex( eb),event.xbutton.button);
          // make an event as list (event button x y)
          { PassagePassIn ( passageGCCPub ) ;
            jmp_buf jb2 ;
            jmp_buf * const oldjb = Lisp2DJBglobal  ;
            Lisp2DJBglobal  = & jb2 ;
            int const volatile  jbn2  = setjmp  ( jb2 ) ;
            if  ( jbn2  == 0 ) {
              ParaLispObject  * list [ ] = { (  ( event . type ==  ButtonPress  ) ?
                  & plosbuttonpress . plo :
                  & plosbuttonrelease . plo ) , & eb  ->  plo , & px  ->  plo , & py  ->  plo , NULL } ;
              ParaLispObject  * const sendeventp = ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list});
              PLOWindow_MakeEvent ( plow2 , sendeventp ) ; 
            } else {
              Lisp2DJBglobal  = oldjb ;
              PassagePassOut ( passageGCCPub ) ;
              longjmp ( * Lisp2DJBglobal  , jbn2 ) ; 
            }
            PassagePassOut ( passageGCCPub ) ;
          } 
        } 
      } // xy
      break;
    case  DestroyNotify:
# ifdef  LISP2D_INNERHISTORY
      {
        # define  wsih_pthwindow5  Lisp2Dwsih_pthwindow51wa6
        static  wchar_t  const  wsih_pthwindow5 [] =
          L"pthWindow(void  * arg):case  DestroyNotify:" ;
        Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_pthwindow5  ) ;
      }
# endif            
      ret = true;
      break;
    case  ConfigureNotify:
      // why crashed?
      plowp->winwidth = event.xconfigure.width;
      plowp->winheight  = event.xconfigure.height;
      PassagePassIn ( passageGCCPub ) ;
      { jmp_buf jb2 ;
        jmp_buf * const oldjb = Lisp2DJBglobal  ;
        Lisp2DJBglobal  = & jb2 ;
        int const volatile  jbn2  = setjmp  ( jb2 ) ;
        if  ( jbn2 == 0 ) {
          PLOComplex  * const  h= NewComplexBareExc();
          Complex_SetInt  ( PLOComplexToComplex( h),event.xconfigure.height);
          PLOCons * const xin= NewCons( & h->plo,&plonil.plo);
          PLOComplex  * const  w= NewComplexBareExc();
          Complex_SetInt  ( PLOComplexToComplex( w),event.xconfigure.width);
          PLOCons * const xin2=NewCons( &  w->plo,  &   xin->plo);
          PLOCons * const ce  = NewCons ( & plosconfigurenotify . plo , &  xin2 ->  plo ) ;
          PLOWindow_MakeEvent ( plow2 , & ce  ->  plo ) ;
        } else  {
          Lisp2DJBglobal  = oldjb ;
          PassagePassOut ( passageGCCPub ) ;
          longjmp ( * Lisp2DJBglobal  , jbn2 ) ;
        }
      } // jb2
      PassagePassOut ( passageGCCPub ) ;
      break;
    // ! XCheckWindowEvent() cannot return ClientMessage, MappingNotify,
      //SelectionClear, SelectionNotify,
    //  or SelectionRequest events because these event types are by definition
      //unmaskable.
    case  MappingNotify:   
      break;
    case  ClientMessage:
      if ( lint_cast_ulint ( event . xclient.data.l [ 0 ] ) ==  plowp -> wmDeleteMessage ) {
        // send event: button close
        PassagePassIn ( passageGCCPub ) ;
        { ParaLispObject  * const sendevent2 = & NewCons ( & ploswindowclose . plo , & plonil . plo ) -> plo ;
          PLOWindow_MakeEvent ( plow2 , sendevent2  ) ; 
        }
        PassagePassOut ( passageGCCPub ) ;
      }
      break;
    case  SelectionClear:
    case  SelectionNotify:
    case  SelectionRequest:    
      break;
         
    case  GraphicsExpose:    
      break;
    case  NoExpose:    
      break;
    default:  ;
    }  // switch
  }while(((not ret)  and (not  (plowp->flagclose))) and (not 
    flagThreadsShutDown ) ) ;
Close:
# ifdef  LISP2D_INNERHISTORY
  {
    # define  wsih_pthwindow6  Lisp2Dwsih_pthwindow6b4YY
    static  wchar_t  const  wsih_pthwindow6[]  =
      L"pthWindow(void  * arg):Close:" ;
    Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_pthwindow6  ) ;
  }
# endif
// !? without it crashed !?    
  PassagePassLock ( passageGCCPub ) ;
// !? to protect from GC !?  
# ifdef LISP2D_DEBUG  
  if  ( PLOWindow_plo ( plow2 ) -> objstate not_eq Lisp2DObjectStateConstructed ) {
    Lisp2DExceptionStringGlobal . str = (wchar_t const(*)[])&
      L"Lisp2DpthWindow:objstate not_eq  Lisp2DObjectStateConstructed\n" ;
    fputws  ( &((*Lisp2DExceptionStringGlobal . str)[0]) , stderr ) ;
    longjmp ( * Lisp2DJBglobal  , Lisp2DExcTypeString ) ;
  }
# endif    
  plowp ->  boolHaveThread = false  ;
  XLockDisplay(plowp->dpy);
  XDestroyWindow(plowp->dpy, plowp->win);
  XFreeGC(plowp->dpy,plowp->gc);
  plowp ->  gc = 0 ;
  XUnlockDisplay(plowp->dpy);
  pthread_mutex_lock  ( & Lisp2DmutexXDisplay2  ) ;
  XCloseDisplay(plowp->dpy);
  plowp ->  dpy = 0 ;
  pthread_mutex_unlock  ( & Lisp2DmutexXDisplay2  ) ;
  CountWindowsThreads2_Dec();
# ifdef  LISP2D_INNERHISTORY
  # define  wsih_pthwindow7  Lisp2Dwsih_pthwindow7OSlU
  static  wchar_t  const  wsih_pthwindow7[]  =
    L"pthWindow(void  * arg):Lisp2DsignalWindowsExit" ;
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_pthwindow7  ) ;
# endif
  Mutex2Lock ( & Lisp2DmutexWindowsExit ) ;
  if  ( Lisp2DflagMainWaitWindows and ( CountWindowsThreads2() ==  0  ) ) {
# ifdef  LISP2D_INNERHISTORY
    # define  wsih_pthwindow9  Lisp2Dwsih_pthwindow9hBx9
    static  wchar_t  const  wsih_pthwindow9[]  =
      L"pthWindow(void  * arg):Lisp2DsignalWindowsExit(was WaitSignal)" ;
    Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_pthwindow9 ) ;
# endif    
    Lisp2DflagMainWaitWindows = false ;
    ConditionSignal  ( & Lisp2DsignalWindowsExit ) ;
  }
  Mutex2Unlock  ( & Lisp2DmutexWindowsExit ) ;
// !? without it crashed !?  
  PassagePassUnLock ( passageGCCPub ) ;
# ifdef  LISP2D_INNERHISTORY
  # define  wsih_pthwindow8  Lisp2Dwsih_pthwindow8OE0B
  static  wchar_t  const  wsih_pthwindow8 [] = L"pthWindow(void  * arg):Lisp2DsignalManager" ;
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_pthwindow8  ) ;
# endif  
  Mutex2Lock ( & Lisp2Dmutex2ManagerTasks ) ;
  if  ( flagManagerWaitSignal ) {
    flagManagerWaitSignal = false ;
    jmp_buf jb2 ;
    jmp_buf * const oldjb = Lisp2DJBglobal  ;
    Lisp2DJBglobal  = & jb2 ;
    int const volatile  jbn2  = setjmp  ( jb2 ) ;
    if  ( jbn2 ) {
      Lisp2DJBglobal  = oldjb ;
      Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
      longjmp ( * Lisp2DJBglobal  , jbn2 ) ;
    }
    ConditionSignal ( & Lisp2DsignalManager ) ;
    Lisp2DJBglobal  = oldjb ;    
    // nobody didnot signaling as flagManagerWaitSignal=false
    // manager will little wait
  }
  Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;  
  Lisp2DJBglobal = oldjb0  ;
# ifdef  LISP2D_INNERHISTORY
  # define  wsih_pthwindow2  Lisp2Dwsih_pthwindow2qsox
  static  wchar_t  const  wsih_pthwindow2[]  = L"pthWindow(void  * arg):Quit." ;
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , wsih_pthwindow2  ) ;
# endif
  return 0 ; 
}

# include "window/inline.h"
# include "window/inlinepri.h"

# endif // ! LISP2D_DONTUSEX11
