// Quote '
// ©2011-23 by Alex Glebe
# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include "quote/private.h"

_Atomic ( size_t ) PLOQuote_constrstat = 0 ;

# endif // LISP2D_CONSTRSTAT

# include "quote/public.h"

# ifdef  LISP2D_CONSTRSTAT

void  PLOQuote_constrstat_Inc  ( void  ) {
  ++  PLOQuote_constrstat  ;
}

size_t  PLOQuote_constrstat_Value  ( void  ) {
  return  PLOQuote_constrstat  ;
}

# endif // LISP2D_CONSTRSTAT

# include "symbolc.h"

# define  PLOQuote_staticTypeOf Lisp2D_PLOQuote_staticTypeOf
ParaLispObject  * PLOQuote_staticTypeOf ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  & plosquote2 . plo  ;
}

# include "sharedc.h"
# include "shared/inline.h"
# include "quote/struct.h"
# include "plostream/public.h"

# define  PLOQuote_Cout Lisp2D_PLOQuote_Cout
static  void  PLOQuote_Cout  ( PLOQuote const * const me , FuncCoutToInterpretHuman  funccout , PLOStream  const * const  sp ,
  bool  flag2p  , Vector ( StackPLOP ) * const lookingp  ) {
  bool  flagp  = flag2p  ;
  if  ( Printed3Points  ( & me -> plo , sp , & flagp ,  lookingp ) )  
    return  ;
  PLOStreamPushWChar  ( sp  , L'\'' ) ;
  Vector_PushByValue ( StackPLOP ) (  lookingp , & ( ( PLOQuote * ) me ) -> plo ) ;
  funccout ( me -> item ,  sp , &  flagp  ,  lookingp ) ;
  VectorPop(StackPLOP) (  lookingp ) ;
}

bool  PLOQuote_staticisBADCopyPrivate ( ParaLispObject const * const  me , ParaLispObject  * * const resultp  ) {
  { PLOQuote * const  res  = aligned_alloc ( _Alignof ( PLOQuote ) , sizeof ( PLOQuote ) ) ;
    if  ( res ) {
      PLOQuote_Init(res);
      PLOQuote_SetItem ( res , ParaLispObjectToPLOQuoteConst(me) -> item ) ;
      ParaLispObject_virtualPushAsNew (&res ->  plo ) ;
      ( * resultp )  = &res->plo ;
      return  false ;
    }
  }
  return  true  ;
}

void  PLOQuote_staticGCDeclareContent ( ParaLispObject * const me ) {
  ParaLispObject_virtualDeclareForGC ( ParaLispObjectToPLOQuote(me) -> item) ;
}

# include "nilc.h"

void  PLOQuote_Init( PLOQuote * const me ) {
  me -> item  = &  plonil.plo ;
  { VirtualTypePointer  vtp = { . addr = { . p = me } , . type = TypeGlobalListMemberPLOQuote } ;
    ParaLispObject_InitVTP(&me->plo ,vtp );
  }
# ifdef  LISP2D_CONSTRSTAT
  PLOQuote_constrstat_Inc ( ) ;
# endif
}

void  PLOQuote_staticCoutToInterpret ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector  ( StackPLOP ) * const h ) {
  PLOQuote_Cout  ( ParaLispObjectToPLOQuoteConst  ( me  ) , ParaLispObject_CoutToInterpret , s , flag2pprinted , h ) ;
}

void  PLOQuote_staticCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector  ( StackPLOP )  * const h ) {
  PLOQuote_Cout  ( ParaLispObjectToPLOQuoteConst  (  me  ) , ParaLispObject_CoutToHuman , s , flag2pprinted , h ) ;
}

# include "cons/inline.h"
# include "stcl/public.h"
# include "stcl/inline.h"

// 'quote newobject (2 + 2) -> '4
TaskForThread Lisp2Dbimquotequote2  ( StackClusterPrivate  * const stclpp  ) {
  PLOQuote  * const mep  =ParaLispObjectToPLOQuote ( StackClusterPrivate_ThisTop(stclpp))  ;
  PLOQuote_SetItem ( mep , CCAR ( StackClusterPrivate_ArgTop(stclpp)) ) ;
  StackClusterPrivate_SetResult (stclpp,& mep -> plo  ) ;
  return  TaskForThread_Analyse ;
}

// quote setf quote
TaskForThread Lisp2Dbimquotesetf2 ( StackClusterPrivate * const stclpp ) {
  PLOQuote  * const mep  =ParaLispObjectToPLOQuote (
    StackClusterPrivate_ThisTop(stclpp))  ;
  ParaLispObject  * const argp =  CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  if  ( not  IsNotQuote (  stclpp  ,  argp ) ) {
    PLOQuote_Set (  mep , ParaLispObjectToPLOQuote ( argp ) ) ;
    StackClusterPrivate_SetResult (stclpp ,& mep -> plo  ) ;
  }
  return  TaskForThread_Analyse ;
}

// quote swap quote
TaskForThread Lisp2Dbimquoteswap2 ( StackClusterPrivate * const stclpp ) {
  PLOQuote  * const mep = ParaLispObjectToPLOQuote (
    StackClusterPrivate_ThisTop(stclpp))  ;
  ParaLispObject  * const argp = CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  if  ( not  IsNotQuote (  stclpp  ,  argp ) ) {
    if  ( IsConst (   stclpp ,  argp ) )
// ! to exception
      return  TaskForThread_Analyse ;
    PLOQuote_Swap  (  mep , ParaLispObjectToPLOQuote ( argp ) ) ;
    StackClusterPrivate_SetResult (stclpp ,& mep->plo  ) ;
  }
  return  TaskForThread_Analyse ;
}

# include "boolean.h"

TaskForThread Lisp2Dbimnilquotep2 ( StackClusterPrivate * const stclpp ) {
  ParaLispObject  * const xp = CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  StackClusterPrivate_SetResult (stclpp ,( QuoteP (  xp )  ?
    xp :
    &  plofalse.plo )) ;
  return  TaskForThread_Analyse ;
}

# include "newobject.h"

bool  IsNotQuote  ( StackClusterPrivate  * const stclp  , ParaLispObject * const  xp ) {
  tUniversalIsNotType ar  = {
    . stclp = stclp ,
    . xp  = xp ,
    . typetype  = TypeGlobalListMemberPLOQuote ,
    . res = false ,
  } ;
  UniversalIsNotTypess  ( & ar  ) ;
  return  ar  . res ;
  //return  UniversalIsNotType  ( stclp , xp ,  TypeGlobalListMemberPLOQuote ) ;
}

ParaLispObject  * PLOQuote_staticClassDef  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  ploclassdefQuote  ;
}

ParaLispObject  * PLOQuote_staticClassParents  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return   ploclassparentsQuote  ;
}

void  PLOQuote_Destr ( PLOQuote * const me ) {
  ParaLispObject_staticDestr(&me->plo);
}

void PLOQuote_staticDestr  ( ParaLispObject * const me ) {
  PLOQuote_Destr  ( ParaLispObjectToPLOQuote ( me  )  ) ;
}

void  PLOQuote_Swap  ( PLOQuote * const me , PLOQuote * const xp  ) {
  if ( me not_eq xp ) {
    ParaLispObject  * const myitem  = me -> item;
    me -> item = xp -> item ;
    xp -> item = myitem ;
  }
}
