// Lisp2D - global functions
// ©2020-3 by Alex Glebe
/*
Locks:
-------------

manager:
----------------
mutexTasks
mutexqueueStCl
runpth[i2].mutexTask

mutexTasks
mutexqueueStCl

mutexTasks
mutexStstcl

mutexTasks
runpth[i].mutexTask

PushEnv3WithLocking
----------------------------
mutexLock
mutexdeletedlists

mutexLock
mutexobjects

CreateTaskEnv
-------------------
mutexBoss
mutexqueueStCl

bimsymbolnamespace
----------------------------
mutexnamespace
mutexdeletedlists

mutexnamespace
mutexobjects

pthEval2
-----------
mutexBoss
mutexSon

mutexBoss
mutexqueueStCl

mutexdeletedstacks
mutexHistory

*/

/*
Namespace:

StackCluster: namespaceproplist - list of namespaceprops created by namespace
  (namespaceprops ... namespaceprops) or  NIL

PLOSymbol:  namespaceprops  - NIL or #(.. (symbol . #(..  (properties . propvalue)  ..))  ..)
  THIS  is namespace

 sorted by name pointer
std::vector<NameSpaceDef> namespacedef;

*/

/*
Class definition:

system::class:
  list ((parent-name ... parent-name) PLOEnvironmentLayer(public methods) PLOEnvironmentLayer(private variables)
    PLOEnvironmentLayer(public static variables) [BinClassName])
*/

/*
mutexBoss:

main:  PCS for all threads                 ->  make private Mutex for threads
manager: PCS for all threads             ->  make private Mutex for threads
StackCluster::CreateTaskEnv:  make son for father, ststcl, queueStCl, signalManager
UnLock: queueStCL, signalManager
pthWindow: queueStCL, signalManager
pthEval2: ((RunningPth*)rpt)->task,((RunningPth*)rpt)->condrunning,
              flagThreadsShutDown    ->  make private Mutex for threads
pthGetch: queueStCL, signalManager

*/
# include <stdio.h>
# include <wchar.h>
# include "sharedc.h"
# include "parray.h"
# include "mutex2/type.h"
# include "mutex2/struct.h"
# include "mutex2/public.h"

LISP2D_MUTEX2  ( Lisp2Dmutex2ManagerTasks  ) 

LISP2D_CONDIT  ( Lisp2DsignalManager ) 

LISP2D_MUTEX2  ( Lisp2DmutexNameSpace  )  

LISP2D_MUTEX2  ( Lisp2DmutexGenTemp  ) 

LISP2D_MUTEX2  ( Lisp2DMutexTreeSymbols  ) 

void  Lisp2D_writelog  ( Lisp2Dt_writelog const l ) {
  if  ( fwprintf ( stderr , L"\n%ls\n" , * l . a ) == - 1 )  {
    Lisp2DExceptionStringGlobal . str = (wchar_t const(*)[])&
      L"Lisp2D_writelog:fwprintf ( stderr , L\"\n%ls\n\" , * l . a )"  ;
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;  
  }
}

# include "plostream/public.h"
    
bool  Printed3Points  ( ParaLispObject  const * const x , PLOStream const * const osp , bool *  const flag2pprinted2p ,
  Vector  ( StackPLOP ) * const looking2p  ) {
  unsigned  char  see2 = 2 ;
  { ParaLispObject   * *   j = VectorBegin ( StackPLOP ) ( looking2p ) ;
    size_t  i = VectorSizeCopy  ( StackPLOP ) ( looking2p ) ;
    for ( ; i > 0 ; ++ j  ) {
      -- i  ;
      if  ( ( * j )  ==  x  ) {
        --  see2  ;
        if  ( see2  ==  0 ) {
          PLOStreamPushWideCharArray  (  osp , (PArray_wchar_c){ (wchar_t const(*)[])&L" ... " } ) ;
          return  true;
        }
      }
    }
  }  // j
  if  ( ( see2 ==  1  ) and ( not  (  * flag2pprinted2p ) ) ) {
      PLOStreamPushWideCharArray  (  osp ,
        (PArray_wchar_c) { (wchar_t const(*)[])&L" .. " });
      ( * flag2pprinted2p ) = true ;    
  }
  return  false;
}
  
// process Item and Pause
volatile  _Atomic ( int ) runpthcount = 0 ;

volatile  _Atomic ( size_t  ) countExtraThreads2  = 0 ;

volatile  _Atomic ( size_t  ) countStackClusterWantToBeInGarbage = 0 ;  

size_t  countStackClusterWantToBeInGarbage_Value ( void  ) {
  return  countStackClusterWantToBeInGarbage  ; 
}

void  countStackClusterWantToBeInGarbage_Inc  ( void  ) {
  ++  countStackClusterWantToBeInGarbage  ; 
}

void  countStackClusterWantToBeInGarbage_Dec  ( void  ) {
  --  countStackClusterWantToBeInGarbage  ; 
}

size_t  countExtraThreads2Value ( void  ) {
  return  countExtraThreads2  ; 
}

void  countExtraThreads2_Inc  ( void  ) {
  ++  countExtraThreads2  ; 
}

void  countExtraThreads2_Dec  ( void  ) {
  --  countExtraThreads2  ; 
}

int runpthcount_Value ( void  ) {
  return  runpthcount ; 
}

void  runpthcount_Inc ( void  ) {
  ++  runpthcount ; 
}

void  runpthcount_Dec ( void  ) {
  --  runpthcount ; 
}

unsigned  int maxCountThreads ;

// ! to _Atomic(bool) ?
volatile  bool flagManagerWaitSignal = false ;

size_t    gcobjects2 = 0 ;

  // create Tasks and Pause
  unsigned  int maxTasksCreate  ;

// ! to _Atomic(bool) ?
  volatile  bool    flagdeletetzname02 = false ;
// ! to _Atomic(bool) ?
  volatile  bool    flagdeletetzname12 = false ;

// ! to _Atomic(bool) ?
volatile  bool  allowgc;

// ! to _Atomic(bool) ?
volatile  bool  flagStopToGC;

# include "define.h"

// ! to _Atomic(bool) ?
# ifdef  LISP2D_DEBUG
// ! to use innerhistory  
  volatile  bool  debugGCRunning = false ;
# endif  

// ! to _Atomic(bool) ?
volatile  bool  flagThreadsShutDown = false ;  

# include "deque/public-byte.h"
# include "cast.h"

// wchar -> bytedeque += {codes}
bool  isBADWCharPushToByteDeque ( wchar_t const i ,
  Deque ( Byte ) * const yp ) {
  if  ( i < 0 ) 
    return   true   ;
  if  ( i  < 0x80 )
    Deque_Push_back ( Byte ) ( yp , wchar_cast_byte ( i ) ) ;
  else  {
    if  ( i  < 0x800  ) 
      Deque_Push_back ( Byte ) ( yp , uint_cast_uint8 (0xc0U bitor
        (wchar_cast_uint ( i ) >>  6)) ) ;
    else  {
      if(i  < 0x10000)
        Deque_Push_back ( Byte ) ( yp , uint_cast_uint8 (0xe0U bitor
          (wchar_cast_uint(i) >>  12)));
      else  {
        if(i  < 0x200000)
          Deque_Push_back ( Byte ) ( yp , uint_cast_uint8 (0xf0U bitor
            (wchar_cast_uint(i) >>  18)));
        else{
          if(i  < 0x4000000) 
            Deque_Push_back ( Byte ) ( yp , uint_cast_uint8 (0xf8U bitor
              (wchar_cast_uint(i) >>  24)));
          else{
            Deque_Push_back ( Byte ) ( yp , uint_cast_uint8 (0xfcU bitor
              (wchar_cast_uint(i) >>  30)));
            Deque_Push_back ( Byte ) ( yp , uint_cast_uint8 (0x80U bitor
              ((wchar_cast_uint(i) >>  24) bitand  0x3fU))); 
          } // not(i  < 0x4000000U)
          Deque_Push_back ( Byte ) ( yp , uint_cast_uint8 (0x80U bitor ((wchar_cast_uint(i) >>  18) bitand  0x3fU)));
        } // not(i  < 0x200000U)
        Deque_Push_back ( Byte ) ( yp , uint_cast_uint8 (0x80U bitor ((wchar_cast_uint(i) >>  12) bitand  0x3fU)));
      } // not(i  < 0x10000U)
      Deque_Push_back ( Byte ) ( yp , uint_cast_uint8 (0x80U bitor ((wchar_cast_uint(i) >>  6)  bitand  0x3fU)));
    } // not(i  < 0x800U)
    Deque_Push_back ( Byte ) ( yp , uint_cast_uint8 (0x80U bitor (wchar_cast_uint(i) bitand  0x3fU)));
  }  // not(i  < 0x80U)
  return  false;
} 

# include "string/public.h"
# include "string/struct.h"
# include "nilc.h"

void  BadString ( StackClusterPrivate  * const stclp  , PLOStringPub  * const xp  ) {
  ParaLispObject  * list [ ] = { & PLOString_NewCopy(L"Bad string ")->plo, & xp->plo, 0 } ;
  StackClusterPrivate_ExceptionSet(stclp,ListOfPLO((PArrayPLOP){ (ParaLispObject*(*)[])&list}));
  StackClusterPrivate_ExceptionSet(stclp,&plonil.plo);
}

# include "inerrors.h"

void  HasConstLink( StackClusterPrivate  * const stclp , ParaLispObject * const xp){
  static  wchar_t const  we [ ]  = L" has const link" ;
  if(stclp) {
    ParaLispObject  * list [ ] = {  xp,  & PLOString_NewCopy(we)->plo, 0 } ;
    StackClusterPrivate_ExceptionSet(stclp, ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
  } else    
    inErrorS(
      PLOStreamPushPLO(& Lisp2Dferr ,xp);
      PLOStreamPushWideCharArray  ( &Lisp2Dferr , (PArray_wchar_c) { (wchar_t const(*)[])&  we});)
}

# include "cons/public.h"

ParaLispObject  * ClassGetParents(ParaLispObject  const * const lp){ 
  return CCAR(lp);
}  

ParaLispObject  * ClassGetMethods(ParaLispObject  const * const lp){  
  return  CCAR(CCDR(lp));
}

ParaLispObject  * ClassGetVars(ParaLispObject const * const lp){ 
  return  CCAR(CCDR(CCDR(lp)));
}

ParaLispObject  * ClassGetStatic(ParaLispObject const * const lp){
  return  CCAR(CCDR(CCDR(CCDR(lp))));
}

# include "passage/public.h"

bool  IsConstLockGC( StackClusterPrivate  * const stclp ,
  ParaLispObject * const xp){
  if(not  xp -> flagConst)  
    return  false;
  wchar_t  const  (*wstrisconst2p)  [ ] =(wchar_t const (*)[])&
    L" is constant" ;
  if(stclp) {
    PassagePassIn ( passageGCCPub ) ;
    ParaLispObject  * list [ ] = {  xp,
      & PLOString_NewCopy(*wstrisconst2p)->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(
      stclp,ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));    
    PassagePassOut ( passageGCCPub ) ; 
  } else
    inErrorS(PLOStreamPushPLO(& Lisp2Dferr ,xp);
          PLOStreamPushWideCharArray  ( &Lisp2Dferr ,
          (PArray_wchar_c) {     wstrisconst2p});)
  return  true  ;
}

bool  IsConst( StackClusterPrivate  * const stclp,ParaLispObject * const xp ) {
  if(not  xp -> flagConst)  
    return  false;
  static  wchar_t  const  ( * wstrisconst2p ) [ ] = (wchar_t const (*)[])& L" is constant" ;
  if  ( stclp ) {
    ParaLispObject  * list [ ] = {  xp, & PLOString_NewCopy ( * wstrisconst2p ) -> plo , NULL } ;
    StackClusterPrivate_ExceptionSet(stclp, ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
  } else 
    inErrorS(    PLOStreamPushPLO(& Lisp2Dferr ,xp);
                 PLOStreamPushWideCharArray  ( &Lisp2Dferr , ( PArray_wchar_c ) { wstrisconst2p } ) ; )
  return  true ;
}

# include "errorstra.h"
# include "inner-history/inline.h"
# include "cons/inline.h"

ParaLispObject * ListOfPLO ( PArrayPLOP const arr ) {
  ParaLispObject * * arrindex = &((*arr.p)[0]) ;
  ParaLispObject *  first = ((*arr.p)[0]) ;
  if  ( first == NULL )
    return & plonil.plo ;
  PLOCons *  res  ;
  { PLOCons *  last ;
    res = ( last =   NewCons  (   first  , &plonil.plo  ) ) ;
While :
    ++  arrindex ;
    first = * arrindex ;
    if ( first == NULL )
      return &res->plo ;
    { PLOCons * const next3 = NewCons (   first , &plonil.plo ) ;
      ClassCons_SetRest(&last->cc,&  next3->plo);
      last  =  next3 ;
    } // next3
    goto  While ; 
  } 
}

# include "cast.h"

# ifdef  LISP2D_BIMSTAT

long  double  CalcDT  ( struct timespec const start , struct  timespec const  end  ) {
  return slong_cast_ldouble  ( end . tv_sec - start  . tv_sec  ) +
    ( slong_cast_ldouble  ( end . tv_nsec  - start  . tv_nsec ) * 1.0e-9L ) ;
}

# include "statistics.h"

void  IncreaseStat5 ( struct timespec  const * const startp , struct  timespec  const * const endp  ,
  struct Lisp2DStatistics  * const stp  ) {
  StatisticsPush  (  stp , CalcDT  ( * startp  , * endp  ) ) ;
}

# endif // LISP2D_BIMSTAT

# include "env/public.h"
# include "stcl/public.h"
# include "stcl/classc.h"

// (this  defclass  parents)
// didnot place father-class=TRUE by default
void  bindefclassForMain  ( StackClusterPrivate * const stclp ) {
  ParaLispObject  * classenv2 ;
  ParaLispObject  * classconstfenv2 ;
  ParaLispObject  * classconstenv2  ;
  classenv2 = & NewEnvironmentLayer ( ) -> plo ;
  classconstfenv2 = & NewEnvironmentLayer ( ) -> plo ;
  classconstenv2  = & NewEnvironmentLayer ( ) -> plo ;
  ParaLispObject  * const mep  = StackClusterPrivate_ThisTop(stclp ) ;
  ParaLispObject  * const list [ ] = { StackClusterPrivate_ArgTop( stclp ) ,  classconstfenv2 , classenv2 ,
    classconstenv2  , mep  , NULL } ;
  ParaLispObject  * const resp  = ListOfPLO((PArrayPLOP){ (ParaLispObject*(*)[])&list});
  SetProp2  ( Environment_NamespacePropList ( StackClusterPrivate_envLocal  ( stclp ) ) ,
    mep  , & plossystemclass .  plo , resp ,  stclp ) ;
}

// wchar_t const* -> string
bool  isBADReadWCharToCharString ( wchar_t volatile const * const x , String ( Char ) * const yp ) {
  StringClear(Char)(yp);
  for ( wchar_t volatile const * j = x ; * j ; ++  j ) {
    if  ( ( * j )  < 0  )  
      return   true   ;
    if  ( ( * j )  < 0x80 )  {
      String_AddChar  ( Char  ) ( yp  , wchar_cast_char ( * j ) ) ;
      continue  ; 
    }
    if((*j)  < 0x800)
      String_AddChar(Char)(yp,(char)(0xc0U bitor ((wchar_cast_uint(*j)) >>  6)));
    else {
      if((*j)  < 0x10000)
        String_AddChar(Char)(yp,(char)(0xe0U bitor (((unsigned int)(*j)) >>  12)));
      else {
        if((*j)  < 0x200000)
          String_AddChar(Char)(yp,(char)(0xf0U bitor (((unsigned int)(*j)) >>  18)));
        else {
          if((*j)  < 0x4000000)
            String_AddChar(Char)(yp,(char)(0xf8U bitor (((unsigned int)(*j)) >>  24)));
          else {
            String_AddChar(Char)(yp,(char)(0xfcU bitor (((unsigned int)(*j)) >>  30)));
            String_AddChar(Char)(yp,(char)(0x80U bitor ((((unsigned  int)(*j)) >>  24) bitand  0x3fU)));
          } 
                // not(i  < 0x4000000U)
          String_AddChar(Char)(yp,(char)(0x80U bitor ((((unsigned  int)(*j)) >>  18) bitand  0x3fU)));
        }
            // not(i  < 0x200000U)
        String_AddChar(Char)(yp,(char)(0x80U bitor ((((unsigned  int)(*j)) >>  12) bitand  0x3fU)));
      }
            // not(i  < 0x10000U)
      String_AddChar(Char)(yp,(char)(0x80U bitor ((((unsigned  int)(*j)) >>  6)  bitand  0x3fU)));
    }
          // not(i  < 0x800U)
    String_AddChar(Char)(yp,(char)(0x80U bitor (((unsigned int)(*j)) bitand  0x3fU)));
  } // for
  return  false;
}

// wchar_t[] -> bytedeque
bool  isBADReadWCharArrayToByteDeque ( wchar_t volatile const * const xp  ,
  Deque ( Byte )  * const yp ) {
  Deque_Clear ( Byte ) ( yp ) ;
  wchar_t volatile const * i = xp  ;
  while ( * i ) {
    if  ( isBADWCharPushToByteDeque ( * i , yp ) )
      return   true   ;
    ++  i ; 
  }
  return   false  ; 
}

# include "stat/struct.h"
    
# define  array_mode_symbol Lisp2D_array_mode_symbol
static  ModePLOSymbolP  array_mode_symbol [ array_mode_symbol_size ] ;
ModePLOSymbolP const ( * const arrayp_mode_symbol ) [ ]  =
  ( ModePLOSymbolP const ( * ) [ ]  ) & array_mode_symbol ;

# include <sys/stat.h>
# include <errno.h>  
  
void  InitArrayModeSymbol ( void  ) {
  MapNode ( errnotosymbol ) const errnotosymbol_arr [ ] = {
        { EACCES  , & plosaccess  } ,          { EAGAIN  , &  plosagain } ,
        { EBADF , & plosbadf  } ,          { EBUSY , &  plosbusy  } ,
        { EDESTADDRREQ  , & plosdestaddrreq } ,          { EDQUOT  , &  plosdquote  } ,
        { EEXIST  , & plosexist } ,          { EFAULT  , &  plosfault } ,
        { EFBIG , & plosfbig  } ,           { EINTR , & plosintr  } ,
        { EINVAL  , & plosinval } ,           { EISDIR  , & plosisdir } ,
        { EIO , & plosio  } ,          { ELOOP , &  plosloop  } ,
        { EMFILE  , & plosmfile } ,          { EMLINK  , &  plosmlink } ,
        { ENAMETOOLONG  , & plosnametoolong } ,           { ENFILE  , & plosnfile } ,
        { ENODEV  , & plosnodev } ,           { ENOENT  , & plosnoent } ,
        { ENOMEM  , & plosnomem } ,          { ENOSPC  , &  plosnospc } ,
        { ENOSYS  , & plosnosys } ,          { ENOTDIR , &  plosnotdir  } ,
        { ENOTEMPTY , & plosnotempty  } ,          { ENOTTY , & plosnotty  } ,
        { ENXIO , & plosnxio  } ,          { EOPNOTSUPP  , &  plosopnotsupp } ,
        { EOVERFLOW , & plosoverflow  } ,          { EPERM , &  plosperm  } ,
        { EPIPE , & plospipe  } ,          { EROFS , &  plosrofs  } ,
        { ESPIPE  , & plosspipe } ,           { ETXTBSY , & plostxtbsy  } ,
        { EWOULDBLOCK , & ploswouldblock  } ,          { EXDEV , &  plosxdev }
    } ;
  MapPubInit  ( errnotosymbol ) ( seterrnotosymbol_pub , seterrnotosymbol_fun ) ;
  { MapNode ( errnotosymbol ) const * j = & errnotosymbol_arr [
      sizeof  ( errnotosymbol_arr ) / sizeof  ( errnotosymbol_arr [ 0 ] ) ] ;
    do {
      --  j ;
      MapPubInsert  ( errnotosymbol ) ( seterrnotosymbol_pub , * j ) ;
    } while ( j > & errnotosymbol_arr [ 0 ] ) ; 
  }
  
  MapNode ( FlessOpenModes  ) const symboltoopenmodes_arr [ ] = {
    { & plosin  . plo , OpenModes_In  } , { & plosout . plo , OpenModes_Out } ,
    { & plosinout . plo , OpenModes_InOut } ,
    { & plostrunc . plo , OpenModes_Trunc } , { & plosapp . plo , OpenModes_App } ,
    { & plosate . plo , OpenModes_Ate } ,    { &  plosasync . plo , OpenModes_Async } ,
    { & ploscloexec . plo , OpenModes_Cloexec } ,    { &  ploscreat . plo , OpenModes_Creat } ,
    { & plosrwxusr  . plo  , OpenModes_RwxUsr } ,
    { & plosrusr  . plo , OpenModes_RUsr } , { &  ploswusr  . plo , OpenModes_WUsr } ,
    { & plosxusr  . plo , OpenModes_XUsr } ,    { & plosrwxgrp  . plo  , OpenModes_RwxGrp } ,
    { & plosrgrp  . plo  , OpenModes_RGrp } ,    { &  ploswgrp  . plo  , OpenModes_WGrp } ,
    { & plosxgrp  . plo  , OpenModes_XGrp } ,    { &  plosrwxoth  . plo  , OpenModes_RwxOth } ,
    { & plosroth  . plo  , OpenModes_ROth } ,    { &  ploswoth  . plo  , OpenModes_WOth } ,
    { & plosxoth  . plo  , OpenModes_XOth } ,
    { & plossuid  . plo , OpenModes_Suid } , { &  plossgid  . plo , OpenModes_Sgid } ,
    { & plossvtx  . plo , OpenModes_Svtx } ,    { & plosdirect . plo , OpenModes_Direct } ,
    { & plosdirectory . plo , OpenModes_Directory } ,    { &  plosdsync . plo , OpenModes_Dsync } ,
    { & plosexcl  . plo , OpenModes_Excl } ,     { &  ploslargefile . plo , OpenModes_Largefile } ,
    { & plosnoatime . plo , OpenModes_Noatime } ,    { &  plosnoctty  . plo , OpenModes_Noctty } ,
    { & plosnofollow  . plo , OpenModes_Nofollow } ,    { & plosnonblock  . plo , OpenModes_NonblockOrNdelay } ,
    { & plosndelay  . plo , OpenModes_NonblockOrNdelay } ,
    { & plospath  . plo , OpenModes_Path } , { &  plossync  . plo , OpenModes_Sync } ,
    { & plostmpfile . plo , OpenModes_Tmpfile }
  } ;
  MapPubInit  ( FlessOpenModes  ) ( symboltoopenmodes_pub , symboltoopenmodes_fun ) ;
  { MapNode ( FlessOpenModes  ) const * j = & symboltoopenmodes_arr [
      sizeof  ( symboltoopenmodes_arr ) / sizeof  ( symboltoopenmodes_arr [ 0 ] ) ] ;
    do {
      --  j ;
      MapPubInsert  ( FlessOpenModes  ) ( symboltoopenmodes_pub , * j ) ;
    } while ( j > & ( symboltoopenmodes_arr [ 0 ] ) ) ;
  }
  
  array_mode_symbol [ 0 ] = ( ModePLOSymbolP  ) {    . mo  = S_ISUID , . sp  = &  plossuid } ;
  array_mode_symbol [ 1 ] = ( ModePLOSymbolP  ) {    . mo  = S_ISGID , . sp  = &  plossgid } ;
  array_mode_symbol [ 2 ] = ( ModePLOSymbolP  ) {    . mo  = S_ISVTX , . sp  = &  plossvtx } ;
  array_mode_symbol [ 3 ] = ( ModePLOSymbolP  ) {    . mo  = S_IRUSR , . sp  = &  plosrusr } ;
  array_mode_symbol [ 4 ] = ( ModePLOSymbolP  ) {    . mo  = S_IWUSR , . sp  = &  ploswusr } ;
  array_mode_symbol [ 5 ] = ( ModePLOSymbolP  ) {    . mo  = S_IXUSR , . sp  = &  plosxusr } ;
  array_mode_symbol [ 6 ] = ( ModePLOSymbolP  ) {    . mo  = S_IRGRP , . sp  = &  plosrgrp } ;
  array_mode_symbol [ 7 ] = ( ModePLOSymbolP  ) {    . mo  = S_IWGRP , . sp  = &  ploswgrp } ;
  array_mode_symbol [ 8 ] = ( ModePLOSymbolP  ) {     . mo  = S_IXGRP , . sp  = & plosxgrp } ;
  array_mode_symbol [ 9 ] = ( ModePLOSymbolP  ) {    . mo  = S_IROTH , . sp  = &  plosroth } ;
  array_mode_symbol [ 10 ] = ( ModePLOSymbolP  ) {    . mo  = S_IWOTH , . sp  = & ploswoth } ;
  array_mode_symbol [ 11 ] = ( ModePLOSymbolP  ) {    . mo  = S_IXOTH , . sp  = & plosxoth } ;
  
  MapNode ( FlessMkdirModes ) const symboltomkdirmodes_arr [ ] = {
    { & plosrwxusr  . plo  , MKDirClass_RwxUsr } ,    { & plosrusr  . plo , MKDirClass_RUsr } ,
    { & ploswusr  . plo , MKDirClass_WUsr } ,    { &  plosxusr  . plo , MKDirClass_XUsr } ,
    { & plosrwxgrp  . plo  , MKDirClass_RwxGrp } ,    { & plosrgrp  . plo  , MKDirClass_RGrp } ,
    { & ploswgrp  . plo  , MKDirClass_WGrp } ,    { & plosxgrp  . plo  , MKDirClass_XGrp } ,
    { & plosrwxoth  . plo  , MKDirClass_RwxOth } ,    { & plosroth  . plo  , MKDirClass_ROth } ,
    { & ploswoth  . plo  , MKDirClass_WOth } ,    { & plosxoth  . plo  , MKDirClass_XOth } ,
    { & plossuid  . plo , MKDirClass_Suid } ,
    { & plossgid  . plo , MKDirClass_Sgid } , { & plossvtx  . plo , MKDirClass_Svtx }
  } ;
  MapPubInit  ( FlessMkdirModes ) ( symboltomkdirmodes_pub ,
    symboltomkdirmodes_fun ) ;
  { MapNode ( FlessMkdirModes ) const * j = & symboltomkdirmodes_arr [
      sizeof  ( symboltomkdirmodes_arr ) /
      sizeof  ( symboltomkdirmodes_arr [ 0 ] ) ] ;
    do {
      --  j ;
      MapPubInsert  ( FlessMkdirModes ) ( symboltomkdirmodes_pub , * j ) ;
    } while ( j > & symboltomkdirmodes_arr [ 0 ] ) ; 
  }
}

// string -> wstring
bool  isBADReadCStringToWString2 ( String ( Char ) const * const xp ,
  String ( WideChar ) * const yp ) {
  StringClear ( WideChar  ) ( yp  ) ;
  char  const * ic = String_CBegin ( Char ) ( xp ) ;
  char  const * const xendc2 = String_CEnd ( Char ) ( xp ) ;
  while ( ic < xendc2  ) {
    wchar_t wy ;
    if  ( isBADReadStringToOneWChar ( xendc2 , & ic , & wy ) )
      return   true ;
    String_AddChar ( WideChar  ) ( yp , wy ) ; 
  }
  return  false ; 
}

void  volatile  * memsetv ( void  volatile  * const s , int const c , size_t  n ) {
  uint8_t volatile  * p = s ;
  while ( n ) {
    * p = int_cast_byte ( c ) ;
    -- n ;
    ++ p ; 
  }
  return s ; 
}

void  frees ( void  volatile  * const s , int const c , size_t  n ) {
  memsetv ( s , c , n ) ;
  free ( voidvolatp_cast_voidp ( s ) ) ;
}

// -- treeSymbolsLess --
  
# define  treeSymbols_pri Lisp2D_treeSymbols_pri
static  MapPri  ( treeSymbolsLessType ) treeSymbols_pri ;
MapPub  ( treeSymbolsLessType ) * const treeSymbols_pub = & treeSymbols_pri . pub ;

LISP2DSTACKPUSHBYVALUE ( StackMapNodetreeSymbolsLessType ,  MapNode ( treeSymbolsLessType ) , )
LISP2DSTACKPUSHATVALUE ( StackMapNodetreeSymbolsLessType ,  MapNode ( treeSymbolsLessType ) )
LISP2DSTACKCAT ( StackMapNodetreeSymbolsLessType ,  MapNode ( treeSymbolsLessType ) )
LISP2DMAPPUBFINDBODY  ( treeSymbolsLessType , PLOSymbol * )
LISP2DMAPPUBINSERTBODY  ( treeSymbolsLessType )

// -- setTypeSymbolName --

# define  setTypeSymbolName_pri Lisp2D_setTypeSymbolName_pri
static  MapPri  ( setTypeSymbolNameType ) setTypeSymbolNameType_pri ;
MapPub  ( setTypeSymbolNameType ) * const setTypeSymbolNameType_pub =
  & setTypeSymbolNameType_pri . pub ;

LISP2DSTACKPUSHBYVALUE ( StackMapNodesetTypeSymbolNameType , MapNode ( setTypeSymbolNameType ) , )
LISP2DSTACKPUSHATVALUE ( StackMapNodesetTypeSymbolNameType ,
  MapNode ( setTypeSymbolNameType ) )
LISP2DSTACKCAT ( StackMapNodesetTypeSymbolNameType ,
  MapNode ( setTypeSymbolNameType ) )
LISP2DMAPPUBFINDBODY  ( setTypeSymbolNameType , uint8_t )
LISP2DMAPPUBINSERTBODY  ( setTypeSymbolNameType )

int setTypeSymbolName_fun  ( uint8_t const  a , uint8_t const b ) {
  return  ( a == b ? 0 : ( a < b ? -1 : 1 ) ) ; 
}

// -- seterrnotosymbol --
# define  seterrnotosymbol_pri Lisp2D_seterrnotosymbol_pri
static  MapPri  ( errnotosymbol ) seterrnotosymbol_pri ;
MapPub  ( errnotosymbol ) * const seterrnotosymbol_pub =  & seterrnotosymbol_pri . pub ;

LISP2DSTACKPUSHBYVALUE ( StackMapNodeerrnotosymbol ,  MapNode ( errnotosymbol ) , )
LISP2DSTACKPUSHATVALUE ( StackMapNodeerrnotosymbol ,  MapNode ( errnotosymbol ) )
LISP2DSTACKCAT ( StackMapNodeerrnotosymbol ,  MapNode ( errnotosymbol ) )
LISP2DMAPPUBFINDBODY  ( errnotosymbol , int )
LISP2DMAPPUBINSERTBODY  ( errnotosymbol )

int seterrnotosymbol_fun  ( int const  a , int const b ) {
  return  ( a == b ? 0 : ( a < b ? -1 : 1 ) ) ; 
}

# include "listplo/structpri.h"
  
# define  list_global_atomscp Lisp2D_list_global_atomscp
static  Lisp2D_ListPri ( PLO ) list_global_atomscp  ;
Lisp2D_List ( PLO ) * const list_global_atomsc = & list_global_atomscp . pub ;

typedef struct  functionisBADReadStringToOneWChar
  functionisBADReadStringToOneWChar ;

struct  functionisBADReadStringToOneWChar {
  functionboolcharp base  ;
  char  const * * ip  ;
  char  const * xend1 ;
} ;

static  void  functionisBADReadStringToOneWChar_Init (
  functionisBADReadStringToOneWChar * const me , char  const * * const i1 ,
  char  const * const xend2 ) {
  functionboolcharp_Init  ( & me -> base ,
    type_functionisBADReadStringToOneWChar ) ;
  me -> ip = i1 ;
  me ->  xend1 = xend2 ; 
}

# define  functionboolcharpp_cast_bytep Lisp2D_functionboolcharpp_cast_bytep
inline  uint8_t * functionboolcharpp_cast_bytep ( functionboolcharp * const p ) {
  return  ( uint8_t * ) p ;
}

# define  bytep_cast_funp Lisp2D_bytep_cast_funp
inline  functionisBADReadStringToOneWChar * bytep_cast_funp ( uint8_t * const p ) {
  return ( functionisBADReadStringToOneWChar * ) p ;
}

inline  functionisBADReadStringToOneWChar *
  fromFunctionboolcharpToFunctionisBADReadStringToOneWChar  (
  functionboolcharp * const p ) {
  return  bytep_cast_funp ( functionboolcharpp_cast_bytep ( p ) -
    offsetof  ( functionisBADReadStringToOneWChar , base  ) ) ; 
}

bool  functionisBADReadStringToOneWChar_Fun ( functionboolcharp  * const p ,
  char  * const y ) {
  functionisBADReadStringToOneWChar * const me  =
    fromFunctionboolcharpToFunctionisBADReadStringToOneWChar  ( p ) ;
  ++  ( * ( me -> ip )  ) ;
  if  ( ( * ( me -> ip ) ) >= ( me -> xend1 ) )
    return   true  ;
  ( * y ) = ( * * ( me -> ip ) ) ;
  return   false  ; 
}
    
bool  isBADReadStringToOneWChar ( char const * const xend ,
  char  const * * const i1 , wchar_t * const yp ) {
  if  ( ( * i1 ) >= xend )
    return   true   ;
  char const  ch = ( * * i1 ) ;
  functionisBADReadStringToOneWChar f ;
  functionisBADReadStringToOneWChar_Init ( & f , i1 , xend ) ;
  if  ( isBADReadWCharUniversal ( ch , & f . base , yp ) )
    return   true ;
  ++ ( * i1 ) ;
  return   false  ;
}

# include "stack/public.h"

# define  AddForConstrStatic  Lisp2D_AddForConstrStatic
// tolower, newSymbol w/o check
static  PLOSymbol * AddForConstrStatic  ( PLOSymbol * const symtop2 , wchar_t  const * const str  ) {
  ThreadStackPointerType  const oldstack  = Lisp2DThreadSP  ( ) ;
  String  ( WideChar  ) * const sp  = Lisp2D_StackVar ( Lisp2DStackTypeStringWideChar ) ;
  StringConstrCStr  ( WideChar  ) ( sp  , str , true ) ;
  toLower ( String_Size ( WideChar  ) ( sp  ) , String_Begin  ( WideChar  ) ( sp  ) ) ;
  PLOSymbolConstrWCharStringMove  ( symtop2 , sp  ) ;
  ParaLispObject_SetFlagStaticTrue  ( & symtop2 ->  plo ) ;
  { size_t  const jc  = MapPubFind  ( treeSymbolsLessType ) ( treeSymbols_pub , symtop2 ) ;
    if  ( jc  not_eq  MapPubSize  ( treeSymbolsLessType ) ( treeSymbols_pub ) ) {
      inErrorS  ( PLOStreamPushWideCharArray  ( & Lisp2Dferr  , ( PArray_wchar_c  ) { ( wchar_t const ( * ) [ ] ) &
        L"AddForConstr2: symbol " } ) ;
        PLOStreamPushPLO  ( & Lisp2Dferr  , & symtop2 ->  plo ) ;
        PLOStreamPushWideCharArray  ( & Lisp2Dferr  , ( PArray_wchar_c  ) { ( wchar_t const ( * ) [ ] ) &
          L" already defined" } ) ; )
      PLOSymbolstaticDestr  ( & symtop2 ->  plo ) ;
      Lisp2D_StackFree  ( oldstack  ) ;
      return  MapPubCAt ( treeSymbolsLessType ) ( treeSymbols_pub , jc  ) ->  key ;
    }
    MapPubInsert  ( treeSymbolsLessType ) ( treeSymbols_pub ,
      ( MapNode ( treeSymbolsLessType ) ) { symtop2 , 0 } ) ;
  } // jc
  Lisp2D_StackFree  ( oldstack  ) ;
  return  symtop2 ;
}

// tolower, newSymbol w/o check 
static  PLOSymbol * AddForConstr  ( wchar_t  const * const str  ) {
  ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
  String  ( WideChar  ) * const sp = Lisp2D_StackVar ( Lisp2DStackTypeStringWideChar  ) ;
  StringConstrCStr  ( WideChar )  ( sp  , str , true ) ;
  toLower ( String_Size ( WideChar )  ( sp ) , String_Begin ( WideChar  ) ( sp ) ) ;
  { PLOSymbol * const symtop2 = aligned_alloc ( _Alignof ( PLOSymbol ) , sizeof ( PLOSymbol ) ) ;
    if  ( symtop2 ) {
      PLOSymbolConstrWCharStringMove  ( symtop2 , sp  ) ;
      { size_t  const jc  = MapPubFind  ( treeSymbolsLessType ) (
          treeSymbols_pub , symtop2 ) ;
        if  ( jc  not_eq  MapPubSize  ( treeSymbolsLessType ) (
          treeSymbols_pub ) ) {
          inErrorS  ( PLOStreamPushWideCharArray  ( &Lisp2Dferr ,
              ( PArray_wchar_c ) { (wchar_t const(*)[])&  
              L"AddForConstr2: symbol "});
            PLOStreamPushPLO(& Lisp2Dferr , &  (  symtop2->plo ));
            PLOStreamPushWideCharArray  ( &Lisp2Dferr ,
              ( PArray_wchar_c ) { (wchar_t const(*)[])&
              L" already defined"}); )
          PLOSymbolstaticDestr  ( & symtop2 ->  plo ) ;
          free  ( symtop2 ) ;
          Lisp2D_StackFree  ( oldstack ) ;
          return  MapPubCAt ( treeSymbolsLessType ) ( treeSymbols_pub , jc ) -> key ;
        }
        MapPubInsert  ( treeSymbolsLessType ) ( treeSymbols_pub , ( MapNode (
          treeSymbolsLessType ) ) { symtop2 , 0 } ) ; 
      } // jc
      Lisp2D_StackFree  ( oldstack ) ;
      return  symtop2 ; 
    } // if symtop2
    Lisp2D_StackFree  ( oldstack ) ;
    Lisp2DExcOutOfMemoryGlobal . value =  
      L"AddForConstr:symtop2 = aligned_alloc  ( sizeof  ( PLOSymbol ) )" ;
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; 
  }
}
  
# include "boolean.h"

/*
(nil  defclass) 
(false  defclass  nil)  
(true defclass  nil)  
('cons  defclass  nil)  
('vector  defclass  nil)  
('string  defclass  nil)  
('number  defclass  nil)  
('symbol  defclass  nil)  
('char  defclass  nil)  
('stream  defclass  nil)  
('window  defclass  nil)
('lock  defclass  nil)
*/

# include "listplo/public.h"

# define  GlobalDefClass  Lisp2D_GlobalDefClass
// ! to put GlobalDefClass to defclass.cpp
static  void  GlobalDefClass  ( StackClusterPrivate * const stclpp ,
  NameSpaceDef * const nsp  ) {
  PLOCons * const listvar  =  NewCons  (   nsp  -> var  ,
      &plonil.plo  )  ;
  { PLOCons * const listprop =  NewCons (   nsp  -> prop   ,
        &plonil .plo ) ;
    StackClusterPrivate_SetEnv3(stclpp,&  listvar->plo , & listprop->plo  ) ; 
  }
  Vector_PushByValue  ( StackPLOP ) ( StackClusterPrivate_stackcThisp  (
    stclpp  ) , & plonil . plo ) ;  
  Vector_PushByValue  ( StackPLOP )  ( StackClusterPrivate_stackcproArgp  (
    stclpp  ) , & plonil . plo ) ;
  bindefclassForMain  ( stclpp ) ;
  bimnilgetclass (  stclpp  ) ;
  ploclassdefnil  = StackClusterPrivate_result  ( stclpp ) ;
  
  Lisp2D_ListPushBack ( PLO ) ( list_global_atomsc  , ploclassdefnil ) ;
  MapPubInit  ( setTypeSymbolNameType ) ( setTypeSymbolNameType_pub ,
    setTypeSymbolName_fun ) ;
    
  MapPubInsert  ( setTypeSymbolNameType ) ( setTypeSymbolNameType_pub , 
    ( MapNode ( setTypeSymbolNameType ) ) { TypeGlobalListMemberPLONil , & plosnil } ) ;

// ! to make list trio global -> for Garbage Collector  
  { typedef struct  trio  ttrio ;
    struct  trio  {
      uint8_t const uitype  ;
      PLOSymbol * const name  ;
      ParaLispObject  * * const parent  ;
      ParaLispObject  * * const definition  ; 
    } ;
    ttrio const arrtrio [ ] = {
      { TypeGlobalListMemberPLOBoolean ,        & plosboolean , & ploclassparentsboolean  ,        & ploclassdefboolean  } ,
      { TypeGlobalListMemberPLOCons , & ploscons  , & ploclassparentscons , & ploclassdefcons } ,
      { TypeGlobalListMemberPLOVector  , & plosvector  , & ploclassparentsvector , & ploclassdefvector } ,
      { TypeGlobalListMemberPLOString  , & plosstring  , & ploclassparentsstring , & ploclassdefstring } ,
      { TypeGlobalListMemberPLOSymbol  , & plossymbol  , & ploclassparentssymbol , & ploclassdefsymbol } ,
      { TypeGlobalListMemberPLOChar  , & ploschar  , & ploclassparentschar , & ploclassdefchar } ,
      { TypeGlobalListMemberPLOStream  , & plosstream  , & ploclassparentsstream , & ploclassdefstream } ,
# ifndef  LISP2D_DONTUSEX11    
      { TypeGlobalListMemberPLOWindowPri  , & ploswindow  , & ploclassparentswindow , & ploclassdefwindow } ,
# endif    
      { TypeGlobalListMemberPLOTime  , & plostime  , & ploclassparentstime , & ploclassdeftime } ,
      { TypeGlobalListMemberPLODirPri , & plosdir , & ploclassparentsdir  , & ploclassdefdir  } ,
      { TypeGlobalListMemberBIFPrivate , & plosbif , & ploclassparentsbif  , & ploclassdefbif  } ,
      { TypeGlobalListMemberPLOLock  , & ploslock  , & ploclassparentslock , & ploclassdeflock } ,
      { TypeGlobalListMemberPLOSignal  , & plossignal  , & ploclassparentssignal , & ploclassdefsignal } ,
      { TypeGlobalListMemberPLOEnv , & plosenv , & ploclassparentsenv  , & ploclassdefenv  } ,
      { TypeGlobalListMemberPLOEnvironmentLayer  , & plosenvironmentlayer  , & ploclassparentsenvlayer , & ploclassdefenvlayer } ,
      { TypeGlobalListMemberPLOQuote , & plosquote2  , & ploclassparentsQuote  , & ploclassdefQuote  } ,
      { TypeGlobalListMemberBackQuotePrivate , & plosbackquote , & ploclassparentsBackQuote  , & ploclassdefBackQuote  } ,
      { TypeGlobalListMemberPLOComma , & ploscomma , & ploclassparentsComma  , & ploclassdefComma  } ,
      { TypeGlobalListMemberPLOUnquoteSplicing , &  plosUnquoteSplicing , & ploclassparentsUnquoteSplicing  ,
        & ploclassdefUnquoteSplicing  } ,
      { TypeGlobalListMemberPLOComplex , & ploscomplex , & ploclassparentscomplex  , & ploclassdefcomplex  } ,
      { TypeGlobalListMemberPLOByteDeque , &  plosbytedeque , & ploclassparentsbytedeque  , & ploclassdefbytedeque  } ,
      { TypeGlobalListMemberPLOSocket  , &  plossocket  , & ploclassparentssocket , & ploclassdefsocket } ,
      { TypeGlobalListMemberPLOStatPri  , & plosstat  , & ploclassparentsstat , & ploclassdefstat }
    } ;
    { enum  { arrtriosize = sizeof  ( arrtrio ) / sizeof  ( arrtrio [ 0 ] ) } ;
      ttrio  const * sp = &  arrtrio [ arrtriosize ] ;
      do {
        --  sp  ;
        Vector_ReplaceTopByValue  ( StackPLOP ) ( StackClusterPrivate_stackcThisp ( stclpp ) , & sp -> name -> plo ) ;
        ( * ( sp -> parent  ) ) = &( NewCons ( &plonil.plo  , &plonil .plo ) ->plo ) ;
        StackClusterPrivate_ReplaceArg  ( stclpp , * ( sp -> parent  ) ) ;
        bindefclassForMain  ( stclpp ) ;
        bimnilgetclass ( stclpp  ) ;
        ( * ( sp -> definition  ) ) = StackClusterPrivate_result  ( stclpp ) ;
        Lisp2D_ListPushBack ( PLO ) ( list_global_atomsc  , * ( sp -> parent ) ) ;
        Lisp2D_ListPushBack ( PLO ) ( list_global_atomsc  , * ( sp -> definition ) ) ;
        MapPubInsert  ( setTypeSymbolNameType ) ( setTypeSymbolNameType_pub ,
          ( MapNode ( setTypeSymbolNameType ) ) { sp -> uitype , sp -> name } ) ;
      } while ( sp  > & arrtrio [ 0 ] ) ;
    } // arrtriosize
  } // ttrio
  VectorPop(StackPLOP)  ( StackClusterPrivate_stackcThisp ( stclpp ) ) ;
  VectorPop(StackPLOP) ( StackClusterPrivate_stackcproArgp ( stclpp ) ) ; 
}
  
# include "char/public.h"
# include "complex/public.h"
# include "cons/private.h"
# include "listplo/public.h"
# include "socket/public.h"
# include "plocomplex/public.h"
# include "globallista/public.h"
  
StackClusterPrivate  * Constr  ( void ) {
  CreateSetCharNameValue();
  GlobalListConstructor ( & GlobalListOfStackClustersGarbage2 ) ;
  GlobalListConstructor ( & GlobalListOfComplex ) ;
  GlobalListConstructor ( & GlobalListOfComplexGarbage ) ;
  GlobalListConstructor ( & GlobalListOfComplexGC ) ;
  GlobalListConstructor ( & GlobalListOfLayer ) ;
  GlobalListConstructor ( & GlobalListOfLayerGarbage ) ;
  GlobalListConstructor ( & GlobalListOfLayerGC ) ;
# ifndef  LISP2D_DONTUSEX11    
  GlobalListConstructor ( & GlobalListOfWindows ) ;
  GlobalListConstructor ( & GlobalListOfWindowsGarbage ) ;
# endif  
  //  PLOCons *
  GlobalListConstructor ( & GlobalListOfConsPairs ) ;
  GlobalListConstructor ( & GlobalListOfConsPairsGarbage ) ;
  GlobalListConstructor ( & GlobalListOfConsPairsGC ) ;
  GlobalListConstructor ( & GlobalListOfSymbolsGarbage  ) ;

  Lisp2D_ListInit ( PLO ) ( list_global_atomsc  ) ;

  { ParaLispObject  * const ploarr  [ ] = {
      & plonil.plo  , & plotrue.plo , & plofalse.plo  , & Lisp2Dferr.plo  ,
      & Lisp2Dfout.plo  , & Lisp2Dfin.plo } ;
    enum  { ploarrsize  = sizeof(ploarr)/sizeof(ploarr[0]) } ;
    { ParaLispObject  * const * j = & ploarr  [ ploarrsize ] ;
      do  {
        --  j ;
        Lisp2D_ListPushBack ( PLO ) ( list_global_atomsc  , * j ) ;
      } while ( j > & ploarr [ 0 ] ) ; 
    } 
  }

  { Lisp2D_ListNode ( PLO ) * j = Lisp2D_ListFirst  ( PLO ) ( list_global_atomsc  ) ;
    while ( j ) {
      GlobalListPush ( & GlobalListOfObjects , & Lisp2D_ListNodeValue  ( PLO ) ( j ) -> base ) ;
      j = Lisp2D_ListNodeNext ( PLO ) ( j ) ; 
    } 
  }

// ! trans to global arr -> for Garbage Collector
  
  // construct Symbols tree
  MapPubInit  ( treeSymbolsLessType ) ( treeSymbols_pub , PLOSymbolCompareP ) ;
  
  { typedef struct  strSymbolWideStrStatic  tySymbolWideStrStatic ;
    struct  strSymbolWideStrStatic {
      PLOSymbol * const sy ;
      wchar_t const * const ws ;
    } ;
    tySymbolWideStrStatic const arrSymStatic [ ] = {
      { & plosaccess  , L"access" } ,
      { & plosapp , L"app"  } , { & ploarg  , L"arg"  } ,
      { & plosasync , L"async" } , { & plosate , L"ate"  } ,
      { & plosbackquote , L"backquote"  } , { & plosbadf  , L"badf" } ,
      { & plosbif , L"bif"  } , { & plosblock , L"block"  } ,
      { & plosboolean , L"boolean"  } , { & plosbusy , L"busy"  } ,
# ifndef LISP2D_DONTUSEX11
      { & plosbuttonpress , L"button-press" } , { & plosbuttonrelease , L"button-release" } ,
# endif
      { & plosbytedeque , L"byte-vector"  } , { & ploerroroutput  , L"cerr"}  ,
      { & ploschar  , L"char" } , { & ploscharacter , L"character"}  ,
      { & plostandardinput  , L"cin"  } ,      { & ploscloexec , L"cloexec"  } ,
# ifndef LISP2D_DONTUSEX11
      { & plosconfigurenotify , L"configure-notify"}  ,
# endif
      { & ploscons  , L"cons" } ,
      { & ploandconst , L"&const" } , { & plostandardoutput , L"cout" } ,
      { & ploscreat , L"create" } , { & ploscur , L"cur"  } ,
      { & plosdata  , L"data" } ,
      { & plosdir , L"dir"  } , { & plosdirect  , L"direct" } ,
      { & plosdirectory , L"directory"  } , { & plosdquote  , L"dquote" } ,
      { & plosdsync , L"dsync"  } ,
      { & plose , L"e"  } , { & plosend , L"end"  } ,
      { & plosenv , L"environment"  } , { & plosenvironmentlayer  , L"environment-layer"  } ,
      { & plosexcl  , L"excl" } , { & plosexist , L"exist"  } ,
      { & plosfalse , L"false"  } , { & plosfault , L"fault"  } ,
      { & plosfbig  , L"fbig" } , { & plosfifo  , L"fifo" } ,
      { & ploshole  , L"hole" } ,
      { & plosin  , L"in" } ,  { & plosintr  , L"intr" } ,
      { & plosinout , L"in-out" } , { & plosinval , L"inval"  } ,
      { & plosio  , L"io" } ,{ & plosisdir , L"isdir"  } ,
# ifndef LISP2D_DONTUSEX11
      { & ploskeypress  , L"key-press"  } , { & ploskeyrelease  , L"key-release"  } ,
# endif
      { & plolambdaw  , L"λ"  } , { & plolambdanotmod2  , L"lambda" } ,
      { & ploslargefile , L"largefile"  } , { & ploslink  , L"link" } ,
      { & ploslock  , L"lock" } , { & plosloop  , L"loop" } ,
      { & plomacronotmod  , L"macro"  } ,
      { & plosmain  , L"main" } , { & plosmfile , L"mfile"  } ,
      { & plosmlink , L"mlink"  } , { & plosnametoolong , L"nametoolong"  } ,
      { & plosndelay  , L"ndelay" } , { & plosnfile , L"nfile"  } ,
      { & plosnil , L"nil"  } ,
      { & plosnoatime , L"noatime"  } , { & plosnoctty  , L"noctty" } ,
      { & plosnodev , L"nodev"  } , { & plosnoent , L"noent"  } ,
      { & plosnofollow  , L"nofollow" } , { & plosnomem , L"nomem"  } ,
      { & plosnonblock  , L"nonblock" } , { & plosnospc , L"nospc"  } ,
      { & plosnosys , L"nosys"  } , { & plosnotdir  , L"notdir" } ,
      { & plosnotempty , L"notempty"  } , { & plosnotty , L"notty"  } ,
      { & plosnull  , L"null" } , { & ploscomplex , L"number" } ,
      { & plosnxio  , L"nxio" } , { & plosopnotsupp , L"opnotsupp"  } ,
      { & plosout , L"out"  } , { & plosoutofmemory , L"outofmemory"  } ,
      { & plosoverflow  , L"overflow" } ,
      { & plomain , L"package"  } ,      { & plospath  , L"path" } ,
      { & plosperm  , L"perm" } ,
      { & plospi  , L"pi" } , { & plosquestion  , L"?" } ,
      { & plosquote2  , L"quote"  } , { & plosregular , L"regular" } ,
      { & ploandrest  , L"&rest"  } , { & plosrgrp  , L"rgrp" } ,
      { & plosrofs  , L"rofs" } , { & plosroth  , L"roth" } ,
      { & plosrusr  , L"rusr" } , { & plosrwxgrp  , L"rwxgrp" } ,
      { & plosrwxoth  , L"rwxoth" } ,
      { & plosrwxusr  , L"rwxusr" } , { & plossgid  , L"sgid" } ,
      { & plossignal  , L"signal" } ,
      { & plossocket  , L"socket" } , { & plosspipe , L"spipe"  } ,
      { & plossrch  , L"srch" } ,      { & plosstat  , L"stat" } ,
      { & plosstd , L"std"  } , { & plosstream  , L"stream" } ,
      { & plosstring  , L"string" } , { & plossuid  , L"suid" } ,
      { & plossvtx  , L"svtx" } ,
      { & plossymbol  , L"symbol" } , { & plossync  , L"sync" } ,
      { & plossystemclass , L"system::class"  } ,
      { & plosthis  , L"this" } , { & plosthreepoints , L"..."  } ,
      { & plostime  , L"time" } , { & plostmpfile , L"tmpfile"  } ,
      { & plostrue1 , L"true" } , { & plostrunc , L"trunc"  } ,
      { & plostxtbsy  , L"txtbsy" } , { & ploscomma , L"unquote"  } ,
      { & plosUnquoteSplicing , L"unquote-splicing" } , { & plosvector  , L"vector" } ,
      { & ploswgrp  , L"wgrp" } , { & ploandwhole , L"&whole" } ,
# ifndef LISP2D_DONTUSEX11
      { & ploswindow  , L"window" } , { & ploswindowclose , L"window-close" } ,
# endif
      { & ploswoth  , L"woth" } , { & ploswouldblock  , L"wouldblock" } ,
      { & ploswusr  , L"wusr" } , { & plosxdev  , L"xdev" } ,
      { & plosxgrp  , L"xgrp" } ,
      { & plosxoth  , L"xoth" } , { & plosxusr  , L"xusr" } ,
    } ;
    enum  { arrSymSizeStatic = sizeof ( arrSymStatic  ) / sizeof  ( arrSymStatic  [ 0 ] ) } ;
    { tySymbolWideStrStatic const * js = & arrSymStatic  [ arrSymSizeStatic  ] ;
      do {
        --  js ;
        PLOSymbol * const sy  = AddForConstrStatic ( js  ->  sy , js -> ws ) ;
        Lisp2D_ListPushBack ( PLO ) ( list_global_atomsc  , & sy -> plo ) ;
      } while ( js > & arrSymStatic [ 0 ] ) ;
    }
  }  //  listsym
  
  InitArrayModeSymbol ( ) ;
    
  // FirstTaskInit
  StackClusterPrivate  * const stclp  = NewStClOrphan ( LISP2DdefaultHistorySize  ) ;
  // have no father
  GlobalListAtomicPushNotLock ( & Lisp2DGlobalListOfStackClusters2 ,
    StackClusterPrivate_globallistmember  ( stclp ) ) ;
  allowgc = false;
  flagStopToGC  = false;
  { PLOCons * const cons6 = NewCons ( & plonil.plo,&plonil.plo);
    envtop2 = &NewCons( &NewEnvironmentLayer ( ) ->  plo , & plonil . plo ) ->  plo ;
    StackClusterPrivate_SetEnv3(stclp ,  envtop2, & cons6->plo);
// ! ? envtop2 : Eval2 - modifies variable at exit    
  }
  // create std
  NameSpaceDef  * nsstd = NameSpaceAssoc ( & plosstd ) ;
  if  ( not nsstd ) {
    NameSpaceDefine ( & plosstd ) ;
    nsstd = NameSpaceAssoc ( & plosstd ) ;
  }
  
  static  wchar_t const myname  [ ] = L"Constr:isBADSetVar:";  
  { // in lisp2d.cpp sets const value
    PLOSymbol * const arrsym  [ ] = { & ploarg  , & plomain , & plosmain  , & plospi  , & plose } ;
    enum  { arrsymsize = sizeof ( arrsym ) / sizeof ( arrsym [ 0 ] ) } ;
    PLOSymbol * const * j = & arrsym [ arrsymsize ] ;
    do {
      -- j ;
      if(isBADSetVar( nsstd, *j, & plonil.plo, stclp, false)){
        fwprintf  ( stderr  , L"isBADSetVar:'%ls''%ls'\n" , myname  ,
          StringCStr  ( WideChar  ) ( PLOSymbolCValue ( * j ) ) ) ;
        return  stclp ;
      }
    } while(j > & arrsym [ 0 ] ) ; 
  } // arrsym
  
  { typedef struct  sSymPLO tSymPLO ;
    struct  sSymPLO {
      PLOSymbol * const sym ;
      ParaLispObject  * const plo ;
    } ;
    tSymPLO const arrsym  [ ] = {
      { & plostandardoutput , & Lisp2Dfout  . plo  } ,
      { & ploerroroutput  , & Lisp2Dferr  . plo  } ,
      { & plostandardinput  , & Lisp2Dfin . plo } ,
    } ;
    enum { arrsymsize = sizeof  ( arrsym  ) / sizeof  ( arrsym  [ 0 ] ) } ;
    tSymPLO const * j = & arrsym [ arrsymsize ] ;
    do {
      --  j ;
      if  ( isBADSetVar ( nsstd , j ->  sym , j ->  plo , stclp , true  ) ) {
        fwprintf  ( stderr  , L"isBADSetVar:'%ls''%ls'\n" , myname  ,
          StringCStr  ( WideChar  ) ( PLOSymbolCValue  ( j -> sym ) ) ) ;
        return  stclp ; 
      }
    } while ( j > & arrsym[0]);    
  }
    
  { typedef struct  strWStrUInt tWStrUInt ;
    struct  strWStrUInt {
      wchar_t const * const ws ;
      unsigned  int const ui ;
    } ;
    tWStrUInt arr_str_uint [ ] = {
#ifndef  LISP2D_DONTUSEX11
    // key code
      {L"xk-home",XK_Home},{L"xk-enter",XK_Return},{L"xk-end",XK_End},
      {L"xk-page-up",XK_Page_Up},{L"xk-page-down",XK_Page_Down},
      {L"xk-insert",XK_Insert},
      {L"xk-delete",127/*XK_Delete*/},{L"xk-left",XK_Left},
      {L"xk-right",XK_Right},
      {L"xk-up",XK_Up},{L"xk-down",XK_Down},{L"xk-caps-lock",XK_Caps_Lock},
      {L"xk-shift-l",XK_Shift_L},{L"xk-shift-r",XK_Shift_R},
      {L"xk-control-l",XK_Control_L},{L"xk-control-r",XK_Control_R},
      {L"xk-alt-l",XK_Alt_L},{L"xk-alt-r",XK_Alt_R},{L"xk-f1",XK_F1},
      {L"xk-f2",XK_F2},
      {L"xk-f3",XK_F3},{L"xk-f4",XK_F4},{L"xk-f5",XK_F5},{L"xk-f6",XK_F6},
      {L"xk-f7",XK_F7},{L"xk-f8",XK_F8},{L"xk-f9",XK_F9},{L"xk-f10",XK_F10},
      {L"xk-f11",XK_F11},{L"xk-f12",XK_F12},
      {L"xk-backspace",8/*XK_BackSpace*/},
      {L"xk-undo",XK_Undo},{L"xk-num-lock",XK_Num_Lock},
      {L"xk-kp-multiply",XK_KP_Multiply},{L"xk-space",XK_space},
      {L"xk-numbersign",XK_numbersign},{L"xk-question",XK_question},
#endif    
      {L"socket-max-connections",SocketMaxConnections}
    };
    enum { arr_str_uintsize = sizeof(arr_str_uint)/sizeof(arr_str_uint[0]) } ;
    tWStrUInt const * j = & arr_str_uint [ arr_str_uintsize ] ;
    do {
      --  j ;
      PLOSymbol * const symbolnamep = AddForConstr(j->ws);
      PLOComplex  * const  r=NewComplexBareExc(  );
        Complex_SetUInt ( PLOComplexToComplex( r),j->ui);
        if  ( isBADSetVar ( nsstd , symbolnamep  ,
            ParaLispObject_SetFlagConstTrue  ( & r->plo ) ,
            stclp, true  ) ) {
          fwprintf  ( stderr  , L"isBADSetVar:'%ls''%ls'\n" , myname  ,
            StringCStr  ( WideChar  ) ( PLOSymbolCValue  (  symbolnamep  )  ) ) ;
          return  stclp;
        }
    } while(j > & arr_str_uint[0]);    
  }
  // global vars
  StackClusterPrivate * const front  =
    GlobalListMemberToStackClusterPrivate (
      GlobalListAtomicFirst ( & Lisp2DGlobalListOfStackClusters2 ) ) ;
  if  ( front )
    GlobalDefClass  ( front , nsstd ) ;
  else
    fputws(L"Constr: GlobalListOfStackClusters.Front()=nullptr\n",stderr);
  return  stclp ; 
}

# include "vector/public.h"
  
// returns NIL or (symbol . prop)
ParaLispObject  * GetPropPair(ParaLispObject  const * const proplistp,
  ParaLispObject const * const sp,ParaLispObject  * const pp, 
  StackClusterPrivate  * const stclp ) {
  
// !? Pause
  
  ParaLispObject  const *   i= proplistp;
  while(CConsp( i)) {
    ParaLispObject  * const prop2 =
      ClassCons_First(&ParaLispObjectToPLOConsConst(i)->cc);
    if(not Vectorp(prop2)) {
      i = ClassCons_Rest  ( &ParaLispObjectToPLOConsConst  ( i )->cc ) ;
      continue; 
    }
    ParaLispObject  *   sl=  PLOVector_Assoc3 ( ParaLispObjectToPLOVector (
      prop2 ) ,sp);
    if(not  CConsp( sl)){
      i = ClassCons_Rest  ( &ParaLispObjectToPLOConsConst  ( i )->cc ) ;
      continue;
    }
    sl  = ClassCons_Rest  (& ParaLispObjectToPLOCons ( sl  )->cc ) ;
    if(not Vectorp( sl)){
      if(stclp)   {  
        ParaLispObject  * list [ ] = { & PLOString_NewCopy(L"GetPropPair: ")
          ->plo,sl,
          & PLOString_NewCopy(L" is not a vector")->plo, NULL } ;
        StackClusterPrivate_ExceptionSet(stclp,ListOfPLO(
          ( PArrayPLOP ) { ( ParaLispObject*(*)[])&list}));   
      } else
        inErrorS(PLOStreamPushWideCharArray  ( &Lisp2Dferr ,
          ( PArray_wchar_c ) { (wchar_t const(*)[])& L"GetPropPair: "});
      PLOStreamPushPLO(& Lisp2Dferr , sl); PLOStreamPushWideCharArray  (
        &Lisp2Dferr ,
          ( PArray_wchar_c ) { (wchar_t const(*)[])&  L" is not a vector"});)
      return & plonil.plo;
    }
    sl  =   PLOVector_Assoc3(ParaLispObjectToPLOVector(sl),pp);
    if(CConsp(  sl))  
      return   sl;
    i = ClassCons_Rest  ( &ParaLispObjectToPLOConsConst  ( i )->cc ) ; 
  }
  return & plonil.plo;
}

// returns NIL or #(..(symbol . prop)..)
ParaLispObject  * GetPropVector(ParaLispObject  * const proplistp,
  ParaLispObject * const  sp){
  ParaLispObject  * const prop2=CCAR(proplistp);
  if(not Vectorp(prop2))   
    return & plonil.plo;
  return  CCDR(PLOVector_Assoc3(ParaLispObjectToPLOVector(prop2),sp));
}
  
// !? remove argument stcl
void  SetProp2  ( ParaLispObject * const  proplistp,ParaLispObject  * const  sp,
  ParaLispObject * const pp,ParaLispObject  * const vp , StackClusterPrivate  * const stclp ) {
  ParaLispObject  *   prop=CCAR(proplistp);
  if(not  Vectorp( prop)){
    if(IsNotCons(stclp ,proplistp)) 
      return;
    PLOVector * const tmpv = aligned_alloc ( _Alignof ( PLOVector ) , sizeof ( PLOVector ) ) ;
    if ( not tmpv ) {
      OutOfMemory ( stclp ) ;
      return  ;
    }
    PLOVector_Init(tmpv);
    prop  = &tmpv->plo  ;
    ClassCons_SetFirst(&ParaLispObjectToPLOCons(proplistp)->cc, PLOVector_staticPushAsNew(prop));
  }
  ParaLispObject  * const  sl=  PLOVector_Assoc3( ParaLispObjectToPLOVector(prop),sp);
  if(not  CConsp( sl)){
    PLOVector * const vals = aligned_alloc ( _Alignof ( PLOVector ) , sizeof ( PLOVector ) ) ;
    if ( not vals ) {
      OutOfMemory ( stclp ) ;
      return  ;
    }
    PLOVector_Init(vals);
    PLOVector_staticPushAsNew(&vals->plo);
    // ..... rewrite it .... simplify
    PLOVector_PushLink(vals,pp,vp,stclp);
    PLOVector_PushLink(ParaLispObjectToPLOVector(prop),sp, & vals->plo, stclp);
    return;
  }
  // sl is Cons
  if  ( not  Vectorp (  ClassCons_Rest  ( &ParaLispObjectToPLOCons ( sl  )->cc ) ) ) {
    PLOVector * const newrest = aligned_alloc ( _Alignof ( PLOVector ) , sizeof ( PLOVector ) ) ;
    if  ( not newrest ) {
      OutOfMemory ( stclp ) ;
      return ;
    }
    PLOVector_Init(newrest);
    ClassCons_SetRest(&ParaLispObjectToPLOCons(sl)->cc, PLOVector_staticPushAsNew( &newrest->plo));
  }
  PLOVector_PushLink(ParaLispObjectToPLOVector(ClassCons_Rest  ( &ParaLispObjectToPLOCons ( sl  )->cc )),pp,vp,stclp );
}

# include "complex/inline.h"

# ifndef  LISP2D_DONTUSEX11
  
bool  isBADColorsCharsFromObjectOrList(ParaLispObject  * const listornumberp,
  tUCharRGB * const ulcolsp , StackClusterPrivate * const stclp ) {
  if(CConsp(listornumberp)){
    ParaLispObject  * const rp=CCAR(listornumberp);
    if(IsNotNumber(  stclp,rp))     
      return  true;
    ParaLispObject  * const col4p=CCDR(listornumberp);
    ParaLispObject  * const gp=CCAR(col4p);
    if(IsNotNumber(stclp,gp))   
      return  true;
    ParaLispObject  * const bp=CCAR(CCDR(col4p));
    if(IsNotNumber(stclp,bp))  
      return  true;
    ulcolsp -> r = uint_cast_uchar ( FractionForColor  (
      Complex_CRe  (PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        rp ))) ) ) ;
    ulcolsp->g = uint_cast_uchar ( FractionForColor  (
      Complex_CRe  (PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        gp )) ) ) ) ;
    ulcolsp->b  = uint_cast_uchar ( FractionForColor  (
      Complex_CRe  (PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        bp ))) ) ) ;
    return  false;
  }
  if(Numberp(listornumberp)){
      { unsigned  char  const  uctmp=uint_cast_uchar(FractionForColor(
          Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
            listornumberp)))));
        ulcolsp->r = uctmp ; 
        ulcolsp->g = uctmp ;
        ulcolsp->b = uctmp ; 
      }
      return  false;
  }
  {   ParaLispObject  * list [ ] = {   listornumberp,&  PLOString_NewCopy(
        L" is not number nor cons")->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stclp,ListOfPLO((PArrayPLOP){
        (ParaLispObject*(*)[])&list}));
  
      return  true;
  }  
}
      
# endif //  LISP2D_DONTUSEX11

bool  isBADReadWCharUniversal ( char  const FirstByte  ,
  functionboolcharp * const isBADNextByte2  , wchar_t * const wcharResultp ) {
  char  firstchar = FirstByte ;
  if  ( char_cast_schar( firstchar) >= 0 ) {
    ( * wcharResultp  ) = firstchar  ;
    return   false  ; 
  }
  unsigned  int charsize  ;
  if  ( ( uchar_cast_uint ( char_cast_uchar (
          firstchar  ) )  bitand  0xe0U ) ==  0xc0U )  
    charsize  = 2U ;
  else
    if  ( ( uchar_cast_uint ( char_cast_uchar (
            firstchar  ) ) bitand  0xf0U ) ==  0xe0U )   
      charsize  = 3U ;
    else
      if  ( ( uchar_cast_uint ( char_cast_uchar (
              firstchar  ) ) bitand  0xf8U ) ==  0xf0U )      
        charsize  = 4U ;
      else
        if  ( ( uchar_cast_uint ( char_cast_uchar (
                firstchar  ) ) bitand  0xfcU ) ==  0xf8U )    
          charsize  = 5U ;
        else
          if  ( ( uchar_cast_uint ( char_cast_uchar (
                  firstchar ) ) bitand  0xfeU ) ==  0xfcU ) 
            charsize  = 6U ;
          else     
            return   true   ;
  unsigned  int   target = ( uchar_cast_uint ( char_cast_uchar ( firstchar ) )
    bitand ( 0xffU >>  ( charsize  + 1 ) ) ) << ( 6 * ( charsize  - 1 ) ) ;
  unsigned  int j = 1 ;
  do  {
    if  ( functionboolcharp_Fun ( isBADNextByte2 , & firstchar ) ) 
      return   true   ;
    if  ( ( uchar_cast_uint ( char_cast_uchar (
            firstchar  ) ) >>  6 ) not_eq  2 ) 
      return   true   ;
    target  or_eq ( ( uchar_cast_uint ( 
            char_cast_uchar ( firstchar  ) ) bitand  0x3fU ) <<
      ( 6 * ( ( charsize  - 1 ) - j ) ) ) ;
    ++  j ;
  } while ( j < charsize  ) ;
  ( * wcharResultp  ) = uint_cast_wchar ( target  ) ;
  return   false  ; 
}

functionboolcharp_Funp  functionboolcharp_arr_Funp  [ ] = {
  & functionisBADReadStringToOneWChar_Fun ,
  & functionisBADReadCharToWChar_Fun
} ;

# ifdef LISP2D_DEBUG
  size_t  Lisp2D_statMallocPLOComplexPri  = 0 ;
  size_t  Lisp2D_statFreePLOComplexPri  = 0 ;
  size_t  Lisp2D_statMallocPLOCons  = 0 ;
  size_t  Lisp2D_statFreePLOCons  = 0 ;
# endif

# include "castb.h"
# include "widestring/inline.h"

LISP2DSTACKAT ( StackMapNodetreeSymbolsLessType , MapNode ( treeSymbolsLessType ) )
LISP2DSTACKAT ( StackMapNodesetTypeSymbolNameType , MapNode ( setTypeSymbolNameType ) )
LISP2DSTACKAT ( StackMapNodeerrnotosymbol , MapNode ( errnotosymbol ) )

bool  functionboolcharp_Fun ( functionboolcharp  * const p , char  * const cp ) {
  return  functionboolcharp_arr_Funp  [ p -> type ] ( p , cp ) ;
}

LISP2DSTACKPUSHFRONTVALUE ( StackMapNodetreeSymbolsLessType , MapNode ( treeSymbolsLessType ) , )
LISP2DSTACKPUSHFRONTVALUE ( StackMapNodesetTypeSymbolNameType , MapNode ( setTypeSymbolNameType ) , )
LISP2DSTACKPUSHFRONTVALUE ( StackMapNodeerrnotosymbol , MapNode ( errnotosymbol ) , )

void  functionboolcharp_Init  ( functionboolcharp * const me , int const t ) {
  me -> type = t ;
}

functionisBADReadCharToWChar * fromFunctionboolcharpToFunctionisBADReadCharToWChar ( functionboolcharp * const p ) {
  return  ( functionisBADReadCharToWChar * ) ( ( ( uint8_t * ) p ) - offsetof  ( functionisBADReadCharToWChar , base  ) ) ;
}

LISP2DMAPPUBSIZEBODY  ( setTypeSymbolNameType )
LISP2DMAPPUBCATBODY ( setTypeSymbolNameType )
LISP2DMAPPUBDESTRBODY  ( setTypeSymbolNameType )
LISP2DMAPSTACKDESTRBODY ( setTypeSymbolNameType )
LISP2D_MAP_STACK_FREE_BODY ( setTypeSymbolNameType )

LISP2DMAPPUBSIZEBODY  ( treeSymbolsLessType )
LISP2DMAPPUBCATBODY ( treeSymbolsLessType )
LISP2DMAPPUBCLEARBODY ( treeSymbolsLessType )
LISP2DSTACKCLEAR  ( StackMapNodetreeSymbolsLessType , MapNode ( treeSymbolsLessType ) )
LISP2DMAPPUBDESTRBODY  ( treeSymbolsLessType )
LISP2DMAPSTACKDESTRBODY ( treeSymbolsLessType )
LISP2D_MAP_STACK_FREE_BODY ( treeSymbolsLessType )

LISP2DMAPPUBSIZEBODY  ( errnotosymbol )
LISP2DMAPPUBCATBODY ( errnotosymbol )
LISP2DMAPSTACKDESTRBODY ( errnotosymbol )
LISP2D_MAP_STACK_FREE_BODY ( errnotosymbol )
LISP2DMAPPUBDESTRBODY  ( errnotosymbol )
# include "listplo/inlinepri.h"
# include "socket/inline.h"
# include "stcl/inline.h"
# include "shared/inline.h"
