// signed Long
// (C)2019-23

# include "define.h"
# include <stddef.h>  //  size_t
# include "slong/public.h"

# ifdef  LISP2D_CONSTRSTAT
# include <stdatomic.h>
_Atomic ( size_t  ) Lisp2DSLongconstrstat = ATOMIC_VAR_INIT( 0UL ) ;

size_t  Lisp2DSLongconstrstatGetValue  ( void ) {
  return Lisp2DSLongconstrstat ; 
}

void  Lisp2DSLongconstrstatAddOne ( void ) {
  ++  Lisp2DSLongconstrstat  ; 
}

# endif

# include "slong/public.h"
# include "slong/struct.h"
# include "slong/private.h"
# include "ulong/inline.h"
# include "ulong/private.h"
# include "stack/public.h"

void Lisp2DSLongAddSLong ( Lisp2DSLongPub * const my , Lisp2DSLongPub  const * const x ) {
  Lisp2DSLong * const myp = SLong_toPrivate ( my )  ;
  Lisp2DSLong const * const xp = SLong_toCPrivate ( x )  ;
  ULongPub * const mya = ULongToPub ( & myp -> absval ) ;
  ULongPub const * const xa = ULongCToPub ( & xp -> absval ) ;
  if(myp->flagNegative) {
    if(xp->flagNegative)
      ULongAddConst ( mya , xa ) ;
    else {

      if  ( not ULongMore ( mya , xa )  ) {
        // -1 += 10
        myp->flagNegative  = false;
        goto ArgBig ;
      }
      // -10 += 1
      ULongDifferenceEq ( mya , xa ) ;

    }
  } else {
    if(not  (xp->flagNegative))
      ULongAddConst ( mya , xa ) ;
    else {
      if(ULongMoreOrEq(mya,  xa))
        // 10 += -1
        ULongDifferenceEq ( mya , xa ) ;
      else {
        // 1 += -10
        myp->flagNegative  = true;
ArgBig :  ;
        ThreadStackPointerType const oldstack_tmp2 = Lisp2DThreadSP ( ) ;
        ULongPub * const tmp2 = StackNew_ULong ( ) ;
        ULong_ConstrCopy ( tmp2 , xa ) ;
        ULongDifferenceEq ( tmp2 , mya ) ;
        ULongMove ( ULongToPub(& myp ->  absval ) , tmp2 ) ;
        Lisp2D_StackFree  ( oldstack_tmp2 ) ;
      }
    }
  }
}

void  Lisp2DSLongConstrUInt ( Lisp2DSLongPub * const my , unsigned int const v ) {
  Lisp2DSLong * const myp = SLong_toPrivate ( my )  ;
  myp ->  flagNegative  = false ;
  ULongPub  * const a = ULongToPub ( &  myp ->  absval  ) ;
  ULong_Init  ( a ) ;
  ULongSetUInt  ( a , v ) ;
# ifdef  LISP2D_CONSTRSTAT
  ++  Lisp2DSLongconstrstat  ;
# endif  
}

void  Lisp2DSLongDec1 ( Lisp2DSLongPub * const my  ) {
  Lisp2DSLong * const myp = SLong_toPrivate ( my ) ;
  ULongPub  * const a = ULongToPub ( &  myp ->  absval  ) ;
  if  ( myp ->  flagNegative  )   
    ULongAdd1 ( a ) ;
  else {
    if  ( ULongIs0  ( a ) ) {
      ULongSet1 ( a ) ;
      myp ->  flagNegative  = true  ;
    } else
      ULongSub1 ( a ) ;
  }
}

# define  bool_xor_eq Lisp2D_bool_xor_eqkxip
void  bool_xor_eq ( bool  * a , bool  b ) ;

# include "slong/inline.h"

void Lisp2DSLongMulSLong ( Lisp2DSLongPub * const  my ,
  Lisp2DSLongPub  const *  const x ) {
  Lisp2DSLong * const myp = SLong_toPrivate ( my )  ;
  ULongMultiplyConst ( ULongToPub ( & myp ->  absval ) ,  ULongCToPub ( Lisp2DSLongCabs ( x ) ) ) ;
  bool_xor_eq ( & myp ->  flagNegative  , SLong_toCPrivate ( x ) ->  flagNegative  ) ;
}

void  Lisp2DSLongInit ( Lisp2DSLongPub * const my ) {
  ULong_Init  ( ULongToPub ( & SLong_toPrivate ( my ) ->  absval ) ) ;
# ifdef  LISP2D_CONSTRSTAT
  ++  Lisp2DSLongconstrstat  ;
# endif  
}

void  Lisp2DSLongConstrCopy ( Lisp2DSLongPub * const  my , Lisp2DSLongPub  const * const x ) {
  Lisp2DSLong * const myp = SLong_toPrivate ( my )  ;
  Lisp2DSLong const * const xp = SLong_toCPrivate ( x ) ;
# ifdef  LISP2D_DEBUG
  if  ( myp == xp ) {
    Lisp2DExceptionStringGlobal . str = (wchar_t const(*)[])&
      L"SLongConstrCopy:myp == xp" ;
    longjmp ( * Lisp2DJBglobal  , Lisp2DExcTypeString ) ;
  }
# endif
  ULong_ConstrCopy ( ULongToPub ( & myp ->  absval ) , ULongCToPub ( & xp  ->  absval ) ) ;
  myp ->  flagNegative = xp -> flagNegative ;
# ifdef  LISP2D_CONSTRSTAT
  ++  Lisp2DSLongconstrstat  ;
# endif
}

void  SLongConstrSignULong (  t_SLongConstrSignULong  const arg ) {
  SLong * const myp = SLong_toPrivate ( arg . my )  ;
  myp -> flagNegative  = arg . fn ;
  ULong_ConstrCopy ( ULongToPub ( & myp ->  absval ) , ULongCToPub ( arg . xp ) ) ;
# ifdef  LISP2D_CONSTRSTAT
  ++  Lisp2DSLongconstrstat  ;
# endif
}
  
void Lisp2DSLongDivULong  ( Lisp2DSLongPub * const my , ULong  const * const x ) {
  ULongDivConst ( ULongToPub ( & SLong_toPrivate ( my )  ->  absval ) , ULongCToPub ( x ) ) ;
}  // ! x<>0 !    

Lisp2DSLongPub * StackNew_SLong (  void  ) {
  Lisp2DSLong * const slp = Lisp2D_StackVar ( Lisp2DStackTypeSLong ) ;
  return  & slp ->  pub ;
}

void  SLongDestr  ( Lisp2DSLong * const myp ) {
  ULongDestr  ( & myp ->  absval  ) ;
}

// ! ULong -> public
void  SLongSetULong ( Lisp2DSLongPub * const my ,  ULong const * const xp ) {
  Lisp2DSLong * const myp = SLong_toPrivate ( my )  ;
  ULongSet ( ULongToPub (& myp ->  absval ) , ULongCToPub(xp ) ) ;
  myp ->  flagNegative  = false ;
}

void  bool_xor_eq ( bool  * const a , bool const b ) {
  if  ( b )
    ( * a ) = not ( * a ) ;
}
