// Lisp2D - Stream
// ©2006-23 by Alex Glebe
# include <unistd.h>
# include <stdio.h>
# include "streamc.h"
# include "excc.h"
_Atomic(size_t)   StreamConstrstat = 0 ;
# include "define.h"
# ifdef  LISP2D_CONSTRSTAT
void  StreamAddConstrstat ( void  ) {
  ++  StreamConstrstat  ; }
size_t  StreamConstrstatValue ( void  ) {
  return  StreamConstrstat  ; }
# endif

# define  ReadableFD  Lisp2DReadableFD4ndp
bool ReadableFD ( PrivateStream const * ) ;  

bool  ReadableFD ( PrivateStream const * const psp ) {  
  int const f  = ( (psp->intflagsFD)  bitand O_ACCMODE  ) ;
  return  ( f == O_RDONLY )  or ( f == O_RDWR ) ; }

bool  StreamReadable  ( Stream const * const s ) {
  if  ( s -> pro . stretype == StreamTypeName(FD))
    return ReadableFD  ( & s -> pro ) ;
  return  false ;
}

# define  StreamisBADReadSCharFD  Lisp2DStreamisBADReadSCharFDniKb
bool  StreamisBADReadSCharFD  ( PrivateStream * sp  , signed char * scp ) ;  
bool  StreamisBADReadSCharFD  ( PrivateStream * const sp  ,
  signed char * const scp ) {
  char  cbuf  ;
  ssize_t  count = read  ( sp->intFD , &  cbuf , 1 ) ;
  if  ( count <  1  ) {
    sp->flagFDEOF = true  ;
    return   true   ;
  }
  ( * scp ) = cbuf ;
  return   false  ;
}

typedef   bool  ( FuncIsBADReadSChar  )  ( PrivateStream * s  ,
  signed char * sc ) ;  
  
// ! to make gibrid Functional with Lisp2D::isBADReadStringToOneWChar  
# define  isBadReadWChar  Lisp2DisBadReadWCharirpp
bool  isBadReadWChar  ( PrivateStream  * , FuncIsBADReadSChar * f ,
  wchar_t * result ) ;    
    
bool  isBadReadWChar  ( PrivateStream  * const mep  ,
  FuncIsBADReadSChar * const fp , wchar_t * const resultp ) {
  signed  char  sc  ;
  if ( ( * fp ) ( mep  , & sc  ) ) return   true   ;
  if  ( sc  > 0 ) ( * resultp ) = sc  ;
  else  {
    unsigned  int charsize  ;
    goto  CalcSize  ;
ReturnCalcSize  :    
    { unsigned  int target  = ( (
          ( ( unsigned  int ) ( ( unsigned  char ) ( sc  ) ) ) bitand
          ( 0xffU >>  ( charsize  + 1 ) ) ) <<
        ( 6 * ( charsize  - 1 ) ) ) ;
      { unsigned  int j = 1 ;
        do  {
          if ( ( * fp ) ( mep , & sc  ) ) return   true   ;
          if  ( ( ( ( unsigned  int ) ( ( unsigned  char ) ( sc  ) ) )
              >>  6 ) not_eq  2 ) 
            return   true   ;
          target  or_eq ( ( ( ( unsigned  int ) ( (
                    unsigned  char ) ( sc  ) ) ) bitand  0x3fU ) <<
            ( 6 * ( ( charsize  - 1 ) - j ) ) ) ;
          ++  j ;
        } while ( j < charsize  ) ; } // j
      ( * resultp )  = ( ( wchar_t ) ( target  ) ) ; } // target
    return  false ;
CalcSize  :
    if  ( ( ( ( unsigned  int ) ( ( unsigned  char  ) ( sc  ) ) )
        bitand  0xe0U ) ==  0xc0U )
      charsize  = 2 ;
    else
      if  ( ( ( ( unsigned  int ) ( ( unsigned  char ) ( sc  ) ) )
          bitand  0xf0U ) ==  0xe0U )     
        charsize  = 3 ;
      else
        if  ( ( ( ( unsigned  int ) ( ( unsigned  char ) ( sc  ) ) )
            bitand  0xf8U ) ==  0xf0U )         
          charsize  = 4 ;
        else
          if  ( ( ( ( unsigned  int ) ( ( unsigned  char ) ( sc  )
                ) ) bitand  0xfcU ) ==  0xf8U )           
            charsize  = 5 ;
          else
            if  ( ( ( ( unsigned  int ) ( ( unsigned  char ) (
                    sc  ) ) ) bitand  0xfeU ) ==  0xfcU )             
              charsize  = 6 ;
            else              return   true   ;
    goto  ReturnCalcSize ; } // if  not ( sc  > 0 )
  return   false  ; }  
  
bool  StreamisBADReadWChar  ( Stream * const s , wchar_t * const resultp  ) {
  switch  (  s -> pro .stretype   ) {
  case  (StreamTypeName(FD)) :
    if  ( not  StreamReadable ( s ) )      return   true   ;
    return  isBadReadWChar  ( & s -> pro , & StreamisBADReadSCharFD  ,
      resultp ) ;    
  case  (StreamTypeName(No) ) :
    return   true   ;
  default :
# ifdef  LISP2D_DEBUG
    Lisp2DExceptionStringGlobal . str = (wchar_t const(*)[])&
      L"StreamisBADReadWChar: unknown type of stream" ; 
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
# endif    
    return   true   ;
  }
}
    
bool  StreamWriteable ( Stream const * const s ) {
  if  ( s -> pro . stretype    ==  StreamTypeName(FD)  )
    return  StreamWritableFD ( s )  ;
  return  false ;
}
            
int StreamisBADClear  ( Stream * const s ) {
  int res = 0  ;
  if(not  s -> pro .innerstream){
    switch(s -> pro .stretype){
    case  (StreamTypeName(No)):   
      goto Exit  ;
    case   ( StreamTypeName(FD)  ) :
      res = close ( s -> pro .intFD ) ;
      goto  Clean ;
    default:
# ifdef  LISP2D_DEBUG
      fwprintf(stderr,
        L"StreamClearStre: stretype = %d is unknown\n", s -> pro .stretype);
      Lisp2DExceptionStringGlobal . str = (wchar_t const(*)[])&
        L"StreamisBADClear: unknown type of stream" ;
      longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
# endif
      return 1 ;
    }
  }
Clean :
  s -> pro .intFD = -1  ;
  s -> pro .intflagsFD  = 0 ;
  s -> pro .modeFD  = 0 ;
  s -> pro .flagFDEOF = false ;
  s -> pro .stretype  = (StreamTypeName(No));
Exit :    
  return  res ;
}  
  
bool  StreamGood  ( Stream const * const s ) {
  switch  ( s -> pro .stretype  ) {
  case  ( StreamTypeName(No)  ) :
    return  false  ;
  case  ( StreamTypeName(FD)  ) :
    return  not s -> pro .flagFDEOF  ;
  default :
# ifdef  LISP2D_DEBUG
    fwprintf(stderr,
      L"StreamGood: stretype = %d is unknown\n", s -> pro .stretype);
# endif      
    return  false ;
  }
}
  
bool  StreamEof(Stream const * const s ) {
  switch( s -> pro .stretype){
  case  (StreamTypeName(No)):
    return  true;
  case  (StreamTypeName(FD)):
    return   s -> pro .flagFDEOF  ;
  default:
# ifdef  LISP2D_DEBUG
    fwprintf(stderr,
      L"StreamEof: stretype = %d is unknown\n", s -> pro .stretype);
# endif      
    return  true;
  }
}

# include "passage/public.h"
# include "stack/public.h"

bool  StreamisBADOpenWOutLockGC ( Stream * const s , String  ( WideChar  ) const * const namep ,
  struct  Lisp2D_s_StackClusterPrivate * const stclpp ) {
  ThreadStackPointerType const oldstack_a = Lisp2DThreadSP ( ) ;
  String  ( Char  ) * const strtmp = StackNew_StringChar ( ) ;
  String_Init ( Char  ) ( strtmp  , true ) ; // no memory
  if  ( isBADReadWStringToCString ( namep , strtmp  ) )
    goto BadString;
  { int const fd  = creat ( Lisp2DStringCharCStr  ( strtmp  ) , 0 ) ;
    enum  { CREAT_BAD = -1 } ;
    if (  fd not_eq CREAT_BAD ) {
      s -> pro .intFD = fd  ;
      s -> pro .stretype  = StreamTypeName(FD);
      s -> pro .intflagsFD = O_CREAT bitor O_WRONLY bitor O_TRUNC ;
      s -> pro .modeFD = 0 ;
      s -> pro .innerstream = false;  
      Lisp2D_StackFree  ( oldstack_a ) ;
      return  false ;
    }
  }
Bad:    
  Lisp2D_StackFree  ( oldstack_a ) ;
  return  true;
BadString :
  PassagePassIn ( passageGCCPub ) ;
  BadStringN(stclpp);
  PassagePassOut ( passageGCCPub ) ; 
  goto Bad;
}
    
# include "errorstra.h"

static  Stream  const * StreamPushWCharArrayp ( Stream  const * const mep , wchar_t const volatile * const wstrp ) {
  if(StreamStreType(mep)  ==  StreamTypeName(No)){
    ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
      L"PushWCharArray(Stream const *,wchar const *):stream is not open"});
    return  mep ;
  }
  if  ( not  StreamWriteable  ( mep ) ) {
    ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
      L"PushWCharArray(Stream const *,wchar const *):stream is not writeable"});
    return  mep ;
  }
# ifdef  LISP2D_DEBUG
  if  ( not wstrp ) {
    ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
      L"PushWCharArray(Stream const *,wchar const *):wstr=nullptr"});
    return  mep ;
  }
# endif
  switch(StreamStreType(mep)){
  case  StreamTypeName(No):
  case  StreamTypeName(FD):
  default:
    { ThreadStackPointerType const oldstack_wstr = Lisp2DThreadSP ( ) ;
      String  ( WideChar  ) * const wstrtmp = StackNew_StringWideChar ( ) ;
      StringConstrCStr  ( WideChar  ) ( wstrtmp , wstrp , true ) ;
      String  ( Char  ) * const strtmp = StackNew_StringChar ( ) ;
      String_Init ( Char  ) ( strtmp , true ) ; // '\0'
      if  ( isBADReadWStringToCString ( wstrtmp , strtmp  ) ) {
        ErrorStra ( ( PArray_wchar_c ) { ( wchar_t const ( * ) [ ] ) &
          L"Stream.PushWCharArray(wchar const*): string is bad" } ) ;
        goto Free ;
      }
      switch  ( StreamStreType  ( mep ) ) {
      case   ( StreamTypeName ( FD  ) ) :
        { PLOSymbol const * const symbolerror = isBADPushCStringToStreamFD  (
            StreamPointerToConstFD  ( mep ) ,  strtmp ) ;
          if  ( symbolerror ) {
            static  wchar_t const wsp [ ] =
              L"Stream(File).PushWCharArray(wchar const*):" ;
            ThreadStackPointerType const oldstack_ws2 = Lisp2DThreadSP ( ) ;
            String  ( WideChar  ) * const ws2 = StackNew_StringWideChar ( ) ;
            String_ConstrCStrFullLength ( WideChar  ) ( ws2 , wsp ,
              sizeof(wsp)/sizeof(wchar_t),true);
            StringAddCharArray  ( WideChar  ) ( ws2 , StringCStr  ( WideChar  ) ( PLOSymbolCValue  ( symbolerror ) )  ) ;
            ErrorStra(Lisp2DStringWideCharCArr(ws2));
            Lisp2D_StackFree  ( oldstack_ws2 ) ;
          }
        } //  PLOSymbol * symbolerror
        goto Free;
      case  StreamTypeName(No):
      default :  ;
# ifdef  LISP2D_DEBUG
        ErrorStra ( ( PArray_wchar_c ) { ( wchar_t const ( * ) [ ] ) &
          L"Stream.PushWCharArray(wchar const*): type is unknown" } ) ;
# endif
      }
Free :
      Lisp2D_StackFree  ( oldstack_wstr ) ;
    }
  }
  return  mep ;
}

Stream const *  StreamPushWCharArray  ( Stream  const * const mep , PArray_wchar_c const wstr ) {
  return  StreamPushWCharArrayp ( mep , & ( * wstr  . p ) [ 0 ] ) ;
}

Stream const *  StreamPushWCharArrayv  ( Stream  const * const mep , PArray_wchar_cv const wstr ) {
  return  StreamPushWCharArrayp ( mep , & ( * wstr  . p ) [ 0 ] ) ;
}

# include <errno.h>
# include "sharedc.h"
# include "shared/inline.h"

// string in UTF-8 encoding
PLOSymbol * isBADPushCStringToStreamFD  ( int  const * const pfd , String  ( Char  ) const * const pcstr  ) {
  size_t   stsize  = String_Size  ( Char  ) ( pcstr ) ;
  char  const * stcstr  = StringCStr ( Char ) ( pcstr ) ;
  while ( stsize > 0  )  {
    ssize_t const  ss  = write ( * pfd , stcstr , stsize ) ;
    if  ( ss  < 0 ) {
      size_t  const jc  = MapPubFind  ( errnotosymbol ) ( seterrnotosymbol_pub , errno ) ;
      PLOSymbol * errname ;
      if  ( jc  not_eq  MapPubSize  ( errnotosymbol ) ( seterrnotosymbol_pub ) )
        errname = MapPubCAt ( errnotosymbol ) ( seterrnotosymbol_pub  , jc  ) ->  value ;
      else
        errname = & plosquestion ;
      return   errname  ;
    } // if  ( ss  < 0  )
    stcstr  +=  ss  ;
    stsize  -= ( size_t  ) (  ss  )  ;
  } // while ( stsize > 0 )
  return  0 ;
}  

void  PrivateStreamInit ( PrivateStream * const ps  ) {
  ps -> innerstream = false ;
  ps  ->  stretype  = StreamTypeName(No)  ;
  ps  ->  intFD = -1  ;
  ps  ->  intflagsFD  = 0 ;
  ps  ->  modeFD  = 0 ;
  ps  ->  flagFDEOF = false ;
# ifdef  LISP2D_CONSTRSTAT
  LISP2DSTREAMADDCONSTRSTAT
# endif
}

void  PrivateStreamInitFD ( PrivateStream * const ps , bool const inner , int const fd  , int const flags ) {
  ps -> innerstream = inner ;
  ps  ->  stretype  = StreamTypeName(FD)  ;
  ps  ->  intFD = fd  ;
  ps  ->  intflagsFD  = flags ;
  ps  ->  modeFD  = 0 ;
  ps  ->  flagFDEOF = false ;
# ifdef  LISP2D_CONSTRSTAT
  LISP2DSTREAMADDCONSTRSTAT
# endif
}

bool  StreamWritableFD ( Stream const * const s ) {
  return  PrivateStreamWritableFD ( & s -> pro ) ;
}

void StreamClose  ( Stream * const s , int * const res ) {
  ( * res ) = StreamisBADClear  ( s ) ;
}
# include "widestring/inline.h"
