// Lisp2D - symbol
// ©2006-23 by Alex Glebe
# include "nilc.h"
# include "symbolc.h"
# include "define.h"
# ifdef  LISP2D_CONSTRSTAT  
  _Atomic  ( size_t  ) PLOSymbolconstrstat  ;
# endif
  
# ifdef LISP2D_CONSTRSTAT    
size_t  PLOSymbolConstrStatValue  ( void  ) {
  return  PLOSymbolconstrstat ; 
}

void  PLOSymbolAddConstrStatFunc  ( void  ) {
  ++  PLOSymbolconstrstat ;
}
# endif

ParaLispObject  * PLOSymbolTypeOf ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return & plossymbol . plo ;
}

PLOSymbol plosaccess  , plosagain ;
PLOSymbol plosapp ;
PLOSymbol ploarg  , plosasync ;
PLOSymbol plosate , plosbackquote ;
PLOSymbol plosbadf  , plosbif ;
PLOSymbol plosblock , plosboolean ;
PLOSymbol plosbusy  ;
# ifndef LISP2D_DONTUSEX11
PLOSymbol plosbuttonpress , plosbuttonrelease ;
# endif
PLOSymbol plosbytedeque ;
PLOSymbol ploschar  , ploscharacter ;
PLOSymbol ploscloexec ;
PLOSymbol ploscomma , ploscomplex ;
# ifndef LISP2D_DONTUSEX11
PLOSymbol plosconfigurenotify ;
# endif
PLOSymbol ploscons  ;
PLOSymbol ploandconst , ploscreat ;
PLOSymbol ploscur , plosdata  ;
PLOSymbol plosdestaddrreq , plosdir ;
PLOSymbol plosdirect  , plosdirectory ;
PLOSymbol plosdquote  , plosdsync ;
PLOSymbol plose , plosend ;
PLOSymbol plosenv , plosenvironmentlayer ;
PLOSymbol ploerroroutput  , plosexcl  ;
PLOSymbol plosexist , plosfalse ;
PLOSymbol plosfault , plosfbig  ;
PLOSymbol plosfifo  , ploshole  ;
PLOSymbol plosin  , plosintr  ;
PLOSymbol plosinout , plosinval ;
PLOSymbol plosio  , plosisdir ;
# ifndef LISP2D_DONTUSEX11
PLOSymbol ploskeypress  , ploskeyrelease ;
# endif
PLOSymbol plolambdaw  , plolambdanotmod2  ;
PLOSymbol ploslargefile , ploslink  ;
PLOSymbol ploslock  , plosloop  ;
PLOSymbol plomacronotmod  ;
PLOSymbol plosmain  , plomain ;
PLOSymbol plosmfile , plosmlink ;
PLOSymbol plosnametoolong , plosndelay  ;
PLOSymbol plosnfile ;
PLOSymbol plosnil , plosnoatime ;
PLOSymbol plosnoctty  , plosnodev ;
PLOSymbol plosnoent ;
PLOSymbol plosnofollow  , plosnomem ;
PLOSymbol plosnonblock  , plosnospc ;
PLOSymbol plosnosys , plosnotdir  ;
PLOSymbol plosnotempty  , plosnotty ;
PLOSymbol plosnull  , plosnxio  ;
PLOSymbol plosopnotsupp , plosout ;
PLOSymbol plosoutofmemory , plosoverflow  ;
PLOSymbol plospath  , plosperm  ;
PLOSymbol plospi  , plospipe  ;
PLOSymbol plosquestion  , plosquote2  ;
PLOSymbol plosregular ;
PLOSymbol ploandrest  , plosrgrp  ;
PLOSymbol plosrofs  , plosroth  ;
PLOSymbol plosrusr  , plosrwxgrp  ;
PLOSymbol plosrwxoth  ;
PLOSymbol plosrwxusr  , plossgid  ;
PLOSymbol plossignal  ;
PLOSymbol plossocket  , plosspipe ;
PLOSymbol plossrch  , plostandardinput  ;
PLOSymbol plostandardoutput , plosstat  ;
PLOSymbol plosstd ;
PLOSymbol plosstream  , plosstring  ;
PLOSymbol plossuid  , plossvtx  ;
PLOSymbol plossymbol  , plossync  ;
PLOSymbol plossystemclass ;
PLOSymbol plosthis  , plosthreepoints ;
PLOSymbol plostime  , plostmpfile ;
PLOSymbol plostrue1 , plostrunc ;
PLOSymbol plostxtbsy  , plosUnquoteSplicing ;
PLOSymbol plosvector  , ploswgrp  ;
PLOSymbol ploandwhole ;
# ifndef  LISP2D_DONTUSEX11
PLOSymbol ploswindow  , ploswindowclose ;
# endif
PLOSymbol ploswoth  , ploswouldblock  ;
PLOSymbol ploswusr ,  plosxdev  ;
PLOSymbol plosxgrp  ;
PLOSymbol plosxoth  , plosxusr  ;
// ! to make all symbols Static

ParaLispObject  *   ploclassdefsymbol = & plonil . plo ;
ParaLispObject  *   ploclassparentssymbol = & plonil . plo ;

# include "globallistp/struct.h"

// PLOSymbol*
// temporary list for GC
GlobalList  GlobalListOfSymbolsGarbage  ;

ParaLispObject  * PLOSymbolClassDef  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  ploclassdefsymbol ;
}
  
ParaLispObject  * PLOSymbolClassParents  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  ploclassparentssymbol ;
}
  
bool  PLOSymbolEqualP ( PLOSymbol  const * const mep , PLOSymbol  const * const xp ) {
  return  (   mep   ==   xp ) ?
    true  :
    ( wcscmp ( ( wchar_t const * ) ( StringCStr ( WideChar  ) ( PLOSymbolCValue  (  mep  ) ) ) ,
        ( wchar_t const * ) ( StringCStr ( WideChar  ) ( PLOSymbolCValue  (  xp ) ) ) ) ==  0 ) ;
}

bool  PLOSymbolLessP  ( PLOSymbol const * const mep , PLOSymbol  const * const xp ) {
  return  (   mep   ==   xp )  ?
    false :
    ( wcscmp ( ( wchar_t const * ) ( StringCStr ( WideChar  ) ( PLOSymbolCValue  (  mep  ) ) ) ,
      ( wchar_t const * ) ( StringCStr ( WideChar  ) ( PLOSymbolCValue  (  xp ) ) ) ) < 0  ) ;
}

int PLOSymbolCompareP ( PLOSymbol * const mep , PLOSymbol * const xp ) {
  return  ( mep ==  xp  ) ?
    0 :
    wcscmp  ( ( wchar_t const * ) ( StringCStr ( WideChar  )  ( PLOSymbolCValue ( mep ) ) ) ,
      ( wchar_t const * ) ( StringCStr ( WideChar  )  ( PLOSymbolCValue ( xp  ) ) ) ) ;
}
      
bool  SymbolP ( ParaLispObject const * const xp  ) {
  return ParaLispObject_Type(xp)==TypeGlobalListMemberPLOSymbol;
}  

# include "env/public.h"
  
// returns true when EnvironmentLayer not exist OR symbol have Const link
bool  isBADSetVar ( NameSpaceDef * const  dp , PLOSymbol  * const  sp , ParaLispObject * const  vp ,
  StackClusterPrivate  * const stclp , bool  flagconst ) {
  if(not  IsNotEnvironmentLayer(  stclp ,   dp -> var )){
    return  EnvironmentLayerisBADPush (
      & ParaLispObjectToPLOEnvironmentLayer ( dp -> var ) -> envlay ,
      & sp -> plo ,  vp , flagconst ) ; 
  }
  return  true;
}    

# include "plostream/public.h"
  
void  PLOSymbolCoutToInterpret ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool _1 __attribute__ ((unused)) ,
  Vector(StackPLOP) * _ __attribute__ ((unused)) ) {
  PLOStreamPushWideCharArray  ( s ,  StringCArr  ( WideChar  ) (
      PLOSymbolCValue(ParaLispObjectToPLOSymbolConst  (  me  )) ) ) ;
}

void  PLOSymbolCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool flag2pprinted  , Vector(StackPLOP)  * const h ) {
  PLOSymbolCoutToInterpret (  me , s , flag2pprinted  ,  h ) ;
}
  
# include "cons/public.h"
# include "boolean.h"
# include "stcl/public.h"
# include "stcl/inline.h"

// nil symbolp
TaskForThread Lisp2Dbimnilsymbolp2(StackClusterPrivate  * const stclpp){
  ParaLispObject  * const xp = CCAR  ( StackClusterPrivate_ArgTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,(SymbolP(xp) ?
    xp :
    &plofalse.plo));
  return  TaskForThread_Analyse;
}

# include "newobject.h"

bool  IsNotSymbol ( StackClusterPrivate  * const  stclp  , ParaLispObject * const xp ) {
  tUniversalIsNotType ar  = {
    . stclp = stclp ,
    . xp  = xp ,
    . typetype  = TypeGlobalListMemberPLOSymbol ,
    . res = false ,
  } ;
  UniversalIsNotTypess  ( & ar  ) ;
  return  ar  . res ;
}

# include "sharedc.h"
# include "shared/inline.h"

//  symbol defstatic name value
TaskForThread Lisp2Dbimsymboldefstatic2(StackClusterPrivate * const stclpp){
  ParaLispObject  * varB;
  PLOSymbol * const  mep = ParaLispObjectToPLOSymbol(StackClusterPrivate_ThisTop( stclpp ));
  ParaLispObject  * const arglistp = StackClusterPrivate_ArgTop(stclpp );
  varB  = CCAR  ( arglistp);
  if(IsNotSymbol(  stclpp ,  varB))  
    return  TaskForThread_Analyse;
  ParaLispObject  * const varCp  = CCDR ( GetPropPair ( StackClusterPrivate_NamespaceProplist ( stclpp ) , & mep  -> plo ,
    & plossystemclass  .  plo , stclpp ) ) ;
  ParaLispObject  * const localenvfirstp = ClassGetStatic(varCp);
  if(IsNotEnvironmentLayer(  stclpp ,localenvfirstp))  
    return  TaskForThread_Analyse;
  if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (  localenvfirstp ) -> envlay ,
      varB  , CCAR ( CCDR (  arglistp ) ) , true  ) )
    HasConstLink(  stclpp ,  varB);
  return  TaskForThread_Analyse;
}

# include "cons/inline.h"

// ! to remake : symbol -> symbol | (symbol  initvalue)

// symbol defvar [{symbol}]
// nonconst link to NIL
TaskForThread Lisp2Dbimsymboldefvar2(StackClusterPrivate  * const stclpp){
  PLOSymbol * const mep =ParaLispObjectToPLOSymbol(StackClusterPrivate_ThisTop(
    stclpp ));
  ParaLispObject  * localenv;
  { ParaLispObject  * j;
    ParaLispObject  * jslow ;
    localenv  = ClassGetVars  (  CCDR ( 
      GetPropPair (  StackClusterPrivate_NamespaceProplist (
        stclpp ) , & mep  -> plo , & plossystemclass .  plo , stclpp ) ) ) ;
    if(IsNotEnvironmentLayer(  stclpp ,  localenv))  
      return  TaskForThread_Analyse;
    j = StackClusterPrivate_ArgTop(stclpp );
    jslow = j ;
    bool  tocheck = false ;
    while(CConsp( j)){
      { ParaLispObject  * const xp = ClassCons_First (
          &ParaLispObjectToPLOCons ( j )->cc ) ;
        if(IsNotSymbol(  stclpp ,  xp))  
          return  TaskForThread_Analyse;
        if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (
              localenv ) -> envlay ,  xp  , & plonil  . plo , false ) ) {
          HasConstLink(   stclpp ,xp);
          return  TaskForThread_Analyse;
        }
      }
      j = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( j )->cc ) ;
      
      if ( tocheck ) {
        jslow = ClassCons_Rest ( & ParaLispObjectToPLOCons ( jslow ) -> cc ) ;
        if ( j == jslow )
          break ;
        tocheck = false ;
      } else
        tocheck = true ;
    }
  }
  StackClusterPrivate_SetResult(stclpp ,&mep->plo);
  return  TaskForThread_Analyse;
}
  
# include "plostream/public.h"
# include "mutex2/public.h"

// symbol namespace
TaskForThread Lisp2Dbimsymbolnamespace2(StackClusterPrivate * const stclpp){
  ParaLispObject  * varC;
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) )
    goto  Next  ;
  { PLOSymbol * const mep = ParaLispObjectToPLOSymbol ( StackClusterPrivate_ThisTop ( stclpp ));
    { Mutex2Lock ( & Lisp2DmutexNameSpace ) ;
      { NameSpaceDef  *   ns = NameSpaceAssoc  ( mep  ) ;
        if(ns ==  (NameSpaceDef  *)0){
          NameSpaceDefine ( mep ) ;
          ns  = NameSpaceAssoc(mep);
        }
        StackClusterPrivate_Push(stclpp ,StackClusterPrivate_Env(stclpp ));
        StackClusterPrivate_Push(stclpp ,StackClusterPrivate_ExtEnv(stclpp ));
        
        { jmp_buf jump_buffer ;
          jmp_buf * const oldjb = Lisp2DJBglobal  ;
          Lisp2DJBglobal = &  jump_buffer ;
          int const volatile ex = setjmp  ( jump_buffer ) ;
          if  ( ex ) {
            Lisp2DJBglobal = oldjb  ;
            StackClusterPrivate_Popn(stclpp );
            StackClusterPrivate_Popn(stclpp );
            goto  Exit  ;
          }
        
          Environment_NewLevel ( StackClusterPrivate_envLocal ( stclpp ) , ns  ->  var  ) ;
          
          Lisp2DJBglobal = oldjb  ;
        }
          
        // external field have GLOBAL variables
        // another namespace is not accepted
        { jmp_buf jump_buffer ;
          jmp_buf * const oldjb = Lisp2DJBglobal  ;
          Lisp2DJBglobal = &  jump_buffer ;
          int const volatile ex = setjmp  ( jump_buffer ) ;
          if  ( ex ) {
            Lisp2DJBglobal = oldjb  ;
            StackClusterPrivate_Popn(stclpp );
            StackClusterPrivate_SetEnv  ( stclpp ,
              StackClusterPrivate_PopValue  ( stclpp ) ) ;
            goto  Exit  ;
          }
        
          Environment_NewLevel ( StackClusterPrivate_envExternal( stclpp ) ,
                                 ns  ->  var  )  ;
          Lisp2DJBglobal = oldjb  ;
        }
        StackClusterPrivate_Push (stclpp ,
          StackClusterPrivate_NamespaceProplist ( stclpp ) ) ;
        PLOCons * const newcons2 =   NewCons ( ns  ->  prop ,
          StackClusterPrivate_NamespaceProplist ( stclpp ) )  ; 
        SetNamespaceProplist(stclpp , &newcons2->plo);
      }
      Mutex2Unlock  ( & Lisp2DmutexNameSpace ) ;
    }
  }
  varC  = StackClusterPrivate_ArgTop(stclpp );
  for(;CConsp(  varC);
      varC  = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( varC  )->cc ) ) {
    StackClusterPrivate_Push(stclpp , varC);
    StackClusterPrivate_Push  ( stclpp ,  ClassCons_First ( 
      &ParaLispObjectToPLOCons ( varC  )->cc ) ) ;
    StackClusterPrivate_SetflagCont ( stclpp , 1U ) ;
    goto  Exit  ;
Next  :
    varC = StackClusterPrivate_PopValue ( stclpp ) ;
    if(StackClusterPrivate_exceptionnotprocessed  ( stclpp )){
      SetNamespaceProplist  ( stclpp , StackClusterPrivate_PopValue  ( stclpp ) ) ;
      StackClusterPrivate_SetEnv  ( stclpp ,
        StackClusterPrivate_PopValue  ( stclpp ) ) ;
      goto  Exit  ;
    }
  }
  SetNamespaceProplist  ( stclpp , StackClusterPrivate_PopValue  ( stclpp ) ) ;
  StackClusterPrivate_SetExtEnv ( stclpp , StackClusterPrivate_PopValue  ( stclpp ) ) ;
  StackClusterPrivate_SetEnv  ( stclpp , StackClusterPrivate_PopValue  ( stclpp ) ) ;
Exit  :
  return  TaskForThread_Analyse ;
}

// symbol letset x
TaskForThread Lisp2Dbimsymbolletset2(StackClusterPrivate  * const stclpp){
  ParaLispObject  * const xp = CCAR ( StackClusterPrivate_ArgTop(stclpp ));
  if(IsNotEnvironmentLayer(  stclpp ,  CCAR ( StackClusterPrivate_Env(stclpp )))) 
    return  TaskForThread_Analyse;
// !? to check const link here  
  if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (
        CCAR ( StackClusterPrivate_Env(stclpp )) ) -> envlay ,
        StackClusterPrivate_ThisTop( stclpp ) ,  xp ,
      false ) ) {
    HasConstLink(   stclpp ,StackClusterPrivate_ThisTop(stclpp ));
    return  TaskForThread_Analyse;
  }
  StackClusterPrivate_SetResult(stclpp ,xp);
  return  TaskForThread_Analyse;
}
    
# include "undefbool.h"

# define  SymbolMoreEq  Lisp2D_SymbolMoreEqMLjS
static  Lisp2DBoolType SymbolMoreEq(ParaLispObject * const xp,
  ParaLispObject * const yp, StackClusterPrivate  * const stclpp ){
  if(IsNotSymbol(  stclpp , yp)) 
    return  Lisp2DBoolUndef;
  if(PLOSymbolMoreEqP(ParaLispObjectToPLOSymbolConst(xp),
    ParaLispObjectToPLOSymbolConst(yp))) 
    return  Lisp2DBoolTrue;
  return  Lisp2DBoolFalse;
}

# include "lessmore.h"

// symbol >= [{symbol}]
TaskForThread Lisp2Dbimsymbolmoreoreq3(StackClusterPrivate * const stclpp){
  return  bimUniversalLessMore(  & SymbolMoreEq,stclpp);
}

# define  SymbolMore  Lisp2D_SymbolMore7j4i
static  Lisp2DBoolType SymbolMore(ParaLispObject * const xp,
  ParaLispObject * const yp, StackClusterPrivate  * const stclpp ){
  if(IsNotSymbol(  stclpp , yp)) 
    return  Lisp2DBoolUndef;
  if(PLOSymbolMoreP(ParaLispObjectToPLOSymbolConst(xp),
    ParaLispObjectToPLOSymbolConst(yp)))
    return  Lisp2DBoolTrue;
  return  Lisp2DBoolFalse;
}

// symbol > [{symbol}]
TaskForThread Lisp2Dbimsymbolmore3(StackClusterPrivate * const stclpp){
  return  bimUniversalLessMore(  & SymbolMore,stclpp);
}

# include "minmax.h"

// symbol max [{symbol}]
TaskForThread Lisp2Dbimsymbolmax2(StackClusterPrivate * const stclpp){
  return  bimUniversalMinMax(  & SymbolMore,stclpp);
}

# define  SymbolLessEq Lisp2D_SymbolLessEqHeKc
static  Lisp2DBoolType SymbolLessEq(ParaLispObject * const xp,
  ParaLispObject * const yp, StackClusterPrivate  * const stclpp ){
  if(IsNotSymbol(  stclpp , yp)) 
    return  Lisp2DBoolUndef;
  if(PLOSymbolLessEqP(ParaLispObjectToPLOSymbolConst(xp),
    ParaLispObjectToPLOSymbolConst(yp)))
    return  Lisp2DBoolTrue;
  return  Lisp2DBoolFalse;
}

// symbol <= [{symbol}]
TaskForThread Lisp2Dbimsymbollessoreq3(StackClusterPrivate * const stclpp){
  return  bimUniversalLessMore(  & SymbolLessEq,stclpp);
}

# define  SymbolLess  Lisp2D_SymbolLessnPGI
static  Lisp2DBoolType SymbolLess(ParaLispObject * const xp,
  ParaLispObject * const yp, StackClusterPrivate  * const stclpp){
  if(IsNotSymbol(  stclpp, yp))
    return  Lisp2DBoolUndef;
  if(PLOSymbolLessP(ParaLispObjectToPLOSymbolConst(xp),
    ParaLispObjectToPLOSymbolConst(yp)))
    return  Lisp2DBoolTrue;
  return  Lisp2DBoolFalse;
}

// symbol < [{symbol}]
TaskForThread Lisp2Dbimsymbolless3(StackClusterPrivate * const stclpp){ 
  return  bimUniversalLessMore(  & SymbolLess,stclpp);
}
    
// symbol min [{symbol}]
TaskForThread Lisp2Dbimsymbolmin2(StackClusterPrivate * const stclpp){
  return  bimUniversalMinMax(  & SymbolLess,stclpp);
}
  
// (name  defclass  P1 ... PN)
// place father-class=NIL by default
TaskForThread Lisp2Dbimsymboldefclass2  ( StackClusterPrivate  * const stclpp  ) {
  ParaLispObject  * classenv2 ;
  ParaLispObject  * classconstfenv2 ;
  ParaLispObject  * classconstenv2  ;
  classenv2 = ( & NewEnvironmentLayer ( ) -> plo ) ;
  classconstfenv2 = ( & NewEnvironmentLayer ( ) -> plo ) ;
  classconstenv2  = ( & NewEnvironmentLayer ( ) -> plo ) ;
  ParaLispObject  * res2  ;
  { ParaLispObject  * const arglistp =StackClusterPrivate_ArgTop(stclpp ) ;
    if  ( CConsp (  arglistp ) ) {
      ParaLispObject  * list [ ] = {  arglistp , classconstfenv2 , classenv2 ,
        classconstenv2  , NULL } ;
      res2  = ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list});
    } else  {
      PLOCons * pair  ;
      pair  =  NewCons ( &plonil.plo  , &plonil.plo  )  ;
      ParaLispObject  * list [ ] = { &pair->plo  , classconstfenv2 , classenv2 ,
        classconstenv2  , NULL } ;
      res2  = ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list});
    }
  }
  { ParaLispObject  * const mep  =StackClusterPrivate_ThisTop(stclpp ) ;
    SetProp2  ( StackClusterPrivate_NamespaceProplist ( stclpp ) ,  mep  ,
      & plossystemclass . plo , res2  ,  stclpp ) ;
    StackClusterPrivate_SetResult(stclpp , mep  ) ;
  }
  return  TaskForThread_Analyse ;
}

// symbol boundp [env]
TaskForThread Lisp2Dbimsymbolboundp2  ( StackClusterPrivate  * const stclpp  ) {
  ParaLispObject  * const argenvp  = CCAR ( StackClusterPrivate_ArgTop(stclpp ))  ;
  StackClusterPrivate_SetResult(stclpp ,( Assoc ( StackClusterPrivate_ThisTop(stclpp ),
      ( ( ParaLispObject_Type  ( argenvp ) ==  TypeGlobalListMemberPLOEnv ) ?
         Environment_Env ( & ParaLispObjectToPLOEnv (  argenvp  ) -> env ) :
        StackClusterPrivate_Env(stclpp ) )
      ,  stclpp ) ?
      & plotrue.plo  : & plofalse.plo  )) ;
  return  TaskForThread_Analyse ;
}

//  symbol properties
TaskForThread Lisp2Dbimsymbolproperties2  ( StackClusterPrivate  * const stclpp  ) {
  StackClusterPrivate_SetResult(stclpp , GetPropVector (
    StackClusterPrivate_NamespaceProplist ( stclpp ) , StackClusterPrivate_ThisTop(stclpp ) ) ) ;
  return  TaskForThread_Analyse ;
}

# include "string/public.h"
# include "string/struct.h"

//  symbol string
TaskForThread Lisp2Dbimsymbolstring2  ( StackClusterPrivate  * const stclpp  ) {
  PLOStringPub * const  resp  = PLOString_NewCopy ( StringCStr  ( WideChar  ) ( PLOSymbolCValue  (
    ParaLispObjectToPLOSymbol ( StackClusterPrivate_ThisTop ( stclpp ) ) ) ) ) ;
  StackClusterPrivate_SetResult ( stclpp , & resp -> plo ) ;
  return  TaskForThread_Analyse ;
}

// symbol <> [{x}]
# define  SymbolNotEq Lisp2D_SymbolNotEqViji
static  Lisp2DBoolType SymbolNotEq  ( ParaLispObject * const xp  , ParaLispObject * const yp  ) {
  if  (   xp   ==   yp  )
    return  Lisp2DBoolFalse ;
  return  Lisp2DBoolTrue  ;
}

# include "eqnoteq.h"

TaskForThread Lisp2Dbimsymbolnotequal2 ( StackClusterPrivate * const stclpp  ) {
  return  bimUniversalEqNotEq ( & SymbolNotEq  , stclpp  ) ;
}

// symbol = [{x}]
# define  SymbolEq Lisp2D_SymbolEqVtBe
static  Lisp2DBoolType SymbolEq  ( ParaLispObject * const xp  , ParaLispObject * const yp  ) {
  if  ( xp  == yp )
    return  Lisp2DBoolTrue ;
  return  Lisp2DBoolFalse ;
}

TaskForThread Lisp2Dbimsymbolequal2 ( StackClusterPrivate * const stclpp  ) {
  return  bimUniversalEqNotEq ( & SymbolEq  , stclpp  ) ;
}

# include <wctype.h>
# include "cast.h"

void  toLower ( size_t  const strs  , wchar_t volatile * const strp  ) {
  wchar_t volatile * const strend = strp + strs ;
  for ( wchar_t volatile * si = strp ; si < strend ; ++ si )
    ( * si  ) = wint_cast_wchar ( towlower ( wchar_cast_wint ( * si ) ) ) ;
}

Vector  ( NameSpaceDefC ) namespacedefc  ;

LISP2D_PROTO_STACK_FREE ( NameSpaceDefC )
LISP2DSTACKDESTRUCTOR ( NameSpaceDefC , NameSpaceDef )
LISP2D_STACK_FREE ( NameSpaceDefC , NameSpaceDef )
LISP2DSTACKEND  ( NameSpaceDefC , NameSpaceDef )
LISP2DSTACKAT ( NameSpaceDefC , NameSpaceDef )
LISP2DSTACKPUSHBYVALUE  ( NameSpaceDefC , NameSpaceDef , )
LISP2DSTACKPUSHATVALUE  ( NameSpaceDefC , NameSpaceDef )
LISP2DSTACKPUSHFRONTVALUE ( NameSpaceDefC , NameSpaceDef , )

NameSpaceDef  * NameSpaceAssoc(PLOSymbol  * const sp){
  size_t  n = VectorSizeCopy(NameSpaceDefC)(&namespacedefc);
  if(n  ==  0)
    return  0;
  NameSpaceDef  *   nd = VectorFront  ( NameSpaceDefC )(&namespacedefc);
  if( sp  ==  (nd->name))
    return  nd;
  if(n  ==  1)
    return  0;
  // [0..n-1]
  if( sp  < (nd->name))
    return  0;
  --  n;
  // (0..n]
  nd  = VectorAt(NameSpaceDefC)(&namespacedefc,n);
  if( sp  ==  (nd->name))
    return  nd;
  if(nd->name <   sp)  
    return  0;
  size_t  i0 = 0 ;
  // (i0..n)
  while((n  - i0) > 1){
    size_t  i1 = (i0  + n)  >>  1;
    nd  = VectorAt(NameSpaceDefC)(&namespacedefc,i1);
    if( sp  ==  (nd->name))
      return  nd;
    if( sp  < (nd->name))   
      n = i1;
    else 
      i0  = i1;
  }
  return  0;
}

# include "char/public.h"
# include "string/public.h"

// symbol +
TaskForThread Lisp2Dbimsymbolplus2  ( StackClusterPrivate  * const stclpp  ) {
  PLOStringPub * stringtemp  ;
  { ParaLispObject  * j ;
    ParaLispObject  * jslow ;
    { wchar_t volatile const * const ws = StringCStr ( WideChar  ) ( PLOSymbolCValue  ( ParaLispObjectToPLOSymbol (
                StackClusterPrivate_ThisTop( stclpp ) ) ) ) ;
      stringtemp  = PLOString_NewCopy ( ws ) ;
      if  ( not stringtemp ) {
        OutOfMemory (  stclpp ) ;
        goto  Exit  ;
      }
    } // ws
    j =  StackClusterPrivate_ArgTop ( stclpp )  ;
    jslow = j ;
    bool  tocheck = false ;
    while ( CConsp (  j ) ) {
      { ParaLispObject  * const xp =  ClassCons_First ( & ParaLispObjectToPLOCons ( j ) -> cc )  ;
        if  ( SymbolP (  xp ) ) {
          wchar_t volatile const * const ws = StringCStr ( WideChar  ) (
              PLOSymbolCValue  ( ParaLispObjectToPLOSymbol (  xp ) ) ) ;
          PLOString_Addws ( stringtemp , ws ) ;
        } else if  ( Charp (  xp ) )
          PLOStringAddPLOChar ( stringtemp  , ParaLispObjectToPLOChar (  xp ) ) ;
        else if  ( Stringp (  xp ) )
            PLOString_Add (  stringtemp  ,  ParaLispObjectToPLOString ( xp )) ;
        else  {
          ParaLispObject  * list [ ] = {  xp , & PLOString_NewCopy (
            L" is not symbol nor char nor string" )->plo , NULL } ;
          StackClusterPrivate_ExceptionSet(stclpp ,
            ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
          goto  Exit  ;
        }
      } // xp
      j = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( j )->cc ) ;
      if ( tocheck ) {
        jslow = ClassCons_Rest ( & ParaLispObjectToPLOCons (
          jslow ) -> cc ) ;
        if ( j == jslow )
          break ;
        tocheck = false ;
      } else
        tocheck = true ;
    }
  } // j
  StackClusterPrivate_SetResult ( stclpp ,
    SymbolAddMoveString ( PLOString_Value2 ( stringtemp ) ) ) ;
Exit  :  
  return  TaskForThread_Analyse ;
}

# include "vector/struct.h"
# include "vector/public.h"
# include "errorstra.h"

void  NameSpaceDefine  ( PLOSymbol  * const sp ) {
  NameSpaceDef  d ;
  d.var = &  NewEnvironmentLayer ( ) ->  plo ;
  PLOVector * const tmpv = aligned_alloc ( _Alignof ( PLOVector ) , sizeof ( PLOVector ) ) ;
  if ( not tmpv ) {
    Lisp2DExcOutOfMemoryGlobal . value =
      L"isBADNameSpaceDefine:aligned_alloc(sizeof(PLOVector))" ;
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ;
  }
  d.prop  = &tmpv->plo;
  PLOVector_Init(tmpv);
  ParaLispObject_virtualPushAsNew(d.prop);
  d.name  =   sp;
  size_t  n=VectorSizeCopy(NameSpaceDefC)(&namespacedefc);
  if(n  ==  0){
    Vector_PushByValue(NameSpaceDefC)(&namespacedefc,d);
    return ;
  }
  NameSpaceDef  * nd = VectorFront  ( NameSpaceDefC )(&namespacedefc);
  if(n  ==  1){
    if( sp  < (nd->name))
      VectorPushFrontValue(NameSpaceDefC)(&namespacedefc,d);
    else
      Vector_PushByValue(NameSpaceDefC)(&namespacedefc,d);
    return ;
  }
  // n>=2
  if( sp  < (nd->name)){
    VectorPushFrontValue(NameSpaceDefC)(&namespacedefc,d);
    return ;
  }
  --  n;
  // [0..n]
  nd  = VectorAt(NameSpaceDefC)(&namespacedefc,n);
  if(nd->name <   sp ){
    Vector_PushByValue(NameSpaceDefC)(&namespacedefc,d);
    return ;
  }
  size_t  i0=0;
  while((n  - i0) > 1){
    size_t  const   i1=((i0  + n)  >>  1);
    nd  = VectorAt(NameSpaceDefC)(&namespacedefc,i1);
    if( sp  < (nd->name))
      n = i1;
    else      
      i0  = i1;
  }
  VectorPushAtValue(NameSpaceDefC)(&namespacedefc,n,d);
}

//  symbol set value [env]
// nonconst link
TaskForThread Lisp2Dbimsymbolset2 ( StackClusterPrivate * const stclpp ) {
  ParaLispObject  * setenv2 ;
  ParaLispObject  const * const arglistp = StackClusterPrivate_ArgTop(stclpp )  ;
  { ParaLispObject  const * const argrestp = CCDR (  arglistp )  ;
    if  ( CConsp (  argrestp ) ) {
      ParaLispObject  * const ep = ClassCons_First ( &ParaLispObjectToPLOConsConst (
        argrestp )->cc )  ;
      if  ( IsNotEnv  (  stclpp ,  ep ) )
        goto  Exit  ;
      setenv2 = ( Environment_Env ( & ParaLispObjectToPLOEnv  ( ep ) -> env ) ) ;
    } else
      setenv2 =  StackClusterPrivate_Env( stclpp )  ;
  } // argrest
  { ParaLispObject  * const valp = CCAR (  arglistp )  ;
    { PLOSymbol * const mep  = ParaLispObjectToPLOSymbol  ( StackClusterPrivate_ThisTop( stclpp ) ) ;
      { ParaLispObject  * j = setenv2  ;
// !? TaskPause
        for ( ; CConsp (  j ) ;
          j  = ClassCons_Rest ( &ParaLispObjectToPLOCons ( j )->cc ) ) {
          ParaLispObject  * const jlp  = ClassCons_First (
            &ParaLispObjectToPLOCons  ( j )->cc )  ;
          if  ( IsNotEnvironmentLayer (  stclpp , jlp  ) )
            goto  Exit  ;
          bool  wasconst  ;
          if  ( EnvironmentLayerisOKTryChangeValue  ( ( t_EnvironmentLayerisOKTryChangeValue ) {
              . me = & ParaLispObjectToPLOEnvironmentLayer  (  jlp  ) -> envlay , . sp = & mep->plo  ,
              . vp = valp , . flagwasconstp = & wasconst , . flagconst = false  } ) )
            goto  Resu  ;
          if  ( wasconst  ) {
            HasConstLink  (  stclpp ,& mep->plo  ) ;
            goto  Exit  ;
          }
        } // for j
      } // j
      if  ( IsNotCons (  stclpp ,  setenv2 ) )
        goto  Exit  ;
      setenv2 = ClassCons_First ( &ParaLispObjectToPLOCons ( setenv2 )->cc ) ;
      if  ( IsNotEnvironmentLayer (  stclpp ,  setenv2 ) )
        goto  Exit  ;
      if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (
          setenv2 ) -> envlay , & mep->plo  ,  valp , false ) ) {
        OutOfMemory (  stclpp ) ;
        goto  Exit  ;
      }
    }  // me
Resu  :
    StackClusterPrivate_SetResult(stclpp , valp ) ;
  } // val
Exit  :
  return  TaskForThread_Analyse ;
}

//  symbol const [env]
// return symbol or exception
TaskForThread Lisp2Dbimsymbolconst  ( StackClusterPrivate * const stclpp ) {
  { ParaLispObject  * setenv2 ;
    { ParaLispObject  const * const arglistp =StackClusterPrivate_ArgTop(stclpp ) ;
      if  ( CConsp ( arglistp ) ) {
        ParaLispObject  * const ep= ClassCons_First ( &ParaLispObjectToPLOConsConst ( arglistp )->cc ) ;
        if  ( IsNotEnv  (  stclpp , ep ) )
          goto  Exit  ;
        setenv2 = Environment_Env ( & ParaLispObjectToPLOEnv ( ep ) -> env ) ;
      } else
        setenv2 = StackClusterPrivate_Env(  stclpp ) ;
    }  // arglist
    { PLOSymbol * const mep = ParaLispObjectToPLOSymbol ( StackClusterPrivate_ThisTop( stclpp ) ) ;
      { ParaLispObject  * j = setenv2 ;
        for ( ; CConsp (  j ) ;
          j = ClassCons_Rest  ( & ParaLispObjectToPLOCons  ( j )->cc  ) ) {
          ParaLispObject  * const jlp = ClassCons_First ( &ParaLispObjectToPLOCons  ( j )->cc ) ;
          if  ( IsNotEnvironmentLayer (   stclpp , jlp  ) )
            goto  Exit  ;
          if  ( EnvironmentLayerisOKSetConstFlag  (
            & ParaLispObjectToPLOEnvironmentLayer  ( jlp  ) -> envlay , & mep->plo  ,
            true  ) ) {
            StackClusterPrivate_SetResult(stclpp ,& mep->plo  ) ;
            goto  Exit  ;
          }
        } // for j
      } // j
      VariableHaveNoLinks (  stclpp , & mep -> plo  ) ;
    }
  } // me setenv
Exit  :
  return  TaskForThread_Analyse ;
}

//  symbol unconst [env]
// return symbol or exception
TaskForThread Lisp2Dbimsymbolunconst  ( StackClusterPrivate * const stclpp ) {
  { ParaLispObject  * setenv2 ;
    { ParaLispObject  const * const arglistp =StackClusterPrivate_ArgTop(stclpp ) ;
      if  ( CConsp ( arglistp ) ) {
        ParaLispObject  * const ep = ClassCons_First ( &ParaLispObjectToPLOConsConst (
            arglistp )->cc ) ;
        if  ( IsNotEnv  (  stclpp , ep ) )
          goto  Exit  ;
        setenv2 = Environment_Env ( & ParaLispObjectToPLOEnv ( ep ) -> env ) ;
      } else
        setenv2 = StackClusterPrivate_Env( stclpp ) ;
    } // arlist
    { PLOSymbol * const mep  = ParaLispObjectToPLOSymbol  (
        StackClusterPrivate_ThisTop  ( stclpp ) ) ;
      { ParaLispObject  * j = setenv2 ;
        for ( ; CConsp (  j ) ;
          j = ClassCons_Rest  ( & ParaLispObjectToPLOCons  ( j )->cc ) ) {
          ParaLispObject  * const jlp  = ClassCons_First ( &ParaLispObjectToPLOCons  (
            j )->cc ) ;
          if  ( IsNotEnvironmentLayer (  stclpp , jlp  ) )
            goto  Exit  ;
          if  ( EnvironmentLayerisOKSetConstFlag  (
            & ParaLispObjectToPLOEnvironmentLayer  ( jlp  ) -> envlay , & mep->plo  ,
            false ) ) {
            StackClusterPrivate_SetResult(stclpp ,& mep->plo  ) ;
            goto  Exit  ;
          }
        } // for j
      } // j
      VariableHaveNoLinks (  stclpp , & mep -> plo  ) ;
    }
  } // me setenv
Exit  :
  return  TaskForThread_Analyse ;
}

// symbol constp [env]
// returns true or false or exception
TaskForThread Lisp2Dbimsymbolconstp ( StackClusterPrivate  * const stclpp  ) {
  ParaLispObject  * setenv2 ;
  ParaLispObject  const * const arglistp =StackClusterPrivate_ArgTop(stclpp ) ;
  if  ( CConsp ( arglistp ) ) {
    ParaLispObject  * const ep = ClassCons_First ( &ParaLispObjectToPLOConsConst ( 
        arglistp )->cc ) ;
    if  ( IsNotEnv  (  stclpp , ep ) )
      goto  Exit  ;
    setenv2 = Environment_Env ( & ParaLispObjectToPLOEnv  ( ep ) -> env ) ;
  } else
    setenv2 = ( StackClusterPrivate_Env ( stclpp ) ) ;
  { PLOSymbol * const mep  = ParaLispObjectToPLOSymbol  ( StackClusterPrivate_ThisTop(
        stclpp ) ) ;
    { ParaLispObject  * j = setenv2 ;
      for ( ; CConsp (  j ) ;
        j = ClassCons_Rest ( &ParaLispObjectToPLOCons  ( j )->cc ) ) {
        ParaLispObject  * const jlp  = ClassCons_First (
          &ParaLispObjectToPLOCons  ( j )->cc ) ;
        if  ( IsNotEnvironmentLayer (  stclpp , jlp  ) )
          goto  Exit  ;
        bool  flagconst ;
        if  ( EnvironmentLayerisOKGetConstFlag  (
          & ParaLispObjectToPLOEnvironmentLayer  ( jlp  ) -> envlay , & mep->plo  ,
            & flagconst ) ) {
          StackClusterPrivate_SetResult(stclpp ,( flagconst  ? &plotrue.plo :
            &plofalse.plo )) ;
          goto  Exit  ;
        }
      } // for j
    } // j
    VariableHaveNoLinks (  stclpp , & mep -> plo  ) ;
  } // me
Exit  :
  return  TaskForThread_Analyse ;
}

# include "stack/public.h"
  
// symbol defmethod symbol
// method link is const
TaskForThread Lisp2Dbimsymboldefmethod2 ( StackClusterPrivate  * const stclpp  ) {
  ParaLispObject  * const arglistp =StackClusterPrivate_ArgTop(stclpp ) ;
  ParaLispObject  * const argfirstp  = CCAR ( arglistp ) ;
  if  ( IsNotSymbol (  stclpp , argfirstp  ) )
    goto  Exit  ;
  { ParaLispObject  * const classjp  =CCDR ( GetPropPair (
    StackClusterPrivate_NamespaceProplist ( stclpp ) ,
        StackClusterPrivate_ThisTop(stclpp ),
         & plossystemclass  . plo ,   stclpp ) ) ;
    if(classjp==&plonil.plo){
      ParaLispObject  * list [ ] = { & PLOString_NewCopy ( L"class " )->plo ,
          StackClusterPrivate_ThisTop(stclpp ) , & PLOString_NewCopy (
            L" is not defined"  )->plo , NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      goto Exit;
    }
    ParaLispObject  * const envp =ClassGetMethods ( classjp  ) ;        
    if  ( IsNotEnvironmentLayer (  stclpp , envp ) ) 
      goto  Exit  ;
    PLOCons * const res2 = NewCons ( &  plolambdaw  . plo  , CCDR ( arglistp ) ) ;
    if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (
      envp ) -> envlay , argfirstp  , &  res2 ->  plo , false ) ) {
      HasConstLink  (  stclpp , argfirstp  ) ;
      goto  Exit  ;
    }
    StackClusterPrivate_SetResult(stclpp ,&  res2 ->  plo  ) ;
    // second method class::name
    ParaLispObject  * const classjnilp  = CCDR ( GetPropPair (
      StackClusterPrivate_NamespaceProplist ( stclpp ) , & plonil.plo ,
          & plossystemclass . plo ,   stclpp ) ) ;
    if(classjnilp==&plonil.plo){
      ParaLispObject  * list [ ] = { & PLOString_NewCopy ( 
        L"class NIL is not defined"  )->plo , NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      goto Exit;
    }
    ParaLispObject  * const envnilp =ClassGetMethods ( classjnilp  ) ;        
    if  ( IsNotEnvironmentLayer (  stclpp , envnilp ) )
      goto  Exit  ;
    ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
    String  ( WideChar ) * const wsp = Lisp2D_StackVar ( Lisp2DStackTypeStringWideChar ) ;
    StringConstrCStr ( WideChar )  ( wsp , StringCStr ( WideChar  ) (
        PLOSymbolCValue  ( ParaLispObjectToPLOSymbol(StackClusterPrivate_ThisTop  (
              stclpp ) ) ) ) , true ) ;
    StringAddCharArray  ( WideChar  ) ( wsp , L"::" ) ;
    StringAddCharArray  ( WideChar  ) ( wsp , StringCStr  ( WideChar  ) (  PLOSymbolCValue  (
        ParaLispObjectToPLOSymbol(argfirstp))) ) ;
    // ! to SymbolAddMove
    ParaLispObject  * const symbolmethodnamep  = SymbolAddMoveString ( wsp ) ;
    Lisp2D_StackFree  ( oldstack ) ;
    if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (
          envnilp ) -> envlay , symbolmethodnamep  , & res2->plo , false ) ) {
      HasConstLink  (  stclpp , symbolmethodnamep  ) ;
      goto  Exit  ;
    }
  } // env
Exit  :
  return  TaskForThread_Analyse ;
}

// symbol defmacro symbol
// macro link is const
TaskForThread Lisp2Dbimsymboldefmacro2  ( StackClusterPrivate  * const stclpp  ) {
  ParaLispObject  * const arglistp =StackClusterPrivate_ArgTop(stclpp ) ;
  ParaLispObject  * const argfirstp  = CCAR ( arglistp ) ;
  if  ( IsNotSymbol (  stclpp , argfirstp  ) )
    goto  Exit  ;
  PLOCons * const res2  = NewCons ( & plomacronotmod  . plo  , CCDR ( arglistp ) ) ;
  { ParaLispObject  * const envp =ClassGetMethods ( CCDR ( GetPropPair (
          StackClusterPrivate_NamespaceProplist ( stclpp ) ,
            StackClusterPrivate_ThisTop(stclpp ) , & plossystemclass  . plo , stclpp ) ) ) ;
    if  ( IsNotEnvironmentLayer (  stclpp , envp ) )
      goto  Exit  ;
    if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (
          envp ) -> envlay , argfirstp  , & res2->plo  , false ) ) {
      HasConstLink  (  stclpp , argfirstp  ) ;
      goto  Exit  ;
    }
    // second method class::name
    ParaLispObject  * const envnilp =ClassGetMethods (
         CCDR ( GetPropPair ( StackClusterPrivate_NamespaceProplist ( stclpp ) ,
          & plonil.plo , & plossystemclass  . plo ,  stclpp ) ) ) ;
    if  ( IsNotEnvironmentLayer (  stclpp , envnilp ) )
      goto  Exit  ;
    ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
    String  ( WideChar ) * const wsp = Lisp2D_StackVar ( Lisp2DStackTypeStringWideChar ) ;
    StringConstrCStr ( WideChar )  ( wsp , StringCStr ( WideChar  ) ( PLOSymbolCValue  (
      ParaLispObjectToPLOSymbol(StackClusterPrivate_ThisTop(stclpp )  ) ) ) , true ) ;
    StringAddCharArray  ( WideChar  ) ( wsp , L"::" ) ;
    StringAddCharArray  ( WideChar  ) ( wsp , StringCStr  ( WideChar  ) (  PLOSymbolCValue  (
      ParaLispObjectToPLOSymbol(argfirstp))) ) ;
    // ! to SymbolAddMove
    ParaLispObject  * const symbolmethodnamep  = SymbolAddMoveString ( wsp ) ;
    Lisp2D_StackFree  ( oldstack ) ;
    if  ( EnvironmentLayerisBADPush ( & ParaLispObjectToPLOEnvironmentLayer (
          envnilp ) -> envlay ,  symbolmethodnamep  , & res2  ->  plo  , false ) ) {
      HasConstLink  (  stclpp , symbolmethodnamep  ) ;
      goto  Exit  ;
    }
  } // env
  StackClusterPrivate_SetResult(stclpp ,&  res2->plo  ) ;
Exit  :
  return  TaskForThread_Analyse ;
}

//  nil gensym
TaskForThread Lisp2Dbimnilgensym2(StackClusterPrivate * const stclpp){
  StackClusterPrivate_SetResult(stclpp ,
    &PLOSymbolGenTemp(StackClusterPrivate_ThisTop(stclpp ))->plo);
  return  TaskForThread_Analyse;
}

// Lock's not used
void  PLOSymbolDeclareForGC ( ParaLispObject * const me ) {
  if  ( not me -> flagGCPassed ) {
    me -> flagGCPassed = true  ;
    GlobalListPopNotLock  ( & GlobalListOfSymbolsGarbage , & me -> base ) ;
    // ! to check for existing ?
    MapPubInsert  ( treeSymbolsLessType ) ( treeSymbols_pub , ( MapNode (
        treeSymbolsLessType ) ) { ParaLispObjectToPLOSymbol ( me  ) , 0 } ) ;
  }
}

# include "main.h"
# include "ulong/public.h"
# include "ulong/inline.h"

// ! to make : bool isBADSymbolGenTemp(ParaLispObject & x,PLOSymbol * result)
PLOSymbol *  PLOSymbolGenTemp ( ParaLispObject * const xp ) {
  wchar_t volatile const * const cs0 = ( SymbolP ( xp ) ?
    StringCStr  ( WideChar  ) (  PLOSymbolCValue  ( ParaLispObjectToPLOSymbol ( xp ) )  ) :
    L"t"  ) ;
  ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
  String  ( WideChar ) * const cs1 = StackNew_StringWideChar ( ) ;
  String_Init ( WideChar  ) ( cs1 , true ) ;
  { PLOSymbol  * const symtop = aligned_alloc ( _Alignof ( PLOSymbol ) , sizeof ( PLOSymbol ) ) ;
    if  ( symtop  ) {
      PLOSymbolConstrWCharArray ( symtop  , ( PArray_wchar_c ) {
        ( wchar_t const ( * ) [ ] ) ( cs0 ) } ) ;
      do  {
        Mutex2Lock ( & Lisp2DmutexGenTemp ) ;
        ULongAdd1 ( ULongToPub ( & ulongGentempsymbolindex ) ) ;
        Lisp2DULongAddToStrWideChar (
          ULongCToPub ( & ulongGentempsymbolindex ) , cs1 ) ;
        Mutex2Unlock  ( & Lisp2DmutexGenTemp ) ;
        StringAddCharArray  ( WideChar )  ( & symtop -> value ,
          StringCStr  ( WideChar )  ( cs1 ) ) ;
        Mutex2Lock ( & Lisp2DMutexTreeSymbols  ) ;  
        { size_t  const jc  = MapPubFind  ( treeSymbolsLessType ) (
          treeSymbols_pub , symtop ) ;
          if  ( jc  ==  MapPubSize  ( treeSymbolsLessType ) ( treeSymbols_pub )
            ) {
            MapPubInsert  ( treeSymbolsLessType ) ( treeSymbols_pub ,
              ( MapNode ( treeSymbolsLessType ) ) { symtop  , 0 } ) ;
            Mutex2Unlock  ( & Lisp2DMutexTreeSymbols ) ;
            Lisp2D_StackFree  ( oldstack ) ;
            return   symtop ;
          }
          Mutex2Unlock  ( & Lisp2DMutexTreeSymbols ) ;
        }
        StringSetArray  ( WideChar  ) ( & symtop -> value , cs0 ) ;
        StringClear ( WideChar  ) ( cs1 ) ;
      } while ( true  ) ; 
    } else  {
      Lisp2D_StackFree  ( oldstack ) ;
      OutOfMemory ( 0 ) ;
      return  & plosnull  ;
    } 
  } 
}

ParaLispObject  * SymbolAddMoveString ( String ( WideChar ) * const wsp ) {
  toLower ( String_Size ( WideChar )  ( wsp ) , String_Begin ( WideChar  ) ( wsp ) ) ;
  if  ( PLOSymbolEqualWCharArray  ( & plostrue1 ,
    (PArray_wchar_c){(wchar_t const (*)[])(StringCStr(WideChar)(wsp))} ) )
    return & plotrue  . plo ;
  if  ( PLOSymbolEqualWCharArray ( & plosfalse ,
    (PArray_wchar_c){(wchar_t const (*)[])(StringCStr(WideChar)(wsp))} ) )
    return & plofalse . plo ;
  if  ( PLOSymbolEqualWCharArray  ( & plosnil ,
    (PArray_wchar_c){(wchar_t const (*)[])(StringCStr(WideChar)(wsp))} ) )
    return & plonil.plo;
  { PLOSymbol  * const symtop2 = aligned_alloc ( _Alignof ( PLOSymbol ) , sizeof ( PLOSymbol ) ) ;
    if(symtop2){
      PLOSymbolConstrWCharStringMove(symtop2,wsp);
      Mutex2Lock ( & Lisp2DMutexTreeSymbols ) ;
      { size_t  const jc  = MapPubFind  ( treeSymbolsLessType ) ( treeSymbols_pub , symtop2 ) ;
        if  ( jc  not_eq  MapPubSize  ( treeSymbolsLessType ) ( treeSymbols_pub ) ) {
          PLOSymbol * const result = MapPubCAt ( treeSymbolsLessType ) ( treeSymbols_pub , jc ) -> key ;
          Mutex2Unlock  ( & Lisp2DMutexTreeSymbols ) ;
          PLOSymbolstaticDestr  ( & symtop2->plo ) ;
          free  ( symtop2 ) ;
          return  &  result ->  plo ;
        }
        MapPubInsert  ( treeSymbolsLessType ) ( treeSymbols_pub , ( MapNode (
          treeSymbolsLessType ) ) { symtop2 , 0 } ) ; 
      }
      Mutex2Unlock  ( & Lisp2DMutexTreeSymbols ) ;
      return & (  symtop2->plo ) ; 
    }
  }
  OutOfMemory(0);
  return & plonil.plo ; 
}

ParaLispObject  * SymbolAddConstString ( String ( WideChar ) const * const s0p ) {
  ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
  String  ( WideChar ) * const wsp = Lisp2D_StackVar ( Lisp2DStackTypeStringWideChar ) ;
  String_ConstrCopy ( WideChar  ) ( wsp , s0p ) ;
  ParaLispObject  * const res = SymbolAddMoveString ( wsp ) ;
  Lisp2D_StackFree  ( oldstack ) ;
  return res ;
}

# include <errno.h>
  
PLOSymbol * SymbolErrno  ( void ) {
  return  SymbolFromIntErrno  ( errno ) ;
}

PLOSymbol * SymbolFromIntErrno  ( int const e ) {
  size_t  const jc  = MapPubFind  ( errnotosymbol ) ( seterrnotosymbol_pub , e ) ;
  PLOSymbol * errname ;
  if  ( jc  not_eq  MapPubSize  ( errnotosymbol ) ( seterrnotosymbol_pub ) )
    errname = MapPubCAt ( errnotosymbol ) ( seterrnotosymbol_pub  , jc  ) ->  value ;
  else
    errname = & plosquestion ;
  return  errname ;
}

void PLOSymbolConstrWCharStringMove ( PLOSymbol * const me , String(WideChar)  * const xp ) {
  VirtualTypePointer  vtp = { . addr = { . p = me } , . type = TypeGlobalListMemberPLOSymbol } ;
  ParaLispObject_InitCVTP ( & me -> plo , true , vtp ) ;
  String_ConstrMove ( WideChar  ) ( & me -> value , xp  ) ;
  PLOSymbolAddConstrStat
}

# include "widestring/inline.h"

void  PLOSymbolstaticDestr  ( ParaLispObject * const me ) {
  PLOSymbolDestr  ( ParaLispObjectToPLOSymbol ( me  ) ) ;
}

void  PLOSymbolDestr ( PLOSymbol * const me ) {
  StringDestr ( WideChar  ) ( & me -> value ) ;
  ParaLispObject_staticDestr  ( & me  ->  plo ) ;
}

bool  PLOSymbolMoreEqP  ( PLOSymbol  const * const xp  , PLOSymbol  const * const yp ) {
  return  not  (  PLOSymbolLessP(xp  , yp)  ) ;
}
bool  PLOSymbolLessEqP  ( PLOSymbol  const * const xp  , PLOSymbol  const * const yp  ) {
  return  not  (  PLOSymbolLessP(yp , xp) ) ;
}
void  PLOSymbolConstrWCharArray ( PLOSymbol * const me , PArray_wchar_c const c ) {
  VirtualTypePointer  vtp = { . addr = { . p = me } , . type = TypeGlobalListMemberPLOSymbol } ;
  ParaLispObject_InitCVTP ( & me -> plo , true , vtp ) ;
  StringConstrCStr  ( WideChar  ) ( & me -> value , * c . p , true ) ;
  PLOSymbolAddConstrStat
}

bool  PLOSymbolEqualWCharArray ( PLOSymbol  const * const mep , PArray_wchar_c const  x ) {
  return (  wcscmp  ( wcharconstvolatp_cast_wcharconstp ( StringCStr  ( WideChar  ) ( PLOSymbolCValue  ( mep )  ) ) ,
    * x . p )  ==  0 ) ;
}
