// Lisp2D - methods virtual table
// ©2021-3 by Alex Glebe
# include "virttabl.h"
# include "bimc.h"
# include "window.h"
# include "boolean.h"
# include "signall.h"
# include "object/inline.h"
# include "dir/inline.h"
# include "quote/public.h"
# include "string/public.h"
# include "backquote/inline.h"
# include "comma/public.h"
# include "bytedeque/public.h"
# include "char/public.h"
# include "cons/inline.h"
# include "vector/public.h"
# include "lock/public.h"
# include "socket/public.h"
# include "plostream/public.h"
# include "stat/public.h"
# include "plocomplex/public.h"
# include "define.h"
# include "env/public.h"
# include "time/public.h"
# include "unquotesplicing/public.h"
# include "window/inline.h"

void  MakeVirtualTables ( void  ) {
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLONil ] = &  ParaLispObject_isBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOSymbol ] = &  ParaLispObject_isBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOCons ] = & PLOCons_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOString ] = & PLOString_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberBIFPrivate ] = &  ParaLispObject_isBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOVector ] = & PLOVector_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOChar ]
    = & PLOChar_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOStream ]
    = &  ParaLispObject_isBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOLock ]
    = & PLOLock_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOObject ]
    = & PLOObject_staticisBADCopyPrivate ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOWindowPri ]
    = &  ParaLispObject_isBADCopyPrivate ;
# endif
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOTime ]
    = &  PLOTime_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLODirPri ]
    = &  ParaLispObject_isBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOSignal ]
    = &  PLOSignal_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOEnv ]
    = &  PLOEnv_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [
    TypeGlobalListMemberPLOEnvironmentLayer ]
    = &  PLOEnvironmentLayer_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOQuote ]
    = & PLOQuote_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ 
    TypeGlobalListMemberBackQuotePrivate ]
    = &  PLOBackQuote_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOComma ]
    = &  PLOComma_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  PLOUnQuoteSplicing_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOComplex ]
    = & PLOComplex_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOBoolean ]
    = &  ParaLispObject_isBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOByteDeque ]
    = & PLOByteDeque_staticisBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOSocket ]
    = &  ParaLispObject_isBADCopyPrivate ;
  ParaLispObject_virttableisBADCopyPrivate  [ TypeGlobalListMemberPLOStatPri ]
    = &  ParaLispObject_isBADCopyPrivate ;
    
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLONil ]
    = &  PLONilCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOSymbol ]
    = &  PLOSymbolCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOCons ]
    = & PLOCons_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOString ]
    = & PLOString_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberBIFPrivate ]
    = &  PLOBIF_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOVector ]
    = & PLOVector_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOChar ]
    = & PLOChar_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOStream ]
    = &  PLOStreamCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOLock ]
    = & PLOLock_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOObject ]
    = & PLOObject_staticCoutToHuman ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOWindowPri ]
    = & PLOWindow_staticCoutToHuman ;
# endif
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOTime ]
    = &  PLOTime_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLODirPri ]
    = & PLODir_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOSignal ]
    = &  PLOSignal_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOEnv ]
    = &  PLOEnv_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOEnvironmentLayer ]
    = &  PLOEnvironmentLayer_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOQuote ]
    = & PLOQuote_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberBackQuotePrivate ]
    = &  PLOBackQuote_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOComma ]
    = &  PLOComma_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  PLOUnQuoteSplicing_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOComplex ]
    = & PLOComplex_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOBoolean ]
    = &  PLOBooleanCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOByteDeque ]
    = & PLOByteDeque_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOSocket ]
    = & PLOSocket_staticCoutToHuman ;
  ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberPLOStatPri ]
    = & PLOStat_staticCoutToHuman ;
    
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLONil ]
    = &  PLONilCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOSymbol ]
    = &  PLOSymbolCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOCons ]
    = & PLOCons_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOString ]
    = & PLOString_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberBIFPrivate ]
    = &  PLOBIF_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOVector ]
    = & PLOVector_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOChar ]
    = & PLOChar_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOStream ]
    = &  PLOStreamCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOLock ]
    = & PLOLock_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOObject ]
    = &  PLOObject_staticCoutToInterpret ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOWindowPri ]
    = & PLOWindow_staticCoutToInterpret ;
# endif
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOTime ]
    = &  PLOTime_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLODirPri ]
    = & PLODir_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOSignal ]
    = &  PLOSignal_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOEnv ]
    = &  PLOEnv_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [
    TypeGlobalListMemberPLOEnvironmentLayer ]
    = &  PLOEnvironmentLayer_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOQuote ]
    = & PLOQuote_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberBackQuotePrivate ]
    = &  PLOBackQuote_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOComma ]
    = &  PLOComma_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [
    TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  PLOUnQuoteSplicing_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOComplex ]
    = & PLOComplex_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOBoolean ]
    = &  PLOBooleanCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOByteDeque ]
    = & PLOByteDeque_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOSocket ]
    = & PLOSocket_staticCoutToInterpret ;
  ParaLispObject_virttableCoutToInterpret  [ TypeGlobalListMemberPLOStatPri ]
    = & PLOStat_staticCoutToInterpret ;  
    
// ! to make an array of true/false , but not a function's
    
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLONil ]
    = &  ParaLispObject_isBADSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOSymbol ]
    = &  ParaLispObject_isBADSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOCons ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOString ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberBIFPrivate ]
    = &  ParaLispObject_isBADSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOVector ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOChar ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOStream ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOLock ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOObject ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOWindowPri ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
# endif
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOTime ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLODirPri ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOSignal ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOEnv ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOEnvironmentLayer ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOQuote ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberBackQuotePrivate ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOComma ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOComplex ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOBoolean ]
    = &  ParaLispObject_isBADSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOByteDeque ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOSocket ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
  ParaLispObject_virttableisOKSetFlagConstFalse  [ TypeGlobalListMemberPLOStatPri ]
    = &  ParaLispObject_isOKSetFlagConstFalse ;
    
ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLONil ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOSymbol ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOCons ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOString ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberBIFPrivate ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOVector ]
    = & PLOVector_staticPushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOChar ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOStream ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOLock ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOObject ]
    = &  ParaLispObject_PushAsNew ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOWindowPri ]
    = & PLOWindow_staticPushAsNew ;
# endif
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOTime ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLODirPri ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOSignal ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOEnv ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOEnvironmentLayer ]
    = &  PLOEnvironmentLayer_staticPushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOQuote ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberBackQuotePrivate ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOComma ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOComplex ]
    = & PLOComplex_staticPushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOBoolean ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOByteDeque ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOSocket ]
    = &  ParaLispObject_PushAsNew ;
  ParaLispObject_virttablePushAsNew  [ TypeGlobalListMemberPLOStatPri ]
    = &  ParaLispObject_PushAsNew ;
    
  // ! to set NULL , when empty ParaLispObject:: used
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLONil ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOSymbol ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOCons ]
    = & PLOCons_staticGCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOString ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberBIFPrivate ]
    = &  PLOBIF_staticGCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOVector ]
    = & PLOVector_staticGCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOChar ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOStream ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOLock ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOObject ]
    = & PLOObject_staticGCDeclareContent ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOWindowPri ]
    = & PLOWindow_staticGCDeclareContent ;
# endif
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOTime ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLODirPri ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOSignal ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOEnv ]
    = &  PLOEnv_staticGCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [
    TypeGlobalListMemberPLOEnvironmentLayer ] = & 
    PLOEnvironmentLayer_staticGCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOQuote ]
    = & PLOQuote_staticGCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberBackQuotePrivate ]
    = &  PLOBackQuote_staticGCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOComma ]
    = &  PLOComma_staticGCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  PLOUnQuoteSplicing_staticGCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOComplex ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOBoolean ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOByteDeque ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOSocket ]
    = &  ParaLispObject_GCDeclareContent ;
  ParaLispObjectvirttableGCDeclareContent  [ TypeGlobalListMemberPLOStatPri ]
    = &  ParaLispObject_GCDeclareContent ;    

  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLONil ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOSymbol ]
    = &  PLOSymbolDeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOCons ]
    = & PLOCons_staticDeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOString ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberBIFPrivate ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOVector ]
    = & PLOVector_staticDeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOChar ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOStream ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOLock ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOObject ]
    = &  ParaLispObject_DeclareForGC ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOWindowPri ]
    = & PLOWindow_staticDeclareForGC ;
# endif
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOTime ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLODirPri ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOSignal ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOEnv ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOEnvironmentLayer ]
    = &  PLOEnvironmentLayer_staticDeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOQuote ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberBackQuotePrivate ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOComma ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOComplex ]
    = & PLOComplex_staticDeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOBoolean ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOByteDeque ]
    = & PLOByteDeque_staticDeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOSocket ]
    = &  ParaLispObject_DeclareForGC ;
  ParaLispObjectvirttableDeclareForGC  [ TypeGlobalListMemberPLOStatPri ]
    = &  ParaLispObject_DeclareForGC ;   
    
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLONil ]
    = &  PLONilClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOSymbol ]
    = &  PLOSymbolClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOCons ]
    = & PLOCons_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOString ]
    = & PLOString_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberBIFPrivate ]
    = &  PLOBIF_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOVector ]
    = & PLOVector_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOChar ]
    = & PLOChar_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOStream ]
    = &  PLOStreamClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOLock ]
    = & PLOLock_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOObject ]
    = & PLOObject_staticClassParents ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOWindowPri ]
    = & PLOWindow_staticClassParents ;
# endif
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOTime ]
    = &  PLOTime_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLODirPri ]
    = & PLODir_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOSignal ]
    = &  PLOSignal_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOEnv ]
    = &  PLOEnv_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOEnvironmentLayer ]
    = &  PLOEnvironmentLayer_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOQuote ]
    = & PLOQuote_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberBackQuotePrivate ]
    = &  PLOBackQuote_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOComma ]
    = &  PLOComma_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  PLOUnQuoteSplicing_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOComplex ]
    = & PLOComplex_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOBoolean ]
    = &  PLOBooleanClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOByteDeque ]
    = & PLOByteDeque_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOSocket ]
    = & PLOSocket_staticClassParents ;
  ParaLispObjectvirttableClassParents  [ TypeGlobalListMemberPLOStatPri ]
    = & PLOStat_staticClassParents ;  
  
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLONil ]
    = &  PLONilClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOSymbol ]
    = &  PLOSymbolClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOCons ]
    = & PLOCons_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOString ]
    = & PLOString_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberBIFPrivate ]
    = &  PLOBIF_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOVector ]
    = & PLOVector_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOChar ]
    = & PLOChar_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOStream ]
    = &  PLOStreamClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOLock ]
    = & PLOLock_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOObject ]
    = & PLOObject_staticClassDef ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOWindowPri ]
    = & PLOWindow_staticClassDef ;
# endif
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOTime ]
    = &  PLOTime_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLODirPri ]
    = & PLODir_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOSignal ]
    = &  PLOSignal_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOEnv ]
    = &  PLOEnv_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOEnvironmentLayer ]
    = &  PLOEnvironmentLayer_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOQuote ]
    = & PLOQuote_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberBackQuotePrivate ]
    = &  PLOBackQuote_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOComma ]
    = &  PLOComma_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  PLOUnQuoteSplicing_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOComplex ]
    = & PLOComplex_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOBoolean ]
    = &  PLOBooleanClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOByteDeque ]
    = & PLOByteDeque_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOSocket ]
    = & PLOSocket_staticClassDef ;
  ParaLispObjectvirttableClassDef  [ TypeGlobalListMemberPLOStatPri ]
    = & PLOStat_staticClassDef ;   
  
// ! dont virtual => to make check for type : Object      

  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLONil ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOSymbol ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOCons ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOString ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberBIFPrivate ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOVector ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOChar ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOStream ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOLock ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOObject ]
    = & PLOObject_staticContext ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOWindowPri ]
    = &  ParaLispObject_Context ;
# endif
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOTime ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLODirPri ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOSignal ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOEnv ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOEnvironmentLayer ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOQuote ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberBackQuotePrivate ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOComma ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOComplex ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOBoolean ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOByteDeque ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOSocket ]
    = &  ParaLispObject_Context ;
  ParaLispObjectvirttableContext  [ TypeGlobalListMemberPLOStatPri ]
    = &  ParaLispObject_Context ;   
    
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLONil ]
    = &  PLONilTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOSymbol ]
    = &  PLOSymbolTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOCons ]
    = & PLOCons_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOString ]
    = & PLOString_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberBIFPrivate ]
    = &  PLOBIF_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOVector ]
    = & PLOVector_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOChar ]
    = & PLOChar_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOStream ]
    = &  PLOStreamTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOLock ]
    = & PLOLock_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOObject ]
    = & PLOObject_staticTypeOf ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOWindowPri ]
    = & PLOWindow_staticTypeOf ;
# endif
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOTime ]
    = &  PLOTime_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLODirPri ]
    = & PLODir_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOSignal ]
    = &  PLOSignal_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOEnv ]
    = &  PLOEnv_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOEnvironmentLayer ]
    = &  PLOEnvironmentLayer_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOQuote ]
    = & PLOQuote_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberBackQuotePrivate ]
    = &  PLOBackQuote_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOComma ]
    = &  PLOComma_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOUnquoteSplicing ]
    = &  PLOUnQuoteSplicing_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOComplex ]
    = & PLOComplex_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOBoolean ]
    = &  PLOBooleanTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOByteDeque ] = & PLOByteDeque_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOSocket ] = & PLOSocket_staticTypeOf ;
  ParaLispObjectvirttableTypeOf  [ TypeGlobalListMemberPLOStatPri ] = & PLOStat_staticTypeOf ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLONil ] = &  PLONilDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOSymbol ] = &  PLOSymbolstaticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOCons ] = & PLOCons_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOString ] = & PLOString_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberBIFPrivate ] = &  PLOBIF_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOVector ] = & PLOVector_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOChar ] = & PLOChar_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOStream ] = &  PLOStreamDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOLock ] = & PLOLock_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOObject ] = & PLOObject_staticDestr ;
# ifndef LISP2D_DONTUSEX11        
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOWindowPri ] = & PLOWindow_staticDestr ;
# endif
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOTime ] = &  PLOTime_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLODirPri ] = & PLODir_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOSignal ] = & PLOSignal_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOEnv ] = &  PLOEnv_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOEnvironmentLayer ] = &  PLOEnvironmentLayer_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOQuote ] = & PLOQuote_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberBackQuotePrivate ] = &  PLOBackQuote_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOComma ] = &  PLOComma_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOUnquoteSplicing ] = &  PLOUnQuoteSplicing_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOComplex ] = & PLOComplex_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOBoolean ] = &  PLOBooleanDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOByteDeque ] = & PLOByteDeque_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOSocket ] = & PLOSocket_staticDestr ;
  ParaLispObjectvirttableDestr  [ TypeGlobalListMemberPLOStatPri ] = & PLOStat_staticDestr ;
    
}
# include "stat/inline.h"
# include "socket/inline.h"
