// (C)2019-23 Lisp2D WideString
# include "widestring.h"

LISP2DSTRINGADDCHAR ( WideChar , wchar_t , L'\00' )

LISP2DSTRINGCONSTRCSTR  ( WideChar , wchar_t , volatile , wcslen )
LISP2DSTRINGCONSTRCOPY  ( WideChar )
LISP2DSTRINGCONSTRMOVE( WideChar )
LISP2DSTRINGCONSTRCSTRMEMSIZE ( WideChar , wchar_t , volatile )
LISP2DSTRINGDESTR ( WideChar  )
LISP2DSTRINGADDSTRING ( WideChar , wchar_t , L'\00' )

LISP2DSTRINGADDCHARARRAY  ( WideChar , wchar_t , volatile , wcslen )

LISP2DSTRINGSETARRAY  ( WideChar , wchar_t , volatile , wcslen )

# include "cast.h"

// wchar_t const* -> string
bool  isBADReadWStringToCString ( String  ( WideChar  ) const * const x  , String ( Char ) * const y  ) {
  StringClear ( Char ) ( y ) ;
  for ( wchar_t volatile const * j = StringCStr ( WideChar ) ( x ) ; * j ; ++  j ) {
    if  ( ( * j )  < 0  )
      return   true   ;
    if  ( ( * j )  < 0x80 )  {
      String_AddChar ( Char )  ( y , wchar_cast_char ( * j ) ) ;
      continue  ; 
    }
    if((*j)  < 0x800)
      String_AddChar ( Char ) ( y , uint_cast_char(0xc0U bitor ((wchar_cast_uint(*j)) >>  6)));
    else{
      if((*j)  < 0x10000)
        String_AddChar ( Char ) ( y ,
          uint_cast_char(0xe0U bitor ((wchar_cast_uint(*j)) >>  12)));
      else{
        if((*j)  < 0x200000)
          String_AddChar ( Char ) ( y ,
            uint_cast_char(0xf0U bitor ((wchar_cast_uint(*j)) >>  18)));
        else{
          if((*j)  < 0x4000000)
            String_AddChar ( Char ) ( y ,
              uint_cast_char(0xf8U bitor ((wchar_cast_uint(*j)) >>  24)));
          else{
            String_AddChar ( Char ) ( y ,
              uint_cast_char(0xfcU bitor ((wchar_cast_uint(*j)) >>  30)));
            String_AddChar ( Char ) ( y ,
              uint_cast_char(0x80U bitor (((wchar_cast_uint(*j)) >>  24) bitand 0x3fU)));
          }
          // not(i  < 0x4000000U)
          String_AddChar ( Char ) ( y ,
            uint_cast_char(0x80U bitor (((wchar_cast_uint(*j)) >>  18) bitand 0x3fU)));
        }
        // not(i  < 0x200000U)
        String_AddChar ( Char ) ( y ,
          uint_cast_char(0x80U bitor (((wchar_cast_uint(*j)) >>  12) bitand 0x3fU)));
      } // not(i  < 0x10000U)
      String_AddChar ( Char ) ( y ,
        uint_cast_char(0x80U bitor (((wchar_cast_uint(*j)) >>  6)  bitand 0x3fU)));
    } // not(i  < 0x800U)
    String_AddChar ( Char ) ( y ,
      uint_cast_char(0x80U bitor ((wchar_cast_uint(*j)) bitand  0x3fU)));    
  } // for
  return  false;
}
  
LISP2DSTRINGRESIZE  ( WideChar , wchar_t volatile , L'\00' )

LISP2DSTRINGCLEAR ( WideChar , L'\00' )

# include "stack/public.h"
# include "stack/enum.h"

String ( WideChar ) * StackNew_StringWideChar ( void  ) {
  return  Lisp2D_StackVar ( Lisp2DStackTypeStringWideChar ) ;
}

# include "castb.h"
# include "widestring/inline.h"
LISP2DSTRINGCARR ( WideChar , wchar_t  , PArray_wchar_c )
LISP2DSTRINGCEND  ( WideChar , wchar_t volatile )
LISP2DSTRINGCONSTRFILLCHAR  ( WideChar , wchar_t volatile )
LISP2DSTRINGSWAP  ( WideChar )
LISP2DSTRINGREPLACE ( WideChar , wchar_t )
LISP2DSTRINGREPLACECHARS  ( WideChar , wchar_t , volatile )
