// Window
// 2023
# ifndef  LISP2D_DONTUSEX11

# include "condit.h"
# include "mutex2/type.h"
# include "mutex2/struct.h"
# include "mutex2/public.h"
# include "window.h"

LISP2D_CONDIT  ( Lisp2DsignalWindowsExit ) 
LISP2D_MUTEX2  ( Lisp2DmutexWindowsExit  ) 

pthread_mutex_t Lisp2DmutexXDisplay2 = PTHREAD_MUTEX_INITIALIZER ;

pthread_mutex_t Lisp2DmutexCX11 = PTHREAD_MUTEX_INITIALIZER ;
bool  Lisp2DflagMainWaitWindows = false ;
# include "define.h"
# ifdef  LISP2D_CONSTRSTAT
# define  PLOWindow_constrstat  PLOWindow_constrstat_pub  
_Atomic ( size_t  ) PLOWindow_constrstat = 0 ;

size_t  PLOWindow_constrstatValue ( void  ) {
  return  PLOWindow_constrstat  ;
}

void  PLOWindow_constrstatInc ( void  ) {
  ++  PLOWindow_constrstat  ;
}
# undef PLOWindow_constrstat

# endif // LISP2D_CONSTRSTAT

IsNotTypeTemplBody  ( window , TypeGlobalListMemberPLOWindowPri )

// longint -> r:n/m, g:n/m,b:n/m

oLoadColor LoadColor  (iLoadColor const arg) {
  oLoadColor  result  ;
  switch(arg.coldep){
  case  24:
    // 8 8 8
    { unsigned  int const den = (1 << 8) - 1 ;
      result.rd = den;
      result.gd = den;
      result.bd = den;
      result.rn  =  (((arg.colors )  >>  (8 + 8)) bitand den);
      result.gn  = (((arg.colors )  >>  8) bitand den);
      result.bn  = ((arg.colors ) bitand den);
    }
    result.isBAD = false ;
    break;
  case  16:
    // 5 6 5
    { unsigned  int const den = (1 << 5) - 1;
      unsigned  int const deng = (1 << 6) - 1 ;
      result.rd=den;
      result.gd=deng;
      result.bd=den;
      result.rn  = ( ((arg.colors )  >>  (6 + 5)) bitand den);
      result.gn  = (((arg.colors )  >>  5) bitand deng);
      result.bn  = ((arg.colors ) bitand den);
    }
    result.isBAD = false ;
    break;
  case  8:
    // 3 3 2
    { unsigned  int const denrg = (1  << 3) - 1;
      unsigned  int const denb = (1 << 2) - 1;
      result.rd=denrg;
      result.gd=denrg;
      result.bd=denb;
      result.rn  = ( ((arg.colors )  >>  (3 + 2)) bitand denrg);
      result.gn  = ( ((arg.colors )  >>  2) bitand denrg);
      result.bn  = ((arg.colors ) bitand denb);
    }
    result.isBAD = false ;
    break;
  // 1 =  
  // 4 =  
  // 12 = 4 4 4    
  // 15 = 5 5 5 
  // 18 = 6 6 6 
  // 30 = 10 10 10 
  // 32 =   
  // 36 = 12 12 12
  // 48 = 16 16 16
  default:
    result.isBAD = true ;
  }
  return  result;
}

// longint -> r:0-255, g:0-255,b:0-255
// ! UChar -> Byte
bool  isBADLoadColor(unsigned long int const colors,  tUCharRGB * const uc, int const coldep){
  switch(coldep){
  case  24:
    // 8 8 8
    { unsigned  int const den= (1 << 8) - 1;
      uc->r = (((colors )  >>  (8 + 8)) bitand den);
      uc->g = (((colors )  >>  8) bitand den);
      uc->b =  ((colors ) bitand den);
    }
    return  false;
  case  16:
    // 5 6 5
    { unsigned  int const den = (1 << 5) - 1;
      unsigned  int const deng = (1 << 6) - 1;
      uc->r = ((((colors )  >>  (6 + 5)) bitand den) <<        (8 - 5));
      uc->g = ((((colors )  >>  5) bitand deng) <<        (8 - 6));
      uc->b = (((colors ) bitand den) << (8 - 5));
    }
    return  false;
  case  8:
    // 3 3 2
    { unsigned  int const denrg = (1  << 3) - 1;
      unsigned  int const denb = (1 << 2) - 1;
      uc->r = ((((colors )  >>  (3 + 2)) bitand denrg)        <<  (8  - 3));
      uc->g = ((((colors )  >>  2) bitand denrg) <<        (8  - 3));
      uc->b = (((colors ) bitand denb) <<  (8  - 2));
    }
    return  false;    
  // 1 =
  // 4 =  
  // 12 = 4 4 4  
  // 15 = 5 5 5 
  // 18 = 6 6 6 
  // 30 = 10 10 10 
  // 32 =  
  // 36 = 12 12 12
  // 48 = 16 16 16
  default: 
    return  true;
  }
}
    
_Atomic ( size_t  ) countWindowsThreads2 = 0 ;

size_t  CountWindowsThreads2(void){
  return  countWindowsThreads2  ;
}

void  CountWindowsThreads2_Dec(void){
  --  countWindowsThreads2  ;
}

void  CountWindowsThreads2_Inc(void){
  ++  countWindowsThreads2  ;
}

# include "globallistp/struct.h"

GlobalList  GlobalListOfWindows ;
GlobalList  GlobalListOfWindowsGarbage  ;

# include "window/public.h"
# include "window/private.h"

void  PLOWindow_Create  ( PLOWindow * const w , UIntXY const wh ) {
  PLOWindow_NewMap ( PLOWindow_to_pri ( w ) , wh ) ;
  PLOWindow_priv_CreateThread ( PLOWindow_to_pri(w) , wh ) ;
}

# include "cast.h"

void PLOWindow_NewMap ( PLOWindow_pri * const me ,UIntXY const wh)  {
  VectorClear(UnsLongInt)(&me->cmatrixpixel );
  Vector_ResizeFill(UnsLongInt)(&me->cmatrixpixel , uint_cast_size(wh.x) * uint_cast_size(wh.y),0);
  me->matrixsizew = wh.x;
  me->matrixsizeh = wh.y;
}

/*
 * This function chooses the "more desirable" of two input styles.  The
 * style with the more complicated Preedit style is returned, and if the
 * styles have the same Preedit styles, then the style with the more
 * complicated Status style is returned.  There is no "official" way to
 * order interaction styles.  This one makes the most sense to me.
 * This is a long procedure for a simple heuristic.
 */

XIMStyle ChooseBetterStyle  ( XIMStyle style1 , XIMStyle style2 ) {
  XIMStyle preedit = XIMPreeditArea | XIMPreeditCallbacks |
    XIMPreeditPosition | XIMPreeditNothing | XIMPreeditNone ;
  XIMStyle status = XIMStatusArea | XIMStatusCallbacks |
    XIMStatusNothing | XIMStatusNone  ;
  if (style1 == 0)
    return style2;
  if (style2 == 0)
    return style1;
  if ((style1 & (preedit | status)) == (style2 & (preedit | status)))
    return style1;
  XIMStyle s = style1 & preedit;
  XIMStyle t = style2 & preedit;
    if (s != t) {
        if (s | t | XIMPreeditCallbacks)
            return (s == XIMPreeditCallbacks)?style1:style2;
        if (s | t | XIMPreeditPosition)
            return (s == XIMPreeditPosition)?style1:style2;
        if (s | t | XIMPreeditArea)
            return (s == XIMPreeditArea)?style1:style2;
        if (s | t | XIMPreeditNothing)
            return (s == XIMPreeditNothing)?style1:style2;
    } else { /* if preedit flags are the same, compare status flags */
        s = style1 & status;
        t = style2 & status;
        if (s | t | XIMStatusCallbacks)
            return (s == XIMStatusCallbacks)?style1:style2;
        if (s | t | XIMStatusArea)
            return (s == XIMStatusArea)?style1:style2;
        if (s | t | XIMStatusNothing)
            return (s == XIMStatusNothing)?style1:style2;
    }
  // ? clang depend
  return style1 ;  
}

# include "errorstra.h"
# include <errno.h>

// ? (unsigned int const *,unsigned  int const *)
// ! rename: bool isBADCreateThread
void  PLOWindow_priv_CreateThread ( PLOWindow_pri * const me , UIntXY const wh ) {
  if  ( not  ( me -> dpy ) ){
    ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
      L"PLOWindow::CreateThread(): cannot connect to X server"});
    return;
  }
  { { XSetWindowAttributes  myatt ;
      myatt.background_pixel  = 0;
      myatt.bit_gravity = NorthWestGravity;
      XLockDisplay(me -> dpy);
      me -> win = XCreateWindow(me -> dpy,DefaultRootWindow(me -> dpy),0,0,wh.x,wh.y,
        0,CopyFromParent,CopyFromParent,
        CopyFromParent,CWBackPixel bitor CWBitGravity,&  myatt);
    }
    { int const defscr = DefaultScreen(me -> dpy) ;
      { unsigned  long  const  blapix = BlackPixel(me -> dpy,defscr) ;
    XSetWindowBackground(me -> dpy,me -> win,blapix);
    { XGCValues xgcvalues;
      xgcvalues.foreground  = WhitePixel(me -> dpy,defscr);
      xgcvalues.background  = blapix;
      XSelectInput(me -> dpy,me -> win,PLOWindow_alleventmask);
      me -> gc  = XCreateGC(me -> dpy, me -> win,GCForeground bitor GCBackground, & xgcvalues);
    }
    } // blapix
    XMapWindow(me -> dpy, me -> win);
    // I support the WM_DELETE_WINDOW protocol
    me -> wmDeleteMessage = XInternAtom(me -> dpy,"WM_DELETE_WINDOW",false);
    XSetWMProtocols(me -> dpy,me -> win,& me -> wmDeleteMessage,1);
    XFlush(me -> dpy);
    XWindowAttributes wa;
    XGetWindowAttributes(me -> dpy,me -> win,&  wa);
    me -> winwidth  = (wa.width);
    me -> winheight = (wa.height);
    XEvent  event2;
    XWindowEvent(me -> dpy,me -> win,PLOWindow_alleventmask,&  event2);
    me -> colordefaultdepth = DefaultDepth  ( me -> dpy , defscr  ) ;
    // virtual machine has 16
    // 24
    { unsigned  long  int colorxy ;
    for(int  ix=event2.xexpose.width - 1;ix >=  0;--  ix)
      for(int  iy=event2.xexpose.height  - 1;iy >=  0;--  iy) {
        int const ix2=event2.xexpose.x + ix;
        int const iy2=event2.xexpose.y  + iy;
        if(not  PLOWindow_isOKOSColor2( & me -> pub ,(IntXY){ix2,iy2},&colorxy))
          colorxy = 0 ;
        XSetForeground(me -> dpy,me -> gc,colorxy );
        XDrawPoint(me -> dpy,me -> win,me -> gc,event2.xexpose.x  + ix, event2.xexpose.y + iy);
      } // ix iy
    } // colorxy
    } // defscr
    XFlush(me -> dpy);
// !! to make flag for X11 that string is UTF-8
    XChangeProperty(me -> dpy, me -> win,
      XInternAtom(me -> dpy, "_NET_WM_NAME", false),
      XInternAtom(me ->dpy, "UTF8_STRING", false),
      8, PropModeReplace, charcp_cast_ucharcp(StringCStr(Char)(&me -> cmynameutf8)),
      size_cast_int(strlen(StringCStr(Char)(&me -> cmynameutf8))));
     XFlush(me -> dpy);
// !? how to remove pointer
  }
  me -> opened  = true;
  me -> flagclose = false;
  XIM im;
/*
     * Connect to an input method.
     * In this example, we don't pass a resource database
     */
  // sometimes chash  without manual lock
  pthread_mutex_lock  ( & Lisp2DmutexCX11 ) ;
  if ((im = XOpenIM(me -> dpy, NULL, NULL, NULL)) == NULL) {
    pthread_mutex_unlock  ( & Lisp2DmutexCX11 ) ;  
// !? how to fix crash sometime
    XUnlockDisplay(me -> dpy);
    ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
      L"PLOWindow::CreateThread:XOpenIM"});
    goto Exit ;
  }
  pthread_mutex_unlock  ( & Lisp2DmutexCX11 ) ;  
  XUnlockDisplay(me -> dpy);
  XIMStyles * im_supported_styles;
   /* figure out which styles the IM can support */
  pthread_mutex_lock  ( & Lisp2DmutexCX11 ) ;  
  XGetIMValues(im, XNQueryInputStyle, & im_supported_styles, (void*)0 );
    /* set flags for the styles our application can support */
  /*XIMStyle app_supported_styles = XIMPreeditNone | XIMPreeditNothing | XIMPreeditArea;
  app_supported_styles |= XIMStatusNone | XIMStatusNothing | XIMStatusArea;*/
  /*
     * now look at each of the IM supported styles, and
     * chose the "best" one that we can support.
     */
  {XIMStyle best_style = 0;
  for(int i = 0; i < im_supported_styles->count_styles; i ++) {
    XIMStyle style = im_supported_styles->supported_styles[i];
    /* set flags for the styles our application can support */
    XIMStyle app_supported_styles = XIMPreeditNone | XIMPreeditNothing |
      XIMPreeditArea | XIMStatusNone | XIMStatusNothing | XIMStatusArea ;
    if ((style & app_supported_styles) == style) /* if we can handle it */
      best_style = ChooseBetterStyle(style, best_style); }
    /* if we couldn't support any of them, print an error and exit */
  if (best_style == 0) {
    ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
      L"PLOWindow::CreateThread:best_style == 0"});
    pthread_mutex_unlock  ( & Lisp2DmutexCX11 ) ;  
    goto Exit ;
  }
  XFree(im_supported_styles);
  /*
     * Now go create an IC using the style we chose.
     * Also set the window and fontset attributes now.
     */
    { XFontSet fontset = (void*)0 ;
      XVaNestedList list = XVaCreateNestedList(0, XNFontSet, fontset, (void*)0);
      me -> xic = XCreateIC(im, XNInputStyle, best_style, XNClientWindow, me -> win,
        XNPreeditAttributes, list, XNStatusAttributes, list, (void*)0);
      XFree(list);
    }
  }
  if (me -> xic == NULL) {
    ErrorStra  ((PArray_wchar_c){(wchar_t const (*)[])&
      L"PLOWindow::CreateThread:XCreateIC -> NULL"  }) ;
    pthread_mutex_unlock  ( & Lisp2DmutexCX11 ) ;  
    goto Exit ;
  }
  pthread_mutex_unlock  ( & Lisp2DmutexCX11 ) ;  
  { pthread_t thread ;
    //  pass argument me as Window Private
    int pci = pthread_create ( & thread, 0 , pthWindow, me ) ;
  if ( pci ) {
    if ( pci == EAGAIN ) {
      ErrorStra(
        (PArray_wchar_c){(wchar_t const (*)[])&
          L"PLOWindow_priv_CreateThread:pthread_create:"
          L"Insufficient resources to create another thread"});
      return ;
    }
    if ( pci == EINVAL ) {
      ErrorStra(
        (PArray_wchar_c){(wchar_t const (*)[])&
          L"PLOWindow_priv_CreateThread:pthread_create:"
          L"Invalid settings in attr"});
      return ;
    }
    if ( pci == EPERM ) {
      ErrorStra(
        (PArray_wchar_c){(wchar_t const (*)[])&
          L"PLOWindow_priv_CreateThread:pthread_create:"
          L"No permission to set the scheduling policy and parameters specified in attr"});
      return ;
    }
    ErrorStra(
      (PArray_wchar_c){(wchar_t const (*)[])&
        L"PLOWindow_priv_CreateThread:pthread_create:?"});
      return ;
  }
  pci = pthread_detach ( thread ) ;
  if ( pci ) {
    if ( pci == EINVAL ) {
      ErrorStra (
        (PArray_wchar_c){(wchar_t const (*)[])&
          L"PLOWindow_priv_CreateThread:pthread_detach:"
          L"thread is not a joinable thread"});
      return ;
    }
    if ( pci == ESRCH ) {
      ErrorStra (
        (PArray_wchar_c){(wchar_t const (*)[])&
          L"PLOWindow_priv_CreateThread:pthread_detach:"
          L"No thread with the ID thread could be found"});
      return ;
    }
    ErrorStra (
      (PArray_wchar_c){(wchar_t const (*)[])&
        L"PLOWindow_priv_CreateThread:pthread_detach:?"});
      return ;
  }
  }
  // join not needed
  me -> boolHaveThread  = true;
  CountWindowsThreads2_Inc();
Exit  : ;
}
   
bool  PLOWindow_Open(PLOWindow * const me) {
  PLOWindow_pri * const mep = PLOWindow_to_pri(me);
  if(mep->opened)
    return  false;
// ! to check for w<=limit(uint):max
  unsigned  int const width =size_cast_uint(mep->matrixsizew);
  if(width  ==  0)  
    return  false;
  unsigned  int  height=0;
  for(unsigned  int  i=0;i  < width;++  i) {
// ! to check for h<=limit(uint):max    
    unsigned  int const s=size_cast_uint(mep->matrixsizeh);
    if(s  > height) 
      height  = s;
  }
  if(height ==  0)  
    return  false;
  PLOWindow_priv_CreateThread(mep,(UIntXY){width,height});
  return  true;
}
   
// ! ..(signed int const * , ..
bool  PLOWindow_isOKOSColor2  ( PLOWindow const * const me , IntXY const xy ,
  unsigned  long  int * const resultp ) {
  PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me ) ;
  if((xy.x < 0)  or  (int_cast_uint( xy.x) >= mep-> matrixsizew))
    return  false;
  if((xy.y < 0)  or  (int_cast_uint(xy.y) >= mep-> matrixsizeh))
    return  false;
  (*resultp) = VectorAtCopy(UnsLongInt)(&mep->cmatrixpixel ,
    (int_cast_size (xy.x)  * mep->matrixsizeh) + int_cast_size(xy.y));
  return  true;
}

# include "stcl/public.h"
# include "stcl/inline.h"

// window close
TaskForThread Lisp2Dbimwindowclose2 ( StackClusterPrivate * const stclpp  ) {
  PLOWindow * const w = ParaLispObjectToPLOWindow (
    StackClusterPrivate_ThisTop ( stclpp ) ) ;
  PLOWindow_Close ( w ) ;
  StackClusterPrivate_SetResult ( stclpp , PLOWindow_plo( w) ) ;
  return  TaskForThread_Analyse ;
}

void  PLOWindow_Destr ( PLOWindow_pri * const me ) {
  if ( me -> dpy ) {
    pthread_mutex_lock  ( & Lisp2DmutexXDisplay2  ) ;
    XCloseDisplay(me -> dpy);
    pthread_mutex_unlock  ( & Lisp2DmutexXDisplay2  ) ;
  }
  //me -> wmDeleteMessage . ~ Atom ( ) ;
  //me -> xic . ~ XIC ( ) ;
  pthread_mutex_destroy ( & me -> mutexQueueStClWaitEvent2  ) ;
  QueueDestructor ( VoidP ) ( & me -> queueStClPWaitEventC . pub )  ;
  QueueDestructor ( VoidP ) ( & me -> queueEventsC . pub )  ;
  //me -> colordefaultdepth . ~ Lisp2DInt ( ) ;
  //me -> event . ~ XEvent ( ) ;
  StringDestr ( Char  ) ( & ( me -> cmynameutf8 ) ) ;
  StringDestr ( WideChar  ) ( & ( me  ->  cmyname ) ) ;
  Vector_Destr  ( UnsLongInt  ) ( & me -> cmatrixpixel  ) ;
  //me -> gc . ~ GC ( ) ;
  //me -> win . ~ Window ( ) ;
  ParaLispObject_staticDestr(&me -> plo);
}

void PLOWindow_Hide(PLOWindow_pri * const me ) {
  if(me->boolHaveThread and me->dpy){
    
// !! Thread -> taskHide, GlobalListWindows.Remove, CloseWin, exit
    
    XLockDisplay(me->dpy);
    me->opened  = false;
    me->flagclose = true;
    me->event.type  = Expose;
# ifndef LISP2D_DEBUG
    XSendEvent(me->dpy,me->win,false,PLOWindow_alleventmask,&  me->event);
# else
    if(XSendEvent(me->dpy,me->win,false,PLOWindow_alleventmask,& me->event)  ==  0){
      ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
        L"PLOWindow::Hide: XSendEvent=0"});
    }
# endif
    XFlush(me->dpy);
    XUnlockDisplay(me->dpy);
  }
}
  
void  PLOWindow_Close ( PLOWindow * const me  ) {
  PLOWindow_pri * const mep = PLOWindow_to_pri ( me ) ;
  PLOWindow_Hide  ( mep ) ;
  VectorClear(UnsLongInt)(&mep->cmatrixpixel );
  mep -> matrixsizeh  = 0 ;
  mep -> matrixsizew = 0 ;
}

// window wait-event
TaskForThread Lisp2Dbimwindowwaitevent2(StackClusterPrivate * const  stclpp){
  if  ( StackClusterPrivate_ClearflagCont ( stclpp ) )
    // thread push event to result
    return  TaskForThread_Analyse;
  PLOWindow * const mep  = ParaLispObjectToPLOWindow ( StackClusterPrivate_ThisTop ( stclpp )  )  ;
  ParaLispObject  * ev  ;
  if(PLOWindow_isBADTryToGetEvent(mep,&ev)) {
    // target window in ThisTop
    StackClusterPrivate_setTaskForManager ( stclpp , TaskWinWaitEvent ) ;
    StackClusterPrivate_SetflagCont ( stclpp , 1U  ) ;
    return  TaskForThread_Analyse;
  }
  StackClusterPrivate_SetResult(stclpp ,  ev);
  return  TaskForThread_Analyse;
}

# include "nilc.h"

// window check-event
TaskForThread Lisp2Dbimwindowcheckevent2(StackClusterPrivate  * const stclpp){
  ParaLispObject  * ev;
  StackClusterPrivate_SetResult ( stclpp , PLOWindow_isBADTryToGetEvent  ( ParaLispObjectToPLOWindow (
        StackClusterPrivate_ThisTop ( stclpp ) ) , & ev  ) ?
    & plonil  . plo  :
    ev ) ;
  return  TaskForThread_Analyse ; 
}

# include "sharedc.h"
# include "shared/inline.h"

// ! to return bool isBAD...
void  PLOWindow_MakeEvent(PLOWindow * const me , ParaLispObject * const evp ) {
  PLOWindow_pri * const mep = PLOWindow_to_pri ( me ) ;
  if  ( pthread_mutex_lock  ( & mep -> mutexQueueStClWaitEvent2 ) ) {
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
      L"PLOWindow_MakeEvent:"
      L"pthread_mutex_lock  ( & mep -> mutexQueueStClWaitEvent2 )" ; 
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
  }
  { void  * stclfirstp ;
    if  ( not QueueIsBadPop ( VoidP ) ( & mep -> queueStClPWaitEventC . pub , & stclfirstp ) ) {
      if  ( pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 ) ) {
        Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
          L"PLOWindow_MakeEvent:"
          L"pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 )" ; 
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
      }
      StackClusterPrivate * const stclfirstp2 = stclfirstp ;
// ! to use stclfirstp2
      StackClusterPrivate_SetResult ( stclfirstp2 , evp  ) ;
      StackClusterPrivate_setTaskForManager (
        (StackClusterPrivate*) stclfirstp  , TaskRun ) ;
      TaskQueuePush ( (StackClusterPrivate*) stclfirstp ) ;
      Mutex2Lock ( & Lisp2Dmutex2ManagerTasks ) ;
      if  ( flagManagerWaitSignal ) {
        flagManagerWaitSignal  = false  ;
        jmp_buf jb2 ;
        jmp_buf * const oldjb = Lisp2DJBglobal  ;
        Lisp2DJBglobal  = & jb2 ;
        int const volatile jbn = setjmp  ( jb2  ) ;
        if  ( jbn  ) {
          Lisp2DJBglobal  = oldjb ;
          Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
          longjmp ( * Lisp2DJBglobal  , jbn ) ;
        }
        ConditionSignal ( & Lisp2DsignalManager ) ;
        Lisp2DJBglobal  = oldjb ;        
      }
      Mutex2Unlock  ( & Lisp2Dmutex2ManagerTasks ) ;
    } else {
      QueueIsBadPushByValue(VoidP) ( & mep -> queueEventsC . pub , evp ) ;
      if  ( pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 ) ) {
        Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
          L"PLOWindow_MakeEvent:"
          L"pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 )" ; 
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
      }
    }
  }
}
        
# include "cons/public.h"        
        
// window make-event x
TaskForThread Lisp2Dbimwindowmakeevent2(StackClusterPrivate * const stclpp){
  PLOWindow * const mep = ParaLispObjectToPLOWindow(
    StackClusterPrivate_ThisTop(stclpp )) ;
  ParaLispObject  * const xp =  CCAR  ( StackClusterPrivate_ArgTop(stclpp ));
  PLOWindow_MakeEvent ( mep  , xp ) ;
  StackClusterPrivate_SetResult(stclpp , xp );
  return  TaskForThread_Analyse;
}
      
void  PLOWindow_Pending ( PLOWindow_pri * const me , size_t * const resp ) {
  if  ( pthread_mutex_lock  ( & me -> mutexQueueStClWaitEvent2 ) ) {
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
      L"PLOWindow_Pending:"
      L"pthread_mutex_lock  ( & me -> mutexQueueStClWaitEvent2 )" ; 
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
  }
  * resp = QueueSize  ( VoidP ) ( & me -> queueEventsC . pub ) ;
  if  ( pthread_mutex_unlock  ( & me -> mutexQueueStClWaitEvent2 ) ) {
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
      L"PLOWindow_Pending:"
      L"pthread_mutex_unlock  ( & me -> mutexQueueStClWaitEvent2 )" ; 
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
  }
}
      
# include "string/public.h"      
# include "string/struct.h"
      
// thread manager calls this task  
bool  PLOWindow_isBADEventQueueLockPop ( PLOWindow * const me ,
  StackClusterPrivate  * const stclp ) {
  PLOWindow_pri * const mep = PLOWindow_to_pri ( me ) ;
  if  ( pthread_mutex_lock  ( & mep -> mutexQueueStClWaitEvent2 ) ) {
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
      L"PLOWindow_isBADEventQueueLockPop:"
      L"pthread_mutex_lock  ( & mep -> mutexQueueStClWaitEvent2 )" ; 
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
  }
  { void  * res ;
    if  ( QueueIsBadPop ( VoidP ) ( & mep -> queueEventsC . pub, & res ) ) {
      if( QueueIsBadPushByValue ( VoidP ) (
        & mep -> queueStClPWaitEventC . pub , stclp ) ) {
        if  ( pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 ) ) {
          Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
            L"PLOWindow_isBADEventQueueLockPop:"
            L"pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 )" ; 
          longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
        }
        StackClusterPrivate_ExceptionSet(stclp ,&PLOString_NewCopy(
          L"PLOWindow::isBADEventQueueLockPop:queueStClWaitEvent.Push2")->plo);
        // false - to exit from window::waitevent with exception
        return  false;
      }
      // first to make task, then to release lock
      if  ( pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 ) ) {
        Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
          L"PLOWindow_isBADEventQueueLockPop:"
          L"pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 )" ; 
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
      }
      return  true;
    }
    StackClusterPrivate_SetResult (stclp , ( ParaLispObject  * ) ( res ) ) ;
  }  // res
  // res is good
  if  ( pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 ) ) {
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
      L"PLOWindow_isBADEventQueueLockPop:"
      L"pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 )" ; 
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
  }
  return  false;
}
      
# include "plostream/public.h" 
      
void  PLOWindow_staticCoutToInterpret ( ParaLispObject const * const me 
# ifndef  LISP2D_DEBUG
  __attribute__((unused))
# endif
  , PLOStream  const * const s , bool _1 __attribute__((unused))  ,
  Vector(StackPLOP)  * _2  __attribute__((unused)) ) {
  PLOStreamPushWideCharArray  ( s ,
    (PArray_wchar_c) { (wchar_t const(*)[])&L"Window"});
# ifdef  LISP2D_DEBUG
  PLOWindow const * const mew = ParaLispObjectToPLOWindowConst(me);
  PLOWindow_pri const * const mewp = PLOWindow_to_cpri ( mew ) ;
  size_t  const   mps=VectorSizeCopy(UnsLongInt)(&mewp->cmatrixpixel );  
  PLOStreamPushWideCharArray  ( s ,
    (PArray_wchar_c) { (wchar_t const(*)[])&L" flagclose="});
  PLOStreamPushWideCharArray  ( s ,
    (PArray_wchar_c) { (mewp->flagclose  ?(wchar_t const(*)[])&L"true"  :
      (wchar_t const(*)[])&L"false")});
  PLOStreamPushWideCharArray  ( s ,
    (PArray_wchar_c) { (wchar_t const(*)[])&L" opened="});
  PLOStreamPushWideCharArray  ( s ,
    (PArray_wchar_c) { (mewp->opened  ?(wchar_t const(*)[])&L"true"  :
      (wchar_t const(*)[])&L"false")});
  PLOStreamPushWideCharArray  ( s ,
    (PArray_wchar_c) { (wchar_t const(*)[])&L" winwidth="});
  PLOStreamPushInt(s, mewp->winwidth);
  PLOStreamPushWideCharArray  ( s ,
    (PArray_wchar_c) { (wchar_t const(*)[])&L" winheight="});
  PLOStreamPushInt(s, mewp->winheight);
  PLOStreamPushWideCharArray  ( s ,
    (PArray_wchar_c) { (wchar_t const(*)[])&L" matrixpixel.size()="});
  PLOStreamPushUSize(s ,mps);
  PLOStreamPushWideCharArray  ( s ,
    (PArray_wchar_c) { (wchar_t const(*)[])&L" myname="});
  PLOStreamPushWideCharArray  ( s ,
    (PArray_wchar_c) { (wchar_t const(*)[])(StringCStr(WideChar)(&(mewp->cmyname)))});
# endif
}
      
/*
YCrCb (YUV)
R ́G ́B ́ - is gamma corrected color (for file & for XSetForeground) 0..1
RGB - is real linear light 0..1
R ́=R^(1/2.2) G ́=G^(1/2.2) B ́=B^(1/2.2)

Y = 0.299R ́ + 0.587G ́ + 0.114B ́
U= – 0.147R ́ – 0.289G ́ + 0.436B ́= 0.492 (B ́ – Y)
V = 0.615R ́ – 0.515G ́ – 0.100B ́= 0.877(R ́ – Y)

Y = 0 .. 1
U = ±112/255
V = ±157/255

R ́ = Y + 1.140V
G ́ = Y – 0.395U – 0.581V
B ́ = Y + 2.032U

 */  
  
// ! UChar -> Byte  
// 0-255,0-255,0-255 > ULInt  
bool  isBADCreateColor(tUCharRGB const rgb , int const  coldep,
  unsigned long int  * const resultp){
  switch(coldep){
  case  24:
    // 8 8 8
    { unsigned  long  int const  restmp = ((((unsigned  long  int)( rgb.r ) <<
      (8 + 8)) bitor
      ((unsigned  long  int)( rgb.g )  <<  8)) bitor
      (unsigned  long  int)( rgb.b ));
      * resultp = restmp;
    }
    return  false;    
  case  16:
    // 5 6 5
    { unsigned  long  int const  restmp=((((unsigned  long  int)( rgb.r  >>
      (8 - 5)) <<  (6 + 5))
        bitor
      ((unsigned  long  int)( rgb.g   >>  (8 - 6))  <<  5)) bitor
      ((unsigned  long  int)( rgb.b   >>  (8 - 5))));
      * resultp = restmp;
    }
    return  false;
  case  8:
    // 3 3 2
    { unsigned  long  int const  restmp=((((unsigned  long  int)( rgb.r  >>
      (8 - 3)) <<  (3 + 2))
        bitor
      ((unsigned  long  int)( rgb.g   >>  (8 - 3))  <<  2)) bitor
      ((unsigned  long  int)( rgb.b   >>  (8 - 2))));
      * resultp = restmp;
    }
    return  false;  
  // 1 = 
  // 4 = 
  // 12 = 4 4 4    
  // 15 = 5 5 5 
  // 18 = 6 6 6 
  // 30 = 10 10 10 
  // 32 =   
  // 36 = 12 12 12
  // 48 = 16 16 16
  
  default:
    return  true;
  }
}
      
// ! UChar -> Byte  
void  PLOWindow_DrawPoint ( PLOWindow * const me  ,
  tUCharRGB const rgb , IntXY  const lxy ) {
  PLOWindow_pri * const mep = PLOWindow_to_pri ( me ) ;
  if((lxy.x  >=  0)  and ((unsigned  int)(lxy.x) < mep->matrixsizew))
    if((lxy.y  >=  0)  and ((unsigned  int)(lxy.y) < mep->matrixsizeh)){
      unsigned long int ulcols;
      if(isBADCreateColor(rgb,mep->colordefaultdepth ,&ulcols))
        fwprintf(stderr,
          L"PLOWindow_DrawPoint(UChar):isBADCreateColor:colordefaultdepth=%d\n",
          mep->colordefaultdepth ); 
      else{
        * VectorAt(UnsLongInt)(&mep->cmatrixpixel ,
          ((size_t)(lxy.x) * mep->matrixsizeh) +
          (size_t)(lxy.y )) = ulcols ;
        if(mep->opened and mep->dpy){
          // ! Speed is slow by X11-Server
          XLockDisplay(mep->dpy);
          XSetForeground(mep->dpy,mep->gc,ulcols );
          XDrawPoint(mep->dpy,mep->win,mep->gc,lxy.x,lxy.y);
          XFlush(mep->dpy);
          XUnlockDisplay(mep->dpy);
        }
      }
    }
}
      
# include "cast.h"

# define  PLOWindow_isBADReName Lisp2D_PLOWindow_isBADReName16gR
static  bool  PLOWindow_isBADReName ( PLOWindow_pri * const me , wchar_t volatile const * const wcp  ) {
  if  ( isBADReadWCharToCharString ( wcp , & me -> cmynameutf8 ) ) 
    return  true ;
  if(me->opened and me->dpy) {
    XChangeProperty(me->dpy, me->win,
      XInternAtom(me->dpy, "_NET_WM_NAME", false),
      XInternAtom(me->dpy, "UTF8_STRING", false),
      8, PropModeReplace, charcp_cast_ucharcp(StringCStr(Char)(&(me->cmynameutf8))),
      size_cast_int(String_Size(Char)(&(me->cmynameutf8))));
  }
  return  false ;
}
      
# include "stringbim.h"   
# include "string/public.h"
      
TaskForThread Lisp2Dbimwindowrename2(StackClusterPrivate  * const stclpp){
  ParaLispObject  * const sp= CCAR  ( StackClusterPrivate_ArgTop(stclpp ));
  if ( IsNotString(  stclpp,sp) )
    return  TaskForThread_Analyse;
  PLOWindow * const  mep =
    ParaLispObjectToPLOWindow(StackClusterPrivate_ThisTop(stclpp ));
  wchar_t volatile const * const wstp = PLOString_CStr ( ParaLispObjectToPLOString ( sp ) ) ;
  PLOWindow_pri * const mepr = PLOWindow_to_pri ( mep ) ;
  if  ( PLOWindow_isBADReName ( mepr  , wstp ) ) {
    BadStringN(stclpp );
    return  TaskForThread_Analyse;
  }
  StackClusterPrivate_SetResult(stclpp ,PLOWindow_plo(mep));
  return  TaskForThread_Analyse;
}
     
# include "boolean.h"     
     
// nil windowp
TaskForThread Lisp2Dbimnilwindowp2(StackClusterPrivate  * const stclpp){
  ParaLispObject  * const xp= CCAR  ( StackClusterPrivate_ArgTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,(Windowp(xp) ? xp :
    &plofalse.plo));
  return  TaskForThread_Analyse;
}
     
// (window  open)
TaskForThread Lisp2Dbimwindowopen2(StackClusterPrivate  * const stclpp){
  PLOWindow * const  wp=ParaLispObjectToPLOWindow(StackClusterPrivate_ThisTop(
    stclpp ));
  StackClusterPrivate_SetResult(stclpp , (PLOWindow_Open(wp) ? PLOWindow_plo(wp) :
    ( &plofalse.plo )));
  return  TaskForThread_Analyse;
}
     
// (window  openp)
TaskForThread Lisp2Dbimwindowopenp2(StackClusterPrivate * const stclpp){
  PLOWindow * const  mep=ParaLispObjectToPLOWindow(
    StackClusterPrivate_ThisTop(stclpp ));
  StackClusterPrivate_SetResult(stclpp ,(PLOWindow_Opened(mep)  ? PLOWindow_plo(mep)  :
    ( &plofalse.plo )));
  return  TaskForThread_Analyse;
}
     
// (window  hide)
TaskForThread Lisp2Dbimwindowhide2(StackClusterPrivate  * const stclpp){
  PLOWindow * const me = ParaLispObjectToPLOWindow (
    StackClusterPrivate_ThisTop ( stclpp )  ) ;
  PLOWindow_Hide  ( PLOWindow_to_pri(me)  ) ;
  StackClusterPrivate_SetResult ( stclpp , PLOWindow_plo( me ) ) ;
  return  TaskForThread_Analyse ;
}
     
void  PLOWindow_QueryPointer  ( PLOWindow * const me , IntXY * const xy ) {
  PLOWindow_pri * const mep = PLOWindow_to_pri ( me ) ;
  if(mep->opened and mep->dpy)  {
    Window  root;
    Window  child;
    int rootx;
    int rooty;
    unsigned  int mask;
    XLockDisplay(mep->dpy);
    XQueryPointer ( mep  ->  dpy , mep  ->  win , & root  , & child , & rootx ,
      & rooty , & xy  ->  x , & xy  -> y  , & mask  ) ;
    XUnlockDisplay(mep->dpy);
  } else  {
    xy  ->  x = 0;
    xy  ->  y = 0;
  }
}
     
void  PLOWindow_Resize(PLOWindow * const me , UIntXY const   wh) {
  PLOWindow_MapResize(me,wh);
  PLOWindow_pri * const mep = PLOWindow_to_pri ( me ) ;
  if(mep->opened and mep->dpy){
    XLockDisplay(mep->dpy);
    XResizeWindow(mep->dpy,mep->win,wh.x,wh.y);
    XUnlockDisplay(mep->dpy);
  }
}
     
# include "minmaxint.h"     
# include "stack/public.h"

void  PLOWindow_MapResize(PLOWindow * const me , UIntXY const wh ) {
  ThreadStackPointerType const oldstack_backup = Lisp2DThreadSP ( ) ;
  Vector  ( UnsLongInt  ) * const backupp = Lisp2D_StackVar ( StackType ( VectorUnsignedLongInt ) ) ;
  PLOWindow_pri * const mep = PLOWindow_to_pri ( me ) ;
  VectorInitMove ( UnsLongInt  ) ( backupp  , & mep->cmatrixpixel );
  VectorClear(UnsLongInt)(&mep->cmatrixpixel );
  Vector_ResizeFill(UnsLongInt)(&mep->cmatrixpixel , (size_t)(wh.x)  * (size_t)(wh.y),0);
  size_t  const  minh = Lisp2DMinSize ( 
# if UINT_MAX  ==  SIZE_MAX
    wh.y
# else  
    (size_t)  ( wh.y )
# endif  
    , mep->matrixsizeh ) ;
  { size_t  i = Lisp2DMinSize ( ( size_t ) ( wh.x ) , mep -> matrixsizew ) ;
    while ( i ) {
      --  i;
      memcpy  ( VectorAt  ( UnsLongInt  ) ( & mep -> cmatrixpixel , i * wh  . y ) ,
        VectorCAt ( UnsLongInt  ) ( backupp  ,  i * ( mep -> matrixsizeh  ) ) ,
        sizeof  ( unsigned long  int  ) * minh  ) ;
    }
  } // i
  mep -> matrixsizew = wh.x ;
  mep -> matrixsizeh = wh.y ; 
  Lisp2D_StackFree  ( oldstack_backup ) ;
}
  
ParaLispObject  * PLOWindow_staticTypeOf ( ParaLispObject const * _ __attribute__((unused)) ) {
  return &  ploswindow . plo ;
}
  
void  PLOWindow_LockFlush ( PLOWindow const * const me ) {
  PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me ) ;
  if  ( mep ->  opened and mep  ->  dpy ) {
    XLockDisplay  ( mep ->  dpy ) ;
    XFlush  ( mep ->  dpy ) ;
    XUnlockDisplay  ( mep ->  dpy ) ;
  }
}
  
// ! to make argument : ..(bool & isBAD)    
void  PLOWindow_Init  ( PLOWindow_pri * const me  ) {
  ParaLispObject_InitVTP  ( & me  ->  plo ,
    ( VirtualTypePointer ) { . addr = { . p = me } , . type = TypeGlobalListMemberPLOWindowPri  } ) ;
  me -> win = (Window)0 ;
  me -> flagclose = false ;
  me -> opened = false ;
  me -> winwidth = 0 ;
  me -> winheight = 0 ;
  me -> dpy = (Display *)0 ;
  me -> gc = (GC)0 ;
  VectorInit  ( UnsLongInt  ) ( & me -> cmatrixpixel , false ) ;
  me -> matrixsizew = 0 ;
  me -> matrixsizeh = 0 ;
  String_Init ( WideChar  ) ( & ( me  ->  cmyname ) , true  ) ;
  String_Init ( Char  ) ( & ( me  ->  cmynameutf8 ) , true  ) ;
  me -> winimage = /*(XImage  *)*/0 ;
  me -> colordefaultdepth = 24 ;
  me -> boolHaveThread = false ;
  QueueConstructorDefault ( VoidP ) ( & me  ->  queueEventsC . pub ) ;
  QueueConstructorDefault ( VoidP ) ( & me  ->  queueStClPWaitEventC . pub ) ;
  me -> mutexQueueStClWaitEvent2 = ( pthread_mutex_t ) PTHREAD_MUTEX_INITIALIZER ;
  me -> xic = /*(XIC)*/0 ;
  me -> wmDeleteMessage = /*(Atom)*/0 ;
  pthread_mutex_lock  ( & Lisp2DmutexXDisplay2  ) ;
  me->dpy = XOpenDisplay(/*(char const *)*/0);
  pthread_mutex_unlock  ( & Lisp2DmutexXDisplay2  ) ;
  if(me->dpy){
    XLockDisplay(me->dpy);
    me->colordefaultdepth = DefaultDepth  ( me->dpy , DefaultScreen ( me->dpy ) )  ;
    XUnlockDisplay(me->dpy);
  }
# ifdef  LISP2D_CONSTRSTAT
  PLOWindow_constrstatInc ( ) ;
# endif
}
  
void  PLOWindow_GetAttributes(PLOWindow const * const me ,
  XWindowAttributes  * const wap) {
  PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me ) ;
  if(mep->opened and mep->dpy)  
    XGetWindowAttributes(mep->dpy,mep->win,  wap);
}

XImage  * PLOWindow_GetImage(PLOWindow const * const me ,IntXY const xy,
  UIntXY const wh,  unsigned  long  int const pm,  int const f){
  PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me ) ;
  if(mep->opened and mep->dpy)
    return  XGetImage(mep->dpy,mep->win,xy.x,xy.y,wh.x,wh.y,pm,f);
  return  (XImage  *)0;
}

void  PLOWindow_Flush ( PLOWindow const * const me ) {
  PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me ) ;
  if(mep->opened and mep->dpy)
    XFlush(mep->dpy);
}
  
# ifdef  LISP2D_DEBUG  

void  PLOWindow_DrawLine(PLOWindow_pri const * const me , IntXY const xy,
  IntXY const xy2) {
  if(me->opened and me->dpy) {
    XDrawLine(me->dpy,me->win,me->gc,xy.x,xy.y,xy2.x,xy2.y);
    XFlush(me->dpy);
  }
}

# endif  
  
void  PLOWindow_Move(PLOWindow const * const me ,IntXY const xy) {
  PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me ) ;
  if(mep->opened and mep->dpy){
    XMoveWindow(mep->dpy,mep->win,xy.x,xy.y);
    XFlush(mep->dpy);
  }
}
  
void  PLOWindow_staticDeclareForGC  ( ParaLispObject * const me ) {
  if(not  me -> flagGCPassed ){
    me -> flagGCPassed =true;
    GlobalListPopNotLock ( & GlobalListOfWindowsGarbage  , & me -> base )  ;
    GlobalListPushNotLock ( & GlobalListOfWindows , & me -> base ) ;
  }
}
  
void  PLOWindow_staticGCDeclareContent ( ParaLispObject * const me ) {
  Queue ( VoidP ) * const pq = & PLOWindow_to_pri  (
    ParaLispObjectToPLOWindow ( me  ) ) ->  queueEventsC ;
  size_t  i = QueueSize ( VoidP ) ( & pq -> pub ) ;
  while ( i ) {
    --  i ;
    void  * res = & plonil  . plo ;
# ifdef  LISP2D_DEBUG
    if  ( QueueIsBadElt ( VoidP ) ( & pq -> pub , i , & res )  ) {
      ErrorStra((PArray_wchar_c){(wchar_t const (*)[])&
        L"PLOWindow::GCDeclareContent2:queueEvents.Elt(i,res)"});
      return  ;
    }
# else      
    res = QueueAtValue  ( VoidP ) ( & pq -> pub , i ) ;
# endif    
    ParaLispObject_virtualDeclareForGC ( ( ParaLispObject  * ) ( res ) ) ;
  }
}
      
// ! UChar -> uint8_t
bool  PLOWindow_isBADColorsWithSizeCheck  ( PLOWindow const * const me ,
  UIntXY  const xy  , tUCharRGB * const rgb ) {
  PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me ) ;
  if(((xy.x) < mep->matrixsizew) and ((xy.y) < mep->matrixsizeh)) {
    if(isBADLoadColor(
        VectorAtCopy(UnsLongInt)(&mep->cmatrixpixel ,
          ((size_t)(xy.x) * mep->matrixsizeh) + (size_t)(xy.y)),
        rgb,PLOWindow_ColorDefaultDepth(mep)))
      return  true;
    return  false;
  }
  rgb->r = 0 ;
  rgb->g = 0 ;
  rgb->b = 0 ;
  return  false;
}

ParaLispObject  * PLOWindow_staticPushAsNew ( ParaLispObject * const  me ) {
  GlobalListPush ( & GlobalListOfWindows , & me -> base  ) ;
  return  me ;
}

ParaLispObject  * PLOWindow_staticClassDef  (
  ParaLispObject const * _ __attribute__((unused)) ) {
  return  ploclassdefwindow;
}

ParaLispObject  * PLOWindow_staticClassParents  (
  ParaLispObject const * _ __attribute__((unused)) ) {
  return  ploclassparentswindow;
}

void  PLOWindow_staticCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector(StackPLOP)  * const h ) {
  PLOWindow_staticCoutToInterpret ( me ,    s , flag2pprinted  , h ) ;
}

PLOWindow * PLOWindow_FromMember ( GlobalListMember * const m ) {
  if  ( m ) {
    if(GlobalListMemberVirt(m).type == TypeGlobalListMemberParaLispObject) {
      ParaLispObject * const plo = (ParaLispObject *) GlobalListMemberVirt ( m ) . addr . p ;
      if  ( plo ->  vaddr . type == TypeGlobalListMemberPLOWindowPri  )
        return  &(( PLOWindow_pri *  ) ( plo ->  vaddr . addr . p ) ) -> pub ;
      fputws ( L"PLOWindow::FromMember ( GlobalListMember * m ):"
        L"plo ->  vaddr . type <> TypeGlobalListMemberPLOWindow\n" , stderr ) ;
      return ( PLOWindow *  ) 0 ;
    }  // obj
    if  ( m ->  vaddr  . type == TypeGlobalListMemberPLOWindowPri )
      return  &(( PLOWindow_pri * ) ( m ->  vaddr  . addr . p ) ) -> pub ;
  }  // m
  return  ( PLOWindow *  ) 0 ;
}

bool  PLOWindow_isBADTryToGetEvent(PLOWindow * const me ,
  ParaLispObject  * * const resp ) {
  PLOWindow_pri * const mep = PLOWindow_to_pri ( me ) ;
  if  ( pthread_mutex_lock  ( & mep -> mutexQueueStClWaitEvent2 ) ) {
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
      L"PLOWindow_isBADTryToGetEvent:"
      L"pthread_mutex_lock  ( & mep -> mutexQueueStClWaitEvent2 )" ; 
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
  }
  { void  * res0  ;
    if  ( QueueIsBadPop ( VoidP ) ( & mep -> queueEventsC . pub , & res0 ) ) {
    // no events, returns to task manager      
      if  ( pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 ) ) {
        Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
          L"PLOWindow_isBADTryToGetEvent:"
          L"pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 )" ; 
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
      }
      return   true  ;
    } 
    ( * resp ) = ( ParaLispObject  * ) ( res0  ) ;
  }
  // res is good
  if  ( pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 ) ) {
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & 
      L"PLOWindow_isBADTryToGetEvent:"
      L"pthread_mutex_unlock  ( & mep -> mutexQueueStClWaitEvent2 )" ; 
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ;
  }
  return  false;
}
  
# include "cons/inline.h"
# include "complex/inline.h"
# include "plocomplex/public.h"
  
// (win draw-pixel  col|(r g b) x y ... x y)
TaskForThread Lisp2Dbimdrawpixel2(StackClusterPrivate * const stclpp){
  PLOWindow * const  mep =ParaLispObjectToPLOWindow( StackClusterPrivate_ThisTop(stclpp ));
  { ParaLispObject  * j;
    unsigned  int tasks = maxListItemProcessing ;
    ParaLispObject  const * const  arglistp=StackClusterPrivate_ArgTop(stclpp );
    ParaLispObject  * const arglistcarp = CCAR ( arglistp );
    tUCharRGB ulcols ;
    if(isBADColorsCharsFromObjectOrList(arglistcarp,&ulcols, stclpp ))
      return  TaskForThread_Analyse;
    if  ( StackClusterPrivate_ClearflagCont ( stclpp ) ) {
      StackClusterPrivate_Pop(stclpp ,&j);
      goto  Next;
    }
    j = CCDR  (  arglistp);
    while(CConsp( j)){
Next  :
      { ParaLispObject  * const xp =
        ClassCons_First(&ParaLispObjectToPLOCons(j)->cc);
      if(IsNotNumber(  stclpp ,xp))       
        return  TaskForThread_Analyse;
      j = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( j )->cc ) ;
      ParaLispObject  * const yp= CCAR ( j);
      if(IsNotNumber(  stclpp ,yp))     
        return  TaskForThread_Analyse;
      { IntXY ixy ;
      if(FractionIsBADIntValue(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
          xp))), &ixy.x))
        goto NextP ;
      if(FractionIsBADIntValue(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
          yp))), &ixy.y))
        goto NextP ;
      PLOWindow_DrawPoint ( mep ,  ulcols , ixy ) ; 
      } 
      }
NextP :      
      j = ClassCons_Rest  ( &ParaLispObjectToPLOCons ( j )->cc ) ;
      if((--  tasks)  ==  0){
        if(CConsp(  j)){
          StackClusterPrivate_setTaskForManager ( stclpp , 
            TaskPause ) ;
          StackClusterPrivate_SetflagCont ( stclpp , 1U  ) ;
          StackClusterPrivate_Push(stclpp , j);
          return  TaskForThread_Analyse;
        }
        break;
      }
    }
  }
  StackClusterPrivate_SetResult(stclpp ,PLOWindow_plo(mep));
  return  TaskForThread_Analyse;
}

// getpixel
TaskForThread Lisp2Dbimwindowgetpixel2(StackClusterPrivate  * const stclpp){
  PLOWindow * const  mep =ParaLispObjectToPLOWindow(
    StackClusterPrivate_ThisTop(stclpp ));
  ParaLispObject  * const arglistp =StackClusterPrivate_ArgTop(stclpp );
  ParaLispObject  * const xp = CCAR (  arglistp);
  if(IsNotNumber(  stclpp ,xp))
    return  TaskForThread_Analyse;
  ParaLispObject  * const yp = CCAR ( CCDR (  arglistp));
  if(IsNotNumber(  stclpp ,yp)) 
    return  TaskForThread_Analyse;
  StackClusterPrivate_SetResult(stclpp ,
    PLOWindow_GetPixel(mep,Complex_CRe(PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(xp))),
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        yp)))));
  return  TaskForThread_Analyse;
}
  
// width
TaskForThread Lisp2Dbimwindowwidth2(StackClusterPrivate * const stclpp){
  PLOWindow * const  me2=ParaLispObjectToPLOWindow(StackClusterPrivate_ThisTop(
    stclpp ));
  if(PLOWindow_Opened(me2)){
    XWindowAttributes wa;
    PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me2 ) ;
    XLockDisplay(PLOWindow_MyDisplay(mep));
    PLOWindow_GetAttributes(me2,&wa);
    XUnlockDisplay(PLOWindow_MyDisplay(mep)); 
    PLOWindow_SetWindowWidth2 ( me2  ,
      ( unsigned  int ) ( ( wa  . width  < 0  )  ? 0 :
        (  wa  . width ) ) ) ;
    PLOComplex  * const  res=NewComplexBareExc();
    Complex_SetInt  ( PLOComplexToComplex( res),wa.width);
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);
    return  TaskForThread_Analyse;
  }
  StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
  return  TaskForThread_Analyse;
}
  
// height
TaskForThread Lisp2Dbimwindowheight2(StackClusterPrivate  * const stclpp){
  PLOWindow * const  me2=ParaLispObjectToPLOWindow(StackClusterPrivate_ThisTop(
    stclpp ));
  if(PLOWindow_Opened(me2)){
    XWindowAttributes wa;
    PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me2 ) ;
    XLockDisplay(PLOWindow_MyDisplay(mep));
    PLOWindow_GetAttributes(me2,&wa);
    XUnlockDisplay(PLOWindow_MyDisplay(mep)); 
    PLOWindow_SetWindowHeight2  ( me2  , ( unsigned int  ) (
      ( wa.height < 0 ) ? 0 : ( wa  . height  ) ) ) ;
    PLOComplex  * const  res=NewComplexBareExc();
    Complex_SetInt  ( PLOComplexToComplex( res),wa.height);
    StackClusterPrivate_SetResult(stclpp ,&  res->plo);
    return  TaskForThread_Analyse;
  }
  StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
  return  TaskForThread_Analyse;
}
  
// window pointer-coord
TaskForThread Lisp2Dbimwindowpointercoord2  ( StackClusterPrivate  * const stclpp ) {
  IntXY xy  ;
  PLOWindow_QueryPointer  ( ParaLispObjectToPLOWindow ( StackClusterPrivate_ThisTop (
    stclpp  ) ) , & xy  ) ;
  PLOComplex  * const  pplox=NewComplexBareExc(  );
  Complex_SetInt  ( PLOComplexToComplex( pplox),xy.x);
  PLOComplex  * const  pploy=NewComplexBareExc(  );
  Complex_SetInt  ( PLOComplexToComplex( pploy),xy.y);
  ParaLispObject  * list [ ] = { &pplox->plo,&pploy->plo, NULL } ;
  StackClusterPrivate_SetResult(stclpp ,
    ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
  return  TaskForThread_Analyse;
}
  
# ifdef  LISP2D_DEBUG
// window *getpixel* x y
TaskForThread Lisp2Dbimwindowsysgetpixel2(StackClusterPrivate * const  stclpp){
  PLOWindow * const  me2=ParaLispObjectToPLOWindow(StackClusterPrivate_ThisTop(
    stclpp ));
  ParaLispObject  * const arglistp=StackClusterPrivate_ArgTop(stclpp );
  ParaLispObject  * const ploxp= CCAR ( arglistp);
  if(IsNotNumber(  stclpp ,ploxp))  
    return  TaskForThread_Analyse;
  ParaLispObject  * const ployp= CCAR  ( CCDR  ( arglistp));
  if(IsNotNumber(  stclpp ,ployp)) 
    return  TaskForThread_Analyse;
  int const x=Complex_IValue(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
    ploxp)));
  int const y=Complex_IValue(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
    ployp)));
  int const w=PLOWindow_Width(me2);
  int const h=PLOWindow_Height(me2);
  PLOComplex  * const  r2=NewComplexBareExc();
  Complex_Set0  ( PLOComplexToComplex( r2));    
  PLOComplex  * const  g2=NewComplexBareExc();
  Complex_Set0  ( PLOComplexToComplex( g2));    
  PLOComplex  * const  b2=NewComplexBareExc();  
  Complex_Set0  ( PLOComplexToComplex( b2));    
  if((x >=  0) and ((x < w) and ((y >=  0)  and (y  < h)))){
    PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me2 ) ;
    XLockDisplay(PLOWindow_MyDisplay(mep));
    // may returns nullptr
    { XImage * const xi = PLOWindow_GetImage  ( me2  , (IntXY) { x , y } ,
        (UIntXY)  { 1 , 1 } , AllPlanes,XYPixmap) ;
    if  ( xi ) {
      unsigned  long  int const  pix=XGetPixel(xi,0,0);
      XDestroyImage(xi);      
  iLoadColor args = { pix , PLOWindow_ColorDefaultDepth(mep) } ;
  oLoadColor result = LoadColor(args);
      // longint -> r:n/m, g:n/m,b:n/m
      if(result.isBAD)
        StackClusterPrivate_ExceptionSet(stclpp ,
          &PLOString_NewCopy(L"isBADLoadColor")->plo);
      else{
        
        FractionSetUIntUInt ( Complex_Re  ( 
          PLOComplexToComplex (
          r2  ) ) , result  . rn    ,  result  . rd    ) ;
        
        FractionSetUIntUInt ( Complex_Re  (  
          PLOComplexToComplex (
          g2  ) ) , result  . gn    , result  . gd    ) ;
        
        FractionSetUIntUInt ( Complex_Re  ( 
          PLOComplexToComplex (
          b2  ) ) , result  . bn    , result  . bd    ) ;        
      }
    XUnlockDisplay(PLOWindow_MyDisplay(mep));
    }/*if*/
    }  // xi
  ParaLispObject  * list [ ] = { &r2->plo,&g2->plo,&b2->plo, NULL } ;
  StackClusterPrivate_SetResult(stclpp ,
    ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list})); 
  }  //  if
  return  TaskForThread_Analyse;
}
# endif // LISP2D_DEBUG
  

// example: 
// ('w set ('window newobject 100 100))
// (w *font* 0 0 1 "-*-helvetica-bold-r-*-*-*-120-100-100-*-*-iso8859-1")
// (w *font* 0 0 1 "-*-helvetica-medium-r-*-*-20-*-100-100-*-*-iso8859-1")
# ifdef  LISP2D_DEBUG
// window *font* x y color|(r g b) fontname
TaskForThread Lisp2Dbimwindowsysloadfont2(StackClusterPrivate * const stclpp){
  StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
  ParaLispObject  * const arglistp=StackClusterPrivate_ArgTop(stclpp );
  ParaLispObject  * const x0p= CCAR  ( arglistp);
  if(IsNotNumber(  stclpp ,x0p))   
    return  TaskForThread_Analyse;
  ParaLispObject  * const y0p= CCAR  ( CCDR  ( arglistp));
  if(IsNotNumber(  stclpp ,y0p))  
    return  TaskForThread_Analyse;
  PLOWindow * const  mep=ParaLispObjectToPLOWindow(
    StackClusterPrivate_ThisTop(stclpp ));
  tUCharRGB uc ;
  if(isBADColorsCharsFromObjectOrList(
     CCAR  ( CCDR  ( CCDR  ( arglistp))),&uc,stclpp ))   
    return  TaskForThread_Analyse;
  unsigned long int c;
  if  ( isBADCreateColor  ( uc , PLOWindow_ColorDefaultDepth (
    PLOWindow_to_cpri ( mep  ) ) , &c)) 
    return  TaskForThread_Analyse;
  ParaLispObject  * const fontnamep= CCAR  ( CCDR  ( CCDR  ( CCDR  (
    arglistp))));
  if(IsNotString(  stclpp ,fontnamep)) 
    return  TaskForThread_Analyse;
  XFontStruct *  fontinfo=/*(void*)*/0;
  XLockDisplay(PLOWindow_MyDisplay(PLOWindow_to_cpri(mep)));
  { ThreadStackPointerType const oldstack = Lisp2DThreadSP ( ) ;
    String  ( Char ) * const strtmp2 = StackNew_StringChar ( ) ;
    String_Init ( Char  ) ( strtmp2 , true ) ;
    if  ( isBADReadWCharToCharString  ( PLOString_CStr  (
      ParaLispObjectToPLOString ( fontnamep  ) ) , strtmp2 ) ) {
      Lisp2D_StackFree  ( oldstack ) ;
      BadString(stclpp ,ParaLispObjectToPLOString(fontnamep));
      return  TaskForThread_Analyse; 
    }
    fontinfo  = XLoadQueryFont  ( PLOWindow_MyDisplay ( 
      PLOWindow_to_cpri ( mep  ) ) , StringCStr(Char)(strtmp2));
    Lisp2D_StackFree  ( oldstack ) ;
  }
  if(fontinfo ==  /*(void*)*/0){
    ParaLispObject  * list [ ] = { &  PLOString_NewCopy(L"can't open ")->plo,
      fontnamep,&  PLOString_NewCopy(L" font")->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    XUnlockDisplay(PLOWindow_MyDisplay(PLOWindow_to_cpri(mep)));
    return  TaskForThread_Analyse; 
  }
  wprintf ( L"minch=%u\n" , fontinfo  ->  min_char_or_byte2 ) ;
  wprintf ( L"maxch=%u\n" , fontinfo  ->  max_char_or_byte2 ) ;
  wprintf ( L"all chars exist=%d\n" , fontinfo  ->  all_chars_exist ) ;
  wprintf ( L"ascent=%d\n" , fontinfo ->  ascent ) ;
  wprintf ( L"descent=%d\n" , fontinfo  ->  descent ) ;
  for(int  i=(int)(fontinfo->min_char_or_byte2);
      i  <=  (int)(fontinfo->max_char_or_byte2);++  i){
    int const j=i - (int)(fontinfo->min_char_or_byte2);
    wprintf ( L"i=%d ch=%c\n" , i , (char)i ) ;
    XCharStruct * const  chstp= &(fontinfo->per_char[j]);
    wprintf ( L"lbearing=%d\n" , (int)(chstp->lbearing) ) ;
    wprintf ( L"rbearing=%d\n" , (int)(chstp->rbearing) ) ;
    wprintf ( L"width=%d\n" , (int)(chstp->width) ) ;
    wprintf ( L"ascent=%d\n" , (int)(chstp->ascent) ) ;
    wprintf ( L"descent=%d\n" , (int)(chstp->descent) ) ;
    char  toprint[2]={(char)(i),'\00'};
    XSetForeground  ( PLOWindow_MyDisplay ( PLOWindow_to_cpri ( mep  ) ) ,
      PLOWindow_MyGC2 ( PLOWindow_to_cpri(mep)),c);
    { int x0re ;
      if(FractionIsBADIntValue(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
          x0p))), &x0re))
        x0re = 0 ;
      { int y0re ;
        if(FractionIsBADIntValue(
          Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst
          (y0p))), &y0re))
          y0re = 0 ;
        XDrawString ( PLOWindow_MyDisplay ( PLOWindow_to_cpri ( mep  ) ) ,
          * PLOWindow_MyWindow  ( PLOWindow_to_pri ( mep  ) ) ,
          PLOWindow_MyGC2 ( PLOWindow_to_cpri ( mep  ) ) , x0re, y0re,toprint
          ,1); 
      }
    }
    PLOWindow_Flush(mep);
    fputws  ( L"(#("  , stdout  ) ;
    int y0re ;
    if(FractionIsBADIntValue(Complex_CRe(
      PLOComplexToComplexConst(
      ParaLispObjectToPLOComplexConst(y0p))),&y0re))
      y0re = 0 ;
    for(int  y=y0re  - (chstp->ascent); ;++ y){
      { int y0re2 ;
        if(FractionIsBADIntValue(
          Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
            y0p))), &y0re2))
          y0re2 = 0 ;
        if  ( not ( y <=  y0re2  + (chstp->descent)))
          break ;
      }
      fputws  ( L"#("  , stdout  ) ;
      int x0re ;
      if(FractionIsBADIntValue(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
          x0p))), &x0re))
        x0re = 0 ;
      for(int  x=x0re; ;++  x){
        { int x0re2 ;
          if(FractionIsBADIntValue(
            Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst
              (x0p))), &x0re2))
            x0re2 = 0 ;
          if(not(x <=  x0re2 + (chstp->rbearing)))
            break ;
        }
        { XImage * const xi =  PLOWindow_GetImage  ( mep  , (IntXY) { x , y } ,
            (UIntXY)  { 1 , 1 } , AllPlanes,XYPixmap) ;
          if  ( xi  ) {
            unsigned  long  int const pix=XGetPixel(xi,0,0) bitand 0xFF;
            XDestroyImage(xi);
            wprintf(L" %lu",pix);
          } else {
            ParaLispObject  * list [ ] = { &
              PLOString_NewCopy(L"GetImage=nullptr")-> plo, NULL } ;
            StackClusterPrivate_ExceptionSet(stclpp ,
              ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
          }
        }
      }
      fputws  ( L")\n"  , stdout  ) ; 
    }
    fputws  ( L") * 1/0xff)\n"  , stdout  ) ;
    XSetForeground  ( PLOWindow_MyDisplay ( PLOWindow_to_cpri ( mep  ) ) ,
      PLOWindow_MyGC2 ( PLOWindow_to_cpri(mep)),0);
    for(int  y=0;y  < 200;++  y)
      PLOWindow_DrawLine(PLOWindow_to_pri(mep),(IntXY){0,y},(IntXY){200,y});
    PLOWindow_Flush(mep); 
  } // for i
  XFreeFontInfo((void*)0,fontinfo,1);
  XUnlockDisplay(PLOWindow_MyDisplay(PLOWindow_to_cpri(mep)));
  StackClusterPrivate_SetResult(stclpp ,&plotrue.plo);
  return  TaskForThread_Analyse; 
}

# endif // LISP2D_DEBUG
  
// window move
TaskForThread Lisp2Dbimwindowmove2(StackClusterPrivate  * const stclpp){
  PLOWindow * const  mep=ParaLispObjectToPLOWindow(StackClusterPrivate_ThisTop(
    stclpp ));
  ParaLispObject  * const arglistp=StackClusterPrivate_ArgTop(stclpp );
  ParaLispObject  * const ploxp= CCAR  ( arglistp);
  if(IsNotNumber(  stclpp ,ploxp))  
    return  TaskForThread_Analyse;
  ParaLispObject  * const ployp= CCAR  ( CCDR  ( arglistp));
  if(IsNotNumber(  stclpp ,ployp))  
    return  TaskForThread_Analyse;
  int x ;
  if(FractionIsBADIntValue(Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(ploxp))),&x)){
    StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
    return  TaskForThread_Analyse;
  }
  int y ;
  if(FractionIsBADIntValue(Complex_CRe(PLOComplexToComplexConst(
    ParaLispObjectToPLOComplexConst(ployp))),&y)){
    StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
    return  TaskForThread_Analyse;
  }
  XLockDisplay(PLOWindow_MyDisplay(PLOWindow_to_cpri(mep)));
  PLOWindow_Move(mep,(IntXY){x,y});
  XUnlockDisplay(PLOWindow_MyDisplay(PLOWindow_to_cpri(mep)));
  StackClusterPrivate_SetResult(stclpp ,PLOWindow_plo(mep));
  return  TaskForThread_Analyse ; 
}
  
// window resize
TaskForThread Lisp2Dbimwindowresize2(StackClusterPrivate  * const stclpp){
  PLOWindow * const  wip=ParaLispObjectToPLOWindow(StackClusterPrivate_ThisTop(
    stclpp ));
  ParaLispObject  * const arglistp=StackClusterPrivate_ArgTop(stclpp );
  ParaLispObject  * const plowp= CCAR  ( arglistp);
  StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
  if(IsNotNumber(  stclpp ,plowp))  
    return  TaskForThread_Analyse;
  ParaLispObject  * const plohp= CCAR  ( CCDR  ( arglistp));
  if(IsNotNumber(  stclpp ,plohp))  
    return  TaskForThread_Analyse;
  if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        plowp)))))
    return  TaskForThread_Analyse;
  if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
        ParaLispObjectToPLOComplex(plowp))),0U)) 
    return  TaskForThread_Analyse;
  if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
        plohp)))))
    return  TaskForThread_Analyse;
  if(FractionLessUInt(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(plohp)))
      ,0U)) 
    return  TaskForThread_Analyse;
// ! to check for UIValue - error    
  PLOWindow_Resize  ( wip , ( UIntXY  ) { FractionUIValue  (
    Complex_CRe (
          PLOComplexToComplexConst  ( ParaLispObjectToPLOComplexConst (
              plowp ) ) ) ) , FractionUIValue  ( Complex_CRe (
          PLOComplexToComplexConst  ( ParaLispObjectToPLOComplexConst (
            plohp ) ) ) ) } ) ;
  XLockDisplay(PLOWindow_MyDisplay(PLOWindow_to_cpri(wip)));
  PLOWindow_Flush(wip);
  { XWindowAttributes wa;
    PLOWindow_GetAttributes(wip,&wa);
    PLOWindow_SetWindowWidth2 ( wip  ,
      ( unsigned  int ) ( ( wa  . width  < 0  ) ? 
      0 : 
      ( wa  . width ) ) ) ;
    PLOWindow_SetWindowHeight2  ( wip , ( unsigned int  ) (
      ( wa  . height < 0  ) ? 
      0 :
      ( wa  . height  ) ) ) ; 
  }  // wa
  XUnlockDisplay(PLOWindow_MyDisplay(PLOWindow_to_cpri(wip)));
  StackClusterPrivate_SetResult(stclpp ,PLOWindow_plo(wip));
  return  TaskForThread_Analyse ; 
}

// window map-resize w h
TaskForThread Lisp2Dbimwindowmapresize2(StackClusterPrivate * const stclpp){
  PLOWindow * const  wip=ParaLispObjectToPLOWindow(StackClusterPrivate_ThisTop(
    stclpp ));
  { ParaLispObject  * const arglistp=StackClusterPrivate_ArgTop(stclpp );
    ParaLispObject  * const plowp= CCAR  ( arglistp);
    StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
    if(IsNotNumber(  stclpp ,plowp))   
      return  TaskForThread_Analyse;
    ParaLispObject  * const plohp= CCAR  ( CCDR  ( arglistp));
    if(IsNotNumber(  stclpp ,plohp))   
      return  TaskForThread_Analyse;
    if(not  FractionIntegerP(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
          plowp)))))
      return  TaskForThread_Analyse;
    if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
          ParaLispObjectToPLOComplex(plowp))),0U))  
      return  TaskForThread_Analyse;
    if(not  FractionIntegerP(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
          plohp)))))
      return  TaskForThread_Analyse;
    if(FractionLessUInt(Complex_CRe(PLOComplexToComplexConst(
          ParaLispObjectToPLOComplex(plohp))),0U))
      return  TaskForThread_Analyse;
// ! to check for UIValue - error  
    PLOWindow_MapResize ( wip , ( UIntXY  ) { FractionUIValue  (
      Complex_CRe (
            PLOComplexToComplexConst  ( ParaLispObjectToPLOComplexConst (
              plowp ) ) )
          ) , FractionUIValue  ( Complex_CRe ( 
          PLOComplexToComplexConst  (
              ParaLispObjectToPLOComplexConst ( plohp ) ) ) ) } ) ; 
  }
  StackClusterPrivate_SetResult(stclpp ,PLOWindow_plo(wip));
  return  TaskForThread_Analyse ; 
}

// window pending
TaskForThread Lisp2Dbimwindowpending2(StackClusterPrivate * const stclpp ) {
  size_t  res;
  PLOWindow_Pending (PLOWindow_to_pri (
    ParaLispObjectToPLOWindow ( StackClusterPrivate_ThisTop ( stclpp ) ) ) ,
    & res ) ;  
  PLOComplex  * const  res2= NewComplexBareExc();
  Complex_SetUSize  ( PLOComplexToComplex( res2),res);
  StackClusterPrivate_SetResult(stclpp ,&  res2->plo);
  return  TaskForThread_Analyse ; 
}

// ! add arg : StackClusterPrivate *        
ParaLispObject * PLOWindow_GetPixel(PLOWindow const * const me ,
  FractionPub  const * const xp, FractionPub  const * const yp){
  if(not  FractionIntegerP(xp)) 
    return & plonil.plo;
  if(not  FractionIntegerP(yp))  
    return & plonil.plo;
  if(FractionLessUInt( xp,0U))  
    return & plonil.plo;
  if(FractionLessUInt( yp,0U))  
    return & plonil.plo;
  PLOWindow_pri const * const mep = PLOWindow_to_cpri ( me ) ;
  if(not  (FractionLessUSize(xp,mep->matrixsizew)))   
    return & plonil.plo;
  if(not  (FractionLessUSize(yp,mep->matrixsizeh))) 
    return & plonil.plo;
  size_t  sx;
  if(  FractionIsBadSizeValue(xp,&sx))   
    return & plonil.plo;
  size_t  sy;
  if(  FractionIsBadSizeValue(yp,&sy))  
    return & plonil.plo;
  iLoadColor args = { VectorAtCopy(UnsLongInt)(&mep->cmatrixpixel ,
    (sx  * mep->matrixsizeh)  +  sy), mep->colordefaultdepth } ;
  oLoadColor result = LoadColor(args);
  if(result.isBAD)   
    return & plonil.plo;
  PLOComplex  * const  cr= NewComplexBareExc ();
  Complex_SetRealFractionUInt ( PLOComplexToComplex( cr),result.rn,result.rd);
  PLOComplex  * const  cg= NewComplexBareExc ();
  Complex_SetRealFractionUInt ( PLOComplexToComplex( cg),result.gn,result.gd);
  PLOComplex  * const  cb= NewComplexBareExc ();
  Complex_SetRealFractionUInt ( PLOComplexToComplex( cb),result.bn,result.bd);
  ParaLispObject  * list [ ] = { &cr->plo,&cg->plo,&cb->plo, NULL } ;
  return ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list});  
}

// (window  window [width height])
TaskForThread Lisp2Dbimwindowwindow2(StackClusterPrivate  * const stclpp){
  PLOWindow * const  mep=ParaLispObjectToPLOWindow(
    StackClusterPrivate_ThisTop(stclpp ));
  ParaLispObject  const * const  lp=StackClusterPrivate_ArgTop(stclpp );
  unsigned  int  w=1U;
  ParaLispObject  const * const  plowidthp= CCAR  ( lp ) ;
  if(Numberp(plowidthp)){
    unsigned  int const w2=FractionUIValue(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst(
          plowidthp)) ));
    if(w2 > 1) 
      w = w2; 
  } else {
    StackClusterPrivate_SetResult(stclpp ,PLOWindow_plo(mep));
    return  TaskForThread_Analyse ; 
  }
  unsigned  int  h=1;
  ParaLispObject  const * const  ploheightp= CCAR  ( CCDR  ( lp));
  if(Numberp(ploheightp)){
    unsigned  int const h2=FractionUIValue(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplexConst( ploheightp) )));
    if(h2 > 1)  
      h = h2 ; 
  }
  PLOWindow_Create  ( mep  , (UIntXY){w , h} ) ;
  StackClusterPrivate_SetResult ( stclpp ,  PLOWindow_plo( mep) ) ;
  return  TaskForThread_Analyse ; 
}

# include "inner-history/inline.h"

// ! to write (window map)
// ! remove (nil mapwindow
// (nil mapwindow width height)
TaskForThread Lisp2Dbimnilmapwindow2(StackClusterPrivate  * const stclpp){
# ifdef  LISP2D_INNERHISTORY
  static  wchar_t  const  Lisp2Dwsih_mapwindow[] = L"bimnilmapwindow2:Start." ;
  Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , Lisp2Dwsih_mapwindow ) ;
# endif      
  ParaLispObject  * const lp=StackClusterPrivate_ArgTop(stclpp );
  ParaLispObject  * const argwp= CCAR  ( lp);
  StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
  if(IsNotNumber(  stclpp ,argwp)) 
    goto Exit ;
  if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(argwp)))
      )){
    ParaLispObject  * list [ ] = { argwp,&  PLOString_NewCopy(
      L" is not integer") ->plo, NULL } ;
    StackClusterPrivate_ExceptionSet(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    goto Exit ; 
  }
  { ParaLispObject  * const arghp= CCAR  ( CCDR  ( lp));
    if(not  (FractionMoreUInt(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
          argwp))),0U))){
      ParaLispObject  * list [ ] = { argwp,&  PLOString_NewCopy(L"<=0")->plo,      NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      goto Exit ;
    }
    if(IsNotNumber(  stclpp ,arghp))
      goto Exit ;
    if(not  FractionIntegerP(
      Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(arghp)))    )){
      ParaLispObject  * list [ ] = { arghp,&  PLOString_NewCopy(
        L" is not integer") ->plo, NULL } ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      goto Exit ;
    }
    if(not  (FractionMoreUInt(
        Complex_CRe(PLOComplexToComplexConst(ParaLispObjectToPLOComplex(
          arghp))),0U))){
      ParaLispObject  * list [ ] = { arghp,&  PLOString_NewCopy(L"<=0")->plo, NULL }  ;
      StackClusterPrivate_ExceptionSet(stclpp ,
        ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
      goto Exit ;
    }
# ifdef  LISP2D_INNERHISTORY
    static  wchar_t  const  Lisp2Dwsih_mapwindow1[] = L"bimnilmapwindow2:new  (std::nothrow)  PLOWindow" ;
    Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , Lisp2Dwsih_mapwindow1  ) ;
# endif    
    PLOWindow_pri  * const w = aligned_alloc ( _Alignof ( PLOWindow_pri ) , sizeof ( PLOWindow_pri ) ) ;
    if  ( w ) {
      PLOWindow_Init  ( w ) ;
      if(PLOWindow_MyDisplay(w))  {
        StackClusterPrivate_SetResult ( stclpp ,
          PLOWindow_staticPushAsNew ( & w -> plo ) ) ;
        PLOWindow_NewMap  ( w , ( UIntXY ) { FractionUIValue  (
            Complex_CRe  (PLOComplexToComplexConst(
              ParaLispObjectToPLOComplexConst  ( argwp  )) ) ) ,
          FractionUIValue  (
            Complex_CRe  (PLOComplexToComplexConst(
              ParaLispObjectToPLOComplexConst  ( arghp  )) ) ) } ) ; 
      } else
        StackClusterPrivate_ExceptionSet(stclpp ,&
          PLOString_NewCopy(L"No display found")->plo);
    } else
      OutOfMemory( stclpp );
  } // argh
Exit:
# ifdef  LISP2D_INNERHISTORY
  { static  wchar_t  const  Lisp2Dwsih_mapwindow2[] = L"bimnilmapwindow2:Quit." ;
    Lisp2DInnerHistoryPush  ( & Lisp2DinnerHistory , Lisp2Dwsih_mapwindow2  ) ;
  }
# endif      
  return  TaskForThread_Analyse ;
}

// nil display-size
TaskForThread Lisp2Dbimnildisplaysize2(StackClusterPrivate  * const stclpp){
  pthread_mutex_lock  ( & Lisp2DmutexXDisplay2  ) ;
  Display * const dpy=XOpenDisplay((char const *)0);
  pthread_mutex_unlock  ( & Lisp2DmutexXDisplay2  ) ;
  if(dpy){
    int const scrnum=DefaultScreen(dpy);

// !? DisplayWidth - 2x Display give full width - what to do ?    
    
    PLOComplex  * const  pdw= NewComplexBareExc ();
  
    Complex_SetInt  ( PLOComplexToComplex( pdw),DisplayWidth(dpy,scrnum));
    PLOComplex  * const  pdh= NewComplexBareExc ();
  
    Complex_SetInt  ( PLOComplexToComplex( pdh),DisplayHeight(dpy,scrnum));
    ParaLispObject  * list [ ] = { &pdw->plo,&pdh->plo      , NULL } ;
    StackClusterPrivate_SetResult(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    pthread_mutex_lock  ( & Lisp2DmutexXDisplay2  ) ;
    XCloseDisplay(dpy);
    pthread_mutex_unlock  ( & Lisp2DmutexXDisplay2  ) ;
  } else
    StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
  return  TaskForThread_Analyse ;
}

// nil display-sizemm
TaskForThread Lisp2Dbimnildisplaysizemm2(StackClusterPrivate  * const stclpp){
  pthread_mutex_lock  ( & Lisp2DmutexXDisplay2  ) ;
  Display * const dpy=XOpenDisplay((char const *)0);
  pthread_mutex_unlock  ( & Lisp2DmutexXDisplay2  ) ;
  if(dpy){
    int const scrnum=DefaultScreen(dpy);
    
    PLOComplex  * const  pdw= NewComplexBareExc ();
  
    Complex_SetInt  ( PLOComplexToComplex( pdw),DisplayWidthMM(dpy,scrnum));
  
    PLOComplex  * const  pdh= NewComplexBareExc ();
  
    Complex_SetInt  ( PLOComplexToComplex( pdh),DisplayHeightMM(dpy,scrnum));
    ParaLispObject  * list [ ] = { &pdw->plo,&pdh->plo      , NULL } ;
    StackClusterPrivate_SetResult(stclpp ,
      ListOfPLO((PArrayPLOP){(ParaLispObject*(*)[])&list}));
    pthread_mutex_lock  ( & Lisp2DmutexXDisplay2  ) ;
    XCloseDisplay(dpy);
    pthread_mutex_unlock  ( & Lisp2DmutexXDisplay2  ) ;
  } else
    StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
  return  TaskForThread_Analyse ;
}

// nil screen-count
TaskForThread Lisp2Dbimnilscreencount2(StackClusterPrivate  * const stclpp){
  pthread_mutex_lock  ( & Lisp2DmutexXDisplay2  ) ;
  Display * const  dpy=XOpenDisplay((char const *)0);
  pthread_mutex_unlock  ( & Lisp2DmutexXDisplay2  ) ;
  if(dpy){
    PLOComplex  * const  sc= NewComplexBareExc (  );
    Complex_SetInt  ( PLOComplexToComplex( sc),ScreenCount(dpy));
    StackClusterPrivate_SetResult(stclpp ,&  sc->plo);
  } else
    StackClusterPrivate_SetResult(stclpp ,&plonil.plo);
  pthread_mutex_lock  ( & Lisp2DmutexXDisplay2  ) ;
  XCloseDisplay(dpy);
  pthread_mutex_unlock  ( & Lisp2DmutexXDisplay2  ) ;
  return  TaskForThread_Analyse ;
}

void PLOWindow_staticDestr  ( ParaLispObject * const me  ) {
  PLOWindow_Destr ( PLOWindow_to_pri  ( ParaLispObjectToPLOWindow ( me  ) ) ) ;
}

# include "window/inline.h"
# include "castb.h"
# include "widestring/inline.h"
# include "window/inlinepri.h"
# else
static  char  const Lisp2D_c7796 __attribute__((unused)) = '\00'  ;
# endif // LISP2D_DONTUSEX11
