// Lisp2D - AddrForReturn for StackCluster
// ©2018-23 by Alex Glebe
# ifndef  LISP2D_ADDRFORRETURN_PUBLIC_H
# define  LISP2D_ADDRFORRETURN_PUBLIC_H

# include "addrforreturn/type.h"
# include "addrforreturn/struct.h"

# define  AddrForReturn2Set Lisp2DAddrForReturn2Set
inline  void  AddrForReturn2Set ( AddrForReturn * , AddrForReturn ) ;
# define  AddrForReturn2ConstructorCopy Lisp2DAddrForReturn2ConstructorCopy
inline  void  AddrForReturn2ConstructorCopy ( AddrForReturn * , AddrForReturn ) ;

# include "eval-addr/public.h"

# define  s_AddrForReturn2ConstructorFlagInBIM Lisp2D_s_AddrForReturn2ConstructorFlagInBIM
# define  t_AddrForReturn2ConstructorFlagInBIM  Lsip2D_t_AddrForReturn2ConstructorFlagInBIM
typedef struct s_AddrForReturn2ConstructorFlagInBIM t_AddrForReturn2ConstructorFlagInBIM ;

struct s_AddrForReturn2ConstructorFlagInBIM {
  AddrForReturn * const me ;
  Lisp2DEvalAddrCont2  const addr ;
  bool const inbim ;
} ;

# define  AddrForReturn2ConstructorFlagInBIM  Lisp2D_AddrForReturn2ConstructorFlagInBIM
void  AddrForReturn2ConstructorFlagInBIM  ( t_AddrForReturn2ConstructorFlagInBIM const * ) ;

# define  AddrForReturn2ConstructorDefault  Lisp2DAddrForReturn2ConstructorDefault
inline  void  AddrForReturn2ConstructorDefault  ( AddrForReturn * ) ;

inline  void  AddrForReturn2Set ( AddrForReturn * const  me , AddrForReturn const  x ) {
  EvalAddrSet ( & me  -> addr . pub , & x . addr . pub ) ;
  me  ->  inBIM = x . inBIM ;
}

inline  void  AddrForReturn2ConstructorCopy ( AddrForReturn * const  me , AddrForReturn const x ) {
  AddrForReturn2Set ( me , x ) ;
}

inline  void  AddrForReturn2ConstructorDefault  ( AddrForReturn * const  me ) {
  EvalAddrSetCont ( & me -> addr . pub , Lisp2DEvalAddrContZero2 ) ;
  me  -> inBIM = false ; 
}
  
# endif // LISP2D_ADDRFORRETURN_PUBLIC_H
