// Lisp2D - BuildInMethod
// ©2011-23 by Alex Glebe

// ! to dir(bim)/ enum , type , struct , public .. .h

# ifndef  LISP2D_BIMC_H
# define  LISP2D_BIMC_H
# define  BoolCheckThis Lisp2D_BoolCheckThis
# define  BoolCheckThis_False Lisp2D_BoolCheckThis_False
# define  BoolCheckThis_True  Lisp2D_BoolCheckThis_True
enum eBoolCheckThis { BoolCheckThis_False = 0U , BoolCheckThis_True = 1U } ;
typedef enum eBoolCheckThis BoolCheckThis ;

# define  BoolThisIsConst Lisp2D_BoolThisIsConst
# define  BoolThisIsConst_False Lisp2D_BoolThisIsConst_False
# define  BoolThisIsConst_True  Lisp2D_BoolThisIsConst_True
enum eBoolThisIsConst { BoolThisIsConst_False = 0U  , BoolThisIsConst_True  = 1U  } ;
typedef enum eBoolThisIsConst BoolThisIsConst ;

# define  NSBIF_NotCalc Lisp2D_NSBIF_NotCalc
# define  NSBIF_ParaCalc  Lisp2D_NSBIF_ParaCalc
//for arguments of function & func-place  
enum  { NSBIF_ParaCalc  , NSBIF_NotCalc } ;
  
# ifdef LISP2D_CONSTRSTAT
  # include <stddef.h>
  # include <stdatomic.h>
  # define  NSBIF_constrstat Lisp2D_NSBIF_constrstat
  extern  _Atomic ( size_t  ) NSBIF_constrstat ;
  # define  NSBIF_constrstat_Value Lisp2D_NSBIF_constrstat_Value
  size_t  NSBIF_constrstat_Value ( void  ) ;
  # define  NSBIF_constrstat_Inc Lisp2D_NSBIF_constrstat_Inc
  void  NSBIF_constrstat_Inc ( void  ) ;
# endif

# include "define.h"
# include "plo/struct.h"
# include "widestring.h"
# include "symbolc.h"
# include "taskforthread.h"
# ifdef  LISP2D_BIMSTAT
# include "statistics.h"
# endif

# define  s_BIFPrivate  Lisp2D_s_BIFPrivate
# define  BIFPrivate  Lisp2D_BIFPrivate
typedef struct  s_BIFPrivate BIFPrivate  ;
struct  s_BIFPrivate {
  ParaLispObject  plo ;
  String  ( WideChar  ) wname ;
  PLOSymbol const * symbolClassName ;
  //before running set the addr of any function
  FuncBiningP funcbining1 ;
  // ! classtype: int -> unsigned
  int classtype ;
  int argumtype ;
# ifdef  LISP2D_BIMSTAT
  Statistics_t  statstatc ;
# endif
  bool flagToCheckThisType ;
  bool flagThisConst ;
  bool  flagExtraThread ;
} ;

# define  BIFPrivateInit  Lisp2D_BIFPrivateInit
void  BIFPrivateInit  ( BIFPrivate  * , int  at , wchar_t volatile const * na , int ct ,
  BoolCheckThis , BoolThisIsConst ) ;
    
# define  BIFPrivateDestr Lisp2D_BIFPrivateDestr
void  BIFPrivateDestr  ( BIFPrivate * ) ;

# define  s_PLOBIF  Lisp2D_s_PLOBIF
struct  s_PLOBIF ;
typedef struct  s_PLOBIF Lisp2D_PLOBIF  ;

struct s_PLOBIF  {
  BIFPrivate  base  ;
} ;

typedef Lisp2D_PLOBIF PLOBIF  ;

# define  s_PLOBIF_Init Lisp2D_s_PLOBIF_Init
# define  t_PLOBIF_Init Lisp2D_t_PLOBIF_Init
typedef struct  s_PLOBIF_Init t_PLOBIF_Init ;
struct  s_PLOBIF_Init {
  PLOBIF * const me ;
  int const at ;
  wchar_t  volatile const * const na ;
  BoolCheckThis const fcheckthis ;
  int const ct ;
  BoolThisIsConst const flagthisconst ;
} ;

# define  PLOBIF_Init Lisp2D_PLOBIF_Init
void  PLOBIF_Init  ( t_PLOBIF_Init ) ;

# define  PLOBIF_Destr  Lisp2D_Destr
void  PLOBIF_Destr  ( PLOBIF *  ) ;

# define  PLOBIF_staticTypeOf Lisp2D_PLOBIF_staticTypeOf
ParaLispObject  * PLOBIF_staticTypeOf ( ParaLispObject const * ) ;
  
# define  PLOBIF_staticClassDef Lisp2D_PLOBIF_staticClassDef
ParaLispObject  * PLOBIF_staticClassDef  ( ParaLispObject const * ) ;
  
# define  PLOBIF_staticClassParents Lisp2D_PLOBIF_staticClassParents
ParaLispObject  * PLOBIF_staticClassParents  ( ParaLispObject const * ) ;
  
# define  PLOBIF_staticGCDeclareContent Lisp2D_PLOBIF_staticGCDeclareContent
void  PLOBIF_staticGCDeclareContent ( ParaLispObject *  ) ;
  
# define  PLOBIF_staticCoutToHuman  Lisp2D_PLOBIF_staticCoutToHuman
void  PLOBIF_staticCoutToHuman ( ParaLispObject const *  me ,
  Lisp2DPLOStream  const *  s , bool flag2pprinted  , Vector  ( StackPLOP )  *  h ) ;
  
# define  PLOBIF_staticCoutToInterpret  Lisp2D_PLOBIF_staticCoutToInterpret
void  PLOBIF_staticCoutToInterpret ( ParaLispObject const *  me ,
  Lisp2DPLOStream  const *  s , bool flag2pprinted  , Vector  ( StackPLOP )  *  h ) ;
    
# define  ParaLispObjectToPLOBIF Lisp2DParaLispObjectToPLOBIF
inline  PLOBIF * ParaLispObjectToPLOBIF ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOBIFConst Lisp2DParaLispObjectToPLOBIFConst
inline  PLOBIF const * ParaLispObjectToPLOBIFConst ( ParaLispObject const * ) ;
# define  PLOBIF_SetExtraThread Lisp2D_PLOBIF_SetExtraThread
inline  void  PLOBIF_SetExtraThread  ( PLOBIF * , bool f ) ;
# define  PLOBIF_IsExtraThread  Lisp2D_PLOBIF_IsExtraThread
inline  bool  PLOBIF_IsExtraThread ( PLOBIF const * ) ;
# define  PLOBIF_FlagThisConst  Lisp2D_PLOBIF_FlagThisConst
inline  bool  PLOBIF_FlagThisConst ( PLOBIF const * ) ;
# define  PLOBIF_CSymbolClassName Lisp2D_PLOBIF_CSymbolClassName
inline  PLOSymbol const * PLOBIF_CSymbolClassName  ( PLOBIF const * ) ;
# define  PLOBIF_ClassType  Lisp2D_PLOBIF_ClassType
inline  int PLOBIF_ClassType ( PLOBIF const * ) ;
# define  PLOBIF_Method Lisp2D_PLOBIF_Method
inline  Lisp2DFuncBiningP const * PLOBIF_Method  ( PLOBIF const * ) ;
# define  PLOBIF_HaveMethod Lisp2D_PLOBIF_HaveMethod
inline  bool  PLOBIF_HaveMethod  ( PLOBIF const * ) ;
# define  PLOBIF_isToCheckThisType  Lisp2D_PLOBIF_isToCheckThisType
inline  bool  PLOBIF_isToCheckThisType ( PLOBIF const * ) ;
# define  PLOBIF_Argumtype  Lisp2D_PLOBIF_Argumtype
inline  int PLOBIF_Argumtype ( PLOBIF const * ) ;
# define  PLOBIF_Name Lisp2D_PLOBIF_Name
inline  String  ( WideChar  ) const * PLOBIF_Name ( PLOBIF  const * ) ;
# define  PLOBIF_staticDestr  Lisp2D_PLOBIF_staticDestr
void PLOBIF_staticDestr  ( ParaLispObject * ) ;
  
# ifdef  LISP2D_BIMSTAT
# define  PLOBIF_Statistc Lisp2D_PLOBIF_Statistc
inline  struct Lisp2DStatistics  * PLOBIF_Statistc ( PLOBIF * ) ;
  
# define  PLOBIF_CStatistc  Lisp2D_PLOBIF_CStatistc
inline  struct Lisp2DStatistics  const * PLOBIF_CStatistc  ( PLOBIF const * ) ;
# endif // LISP2D_BIMSTAT

# define  bimnilbifp  Lisp2Dbimnilbifp2
FuncBining  bimnilbifp ;

// ! to make static PLOBIF..

# define  plobimcomplexmultiply Lisp2D_plobimcomplexmultiply
extern  PLOBIF  *   plobimcomplexmultiply ;
# define  plobimcomplexmultiplysetf Lisp2D_plobimcomplexmultiplysetf
extern  PLOBIF  *   plobimcomplexmultiplysetf ;
# define  plobimcomplexplus Lisp2D_plobimcomplexplus
extern  PLOBIF  *   plobimcomplexplus ;
# define  plobimvectormult  Lisp2D_plobimvectormult
extern  PLOBIF  *   plobimvectormult  ;
# define  plobimvectormultsetf  Lisp2D_plobimvectormultsetf
extern  PLOBIF  *   plobimvectormultsetf  ;
# define  plobimstringplussetf  Lisp2D_plobimstringplussetf
extern  PLOBIF  *   plobimstringplussetf  ;
# define  plobimnilprogn  Lisp2D_plobimnilprogn
extern  PLOBIF  *   plobimnilprogn  ;
# define  plobimcomplexplussetf Lisp2D_plobimcomplexplussetf
extern  PLOBIF  *   plobimcomplexplussetf ;
# define  plobimcomplexminussetf  Lisp2D_plobimcomplexminussetf
extern  PLOBIF  *   plobimcomplexminussetf  ;

# define  BIFp  Lisp2D_BIFp
bool  BIFp  ( ParaLispObject const * ) ;

inline  PLOBIF * ParaLispObjectToPLOBIF ( ParaLispObject * const p ) {
  return (  PLOBIF * ) ( p  ->  vaddr . addr . p ) ;
}

inline  PLOBIF const * ParaLispObjectToPLOBIFConst ( ParaLispObject const * const p ) {
  return (  PLOBIF const * ) ( p  ->  vaddr . addr . p ) ;
}

inline  void  PLOBIF_SetExtraThread  ( PLOBIF * const me , bool const f  ) {
  me -> base  . flagExtraThread  = f ;
}

inline  bool  PLOBIF_IsExtraThread ( PLOBIF const * const me ) {
  return me -> base . flagExtraThread  ;
}

inline  bool  PLOBIF_FlagThisConst ( PLOBIF const * const me ) {
  return me -> base . flagThisConst  ;
}

inline  PLOSymbol const * PLOBIF_CSymbolClassName  ( PLOBIF const * const me ) {
  return me -> base . symbolClassName  ;
}

inline  int PLOBIF_ClassType ( PLOBIF const * const me ) {
  return me -> base . classtype  ;
}

inline  Lisp2DFuncBiningP const * PLOBIF_Method  ( PLOBIF const * const me ) {
  return & me -> base . funcbining1  ;
}

inline  bool  PLOBIF_HaveMethod  ( PLOBIF const * const me ) {
  return  me -> base . funcbining1 ;
}

inline  bool  PLOBIF_isToCheckThisType ( PLOBIF const * const me ) {
  return me -> base . flagToCheckThisType  ;
}

inline  int PLOBIF_Argumtype ( PLOBIF const * const me ) {
  return me -> base . argumtype  ;
}

inline  String  ( WideChar  ) const * PLOBIF_Name ( PLOBIF  const * const b ) {
  return  & b ->  base  . wname  ;
}

# ifdef  LISP2D_BIMSTAT
inline  struct Lisp2DStatistics  * PLOBIF_Statistc ( PLOBIF * const me ) {
  return & me -> base . statstatc ;
}

inline  struct Lisp2DStatistics  const * PLOBIF_CStatistc  ( PLOBIF const * const me ) {
  return & me -> base . statstatc ;
}

# endif // LISP2D_BIMSTAT
# endif // LISP2D_BIMC_H
