// Boolean type
// ©2012-23 Alex Glebe

# include "define.h"

# ifdef LISP2D_CONSTRSTAT
  # include <stddef.h> // size_t
  # define  PLOBooleanconstrstat  Lisp2DPLOBooleanconstrstat
  extern  _Atomic  ( size_t  ) PLOBooleanconstrstat  ;
  # define  PLOBooleanconstrstatCValue  Lisp2DPLOBooleanconstrstatCValue
  size_t  PLOBooleanconstrstatCValue  ( void  ) ;
  # define  PLOBooleanconstrstat_Inc  Lisp2D_PLOBooleanconstrstat_Inc
  void  PLOBooleanconstrstat_Inc  ( void  ) ;
# endif

# include "plo/struct.h"
  
# define  PLOBoolean  Lisp2DPLOBoolean
typedef struct  sLisp2DPLOBoolean PLOBoolean ;
struct  sLisp2DPLOBoolean {
  ParaLispObject  plo ;
} ;

# define  PLOBoolean_Init Lisp2D_PLOBoolean_Init
void  PLOBoolean_Init ( PLOBoolean * ) ;

# define  PLOBooleanDestr Lisp2DPLOBooleanstaticDestr
void PLOBooleanDestr  ( ParaLispObject * ) ;

# define  plotrue Lisp2Dplotrue
extern  PLOBoolean  plotrue ;
# define  plofalse  Lisp2Dplofalse
extern  PLOBoolean  plofalse  ;

# define  ploclassdefboolean  Lisp2Dploclassdefboolean
extern  ParaLispObject  *   ploclassdefboolean  ;

# define  ploclassparentsboolean  Lisp2Dploclassparentsboolean
extern  ParaLispObject  *   ploclassparentsboolean  ;

# define  PLOBooleanClassDef  Lisp2DPLOBooleanstaticClassDef
ParaLispObject  * PLOBooleanClassDef  ( ParaLispObject const * ) ;

# define  PLOBooleanClassParents  Lisp2DPLOBooleanstaticClassParents
ParaLispObject  * PLOBooleanClassParents  ( ParaLispObject const * ) ;

# define  PLOBooleanTypeOf  Lisp2DPLOBooleanTypeOf
ParaLispObject  * PLOBooleanTypeOf ( ParaLispObject const * ) ;

# include "plostream/type.h"

# define  PLOBooleanCoutToHuman Lisp2DPLOBooleanCoutToHuman
void  PLOBooleanCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;

# define  PLOBooleanCoutToInterpret Lisp2DPLOBooleanCoutToInterpret
void  PLOBooleanCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const * , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;

# define  ParaLispObjectToPLOBoolean Lisp2DParaLispObjectToPLOBoolean
inline  PLOBoolean * ParaLispObjectToPLOBoolean ( ParaLispObject * ) ;

# define  bool_xor  Lisp2D_bool_xor
inline  bool  bool_xor  ( bool , bool ) ;

# define  bool_xor_eq Lisp2D_bool_xor_eq4L74
void  bool_xor_eq ( bool  * a , bool b ) ;

inline  PLOBoolean * ParaLispObjectToPLOBoolean ( ParaLispObject * const p ) {
  return (  PLOBoolean * ) ( p  ->  vaddr . addr . p ) ;
}

inline  bool  bool_xor  ( bool const a , bool const b ) {
  return  b ?
    ( not a ) :
    a ;
}

# include "taskforthread.h"
  
# define  bimnilnot Lisp2Dbimnilnot
FuncBining  bimnilnot  ;  
# define  bimnilor  Lisp2Dbimnilor
FuncBining bimnilor   ;
# define  bimnilnor Lisp2Dbimnilnor
  FuncBining bimnilnor   ;
# define  bimnilxor Lisp2Dbimnilxor
  FuncBining bimnilxor  ;
# define  bimniland Lisp2Dbimniland
  FuncBining bimniland  ;
# define  bimnilnand  Lisp2Dbimnilnand
  FuncBining bimnilnand  ;
# define  bimnilimply Lisp2Dbimnilimply
  FuncBining bimnilimply   ;
# define  bimbooleanstring  Lisp2Dbimbooleanstring
  FuncBining  bimbooleanstring ;
# define  bimnilbooleanp  Lisp2Dbimnilbooleanp
  FuncBining  bimnilbooleanp ;
