// Lisp2D - ByteDeque #[]
// ©2014-23 by Alex Glebe

# ifndef  LISP2D_BYTEDEQUE_PUBLIC_H
# define  LISP2D_BYTEDEQUE_PUBLIC_H

# include "bytedeque/type.h"

# define  PLOByteDeque_Init Lisp2D_PLOByteDeque_Init
void  PLOByteDeque_Init ( PLOByteDeque * ) ;

# define  PLOByteDeque_Destr  Lisp2D_PLOByteDeque_Destr
void  PLOByteDeque_Destr ( PLOByteDeque * )  ;

# include <stddef.h>

# define  PLOByteDeque_InitFrom Lisp2D_PLOByteDeque_InitFrom
void  PLOByteDeque_InitFrom ( PLOByteDeque * me , PLOByteDeque const * v  , size_t  indexfirst  ) ;

# define  s_PLOByteDeque_InitFromTo Lisp2D_s_PLOByteDeque_InitFromTo
# define  t_PLOByteDeque_InitFromTo Lisp2D_t_PLOByteDeque_InitFromTo
typedef struct  s_PLOByteDeque_InitFromTo t_PLOByteDeque_InitFromTo ;

struct  s_PLOByteDeque_InitFromTo {
  PLOByteDeque * const me ;
  PLOByteDeque const * const vp  ;
  size_t const indexfirst  ;
  size_t const indexend ;
} ;

# define  PLOByteDeque_InitFromTo Lisp2D_PLOByteDeque_InitFromTo
void  PLOByteDeque_InitFromTo ( t_PLOByteDeque_InitFromTo const * ) ;

# define  PLOByteDeque_InitSize Lisp2D_PLOByteDeque_InitSize
void  PLOByteDeque_InitSize  ( PLOByteDeque * , size_t fullsize ) ;

# include "plo/struct.h"

# define  PLOByteDeque_staticTypeOf Lisp2D_PLOByteDeque_staticTypeOf
ParaLispObject  * PLOByteDeque_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOByteDeque_staticClassDef Lisp2D_PLOByteDeque_staticClassDef
ParaLispObject  * PLOByteDeque_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOByteDeque_staticClassParents Lisp2D_PLOByteDeque_staticClassParents
ParaLispObject  * PLOByteDeque_staticClassParents  ( ParaLispObject const * ) ;

// Lock's not used
# define  PLOByteDeque_staticDeclareForGC Lisp2D_PLOByteDeque_staticDeclareForGC
void  PLOByteDeque_staticDeclareForGC ( ParaLispObject * ) ;

# include <stdint.h>

// returns error  
# define  PLOByteDeque_PushBack2  Lisp2D_PLOByteDeque_PushBack2
bool  PLOByteDeque_PushBack2  ( PLOByteDeque * me , uint8_t  x2 ) ;

# define  PLOByteDeque_PushFront2 Lisp2D_PLOByteDeque_PushFront2
bool  PLOByteDeque_PushFront2( PLOByteDeque * me ,uint8_t  x2) ;

# define  PLOByteDeque_PopBack2 Lisp2D_PLOByteDeque_PopBack2
bool  PLOByteDeque_PopBack2( PLOByteDeque * me ,uint8_t  * res2) ;

# define  PLOByteDeque_PopFront2  Lisp2D_PLOByteDeque_PopFront2
bool  PLOByteDeque_PopFront2 ( PLOByteDeque * me , uint8_t  * res2 ) ;

# define  PLOByteDeque_Back2  Lisp2D_PLOByteDeque_Back2
bool  PLOByteDeque_Back2( PLOByteDeque const *  me ,  uint8_t  * res2) ;

# define  PLOByteDeque_Front2 Lisp2D_PLOByteDeque_Front2
bool  PLOByteDeque_Front2 ( PLOByteDeque const * me ,  uint8_t  * res2 ) ;

# define  PLOByteDeque_Clear  Lisp2D_PLOByteDeque_Clear
void PLOByteDeque_Clear ( PLOByteDeque * ) ;

# define  PLOByteDeque_Set  Lisp2D_PLOByteDeque_Set
void  PLOByteDeque_Set  ( PLOByteDeque * me , PLOByteDeque  const * x) ;

# define  PLOByteDeque_SetFrontNotCheckNotResize Lisp2D_PLOByteDeque_SetFrontNotCheckNotResize
void  PLOByteDeque_SetFrontNotCheckNotResize  ( PLOByteDeque * me , uint8_t const * p, size_t  s ) ;

# define  PLOByteDeque_Resize2  Lisp2D_PLOByteDeque_Resize2
void  PLOByteDeque_Resize2  ( PLOByteDeque * me  , size_t const  s  , uint8_t  const v2 )  ;

# include "deque/type-byte.h"
  
# define  PLOByteDeque_SwapDeque  Lisp2D_PLOByteDeque_SwapDeque
void  PLOByteDeque_SwapDeque  ( PLOByteDeque * , Deque ( Byte ) * ) ;

# define  PLOByteDeque_SubSeq Lisp2D_PLOByteDeque_SubSeq
void  PLOByteDeque_SubSeq  ( PLOByteDeque * me , PLOByteDeque const * v  , size_t  indexfirst  , size_t e ) ;

# define  PLOByteDeque_staticisBADCopyPrivate  Lisp2D_PLOByteDeque_staticisBADCopyPrivate
bool  PLOByteDeque_staticisBADCopyPrivate  ( ParaLispObject const  * me , ParaLispObject  * * const resultp  ) ;

# include "plostream/type.h"

# define  PLOByteDeque_staticCoutToHuman  Lisp2D_PLOByteDeque_staticCoutToHuman
void  PLOByteDeque_staticCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP )  *  h ) ;

# define  PLOByteDeque_staticCoutToInterpret Lisp2D_PLOByteDeque_staticCoutToInterpret
void  PLOByteDeque_staticCoutToInterpret ( ParaLispObject const * me , PLOStream  const * s ,
  bool flag2pprinted  , Vector ( StackPLOP )  * h ) ;

# define  ByteVectorp Lisp2D_ByteVectorp
bool  ByteVectorp ( ParaLispObject  const * x ) ;

# include "stcl/classc.h"

# define  IsNotByteDeque  Lisp2D_IsNotByteDeque
bool  IsNotByteDeque  ( StackClusterPrivate  *  ,  ParaLispObject  *  )  ;

# define  IsNotByteDequeLockGC  Lisp2D_IsNotByteDequeLockGC
bool  IsNotByteDequeLockGC  ( StackClusterPrivate  *  ,  ParaLispObject  *  )  ;

FuncBining  Lisp2Dbimbytevectorbytevector2  ;
  FuncBining  Lisp2DbimnilbytevectorP2 ;
  FuncBining  Lisp2DbimbytedequeSetf2 ;
  FuncBining  Lisp2DbimbytedequeSwap2 ;
  FuncBining  Lisp2Dbimbytedequesize2 ;
  FuncBining  Lisp2DbimbytedequeElt2 ;
  FuncBining  Lisp2DbimbytedequeSetelt2 ;
  FuncBining  Lisp2Dbimbytedequeresize2 ;
  FuncBining  Lisp2Dbimbytedequepushback2 ;
  FuncBining  Lisp2Dbimbytedequepushfront2   ;
  FuncBining  Lisp2Dbimbytedequepopback2   ;
  FuncBining  Lisp2Dbimbytedequepopfront2  ;
  FuncBining  Lisp2Dbimbytedequeclear2   ;
  FuncBining  Lisp2Dbimbytedequeempty2   ;
  FuncBining  Lisp2Dbimbytedequeback2  ;
  FuncBining  Lisp2Dbimbytedequefront2   ;
  FuncBining  Lisp2DbimbytedequeVector2  ;
  FuncBining  Lisp2DbimbytedequeString2  ;
  FuncBining  Lisp2DbimbytedequeList2  ;
  FuncBining  Lisp2Dbimbytedequesubseq2  ;
  FuncBining  Lisp2Dbimbytevectorchar ;
  
# include "define.h"
# include "bytedeque/struct.h"
# include "deque/type-byte.h"
# include "deque/public.h"
# include "bytedeque/public.h"
# include "deque/public-byte.h"
# include "bytedeque/vectorlength.h"
# include "plo/public.h"

# define  PLOByteDeque_InitCopy Lisp2D_PLOByteDeque_InitCopy
void  PLOByteDeque_InitCopy ( PLOByteDeque * , PLOByteDeque const * ) ;
# define  ParaLispObjectToPLOByteDeque Lisp2DParaLispObjectToPLOByteDeque
inline  PLOByteDeque * ParaLispObjectToPLOByteDeque ( ParaLispObject * ) ;
# define  PLOByteDeque_staticDestr  Lisp2D_PLOByteDeque_staticDestr
void PLOByteDeque_staticDestr  ( ParaLispObject * ) ;
# define  PLOByteDeque_Resize Lisp2D_PLOByteDeque_Resize
inline  void PLOByteDeque_Resize  ( PLOByteDeque * , size_t ) ;
// very big count of temporary size_t variables
# define  PLOByteDeque_Size Lisp2D_PLOByteDeque_Size
inline size_t  PLOByteDeque_Size  ( PLOByteDeque const * ) ;
# define  PLOByteDeque_CValue Lisp2D_PLOByteDeque_CValue
inline  Deque ( Byte  ) const * PLOByteDeque_CValue  ( PLOByteDeque const * ) ;
# define  ParaLispObjectToPLOByteDequeConst Lisp2DParaLispObjectToPLOByteDequeConst
inline  PLOByteDeque const * ParaLispObjectToPLOByteDequeConst ( ParaLispObject const * ) ;
# define  PLOByteDeque_SetAt Lisp2D_PLOByteDeque_SetAt
uint8_t  * PLOByteDeque_SetAt ( PLOByteDeque * , size_t  index , uint8_t val ) ;
# define  PLOByteDeque_AtValue Lisp2D_PLOByteDeque_AtValue
uint8_t PLOByteDeque_AtValue ( PLOByteDeque const * , size_t index ) ;
# define  PLOByteDeque_Empty  Lisp2D_PLOByteDeque_Empty
inline  bool  PLOByteDeque_Empty ( PLOByteDeque const * ) ;
# define  PLOByteDeque_Swap Lisp2D_PLOByteDeque_Swap
void  PLOByteDeque_Swap  ( PLOByteDeque  * , PLOByteDeque  * ) ;

inline  PLOByteDeque * ParaLispObjectToPLOByteDeque ( ParaLispObject * const p ) {
  return (  PLOByteDeque * ) ( p  ->  vaddr . addr . p ) ;
}

inline  void PLOByteDeque_Resize  ( PLOByteDeque * const me  , size_t const s  ) {
  Deque ( Byte ) * const ldb = & me -> dqbyte ;
  Deque_Resize ( Byte ) ( ldb , s ) ;
}

// very big count of temporary size_t variables
inline size_t  PLOByteDeque_Size  ( PLOByteDeque const * const me ) {
  return  Deque_Size ( Byte ) ( & me  ->  dqbyte )  ;
}

inline  Deque ( Byte  ) const * PLOByteDeque_CValue  ( PLOByteDeque const * const me ) {
  return & me  ->  dqbyte  ;
}

inline  PLOByteDeque const * ParaLispObjectToPLOByteDequeConst ( ParaLispObject const * const p ) {
  return (  PLOByteDeque const * ) ( p  ->  vaddr . addr . p ) ;
}

inline  bool  PLOByteDeque_Empty ( PLOByteDeque const * const me ) {
  return Deque_Empty ( Byte ) ( & me -> dqbyte ) ;
}

# include "stcl/inline.h"

# endif // LISP2D_BYTEDEQUE_PUBLIC_H
