// Lisp2D ©2020-3 Glebe A.N.
// type cast protected

# ifndef  LISP2D_CAST_H
# define  LISP2D_CAST_H

# include <stdint.h>

# define  uint8_cast_uint16 Lisp2D_uint8_cast_uint16
inline  uint16_t  uint8_cast_uint16 ( uint8_t ) ;
# define  uint8_cast_uint Lisp2D_uint8_cast_uint
inline  unsigned int  uint8_cast_uint ( uint8_t ) ;
# define  uint16_cast_uint8 Lisp2D_uint16_cast_uint8
inline  uint8_t  uint16_cast_uint8 ( uint16_t ) ;
# define  int_cast_uint8 Lisp2D_int_cast_uint8
inline  uint8_t  int_cast_uint8 ( int ) ;
# define  uint_cast_uint8 Lisp2D_uint_cast_uint8
inline  uint8_t  uint_cast_uint8 ( unsigned  int ) ;
# define  int_cast_uint16 Lisp2D_int_cast_uint16
inline  uint16_t  int_cast_uint16 ( int ) ;
# define  uint_cast_uint16 Lisp2D_uint_cast_uint16
inline  uint16_t  uint_cast_uint16 ( unsigned int ) ;
# define  int_cast_size Lisp2D_int_cast_size

# include <stddef.h> // size_t ptrdiff_t

inline  size_t  int_cast_size ( int ) ;
# define  uint_cast_size Lisp2D_uint_cast_size
inline  size_t  uint_cast_size ( unsigned  int ) ;
# define  int_cast_uint Lisp2D_int_cast_uint
inline  unsigned  int int_cast_uint ( int ) ;
# define  char_cast_uint8 Lisp2D_char_cast_uint8
inline  uint8_t  char_cast_uint8 ( char ) ;
# define  uint8_cast_char Lisp2D_uint8_cast_char
inline  char  uint8_cast_char ( uint8_t ) ;
# define  uint16_cast_char Lisp2D_uint16_cast_char
inline  char  uint16_cast_char ( uint16_t ) ;
# define  int_cast_char Lisp2D_int_cast_char
inline  char  int_cast_char ( int ) ;
# define  charvolatilep_cast_charp Lisp2D_charvolatilep_cast_charp
inline  char * charvolatilep_cast_charp ( char volatile * ) ;
# define  uint8volatilep_cast_unt8p Lisp2D_uint8volatilep_cast_unt8p
inline  uint8_t * uint8volatilep_cast_unt8p ( uint8_t volatile * ) ;
# define  lint_cast_ulint Lisp2D_lint_cast_ulint
inline  unsigned  long  int lint_cast_ulint ( long  int ) ;
# define  ulint_cast_uint Lisp2D_ulint_cast_uint
inline  unsigned int ulint_cast_uint ( unsigned long  int ) ;
# define  ullint_cast_uint Lisp2D_ullint_cast_uint
inline  unsigned int ullint_cast_uint ( unsigned long  long  int ) ;
# define  ulint_cast_lint Lisp2D_ulint_cast_lint
inline  long int ulint_cast_lint ( unsigned long  int ) ;
# define  wchar_cast_byte Lisp2D_wchar_cast_byte
inline  uint8_t wchar_cast_byte ( wchar_t ) ;
# define  wchar_cast_uint Lisp2D_wchar_cast_uint
inline  unsigned int wchar_cast_uint ( wchar_t ) ;

# include <wctype.h> // wint_t

# define  wchar_cast_wint Lisp2D_wchar_cast_wint
inline  wint_t wchar_cast_wint ( wchar_t ) ;
# define  wint_cast_wchar Lisp2D_wint_cast_wchar
inline  wchar_t wint_cast_wchar ( wint_t ) ;
# define  voidcp_cast_uintcp  Lisp2D_voidcp_cast_uintcp
inline  unsigned int const *  voidcp_cast_uintcp ( void const * ) ;
# define  voidp_cast_uintp  Lisp2D_voidp_cast_uintp
inline  unsigned int *  voidp_cast_uintp ( void * ) ;
# define  voidp_cast_bytep  Lisp2D_voidp_cast_bytep
inline  uint8_t * voidp_cast_bytep ( void  * ) ;
# define  const_voidp_cast_bytep  Lisp2D_const_voidp_cast_bytep
inline  uint8_t const * const_voidp_cast_bytep ( void  const  * ) ;
# define  size_cast_uint  Lisp2D_size_cast_uint
inline  unsigned  int size_cast_uint  ( size_t ) ;
# define  size_cast_int  Lisp2D_size_cast_int
inline  int size_cast_int  ( size_t ) ;

# define  ldouble_cast_uint  Lisp2D_ldouble_cast_uint
inline  unsigned int ldouble_cast_uint ( long double ) ;
# define  ldouble_cast_int  Lisp2D_ldouble_cast_int
inline  int ldouble_cast_int ( long double ) ;
# define  uint_cast_uchar Lisp2D_uint_cast_uchar
inline  unsigned char uint_cast_uchar ( unsigned  int ) ;
# define  uint_cast_ushort  Lisp2D_uint_cast_ushort
inline  unsigned short int  uint_cast_ushort  ( unsigned  int ) ;
# define  uint64_cast_uint  Lisp2D_uint64_cast_uint
inline  unsigned  int uint64_cast_uint ( uint64_t const u ) ;

# include <sys/types.h> // ssize_t

# define  ssize_cast_size Lisp2D_ssize_cast_size
inline  size_t  ssize_cast_size ( ssize_t ) ;
# define  size_cast_ssize Lisp2D_size_cast_ssize
inline  ssize_t  size_cast_ssize ( size_t ) ;
# define  uint_cast_int Lisp2D_uint_cast_int
inline int uint_cast_int ( unsigned int ) ;
# define  longint_cast_size_t Lisp2D_longint_cast_size_t
inline  size_t  longint_cast_size_t ( long  int ) ;
# define  uint_cast_wchar  Lisp2D_uint_cast_wchar
inline  wchar_t uint_cast_wchar  ( unsigned int ) ;
# define  char_cast_uchar Lisp2D_char_cast_uchar
inline  unsigned  char char_cast_uchar  ( char ) ;
# define  charcp_cast_ucharcp Lisp2D_charcp_cast_ucharcp
inline  unsigned  char const * charcp_cast_ucharcp  ( char const * ) ;
# define  char_cast_schar Lisp2D_char_cast_schar
inline  signed  char char_cast_schar  ( char ) ;
# define  uchar_cast_uint Lisp2D_uchar_cast_uint
inline  unsigned  int uchar_cast_uint  ( unsigned char ) ;
# define  int_cast_wchar  Lisp2D_int_cast_wchar
inline  wchar_t int_cast_wchar  ( int ) ;
# define  sizet_cast_longint  Lisp2D_sizet_cast_longint
inline  long  int sizet_cast_longint  ( size_t ) ;
# define  uint_cast_longint  Lisp2D_uint_cast_longint
inline  long  int uint_cast_longint  ( unsigned int ) ;
# define  uint_cast_ulint Lisp2D_uint_cast_ulint
inline  unsigned  long  int uint_cast_ulint ( unsigned  int ) ;
# define  longint_cast_uint  Lisp2D_longint_cast_uint
inline  unsigned  int longint_cast_uint  ( long int ) ;
# define  size_cast_ptrdiff Lisp2D_size_cast_ptrdiff
inline  ptrdiff_t size_cast_ptrdiff ( size_t ) ;
# define  ptrdiff_cast_uint Lisp2D_ptrdiff_cast_uint
inline  unsigned  int ptrdiff_cast_uint ( ptrdiff_t ) ;
# define  size_cast_longdouble  Lisp2D_size_cast_longdouble
inline  long  double size_cast_longdouble  ( size_t ) ;

# define  ldouble_cast_size  Lisp2D_ldouble_cast_size
inline  size_t ldouble_cast_size  ( long double ) ;

# define ulint_cast_wchar Lisp2D_ulint_cast_wchar
inline  wchar_t ulint_cast_wchar ( unsigned long int ) ;
# define lint_cast_wchar Lisp2D_lint_cast_wchar
inline  wchar_t lint_cast_wchar ( long int ) ;
# define  wcharp_cast_wcharap Lisp2D_wcharp_cast_wcharap
inline  wchar_t const ( *  wcharp_cast_wcharap ( wchar_t const * ) ) [ ] ;
# define  wcharap_cast_wcharp Lisp2D_wcharap_cast_wcharp
inline  wchar_t const * wcharap_cast_wcharp ( wchar_t const ( * x ) [ ] ) ;
# define  uint8_cast_longdouble Lisp2D_uint8_cast_longdouble
inline  long  double   uint8_cast_longdouble  ( uint8_t ) ;

# define  uchar_cast_ldouble Lisp2D_uchar_cast_ldouble
inline  long  double   uchar_cast_ldouble  ( unsigned char ) ;

# define  longdouble_cast_uint8 Lisp2D_longdouble_cast_uint8
inline  uint8_t   longdouble_cast_uint8  ( long  double ) ;

# define  ldouble_cast_uchar Lisp2D_ldouble_cast_uchar
inline  unsigned char   ldouble_cast_uchar  ( long  double ) ;

# define  slong_cast_ldouble  Lisp2D_slong_cast_ldouble
inline  long double slong_cast_ldouble ( long int ) ;
# define  int_cast_byte Lisp2D_int_cast_byte
inline  uint8_t int_cast_byte ( int ) ;
# define  voidp_cast_wcharp  Lisp2D_voidp_cast_wcharp
inline  wchar_t * voidp_cast_wcharp ( void  * ) ;
# define  const_voidp_cast_wcharp  Lisp2D_const_voidp_cast_wcharp
inline  wchar_t const * const_voidp_cast_wcharp ( void  const * ) ;
# define  wchar_cast_char Lisp2D_wchar_cast_char
inline  char  wchar_cast_char ( wchar_t ) ;
# define  uint_cast_char Lisp2D_uint_cast_char
inline  char  uint_cast_char ( unsigned int ) ;
# define  wcharconstvolatp_cast_wcharconstp  Lisp2D_wcharconstvolatp_cast_wcharconstp
inline  wchar_t const * wcharconstvolatp_cast_wcharconstp ( wchar_t volatile const * ) ;
# define  voidvolatp_cast_voidp  Lisp2D_voidvolatp_cast_voidp
inline  void  *  voidvolatp_cast_voidp ( void volatile * ) ;

# endif // LISP2D_CAST_H  
