// Character public
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_CHAR_PUBLIC_H
# define  LISP2D_CHAR_PUBLIC_H
# include "define.h"
# include <stddef.h>
# ifdef  LISP2D_CONSTRSTAT

# define  PLOChar_constrstat_Inc  Lisp2D_PLOChar_constrstat_Inc
void  PLOChar_constrstat_Inc  ( void  ) ;

# define  PLOChar_constrstat_Value  Lisp2D_PLOChar_constrstat_Value
size_t  PLOChar_constrstat_Value  ( void  ) ;

# endif // LISP2D_CONSTRSTAT

# include "char/type.h"

# define  PLOChar_InitValue Lisp2D_PLOChar_InitValue
void PLOChar_InitValue ( PLOCharPriv * me , wchar_t v ) ;

# define  PLOChar_Destr Lisp2D_PLOChar_Destr
void  PLOChar_Destr ( PLOCharPriv * me ) ;

# include "plo/struct.h"

# define  PLOChar_staticTypeOf  Lisp2D_PLOChar_staticTypeOf
ParaLispObject  * PLOChar_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOChar_staticClassDef  Lisp2D_PLOChar_staticClassDef
ParaLispObject  * PLOChar_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOChar_staticClassParents  Lisp2D_PLOChar_staticClassParents
ParaLispObject  * PLOChar_staticClassParents  ( ParaLispObject const * ) ;

# define  PLOChar_staticisBADCopyPrivate  Lisp2D_PLOChar_staticisBADCopyPrivate
bool  PLOChar_staticisBADCopyPrivate  ( ParaLispObject const * me , ParaLispObject  * * resultp  ) ;

# include "plostream/type.h"

# define  PLOChar_staticCoutToHuman Lisp2D_PLOChar_staticCoutToHuman
void  PLOChar_staticCoutToHuman ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector  ( StackPLOP ) *  h ) ;

# define  PLOChar_staticCoutToInterpret Lisp2D_PLOChar_staticCoutToInterpret
void  PLOChar_staticCoutToInterpret ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector  ( StackPLOP ) *  h ) ;

# define  PLOChar_Eq  Lisp2D_PLOChar_Eq
bool  PLOChar_Eq  ( PLOCharPub  const * , PLOCharPub const * ) ;

# define  PLOChar_Less  Lisp2D_PLOChar_Less
bool  PLOChar_Less  ( PLOCharPub const * , PLOCharPub const  * ) ;

# include "taskforthread.h"

FuncBining Lisp2Dbimnilcharp2  ;
FuncBining Lisp2Dbimcharequal2 ;
  FuncBining Lisp2Dbimcharlessoreq3 ;
  FuncBining Lisp2Dbimcharnumber   ;
  FuncBining Lisp2Dbimcharsymbol2 ;
  FuncBining Lisp2Dbimcharstring2 ;
  FuncBining Lisp2Dbimcharnotequal2 ;
  FuncBining Lisp2Dbimcharless3 ;
  FuncBining Lisp2Dbimcharmore3 ;
  FuncBining Lisp2Dbimcharmoreoreq3 ;
  FuncBining Lisp2Dbimcharmin2 ;
  FuncBining Lisp2Dbimcharmax2 ;
  FuncBining Lisp2Dbimcharalphap2 ;
  FuncBining Lisp2Dbimcharupperp2 ;
  FuncBining Lisp2Dbimcharlowerp2 ;
  FuncBining Lisp2Dbimchardigitp2 ;
  FuncBining Lisp2Dbimcharspacep2 ;
  FuncBining Lisp2Dbimcharcontrolp2 ;
  FuncBining Lisp2Dbimcharprintp2 ;
  FuncBining Lisp2Dbimcharupper2 ;
  FuncBining Lisp2Dbimcharlower2 ;
  FuncBining Lisp2Dbimcharsetf2  ;
  FuncBining Lisp2Dbimcharswap2  ;
  FuncBining Lisp2Dbimcharchar   ;  
  FuncBining  Lisp2Dbimcharbytevector ;

# define  Charp Lisp2D_Charp
bool  Charp ( ParaLispObject const * ) ;

# define  IsNotChar Lisp2D_IsNotChar
bool  IsNotChar ( StackClusterPrivate  * , ParaLispObject * )  ;

# define  CreateSetCharNameValue  Lisp2D_CreateSetCharNameValue
void  CreateSetCharNameValue  ( void ) ;  

# define  DeleteSetCharNameValue  Lisp2D_DeleteSetCharNameValue
void  DeleteSetCharNameValue  ( void  ) ;

# define  ParaLispObjectToPLOChar Lisp2DParaLispObjectToPLOChar
inline  PLOCharPub * ParaLispObjectToPLOChar  ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOCharConst Lisp2DParaLispObjectToPLOCharConst
inline  PLOCharPub const * ParaLispObjectToPLOCharConst ( ParaLispObject const * ) ;
# define  PLOChar_staticDestr Lisp2D_PLOChar_staticDestr
void PLOChar_staticDestr  ( ParaLispObject * ) ;
# define  PLOChar_Swap  Lisp2D_PLOChar_Swap
void  PLOChar_Swap  ( PLOCharPub  * , PLOCharPub  * ) ;
# define  PLOChar_Set Lisp2D_PLOChar_Set
inline  void  PLOChar_Set ( PLOCharPub  * , PLOCharPub const * ) ;
# define  PLOChar_SetValue Lisp2D_PLOChar_SetValue
void  PLOChar_SetValue ( PLOCharPub  * , wchar_t ) ;
# define  PLOChar_Value  Lisp2D_PLOChar_Value
wchar_t PLOChar_Value  ( PLOCharPub const * ) ;
# define  PLOChar_SetULInt  Lisp2D_PLOChar_SetULInt
inline  void PLOChar_SetULInt ( PLOCharPub  * , unsigned long int ) ;
# define  PLOChar_SetLInt  Lisp2D_PLOChar_SetLInt
inline  void PLOChar_SetLInt ( PLOCharPub  * , long int ) ;
# define  PLOChar_Init  Lisp2D_PLOChar_Init
void  PLOChar_Init ( PLOCharPriv * ) ;
# define  PLOChar_InitULInt Lisp2D_PLOChar_InitULInt
inline  void  PLOChar_InitULInt ( PLOCharPriv * , unsigned  long  int ) ;
# define  PLOChar_InitInt Lisp2D_PLOChar_InitInt
void PLOChar_InitInt ( PLOCharPriv * , int ) ;
# define  PLOChar_InitCopy  Lisp2D_PLOChar_InitCopy
void  PLOChar_InitCopy ( PLOCharPriv * , PLOCharPub const * ) ;
# define  PLOChar_NotEq Lisp2D_PLOChar_NotEq
inline  bool  PLOChar_NotEq ( PLOCharPub  const * , PLOCharPub  const  * ) ;
# define  PLOChar_LessEq  Lisp2D_PLOChar_LessEq
bool  PLOChar_LessEq ( PLOCharPub  const * , PLOCharPub  const  * ) ;
# define  PLOChar_MoreEq  Lisp2D_PLOChar_MoreEq
bool  PLOChar_MoreEq ( PLOCharPub  const * , PLOCharPub  const  * ) ;
# define  PLOChar_More  Lisp2D_PLOChar_More
inline  bool  PLOChar_More ( PLOCharPub const * , PLOCharPub  const  * ) ;

# include "char/structpri.h"

inline  PLOCharPub * ParaLispObjectToPLOChar  ( ParaLispObject * const p ) {
  return &((  PLOCharPriv * ) ( p  ->  vaddr . addr . p ) ) -> pub ;
}

inline  PLOCharPub const * ParaLispObjectToPLOCharConst ( ParaLispObject const * const p ) {
  return &((  PLOCharPriv const * ) ( p  ->  vaddr . addr . p ) ) -> pub ;
}

# include "char/struct.h"
# include "char/private.h"

inline  void  PLOChar_Set ( PLOCharPub  * const me , PLOCharPub const * const x ) {
  if  ( me not_eq  x ) {
    PLOCharPriv * const mep = CharPub_cast_CharPriv ( me  ) ;
    PLOCharPriv const * xp = CharPub_cast_CharPrivConst ( x ) ;
    mep -> value  = (  xp -> value ) ;
  }
}

# include "castb.h"

inline  void PLOChar_SetULInt ( PLOCharPub  * const me , unsigned long int const x ) {
  PLOCharPriv * const mep = CharPub_cast_CharPriv ( me  ) ;
  mep -> value  = ulint_cast_wchar ( x ) ;
}

inline  void PLOChar_SetLInt ( PLOCharPub  * const me , long int const x ) {
  PLOCharPriv * const mep = CharPub_cast_CharPriv ( me  ) ;
  mep -> value  = lint_cast_wchar ( x ) ;
}

# include "plo/public.h"

inline  void  PLOChar_InitULInt ( PLOCharPriv * const me , unsigned  long  int const v ) {
  me -> value = ulint_cast_wchar ( v ) ;
  VirtualTypePointer  const vtp = { . addr = { . p = me } , . type = TypeGlobalListMemberPLOChar } ;
  ParaLispObject_InitVTP  ( & me  ->  pub . plo , vtp ) ;
# ifdef  LISP2D_CONSTRSTAT
  PLOChar_constrstat_Inc  ( ) ;
# endif
}

inline  bool  PLOChar_NotEq ( PLOCharPub  const * const x  , PLOCharPub  const  * const y ) {
  return not  PLOChar_Eq ( x , y ) ;
}

inline  bool  PLOChar_More ( PLOCharPub const * const x , PLOCharPub  const  * const y ) {
  return PLOChar_Less ( y  , x ) ;
}

# include "char/inlinepri.h"

# endif // LISP2D_CHAR_PUBLIC_H
