// 2023 Complex Public
# ifndef  LISP2D_COMPLEX_PUBLIC_H
# define  LISP2D_COMPLEX_PUBLIC_H

# include "define.h"

# define  Complex_CoutDefaultDepth  Lisp2D_Complex_CoutDefaultDepth
enum { Complex_CoutDefaultDepth  = 12 } ;

# ifdef  LISP2D_CONSTRSTAT

# define  Complex_constrstat_Value  Lisp2D_Complex_constrstat_Value
size_t  Complex_constrstat_Value ( void ) ;

# endif

# include "complex/type.h"

// 0/0+0/0i
# define  Complex_Init  Lisp2D_Complex_Init
void  Complex_Init  ( Complex * me  ) ;  
  
# define  Complex_InitCopy  Lisp2D_Complex_InitCopy
void  Complex_InitCopy  ( Complex * me , Complex const * xp ) ;  
  
# define  Complex_InitMove  Lisp2D_Complex_InitMove
void  Complex_InitMove  ( Complex * me , Complex  * xp ) ;

# define  Complex_Set Lisp2D_Complex_Set
void  Complex_Set ( Complex  * , Complex  const  *  ) ;

# define  Complex_Swap  Lisp2D_Complex_Swap
void  Complex_Swap  ( Complex * , Complex  * ) ;

# define  Complex_Move  Lisp2D_Complex_Move
void  Complex_Move  ( Complex * , Complex  * ) ;

# include "ulong/private.h"

# define  Complex_SetULong  Lisp2D_Complex_SetULong
void  Complex_SetULong  ( Complex * , ULongPub  const *  ) ;

# define  Complex_SwapULong Lisp2D_Complex_SwapULong
void  Complex_SwapULong ( Complex * , ULongPub * )  ;

# define  Complex_MoveULong Lisp2D_Complex_MoveULong
void  Complex_MoveULong ( Complex * , ULongPub * )  ;

# define  Complex_SetUInt Lisp2D_Complex_SetUInt
void  Complex_SetUInt ( Complex * , unsigned int ) ;

# define  Complex_SetInt  Lisp2D_Complex_SetInt
void Complex_SetInt  ( Complex * , int )  ;

# include "fraction/type.h"

# define  Complex_SetFraction Lisp2D_Complex_SetFraction
void  Complex_SetFraction ( Complex * , FractionPub const  * ) ;

# define  Complex_SwapFraction  Lisp2D_Complex_SwapFraction
void  Complex_SwapFraction  ( Complex * , FractionPub * )  ;

# define  Complex_SetULInt  Lisp2D_Complex_SetULInt
void  Complex_SetULInt  ( Complex * , unsigned long  int ) ;

# define  Complex_SetLInt Lisp2D_Complex_SetLInt
void  Complex_SetLInt ( Complex * , long  int ) ;

# include "sys/types.h" // off_t

# define  Complex_SetOff  Lisp2D_Complex_SetOff
void  Complex_SetOff ( Complex * , off_t ) ;

# define  Complex_SetSSize  Lisp2D_Complex_SetSSize
void  Complex_SetSSize ( Complex * , ssize_t )  ;

# define  Complex_SetUSize  Lisp2D_Complex_SetUSize
void  Complex_SetUSize  ( Complex * , size_t )  ;

# define  Complex_SetWChar  Lisp2D_Complex_SetWChar
void  Complex_SetWChar  ( Complex * , wchar_t ) ;

# define  Complex_Set0  Lisp2D_Complex_Set0
void  Complex_Set0  ( Complex  * ) ;

# define  Complex_SetRealFractionUInt Lisp2D_Complex_SetRealFractionUInt
void  Complex_SetRealFractionUInt ( Complex * , unsigned  int  num ,
  unsigned int  den ) ;

# define  Complex_SetExactFromLD  Lisp2D_Complex_SetExactFromLD
void  Complex_SetExactFromLD  ( Complex * , long  double )  ;

# define  Complex_SetLDComplex Lisp2D_Complex_SetCComplex
void  Complex_SetLDComplex  ( Complex * , long double _Complex ) ;

# include "plo/type.h"
# include "taskforthread.h"

# define  IsNotNumber Lisp2D_IsNotNumber
bool  IsNotNumber ( StackClusterPrivate  * , ParaLispObject * ) ;

# define  Numberp Lisp2D_Numberp
bool  Numberp ( ParaLispObject  const * ) ;

# include "plostream/type.h"

# define  Complex_CoutToInterpret Lisp2D_Complex_CoutToInterpret
void  Complex_CoutToInterpret ( Complex const * , PLOStream  const * ) ;
  
# define  Complex_CoutToHuman Lisp2D_Complex_CoutToHuman
void  Complex_CoutToHuman ( Complex const * , PLOStream  const *  ) ;

# define  Complex_AddConst Lisp2D_Complex_AddConst
void  Complex_AddConst ( Complex * , Complex const  * ) ;

# define  Complex_AddMove Lisp2D_Complex_AddMove
void  Complex_AddMove ( Complex * , Complex * ) ;

# define  Complex_Subtract  Lisp2D_Complex_Subtract
void  Complex_Subtract  ( Complex * , Complex const  * )  ;

# define  Complex_Div Lisp2D_Complex_Div
void  Complex_Div ( Complex * , Complex const * ) ;

# define  Complex_DivFraction Lisp2D_Complex_DivFraction
void  Complex_DivFraction ( Complex * , FractionPub const  * ) ;

# define  Complex_DivUInt Lisp2D_Complex_DivUInt
void  Complex_DivUInt ( Complex * , unsigned  int ) ;

# define  Complex_Mul Lisp2D_Complex_Mul
void  Complex_Mul ( Complex * , Complex const  * ) ;

# define  Complex_MulFraction Lisp2D_Complex_MulFraction
void  Complex_MulFraction ( Complex * , FractionPub const * ) ;

# define  Complex_MulUInt Lisp2D_Complex_MulUInt
void  Complex_MulUInt ( Complex * , unsigned  int ) ;

// this:=1/this
# define  Complex_OneDivide Lisp2D_Complex_OneDivide
void  Complex_OneDivide ( Complex * ) ;

# define  Complex_Ceil  Lisp2D_Complex_Ceil
void  Complex_Ceil  ( Complex * ) ;

# define  Complex_CeilDiv Lisp2D_Complex_CeilDiv
void  Complex_CeilDiv  ( Complex * , Complex const * ) ;

# define  Complex_Floor Lisp2D_Complex_Floor
void  Complex_Floor ( Complex * ) ;

# define  Complex_FloorDiv  Lisp2D_Complex_FloorDiv
void  Complex_FloorDiv ( Complex * , Complex const * ) ;

# define  Complex_Trunc Lisp2D_Complex_Trunc
void  Complex_Trunc ( Complex * ) ;

# define  Complex_TruncDiv  Lisp2D_Complex_TruncDiv
void  Complex_TruncDiv ( Complex * , Complex const * ) ;

# define  Complex_ModEq Lisp2D_Complex_ModEq
void  Complex_ModEq  ( Complex * , Complex const * ) ;

# define  Complex_Factorial Lisp2D_Complex_Factorial
void  Complex_Factorial ( Complex * ) ;

# define  Complex_Power Lisp2D_Complex_Power
// recursive
void  Complex_Power ( Complex * , ULongPub  const  * ) ;

# define  Complex_Cbrt  Lisp2D_Complex_Cbrt
void  Complex_Cbrt  ( Complex * , FractionPub const * eps ) ;

# define  Complex_RoundRel  Lisp2D_Complex_RoundRel
// re*(1-eps)..re*(1+eps) , im*(1-eps)..im*(1+eps)
void  Complex_RoundRel ( Complex * , FractionPub const * eps ) ;

# define  Complex_isReal  Lisp2D_Complex_isReal
bool  Complex_isReal  ( Complex  const * ) ;

# define  ComplexToString  Lisp2DComplexToString3448
void  ComplexToString  ( FuncToStringForInterpretHumanPub f  ,
  Complex  const * mep ,
  String  ( WideChar  ) * sc  , unsigned  int digc ) ;

// !? to return UndefBool::Type
# define  Complex_Eq  Lisp2D_Complex_Eq
bool  Complex_Eq  ( Complex  const * , Complex const  * ) ;
  
# define  Complex_NotEq Lisp2D_Complex_NotEq
bool  Complex_NotEq  ( Complex  const * , Complex const  * ) ;

# define  Complex_IsInf Lisp2D_Complex_IsInf
bool  Complex_IsInf ( Complex const * ) ;

# include "undefbool.h"

# define  Complex_Less  Lisp2D_Complex_Less
BoolType Complex_Less  ( Complex  const * , Complex const * ) ;

# define  Complex_Integerp  Lisp2D_Complex_Integerp
bool  Complex_Integerp  ( Complex  const * ) ;

# define  Complex_Is0 Lisp2D_Complex_Is0
bool  Complex_Is0 ( Complex const * ) ;

# define  Complex_IValue  Lisp2D_Complex_IValue
int Complex_IValue  ( Complex  const * ) ;

# define  Complex_IsBADIntValue Lisp2D_Complex_IsBADIntValue
bool  Complex_IsBADIntValue ( Complex const * ,  int * resp )  ;

# define  Complex_IsBADUI16Value  Lisp2D_Complex_IsBADUI16Value
bool  Complex_IsBADUI16Value  ( Complex  const * , uint16_t  * resp ) ;

# define  IsNotNumberLockGC Lisp2D_IsNotNumberLockGC
bool  IsNotNumberLockGC ( StackClusterPrivate  * , ParaLispObject * )  ;

# define  Complex_Ln  Lisp2D_Complex_Ln
void  Complex_Ln  ( Complex  const * , Complex * resultp  ) ;

# define  Complex_isBADUCharValue Lisp2D_Complex_isBADUCharValue
bool  Complex_isBADUCharValue ( Complex const * , unsigned  char * resp ) ;

# include "globallistp/type.h"

# define  GlobalListOfComplex Lisp2DGlobalListOfComplex
extern  GlobalList  GlobalListOfComplex ;
# define  GlobalListOfComplexGarbage  Lisp2DGlobalListOfComplexGarbage
extern  GlobalList  GlobalListOfComplexGarbage  ;
# define  GlobalListOfComplexGC Lisp2DGlobalListOfComplexGC
extern  GlobalList  GlobalListOfComplexGC ;

// returns public pointer to raw complex not constructed
# define  Complex_FromStack Lisp2D_Complex_FromStack
Complex * Complex_FromStack ( void  ) ;
// ?? how to control capacity for GC (only for PLOComplex)
# define  Complex_SetPointer  Lisp2D_Complex_SetPointer
void  Complex_SetPointer  ( Complex * mep , void * x ) ;
// re-=[re] , im-=[im]
# define  Complex_Mod Lisp2D_Complex_Mod
void  Complex_Mod ( Complex * mep ) ;
# define  Complex_Conj  Lisp2D_Complex_Conj
inline  void  Complex_Conj  ( Complex * mep ) ;
# define  Complex_TurnSign  Lisp2D_Complex_TurnSign
void  Complex_TurnSign  ( Complex * mep ) ;
# define  Complex_Re  Lisp2D_Complex_Re
inline  FractionPub * Complex_Re  ( Complex * mep ) ;
# define  Complex_Im  Lisp2D_Complex_Im
inline  FractionPub * Complex_Im  ( Complex * mep ) ;
# define  Complex_CRe Lisp2D_Complex_CRe
inline  FractionPub const * Complex_CRe ( Complex const * mep ) ;
# define  Complex_CIm Lisp2D_Complex_CIm
inline  FractionPub  const * Complex_CIm ( Complex const * mep ) ;
# define  Complex_ToStringForInterpret  Lisp2DComplex_ToStringForInterpret9812
void  Complex_ToStringForInterpret  ( Complex  const * mep ,
  String  ( WideChar  ) * sc  , unsigned  int digc2 ) ;
# define  Complex_ToStringForHuman  Lisp2DComplex_ToStringForHuman1273
void  Complex_ToStringForHuman  ( Complex  const * mep ,
  String  ( WideChar  ) * sc  , unsigned  int digc2 ) ;
# define  Complex_IsBadSizeValue  Lisp2D_Complex_IsBadSizeValue
bool  Complex_IsBadSizeValue  ( Complex const * x , size_t * resultp  ) ;
# define  Complex_Destr Lisp2D_Complex_Destr
void  Complex_Destr ( Complex * me  ) ;

# endif // LISP2D_COMPLEX_PUBLIC_H
