// Lisp2D - Cons - Inline
// ©2011-23 by Alex Glebe
# ifndef  LISP2D_CONS_INLINE_H
# define  LISP2D_CONS_INLINE_H
# include "cons/struct.h"
# include "cons/public.h"
inline  void  ClassCons_SetFirstRest  ( ClassCons * const me , ParaLispObject * const first  , ParaLispObject  * const rest ) {
  me -> first  = first ;
  me -> rest = rest ;
}

# include "nilc.h"
    
inline  void  ClassCons_Init ( ClassCons * const me ) {
  me -> first = & plonil . plo ;
  me -> rest = & plonil  . plo ;
}

inline  void  ClassCons_InitCopy ( ClassCons * const me , ClassCons const * const from ) {
  me -> first = from -> first ;
  me -> rest = from -> rest ;
}

inline  void  ClassCons_InitPair ( ClassCons * const me , ParaLispObject  * const first , ParaLispObject  * const rest ) {
  me -> first = first ;
  me -> rest = rest ;
}

inline  ParaLispObject * ClassCons_First ( ClassCons const * const me ) {
  return  me -> first ;
}

inline  ParaLispObject  * ClassCons_Rest ( ClassCons const * const me ) {
  return  me -> rest  ;
}
/*
inline  void  ClassCons_FirstTo  ( ClassCons const * const me , ParaLispObject * * const result ) {
  ( * result ) = me -> first ;
}
*/
inline  void  ClassCons_SetRest ( ClassCons * const me , ParaLispObject  * const  x ) {
  me -> rest = x ;
}

inline  ParaLispObject  * * ClassCons_PFirst  ( ClassCons * const me ) {
  return & ( me -> first ) ;
}

inline  void  ClassCons_SetFirst  ( ClassCons * const me , ParaLispObject * const x  ) {
  me -> first  = x ;
}

inline  ParaLispObject  const * ClassCons_CRest ( ClassCons const * const me ) {
  return  me -> rest  ;
}

inline  ParaLispObject  * * ClassCons_PRest ( ClassCons * const me ) {
  return & me -> rest  ;
}

inline  ParaLispObject const * ClassCons_CFirst ( ClassCons const * const me ) {
  return  me -> first ;
}

inline  ParaLispObject  * const * ClassCons_CPRest ( ClassCons const * const me ) {
  return  & me -> rest ;
}

inline  ParaLispObject  * const * ClassCons_CPFirst  ( ClassCons const * const me ) {
  return & me -> first  ;
}

inline  PLOCons const * ParaLispObjectToPLOConsConst ( ParaLispObject const * p ) {
  return (  PLOCons const * ) ( p  ->  vaddr . addr . p ) ;
}

# include "define.h"
  
inline  void  PLOCons_InitCopy  ( PLOCons * const mep , PLOCons const * const xp ) {
  VirtualTypePointer  vtp = { . addr = { . p = mep } , . type = TypeGlobalListMemberPLOCons } ;
  ParaLispObject_InitVTP(&mep->plo ,vtp);
  ClassCons_InitCopy(&mep->cc,&xp->cc);
# ifdef  LISP2D_CONSTRSTAT
  PLOCons_constrstatInc ( ) ;
# endif
}

inline  PLOCons * ParaLispObjectToPLOCons ( ParaLispObject * const p ) {
  return (  PLOCons * ) ( p  ->  vaddr . addr . p ) ;
}

inline  void  PLOCons_Clear ( PLOCons * const mep ) {
  ClassCons_SetFirst(&mep->cc,& plonil.plo  ) ;
  ClassCons_SetRest(&mep->cc,& plonil.plo  ) ;
  ParaLispObject_SetFlagConstFalse ( & mep-> plo ) ;
}

inline  void PLOCons_Set ( PLOCons * const mep , PLOCons const * const xp ) {
  ClassCons_Set ( &mep->cc  , & xp->cc ) ;
}
# endif // LISP2D_CONS_INLINE_H
