// Lisp2D - Cons - public
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_CONS_PUBLIC_H
# define  LISP2D_CONS_PUBLIC_H

# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include <stddef.h>

extern  _Atomic ( size_t  ) PLOCons_constrstat  ;

# define  PLOCons_constrstatValue Lisp2D_PLOCons_constrstatValue
size_t  PLOCons_constrstatValue ( void  ) ;

# define  PLOCons_constrstatInc Lisp2D_PLOCons_constrstatInc
void  PLOCons_constrstatInc ( void  ) ;
# endif //  LISP2D_CONSTRSTAT

# include "cons/type.h"

# define  PLOCons_Destr Lisp2D_PLOCons_Destr
void  PLOCons_Destr ( PLOCons * ) ;

# include "plo/type.h"

# define  PLOCons_InitC Lisp2D_PLOCons_InitC
void  PLOCons_InitC ( PLOCons * cop , ParaLispObject  * ap , ParaLispObject  * bp )  ;

# include <stdbool.h>

# define  PLOCons_staticisBADCopyPrivate  Lisp2D_PLOCons_staticisBADCopyPrivate
bool  PLOCons_staticisBADCopyPrivate  ( ParaLispObject const * me , ParaLispObject  * * resultp  ) ;

// returns pointer (PLOCons *) or exception
# define  NewCons Lisp2D_NewCons
PLOCons * NewCons ( ParaLispObject  * a , ParaLispObject  * b ) ;

# include "globallistm/type.h"

# define  PLOCons_FromMember  Lisp2D_PLOCons_FromMember
PLOCons * PLOCons_FromMember ( GlobalListMember * ) ;

# define  PLOCons_staticGCDeclareContent  Lisp2D_PLOCons_staticGCDeclareContent
void  PLOCons_staticGCDeclareContent ( ParaLispObject *  ) ;

# define  PLOCons_staticTypeOf  Lisp2D_PLOCons_staticTypeOf
ParaLispObject  * PLOCons_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOCons_staticDestr Lisp2D_PLOCons_staticDestr
void PLOCons_staticDestr  ( ParaLispObject * ) ;

# define  PLOCons_staticClassDef  Lisp2D_PLOCons_staticClassDef
ParaLispObject  * PLOCons_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOCons_staticClassParents  Lisp2D_PLOCons_staticClassParents
ParaLispObject  * PLOCons_staticClassParents  ( ParaLispObject const * ) ;

# define  PLOCons_staticDeclareForGC  Lisp2D_PLOCons_staticDeclareForGC
void  PLOCons_staticDeclareForGC ( ParaLispObject *  ) ;

# include "plostream/type.h"

# define  PLOCons_staticCoutToInterpret Lisp2D_PLOCons_staticCoutToInterpret
void  PLOCons_staticCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP )  * h ) ;

# define  PLOCons_staticCoutToHuman Lisp2D_PLOCons_staticCoutToHuman
void  PLOCons_staticCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP )  * h ) ;
  
# define  PLOCons_SetPair Lisp2D_PLOCons_SetPair
void  PLOCons_SetPair ( PLOCons  * cp , ParaLispObject  * ap , ParaLispObject  * bp ) ;
    
# define  PLOCons_LastFast  Lisp2D_PLOCons_LastFast
PLOCons *  PLOCons_LastFast ( PLOCons * lp ) ;

# include "stcl/classc.h"

# define  IsNotCons Lisp2D_IsNotCons
bool  IsNotCons(StackClusterPrivate  * stclp ,ParaLispObject * xp) ;

# define  Assoc Lisp2D_Assoc
  ParaLispObject  * Assoc ( ParaLispObject  * , ParaLispObject  const * , StackClusterPrivate  * ) ;

  FuncBining Lisp2Dbimconsfirst2 ;
  FuncBining Lisp2Dbimconssecond2  ;
  FuncBining Lisp2Dbimconsthird2 ;
  FuncBining Lisp2Dbimconsrest2  ;
  FuncBining Lisp2Dbimconssize2  ;
  FuncBining Lisp2Dbimconssubseq2  ;
  FuncBining Lisp2Dbimconswithout2 ;
  FuncBining Lisp2Dbimconssetfirst2  ;
  FuncBining Lisp2Dbimconssetrest2 ;
  FuncBining  Lisp2Dbimconslast2 ;
  FuncBining  Lisp2Dbimnilreverse2 ;
  FuncBining  Lisp2Dbimconsnconc2 ;
  FuncBining  Lisp2Dbimconscopytree2 ;
  FuncBining  Lisp2Dbimconscopylist2 ;
  FuncBining  Lisp2Dbimconscopylistprotected2 ;
  FuncBining  Lisp2Dbimconsvector2  ;
  FuncBining  Lisp2Dbimconssetf2  ;
  FuncBining  Lisp2Dbimconsswap2  ;
  FuncBining  Lisp2Dbimconsforcons2 ;
  FuncBining  Lisp2Dbimconscons2 ;
  FuncBining  Lisp2Dbimconsmap2 ;
  FuncBining  Lisp2Dbimconsmapc2 ;
FuncBining  Lisp2Dbimnilfirst2 ;
  FuncBining  Lisp2Dbimnilrest2  ;
  FuncBining  Lisp2Dbimnilcons2  ;
  FuncBining  Lisp2Dbimnilatom2  ;
  FuncBining  Lisp2Dbimnillist2  ;
  FuncBining  Lisp2Dbimnillistc2  ;
  FuncBining  Lisp2Dbimnillast2  ;
  FuncBining Lisp2Dbimnillistp2  ;
  FuncBining Lisp2Dbimnilconsp2  ;
  FuncBining Lisp2Dbimnilacons23  ;
  FuncBining  Lisp2Dbimnilforcons2 ;
  FuncBining  Lisp2Dbimnilfor2 ;
  FuncBining  Lisp2Dbimnilsize2 ;
  FuncBining  Lisp2Dbimnilplus2 ;
  FuncBining  Lisp2Dbimnilcopytree2 ;
  FuncBining  Lisp2Dbimnilcopylist2 ;
  FuncBining  Lisp2Dbimnilcommaatsign2 ;
  FuncBining  Lisp2Dbimnilcycledp2  ;
  
# define  CCAR  Lisp2D_CAR
ParaLispObject * CCAR  ( ParaLispObject const * ) ;

# define  CCDR  Lisp2D_CDR
ParaLispObject * CCDR  ( ParaLispObject const * ) ;

# define  CConsp  Lisp2D_CConsp
bool  CConsp ( ParaLispObject const * ) ;

# define  ClassCons_SetFirstRest  Lisp2D_ClassCons_SetFirstRest
inline  void  ClassCons_SetFirstRest  ( ClassCons * , ParaLispObject * first  , ParaLispObject  * rest ) ;

# define  ClassCons_Swap  Lisp2D_ClassCons_Swap
void  ClassCons_Swap  ( ClassCons * , ClassCons * ) ;

# define  ClassCons_Set Lisp2D_ClassCons_Set
void  ClassCons_Set ( ClassCons * , ClassCons const * ) ;

# define  ClassCons_Init  Lisp2D_ClassCons_Init
inline  void  ClassCons_Init ( ClassCons * ) ;

# define  ClassCons_InitCopy  Lisp2D_ClassCons_InitCopy
inline  void  ClassCons_InitCopy ( ClassCons * , ClassCons const * ) ;

# define  ClassCons_InitPair  Lisp2D_ClassCons_InitPair
inline  void  ClassCons_InitPair ( ClassCons * , ParaLispObject  * first , ParaLispObject  * rest ) ;

# define  ClassCons_First Lisp2D_ClassCons_First
inline  ParaLispObject * ClassCons_First ( ClassCons const * ) ;

# define  ClassCons_Rest Lisp2D_ClassCons_Rest
inline  ParaLispObject  * ClassCons_Rest ( ClassCons const * ) ;
/*
# define  ClassCons_FirstTo  Lisp2D_ClassCons_FirstTo
inline  void  ClassCons_FirstTo  ( ClassCons const * , ParaLispObject * * result ) ;
*/
# define  ClassCons_SetRest Lisp2D_ClassCons_SetRest
inline  void  ClassCons_SetRest ( ClassCons * , ParaLispObject  * ) ;

# define  ClassCons_PFirst  Lisp2D_ClassCons_PFirst
inline  ParaLispObject  * * ClassCons_PFirst  ( ClassCons * ) ;

# define  ClassCons_SetFirst  Lisp2D_ClassCons_SetFirst
inline  void  ClassCons_SetFirst  ( ClassCons * , ParaLispObject * ) ;

# define  ClassCons_CRest Lisp2D_ClassCons_CRest
inline  ParaLispObject  const * ClassCons_CRest ( ClassCons const * ) ;

# define  ClassCons_PRest Lisp2D_ClassCons_PRest
inline  ParaLispObject  * * ClassCons_PRest ( ClassCons * ) ;

# define  ClassCons_CFirst Lisp2D_ClassCons_CFirst
inline  ParaLispObject const * ClassCons_CFirst ( ClassCons const * ) ;

# define  ClassCons_CPRest Lisp2D_ClassCons_CPRest
inline  ParaLispObject  * const * ClassCons_CPRest ( ClassCons const * ) ;

# define  ClassCons_CPFirst Lisp2D_ClassCons_CPFirst
inline  ParaLispObject  * const * ClassCons_CPFirst  ( ClassCons const * ) ;

# define  ParaLispObjectToPLOConsConst Lisp2DParaLispObjectToPLOConsConst
inline  PLOCons const * ParaLispObjectToPLOConsConst ( ParaLispObject const * ) ;

# define  PLOCons_InitCopy  Lisp2D_PLOCons_InitCopy
inline  void  PLOCons_InitCopy  ( PLOCons * , PLOCons const * ) ;

# define  ParaLispObjectToPLOCons Lisp2DParaLispObjectToPLOCons
inline  PLOCons * ParaLispObjectToPLOCons ( ParaLispObject * ) ;

# define  PLOCons_Clear Lisp2D_PLOCons_Clear
inline  void  PLOCons_Clear ( PLOCons * ) ;

# define  PLOCons_Set Lisp2D_PLOCons_Set
inline  void PLOCons_Set ( PLOCons * , PLOCons const * ) ;

# define  PLOCons_Init  Lisp2D_PLOCons_Init
void  PLOCons_Init ( PLOCons * ) ;

# include "stcl/inline.h"

# endif // LISP2D_CONS_PUBLIC_H
