// Lisp2D - consequent of atomic pointer Public
// ©2015-23 by Alex Glebe

# ifndef  LISP2D_CONSATOMIC_PUBLIC_H
# define  LISP2D_CONSATOMIC_PUBLIC_H

# include <stddef.h> // offsetof
# include <stdint.h> // uint8_t
# include "consatomic/struct.h"

# define  ConsAtomicPointerConst_cast_bytep  Lisp2D_ConsAtomicPointerConst_cast_bytep
inline  uint8_t const * ConsAtomicPointerConst_cast_bytep  ( ConsAtomicPointe const * ) ;
# define  ConsAtomicPointerFirst  Lisp2DConsAtomicPointerFirst
inline  void  * ConsAtomicPointerFirst ( ConsAtomicPointe const * ) ;
# define  ConsAtomicPointerRest Lisp2DConsAtomicPointerRest
inline  void  * ConsAtomicPointerRest  ( ConsAtomicPointe const * ) ;
# define  ConsAtomicPointer_cast_bytep  Lisp2D_ConsAtomicPointer_cast_bytep
inline  uint8_t const * ConsAtomicPointer_cast_bytep  ( ConsAtomicPointe * ) ;
# define  ConsAtomicPointerClear  Lisp2DConsAtomicPointerClear
inline  void  ConsAtomicPointerClear ( ConsAtomicPointe * ) ;
# define  ConsAtomicPointerConstructor  Lisp2DConsAtomicPointerConstructor
inline  void  ConsAtomicPointerConstructor ( ConsAtomicPointe * ) ;
# define  ConsAtomicPointerSetFirst Lisp2DConsAtomicPointerSetFirst
inline  void  ConsAtomicPointerSetFirst  ( ConsAtomicPointe * , void  * ) ;
# define  ConsAtomicPointerSetRest  Lisp2DConsAtomicPointerSetRest
inline  void  ConsAtomicPointerSetRest ( ConsAtomicPointe * , void  * ) ;
// returns pointer to new struct or long jump
# define  NewConsAtomicPointer Lisp2DNewConsAtomicPointer_ExcMem
ConsAtomicPointe * NewConsAtomicPointer ( void ) ;
# define  ConsAtomicPointerFree  Lisp2D_ConsAtomicPointerFree
void  ConsAtomicPointerFree ( ConsAtomicPointe * ) ;

inline  uint8_t const * ConsAtomicPointerConst_cast_bytep  ( ConsAtomicPointe const * const p ) {
  return  ( uint8_t const * ) p ;
}

# include "consatomic/private.h"

inline  void  * ConsAtomicPointerFirst ( ConsAtomicPointe const * const me  ) {
  return  ConsAtomicPointerConst_cast_Private ( me ) -> first2 ;
}

inline  void  * ConsAtomicPointerRest  ( ConsAtomicPointe const * const me  ) {
  return  ConsAtomicPointerConst_cast_Private ( me ) -> rest  ;
}  

inline  uint8_t const * ConsAtomicPointer_cast_bytep  ( ConsAtomicPointe * const p ) {
  return  ( uint8_t * ) p ;
}

inline  void  ConsAtomicPointerClear ( ConsAtomicPointe * const me  ) {
  ConsAtomicPointer_cast_Private ( me ) -> first2  = 0 ;
  ConsAtomicPointer_cast_Private ( me ) -> rest  = 0 ;
}

inline  void  ConsAtomicPointerConstructor ( ConsAtomicPointe * const  me  ) {
  ConsAtomicPointerClear ( me  ) ;
}

inline  void  ConsAtomicPointerSetFirst  ( ConsAtomicPointe * const me  , void  * const x ) {
  ConsAtomicPointer_cast_Private ( me ) -> first2  = x ;
}

inline  void  ConsAtomicPointerSetRest ( ConsAtomicPointe * const me  , void  * const x ) {
  ConsAtomicPointer_cast_Private ( me ) -> rest  = x ;
}  

# endif // LISP2D_CONSATOMIC_PUBLIC_H
