// Lisp2D - deque public functions declaration
// ©2020-3 by Alex Glebe

# ifndef  LISP2D_DEQUE_PUBLICBYTE_H
# define  LISP2D_DEQUE_PUBLICBYTE_H

# include "deque/public.h"
# include "deque/type-byte.h"
# include <stdint.h> // uint8_t

inline  void  Deque_Init ( Byte ) ( Deque ( Byte ) * ) ;
void  Deque_InitCopy ( Byte ) ( Deque ( Byte ) * me , Deque ( Byte ) const * from ) ;
void  Deque_Destr ( Byte ) ( Deque ( Byte ) * ) ;
void  Deque_Resize  ( Byte ) ( Deque ( Byte ) * , size_t count ) ;
void  Deque_Set ( Byte ) ( Deque ( Byte ) * me , Deque ( Byte ) const * from ) ;

inline  void  Deque_Init ( Byte ) ( Deque ( Byte ) * const me ) {
  DequeVoidInit ( me ) ;
}

Deque_End_Decl  ( Byte )
Deque_CEnd_Decl  ( Byte )
Deque_REnd_Decl  ( Byte )
Deque_CREnd_Decl  ( Byte )
Deque_Begin_Decl  ( Byte )
Deque_CBegin_Decl  ( Byte )
Deque_RBegin_Decl ( Byte )
Deque_CRBegin_Decl ( Byte )
Deque_Push_back_Decl ( Byte , uint8_t )
Deque_Push_front_Decl ( Byte , uint8_t )
Deque_At_Decl  ( Byte , uint8_t )
Deque_AtFast_Decl  ( Byte , uint8_t )
inline  Deque_Const_Cast_Decl ( Byte )
inline  Deque_AtConstDecl ( Byte , uint8_t )
inline  Deque_AtFastConstDecl ( Byte , uint8_t )
inline  Deque_Clear_Decl ( Byte )
inline  Deque_Empty_Decl ( Byte )
Deque_Size_Decl( Byte )
Deque_InitSize_Decl  ( Byte )
Deque_Pop_back_Decl ( Byte , uint8_t )
Deque_Pop_front_Decl ( Byte , uint8_t )
Deque_Front_Decl  ( Byte , uint8_t )
inline  Deque_FrontConstDecl ( Byte , uint8_t )
Deque_Back_Decl  ( Byte , uint8_t )
inline  Deque_BackConstDecl ( Byte , uint8_t )
Deque_ResizeVal_Decl  ( Byte , uint8_t )
inline  Deque_Swap_Decl ( Byte )
Deque_ConstIterator_NotEq_Decl ( Byte )
Deque_ConstIterator_NotEqIterator_Decl ( Byte )

inline  Deque_Const_Cast_Templ  ( Byte )
inline  Deque_AtConstTempl ( Byte , uint8_t )
inline  Deque_AtFastConstTempl ( Byte , uint8_t )
inline  Deque_Clear_Templ ( Byte )
inline  Deque_EmptyTempl  ( Byte )
inline  Deque_FrontConstTempl ( Byte , uint8_t )
inline  Deque_BackConstTempl ( Byte , uint8_t )
inline  Deque_SwapTempl ( Byte )

# include "deque/struct.h"

inline  Deque_Iterator_Place_Decl ( Byte , uint8_t )
inline  Deque_ConstIterator_Place_Decl ( Byte , uint8_t )

# include "cast.h"

inline  Deque_Iterator_Place_Templ ( Byte , uint8_t , voidp_cast_bytep )
inline  Deque_ConstIterator_Place_Templ ( Byte , uint8_t , const_voidp_cast_bytep )

Deque_ConstIterator_Inc_Decl  ( Byte  )
Deque_ConstIterator_Dec_Decl  ( Byte  )
Deque_ConstIterator_Add_Decl  ( Byte  )
Deque_Iterator_Inc_Decl  ( Byte  )
Deque_Iterator_Dec_Decl  ( Byte  )
Deque_Iterator_Add_Decl  ( Byte  )

# endif // LISP2D_DEQUE_PUBLICBYTE_H
