// Lisp2D - deque public functions declaration
// ©2020-3 by Alex Glebe
# ifndef  LISP2D_DEQUE_PUBLIC_H
# define  LISP2D_DEQUE_PUBLIC_H

# include "deque/type.h"

# define  DequeVoidInit  Lisp2D_DequeVoidInit
void  DequeVoidInit ( DequeVoid * ) ;

# include <stddef.h>  //  size_t

# define  Deque_Void_InitCopy Lisp2D_Deque_Void_InitCopy
void  Deque_Void_InitCopy ( DequeVoid * dq , DequeVoid const * dq2 , size_t elt_size  , unsigned int ali )  ;

# define  Deque_Void_InitMove  Lisp2D_Deque_Void_InitMove
void  Deque_Void_InitMove ( DequeVoid * me , DequeVoid * from ) ;

# define  DequeVoidDestr  Lisp2D_DequeVoidDestr
void  DequeVoidDestr ( DequeVoid * ) ;

# define  DequeVoidClear  Lisp2D_DequeVoidClear
void  DequeVoidClear  ( DequeVoid * ) ;

// elt raw copy withOut func copy
# define  Deque_Void_Set  Lisp2D_Deque_Void_Set
void  Deque_Void_Set ( DequeVoid * dq , DequeVoid const * dq2 , size_t  elt_size , unsigned int ali ) ;

# define  Deque_Void_Move  Lisp2D_Deque_Void_Move
void  Deque_Void_Move ( DequeVoid * me , DequeVoid * from ) ;

# define  Deque_Void_Swap  Lisp2D_Deque_Void_Swap
void  Deque_Void_Swap ( DequeVoid * me , DequeVoid * from ) ;

# define  Lisp2D_Deque_Swap( T )  Lisp2D_Deque_ ## T ## _Swap
# define  Deque_Swap( T )  Lisp2D_Deque_Swap ( T )
# define  Deque_Swap_Decl( T )  \
  void  Deque_Swap ( T ) ( Deque ( T ) * , Deque ( T ) * ) ;

# define  Deque_SwapTempl( NAME ) \
void  Deque_Swap ( NAME ) ( Deque ( NAME ) * const me , \
  Deque ( NAME ) * const you ) { \
  Deque_Void_Swap ( me , you ) ;  \
}

// second arg is size of one element in bytes
// third arg is count of this elements
# define  DequeVoidResize  Lisp2D_DequeResize
void  DequeVoidResize ( DequeVoid * , size_t elemsize , size_t count , unsigned int ali ) ;

# define  DequeVoidSize Lisp2D_DequeVoidSize
size_t  DequeVoidSize ( DequeVoid const * , size_t elemsize ) ;

# define  Lisp2D_Deque_Init( T )  Lisp2D_Deque_ ## T ## _Init
# define  Deque_Init( T )  Lisp2D_Deque_Init  ( T )
# define  Deque_Init_Decl( T )  void  Deque_Init ( T ) ( Deque ( T ) * ) ;

# define  Lisp2D_Deque_InitCopy( T )  Lisp2D_Deque_ ## T ## _InitCopy
# define  Deque_InitCopy( T )  Lisp2D_Deque_InitCopy  ( T )
# define  Deque_InitCopy_Decl( T )  void  Deque_InitCopy ( T ) ( \
  Deque ( T ) * , Deque ( T ) const * ) ;

# define  Lisp2D_Deque_ConstIterator_NotEq( T )  \
  Lisp2D_Deque_ ## T ## _ConstIterator_NotEq
# define  Deque_ConstIterator_NotEq( T )  Lisp2D_Deque_ConstIterator_NotEq ( T )
# define  Deque_ConstIterator_NotEq_Decl( T )  \
  bool  Deque_ConstIterator_NotEq ( T ) ( DequeConstIterator ( T ) , \
    DequeConstIterator ( T ) ) ;

# define  Lisp2D_Deque_ConstIterator_NotEqIterator( T )  \
  Lisp2D_Deque_ ## T ## _ConstIterator_NotEqIterator
# define  Deque_ConstIterator_NotEqIterator( T ) \
  Lisp2D_Deque_ConstIterator_NotEqIterator ( T )
# define  Deque_ConstIterator_NotEqIterator_Decl( T )  \
  bool  Deque_ConstIterator_NotEqIterator ( T ) ( DequeConstIterator ( T ) , \
    DequeIterator ( T ) ) ;
    
# define  Lisp2D_Deque_InitSize( T )  Lisp2D_Deque_ ## T ## _InitSize
# define  Deque_InitSize( T )  Lisp2D_Deque_InitSize  ( T )
# define  Deque_InitSize_Decl( T ) \
  void  Deque_InitSize ( T ) ( Deque ( T ) * , size_t ) ;
  
# define  Lisp2D_Deque_Destr( T )  Lisp2D_Deque_ ## T ## _Destr
# define  Deque_Destr( T )  Lisp2D_Deque_Destr  ( T )
# define  Deque_Destr_Decl( T )  void  Deque_Destr ( T ) ( Deque ( T ) * ) ;
  
# define  Lisp2D_Deque_Resize( T )  Lisp2D_Deque_ ## T ## _Resize
# define  Deque_Resize( T )  Lisp2D_Deque_Resize  ( T )
# define  Deque_Resize_Decl( T )  \
  void  Deque_Resize ( T ) ( Deque ( T ) * , size_t ) ;

# define  Lisp2D_Deque_Set( T )  Lisp2D_Deque_ ## T ## _Set
# define  Deque_Set( T )  Lisp2D_Deque_Set ( T )
# define  Deque_Set_Decl( T )  \
  void  Deque_Set ( T ) ( Deque ( T ) * , Deque ( T ) const * ) ;

# define  Lisp2D_Deque_End( T )  Lisp2D_Deque_ ## T ## _End
# define  Deque_End( T )  Lisp2D_Deque_End ( T )
# define  Deque_End_Decl( T )  \
  DequeIterator  ( T ) Deque_End ( T ) ( Deque ( T ) * ) ;

# define  Lisp2D_Deque_CEnd( T )  Lisp2D_Deque_ ## T ## _CEnd
# define  Deque_CEnd( T )  Lisp2D_Deque_CEnd ( T )
# define  Deque_CEnd_Decl( T )  \
  DequeConstIterator  ( T ) Deque_CEnd ( T ) ( Deque ( T ) const * ) ;

# define  Lisp2D_Deque_REnd( T )  Lisp2D_Deque_ ## T ## _REnd
# define  Deque_REnd( T )  Lisp2D_Deque_REnd ( T )
# define  Deque_REnd_Decl( T )  \
  DequeReverseIterator  ( T ) Deque_REnd ( T ) ( Deque ( T ) * ) ;

# define  Lisp2D_Deque_CREnd( T )  Lisp2D_Deque_ ## T ## _CREnd
# define  Deque_CREnd( T )  Lisp2D_Deque_CREnd ( T )
# define  Deque_CREnd_Decl( T )  \
  DequeConstReverseIterator  ( T ) Deque_CREnd ( T ) ( Deque ( T ) const * ) ;
  
# define  Lisp2D_Deque_Begin( T )  Lisp2D_Deque_ ## T ## _Begin
# define  Deque_Begin( T )  Lisp2D_Deque_Begin  ( T )
# define  Deque_Begin_Decl( T )  \
  DequeIterator  ( T ) Deque_Begin ( T ) ( Deque ( T ) const  * ) ;

# define  Lisp2D_Deque_CBegin( T )  Lisp2D_Deque_ ## T ## _CBegin
# define  Deque_CBegin( T )  Lisp2D_Deque_CBegin  ( T )
# define  Deque_CBegin_Decl( T )  \
  DequeConstIterator  ( T ) Deque_CBegin ( T ) ( Deque ( T ) const  * ) ;

# define  Lisp2D_Deque_RBegin( T )  Lisp2D_Deque_ ## T ## _RBegin
# define  Deque_RBegin( T )  Lisp2D_Deque_RBegin  ( T )
# define  Deque_RBegin_Decl( T )  \
  DequeReverseIterator  ( T ) Deque_RBegin ( T ) ( Deque ( T ) * ) ;

# define  Lisp2D_Deque_CRBegin( T )  Lisp2D_Deque_ ## T ## _CRBegin
# define  Deque_CRBegin( T )  Lisp2D_Deque_CRBegin  ( T )
# define  Deque_CRBegin_Decl( T )  \
  DequeConstReverseIterator  ( T ) Deque_CRBegin ( T ) \
  ( Deque ( T ) const  * ) ;
  
# define  Lisp2D_Deque_Push_back( T )  Lisp2D_Deque_ ## T ## _Push_back
# define  Deque_Push_back( T )  Lisp2D_Deque_Push_back  ( T )
# define  Deque_Push_back_Decl( T , T2 )  void Deque_Push_back ( T ) ( \
  Deque ( T ) * , T2 ) ;

# define  Lisp2D_Deque_Push_front( T )  Lisp2D_Deque_ ## T ## _Push_front
# define  Deque_Push_front( T )  Lisp2D_Deque_Push_front  ( T )
# define  Deque_Push_front_Decl( T , T2 )  void Deque_Push_front ( T ) ( \
  Deque ( T ) * , T2 ) ;

# define  Lisp2D_Deque_At( T )  Lisp2D_Deque_ ## T ## _At
# define  Deque_At( T )  Lisp2D_Deque_At  ( T )
# define  Deque_At_Decl( T , R )  R *  Deque_At ( T ) \
  ( Deque ( T ) * , size_t ) ;

# define  Lisp2D_Deque_ResizeVal( T )  Lisp2D_Deque_ ## T ## _ResizeVal
# define  Deque_ResizeVal( T )  Lisp2D_Deque_ResizeVal ( T )
# define  Deque_ResizeVal_Decl( N , T )  void Deque_ResizeVal ( N ) ( \
  Deque ( N ) * , size_t , T ) ;

# define  Lisp2D_Deque_Front( T )  Lisp2D_Deque_ ## T ## _Front
# define  Deque_Front( T )  Lisp2D_Deque_Front  ( T )
# define  Deque_Front_Decl( T , R )  R *  Deque_Front ( T ) ( Deque ( T ) * ) ;

# define  Lisp2D_Deque_Back( T )  Lisp2D_Deque_ ## T ## _Back
# define  Deque_Back( T )  Lisp2D_Deque_Back  ( T )
# define  Deque_Back_Decl( T , R )  R *  Deque_Back ( T ) ( Deque ( T ) * ) ;
  
# define  Lisp2D_Deque_AtFast( T )  Lisp2D_Deque_ ## T ## _AtFast
# define  Deque_AtFast( T )  Lisp2D_Deque_AtFast  ( T )
# define  Deque_AtFast_Decl( T , R )  R *  Deque_AtFast ( T ) ( \
  Deque ( T ) * , size_t ) ;

# define  Lisp2D_Deque_AtConst( T )  Lisp2D_Deque_ ## T ## _AtConst
# define  Deque_AtConst( T )  Lisp2D_Deque_AtConst  ( T )
# define  Deque_AtConst_Decl( T , R )  \
  R const *  Deque_AtConst ( T ) ( Deque ( T ) const * , size_t ) ;

# define  Lisp2D_Deque_FrontConst( T )  Lisp2D_Deque_ ## T ## _FrontConst
# define  Deque_FrontConst( T )  Lisp2D_Deque_FrontConst  ( T )
# define  Deque_FrontConst_Decl( T , R ) \
  R const *  Deque_FrontConst ( T ) ( Deque ( T ) const * ) ;

# define  Lisp2D_Deque_BackConst( T )  Lisp2D_Deque_ ## T ## _BackConst
# define  Deque_BackConst( T )  Lisp2D_Deque_BackConst  ( T )
# define  Deque_BackConst_Decl( T , R ) \
  R const *  Deque_BackConst ( T ) ( Deque ( T ) const * ) ;
  
# define  Lisp2D_Deque_AtFastConst( T )  Lisp2D_Deque_ ## T ## _AtFastConst
# define  Deque_AtFastConst( T )  Lisp2D_Deque_AtFastConst  ( T )
# define  Deque_AtFastConst_Decl( T , R )  R const * \
  Deque_AtFastConst ( T ) ( Deque ( T ) const * , size_t ) ;
  
# define  Lisp2D_Deque_Size( T )  Lisp2D_Deque_ ## T ## _Size
# define  Deque_Size( T )  Lisp2D_Deque_Size  ( T )
# define  Deque_Size_Decl( T )  \
  size_t  Deque_Size ( T ) ( Deque ( T ) const * ) ;
  
# define  Deque_SizeTempl( NAME , TYPE ) \
size_t  Deque_Size  ( NAME ) ( Deque ( NAME ) const * const me  ) { \
  return  DequeVoidSize ( me  , sizeof  ( TYPE  ) ) ; \
}

# define  Deque_Clear_Decl( NAME ) \
void  Deque_Clear ( NAME ) ( Deque ( NAME ) * ) ;
# define  Lisp2D_Deque_Clear( T )  Lisp2D_Deque_ ## T ## _Clear
# define  Deque_Clear( T )  Lisp2D_Deque_Clear ( T )
# define  Deque_Clear_Templ( NAME ) \
void  Deque_Clear ( NAME ) ( Deque ( NAME ) * const me  ) { \
  DequeVoidClear ( me ) ; \
}
  
# define  Lisp2D_Deque_Const_Cast( T )  Lisp2D_Deque_ ## T ## _Const_Cast
# define  Deque_Const_Cast( T )  Lisp2D_Deque_Const_Cast  ( T )
# define  Deque_Const_Cast_Decl( T )  \
  Deque ( T ) * Deque_Const_Cast ( T ) ( Deque ( T ) const * ) ;
  
# define  Deque_Const_Cast_Templ( NAME )  \
  Deque ( NAME ) * Deque_Const_Cast ( NAME  ) ( Deque ( NAME ) const * const me ) { \
  return ( Deque ( NAME ) * ) me ; \
}

# define  Deque_AtConstDecl( NAME , TYPE ) \
TYPE const * Deque_AtConst  ( NAME ) ( Deque ( NAME ) const * me , size_t i ) ;

# define  Deque_AtConstTempl( NAME , TYPE ) \
TYPE const * Deque_AtConst  ( NAME ) ( Deque ( NAME ) const * const me , size_t const i ) { \
  return  Deque_At ( NAME ) ( Deque_Const_Cast ( NAME ) ( me ) , i ) ;  \
}

# define  Deque_FrontConstDecl( NAME , TYPE ) \
TYPE const * Deque_FrontConst  ( NAME ) ( Deque ( NAME ) const * ) ;

# define  Deque_FrontConstTempl( NAME , TYPE ) \
TYPE const * Deque_FrontConst  ( NAME ) ( Deque ( NAME ) const * const me ) { \
  return  Deque_Front ( NAME ) ( Deque_Const_Cast ( NAME ) ( me ) ) ; \
}

# define  Deque_BackConstDecl( NAME , TYPE ) \
TYPE const * Deque_BackConst  ( NAME ) ( Deque ( NAME ) const * ) ;

# define  Deque_BackConstTempl( NAME , TYPE ) \
TYPE const * Deque_BackConst  ( NAME ) ( Deque ( NAME ) const * const me ) { \
  return  Deque_Back ( NAME ) ( Deque_Const_Cast ( NAME ) ( me ) ) ;  \
}

# define  Deque_AtFastConstDecl( NAME , TYPE ) \
TYPE const * Deque_AtFastConst  ( NAME ) ( Deque ( NAME ) const * me , size_t i ) ;

# define  Deque_AtFastConstTempl( NAME , TYPE ) \
TYPE const * Deque_AtFastConst  ( NAME ) ( Deque ( NAME ) const * const me , size_t const i ) { \
  return  Deque_AtFast ( NAME ) ( Deque_Const_Cast ( NAME ) ( me ) , i ) ;  \
}

# include <stdbool.h>
  
# define  DequeVoidEmpty  Lisp2D_DequeVoidEmpty
bool  DequeVoidEmpty  ( DequeVoid const * ) ;

# define  Lisp2D_Deque_Empty( T )  Lisp2D_Deque_ ## T ## _Empty
# define  Deque_Empty( T )  Lisp2D_Deque_Empty  ( T )
# define  Deque_Empty_Decl( T )  \
  bool  Deque_Empty ( T ) ( Deque ( T ) const * ) ;
# define  Deque_EmptyTempl( NAME ) \
bool  Deque_Empty ( NAME ) ( Deque ( NAME ) const * const me  ) { \
  return  DequeVoidEmpty ( me ) ; \
}

# define  Lisp2D_Deque_Pop_back( T )  Lisp2D_Deque_ ## T ## _Pop_back
# define  Deque_Pop_back( T )  Lisp2D_Deque_Pop_back  ( T )
# define  Deque_Pop_back_Decl( T , T2 )  T2 Deque_Pop_back ( T ) ( \
  Deque ( T ) * ) ;

# define  Lisp2D_Deque_Pop_front( T )  Lisp2D_Deque_ ## T ## _Pop_front
# define  Deque_Pop_front( T )  Lisp2D_Deque_Pop_front  ( T )
# define  Deque_Pop_front_Decl( T , T2 )  T2 Deque_Pop_front ( T ) ( \
  Deque ( T ) * ) ;

# define  Lisp2D_Deque_Iterator_Place( T ) \
  Lisp2D_Deque_ ## T ## _Iterator_Place
# define  Deque_Iterator_Place( T )  Lisp2D_Deque_Iterator_Place ( T )  

# define  Deque_Iterator_Place_Decl( NAME , TYPE ) \
TYPE * Deque_Iterator_Place ( NAME ) ( DequeIterator ( NAME ) ) ;

# define  Deque_Iterator_Place_Templ( NAME , TYPE , CAST ) \
TYPE * Deque_Iterator_Place ( NAME ) ( DequeIterator ( NAME ) const i ) {  \
  return & ( CAST ( * ( i . line ) ) [ i . index ] ) ; \
}

# define  Lisp2D_Deque_ConstIterator_Place( T )  \
  Lisp2D_Deque_ ## T ## _ConstIterator_Place
# define  Deque_ConstIterator_Place( T )  Lisp2D_Deque_ConstIterator_Place ( T )

# define  Deque_ConstIterator_Place_Decl( NAME , TYPE ) \
TYPE const  * Deque_ConstIterator_Place ( NAME ) ( DequeConstIterator ( NAME ) ) ;

# define  Deque_ConstIterator_Place_Templ( NAME , TYPE , CAST ) \
TYPE const  * Deque_ConstIterator_Place ( NAME ) ( DequeConstIterator ( NAME ) const i ) { \
  return & ( CAST ( * i . base . line ) [ i . base . index ] ) ; \
}

# define  Lisp2D_Deque_ConstIterator_Inc( T )  \
  Lisp2D_Deque_ ## T ## _ConstIterator_Inc
# define  Deque_ConstIterator_Inc( T )  Lisp2D_Deque_ConstIterator_Inc ( T )
# define  Deque_ConstIterator_Inc_Decl( T ) \
  void  Deque_ConstIterator_Inc ( T ) ( DequeConstIterator ( T ) * ) ;

# define  Lisp2D_Deque_ConstIterator_Dec( T )  \
  Lisp2D_Deque_ ## T ## _ConstIterator_Dec
# define  Deque_ConstIterator_Dec( T )  Lisp2D_Deque_ConstIterator_Dec ( T )
# define  Deque_ConstIterator_Dec_Decl( T ) \
  void  Deque_ConstIterator_Dec ( T ) ( DequeConstIterator ( T ) * ) ;

# define  Lisp2D_Deque_Iterator_Inc( T )  \
  Lisp2D_Deque_ ## T ## _Iterator_Inc
# define  Deque_Iterator_Inc( T )  Lisp2D_Deque_Iterator_Inc ( T )
# define  Deque_Iterator_Inc_Decl( T ) \
  void  Deque_Iterator_Inc ( T ) ( DequeIterator ( T ) * ) ;

# define  Lisp2D_Deque_Iterator_Dec( T )  \
  Lisp2D_Deque_ ## T ## _Iterator_Dec
# define  Deque_Iterator_Dec( T )  Lisp2D_Deque_Iterator_Dec ( T )
# define  Deque_Iterator_Dec_Decl( T ) \
  void  Deque_Iterator_Dec ( T ) ( DequeIterator ( T ) * ) ;
  
# define  Lisp2D_Deque_ConstIterator_Add( T )  \
  Lisp2D_Deque_ ## T ## _ConstIterator_Add
# define  Deque_ConstIterator_Add( T )  Lisp2D_Deque_ConstIterator_Add ( T )
# define  Deque_ConstIterator_Add_Decl( T ) \
  DequeConstIterator ( T )  Deque_ConstIterator_Add ( T ) ( \
    DequeConstIterator ( T ) , ptrdiff_t ) ;

# define  Lisp2D_Deque_Iterator_Add( T )  \
  Lisp2D_Deque_ ## T ## _Iterator_Add
# define  Deque_Iterator_Add( T )  Lisp2D_Deque_Iterator_Add ( T )
# define  Deque_Iterator_Add_Decl( T ) \
  DequeIterator ( T )  Deque_Iterator_Add ( T ) ( DequeIterator ( T ) , ptrdiff_t ) ;

# define  Lisp2D_Deque_Erase( T )  \
  Lisp2D_Deque_ ## T ## _Erase
# define  Deque_Erase( T )  Lisp2D_Deque_Erase ( T )
# define  Deque_Erase_Decl( NAME ) \
  DequeIterator ( NAME  ) Deque_Erase ( NAME  ) ( \
    Deque ( NAME  ) * me  , \
  DequeConstIterator  ( NAME  ) begin , \
  DequeConstIterator  ( NAME  ) end ) ;

# endif // LISP2D_DEQUE_PUBLIC_H
