// Lisp2D - Directory object passing
// ©2011-23 by Alex Glebe

# include "dir/struct.h"
# include "dir/public.h"
# include "dir/inlinepri.h"

inline  PLODirPub * ParaLispObjectToPLODir ( ParaLispObject * const  p ) {
  return & ( ( (  PLODirPri * ) ( p  ->  vaddr . addr . p ) ) -> pub ) ;
}

inline  PLODirPub const * ParaLispObjectToPLODirConst ( ParaLispObject const * const p ) {
  return & ( ( (  PLODirPri const * ) ( p  ->  vaddr . addr . p ) ) -> pub ) ;
}

inline  DIR * const * PLODir_DirPointerAddress ( PLODirPub const * const mep ) {
  PLODirPri const * const me = PLODirPub_cast_PLODirPriConst ( mep ) ;
  return  & me -> dir ;
}

inline  DIR * PLODir_DirPointerValue ( PLODirPub const * const mep ) {
  PLODirPri const * const me = PLODirPub_cast_PLODirPriConst ( mep ) ;
  return  me -> dir ;
}

# include "plo/public.h"

inline  bool  Dirp ( ParaLispObject const * const xp ) {
  return  ParaLispObject_Type ( xp  ) ==  TypeGlobalListMemberPLODirPri  ;
}
