// Lisp2D - Directory object passing
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_DIR_PUBLIC_H
# define  LISP2D_DIR_PUBLIC_H
# include <stddef.h>
# include "define.h"
# ifdef  LISP2D_CONSTRSTAT

# define  PLODir_constrstatValue Lisp2D_PLODir_constrstatValue
size_t  PLODir_constrstatValue ( void  ) ;

# define  PLODir_constrstatInc Lisp2D_PLODir_constrstatInc
void  PLODir_constrstatInc ( void  ) ;

# endif // LISP2D_CONSTRSTAT

# include "dir/type.h"

# define  PLODir_Destr  Lisp2D_PLODir_Destr
void  PLODir_Destr ( PLODirPri * ) ;

# include "plo/struct.h"

# define  PLODir_staticTypeOf Lisp2D_PLODir_staticTypeOf
ParaLispObject  * PLODir_staticTypeOf ( ParaLispObject const *  ) ;

# define  PLODir_staticClassDef Lisp2D_PLODir_staticClassDef
ParaLispObject  * PLODir_staticClassDef  ( ParaLispObject const *  ) ;

# define  PLODir_staticClassParents Lisp2D_PLODir_staticClassParents
ParaLispObject  * PLODir_staticClassParents  ( ParaLispObject const * ) ;

# include "stcl/classc.h"

# define  PLODir_OpenCharS  Lisp2D_PLODir_OpenCharS
void  PLODir_OpenCharS  ( PLODirPub * , char const * s  , StackClusterPrivate  * ) ;

# define  PLODir_Open Lisp2D_PLODir_Open
void  PLODir_Open  ( PLODirPub * ) ;

# define  isBADPLODir_Close  Lisp2D_isBADPLODir_Close
int isBADPLODir_Close ( PLODirPub * ) ;

# define  PLODir_Read Lisp2D_PLODir_Read
ParaLispObject  * PLODir_Read  ( PLODirPub * ) ;

# define  PLODir_Openp  Lisp2D_PLODir_Openp
ParaLispObject  * PLODir_Openp ( PLODirPub * ) ;

# define  PLODir_Rewind Lisp2D_PLODir_Rewind
ParaLispObject  * PLODir_Rewind ( PLODirPub * ) ;

# include "fraction/type.h"

# define  PLODir_Seek Lisp2D_PLODir_Seek
void PLODir_Seek  ( PLODirPub * , FractionPub const * ) ;

# include "plostream/type.h"

# define  PLODir_staticCoutToHuman  Lisp2D_PLODir_staticCoutToHuman
void  PLODir_staticCoutToHuman ( ParaLispObject const * ,
  PLOStream  const * , bool flag2pprinted  , Vector ( StackPLOP )  * h ) ;

# define  PLODir_staticCoutToInterpret  Lisp2D_PLODir_staticCoutToInterpret
void  PLODir_staticCoutToInterpret ( ParaLispObject const * ,
  PLOStream  const * , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;

FuncBining  Lisp2Dbimdirdir2 ;
  FuncBining  Lisp2Dbimdirswap2 ;
  FuncBining  Lisp2Dbimnildirp2 ;
  FuncBining  Lisp2Dbimdiropen2 ;
  FuncBining  Lisp2Dbimdirclose2 ;
  FuncBining  Lisp2Dbimdirread2 ;
  FuncBining  Lisp2Dbimdiropenp2 ;
  FuncBining  Lisp2Dbimdirrewind2 ;
  FuncBining  Lisp2Dbimdirseek2 ;
  FuncBining  Lisp2Dbimdirtell2 ;

# define  IsNotDir  Lisp2D_IsNotDir
bool  IsNotDir  ( StackClusterPrivate * , ParaLispObject * ) ;

# include "string/type.h"

# define  PLODir_OpenPLOString  Lisp2D_PLODir_OpenPLOString
void  PLODir_OpenPLOString  ( PLODirPub * , PLOStringPub  *  , StackClusterPrivate  * ) ;

# define  ParaLispObjectToPLODir Lisp2DParaLispObjectToPLODir
inline  PLODirPub * ParaLispObjectToPLODir ( ParaLispObject * ) ;

# define  PLODir_staticDestr  Lisp2D_PLODir_staticDestr
void PLODir_staticDestr  ( ParaLispObject * ) ;

# define  ParaLispObjectToPLODirConst Lisp2DParaLispObjectToPLODirConst
inline  PLODirPub const * ParaLispObjectToPLODirConst ( ParaLispObject const * ) ;

# define  PLODir_Swap Lisp2D_PLODir_Swap
void  PLODir_Swap  ( PLODirPub * , PLODirPub * ) ;

# include <dirent.h>  // DIR

# define  PLODir_DirPointerAddress  Lisp2D_PLODir_DirPointerAddress
inline  DIR * const * PLODir_DirPointerAddress ( PLODirPub const * ) ;

# define  PLODir_DirPointerValue  Lisp2D_PLODir_DirPointerValue
inline  DIR * PLODir_DirPointerValue ( PLODirPub const * ) ;

# define  PLODir_Init Lisp2D_PLODir_Init
void  PLODir_Init ( PLODirPri * ) ;

# define  Dirp  Lisp2D_Dirp
inline  bool  Dirp ( ParaLispObject const * ) ;

# include "stcl/inline.h"

# endif // LISP2D_DIR_PUBLIC_H
