// Lisp2D - Environment
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_ENV_PUBLIC_H
# define  LISP2D_ENV_PUBLIC_H

LISP2DMAPSTACKPUSHBYVALUEPROTO  ( PLOValueFlagConst )
LISP2DMAPSTACKATPROTO ( PLOValueFlagConst )
LISP2DMAPSTACKCATPROTO  ( PLOValueFlagConst )
LISP2DMAPSTACKPUSHATVALUEPROTO  ( PLOValueFlagConst )
# include "plo/type.h"
LISP2DMAPCOMPTYPE ( PLOValueFlagConst , ParaLispObject * )
LISP2DMAPINSERTPROTO  (  PLOValueFlagConst )
LISP2DMAPFINDPROTO  (  PLOValueFlagConst , ParaLispObject * )

# define  EnvironmentPLOLess  Lisp2DEnvironmentPLOLessht9q
int EnvironmentPLOLess  ( ParaLispObject * , ParaLispObject * ) ;

// returns error when OutOfmemory OR ConstLink modifying    
# define  EnvironmentLayerisBADPush Lisp2DEnvironmentLayerisBADPush
bool  EnvironmentLayerisBADPush ( EnvironmentLayer  * , ParaLispObject  * s ,
  ParaLispObject  * v , bool  flagconst ) ;

// const variable : change value in BIM consiquent cycles
// returns Value or nullptr
# define  EnvironmentLayerAssocPassage  Lisp2DEnvironmentLayerAssocPassage
ParaLispObject  * EnvironmentLayerAssocPassage  ( EnvironmentLayer  * , ParaLispObject * ) ;

# define  s_EnvironmentLayerisOKTryChangeValue  Lisp2D_s_EnvironmentLayerisOKTryChangeValue
# define  t_EnvironmentLayerisOKTryChangeValue  Lisp2D_t_EnvironmentLayerisOKTryChangeValue
typedef struct  s_EnvironmentLayerisOKTryChangeValue  t_EnvironmentLayerisOKTryChangeValue  ;

struct  s_EnvironmentLayerisOKTryChangeValue  {
  EnvironmentLayer * const me ;
  ParaLispObject * const sp  ;
  ParaLispObject  * const vp ;
  bool * const flagwasconstp  ;
  bool  const flagconst ;
} ;

// returns false when value not present OR have Const Links  
# define  EnvironmentLayerisOKTryChangeValue Lisp2DEnvironmentLayerisOKTryChangeValue
bool  EnvironmentLayerisOKTryChangeValue  ( t_EnvironmentLayerisOKTryChangeValue ) ;

# define  EnvironmentLayerisOKTryChangeValueIgnoreWasConst Lisp2DEnvironmentLayerisOKTryChangeValueIgnoreWasConst
bool  EnvironmentLayerisOKTryChangeValueIgnoreWasConst  ( EnvironmentLayer  * ,
  ParaLispObject *  , ParaLispObject  * , bool flagconst  ) ;

# define  EnvironmentLayerisOKSetConstFlag Lisp2DEnvironmentLayerisOKSetConstFlag
bool  EnvironmentLayerisOKSetConstFlag  ( EnvironmentLayer  * , ParaLispObject * , bool ) ;

# define  EnvironmentLayerisOKGetConstFlag Lisp2DEnvironmentLayerisOKGetConstFlag
bool  EnvironmentLayerisOKGetConstFlag  ( EnvironmentLayer  * , ParaLispObject * , bool  * ) ;

# define  EnvironmentLayerPushAll Lisp2DEnvironmentLayerPushAll
void  EnvironmentLayerPushAll ( EnvironmentLayer  * , EnvironmentLayer  const * ) ;

# define  EnvironmentLayerGCDeclare Lisp2DEnvironmentLayerGCDeclare
void  EnvironmentLayerGCDeclare  ( EnvironmentLayer  * ) ;  

# include "define.h"

# ifdef  LISP2D_CONSTRSTAT  
# define  PLOEnvironmentLayer_ConstrstatValue Lisp2D_PLOEnvironmentLayer_ConstrstatValue
size_t  PLOEnvironmentLayer_ConstrstatValue  ( void ) ;  

# define  PLOEnvironmentLayer_ConstrstatAdd Lisp2D_PLOEnvironmentLayer_ConstrstatAdd
void  PLOEnvironmentLayer_ConstrstatAdd ( void )  ;
# endif

# define  PLOEnvironmentLayer_Init  Lisp2D_PLOEnvironmentLayer_Init
void  PLOEnvironmentLayer_Init ( PLOEnvironmentLayer  * )  ;    

# define  PLOEnvironmentLayer_InitCopy_Exc Lisp2D_PLOEnvironmentLayer_InitCopy_Exc
void  PLOEnvironmentLayer_InitCopy_Exc ( PLOEnvironmentLayer  * me , PLOEnvironmentLayer const * x ) ;

# define  PLOEnvironmentLayer_Destr  Lisp2D_PLOEnvironmentLayer_Destr
void  PLOEnvironmentLayer_Destr ( PLOEnvironmentLayer  * )  ;  

# define  PLOEnvironmentLayer_staticDestr Lisp2D_PLOEnvironmentLayer_staticDestr
void PLOEnvironmentLayer_staticDestr  ( ParaLispObject * ) ;  

# define  PLOEnvironmentLayer_staticClassDef Lisp2D_PLOEnvironmentLayer_staticClassDef
ParaLispObject  * PLOEnvironmentLayer_staticClassDef  ( ParaLispObject const *  ) ;

# define  GlobalListOfLayer Lisp2D_GlobalListOfLayer
extern  GlobalList  GlobalListOfLayer ;
# define  GlobalListOfLayerGarbage  Lisp2D_GlobalListOfLayerGarbage
extern  GlobalList  GlobalListOfLayerGarbage  ;
# define  GlobalListOfLayerGC Lisp2D_GlobalListOfLayerGC
extern  GlobalList  GlobalListOfLayerGC ;

# define  PLOEnvironmentLayer_staticClassParents Lisp2D_PLOEnvironmentLayer_staticClassParents
ParaLispObject  * PLOEnvironmentLayer_staticClassParents  ( ParaLispObject const *  ) ;

# define  PLOEnvironmentLayer_staticTypeOf Lisp2D_PLOEnvironmentLayer_staticTypeOf
ParaLispObject  * PLOEnvironmentLayer_staticTypeOf ( ParaLispObject const * ) ;  

# define  PLOEnvironmentLayer_staticGCDeclareContent  Lisp2D_PLOEnvironmentLayer_staticGCDeclareContent
void  PLOEnvironmentLayer_staticGCDeclareContent ( ParaLispObject *  ) ;  

# define  PLOEnvironmentLayer_staticPushAsNew Lisp2D_PLOEnvironmentLayer_staticPushAsNew
ParaLispObject  * PLOEnvironmentLayer_staticPushAsNew ( ParaLispObject * me ) ;  

# define  PLOEnvironmentLayer_staticDeclareForGC Lisp2D_PLOEnvironmentLayer_staticDeclareForGC
void  PLOEnvironmentLayer_staticDeclareForGC ( ParaLispObject *  ) ;  

# define  PLOEnvironmentLayer_staticisBADCopyPrivate  Lisp2D_PLOEnvironmentLayer_staticisBADCopyPrivate
bool  PLOEnvironmentLayer_staticisBADCopyPrivate ( ParaLispObject const * me , ParaLispObject  * *  resultp  ) ;

# define  NewEnvironmentLayerCopy Lisp2D_NewEnvironmentLayerCopy
PLOEnvironmentLayer * NewEnvironmentLayerCopy ( PLOEnvironmentLayer const * ) ;    

# define  PLOEnvironmentLayer_FromMember  Lisp2D_PLOEnvironmentLayer_FromMember
PLOEnvironmentLayer * PLOEnvironmentLayer_FromMember ( GlobalListMember * ) ;
  
# include "plostream/type.h"

# define  PLOEnvironmentLayer_staticCoutToHuman Lisp2D_PLOEnvironmentLayer_staticCoutToHuman
void  PLOEnvironmentLayer_staticCoutToHuman ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector(StackPLOP)  *  h ) ;

# define  PLOEnvironmentLayer_staticCoutToInterpret Lisp2D_PLOEnvironmentLayer_staticCoutToInterpret
void  PLOEnvironmentLayer_staticCoutToInterpret ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted , Vector(StackPLOP)  *  h ) ;       

# define  Environment_NewLevel  Lisp2D_Environment_NewLevel
void  Environment_NewLevel ( Environment  * e , ParaLispObject * level  )  ;
  
# define  Environment_ReleaseLevel  Lisp2D_Environment_ReleaseLevel
void  Environment_ReleaseLevel  ( Environment  * ) ;  

# ifdef LISP2D_CONSTRSTAT

# define  PLOEnv_constrstatValue  Lisp2D_PLOEnv_constrstatValue
size_t  PLOEnv_constrstatValue  ( void  ) ;

# define  PLOEnv_constrstatIncr Lisp2D_PLOEnv_constrstatIncr
void  PLOEnv_constrstatIncr  ( void  ) ;

# endif

# define  PLOEnv_Init Lisp2D_PLOEnv_Init
void  PLOEnv_Init  ( PLOEnvC * )  ;  

# define  PLOEnv_staticClassDef Lisp2D_PLOEnv_staticClassDef
ParaLispObject  * PLOEnv_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOEnv_staticClassParents Lisp2D_PLOEnv_staticClassParents
ParaLispObject  * PLOEnv_staticClassParents  ( ParaLispObject const * ) ;
  
# define  PLOEnv_staticTypeOf Lisp2D_PLOEnv_staticTypeOf
ParaLispObject  * PLOEnv_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOEnv_staticisBADCopyPrivate Lisp2D_PLOEnv_staticisBADCopyPrivate
bool  PLOEnv_staticisBADCopyPrivate ( ParaLispObject const * me  , ParaLispObject  * * resultp  ) ;

# define  PLOEnv_staticGCDeclareContent Lisp2D_PLOEnv_staticGCDeclareContent
void  PLOEnv_staticGCDeclareContent ( ParaLispObject *  ) ;  
  
# define  PLOEnv_staticCoutToHuman  Lisp2D_PLOEnv_staticCoutToHuman
void  PLOEnv_staticCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector(StackPLOP)  * h ) ;

# define  PLOEnv_staticCoutToInterpret  Lisp2D_PLOEnv_staticCoutToInterpret
void  PLOEnv_staticCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector  ( StackPLOP ) * h ) ;

# define  PLOEnv_Destr  Lisp2D_PLOEnv_Destr
void  PLOEnv_Destr  ( PLOEnvC  * ) ;

# define  PLOEnv_staticDestr  Lisp2D_PLOEnv_staticDestr
void PLOEnv_staticDestr  ( ParaLispObject * ) ;

# define  ploclassdefenv  Lisp2d_ploclassdefenv
extern  ParaLispObject  *   ploclassdefenv  ;

# define  ploclassparentsenv  Lisp2D_ploclassparentsenv
extern  ParaLispObject  *   ploclassparentsenv  ;

# define  NewEnvironmentLayer Lisp2D_NewEnvironmentLayer
PLOEnvironmentLayer * NewEnvironmentLayer ( void ) ;

# include "taskforthread.h"

# define  IsNotEnvironmentLayer Lisp2D_IsNotEnvironmentLayer
bool  IsNotEnvironmentLayer ( StackClusterPrivate * , ParaLispObject  * ) ;

FuncBining  Lisp2Dbimnilenvironment2  ;
  FuncBining  Lisp2Dbimnilenvironmentexternal2  ;
  FuncBining  Lisp2Dbimnilenvp2 ;
  FuncBining  Lisp2Dbimenveval2 ;
  FuncBining  Lisp2Dbimenvapply2 ;
  FuncBining  Lisp2Dbimenvfuncall2 ;
  FuncBining  Lisp2Dbimenvsetq2 ;

# define  IsNotEnv  Lisp2D_IsNotEnv
bool  IsNotEnv  ( StackClusterPrivate * , ParaLispObject  * ) ;

# define  EnvironmentLayerInit  Lisp2D_EnvironmentLayer_Init
void  EnvironmentLayerInit  ( EnvironmentLayer  * ) ;
# define  EnvironmentLayer_InitCopy  Lisp2D_EnvironmentLayer_InitCopy
void  EnvironmentLayer_InitCopy ( EnvironmentLayer  * , EnvironmentLayer const * ) ;
# define  EnvironmentLayerDestr  Lisp2DEnvironmentLayerDestr
void  EnvironmentLayerDestr ( EnvironmentLayer  * ) ;
# define  EnvironmentLayerMap Lisp2DEnvironmentLayerMap
inline  Map(PLOValueFlagConst)  const * EnvironmentLayerMap ( EnvironmentLayer  const * ) ;
# define  EnvironmentLayerSet Lisp2DEnvironmentLayerSet
EnvironmentLayer * EnvironmentLayerSet ( EnvironmentLayer  * , EnvironmentLayer  const * ) ;
# define  EnvironmentLayerClear Lisp2DEnvironmentLayerClear
void  EnvironmentLayerClear ( EnvironmentLayer  * ) ;
# define  passageconst_cast_rw  Lisp2D_passageconst_cast_rw
inline  struct  Lisp2DPassagePrivate *  passageconst_cast_rw  ( struct  Lisp2DPassagePrivate const * ) ;
# define  EnvironmentLayerRWThePassageC Lisp2DEnvironmentLayerRWThePassageC
inline  struct  Lisp2DPassagePrivate * EnvironmentLayerRWThePassageC  ( EnvironmentLayer  const * ) ;
# define  ParaLispObjectToPLOEnvironmentLayer Lisp2D_ParaLispObjectToPLOEnvironmentLayer
inline  PLOEnvironmentLayer * ParaLispObjectToPLOEnvironmentLayer ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOEnvironmentLayerConst Lisp2DParaLispObjectToPLOEnvironmentLayerConst
inline  PLOEnvironmentLayer const * ParaLispObjectToPLOEnvironmentLayerConst ( ParaLispObject const * ) ;
# define  Environment_Init  Lisp2D_Environment_Init
inline  void  Environment_Init  ( Environment * ) ;
# define  Environment_SetCopy Lisp2D_Environment_SetCopy
inline  void  Environment_SetCopy ( Environment * , Environment const * ) ;
# define  Environment_SetPair Lisp2D_Environment_SetPair
inline  void  Environment_SetPair ( Environment * , ParaLispObject  * , ParaLispObject  * ) ;
# define  Environment_SetNamespacePropList  Lisp2D_Environment_SetNamespacePropList
inline  void  Environment_SetNamespacePropList  ( Environment  * , ParaLispObject * ) ;
# define  Environment_SetEnv  Lisp2D_Environment_SetEnv
inline  void  Environment_SetEnv  ( Environment * , ParaLispObject * ) ;
# define  Environment_NamespacePropList Lisp2D_Environment_NamespacePropList
inline  ParaLispObject  * Environment_NamespacePropList ( Environment const * ) ;
# define  Environment_Env Lisp2D_Environment_Env
inline  ParaLispObject  * Environment_Env ( Environment const * ) ;
# define  Environment_InitCopy  Lisp2D_Environment_InitCopy
inline  void  Environment_InitCopy  ( Environment * , Environment const * ) ;
# define  ParaLispObjectToPLOEnv Lisp2DParaLispObjectToPLOEnv
inline  PLOEnvC * ParaLispObjectToPLOEnv ( ParaLispObject * ) ;
# define  PLOEnv_InitCopy Lisp2D_PLOEnv_InitCopy
void  PLOEnv_InitCopy  ( PLOEnvC * , PLOEnvC const * ) ;
# define  ParaLispObjectToPLOEnvConst Lisp2DParaLispObjectToPLOEnvConst
inline  PLOEnvC const * ParaLispObjectToPLOEnvConst ( ParaLispObject const * ) ;
# define  Envp  Lisp2D_Envp
inline  bool  Envp ( ParaLispObject const * ) ;
# define  EnvLayerp Lisp2D_EnvLayerp
inline  bool  EnvLayerp ( ParaLispObject const * ) ;

inline  LISP2DDECLAREMAPSTACKINIT (  PLOValueFlagConst )
LISP2DPROTOMAPSTACKINITCOPY (  PLOValueFlagConst )
LISP2DPROTOMAPSTACKDESTR ( PLOValueFlagConst )
LISP2PROTODMAPSTACKPUSHFRONTVALUE ( PLOValueFlagConst )
inline  LISP2DPROTOMAPSTACKATCOPY ( PLOValueFlagConst )
LISP2DPROTOMAPSTACKCLEAR ( PLOValueFlagConst )
LISP2DPROTOMAPSTACKSET ( PLOValueFlagConst )
inline  LISP2DMAPINITDECLARE ( PLOValueFlagConst )
LISP2DMAPINITCOPYDECLARE ( PLOValueFlagConst )
inline  LISP2DMAPSIZEDECLARE ( PLOValueFlagConst )
inline  LISP2DMAPCATDECLARE ( PLOValueFlagConst )
inline  LISP2DMAPATDECLARE ( PLOValueFlagConst )
inline  LISP2DMAPATCOPYDECLARE ( PLOValueFlagConst )
inline  LISP2DMAPCLEARDECLARE ( PLOValueFlagConst )
inline  LISP2DMAPSETDECLARE ( PLOValueFlagConst )
inline  LISP2DMAPDESTRDECLARE ( PLOValueFlagConst )

inline  LISP2DMAPSTACKINITBODY (  PLOValueFlagConst )
inline  LISP2DMAPSTACKATCOPYBODY  ( PLOValueFlagConst )
# include "env/public.h"
inline  LISP2DMAPINITBODY (  PLOValueFlagConst )
inline  LISP2DMAPSIZEBODY (  PLOValueFlagConst )
inline  LISP2DMAPCATBODY (  PLOValueFlagConst )
inline  LISP2DMAPATBODY (  PLOValueFlagConst )
inline  LISP2DMAPATCOPYBODY (  PLOValueFlagConst )
inline  LISP2DMAPCLEARBODY  (  PLOValueFlagConst )
inline  LISP2DMAPSETBODY  (  PLOValueFlagConst )
inline  LISP2DMAPDESTRBODY (  PLOValueFlagConst   )

# include "passage/public.h"

inline  Map(PLOValueFlagConst)  const * EnvironmentLayerMap ( EnvironmentLayer  const * const e ) {
  return  & e -> maplinks ;
}

inline  struct  Lisp2DPassagePrivate *  passageconst_cast_rw  ( struct  Lisp2DPassagePrivate const * const p ) {
  return  ( struct  Lisp2DPassagePrivate * ) p ;
}

// ! to return public

inline  struct  Lisp2DPassagePrivate * EnvironmentLayerRWThePassageC  ( EnvironmentLayer  const * const e ) {
  return  passageconst_cast_rw ( & ( e  ->  passagec ) ) ;
}

inline  PLOEnvironmentLayer * ParaLispObjectToPLOEnvironmentLayer ( ParaLispObject * const p ) {
  return (  PLOEnvironmentLayer * ) ( p  ->  vaddr . addr . p ) ;
}

inline  PLOEnvironmentLayer const * ParaLispObjectToPLOEnvironmentLayerConst ( ParaLispObject const * const p ) {
  return (  PLOEnvironmentLayer const * ) ( p  ->  vaddr . addr . p ) ;
}

# include "nilc.h"

inline  void  Environment_Init  ( Environment * const e ) {
  e -> env  = (  &  plonil  . plo ) ;
  e -> namespaceproplist = ( &  plonil  . plo ) ;
}

inline  void  Environment_SetCopy ( Environment * const me  , Environment const * const e ) {
  me -> env = e -> env ;
  me -> namespaceproplist = e -> namespaceproplist ;
}

inline  void  Environment_SetPair ( Environment * const en  , ParaLispObject  * const e , ParaLispObject  * const p ) {
  en -> env = e ;
  en -> namespaceproplist = p ;
}

inline  void  Environment_SetNamespacePropList  ( Environment  * const e , ParaLispObject * const p ) {
  e -> namespaceproplist = p ;
}

inline  void  Environment_SetEnv  ( Environment * const me  , ParaLispObject * const e  ) {
  me -> env = e ;
}

inline  ParaLispObject  * Environment_NamespacePropList ( Environment const * const e ) {
  return e -> namespaceproplist ;
}

inline  ParaLispObject  * Environment_Env ( Environment const * const e ) {
  return  e -> env ;
}

inline  void  Environment_InitCopy  ( Environment * const me , Environment const * const x ) {
  me -> env = x -> env ;
  me -> namespaceproplist = x -> namespaceproplist ;
}

inline  PLOEnvC * ParaLispObjectToPLOEnv ( ParaLispObject * const p ) {
  return p  ->  vaddr . addr . p ;
}

# include "define.h"

inline  PLOEnvC const * ParaLispObjectToPLOEnvConst ( ParaLispObject const * const p ) {
  return p  ->  vaddr . addr . p ;
}

inline  bool  Envp ( ParaLispObject const * const xp  ) {
  return  ParaLispObject_Type ( xp  ) ==  TypeGlobalListMemberPLOEnv  ;
}

inline  bool  EnvLayerp ( ParaLispObject const * const xp  ) {
  return  ParaLispObject_Type ( xp  ) == TypeGlobalListMemberPLOEnvironmentLayer  ;
}

# endif // LISP2D_ENV_PUBLIC_H
