// EvalAddr Public
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_EVAL_ADDR_PUBLIC_H
# define  LISP2D_EVAL_ADDR_PUBLIC_H

# include "eval-addr/type.h"
# include "eval-addr/enum.h"
# include "eval-addr/struct.h"

// ! EvalAddrPrivat -> EvalAddrPub

# define  EvalAddrSwapByte  Lisp2DEvalAddrSwapByte
inline  void  EvalAddrSwapByte  ( EvalAddrPub * , EvalAddrCont2  * ) ;
# define  EvalAddrClear Lisp2DEvalAddrClear
inline  void  EvalAddrClear ( EvalAddrPub * ) ;
# define  EvalAddrValue Lisp2DEvalAddrValue
inline  EvalAddrCont2 EvalAddrValue ( EvalAddrPub  const * ) ;
# include <stdbool.h>
# define  EvalAddrisZero  Lisp2DEvalAddrisZero
inline  bool  EvalAddrisZero  ( EvalAddrPub const * ) ;
# define  EvalAddrSetCont Lisp2DEvalAddrSetCont
inline  void  EvalAddrSetCont ( EvalAddrPub * , EvalAddrCont2 ) ;
# define  EvalAddrSet Lisp2DEvalAddrSet
inline  void  EvalAddrSet ( EvalAddrPub * , EvalAddrPub const * ) ;

# include "eval-addr/private.h"

inline  void  EvalAddrSwapByte  ( EvalAddrPub * const p  , EvalAddrCont2  * const x ) {
  EvalAddrCont2 xcopy = ( * x ) ;
  EvalAddrPrivat * const e = EvalAddrPub_Cast_Private ( p ) ;
  ( * x ) = ( e -> addr ) ;
  e -> addr  = xcopy ;
}

inline  void  EvalAddrClear ( EvalAddrPub * const p  ) {
  EvalAddrPrivat * const e = EvalAddrPub_Cast_Private ( p ) ;
  e ->  addr  = Lisp2DEvalAddrContZero2 ;
}

inline  EvalAddrCont2 EvalAddrValue ( EvalAddrPub  const * const p  ) {
  EvalAddrPrivat const * const me = EvalAddrPub_Cast_PrivateConst ( p ) ;
  return  me  -> addr  ;
}  
  
inline  bool  EvalAddrisZero  ( EvalAddrPub const * const p ) {
  return EvalAddrValue  ( p ) ==  Lisp2DEvalAddrContZero2  ;
}
  
inline  void  EvalAddrSetCont ( EvalAddrPub * const p , EvalAddrCont2 const a ) {
  EvalAddrPrivat * const e = EvalAddrPub_Cast_Private ( p ) ;
  e ->  addr  = a ;
}
  
inline  void  EvalAddrSet ( EvalAddrPub * const p , EvalAddrPub const * const x ) {
  EvalAddrPrivat * const me = EvalAddrPub_Cast_Private ( p ) ;
  EvalAddrPrivat const * const mx = EvalAddrPub_Cast_PrivateConst ( x ) ;
  me  ->  addr  = ( mx -> addr  ) ;
}
  
# endif
