// Lisp2D - Exception inner
// ©2018-23 by Alex Glebe
# ifndef  LISP2D_EXCC_H
# define  LISP2D_EXCC_H

# include <wchar.h>
# include <setjmp.h>

enum  eLisp2DExcType  {
  Lisp2DExcTypeNULL ,
  Lisp2DExcTypeString ,
  Lisp2DExcTypeXSupportsLocale  ,
  Lisp2DExcTypeOutOfMemory  ,
  Lisp2DExcTypeMutex  ,
  Lisp2DExcTypeStack  ,
} ;

typedef enum  eLisp2DExcType  Lisp2DExcType ;

typedef struct sLisp2DExceptionString Lisp2DExceptionString ;

struct sLisp2DExceptionString {
  wchar_t  const ( * str ) [ ] ;  
}  ;

// ! what's this ?
extern  wchar_t const * const Lisp2DExcTypeName [ ] ;

extern 
# ifdef __cplusplus
  thread_local
# else
  _Thread_local
# endif
jmp_buf * Lisp2DJBglobal  ;

extern 
# ifdef __cplusplus
  thread_local
# else
  _Thread_local
# endif
Lisp2DExceptionString Lisp2DExceptionStringGlobal ;

typedef struct  sLisp2DException  Lisp2DExceptionType ;

struct  sLisp2DException  {
  void  *
# ifndef __cplusplus
    restrict
# endif
    valp ;
} ;

extern
# ifdef __cplusplus
  thread_local
# else
  _Thread_local
# endif
  Lisp2DExceptionType Lisp2Dexception ;

typedef struct  sLisp2DExcXSupportsLocale Lisp2DExcXSupportsLocale ;

struct  sLisp2DExcXSupportsLocale  {
  wchar_t const ( * whata ) [ ] ;
  char * locold ;
} ;

extern  Lisp2DExcXSupportsLocale const  vLisp2DExcXSupportsLocale ;  
  
typedef struct sLisp2DExceptionOutOfMemory  Lisp2DExcOutOfMemory ;

struct sLisp2DExceptionOutOfMemory {
  wchar_t  const * value ; 
} ;

extern 
# ifdef __cplusplus
  thread_local
# else
  _Thread_local
# endif
  Lisp2DExcOutOfMemory Lisp2DExcOutOfMemoryGlobal ;

typedef struct sLisp2DExceptionMutex  Lisp2DExcMutex ;
  
struct sLisp2DExceptionMutex { 
  wchar_t  const * value ; 
} ;

extern 
# ifdef __cplusplus
  thread_local
# else
  _Thread_local
# endif
  Lisp2DExcMutex Lisp2DExcMutexGlobal ;

typedef struct Lisp2DsExcTryThrow Lisp2DExcTryThrow ;
  
struct Lisp2DsExcTryThrow {
  jmp_buf jb  ;
  int code  ;
  jmp_buf * jb_old  ;
} ;
  
inline  void  Lisp2DExcTryThrowDestr  ( Lisp2DExcTryThrow const * const ex  ) {
  Lisp2DJBglobal  = ex  -> jb_old ;  
}

typedef struct Lisp2DsExcStack  Lisp2DExcStack ;

struct Lisp2DsExcStack {
  wchar_t  const * value ;  
} ;

extern 
# ifdef __cplusplus
  thread_local
# else
  _Thread_local
# endif
Lisp2DExcStack Lisp2DExcStackGlobal ;
    
# endif //  LISP2D_EXCC_H
