// Lisp2D - Fraction number private members
// ©2011-23 by Alex Glebe

# include "define.h"

# ifndef  LISP2D_FRACTION_PRIVATE_H
# define  LISP2D_FRACTION_PRIVATE_H

# ifdef  LISP2D_CONSTRSTAT

# include <stdatomic.h>
# include <stddef.h> // size_t
extern  _Atomic ( size_t  ) Lisp2DFraction2Constrstat ;

# endif

# include "fraction/type.h"

# define  FractionSimplify Lisp2D_FractionSimplify
void  FractionSimplify ( Fraction2 * ) ;

# define  FractionSetExactLDoublePrivate Lisp2D_FractionSetExactLDoublePrivate
void  FractionSetExactLDoublePrivate ( Fraction2 * , long double ) ;  

# define  FractionIsSimpleSetExactPrivate Lisp2D_FractionIsSimpleSetExactPrivate
bool  FractionIsSimpleSetExactPrivate  ( Fraction2  * , long  double ) ;    

# define  s_FractionToStringWithDigitsCountLocal  Lisp2D_s_FractionToStringWithDigitsCountLocal
# define  t_FractionToStringWithDigitsCountLocal  Lisp2D_t_FractionToStringWithDigitsCountLocal
typedef struct  s_FractionToStringWithDigitsCountLocal t_FractionToStringWithDigitsCountLocal ;

struct  s_FractionToStringWithDigitsCountLocal  {
  Fraction2 const * const pointerToMe2  ;
  String  ( WideChar  ) * const stringtarget ;
  unsigned  int digc  ;
  bool const toflagshowsign ;
} ;

# define  FractionToStringWithDigitsCountLocal Lisp2DFractionToStringWithDigitsCountLocal7165
void  FractionToStringWithDigitsCountLocal ( t_FractionToStringWithDigitsCountLocal ) ;

# define  FractionToStringForInterpretLocal Lisp2DFractionToStringForInterpretLocal2957
void  FractionToStringForInterpretLocal ( Fraction2 const *  pointerToMe2 ,
  bool   flagshowsign , String(WideChar) *  stringtarget ) ;

# define  FractionRoundStaticMovePriv Lisp2D_FractionRoundStaticMovePriv
// this -> [this-q..this+q]
void  FractionRoundStaticMovePriv ( FractionPub * mep , FractionPub * qp )  ;

# define  FractionDestrPri  Lisp2D_FractionDestrPri
void  FractionDestrPri  ( Fraction2 * ) ;

# define  FractionPubC_cast_bytep  Lisp2D_FractionPubC_cast_bytep
inline  uint8_t const * FractionPubC_cast_bytep  ( FractionPub const * ) ;

# define  bytepc_cast_Fraction  Lisp2D_bytepc_cast_Fraction
inline  Fraction2 const * bytepc_cast_Fraction  ( uint8_t const * p ) ;

# define  Fraction_toCPrivate Lisp2D_Fraction_toCPrivate
inline  Fraction2 const * Fraction_toCPrivate ( FractionPub const * ) ;

# define  bytep_cast_Fraction  Lisp2D_bytep_cast_Fraction
inline  Fraction2 * bytep_cast_Fraction  ( uint8_t * p ) ;

# define  FractionPub_cast_bytep  Lisp2D_FractionPub_cast_bytep
inline  uint8_t * FractionPub_cast_bytep  ( FractionPub * ) ;

# define  Fraction_toPrivate  Lisp2D_Fraction_toPrivate
inline  Fraction2 * Fraction_toPrivate ( FractionPub * ) ;

# endif // LISP2D_FRACTION_PRIVATE_H
