// Lisp2D - Fraction number public members
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_FRACTION_PUBLIC_H
# define  LISP2D_FRACTION_PUBLIC_H

# include "fraction/type.h"

// +0/0 +nan
# define  FractionInit  Lisp2D_FractionInit
void  FractionInit ( FractionPub * ) ;

# define  FractionConstrZero  Lisp2D_FractionConstrZero
void  FractionConstrZero ( FractionPub * ) ;

# define  FractionConstrUInt  Lisp2D_FractionConstrUInt
void  FractionConstrUInt ( FractionPub * , unsigned int ) ;

# define  FractionConstrFNUIntUInt  Lisp2D_FractionConstrFNUIntUInt
void  FractionConstrFNUIntUInt ( FractionPub * m , bool f  , unsigned int n , unsigned int d );

# define  FractionConstrCopy  Lisp2D_FractionConstrCopy
void  FractionConstrCopy ( FractionPub * m , FractionPub const * x ) ;

# define  FractionMoreUInt  Lisp2D_FractionMoreUInt
bool  FractionMoreUInt ( FractionPub const * me , unsigned  int ux ) ;  

# define  FractionConstrMove  Lisp2D_FractionConstrMove
void  FractionConstrMove ( FractionPub * m , FractionPub * x ) ;

# define  FractionIsBADIntValue Lisp2D_FractionIsBADIntValue
bool  FractionIsBADIntValue ( FractionPub const * xp,int  * resp) ;

# include "ulong/private.h"

# define  FractionConstrFNULongULong  Lisp2D_FractionConstrFNULongULong
void  FractionConstrFNULongULong ( FractionPub * mp , bool flagneg , ULongPub const * c , ULongPub const * d ) ;

# define  FractionLValue  Lisp2D_FractionLValue
long  int  FractionLValue ( FractionPub  const * xp) ;

# define  FractionConstrMoveFNULongULong  Lisp2D_FractionConstrMoveFNULongULong
void  FractionConstrMoveFNULongULong ( FractionPub * mp , bool flagneg , ULongPub * c , ULongPub * d ) ;

# define  FractionConstrCopyULong Lisp2D_FractionConstrCopyULong
void  FractionConstrCopyULong ( FractionPub * mp , ULongPub const * x ) ;

# define  FractionConstrULInt Lisp2D_FractionConstrULInt
void  FractionConstrULInt ( FractionPub * fp , unsigned long int x ) ;

# define  FractionConstrLInt  Lisp2D_FractionConstrLInt
void  FractionConstrLInt ( FractionPub * fp , long int li ) ;

# define  FractionConstrUSize Lisp2D_FractionConstrUSize
void  FractionConstrUSize ( FractionPub * fp , size_t s ) ;

// ! to speed up  
# define  FractionAddUInt Lisp2D_FractionAddUInt
void FractionAddUInt ( FractionPub *  mep , unsigned  int  x ) ;

# define  FractionMultConstFraction Lisp2D_FractionMultConstFraction
void FractionMultConstFraction ( FractionPub * me , FractionPub const * px ) ;

// 0..255
# define  FractionForColor  Lisp2D_FractionForColor
unsigned  int FractionForColor  ( FractionPub const * xp  ) ;

# define  FractionSquare  Lisp2D_FractionSquare
void FractionSquare  ( FractionPub * me ) ;

# define  FractionIsBADByteValue  Lisp2D_FractionIsBADByteValue
bool  FractionIsBADByteValue(FractionPub const * mep , uint8_t * resp)  ;

# define  FractionMultMoveFraction  Lisp2D_FractionMultMoveFraction
void  FractionMultMoveFraction  ( FractionPub * me , FractionPub * px ) ;

# define  FractionAddMoveFraction Lisp2D_FractionAddMoveFraction
void  FractionAddMoveFraction  ( FractionPub  * mep  , FractionPub * xp  ) ;

# define  FractionMultULInt Lisp2D_FractionMultULInt
void  FractionMultULInt ( FractionPub * me, unsigned long int x )  ;

# define  FractionSubtractMove  Lisp2D_FractionSubtractMove
void  FractionSubtractMove  ( FractionPub  * me , FractionPub *  px  ) ;  

# define  FractionDivULInt  Lisp2D_FractionDivULInt
void  FractionDivULInt  ( FractionPub * me , unsigned long int x )  ;

# define  FractionSetExactLDouble Lisp2D_FractionSetExactLDouble
void  FractionSetExactLDouble ( FractionPub  * me , long double x2 ) ;  

# define  FractionMultULongConst  Lisp2D_FractionMultULongConst
void FractionMultULongConst  ( FractionPub  * me , ULongPub  const * pxp )  ;

# define  FractionAddConstFraction  Lisp2D_FractionAddConstFraction
void  FractionAddConstFraction  ( FractionPub * me , FractionPub const * px  ) ;

# define  FractionDivFractionConst  Lisp2D_FractionDivFractionConst
void FractionDivFractionConst  ( FractionPub  * me , FractionPub const *  px  ) ;

# define  FractionSubtractConst Lisp2D_FractionSubtractConst
void  FractionSubtractConst  ( FractionPub * me , FractionPub const *  px  ) ;  

# define  FractionDivFractionMove Lisp2D_FractionDivFractionMove
void FractionDivFractionMove  ( FractionPub  * me , FractionPub *  px  )  ;  

# define  FractionSetFraction Lisp2D_FractionSetFraction
void FractionSetFraction ( FractionPub  * me , FractionPub  const * x ) ;

# define  FractionIsInf Lisp2D_FractionIsInf
bool  FractionIsInf ( FractionPub  const * xp) ;  

// ! to use FractionMoveFraction to optimize

# define  FractionSwapFraction  Lisp2D_FractionSwapFraction
void  FractionSwapFraction  ( FractionPub * me , FractionPub * x ) ;

# define  FractionMoveFraction  Lisp2D_FractionMoveFraction
void  FractionMoveFraction  ( FractionPub * const mep , FractionPub * const xp ) ;

# define  FractionSetULInt  Lisp2D_FractionSetULInt
void  FractionSetULInt  ( FractionPub * me , unsigned long  int x  ) ;

# define  FractionSetULong  Lisp2D_FractionSetULong
void  FractionSetULong ( FractionPub * me , ULongPub const * cp ) ;

# include <sys/types.h> //  ssize_t

# define  FractionSetSSize  Lisp2D_FractionSetSSize
void  FractionSetSSize ( FractionPub * me , ssize_t ss )  ;

# define  FractionSwapULong Lisp2D_FractionSwapULong
void  FractionSwapULong  ( FractionPub * me , ULongPub  * cp )  ;

# define  FractionMoveULong Lisp2D_FractionMoveULong
void  FractionMoveULong  ( FractionPub * me , ULongPub  * cp )  ;

# define  FractionIsBADUCharValue Lisp2D_FractionIsBADUCharValue
bool  FractionIsBADUCharValue ( FractionPub const * mep , unsigned  char * resp ) ;

# define  FractionSetUInt Lisp2D_FractionSetUInt
void  FractionSetUInt ( FractionPub * me , unsigned  int x ) ;

# define  FractionLn  Lisp2D_FractionLn
void  FractionLn  ( FractionPub const * xp  , FractionPub  * resultp  ) ;

# define  FractionSetUIntUInt Lisp2D_FractionSetUIntUInt
// +n/d  
void  FractionSetUIntUInt ( FractionPub * me , unsigned int num , unsigned int denom )  ;

# define  FractionSetSignUIntUInt Lisp2D_FractionSetSignUIntUInt
// ±n/d  
void  FractionSetSignUIntUInt ( FractionPub * me ,bool  flagneg, unsigned int num , unsigned int denom);

# define  FractionFactorial Lisp2D_FractionFactorial
void  FractionFactorial ( FractionPub * me ) ;  

# define  FractionClearSwapSignULongULong Lisp2D_FractionClearSwapSignULongULong
// for LoadChastDelit2
void  FractionClearSwapSignULongULong  ( FractionPub * me , bool flagneg , ULongPub * num , ULongPub *  denom  ) ;

# define  FractionClearMoveSignULongULong Lisp2D_FractionClearMoveSignULongULong
// for LoadChastDelit2
void  FractionClearMoveSignULongULong  ( FractionPub * me , bool flagneg , ULongPub * num , ULongPub *  denom  ) ;

# define  FractionEqUInt  Lisp2D_FractionEqUInt
bool  FractionEqUInt  ( FractionPub const * me , unsigned int x ) ;

# define  FractionSwapSignULongULong  Lisp2D_FractionSwapSignULongULong
// ! to private ?
// for LoadChastDelit2
void  FractionSwapSignULongULong ( FractionPub * me , bool flagneg , ULongPub * num , ULongPub *  denom )  ;

# define  FractionMoveSignULongULong  Lisp2D_FractionMoveSignULongULong
// ! to private ?
// for LoadChastDelit2
void  FractionMoveSignULongULong ( FractionPub * me , bool flagneg , ULongPub * num , ULongPub *  denom )  ;

# define  FractionPower Lisp2D_FractionPower
void  FractionPower ( FractionPub * me , FractionPub  const * np ) ;

# define  FractionMoveNumPositiveULongULong  Lisp2D_FractionMoveNumPositiveULongULong
// ! to private ?
void FractionMoveNumPositiveULongULong  ( FractionPub * me , ULongPub * cp , ULongPub const * dp  ) ;

# define  FractionMoveDenomPositiveULongULong Lisp2D_FractionMoveDenomPositiveULongULong
// ! to private ?
void FractionMoveDenomPositiveULongULong  ( FractionPub * me , ULongPub const * cp , ULongPub * dp )  ;
  
# define  FractionIsBADUI16Value  Lisp2D_FractionIsBADUI16Value
bool  FractionIsBADUI16Value  ( FractionPub const * xp, uint16_t  * resp)  ;

# define  FractionMulUInt Lisp2D_FractionMulUInt
void FractionMulUInt  ( FractionPub * me ,unsigned int x) ;  

# define  FractionSetUSize  Lisp2D_FractionSetUSize
void  FractionSetUSize ( FractionPub * me , size_t    s  )  ;

# define  FractionMul2  Lisp2D_FractionMul2
void  FractionMul2  ( FractionPub * me);

# define  FractionSetWChar  Lisp2D_FractionSetWChar
void  FractionSetWChar  ( FractionPub * me , wchar_t  s  ) ;

# define  FractionDiv2  Lisp2D_FractionDiv2
void  FractionDiv2  ( FractionPub * me )  ;

# include "undefbool.h"

# define  FractionMoreEq  Lisp2D_FractionMoreEq
BoolType  FractionMoreEq  ( FractionPub const *  x,
  FractionPub  const * y) ;

# define  FractionDivUInt Lisp2D_FractionDivUInt
void FractionDivUInt ( FractionPub * me , unsigned int  x  ) ;

# define  FractionMinusUInt Lisp2D_FractionMinusUInt
// ! to speed up    
void FractionMinusUInt  ( FractionPub *  me,unsigned  int x)  ;

# define  FractionSetInt  Lisp2D_FractionSetInt
void  FractionSetInt  ( FractionPub * me ,int  x) ;

# define  FractionSqrt  Lisp2D_FractionSqrt
void  FractionSqrt  ( FractionPub *  xp)  ;

# define  FractionSet0  Lisp2D_FractionSet0
void  FractionSet0  ( FractionPub * me )  ;

# define  FractionSetFromBits Lisp2D_FractionSetFromBits
void  FractionSetFromBits ( FractionPub * me , void  const *  x  , size_t bits ) ;

# define  FractionSet1  Lisp2D_FractionSet1
void  FractionSet1  ( FractionPub  * me)  ;

# define  FractionRound Lisp2D_FractionRound
// [this+0.5]
void FractionRound (  FractionPub  * me  ) ;

# include "define.h"

# ifdef LISP2D_CONSTRSTAT
# define  FractionconstrstatGetValue  Lisp2D_FractionconstrstatGetValue
size_t  FractionconstrstatGetValue ( void ) ;
# endif

# define  FractionRoundStaticConst  Lisp2D_FractionRoundStaticConst
// this -> [this-q..this+q]
void  FractionRoundStaticConst ( FractionPub * me , FractionPub  const *  pqin) ;

# define  FractionRoundStaticMove Lisp2D_FractionRoundStaticMove
// this -> [this-q..this+q]
void  FractionRoundStaticMove ( FractionPub * const mep , FractionPub * const qp ) ;

// cos ( x , eps ) = result +- eps
// eps > 0
# define  Fraction_Cos_Eps  Lisp2D_Fraction_Cos_Eps
void  Fraction_Cos_Eps ( FractionPub * const me , FractionPub  const * const eps ) ;

# define  FractionIsNaN Lisp2D_FractionIsNaN
bool  FractionIsNaN ( FractionPub const * me)  ;

// me -> me := cos(me) , mysin := sin(me)
// eps > 0
# define  Fraction_CosSin_Eps Lisp2D_Fraction_CosSin_Eps
void  Fraction_CosSin_Eps ( FractionPub * me , FractionPub * mysin , FractionPub  const * eps ) ;

# define  FractionIs0 Lisp2D_FractionIs0
bool  FractionIs0 ( FractionPub const * me )  ;

// me := Ln(me) +- eps
# define  Fraction_Ln_Eps Lisp2D_Fraction_Ln_Eps
void  Fraction_Ln_Eps ( FractionPub * me , FractionPub  const * eps ) ;

# define  FractionSetNaN  Lisp2D_FractionSetNaN
// 0/0    
void  FractionSetNaN  ( FractionPub * me) ;

# define  FractionSetInf  Lisp2D_FractionSetInf
// +1/0
void  FractionSetInf  ( FractionPub  * me) ;

# define  Fraction_Sqrt_Rel Lisp2D_Fraction_Sqrt_Rel
void  Fraction_Sqrt_Rel ( FractionPub * me , FractionPub  const * eps )  ;

# define  FractionOverTurn  Lisp2D_FractionOverTurn
// -2/3 -> -3/2  ==  this=1/this
void  FractionOverTurn  ( FractionPub  * me ) ;

// eps > 0
# define  Fraction_Cbrt_Rel Lisp2D_Fraction_Cbrt_Rel
void  Fraction_Cbrt_Rel ( FractionPub * me , FractionPub  const * eps ) ;

# define  FractionFloor Lisp2D_FractionFloor
void  FractionFloor ( FractionPub  * me ) ;

# define  FractionTrunc Lisp2D_FractionTrunc
void  FractionTrunc ( FractionPub  * me ) ;

# define  FractionExp Lisp2D_FractionExp
// !! exp(1e5) -> inf REWRITE !!
void  FractionExp (FractionPub  const * xp,FractionPub  * resultp)  ;

# define  FractionAbsFloor  Lisp2D_FractionAbsFloor
// sign didn't touch  
void  FractionAbsFloor  ( FractionPub  * me )  ;

# define  FractionIs1 Lisp2D_FractionIs1
bool  FractionIs1 ( FractionPub  const * xp) ;

# define  FractionCeil  Lisp2D_FractionCeil
void  FractionCeil  ( FractionPub  * me )  ;

# define  FractionAdd1  Lisp2D_FractionAdd1
void  FractionAdd1  ( FractionPub  * me )  ;

# define  FractionSub1  Lisp2D_FractionSub1
void  FractionSub1  ( FractionPub  * me ) ;

# define  FractionRoundStaticMethod Lisp2D_FractionRoundStaticMethod
void  FractionRoundStaticMethod ( FractionPub * me , FractionPub  const * qp ) ;

# define  FractionSetLInt Lisp2D_FractionSetLInt
void  FractionSetLInt ( FractionPub * me , long  int l ) ;

# define  FractionMod Lisp2D_FractionMod
// this-=[this]
void  FractionMod ( FractionPub * me ) ;

# define  FractionIsBADUShortValue  Lisp2D_FractionIsBADUShortValue
bool  FractionIsBADUShortValue  ( FractionPub const * xp, unsigned short int  * resp)  ;

# define  FractionSetRoundEps Lisp2DFractionSetRoundEps8682
void  FractionSetRoundEps ( FractionPub * me , long  double x2 , FractionPub const  *  eps )  ;

# define  FractionToStringWhereMeChastIs0ForInterpret Lisp2DFractionToStringWhereMeChastIs0ForInterpret4623
void  FractionToStringWhereMeChastIs0ForInterpret ( FractionPub const * pointerToMe2  ,
  bool  pointertoflagshowsign , String(WideChar) * stringtarget) ;

# define  FractionToStringWhereMeChastIs0ForHuman Lisp2DFractionToStringWhereMeChastIs0ForHuman7083
void  FractionToStringWhereMeChastIs0ForHuman ( FractionPub const *  pointerToMe2  ,
  bool  pointertoflagshowsign , String(WideChar) *  stringtarget) ;

# define  FractionToString  Lisp2DFractionToString4495
void  FractionToString ( FractionPubAddrToStringWhereMeChastIs0ForInterpretHuman f  ,
  FractionPub const *  mep , String(WideChar) * sc  , unsigned int digc0  , bool flagshowsign ) ;

# define  FractionIsBadSizeValue  Lisp2D_FractionIsBadSizeValue
bool  FractionIsBadSizeValue  ( FractionPub const * xp, size_t  * resultp ) ;

# define  FractionToStringForInterpret  Lisp2DFractionToStringForInterpret3329
void  FractionToStringForInterpret  ( FractionPub const *  mep , String(WideChar) * sc  ,
  unsigned int    digc0  , bool flagshowsign ) ;

# define  FractionToStringForHuman  Lisp2DFractionToStringForHuman0254
void  FractionToStringForHuman  ( FractionPub const *  mep ,
  String(WideChar) *  sc  , unsigned int  digc0  , bool flagshowsign ) ;

# define  FractionLessUInt  Lisp2D_FractionLessUInt
bool  FractionLessUInt ( FractionPub  const * me  , unsigned int ux ) ;

# define  FractionLDValueTemp Lisp2DFractionLDValueTemp6365
long  double  FractionLDValueTemp  ( FractionPub *  me )  ;
  
# define  FractionMoreEqUSize Lisp2D_FractionMoreEqUSize
bool  FractionMoreEqUSize ( FractionPub const * me , size_t x )  ;

# define  s_FractionLoadChastDelitFromString  Lisp2D_s_FractionLoadChastDelitFromString
# define  t_FractionLoadChastDelitFromString  Lisp2D_t_FractionLoadChastDelitFromString
typedef struct  s_FractionLoadChastDelitFromString  t_FractionLoadChastDelitFromString  ;

struct  s_FractionLoadChastDelitFromString  {
  String  ( WideChar  ) const * const wsp ;
  size_t  * const jp ;
  FractionPub * const rf0 ;
  bool  * const lerr ;
  size_t  const i ;
  bool  * const flagImp ;
} ;

# define  FractionLoadChastDelitFromString Lisp2DFractionLoadChastDelitFromString7895
// !! very slow: 123e12345
// string may partially compiled
// in start rf=0/1
bool  FractionLoadChastDelitFromString  ( t_FractionLoadChastDelitFromString const  * ) ;

# define  FractionMoreUSize Lisp2D_FractionMoreUSize
bool  FractionMoreUSize ( FractionPub  const * me, size_t x)  ;

// returns dead fraction
# define  NewStackFraction  Lisp2D_NewStackFraction
FractionPub * NewStackFraction (  void  ) ;

# define  FractionLessUSize Lisp2D_FractionLessUSize
bool  FractionLessUSize ( FractionPub  const * me,size_t x)  ;

# define  FractionLess  Lisp2D_FractionLess
BoolType  FractionLess  ( FractionPub const *  me, FractionPub  const *  x)  ;

# define  FractionIntegerP  Lisp2D_FractionIntegerP
bool  FractionIntegerP  ( FractionPub const * x  ) ;

# define  FractionEq  Lisp2D_FractionEq
bool  FractionEq  ( FractionPub const * me, FractionPub const * x) ;

# define  FractionUIValue Lisp2D_FractionUIValue
unsigned  int FractionUIValue ( FractionPub  const * ) ;

# define  FractionLDValueConst  Lisp2D_FractionLDValueConst
long  double  FractionLDValueConst  ( FractionPub const * ) ;

# define  FractionploConstPiPub Lisp2D_FractionploConstPiPub
extern  FractionPub const * const FractionploConstPiPub ;
# define  FractionploPiPub  Lisp2D_FractionploPiPub
extern  FractionPub * const FractionploPiPub  ;
# define  FractionploConst2PiPub Lisp2D_FractionploConst2PiPub
extern  FractionPub const * const FractionploConst2PiPub ;
# define  Fractionplo2PiPub Lisp2D_Fractionplo2PiPub
extern  FractionPub * const Fractionplo2PiPub ;
# define  FractionploHalfPiPub  Lisp2D_FractionploHalfPiPub
extern  FractionPub * const FractionploHalfPiPub  ;
# define  FractionploConstHalfPiPub Lisp2D_FractionploConstHalfPiPub
extern  FractionPub const * const FractionploConstHalfPiPub  ;
# define  FractionploEPub Lisp2D_FractionploEPub
extern  FractionPub * const FractionploEPub  ;
# define  FractionploConstEPub  Lisp2D_FractionploConstEPub
extern  FractionPub const * const FractionploConstEPub  ;

# include "fraction/inlinepri.h"

# define  FractionSetFlagNegative Lisp2D_FractionSetFlagNegative
inline void FractionSetFlagNegative ( FractionPub * , bool  flagneg ) ;
# define  FractionToPub Lisp2D_FractionToPub
inline  FractionPub * FractionToPub ( Fraction2 * ) ;
# define  FractionCToPub Lisp2D_FractionCToPub
inline  FractionPub const * FractionCToPub ( Fraction2 const * ) ;
# define  FractionMoreEqUInt  Lisp2D_FractionMoreEqUInt
bool  FractionMoreEqUInt  ( FractionPub const * , unsigned  int ) ;
# define  FractionCDenomp  Lisp2D_FractionCDenomp
inline  ULongPub const * FractionCDenomp  ( FractionPub  const * ) ;
# define  FractionFiniteP Lisp2D_FractionFiniteP
inline  bool  FractionFiniteP ( FractionPub  const * ) ;
# define  FractionNotEq Lisp2D_FractionNotEq
bool  FractionNotEq ( FractionPub const * , FractionPub  const * ) ;
# define  FractionAbs Lisp2D_FractionAbs
inline  void  FractionAbs ( FractionPub * ) ;
# define  FractionMore  Lisp2D_FractionMore
inline  BoolType  FractionMore ( FractionPub const * , FractionPub  const * ) ;
# define  FractionLessEqUInt  Lisp2D_FractionLessEqUInt
bool  FractionLessEqUInt  ( FractionPub const * , unsigned  int ) ;
# define  FractionSetPointer  Lisp2D_FractionSetPointer
void  FractionSetPointer  ( FractionPub * , void * ) ;
# define  FractionIsNegative  Lisp2D_FractionIsNegative
inline  bool  FractionIsNegative ( FractionPub  const * ) ;
# define  FractionTurnSign  Lisp2D_FractionTurnSign
inline  void FractionTurnSign  ( FractionPub * ) ;
# define  FractionNump  Lisp2D_FractionNump
inline  ULongPub * FractionNump  ( FractionPub * ) ;
# define  FractionCNump  Lisp2D_FractionCNump
inline  ULongPub const * FractionCNump  ( FractionPub  const * ) ;
# define  FractionDenomp  Lisp2D_FractionDenomp
inline  ULongPub * FractionDenomp  ( FractionPub * ) ;
# define  FractionDestr Lisp2D_FractionDestr
void  FractionDestr ( FractionPub * ) ;

inline void FractionSetFlagNegative ( FractionPub * const mep , bool  const flagneg ) {
  Fraction_toPrivate  ( mep ) -> flagNegative = flagneg  ;
}

inline  FractionPub * FractionToPub ( Fraction2 * const pr )  {
  return  & pr  ->  pub ;
}

inline  FractionPub const * FractionCToPub ( Fraction2 const * const pr )  {
  return  & pr  ->  pub ;
}

# include "fraction/public.h"
# include "ulong/inline.h"

inline  ULongPub const * FractionCDenomp  ( FractionPub  const * const  mep ) {
  Fraction2 const * const me = Fraction_toCPrivate  ( mep ) ;
  return ULongCToPub ( & ( me -> denom ) ) ;
}

inline  bool  FractionFiniteP ( FractionPub  const * const xp ) {
  return not  ( ULongIs0 ( FractionCDenomp  ( xp  ) ) ) ;
}

inline  void  FractionAbs ( FractionPub * const x ) {
  FractionSetFlagNegative  ( x , false ) ;
}

inline  BoolType  FractionMore ( FractionPub const * const xp , FractionPub  const * const yp ) {
  return  FractionLess  ( yp , xp ) ;
}

inline  bool  FractionIsNegative ( FractionPub  const * const mep ) {
  Fraction2 const * const me = Fraction_toCPrivate  ( mep ) ;
  return me -> flagNegative ;
}

inline  void FractionTurnSign  ( FractionPub * const xp ) {
  Fraction2 * const me = Fraction_toPrivate  ( xp ) ;
  me -> flagNegative  = not ( me  ->  flagNegative ) ;
}

inline  ULongPub * FractionNump  ( FractionPub * const  mep ) {
  Fraction2 * const me = Fraction_toPrivate  ( mep ) ;
  return ULongToPub ( & ( me -> numer  ) ) ;
}

inline  ULongPub const * FractionCNump  ( FractionPub  const * const  mep ) {
  Fraction2 const * const me = Fraction_toCPrivate  ( mep ) ;
  return ULongCToPub ( & ( me -> numer  ) ) ;
}

inline  ULongPub * FractionDenomp  ( FractionPub * const  mep ) {
  Fraction2 * const me = Fraction_toPrivate  ( mep ) ;
  return ULongToPub ( & ( me -> denom ) ) ;
}

# endif // LISP2D_FRACTION_PUBLIC_H
