// Lisp2D GlobalList
// ©2010-23 by Alex Glebe
# ifndef  LISP2D_GLOBALLIST_H
# define  LISP2D_GLOBALLIST_H
# include "define.h"
  
# define  TypeGlobalListMemberBase  Lisp2DTypeGlobalListMemberBase
# define  TypeGlobalListMemberStClPriv  Lisp2DTypeGlobalListMemberStClPriv
# define  TypeGlobalListMemberPLOComplex  Lisp2DTypeGlobalListMemberPLOComplex
# define  TypeGlobalListMemberParaLispObject  Lisp2DTypeGlobalListMemberParaLispObject
# define  TypeGlobalListMemberPLOStream Lisp2DTypeGlobalListMemberPLOStream
# define  TypeGlobalListMemberPLOEnv  Lisp2DTypeGlobalListMemberPLOEnv
# define  TypeGlobalListMemberPLOObject Lisp2DTypeGlobalListMemberPLOObject
# define  TypeGlobalListMemberPLOCons Lisp2DTypeGlobalListMemberPLOCons
# define  TypeGlobalListMemberBackQuotePrivate \
  Lisp2DTypeGlobalListMemberBackQuotePrivate
# define  TypeGlobalListMemberPLOString Lisp2DTypeGlobalListMemberPLOString
# define  TypeGlobalListMemberPLOVector Lisp2DTypeGlobalListMemberPLOVector
# define  TypeGlobalListMemberPLOChar Lisp2DTypeGlobalListMemberPLOChar
# define  TypeGlobalListMemberPLOByteDeque  Lisp2DTypeGlobalListMemberPLOByteDeque
# ifndef  LISP2D_DONTUSEX11
# define  TypeGlobalListMemberPLOWindowPri Lisp2D_TypeGlobalListMemberPLOWindowPri
# endif
# define  TypeGlobalListMemberPLOTime Lisp2DTypeGlobalListMemberPLOTime
# define  TypeGlobalListMemberPLOComma  Lisp2DTypeGlobalListMemberPLOComma
# define  TypeGlobalListMemberPLODir  Lisp2DTypeGlobalListMemberPLODir
# define  TypeGlobalListMemberPLOSocket Lisp2DTypeGlobalListMemberPLOSocket
# define  TypeGlobalListMemberPLOUnquoteSplicing \
  Lisp2DTypeGlobalListMemberPLOUnquoteSplicing
# define  TypeGlobalListMemberPLOStatPri Lisp2DTypeGlobalListMemberPLOStatPri
# define  TypeGlobalListMemberPLOQuote  Lisp2DTypeGlobalListMemberPLOQuote
# define  TypeGlobalListMemberPLOLock Lisp2DTypeGlobalListMemberPLOLock
# define  TypeGlobalListMemberPLOSignal Lisp2DTypeGlobalListMemberPLOSignal
# define  TypeGlobalListMemberPLOEnvironmentLayer \
  Lisp2DTypeGlobalListMemberPLOEnvironmentLayer
# define  TypeGlobalListMemberPLONil  Lisp2DTypeGlobalListMemberPLONil
# define  TypeGlobalListMemberPLOSymbol Lisp2DTypeGlobalListMemberPLOSymbol
# define  TypeGlobalListMemberBIFPrivate  Lisp2DTypeGlobalListMemberBIFPrivate
# define  TypeGlobalListMemberPLOBoolean  Lisp2DTypeGlobalListMemberPLOBoolean
# define  TypeGlobalListMemberSIZE  Lisp2DTypeGlobalListMemberSIZE
enum  { TypeGlobalListMemberBase  , TypeGlobalListMemberStClPriv  ,
  TypeGlobalListMemberPLOComplex  , TypeGlobalListMemberParaLispObject ,
  TypeGlobalListMemberPLOStream , TypeGlobalListMemberPLOEnv  ,
  TypeGlobalListMemberPLOObject , TypeGlobalListMemberPLOCons ,
  TypeGlobalListMemberBackQuotePrivate  , TypeGlobalListMemberPLOString ,
  TypeGlobalListMemberPLOChar , TypeGlobalListMemberPLOVector ,
  TypeGlobalListMemberPLOByteDeque  ,
# ifndef  LISP2D_DONTUSEX11  
  TypeGlobalListMemberPLOWindowPri ,
# endif  
  TypeGlobalListMemberPLOTime , TypeGlobalListMemberPLOComma  ,
  TypeGlobalListMemberPLODirPri  , TypeGlobalListMemberPLOSocket ,
  TypeGlobalListMemberPLOUnquoteSplicing  , TypeGlobalListMemberPLOStatPri ,
  TypeGlobalListMemberPLOQuote  , TypeGlobalListMemberPLOLock ,
  TypeGlobalListMemberPLOSignal , TypeGlobalListMemberPLOEnvironmentLayer ,
  TypeGlobalListMemberPLONil  , TypeGlobalListMemberPLOSymbol ,
  TypeGlobalListMemberBIFPrivate  , TypeGlobalListMemberPLOBoolean  ,
  TypeGlobalListMemberSIZE
} ;

# include <stddef.h> // size_t

# ifdef  LISP2D_CONSTRSTAT
  # define  GlobalListconstrstat  Lisp2D_GlobalListconstrstat
  extern  _Atomic ( size_t ) GlobalListconstrstat  ;
# endif  
  
# define  GlobalListconstrstatValue Lisp2DGlobalListconstrstatValue
size_t  GlobalListconstrstatValue ( void  ) ;

# include "globallistp/type.h"

# define  GlobalListClear Lisp2DGlobalListClear
  void  GlobalListClear ( GlobalList * ) ; // for GC

# include "globallistm/type.h"
# include <stdbool.h>

# define  GlobalListisOKPopFirstNotLock Lisp2DGlobalListisOKPopFirstNotLock
  bool  GlobalListisOKPopFirstNotLock ( GlobalList *  , GlobalListMember * *  result  ) ;
// ! to rename isBAD..  
# define  GlobalListisBADPopFirst  Lisp2DGlobalListisBADPopFirst
  bool  GlobalListisBADPopFirst  ( GlobalList *  , GlobalListMember * *  result )  ;
  // without freeze  
# define  GlobalListisOKTryPopFirst Lisp2DGlobalListisOKTryPopFirst
  bool  GlobalListisOKTryPopFirst ( GlobalList *  , GlobalListMember * *  result  ) ;
  // without freeze  
# define  GlobalListisOKTryPop  Lisp2DGlobalListisOKTryPop
  bool  GlobalListisOKTryPop  ( GlobalList *  , GlobalListMember *  item  )  ;

// exception Lisp2DExcTypeString
# define  GlobalListPopNotLock  Lisp2DGlobalListPopNotLock
  void  GlobalListPopNotLock ( GlobalList *  , GlobalListMember *  )  ;
  
# define  GlobalListPushNotLock Lisp2DGlobalListPushNotLock
  void  GlobalListPushNotLock ( GlobalList *  , GlobalListMember *  ) ;
# define  GlobalListConstructor Lisp2DGlobalListConstructor
  void  GlobalListConstructor  ( GlobalList *  ) ;
# ifdef LISP2D_DEBUG  
  # define  GlobalListDestructor  Lisp2DGlobalListDestructor  
  void  GlobalListDestructor  ( GlobalList * ) ;
# else
  # define  GlobalListDestructor( X )
  # define  Lisp2DGlobalListDestructor( X )
# endif
// ! bool isBAD..    
# define  GlobalListPush  Lisp2DGlobalListPush
  void  GlobalListPush ( GlobalList *  , GlobalListMember *  )  ;
  // without freeze  
# define  GlobalListisOKTryPush Lisp2DGlobalListisOKTryPush
  bool  GlobalListisOKTryPush ( GlobalList *  , GlobalListMember *  item  ) ;
// ! to return isBAD..    
# define  GlobalListPop Lisp2DGlobalListPop
  void  GlobalListPop  ( GlobalList *  , GlobalListMember *  )  ;
  // replace list member position ..,a,..,b,.. -> ..,b,..,a,..
# define  GlobalListSwapM Lisp2DGlobalListSwapM
  void  GlobalListSwapM  ( GlobalListMember *  a  , GlobalListMember *  b ) ;
  // may be nullptr
# define  GlobalListFirst Lisp2DGlobalListFirst
  GlobalListMember * GlobalListFirst ( GlobalList const * ) ;

# define  GlobalListSizePublic  Lisp2DGlobalListSizePublic
  size_t  GlobalListSizePublic  ( GlobalList const * ) ;
# ifdef  LISP2D_BIMSTAT
# define  GlobalListStatFast  Lisp2DGlobalListStatFast
  size_t  GlobalListStatFast  ( GlobalList const * ) ;
# define  GlobalListStatWait  Lisp2DGlobalListStatWait
  size_t  GlobalListStatWait ( GlobalList const * ) ;
# endif
# define  GlobalListClearSwap Lisp2DGlobalListClearSwap
  void  GlobalListClearSwap ( GlobalList  *  me  , GlobalList  *  x ) ;

# define  GlobalListOfStackClustersGarbage2 Lisp2DGlobalListOfStackClustersGarbage2
extern  GlobalList  GlobalListOfStackClustersGarbage2  ;  

# endif //  LISP2D_GLOBALLIST_H
