// Lisp2D - List template public declare body
// ©2022-3 by Alex Glebe

# ifndef  LISP2D_LIST_PUBLIC_H
# define  LISP2D_LIST_PUBLIC_H

# include <stdlib.h> // free
# include "excc.h"

# define  Lisp2D_ListInit(  N ) Lisp2D_ListInit_  ##  N

# define  LISP2DLISTINITDECL( NAME  ) \
void  Lisp2D_ListInit ( NAME ) ( Lisp2D_List ( NAME ) * ) ;

# define  LISP2DLISTINITBODY( NAME  ) \
void  Lisp2D_ListInit ( NAME ) ( Lisp2D_List ( NAME ) * const p ) { \
  Lisp2D_ListPri ( NAME ) * const me = Lisp2D_ListToPrivate ( NAME ) ( p ) ; \
  me  ->  first = 0 ; \
  me  ->  last  = 0 ; \
}

# define  Lisp2D_ListFirst(  N ) Lisp2D_ListFirst_  ##  N

# define  LISP2DLISTFIRSTDECL( NAME  ) \
Lisp2D_ListNode ( NAME ) * Lisp2D_ListFirst ( NAME ) ( Lisp2D_List ( NAME ) * ) ;

# define  LISP2DLISTFIRSTBODY( NAME  ) \
Lisp2D_ListNode ( NAME ) * Lisp2D_ListFirst ( NAME ) ( Lisp2D_List ( NAME ) * const p ) { \
  return  Lisp2D_ListToPrivate ( NAME ) ( p ) ->  first ; \
}

# define  Lisp2D_ListDestr( N ) Lisp2D_ListDestr_ ##  N
  
# define  LISP2DLISTDESTRDECL( NAME  ) \
void  Lisp2D_ListDestr  ( NAME ) ( Lisp2D_List ( NAME ) * ) ;

# define  LISP2DLISTDESTRBODY( NAME  ) \
void  Lisp2D_ListDestr ( NAME ) ( Lisp2D_List ( NAME ) * const p ) { \
  Lisp2D_ListNode ( NAME  ) * i = Lisp2D_ListToPrivate ( NAME ) ( p ) -> first ; \
  while ( i ) { \
    Lisp2D_ListNodePri ( NAME ) * const ip = Lisp2D_ListNodeToPrivate ( NAME ) ( i ) ; \
    i = ip -> next  ; \
    free  ( ip ) ; \
  } \
}

# define  Lisp2D_ListPushBack(  N ) Lisp2D_ListPushBack_  ##  N
    
# define  LISP2DLISTPUSHBACKDECL( NAME  , TYPE ) \
void  Lisp2D_ListPushBack ( NAME ) ( Lisp2D_List ( NAME ) * , TYPE ) ;

# include <iso646.h>  //  not

# define  LISP2DLISTPUSHBACKBODY( NAME  , TYPE  ) \
void  Lisp2D_ListPushBack ( NAME ) ( Lisp2D_List ( NAME ) * const p , TYPE const v ) { \
  Lisp2D_ListNodePri ( NAME ) * const ne  = \
    aligned_alloc ( _Alignof ( Lisp2D_ListNodePri ( NAME ) ) , sizeof  ( Lisp2D_ListNodePri ( NAME ) ) ) ; \
  if ( not ne ) { \
    Lisp2DExcOutOfMemoryGlobal . value =  \
      L"Lisp2D_ListPushBack:aligned_alloc ( sizeof ( Lisp2D_ListNodePri ) ) == NULL" ; \
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
  } \
  ne  -> val = v ; \
  ne  -> next = 0 ; \
  Lisp2D_ListPri ( NAME ) * const me = Lisp2D_ListToPrivate ( NAME ) ( p ) ; \
  if ( me -> last ) \
    Lisp2D_ListNodeToPrivate ( NAME ) ( me -> last )  ->  next  = & ne -> pub ; \
  else \
    me -> first = & ne -> pub ; \
  me -> last  = & ne -> pub ; \
}
    
# define  Lisp2D_ListNodeInit(  N ) Lisp2D_ListNodeInit_  ##  N
    
# define  LISP2DLISTNODEINITDECL( NAME  , TYPE ) \
void  Lisp2D_ListNodeInit ( NAME ) ( Lisp2D_ListNode ( NAME ) * , TYPE ) ;
  
# define  LISP2DLISTNODEINITBODY( NAME  , TYPE ) \
void  Lisp2D_ListNodeInit ( NAME ) ( Lisp2D_ListNode ( NAME ) * const p , TYPE const v ) { \
  Lisp2D_ListNodePri ( NAME ) * const me = Lisp2D_ListNodeToPrivate ( NAME ) ( p ) ; \
  me  ->  val = v ; \
  me  ->  next  = 0 ; \
}

# define  Lisp2D_ListNodeNext(  N ) Lisp2D_ListNodeNext_  ##  N

# define  LISP2DLISTNODENEXTDECL( NAME ) \
Lisp2D_ListNode ( NAME ) * Lisp2D_ListNodeNext ( NAME ) ( Lisp2D_ListNode ( NAME ) * ) ;
  
# define  LISP2DLISTNODENEXTBODY( NAME ) \
Lisp2D_ListNode ( NAME ) * Lisp2D_ListNodeNext  ( NAME ) ( Lisp2D_ListNode ( NAME ) * const p ) { \
  return  Lisp2D_ListNodeToPrivate ( NAME ) ( p )  ->  next  ; \
}

# define  Lisp2D_ListNodeValue(  N ) Lisp2D_ListNodeValue_  ##  N

# define  LISP2DLISTNODEVALUEDECL( NAME , TYPE ) \
TYPE  Lisp2D_ListNodeValue  ( NAME ) ( Lisp2D_ListNode ( NAME ) const * ) ;

# define  LISP2DLISTNODEVALUEBODY( NAME , TYPE ) \
TYPE  Lisp2D_ListNodeValue  ( NAME ) ( Lisp2D_ListNode ( NAME ) const * const p ) { \
  return  Lisp2D_ListNodeToConstPrivate ( NAME ) ( p )  ->  val  ; \
}
  
# endif //  LISP2D_LIST_PUBLIC_H
