// Lisp2D - Lock
// ©2021-3 by Alex Glebe
# ifndef  LISP2D_LOCK_PUBLIC_H
# define  LISP2D_LOCK_PUBLIC_H
# include "define.h"

# ifdef  LISP2D_CONSTRSTAT 

# define  PLOLockconstrstat Lisp2D_PLOLockconstrstat
extern  _Atomic  ( size_t  ) PLOLockconstrstat  ;

# define  PLOLockConstrStatValue  Lisp2D_PLOLockConstrStatValue
size_t  PLOLockConstrStatValue  ( void  ) ;

# define  PLOLockAddConstrStatFunc  Lisp2D_PLOLockAddConstrStatFunc
void  PLOLockAddConstrStatFunc  ( void  ) ;
# endif

# include "taskforthread.h"

FuncBining  Lisp2Dbimlockprogn2 ;
  FuncBining  Lisp2Dbimlocktry2 ;
  FuncBining  Lisp2Dbimlockset2 ;
  FuncBining  Lisp2Dbimlockunlock2 ;
  FuncBining  Lisp2Dbimnillockp2 ;
  
# include "plo/struct.h"
  
# define  PLOLock_staticisBADCopyPrivate  Lisp2D_PLOLock_staticisBADCopyPrivate
bool  PLOLock_staticisBADCopyPrivate ( ParaLispObject const * me , ParaLispObject  * *  resultp  ) ;

# include "plostream/type.h"

# define  PLOLock_staticCoutToHuman Lisp2D_PLOLock_staticCoutToHuman
void  PLOLock_staticCoutToHuman ( ParaLispObject const *  me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;
  
# define  PLOLock_staticCoutToInterpret Lisp2D_PLOLock_staticCoutToInterpret
void  PLOLock_staticCoutToInterpret ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector  ( StackPLOP )  *  h ) ;  

# define  PLOLock_staticTypeOf  Lisp2D_PLOLock_staticTypeOf
ParaLispObject  * PLOLock_staticTypeOf ( ParaLispObject const *  ) ;
  
# define  PLOLock_staticClassParents  Lisp2D_PLOLock_staticClassParents
ParaLispObject  * PLOLock_staticClassParents  ( ParaLispObject const *  ) ;

# define  PLOLock_staticClassDef  Lisp2D_PLOLock_staticClassDef
ParaLispObject  * PLOLock_staticClassDef  ( ParaLispObject const *  ) ;

# define  PLOLock_staticDestr Lisp2D_PLOLock_staticDestr
void  PLOLock_staticDestr  ( ParaLispObject * ) ;
  
# include "lock/type.h"

# define  PLOLock_Destr Lisp2D_PLOLock_Destr
void PLOLock_Destr ( PLOLock * ) ;

  // if mutexQueue is locked then return false,thread->trylock3
  // else check now and here
  // !! must be locked=true
  // returns error: not locked
# define  PLOLock_isBADUnLock Lisp2D_PLOLock_isBADUnLock
bool  PLOLock_isBADUnLock ( PLOLock * ) ;

  // returns true=can lock & transfer StCl to Taskqueue, false= cant
  // returns true=can lock , false= cant
  // if can lock -> not touch taskqueue, thread evaluate stcl yourself
# define  PLOLock_isOKTryLock3  Lisp2D_PLOLock_isOKTryLock3
bool  PLOLock_isOKTryLock3  ( PLOLock * , StackClusterPrivate * ) ;

# define  PLOLock_isOKTryLock Lisp2D_PLOLock_isOKTryLock
  // ! returns BAD if memory out
  // ! don't show exception
  // returns true=can lock , false= cant
bool  PLOLock_isOKTryLock ( PLOLock * ) ;

# define  PLOLock_Init  Lisp2D_PLOLock_Init
void PLOLock_Init ( PLOLock * ) ;

# define  PLOLock_malloc Lisp2D_PLOLock_malloc
PLOLock *  PLOLock_malloc ( void  ) ;

# define  IsNotLock Lisp2D_IsNotLock
bool  IsNotLock ( StackClusterPrivate  * , ParaLispObject  * ) ;

# define  Lockp Lisp2D_Lockp
bool  Lockp ( ParaLispObject  const * ) ;

# define  ParaLispObjectToPLOLock  Lisp2DParaLispObjectToPLOLock
inline  PLOLock * ParaLispObjectToPLOLock ( ParaLispObject * ) ;

inline  PLOLock * ParaLispObjectToPLOLock ( ParaLispObject * const p ) {
  return p  ->  vaddr . addr  . p ;
}

# endif // LISP2D_LOCK_PUBLIC_H
