// Lisp2D - Map
// ©2019-23 by Alex Glebe

# ifndef  LISP2D_MAP_H
# define  LISP2D_MAP_H

# include "stack-define.h"

# define  LISP2DMAPNODETYPE(  NA ) \
typedef struct  Lisp2DsMapNode  ##  NA  Lisp2DMapNode ##  NA ;

# define  LISP2DMAPNODE(  NA  , KE  , VA  ) \
struct  Lisp2DsMapNode  ##  NA  { \
  KE  key ; \
  VA  value ; \
} ;

# define  MapNode(  NA  ) Lisp2DMapNode ##  NA

# define  LISP2DMAPSTACKTYPE(  NA  ) \
LISP2DSTACKSTRUCTTYPE ( StackMapNode  ##  NA )

# define  LISP2DMAPSTACK(  NA  ) \
LISP2DSTACKSTRUCT ( StackMapNode  ##  NA , MapNode  ( NA  ) )

# define  LISP2DMAPTYPE(  NA ) \
typedef struct  Lisp2DsMap  ##  NA  Lisp2DMap ##  NA ;

# define  LISP2DMAP(  NA , KE ) \
struct  Lisp2DsMap  ##  NA  { \
  Vector ( StackMapNode ##  NA ) vector ; \
  int ( * func  ) ( KE  , KE  ) ; \
} ;

# define  Map(  NA  ) Lisp2DMap ##  NA

# define  LISP2DMAPPUB(  NA ) \
typedef struct  Lisp2DsMapPub  ##  NA  { \
  uint8_t _ ; \
} Lisp2DMapPub ##  NA ;

# define  MapPub(  NA  ) Lisp2DMapPub ##  NA

# define  LISP2DMAPPRI(  NA , KE ) \
typedef struct  Lisp2DsMapPri  ##  NA Lisp2DMapPri ##  NA ; \
struct  Lisp2DsMapPri  ##  NA  { \
  Vector ( StackMapNode ##  NA ) vector ; \
  int ( * func  ) ( KE  , KE  ) ; \
  MapPub  ( NA  ) pub ; \
} ;

# define  MapPri( NA  ) Lisp2DMapPri ##  NA

# define  LISP2DPRIFROMMAPPUBBODY(  NA ) \
MapPri  ( NA  ) * PriFromMapPub( NA ) ( MapPub ( NA ) * const p ) { \
  return ( MapPri ( NA ) * ) ( ( ( uint8_t * ) p ) - offsetof  ( MapPri ( NA ) , pub ) ) ; \
}

# define  LISP2DPRIFROMMAPPUBPROTO(  NA ) \
  MapPri  ( NA  ) * PriFromMapPub( NA ) ( MapPub ( NA ) * ) ;
  
# define  PriFromMapPub( NA ) Lisp2D_Pri_From_MapPub ## NA

# define  LISP2DCONSTPRIFROMMAPPUBBODY(  NA ) \
MapPri  ( NA  ) const * ConstPriFromMapPub ( NA ) ( MapPub ( NA ) const * const p ) {  \
  return ( MapPri ( NA ) const * ) ( ( ( uint8_t * ) p ) - \
    offsetof  ( MapPri ( NA ) , pub ) ) ; \
}

# define  LISP2DCONSTPRIFROMMAPPUBPROTO(  NA ) \
MapPri  ( NA  ) const * ConstPriFromMapPub ( NA ) ( MapPub ( NA ) const * ) ;
  
# define  ConstPriFromMapPub( NA ) Lisp2D_ConstPri_From_MapPub ## NA

# define  LISP2DDECLAREMAPSTACKINIT(  NA ) \
LISP2DDECLARESTACKCONSTRUCTORDEFAULT ( StackMapNode  ##  NA  )
  
# define  LISP2DMAPSTACKINITBODY(  NA ) \
LISP2DSTACKCONSTRUCTORDEFAULT ( StackMapNode  ##  NA  )

# define  LISP2DPROTOMAPSTACKINITCOPY(  NA ) \
LISP2DPROTOSTACKCONSTRUCTORCOPY ( StackMapNode ##  NA )

# define  LISP2DMAPSTACKINITCOPYBODY(  NA ) \
LISP2DSTACKCONSTRUCTORCOPY ( StackMapNode ##  NA , MapNode  ( NA  ) )

# define  LISP2D_PROTO_MAP_STACK_FREE(  NA ) \
LISP2D_PROTO_STACK_FREE ( StackMapNode  ##  NA )

# define  LISP2D_MAP_STACK_FREE_BODY(  NA ) \
LISP2D_STACK_FREE ( StackMapNode  ##  NA , MapNode ( NA  ) )

# define  LISP2DPROTOMAPSTACKDESTR(  NA ) \
LISP2DPROTOSTACKDESTRUCTOR ( StackMapNode  ##  NA )

# define  LISP2DMAPSTACKDESTRBODY(  NA ) \
LISP2DSTACKDESTRUCTOR ( StackMapNode  ##  NA , MapNode ( NA  ) )

# define  LISP2DMAPSTACKPUSHBYVALUEPROTO( NA ) \
LISP2DPROTOSTACKPUSHBYVALUE (  StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DMAPSTACKPUSHBYVALUEBODY( NA ) \
LISP2DSTACKPUSHBYVALUE  (  StackMapNode ##  NA  , MapNode ( NA  ) , )

# define  LISP2PROTODMAPSTACKPUSHFRONTVALUE( NA ) \
LISP2DPROTOSTACKPUSHFRONTVALUE (  StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DMAPSTACKPUSHFRONTVALUEBODY( NA ) \
LISP2DSTACKPUSHFRONTVALUE (  StackMapNode  ##  NA  , MapNode ( NA  ) , )

# define  LISP2DMAPSTACKPUSHFRONTVALUEPROTO( NA ) \
LISP2DPROTOSTACKPUSHFRONTVALUE  (  StackMapNode ##  NA  , MapNode ( NA  ) )

# define  LISP2DMAPSTACKATPROTO( NA  ) \
LISP2DPROTOSTACKAT ( StackMapNode ##  NA  , MapNode ( NA  ) )

# define  LISP2DMAPSTACKATBODY( NA  ) \
LISP2DSTACKAT ( StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DPROTOMAPSTACKPUSHATVALUEBODY( NA  ) \
LISP2DPROTOSTACKPUSHATVALUE ( StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DMAPSTACKPUSHATVALUEPROTO( NA  ) \
LISP2DPROTOSTACKPUSHATVALUE ( StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DMAPSTACKPUSHATVALUEBODY( NA  ) \
LISP2DSTACKPUSHATVALUE  ( StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DMAPSTACKCATPROTO( NA  ) \
LISP2DPROTOSTACKCAT ( StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DMAPSTACKCATBODY( NA  ) \
LISP2DSTACKCAT  ( StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DPROTOMAPSTACKATCOPY( NA  ) \
LISP2DPROTOSTACKATCOPY ( StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DMAPSTACKATCOPYBODY( NA  ) \
LISP2DSTACKATCOPY ( StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DPROTOMAPSTACKCLEAR(  NA  ) \
LISP2DPROTOSTACKCLEAR  ( StackMapNode  ##  NA  )

# define  LISP2DMAPSTACKCLEARBODY(  NA  ) \
LISP2DSTACKCLEAR  ( StackMapNode  ##  NA , MapNode ( NA  ) )

# define  LISP2DPROTOMAPSTACKSET(  NA  ) \
LISP2DPROTOSTACKSET  ( StackMapNode  ##  NA  , MapNode ( NA  ) )

# define  LISP2DMAPSTACKSETBODY(  NA  ) \
LISP2DSTACKSET  ( StackMapNode  ##  NA  , MapNode ( NA  ) , )

# define  LISP2DMAPCOMPTYPE(  NA , KE ) \
typedef int ( * Lisp2DMapCompFunc ##  NA  ) ( KE  , KE  ) ;

# define  LISP2DMAPINITDECLARE(  NA  ) \
void  Lisp2DMap ##  NA  ##  Init ( Map  ( NA  ) * , Lisp2DMapCompFunc ##  NA ) ;

# define  LISP2DMAPINITBODY(  NA  ) \
void  MapInit ( NA ) ( Map  ( NA  ) * const me , Lisp2DMapCompFunc ##  NA fu ) { \
  VectorInit  ( StackMapNode  ##  NA  ) ( & me -> vector , false ) ; \
  me -> func = fu ; \
}

# define  Lisp2DMapInit(  NA  ) Lisp2DMap ##  NA  ##  Init
# define  MapInit Lisp2DMapInit  

# define  LISP2DMAPPUBINITDECLARE(  NA  ) \
void  MapPubInit ( NA ) ( MapPub  ( NA  ) * , Lisp2DMapCompFunc ##  NA ) ;

# define  LISP2DMAPPUBINITBODY(  NA  ) \
void  MapPubInit ( NA ) ( MapPub  ( NA  ) * const me , Lisp2DMapCompFunc ##  NA fu ) { \
  MapPri  ( NA  ) * const mep = PriFromMapPub ( NA ) ( me ) ; \
  VectorInit  ( StackMapNode  ##  NA  ) ( & mep -> vector , false ) ; \
  mep -> func = fu ; \
}

# define  Lisp2DMapPubInit(  NA  ) Lisp2DMapPub ##  NA  ##  Init
# define  MapPubInit Lisp2DMapPubInit  

# define  LISP2DMAPINITCOPYDECLARE(  NA ) \
void  Lisp2DMap ##  NA  ##  InitCopy ( Map  ( NA  ) * , Map ( NA  ) const * ) ;

# define  LISP2DMAPINITCOPYBODY(  NA ) \
void  Lisp2DMap ##  NA  ##  InitCopy ( Map  ( NA  ) * const me , \
  Map ( NA  ) const * const fr ) { \
  VectorConstrCopy ( StackMapNode  ##  NA  ) ( & me -> vector  , & fr -> vector  ) ; \
  me -> func = fr -> func ; \
}

# define  Lisp2DMapInitCopy(  NA  ) Lisp2DMap ##  NA  ##  InitCopy
# define  MapInitCopy Lisp2DMapInitCopy
  
# define  LISP2DMAPDESTRDECLARE(  NA ) \
void  Lisp2DMap ##  NA  ##  Destr ( Map ( NA  ) * ) ;

# define  LISP2DMAPDESTRBODY(  NA ) \
void  Lisp2DMap ##  NA  ##  Destr ( Map ( NA  ) * const me ) { \
  Vector_Destr  ( StackMapNode  ##  NA  ) ( & me -> vector  ) ; \
}

# define  Lisp2DMapDestr( NA  ) Lisp2DMap  ##  NA  ##  Destr
# define  MapDestr  Lisp2DMapDestr

# define  LISP2DMAPPUBDESTRPROTO(  NA ) \
void  MapPubDestr ( NA ) ( MapPub ( NA  ) * ) ;

# define  LISP2DMAPPUBDESTRBODY(  NA ) \
void  MapPubDestr ( NA ) ( MapPub ( NA  ) * const mep ) { \
  MapPri  ( NA  ) * const me = PriFromMapPub ( NA ) ( mep ) ; \
  Vector_Destr  ( StackMapNode  ##  NA  ) ( & me -> vector  ) ; \
}

# define  Lisp2DMapPubDestr(  NA  ) Lisp2DMapPub  ##  NA  ##  Destr
# define  MapPubDestr  Lisp2DMapPubDestr

# define  LISP2DMAPCLEARDECLARE(  NA ) \
void  Lisp2DMap ##  NA  ##  Clear ( Map ( NA  ) * ) ;

# define  LISP2DMAPCLEARBODY(  NA ) \
void  Lisp2DMap ##  NA  ##  Clear ( Map ( NA  ) * const me ) { \
  VectorClear ( StackMapNode  ##  NA  ) ( & me -> vector  ) ; \
}

# define  Lisp2DMapClear( NA  ) Lisp2DMap  ##  NA  ##  Clear
# define  MapClear  Lisp2DMapClear

# define  LISP2DMAPPUBCLEARDECLARE(  NA ) \
void  MapPubClear ( NA ) ( MapPub ( NA  ) * ) ;

# define  LISP2DMAPPUBCLEARBODY(  NA ) \
void  MapPubClear ( NA ) ( MapPub ( NA  ) * const mep ) { \
  MapPri  ( NA  ) * const me = PriFromMapPub ( NA ) ( mep ) ; \
  VectorClear ( StackMapNode  ##  NA  ) ( & me -> vector  ) ; \
}

# define  Lisp2DMapPubClear(  NA  ) Lisp2DMapPub  ##  NA  ##  Clear
# define  MapPubClear  Lisp2DMapPubClear

# define  LISP2DMAPSETDECLARE(  NA ) \
void  Lisp2DMap ##  NA  ##  Set ( Map ( NA  ) * , Map ( NA  ) const * ) ;

# define  LISP2DMAPSETBODY(  NA ) \
void  Lisp2DMap ##  NA  ##  Set ( Map ( NA  ) * const me , \
  Map ( NA  ) const * const from ) { \
  VectorSet ( StackMapNode ## NA  ) ( & me -> vector  , & from -> vector  ) ; \
}

# define  Lisp2DMapSet( NA  ) Lisp2DMap ##  NA  ##  Set
# define  MapSet  Lisp2DMapSet

# define  LISP2DMAPSIZEDECLARE(  NA ) \
size_t  Lisp2DMap ##  NA  ##  Size ( Map  ( NA  ) const * ) ;

# define  LISP2DMAPSIZEBODY(  NA ) \
size_t  Lisp2DMap ##  NA  ##  Size ( Map  ( NA  ) const * const me ) { \
  return  VectorSizeCopy  ( StackMapNode  ##  NA  ) ( & me -> vector  ) ; \
}

# define  Lisp2DMapSize(  NA  ) Lisp2DMap ##  NA  ##  Size
# define  MapSize Lisp2DMapSize

# define  LISP2DMAPPUBSIZEDECL(  NA ) \
size_t  MapPubSize ( NA ) ( MapPub ( NA ) const * ) ;

# define  LISP2DMAPPUBSIZEBODY(  NA ) \
size_t  MapPubSize ( NA ) ( MapPub ( NA ) const * const mep ) { \
  MapPri  ( NA  ) const * const me = ConstPriFromMapPub ( NA ) ( mep ) ; \
  return  VectorSizeCopy ( StackMapNode ## NA ) ( & me -> vector  ) ; \
}

# define  Lisp2DMapPubSize( NA ) Lisp2DMapPub ## NA ## Size
# define  MapPubSize Lisp2DMapPubSize

# define  LISP2DMAPCATDECLARE(  NA ) \
MapNode ( NA  ) const * Lisp2DMap ##  NA  ##  CAt ( Map ( NA  ) const * , size_t ) ;

# define  LISP2DMAPCATBODY(  NA ) \
MapNode ( NA  ) const * Lisp2DMap ##  NA  ##  CAt ( \
  Map ( NA  ) const * const me , size_t const  i ) { \
  return  VectorCAt ( StackMapNode  ##  NA  ) ( & me -> vector  , i ) ; \
}

# define  Lisp2DMapCAt( NA  ) Lisp2DMap  ##  NA  ##  CAt
# define  MapCAt Lisp2DMapCAt

# define  LISP2DMAPPUBCATDECL(  NA ) \
MapNode ( NA  ) const * MapPubCAt ( NA ) ( MapPub  ( NA  ) const * , size_t ) ;

# define  LISP2DMAPPUBCATBODY(  NA ) \
MapNode ( NA  ) const * MapPubCAt ( NA ) ( MapPub  ( NA  ) const * const mep , size_t const i ) { \
  MapPri  ( NA  ) const * const me = ConstPriFromMapPub ( NA ) ( mep ) ; \
  return  VectorCAt ( StackMapNode  ##  NA  ) ( & me -> vector  , i ) ; \
}

# define  Lisp2DMapPubCAt(  NA  ) Lisp2DMapPub  ##  NA  ##  CAt
# define  MapPubCAt Lisp2DMapPubCAt

# define  LISP2DMAPATDECLARE(  NA ) \
MapNode ( NA  ) * Lisp2DMap ##  NA  ##  At ( Map  ( NA  ) * , size_t ) ;

# define  LISP2DMAPATBODY(  NA ) \
MapNode ( NA  ) * Lisp2DMap ##  NA  ##  At ( Map  ( NA  ) * const me , \
  size_t const  i ) { \
  return  VectorAt  ( StackMapNode ##  NA ) ( & me -> vector  , i ) ; \
}

# define  Lisp2DMapAt(  NA  ) Lisp2DMap ##  NA  ##  At
# define  MapAt Lisp2DMapAt

# define  LISP2DMAPATCOPYDECLARE(  NA ) \
MapNode ( NA  ) Lisp2DMap ##  NA  ##  AtCopy ( Map  ( NA  ) const * , size_t ) ;

# define  LISP2DMAPATCOPYBODY(  NA ) \
MapNode ( NA  ) Lisp2DMap ##  NA  ##  AtCopy ( Map  ( NA  ) const * const me , size_t const  i ) { \
  return  VectorAtCopy  ( StackMapNode ##  NA ) ( & me -> vector  , i ) ; \
}

# define  Lisp2DMapAtCopy ( NA  ) Lisp2DMap ##  NA  ##  AtCopy
# define  MapAtCopy Lisp2DMapAtCopy

# define  Lisp2DMapInsert(  NA  ) Lisp2DMap ##  NA  ##  Insert
# define  MapInsert Lisp2DMapInsert

# define  LISP2DMAPINSERTPROTO(  NA  ) \
void  MapInsert ( NA  ) ( Map ( NA  ) * , MapNode ( NA  ) ) ;

// Insert new pair OR change existing value of pair
# define  LISP2DMAPINSERTBODY(  NA  ) \
void  MapInsert ( NA  ) ( Map ( NA  ) * const me , MapNode  ( NA  ) const no ) { \
  Vector  ( StackMapNode  ##  NA  )  * const stackp = & me -> vector  ; \
  Lisp2DMapCompFunc ##  NA const fu = me -> func ;  \
  size_t const si = VectorSizeCopy  ( StackMapNode  ##  NA  ) ( stackp )  ; \
  switch  ( si ) { \
  case  0 : \
    Vector_PushByValue ( StackMapNode  ##  NA  ) ( stackp , no ) ; \
    break ; \
  case  1 : \
    { MapNode ( NA  ) * const frno = VectorFront  ( StackMapNode  ##  NA  ) ( stackp ) ; \
      { int const lo = fu ( no.key , frno -> key ) ; \
        if ( lo == 0 )  \
          frno -> value = no.value ; \
        else { \
          if ( lo < 0 ) \
            Lisp2DStackMapNode  ##  NA  ##  PushFrontValue ( stackp , no ) ;  \
          else  \
            Vector_PushByValue ( StackMapNode  ##  NA  )  ( stackp  , no ) ; \
        } \
      } \
    } \
    break ; \
  default : { \
    size_t  be = 0 ; \
    size_t  en = si ; \
    size_t  j ; \
    do { \
      j = ( be + en ) >> 1 ; \
      { MapNode ( NA  ) * const meno = VectorAt ( StackMapNode  ##  NA ) ( stackp ,  j ) ; \
        int const lo = fu ( no  . key , meno -> key ) ; \
        if ( lo == 0 ) {  \
          meno -> value = no  . value ;  \
          return ; \
        } \
        if  ( lo < 0  ) \
          en = j ;  \
        else  \
          be = j + 1 ; \
      } \
    } while  ( en >= be + 2 ) ; \
      if ( en == ( be + 1 ) ) { \
        MapNode ( NA  ) * const beno = VectorAt ( StackMapNode  ##  NA ) ( stackp ,  be ) ; \
        int const lo = fu ( no  . key , beno -> key ) ; \
        if ( lo == 0 ) {  \
          beno -> value = no  . value ;  \
          return ; \
        } \
        if ( lo < 0 ) \
          VectorPushAtValue ( StackMapNode  ##  NA  ) ( stackp , be , no  ) ; \
        else \
          VectorPushAtValue ( StackMapNode  ##  NA  )  ( stackp  , be + 1 , no  ) ; \
        return ; \
      } \
      VectorPushAtValue ( StackMapNode  ##  NA  ) ( stackp , be , no  ) ; \
    } \
  } \
}

# define  Lisp2DMapPubInsert(  NA  ) Lisp2DMapPub ##  NA  ##  Insert
# define  MapPubInsert Lisp2DMapPubInsert

# define  LISP2DMAPPUBINSERTPROTO(  NA  ) \
void  MapPubInsert ( NA  ) ( MapPub ( NA  ) * , MapNode ( NA  ) ) ;

// Insert new pair OR change existing value of pair
# define  LISP2DMAPPUBINSERTBODY(  NA  ) \
void  MapPubInsert ( NA  ) ( MapPub ( NA  ) * const mep , MapNode  ( NA  ) const no ) { \
  MapPri  ( NA  ) * const me = PriFromMapPub ( NA ) ( mep ) ; \
  Vector  ( StackMapNode  ##  NA  )  * const stackp = & me -> vector  ; \
  Lisp2DMapCompFunc ##  NA const fu = me -> func ;  \
  size_t const si = VectorSizeCopy  ( StackMapNode  ##  NA  ) ( stackp )  ; \
  switch  ( si ) { \
  case  0 : \
    Vector_PushByValue ( StackMapNode  ##  NA  ) ( stackp , no ) ; \
    break ; \
  case  1 : \
    { MapNode ( NA  ) * const frno = VectorFront  ( StackMapNode  ##  NA  ) ( stackp ) ; \
      { int const lo = fu ( no  . key , frno -> key ) ; \
        if ( lo == 0 )  \
          frno -> value = no  . value ; \
        else { \
          if ( lo < 0 ) \
            Lisp2DStackMapNode  ##  NA  ##  PushFrontValue ( stackp , no ) ;  \
          else  \
            Vector_PushByValue ( StackMapNode  ##  NA  ) ( stackp  , no ) ; \
        } \
      } \
    } \
    break ; \
  default : { \
    size_t  be = 0 ; \
    size_t  en = si ; \
    size_t  j ; \
    do { \
      j = ( be + en ) >> 1 ; \
      { MapNode ( NA  ) * const meno = VectorAt ( StackMapNode  ##  NA ) ( stackp ,  j ) ; \
        int const lo = fu ( no  . key , meno -> key ) ; \
        if ( lo == 0 ) {  \
          meno -> value = no  . value ;  \
          return ; \
        } \
        if  ( lo < 0  ) \
          en = j ;  \
        else  \
          be = j + 1 ; \
      } \
    } while  ( en >= be + 2 ) ; \
      if ( en == ( be + 1 ) ) { \
        MapNode ( NA  ) * const beno = VectorAt ( StackMapNode  ##  NA ) ( stackp ,  be ) ; \
        int const lo = fu ( no  . key , beno -> key ) ; \
        if ( lo == 0 ) {  \
          beno -> value = no  . value ;  \
          return ; \
        } \
        if ( lo < 0 ) \
          VectorPushAtValue ( StackMapNode  ##  NA  ) ( stackp , be , no  ) ; \
        else \
          VectorPushAtValue ( StackMapNode  ##  NA  )  ( stackp  , be + 1 , no  ) ; \
        return ; \
      } \
      VectorPushAtValue ( StackMapNode  ##  NA  ) ( stackp , be , no  ) ; \
    } \
  } \
}    
    
# define  LISP2DMAPFINDPROTO(  NA , KE ) \
size_t  Lisp2DMap ##  NA  ##  Find ( Map  ( NA  ) const * , KE ) ;    
    
// returns index for key, or MapSize when not found
# define  LISP2DMAPFINDBODY(  NA , KE ) \
size_t  Lisp2DMap ## NA ## Find ( Map ( NA  ) const * const me , \
  KE const key ) { \
  Vector  ( StackMapNode ## NA  ) const * const stackp = & me -> vector  ; \
  Lisp2DMapCompFunc ## NA const fu = me -> func ;  \
  size_t const si = VectorSizeCopy  ( StackMapNode ## NA  )  ( stackp )  ; \
  switch  ( si ) { \
  case  0 : \
    return 0 ; \
  case  1 : \
    { MapNode ( NA  ) const * const frno = VectorCFront ( StackMapNode ## NA  ) ( stackp ) ; \
      { int const lo = fu ( key , frno -> key ) ; \
        if ( lo == 0 )  \
          return 0 ; \
        return  1 ; \
      } \
    } \
    break ; \
  default : \
    { size_t  be = 0 ; \
      size_t  en = si ; \
      size_t  j ; \
      do { \
        j = ( be + en ) >> 1 ; \
        { MapNode ( NA  ) const * const meno = VectorCAt ( StackMapNode  ##  NA ) ( stackp ,  j ) ; \
          int const lo = fu ( key , meno -> key ) ; \
          if ( lo == 0 )  \
            return j ; \
          if  ( lo < 0  ) \
            en = j ;  \
          else  \
            be = j + 1 ; \
        } \
      } while  ( en >= be + 2 ) ; \
      if ( en == ( be + 1 ) ) { \
        MapNode ( NA  ) const * const beno = VectorCAt ( StackMapNode  ##  NA ) ( stackp ,  be ) ; \
        int const lo = fu ( key , beno -> key ) ; \
        if ( lo == 0 )  \
          return be ; \
      } \
      return  si  ; \
    } \
  } \
}     

# define  Lisp2DMapFind(  NA  ) Lisp2DMap ## NA ## Find
# define  MapFind Lisp2DMapFind
    
# define  LISP2DMAPPUBFINDPROTO(  NA , KE ) \
size_t  Lisp2DMapPub ## NA ## Find ( MapPub ( NA ) const * , KE ) ;    
    
// returns index for key, or MapSize when not found
# define  LISP2DMAPPUBFINDBODY(  NA , KE ) \
size_t  Lisp2DMapPub ## NA ## Find ( MapPub ( NA ) const * const mep , KE const key ) { \
  MapPri  ( NA  ) const * const me = ConstPriFromMapPub ( NA ) ( mep ) ; \
  Vector  ( StackMapNode  ##  NA  ) const * const stackp = & me -> vector  ; \
  Lisp2DMapCompFunc ##  NA const fu = me -> func ;  \
  size_t const si = VectorSizeCopy  ( StackMapNode  ##  NA  ) ( stackp )  ; \
  switch  ( si ) { \
  case  0 : \
    return 0 ; \
  case  1 : \
    { MapNode ( NA  ) const * const frno =  \
        VectorCFront  ( StackMapNode  ##  NA  ) ( stackp ) ; \
      { int const lo = fu ( key , frno -> key ) ; \
        if ( lo == 0 )  \
          return 0 ; \
        return  1 ; \
      } \
    } \
    break ; \
  default : \
    { size_t  be = 0 ; \
      size_t  en = si ; \
      size_t  j ; \
      do { \
        j = ( be + en ) >> 1 ; \
        { MapNode ( NA  ) const * const meno = VectorCAt ( StackMapNode  ##  NA ) ( stackp ,  j ) ; \
          int const lo = fu ( key , meno -> key ) ; \
          if ( lo == 0 )  \
            return j ; \
          if  ( lo < 0  ) \
            en = j ;  \
          else  \
            be = j + 1 ; \
        } \
      } while  ( en >= be + 2 ) ; \
      if ( en == ( be + 1 ) ) { \
        MapNode ( NA  ) const * const beno = VectorCAt ( StackMapNode  ##  NA ) ( stackp ,  be ) ; \
        int const lo = fu ( key , beno -> key ) ; \
        if ( lo == 0 )  \
          return be ; \
      } \
      return  si  ; \
    } \
  } \
}     

# define  Lisp2DMapPubFind( NA  ) Lisp2DMapPub  ##  NA  ##  Find
# define  MapPubFind Lisp2DMapPubFind
    
# endif // LISP2D_MAP_H
