// Lisp2D - int Lisp2DMinInt(int,int) , ...
// ©2017-23 by Alex Glebe

# ifndef  LISP2D_MINMAXINT_H
# define  LISP2D_MINMAXINT_H
# include <stddef.h> // size_t

# ifdef LISP2D_BODY_MINMAX
# error LISP2D_BODY_MINMAX defined
# endif

# define LISP2D_BODY_MINMAX(  MINMAXNAME  , MINMAXTYPE  , MINMAXOPERATOR  )  \
MINMAXTYPE  Lisp2D  ##  MINMAXNAME  ( MINMAXTYPE const x , MINMAXTYPE const y ) { \
  return  ( x MINMAXOPERATOR y ) ?  \
    x : \
    y ; \
}

# ifdef LISP2D_BODY_MINMAXP
# error LISP2D_BODY_MINMAXP defined
# endif

# define LISP2D_BODY_MINMAXP(  MINMAXNAME  , MINMAXTYPE , MINMAXOPERATOR )  \
MINMAXTYPE  *  Lisp2D ##  MINMAXNAME  ( MINMAXTYPE * const x , MINMAXTYPE * const y ) { \
  return  ( ( * x ) MINMAXOPERATOR (  * y ) ) ? \
    x : \
    y ; \
}

# ifdef LISP2D_BODY_MINMAXCP
# error LISP2D_BODY_MINMAXCP defined
# endif

# define LISP2D_BODY_MINMAXCP(  MINMAXNAME  , MINMAXTYPE , MINMAXOPERATOR )  \
MINMAXTYPE  const *  Lisp2D ##  MINMAXNAME  ( MINMAXTYPE const * const x , MINMAXTYPE const * const y ) { \
  return  ( ( * x ) MINMAXOPERATOR (  * y ) ) ? \
    x : \
    y ; \
}
  
inline  LISP2D_BODY_MINMAX  ( MinInt  , int , < )
inline  LISP2D_BODY_MINMAX  ( MaxInt  , int , > )
inline  LISP2D_BODY_MINMAX  ( MinUInt , unsigned int  , < )
inline  LISP2D_BODY_MINMAX  ( MaxUInt , unsigned int  , > )
inline  LISP2D_BODY_MINMAX  ( MinSize , size_t  , < )
inline  LISP2D_BODY_MINMAX  ( MaxSize , size_t  , > )
inline  LISP2D_BODY_MINMAX  ( MinPtrDiff  , ptrdiff_t , < )
inline  LISP2D_BODY_MINMAX  ( MaxPtrDiff  , ptrdiff_t , > )
inline  LISP2D_BODY_MINMAX  ( MinLDouble  , long double , < )
inline  LISP2D_BODY_MINMAX  ( MaxLDouble  , long double , > )
inline  LISP2D_BODY_MINMAXP ( MinLDoubleP  , long double , < )
inline  LISP2D_BODY_MINMAXP ( MaxLDoubleP  , long double , > )
inline  LISP2D_BODY_MINMAXCP ( MinLDoubleCP  , long double , < )
inline  LISP2D_BODY_MINMAXCP ( MaxLDoubleCP  , long double , > )
# undef  LISP2D_BODY_MINMAX
# undef  LISP2D_BODY_MINMAXP
# undef  LISP2D_BODY_MINMAXCP
# endif // LISP2D_MINMAXINT_H
