// Lisp2D - Mutex auto init/destroy with statistics
// ©2012-23 by Alex Glebe

# ifndef  LISP2D_MUTEX_H
# define  LISP2D_MUTEX_H

# include "define.h"
# include "mutexp.h"
void  Lisp2DMutexConstructor ( Lisp2DMutex * ) ;
void  Lisp2DMutexDestructor  ( Lisp2DMutex * ) ;
void  Lisp2DMutexLock ( Lisp2DMutex  * ) ;
void  Lisp2DMutexUnLock ( Lisp2DMutex  * ) ;
# ifdef  LISP2D_BIMSTAT
inline  size_t  Lisp2DMutexStatFast  ( Lisp2DMutex const * const me ) {
  return  me -> statfast  ;
}

inline  size_t  Lisp2DMutexStatWait  ( Lisp2DMutex const * const me ) {
  return  me -> statwait  ;
}

inline  void  Lisp2DMutexClearStat ( Lisp2DMutex * const me ) {
  me  -> statfast  = 0 ;
  me  -> statwait = 0 ;
}

# endif // LISP2D_BIMSTAT
pthread_mutex_t * Lisp2DMutexAddr ( Lisp2DMutex  * ) ;

# endif // LISP2D_MUTEX_H
