// Lisp2D - Mutex auto init/destroy with statistics public
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_MUTEX2_PUBLIC_H
# define  LISP2D_MUTEX2_PUBLIC_H

# include "mutex2/type.h"
# include <pthread.h>

# define  Mutex2Constructor Lisp2D_Mutex2Constructor
void  Mutex2Constructor  ( Mutex2 * , pthread_mutexattr_t const * ) ;
# define  Mutex2Destructor  Lisp2D_Mutex2Destructor
void  Mutex2Destructor  ( Mutex2 * ) ;
# define  Mutex2Lock  Lisp2D_Mutex2Lock
void  Mutex2Lock  ( Mutex2  * ) ;
# define  Mutex2Unlock  Lisp2D_Mutex2Unlock
void  Mutex2Unlock  ( Mutex2  * ) ;

# include <stdbool.h>

# define  Mutex2IsBadTryLock  Lisp2D_Mutex2IsBadTryLock
bool  Mutex2IsBadTryLock  ( Mutex2 * ) ;
# define  Mutex2Addr  Lisp2D_Mutex2Addr
pthread_mutex_t * Mutex2Addr ( Mutex2 * ) ;

# include "define.h"
# include "mutex2/struct.h"

# ifdef  LISP2D_BIMSTAT

# define  Mutex2StatFast  Lisp2D_Mutex2StatFast
inline  size_t  Mutex2StatFast  ( Mutex2 const * const mep ) {
  return  mep -> statfast  ;
}

# define  Mutex2StatWait  Lisp2D_Mutex2StatWait
size_t  Mutex2StatWait  ( Mutex2 const * ) ;

# endif // LISP2D_BIMSTAT

# define  LISP2D_MUTEX2( varname ) \
  Mutex2 varname = { . s = Lisp2DObjectStateRaw } ;

// many work 
# define  Mutex2SetStateRaw Lisp2D_Mutex2SetStateRaw
void  Mutex2SetStateRaw  ( Mutex2 * ) ;

# endif // LISP2D_MUTEX2_PUBLIC_H
