// Lisp2D - Mutex auto init/destroy with statistics
// ©2012-23 by Alex Glebe

# ifndef  LISP2D_MUTEXP_H
# define  LISP2D_MUTEXP_H

# include "struct-state.h"
# include <pthread.h> // pthread_mutex_t
# include "define.h"

typedef  struct sLisp2DMutex Lisp2DMutex ;

// Lock -> try{++fast}else lock{++wait} -> transparent = fast/(fast+wait)%
struct sLisp2DMutex  {
  pthread_mutex_t  m ;
# ifdef  LISP2D_BIMSTAT
  size_t  statfast  ;
  size_t  statwait  ;
# endif
# ifdef  LISP2D_DEBUG
  Lisp2DStructState state ;
# endif
} ;

# endif // LISP2D_MUTEXP_H
