// Lisp2D - NIL type
// ©2006-23 by Alex Glebe

# ifndef  LISP2D_NILC_H
# define  LISP2D_NILC_H

# include "define.h"
# include "plo/struct.h"

// ! to nil/type.h

# define  PLONil  Lisp2DPLONil
typedef struct sLisp2DPLONil  PLONil  ;

// ! to nil/struct.h

struct sLisp2DPLONil {
  ParaLispObject  plo ;
} ;

// ! to nil/public.h

# define  plonil  Lisp2Dplonil
extern  PLONil  plonil  ;   

# include <stdatomic.h>
# ifdef  LISP2D_CONSTRSTAT
  # define  PLONilconstrstat  Lisp2DPLONilconstrstat
  extern  _Atomic  ( size_t  ) PLONilconstrstat  ;
# define  AddPLONilconstrstat Lisp2DAddPLONilconstrstat
void  AddPLONilconstrstat ( void  ) ;    
# define  PLONilconstrstatValue Lisp2DPLONilconstrstatValue
size_t  PLONilconstrstatValue ( void  ) ;

# endif

# ifdef  LISP2D_CONSTRSTAT
  # define  ADDPLONilconstrstat ++  PLONilconstrstat  ;
# else
  # define  ADDPLONilconstrstat
# endif

# include "plo/public.h"

// ! to nil/public.h

# define  PLONilDestr Lisp2DPLONilDestr
void PLONilDestr  ( ParaLispObject * ) ;
  
# define  PLONilDestrStatic Lisp2DPLONilDestrStatic
void PLONilDestrStatic  ( PLONil * ) ;

# define  PLONilClassDef  Lisp2DPLONilClassDef
ParaLispObject  * PLONilClassDef  ( ParaLispObject const * ) ;

# define  ploclassdefnil  Lisp2Dploclassdefnil
extern  ParaLispObject  *   ploclassdefnil  ;

# define  PLONilClassParents  Lisp2DPLONilClassParents
ParaLispObject  * PLONilClassParents  ( ParaLispObject const * ) ;  

# define  PLONilTypeOf  Lisp2DPLONilTypeOf
ParaLispObject  * PLONilTypeOf ( ParaLispObject const * ) ;  

# define  ploclassdefbif  Lisp2D_ploclassdefbif

# define  PLONilCoutToInterpret Lisp2DPLONilCoutToInterpret
void  PLONilCoutToInterpret ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector  (StackPLOP)  *  h ) ;

# define  PLONilCoutToHuman Lisp2DPLONilCoutToHuman
void  PLONilCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector (StackPLOP)  * h ) ;

# include "taskforthread.h"
  
// `(a + b) backquote(..,(a+b))
// !! this is NOT method, but function for eval()
# define  bimnilbackquote23 Lisp2Dbimnilbackquote23
TaskForThread bimnilbackquote23 ( StackClusterPrivate * , ParaLispObject  *  varA2  ) ;

# define  bimnilequal Lisp2Dbimnilequal
FuncBining  bimnilequal ;  
# define  bimnileq  Lisp2Dbimnileq
FuncBining  bimnileq  ;
# define  bimniltypeof  Lisp2Dbimniltypeof
FuncBining  bimniltypeof  ;
# define  bimnilgeteuid Lisp2Dbimnilgeteuid
FuncBining  bimnilgeteuid ;
# define  bimnilgetegid Lisp2Dbimnilgetegid
FuncBining  bimnilgetegid ;
# define  bimnilgetuid  Lisp2Dbimnilgetuid
FuncBining  bimnilgetuid ;
# define  bimnilgetgid  Lisp2Dbimnilgetgid
FuncBining  bimnilgetgid ;
# define  bimnilsysname Lisp2Dbimnilsysname
FuncBining  bimnilsysname ;
# define  bimnilrelease Lisp2Dbimnilrelease
FuncBining  bimnilrelease ;
# define  bimnilversion Lisp2Dbimnilversion
FuncBining  bimnilversion ;
# define  bimnilmachine Lisp2Dbimnilmachine
FuncBining  bimnilmachine ;
# define  bimnilnodename  Lisp2Dbimnilnodename
FuncBining  bimnilnodename ;
# define  bimniluptime  Lisp2Dbimniluptime
FuncBining  bimniluptime ;
# define  bimniltotalram  Lisp2Dbimniltotalram
FuncBining  bimniltotalram ;
# define  bimnilfreeram Lisp2Dbimnilfreeram
FuncBining  bimnilfreeram ;
# define  bimnilgetcwd  Lisp2Dbimnilgetcwd
FuncBining  bimnilgetcwd ;
# define  bimnilboundp  Lisp2Dbimnilboundp
FuncBining  bimnilboundp ;
# define  bimnildefmethod Lisp2Dbimnildefmethod
FuncBining  bimnildefmethod ;
# define  bimnilgetmethod Lisp2Dbimnilgetmethod
FuncBining  bimnilgetmethod ;
# define  bimnilget Lisp2Dbimnilget
FuncBining  bimnilget ;
# define  bimnilput Lisp2Dbimnilput
FuncBining  bimnilput ;
# define  bimnildefmacro  Lisp2Dbimnildefmacro
FuncBining  bimnildefmacro ;  
# define  bimnilremprop Lisp2Dbimnilremprop
FuncBining  bimnilremprop ;
# define  bimnilcopy  Lisp2Dbimnilcopy
FuncBining  bimnilcopy ;
# define  bimnilnprocs  Lisp2Dbimnilnprocs
FuncBining  bimnilnprocs ;
# define  bimnilnotequal  Lisp2Dbimnilnotequal
FuncBining  bimnilnotequal ;
# define  bimnilgetclass  Lisp2Dbimnilgetclass
FuncBining  bimnilgetclass ;
# define  bimnildowhile Lisp2Dbimnildowhile
FuncBining  bimnildowhile ;
# define  bimnilprogn Lisp2Dbimnilprogn
FuncBining  bimnilprogn ;
# define  bimnilcond  Lisp2Dbimnilcond
FuncBining  bimnilcond ;
# define  bimnilapply Lisp2Dbimnilapply
FuncBining  bimnilapply ;
# define  bimnilif  Lisp2Dbimnilif
FuncBining  bimnilif ;
# define  bimnilparallel  Lisp2Dbimnilparallel
FuncBining  bimnilparallel ;
# define  bimnilwhile Lisp2Dbimnilwhile
FuncBining  bimnilwhile ;
# define  bimnileval  Lisp2Dbimnileval
FuncBining  bimnileval ;
# define  bimnilsetq  Lisp2Dbimnilsetq
FuncBining  bimnilsetq ;
# define  bimnilfork  Lisp2Dbimnilfork
FuncBining  bimnilfork ;
# define  bimnillet Lisp2Dbimnillet
FuncBining  bimnillet ;
# define  bimnilfuncall Lisp2Dbimnilfuncall
FuncBining  bimnilfuncall ;
# define  bimnilwhen  Lisp2Dbimnilwhen
FuncBining  bimnilwhen ;
# define  bimnilgetlogin  Lisp2Dbimnilgetlogin
FuncBining  bimnilgetlogin ;
# define  bimnilsetdebug  Lisp2Dbimnilsetdebug
FuncBining  bimnilsetdebug ;
# define  bimnilgetdebug  Lisp2Dbimnilgetdebug
FuncBining  bimnilgetdebug ;
# define  bimnilmap Lisp2Dbimnilmap
FuncBining  bimnilmap ;
# define  bimnilgetpid  Lisp2Dbimnilgetpid
FuncBining  bimnilgetpid ;
# define  bimnilgetppid Lisp2Dbimnilgetppid
FuncBining  bimnilgetppid ;
# define  bimniltry Lisp2Dbimniltry
FuncBining  bimniltry ;
# define  bimnilthrow Lisp2Dbimnilthrow
FuncBining  bimnilthrow ;
# define  bimnilexception Lisp2Dbimnilexception
FuncBining  bimnilexception ;
# define  bimnilexceptionhistory  Lisp2Dbimnilexceptionhistory
FuncBining  bimnilexceptionhistory  ;
# ifdef LISP2D_DEBUG
# define  bimnilcrash Lisp2Dbimnilcrash
  FuncBining  bimnilcrash  ;
# endif  
# define  bimnilconstp  Lisp2Dbimnilconstp
FuncBining  bimnilconstp  ;
# define  bimnilconst Lisp2Dbimnilconst
FuncBining  bimnilconst   ;
# define  bimnilunconst Lisp2Dbimnilunconst
FuncBining  bimnilunconst   ;
# define  bimnilsubseq  Lisp2Dbimnilsubseq
FuncBining  bimnilsubseq  ;
# define  bimnilwithout Lisp2Dbimnilwithout
FuncBining  bimnilwithout   ;
# define  bimniladdressof Lisp2Dbimniladdressof
FuncBining  bimniladdressof   ;
# define  bimnilprivate Lisp2Dbimnilprivate
FuncBining  bimnilprivate   ;
# define  bimnillog Lisp2Dbimnillog
FuncBining  bimnillog   ;
# define  bimnilloglist Lisp2Dbimnilloglist
FuncBining  bimnilloglist   ;
# define  bimnilenvironlist Lisp2Dbimnilenvironlist
FuncBining  bimnilenvironlist ;

# endif // LISP2D_NILC_H
