// Lisp2D - Object State
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_OBJECTSTATE_H
# define  LISP2D_OBJECTSTATE_H
# include "endianc.h"

# ifdef LISP2D_INT_SIZE_4
enum  eLisp2DObjectState  { Lisp2DObjectStateRaw = 0x55555555 ,
  Lisp2DObjectStateConstructed = 0x66666666 ,
  Lisp2DObjectStateDestructed = (int)0xaaaaaaaa
} ;
# else
# ifdef LISP2D_INT_SIZE_8
  enum  eLisp2DObjectState  { Lisp2DObjectStateRaw = 0x5555555555555555 ,
    Lisp2DObjectStateConstructed = 0x6666666666666666 ,
    Lisp2DObjectStateDestructed = (int)0xaaaaaaaaaaaaaaaa
  } ;
# else
# ifdef LISP2D_INT_SIZE_2
  enum  eLisp2DObjectState  { Lisp2DObjectStateRaw = 0x5555 ,
    Lisp2DObjectStateConstructed = 0x6666 ,
    Lisp2DObjectStateDestructed = (int)0xaaaa
  } ;
# else
# error sizeof(int) not_eq 2 nor 4 nor 8
# endif  
# endif  
# endif  
  
typedef enum  eLisp2DObjectState  Lisp2DObjectState ;

# endif // LISP2D_OBJECTSTATE_H
