// Parallel Lisp Object
// Lisp2D 2022-3
# ifndef  LISP2D_PLO_PUBLIC_H
# define  LISP2D_PLO_PUBLIC_H

# include "plo/type.h"

# define  ParaLispObject_staticDestr  Lisp2D_ParaLispObject_staticDestr
void  ParaLispObject_staticDestr  ( ParaLispObject * )  ;

# define  ParaLispObject_virtualDestr Lisp2D_ParaLispObject_virtualDestr
void ParaLispObject_virtualDestr ( ParaLispObject * ) ;

extern  void ( * ParaLispObjectvirttableDestr [ TypeGlobalListMemberSIZE ] ) (  ParaLispObject * ) ;

# define  ParaLispObject_InitCVTP Lisp2D_ParaLispObject_InitCVTP
void  ParaLispObject_InitCVTP ( ParaLispObject * , bool flagconst , VirtualTypePointer ) ;

# define  ParaLispObject_InitVTP  Lisp2D_ParaLispObject_InitVTP
void  ParaLispObject_InitVTP ( ParaLispObject * me , VirtualTypePointer fb ) ;

// Lock's not used
// dont use it, this task is for GC

# define  ParaLispObject_virtualGCDeclareContent \
  Lisp2D_ParaLispObject_virtualGCDeclareContent
void  ParaLispObject_virtualGCDeclareContent ( ParaLispObject *  ) ;

extern  void ( * ParaLispObjectvirttableGCDeclareContent
  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject * ) ;

# define  ParaLispObject_GCDeclareContent \
  Lisp2D_ParaLispObject_GCDeclareContent
void  ParaLispObject_GCDeclareContent ( ParaLispObject *  ) ;

# define  ParaLispObject_virtualTypeOf  Lisp2D_ParaLispObject_virtualTypeOf
ParaLispObject  * ParaLispObject_virtualTypeOf ( ParaLispObject const * ) ;

extern  ParaLispObject  * ( * ParaLispObjectvirttableTypeOf
  [ TypeGlobalListMemberSIZE ] ) (  ParaLispObject const * ) ;

# define  ParaLispObject_virtualContext Lisp2D_ParaLispObject_virtualContext
ParaLispObject  * ParaLispObject_virtualContext  ( ParaLispObject const * ) ;

extern  ParaLispObject  * ( * ParaLispObjectvirttableContext
  [ TypeGlobalListMemberSIZE ] ) (  ParaLispObject const * ) ;

# define  ParaLispObject_virtualClassDef  Lisp2D_ParaLispObject_virtualClassDef
ParaLispObject  * ParaLispObject_virtualClassDef  ( ParaLispObject const * ) ;

extern  ParaLispObject  * ( * ParaLispObjectvirttableClassDef
  [ TypeGlobalListMemberSIZE ] ) (  ParaLispObject const * ) ;

# define  ParaLispObject_virtualClassParents \
  Lisp2D_ParaLispObject_virtualClassParents
ParaLispObject  * ParaLispObject_virtualClassParents
  ( ParaLispObject const * ) ;

extern  ParaLispObject  * ( * ParaLispObjectvirttableClassParents
  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject const * ) ;

// Lock's not used
  // for only little bits of types
  // virtual declares place, where this type is kept
# define  ParaLispObject_virtualDeclareForGC \
  Lisp2D_ParaLispObject_virtualDeclareForGC
void  ParaLispObject_virtualDeclareForGC ( ParaLispObject * ) ;

extern  void ( * ParaLispObjectvirttableDeclareForGC
  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject * ) ;

// returns: this OR exception
# define  ParaLispObject_virtualPushAsNew Lisp2D_ParaLispObject_virtualPushAsNew
ParaLispObject  * ParaLispObject_virtualPushAsNew  ( ParaLispObject * )  ;

# define  ParaLispObject_virttablePushAsNew \
  Lisp2D_ParaLispObject_virttablePushAsNew
extern  ParaLispObject * ( * ParaLispObject_virttablePushAsNew
  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject  * ) ;

// func makes unconst, return true
bool ParaLispObject_isOKSetFlagConstFalse ( ParaLispObject * ) ;

// func dont unconst , returns false
bool ParaLispObject_isBADSetFlagConstFalse ( ParaLispObject * ) ;

# define  ParaLispObject_isBADCopyPrivate Lisp2D_ParaLispObject_isBADCopyPrivate
bool ParaLispObject_isBADCopyPrivate ( ParaLispObject const * me ,
    ParaLispObject  * * resultp ) ;

# define  ParaLispObject_virttableisBADCopyPrivate \
  Lisp2D_ParaLispObject_virttableisBADCopyPrivate
extern  bool ( * ParaLispObject_virttableisBADCopyPrivate
  [ TypeGlobalListMemberSIZE ] ) ( ParaLispObject const * ,
  ParaLispObject  * * ) ;

# define  ParaLispObject_virttableisOKSetFlagConstFalse \
  Lisp2D_ParaLispObject_virttableisOKSetFlagConstFalse
extern  bool ( * ParaLispObject_virttableisOKSetFlagConstFalse  [
  TypeGlobalListMemberSIZE ] ) ( ParaLispObject * ) ;

# include "plostream/type.h"

# define  ParaLispObject_virttableCoutToInterpret \
  Lisp2D_ParaLispObject_virttableCoutToInterpret
extern  void ( * ParaLispObject_virttableCoutToInterpret
  [ TypeGlobalListMemberSIZE ] ) (
    ParaLispObject const * , PLOStream  const * ,
// ! to Vector  ( StackPLOPC )
    bool flag2pprinted  , Vector  ( StackPLOP )  * ) ;

# define  ParaLispObject_CoutToInterpret  Lisp2D_ParaLispObject_CoutToInterpret
void  ParaLispObject_CoutToInterpret ( ParaLispObject  const * me  ,
  PLOStream const * s ,
// ! to Vector  ( StackPLOPC )
  bool  const * flag2pprinted , Vector  ( StackPLOP ) * historyp ) ;

# define  ParaLispObject_CoutToHuman  Lisp2D_ParaLispObject_CoutToHuman
void  ParaLispObject_CoutToHuman ( ParaLispObject  const * me  ,
  PLOStream const * s , bool  const * flag2pprinted ,
// ! to Vector  ( StackPLOPC )
  Vector  ( StackPLOP ) * historyp ) ;

# define  ParaLispObject_virttableCoutToHuman Lisp2D_ParaLispObject_virttableCoutToHuman
extern  void ( * ParaLispObject_virttableCoutToHuman  [ TypeGlobalListMemberSIZE ] ) (
    ParaLispObject const * ,  PLOStream  const * ,
// ! to Vector  ( StackPLOPC )
    bool flag2pprinted  , Vector  ( StackPLOP )  * ) ;

# define  ParaLispObject_PushAsNew  Lisp2D_ParaLispObject_PushAsNew
ParaLispObject  * ParaLispObject_PushAsNew ( ParaLispObject * me ) ;

# define  ParaLispObject_DeclareForGC Lisp2D_ParaLispObject_DeclareForGC
void  ParaLispObject_DeclareForGC ( ParaLispObject *  ) ;

# define  GlobalListOfObjects Lisp2DGlobalListOfObjects
extern  GlobalList  GlobalListOfObjects ;

# define  GlobalListOfObjectsGarbage  Lisp2DGlobalListOfObjectsGarbage
extern  GlobalList  GlobalListOfObjectsGarbage  ;

# define  ParaLispObject_Context  Lisp2D_ParaLispObject_Context
ParaLispObject  * ParaLispObject_Context ( ParaLispObject const * ) ;

# define  ploclassdefenvlayer Lisp2D_ploclassdefenvlayer
extern  ParaLispObject  *   ploclassdefenvlayer ;

# define  ploclassparentsenvlayer Lisp2D_ploclassparentsenvlayer
extern  ParaLispObject  *   ploclassparentsenvlayer ;

# define  ploclassdefbif  Lisp2D_ploclassdefbif
extern  ParaLispObject  *   ploclassdefbif  ;

# define  ploclassparentsbif  Lisp2D_ploclassparentsbif
extern  ParaLispObject  *   ploclassparentsbif  ;

# define  ploclassdefsignal Lisp2D_ploclassdefsignal
extern  ParaLispObject  *   ploclassdefsignal ;

# define  ploclassparentssignal Lisp2D_ploclassparentssignal
extern  ParaLispObject  *   ploclassparentssignal ;

# define  ploclassdeftime Lisp2D_ploclassdeftime
extern  ParaLispObject  *   ploclassdeftime ;

# define  ploclassparentstime Lisp2D_ploclassparentstime
extern  ParaLispObject  *   ploclassparentstime ;

ParaLispObject * ParaLispObjectFromMember ( GlobalListMember * ) ;

# define  ploclassdefdir  Lisp2D_ploclassdefdir
extern  ParaLispObject  *   ploclassdefdir  ;

# define  ploclassparentsdir  Lisp2D_ploclassparentsdir
extern  ParaLispObject  *   ploclassparentsdir  ;

# define  ploclassdefQuote  Lisp2D_ploclassdefQuote
extern  ParaLispObject  * ploclassdefQuote  ;

# define  ploclassparentsQuote  Lisp2D_ploclassparentsQuote
extern  ParaLispObject  * ploclassparentsQuote  ;

# include "define.h"

# ifndef  LISP2D_DONTUSEX11
  extern  ParaLispObject  *   ploclassparentswindow ;
# endif
  extern  ParaLispObject  *   ploclassparentslock ;
  extern  ParaLispObject  *   ploclassparentsBackQuote  ;
  extern  ParaLispObject  *   ploclassparentsComma  ;
  extern  ParaLispObject  *   ploclassparentsUnquoteSplicing  ;
  extern  ParaLispObject  *   ploclassparentscomplex  ;
  extern  ParaLispObject  *   ploclassparentscomplexirr2  ;
  extern  ParaLispObject  *   ploclassparentsbytedeque  ;
  extern  ParaLispObject  *   ploclassparentssocket ;
  extern  ParaLispObject  *   ploclassparentsstat ;
# define  ploclassdefstream Lisp2D_ploclassdefstream
  extern  ParaLispObject  *   ploclassdefstream ;
# define  ploclassparentsstream  Lisp2D_ploclassparentsstream
  extern  ParaLispObject  *   ploclassparentsstream ;
  extern  ParaLispObject  *   ploclassparentscons ;
  extern  ParaLispObject  *   ploclassparentsvector ;
  extern  ParaLispObject  *   ploclassparentsstring ;
  extern  ParaLispObject  *   ploclassparentschar ;
extern  ParaLispObject  *   ploclassdefcons ;
  extern  ParaLispObject  *   ploclassdefvector ;
  extern  ParaLispObject  *   ploclassdefstring ;
  extern  ParaLispObject  *   ploclassdefchar ;
# ifndef  LISP2D_DONTUSEX11
  extern  ParaLispObject  *   ploclassdefwindow ;
# endif
  extern  ParaLispObject  *   ploclassdeflock ;
  extern  ParaLispObject  *   ploclassdefBackQuote  ;
  extern  ParaLispObject  *   ploclassdefComma  ;
  extern  ParaLispObject  *   ploclassdefUnquoteSplicing  ;
  extern  ParaLispObject  *   ploclassdefcomplex  ;
  extern  ParaLispObject  *   ploclassdefcomplexirr2  ;
  extern  ParaLispObject  *   ploclassdefbytedeque  ;
  extern  ParaLispObject  *   ploclassdefsocket ;
  extern  ParaLispObject  *   ploclassdefstat ;
# define  globalresult2 Lisp2D_globalresult2
  extern  ParaLispObject  * globalresult2 ;
// ! ? envtop2 : Eval2 - modifies variable at exit
# define  envtop2 Lisp2D_envtop2
  extern  ParaLispObject  * envtop2 ;

# define  ParaLispObjectPrivatevirtualisBADCopyPrivate  Lisp2D_ParaLispObjectPrivatevirtualisBADCopyPrivate
bool  ParaLispObjectPrivatevirtualisBADCopyPrivate ( ParaLispObject const * const me ,
  ParaLispObject  * * const resultp  ) ;

# define  ParaLispObject_virtualisOKSetFlagConstFalse \
  Lisp2D_ParaLispObject_virtualisOKSetFlagConstFalse
bool  ParaLispObject_virtualisOKSetFlagConstFalse  ( ParaLispObject * ) ;

# define  ParaLispObject_Type Lisp2D_ParaLispObject_Type
inline  int  ParaLispObject_Type  ( ParaLispObject  const * ) ;

# define  ParaLispObject_isBADCopy  Lisp2D_ParaLispObject_isBADCopy
inline  bool  ParaLispObject_isBADCopy ( ParaLispObject  const * const me  , ParaLispObject  * * const resultp  ) ;

# define  ParaLispObject_SetFlagConstFalse  Lisp2D_ParaLispObject_SetFlagConstFalse
inline  ParaLispObject  * ParaLispObject_SetFlagConstFalse ( ParaLispObject  * ) ;

# define  ParaLispObject_SetFlagConstTrue Lisp2D_ParaLispObject_SetFlagConstTrue
inline  ParaLispObject  * ParaLispObject_SetFlagConstTrue  ( ParaLispObject  * ) ;

# define  ParaLispObject_SetFlagStaticFalse Lisp2D_ParaLispObject_SetFlagStaticFalse
inline  void  ParaLispObject_SetFlagStaticFalse ( ParaLispObject  * ) ;

# define  ParaLispObject_SetFlagStaticTrue Lisp2D_ParaLispObject_SetFlagStaticTrue
inline  void  ParaLispObject_SetFlagStaticTrue  ( ParaLispObject  * ) ;

# define  ParaLispObject_IsStatic Lisp2D_ParaLispObject_IsStatic
inline  bool  ParaLispObject_IsStatic ( ParaLispObject const * ) ;

# define  ParaLispObjectPrivatevirtualCoutToInterpret Lisp2D_ParaLispObjectPrivatevirtualCoutToInterpret
void  ParaLispObjectPrivatevirtualCoutToInterpret ( ParaLispObject const * ,
  PLOStream  const * , bool flag2pprinted  , Vector  ( StackPLOP )  * ) ;

# define  ParaLispObjectPrivatevirtualCoutToHuman Lisp2DParaLispObjectPrivatevirtualCoutToHuman
void  ParaLispObjectPrivatevirtualCoutToHuman ( ParaLispObject const * ,
  PLOStream  const * , bool flag2pprinted  , Vector  ( StackPLOP )  * ) ;

inline  int  ParaLispObject_Type  ( ParaLispObject  const * const me ) {
  return me ->  vaddr . type ;
}

inline  bool  ParaLispObject_isBADCopy ( ParaLispObject  const * const me  , ParaLispObject  * * const resultp  ) {
  return ParaLispObjectPrivatevirtualisBADCopyPrivate ( me , resultp  ) ;
}

inline  ParaLispObject  * ParaLispObject_SetFlagConstFalse ( ParaLispObject  * const me  )  {
  me -> flagConst = false ;
  return me ;
}

inline  ParaLispObject  * ParaLispObject_SetFlagConstTrue  ( ParaLispObject  * const me  ) {
  me -> flagConst  = true ;
  return me ;
}

inline  void  ParaLispObject_SetFlagStaticFalse ( ParaLispObject  * const me  )  {
  me -> flagStatic  = false ;
}

inline  void  ParaLispObject_SetFlagStaticTrue  ( ParaLispObject  * const me  ) {
  me -> flagStatic  = true ;
}

inline  bool  ParaLispObject_IsStatic ( ParaLispObject const * const me  ) {
  return  me -> flagStatic  ;
}
# endif //  LISP2D_PLO_PUBLIC_H
