// Lisp2D PloComplex Public
// 2023
# ifndef  LISP2D_PLOCOMPLEX_PUBLIC_H
# define  LISP2D_PLOCOMPLEX_PUBLIC_H

# include "plocomplex/type.h"

// +0/0+0/0i
# define  PLOComplex_InitUnDef  Lisp2D_PLOComplex_InitUnDef
void  PLOComplex_InitUnDef ( PLOComplex * ) ;

# define  PLOComplex_Destr  Lisp2D_PLOComplex_Destr
void  PLOComplex_Destr  ( PLOComplex * ) ;

// new complex, may be from garbage. 
// NOT inserted to GlobalListOfComplex.  
// if(res){ ok }else{ no mem }
# define  PLOComplex_newraw Lisp2D_PLOComplex_newraw
PLOComplex * PLOComplex_newraw ( void ) ;

// call destructor and, pushing memory to garbage  
// OR deletes
# define  PLOComplex_delete Lisp2D_PLOComplex_delete
void  PLOComplex_delete ( PLOComplex * ) ;

# include "plo/type.h"

# define  PLOComplex_staticTypeOf Lisp2D_PLOComplex_staticTypeOf
ParaLispObject  * PLOComplex_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOComplex_staticClassDef Lisp2D_PLOComplex_staticClassDef
ParaLispObject  * PLOComplex_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOComplex_staticClassParents Lisp2D_PLOComplex_staticClassParents
ParaLispObject  * PLOComplex_staticClassParents  ( ParaLispObject const * ) ;
  
# define  PLOComplex_staticDeclareForGC Lisp2D_PLOComplex_staticDeclareForGC
void  PLOComplex_staticDeclareForGC ( ParaLispObject *  ) ;

# define  PLOComplex_staticPushAsNew  Lisp2D_PLOComplex_staticPushAsNew
ParaLispObject  * PLOComplex_staticPushAsNew ( ParaLispObject * me ) ;
  
# include <stdbool.h>

# define  PLOComplex_staticisBADCopyPrivate Lisp2D_PLOComplex_staticisBADCopyPrivate
bool  PLOComplex_staticisBADCopyPrivate  ( ParaLispObject const * me , ParaLispObject  * *  resultp ) ;

# include "plostream/type.h"
  
# define  PLOComplex_staticCoutToHuman  Lisp2D_PLOComplex_staticCoutToHuman
void  PLOComplex_staticCoutToHuman ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector(StackPLOP)  *  h ) ;
    
# define  PLOComplex_staticCoutToInterpret Lisp2D_PLOComplex_staticCoutToInterpret
void  PLOComplex_staticCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector(StackPLOP)  *  h ) ;  

# include "globallistm/type.h"

# define  PLOComplex_FromMember Lisp2D_PLOComplex_FromMember
PLOComplex * PLOComplex_FromMember ( GlobalListMember * ) ;

# include "taskforthread.h" // StackClusterPrivate

// clear number, setting to NOT Const, pushing to garbage , No ~Destructor
// OR deletes
# define  IsNotRealLockGC Lisp2D_IsNotRealLockGC
bool  IsNotRealLockGC ( StackClusterPrivate  * , PLOComplex * ) ;

# include "widestring.h"

# define  s_LoadComplexFromString Lisp2D_s_LoadComplexFromString
# define  t_LoadComplexFromString Lisp2D_t_LoadComplexFromString
typedef struct  s_LoadComplexFromString t_LoadComplexFromString ;

struct  s_LoadComplexFromString {
  String  ( WideChar  ) const * const  wsp ;
  size_t  * const  jp ;
  PLOComplex * const complxp ;
  bool * const  flagErrp ;
  bool * const flagImp ;
  size_t * const  partsizep ;
  bool const flagNegative ;
} ;

# define  LoadComplexFromString Lisp2DLoadComplexFromString
// sign will set by flagNegative
void  LoadComplexFromString ( t_LoadComplexFromString ) ;

// !? to return pointer (PLOComplex *) or nullptr
// !? to return bool:isBAD and argument (&result)
// returns  pointer to new number zero or nullptr
// returns  pointer to new number 0/0+0/0i or nullptr
// new constructor() from new memory or from garbage
// pushed to globalList of numbers  
# define  NewComplexBareExc Lisp2D_NewComplexBareExc
PLOComplex  * NewComplexBareExc ( void ) ;

// returns  pointer to new number 0/0+0/0i or nullptr
// new constructor() from new memory or from garbage
// not in global list, to do : manual add GlobalListOfComplex.Push2(x);
// or :    delete x; (drawing to garbage or deletes)
# define  NewComplexBareNotInGlobalListExc \
  Lisp2D_NewComplexBareNotInGlobalListExc
PLOComplex  * NewComplexBareNotInGlobalListExc  ( void ) ;

// returns  pointer to memory for number (from garbage or new)
// to do manual call constructor() : new (pointer) PLOComplex(..arguments..)
// manual add GlobalListOfComplex.Push2(x);
// or :    delete x; (calls destructor , drawing to garbage or deletes)
// throw std ::  bad_alloc ( ) ;
# define  NewComplexOnlyMemoryNotInGlobalListExc  Lisp2D_NewComplexOnlyMemoryNotInGlobalListExc
PLOComplex  * NewComplexOnlyMemoryNotInGlobalListExc ( void ) ;

# include "complex/type.h"

# define  PLOComplexToComplex Lisp2D_PLOComplexToComplex
inline  Complex * PLOComplexToComplex ( PLOComplex * ) ;
# define  PLOComplexToComplexConst Lisp2D_PLOComplexToComplexConst
inline  Complex const * PLOComplexToComplexConst ( PLOComplex const * ) ;
# define  ParaLispObjectToPLOComplex  Lisp2DParaLispObjectToPLOComplex
inline  PLOComplex * ParaLispObjectToPLOComplex ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOComplexConst Lisp2DParaLispObjectToPLOComplexConst
inline  PLOComplex const * ParaLispObjectToPLOComplexConst ( ParaLispObject const * ) ;
# define  PLOComplex_staticDestr  Lisp2D_PLOComplex_staticDestr
void PLOComplex_staticDestr  ( ParaLispObject * ) ;
# define  PLOComplex_Set  Lisp2D_PLOComplex_Set
inline  PLOComplex  * PLOComplex_Set ( PLOComplex * , PLOComplex  const * ) ;

# include "plocomplex/private.h"

inline  Complex * PLOComplexToComplex ( PLOComplex * const c ) {
  return  & PLOComplexPubToPri  ( c ) ->  pri . pub ;
}

inline  Complex const * PLOComplexToComplexConst ( PLOComplex const * const c ) {
  return  & PLOComplexPubToPriConst ( c ) ->  pri . pub ;
}

inline  PLOComplex * ParaLispObjectToPLOComplex ( ParaLispObject * const  p ) {
  return (  PLOComplex * ) ( p  ->  vaddr . addr . p ) ;
}

inline  PLOComplex const * ParaLispObjectToPLOComplexConst ( ParaLispObject const * const  p ) {
  return (  PLOComplex const * ) ( p  ->  vaddr . addr . p ) ;
}

# include "plocomplex/public.h"
# include "complex/inline.h"

inline  PLOComplex  * PLOComplex_Set ( PLOComplex * const me , PLOComplex  const * const xp ) {
  Complex_Set ( PLOComplexToComplex ( me ) , PLOComplexToComplexConst ( xp ) ) ;
  return me ;
}

# endif // LISP2D_PLOCOMPLEX_PUBLIC_H
