// Lisp2D - Stream
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_PLOSTREAM_PUBLIC_H
# define  LISP2D_PLOSTREAM_PUBLIC_H

# include "plostream/type.h"

extern  PLOStream Lisp2Dferr ;
  
extern  PLOStream Lisp2Dfout ;
  
extern  PLOStream Lisp2Dfin ;

# define  PLOStreamStaticDestr  Lisp2DPLOStreamStaticDestr
void PLOStreamStaticDestr  ( PLOStream * ) ;  
  
// ! virtual
# define  PLOStreamDestr  Lisp2DPLOStreamDestr
void PLOStreamDestr  ( ParaLispObject * ) ;  
  
# define  PLOStreamTypeOf Lisp2DPLOStreamTypeOf
ParaLispObject  * PLOStreamTypeOf ( ParaLispObject const * ) ;  
  
# define  PLOStreamClassDef Lisp2DPLOStreamClassDef
ParaLispObject  * PLOStreamClassDef  ( ParaLispObject const * ) ;  
  
# define  PLOStreamClassParents Lisp2DPLOStreamClassParents
ParaLispObject  * PLOStreamClassParents  ( ParaLispObject const * ) ;  
  
# define  PLOStreamCoutToHuman  Lisp2DPLOStreamCoutToHuman
void  PLOStreamCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;  
  
# define  PLOStreamCoutToInterpret  Lisp2DPLOStreamCoutToInterpret
void  PLOStreamCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;
  
# define  PLOStreamInitFD Lisp2DPLOStreamInitFD
void  PLOStreamInitFD  ( PLOStream * me , bool inner , int fd  , int flags ) ;    
   
# define  PLOStreamPushWChar  Lisp2DPLOStreamPushWChar
PLOStream const * PLOStreamPushWChar ( PLOStream  const * , wchar_t ) ;
    
# define  PLOStreamEndl  Lisp2DPLOStreamEndl
PLOStream const * PLOStreamEndl  ( PLOStream  const * ) ;

# define  PLOStreamCoutHistoryError  Lisp2DPLOStreamCoutHistoryError
void  PLOStreamCoutHistoryError ( PLOStream * ) ;

# define  PLOStreamPushPLO Lisp2DPLOStreamPushPLO
PLOStream const * PLOStreamPushPLO  ( PLOStream  const * ,
  ParaLispObject const * ) ;

# define  PLOStreamPushLDouble  Lisp2DPLOStreamPushLDouble
PLOStream const * PLOStreamPushLDouble  ( PLOStream  const *  ,
  long double ) ;  

# include "streamc.h"

# define  PLOStreamPushStreamType Lisp2D_PLOStreamPushStreamType
PLOStream const * PLOStreamPushStreamType ( PLOStream  const * ,
  StreamType ) ;
  
# define  PLOStreamPushEvalAddrCont  Lisp2DPLOStreamPushEvalAddrCont
PLOStream const * PLOStreamPushEvalAddrCont  ( PLOStream  const *  ,
  EvalAddrCont2 ) ;  

# define  PLOStreamPushInt  Lisp2DPLOStreamPushInt
PLOStream const * PLOStreamPushInt  ( PLOStream  const *  , int ) ; 
  
# define  PLOStreamPushUInt Lisp2DPLOStreamPushUInt
PLOStream const * PLOStreamPushUInt  ( PLOStream  const * , unsigned int ) ;  

# define  PLOStreamPushSInt Lisp2D_PLOStreamPushSInt
PLOStream const * PLOStreamPushSInt  ( PLOStream  const * , signed int ) ;

# define  PLOStreamPushUSize Lisp2DPLOStreamPushUSize
PLOStream const * PLOStreamPushUSize  ( PLOStream  const * , size_t ) ;  

# define  bimnilstreamp Lisp2Dbimnilstreamp2
FuncBining bimnilstreamp  ;
FuncBining Lisp2Dbimstreamwrite2 ;
  FuncBining Lisp2Dbimstreamreadbyte2 ;
# define  bimstreamclose  Lisp2Dbimstreamclose2
FuncBining bimstreamclose ;
# define  bimstreamlisten Lisp2Dbimstreamlisten2
FuncBining bimstreamlisten ;
  FuncBining Lisp2Dbimstreamwriteln2 ;
  FuncBining Lisp2Dbimstreamwritebyte2 ;
  FuncBining Lisp2Dbimstreamread2 ;
FuncBining  Lisp2Dbimstreamseek ;
FuncBining  Lisp2Dbimstreamtell ;
  FuncBining  Lisp2Dbimstreamterpri2 ;
  FuncBining  Lisp2Dbimstreamprinc2 ;
# define  bimstreamopenp  Lisp2Dbimstreamopenp2
  FuncBining  Lisp2Dbimstreamopenp2 ;
  FuncBining  Lisp2Dbimstreamprint2 ;
# define  bimstreamflush  Lisp2Dbimstreamflush2  
  FuncBining  Lisp2Dbimstreamflush2 ;
  FuncBining  Lisp2Dbimstreamreadline2 ;
  FuncBining  Lisp2Dbimstreamreadchar2 ;
  FuncBining  Lisp2Dbimstringopenbinary2  ;
FuncBining  Lisp2Dbimstreamtruncate ;
  FuncBining  Lisp2Dbimstringtruncate2   ;
FuncBining  Lisp2Dbimstreamchdir  ;
FuncBining  Lisp2Dbimstringchownusergroup ;
FuncBining  Lisp2Dbimstringlchownusergroup ;
FuncBining  Lisp2Dbimstreamchownusergroup ;
FuncBining  Lisp2Dbimstringstat ;
FuncBining  Lisp2Dbimstringlstat  ;
FuncBining  Lisp2Dbimstreamstat ;
FuncBining  Lisp2Dbimstreamgetwinsize ;

# define  PLOStreamPushThreadIdC  Lisp2D_PLOStreamPushThreadIdC
PLOStream const * PLOStreamPushThreadIdC  ( PLOStream  const * ,
  pthread_t ) ;

# define  MKDirClass_RwxUsr  Lisp2D_MKDirClass_RwxUsr
void  MKDirClass_RwxUsr  ( mode_t * )  ;

# define  MKDirClass_RUsr  Lisp2D_MKDirClass_RUsr
void  MKDirClass_RUsr  ( mode_t * )  ;

# define  MKDirClass_WUsr  Lisp2D_MKDirClass_WUsr
void  MKDirClass_WUsr  ( mode_t * )  ;

# define  MKDirClass_XUsr  Lisp2D_MKDirClass_XUsr
void  MKDirClass_XUsr  ( mode_t * )  ;

# define  MKDirClass_RwxGrp  Lisp2D_MKDirClass_RwxGrp
void  MKDirClass_RwxGrp  ( mode_t * )  ;

# define  MKDirClass_RGrp  Lisp2D_MKDirClass_RGrp
void  MKDirClass_RGrp  ( mode_t * )  ;

# define  MKDirClass_WGrp  Lisp2D_MKDirClass_WGrp
void  MKDirClass_WGrp  ( mode_t * )  ;

# define  MKDirClass_XGrp  Lisp2D_MKDirClass_XGrp
void  MKDirClass_XGrp  ( mode_t * )  ;

# define  MKDirClass_RwxOth  Lisp2D_MKDirClass_RwxOth
void  MKDirClass_RwxOth  ( mode_t * )  ;

# define  MKDirClass_ROth  Lisp2D_MKDirClass_ROth
void  MKDirClass_ROth  ( mode_t * )  ;

# define  MKDirClass_WOth  Lisp2D_MKDirClass_WOth
void  MKDirClass_WOth  ( mode_t * )  ;

# define  MKDirClass_XOth  Lisp2D_MKDirClass_XOth
void  MKDirClass_XOth  ( mode_t * )  ;

# define  MKDirClass_Suid  Lisp2D_MKDirClass_Suid
void  MKDirClass_Suid  ( mode_t * )  ;

# define  MKDirClass_Sgid  Lisp2D_MKDirClass_Sgid
void  MKDirClass_Sgid  ( mode_t * )  ;

# define  MKDirClass_Svtx  Lisp2D_MKDirClass_Svtx
void  MKDirClass_Svtx  ( mode_t * )  ;

# define  OpenModes_In  Lisp2D_OpenModes_In
void  OpenModes_In  ( OpenModes * ) ;

# define  OpenModes_Out  Lisp2D_OpenModes_Out
void  OpenModes_Out  ( OpenModes * ) ;

# define  OpenModes_InOut  Lisp2D_OpenModes_InOut
void  OpenModes_InOut  ( OpenModes * ) ;

# define  OpenModes_Trunc  Lisp2D_OpenModes_Trunc
void  OpenModes_Trunc  ( OpenModes * ) ;

# define  OpenModes_App  Lisp2D_OpenModes_App
void  OpenModes_App  ( OpenModes * ) ;

# define  OpenModes_Ate  Lisp2D_OpenModes_Ate
void  OpenModes_Ate  ( OpenModes * ) ;

# define  OpenModes_Async  Lisp2D_OpenModes_Async
void  OpenModes_Async  ( OpenModes * ) ;

# define  OpenModes_Cloexec  Lisp2D_OpenModes_Cloexec
void  OpenModes_Cloexec  ( OpenModes * ) ;

# define  OpenModes_Creat  Lisp2D_OpenModes_Creat
void  OpenModes_Creat  ( OpenModes * ) ;

# define  OpenModes_RwxUsr  Lisp2D_OpenModes_RwxUsr
void  OpenModes_RwxUsr  ( OpenModes * ) ;

# define  OpenModes_RUsr  Lisp2D_OpenModes_RUsr
void  OpenModes_RUsr  ( OpenModes * ) ;

# define  OpenModes_WUsr  Lisp2D_OpenModes_WUsr
void  OpenModes_WUsr  ( OpenModes * ) ;

# define  OpenModes_XUsr  Lisp2D_OpenModes_XUsr
void  OpenModes_XUsr  ( OpenModes * ) ;

# define  OpenModes_RwxGrp  Lisp2D_OpenModes_RwxGrp
void  OpenModes_RwxGrp  ( OpenModes * ) ;

# define  OpenModes_RGrp  Lisp2D_OpenModes_RGrp
void  OpenModes_RGrp  ( OpenModes * ) ;

# define  OpenModes_WGrp  Lisp2D_OpenModes_WGrp
void  OpenModes_WGrp  ( OpenModes * ) ;

# define  OpenModes_XGrp  Lisp2D_OpenModes_XGrp
void  OpenModes_XGrp  ( OpenModes * ) ;

# define  OpenModes_RwxOth  Lisp2D_OpenModes_RwxOth
void  OpenModes_RwxOth  ( OpenModes * ) ;

# define  OpenModes_ROth  Lisp2D_OpenModes_ROth
void  OpenModes_ROth  ( OpenModes * ) ;

# define  OpenModes_WOth  Lisp2D_OpenModes_WOth
void  OpenModes_WOth  ( OpenModes * ) ;

# define  OpenModes_XOth  Lisp2D_OpenModes_XOth
void  OpenModes_XOth  ( OpenModes * ) ;

# define  OpenModes_Suid  Lisp2D_OpenModes_Suid
void  OpenModes_Suid  ( OpenModes * ) ;

# define  OpenModes_Sgid  Lisp2D_OpenModes_Sgid
void  OpenModes_Sgid  ( OpenModes * ) ;

# define  OpenModes_Svtx  Lisp2D_OpenModes_Svtx
void  OpenModes_Svtx  ( OpenModes * ) ;

# define  OpenModes_Direct  Lisp2D_OpenModes_Direct
void  OpenModes_Direct  ( OpenModes * ) ;

# define  OpenModes_Directory  Lisp2D_OpenModes_Directory
void  OpenModes_Directory  ( OpenModes * ) ;

# define  OpenModes_Dsync  Lisp2D_OpenModes_Dsync
void  OpenModes_Dsync  ( OpenModes * ) ;

# define  OpenModes_Excl  Lisp2D_OpenModes_Excl
void  OpenModes_Excl  ( OpenModes * ) ;

# define  OpenModes_Largefile  Lisp2D_OpenModes_Largefile
void  OpenModes_Largefile  ( OpenModes * ) ;

# define  OpenModes_Noatime  Lisp2D_OpenModes_Noatime
void  OpenModes_Noatime  ( OpenModes * ) ;

# define  OpenModes_Noctty  Lisp2D_OpenModes_Noctty
void  OpenModes_Noctty  ( OpenModes * ) ;

# define  OpenModes_Nofollow  Lisp2D_OpenModes_Nofollow
void  OpenModes_Nofollow  ( OpenModes * ) ;

# define  OpenModes_NonblockOrNdelay  Lisp2D_OpenModes_NonblockOrNdelay
void  OpenModes_NonblockOrNdelay  ( OpenModes * ) ;

# define  OpenModes_Path  Lisp2D_OpenModes_Path
void  OpenModes_Path  ( OpenModes * ) ;

# define  OpenModes_Sync  Lisp2D_OpenModes_Sync
void  OpenModes_Sync  ( OpenModes * ) ;

# define  OpenModes_Tmpfile  Lisp2D_OpenModes_Tmpfile
void  OpenModes_Tmpfile  ( OpenModes * ) ;

# include "stat/type.h"

TaskForThread bimstreamstat ( StackClusterPrivate * , PLOStream *  me , PLOStat * result  )  ;
  
# include "string/type.h"

TaskForThread bimstringstat ( StackClusterPrivate * , PLOStringPub * me , PLOStat * result  ) ;

# include "plostream/struct.h"

LISP2DPROTOSTACKPUSHBYVALUE ( StackMapNodeFlessOpenModes , MapNode ( FlessOpenModes ) )
LISP2DPROTOSTACKPUSHATVALUE ( StackMapNodeFlessOpenModes , MapNode ( FlessOpenModes ) )

# define  symboltoopenmodes_pub Lisp2D_symboltoopenmodes_pub
extern  MapPub  ( FlessOpenModes ) * const symboltoopenmodes_pub ;

# define  symboltoopenmodes_fun Lisp2D_symboltoopenmodes_fun
int symboltoopenmodes_fun ( ParaLispObject  * , ParaLispObject  * ) ;

LISP2DMAPPUBFINDPROTO ( FlessOpenModes  , ParaLispObject  * )
LISP2DPROTOSTACKCAT ( StackMapNodeFlessOpenModes , MapNode ( FlessOpenModes ) )

# define  symboltomkdirmodes_pub Lisp2D_symboltomkdirmodes_pub
extern  MapPub  ( FlessMkdirModes ) * const symboltomkdirmodes_pub ;

# define  symboltomkdirmodes_fun  Lisp2D_symboltomkdirmodes_fun
int symboltomkdirmodes_fun  ( ParaLispObject  * , ParaLispObject  * ) ;

LISP2DPROTOSTACKPUSHBYVALUE ( StackMapNodeFlessMkdirModes , MapNode ( FlessMkdirModes ) )
LISP2DPROTOSTACKPUSHATVALUE ( StackMapNodeFlessMkdirModes , MapNode ( FlessMkdirModes ) )
LISP2DMAPPUBFINDPROTO ( FlessMkdirModes , ParaLispObject  * )
LISP2DPROTOSTACKCAT ( StackMapNodeFlessMkdirModes , MapNode ( FlessMkdirModes ) )

# define  ParaLispObjectToPLOStream  Lisp2DParaLispObjectToPLOStream
inline  PLOStream * ParaLispObjectToPLOStream ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOStreamConst Lisp2DParaLispObjectToPLOStreamConst
inline  PLOStream const * ParaLispObjectToPLOStreamConst ( ParaLispObject const * ) ;
# define  PLOStreamInit Lisp2D_PLOStreamInit
void  PLOStreamInit ( PLOStream * ) ;
# define  Streamp Lisp2DStreamp
inline  bool  Streamp ( ParaLispObject const * ) ;

# define  PLOStreamPushWideCharArray  Lisp2DPLOStreamPushWideCharArray
inline  PLOStream const * PLOStreamPushWideCharArray  ( PLOStream const * , PArray_wchar_c ) ;

# define  PLOStreamPushWideCharArrayv  Lisp2DPLOStreamPushWideCharArrayv
inline  PLOStream const * PLOStreamPushWideCharArrayv  ( PLOStream const * , PArray_wchar_cv ) ;

# define  PLOStreamPushStringWideChar Lisp2DPLOStreamPushStringWideChar
PLOStream const * PLOStreamPushStringWideChar ( PLOStream  const * , String  ( WideChar  )  const * ) ;
# define  OpenModes_Init  Lisp2D_OpenModes_Init
void  OpenModes_Init ( OpenModes * ) ;
inline  LISP2DDECLAREMAPSTACKINIT ( FlessOpenModes )
inline  LISP2DPRIFROMMAPPUBPROTO ( FlessOpenModes )
inline  LISP2DMAPPUBINITDECLARE ( FlessOpenModes )
LISP2PROTODMAPSTACKPUSHFRONTVALUE ( FlessOpenModes )
LISP2DMAPSTACKATPROTO ( FlessOpenModes )
LISP2DMAPPUBINSERTPROTO ( FlessOpenModes )
LISP2DPROTOMAPSTACKDESTR ( FlessOpenModes )
inline  LISP2DMAPPUBDESTRPROTO ( FlessOpenModes )
inline  LISP2DCONSTPRIFROMMAPPUBPROTO ( FlessOpenModes )
inline  LISP2DMAPPUBSIZEDECL ( FlessOpenModes )
inline  LISP2DMAPPUBCATDECL ( FlessOpenModes )

inline  LISP2DDECLAREMAPSTACKINIT ( FlessMkdirModes )
inline  LISP2DPRIFROMMAPPUBPROTO ( FlessMkdirModes )
inline  LISP2DMAPPUBINITDECLARE ( FlessMkdirModes )
LISP2PROTODMAPSTACKPUSHFRONTVALUE ( FlessMkdirModes )
LISP2DMAPSTACKATPROTO ( FlessMkdirModes )
LISP2DMAPPUBINSERTPROTO ( FlessMkdirModes )
LISP2DPROTOMAPSTACKDESTR ( FlessMkdirModes )
inline  LISP2DMAPPUBDESTRPROTO ( FlessMkdirModes )
inline  LISP2DCONSTPRIFROMMAPPUBPROTO ( FlessMkdirModes )
inline  LISP2DMAPPUBSIZEDECL ( FlessMkdirModes )
inline  LISP2DMAPPUBCATDECL ( FlessMkdirModes )

# include "plostream/struct.h"

# define  ParaLispObjectToPLOStream  Lisp2DParaLispObjectToPLOStream
inline  PLOStream * ParaLispObjectToPLOStream ( ParaLispObject * const  p ) {
  return p  ->  vaddr . addr . p ;
}

inline  PLOStream const * ParaLispObjectToPLOStreamConst ( ParaLispObject const * const  p ) {
  return p  ->  vaddr . addr . p ;
}

inline  bool  Streamp ( ParaLispObject const * const xp  ) {
  return  ParaLispObject_Type ( xp  ) ==  TypeGlobalListMemberPLOStream ;
}

inline  PLOStream const * PLOStreamPushWideCharArray  ( PLOStream const * const sp , PArray_wchar_c const ca ) {
  StreamPushWCharArray ( & sp ->  str , ca ) ;
  return sp  ;
}

inline  PLOStream const * PLOStreamPushWideCharArrayv  ( PLOStream const * const sp , PArray_wchar_cv const ca ) {
  StreamPushWCharArrayv ( & sp ->  str , ca ) ;
  return sp  ;
}

# include "plostream/public.h"

inline  LISP2DMAPSTACKINITBODY ( FlessOpenModes )
inline  LISP2DPRIFROMMAPPUBBODY ( FlessOpenModes )
inline  LISP2DMAPPUBINITBODY ( FlessOpenModes )
inline  LISP2DMAPPUBDESTRBODY  ( FlessOpenModes )
inline  LISP2DCONSTPRIFROMMAPPUBBODY  ( FlessOpenModes )
inline  LISP2DMAPPUBSIZEBODY  ( FlessOpenModes )
inline  LISP2DMAPPUBCATBODY ( FlessOpenModes )

inline  LISP2DMAPSTACKINITBODY ( FlessMkdirModes )
inline  LISP2DPRIFROMMAPPUBBODY ( FlessMkdirModes )
inline  LISP2DMAPPUBINITBODY ( FlessMkdirModes )
inline  LISP2DMAPPUBDESTRBODY  ( FlessMkdirModes )
inline  LISP2DCONSTPRIFROMMAPPUBBODY  ( FlessMkdirModes )
inline  LISP2DMAPPUBSIZEBODY  ( FlessMkdirModes )
inline  LISP2DMAPPUBCATBODY ( FlessMkdirModes )

# endif // LISP2D_PLOSTREAM_PUBLIC_H
