// Lisp2D - global functions
// ©2020-3 by Alex Glebe
# ifndef  LISP2D_SHAREDC_H
# define  LISP2D_SHAREDC_H

# include "condit.h"
# include "plo/struct.h"

extern  Mutex2  Lisp2Dmutex2ManagerTasks ;
extern  Lisp2DCondition Lisp2DsignalManager ;
extern  Mutex2  Lisp2DmutexNameSpace  ;
extern  Mutex2  Lisp2DmutexGenTemp  ;
extern  Mutex2  Lisp2DMutexTreeSymbols  ;
typedef struct  Lisp2Ds_writelog  Lisp2Dt_writelog  ;
struct  Lisp2Ds_writelog {
  wchar_t const ( * a ) [ ] ;
} ;
void  Lisp2D_writelog  ( Lisp2Dt_writelog ) ;

# include "stack-plop.h"
# include "plostream/type.h"

# define  Printed3Points  Lisp2D_Printed3Points
bool  Printed3Points  ( ParaLispObject  const *  , PLOStream const * , bool *  ,  Vector ( StackPLOP ) * ) ;

# include "define.h"

  # define  runpthcount Lisp2D_runpthcount
  // process Item and Pause
  extern  volatile  _Atomic ( int ) runpthcount ;
  # define  countExtraThreads2  Lisp2D_countExtraThreads2
  extern  volatile  _Atomic ( size_t  ) countExtraThreads2  ;
  # define  countStackClusterWantToBeInGarbage Lisp2D_countStackClusterWantToBeInGarbage
  extern  volatile  _Atomic ( size_t  ) countStackClusterWantToBeInGarbage  ;  

# define  countStackClusterWantToBeInGarbage_Value Lisp2D_countStackClusterWantToBeInGarbage_Value
size_t  countStackClusterWantToBeInGarbage_Value ( void  ) ;
# define  countStackClusterWantToBeInGarbage_Inc  Lisp2D_countStackClusterWantToBeInGarbage_Inc
void  countStackClusterWantToBeInGarbage_Inc  ( void  ) ;
# define  countStackClusterWantToBeInGarbage_Dec  Lisp2D_countStackClusterWantToBeInGarbage_Dec
void  countStackClusterWantToBeInGarbage_Dec  ( void  ) ;
# define  countExtraThreads2Value Lisp2D_countExtraThreads2Value
size_t  countExtraThreads2Value ( void  ) ;
# define  countExtraThreads2_Inc  Lisp2D_countExtraThreads2_Inc
void  countExtraThreads2_Inc  ( void  ) ;
# define  countExtraThreads2_Dec  Lisp2D_countExtraThreads2_Dec
void  countExtraThreads2_Dec  ( void  ) ;
# define  runpthcount_Value Lisp2D_runpthcount_Value
int runpthcount_Value ( void  ) ;
# define  runpthcount_Inc Lisp2D_runpthcount_Inc
void  runpthcount_Inc ( void  ) ;
# define  runpthcount_Dec Lisp2D_runpthcount_Dec
void  runpthcount_Dec ( void  ) ;

# define  maxCountThreads Lisp2D_maxCountThreads
extern  unsigned  int maxCountThreads ;

// ! to _Atomic(bool) ?
# define  flagManagerWaitSignal Lisp2D_flagManagerWaitSignal
extern  volatile bool flagManagerWaitSignal ;

struct  Lisp2D_s_StackClusterPrivate  ;

# define  IsConst Lisp2D_IsConst
bool  IsConst ( struct  Lisp2D_s_StackClusterPrivate * , ParaLispObject * x  ) ;

# define  gcobjects2  Lisp2D_gcobjects2
extern  size_t    gcobjects2  ;

enum  { Lisp2D_maxListItemProcessing = 30000U } ;
# define  maxListItemProcessing Lisp2D_maxListItemProcessing

# define  maxTasksCreate  Lisp2D_maxTasksCreate
extern  unsigned  int maxTasksCreate  ;

// ! to _Atomic(bool) ?
# define  flagdeletetzname02 Lisp2D_flagdeletetzname02
  extern  volatile  bool    flagdeletetzname02 ;
  // ! to _Atomic(bool) ?
# define  flagdeletetzname12 Lisp2D_flagdeletetzname12
  extern  volatile  bool    flagdeletetzname12 ;

  // ! to _Atomic(bool) ?
# define  allowgc Lisp2D_allowgc
    // transparrency is 80%
  extern  volatile  bool  allowgc ;

  // ! to _Atomic(bool) ?
# define  flagStopToGC  Lisp2D_flagStopToGC
extern  volatile  bool  flagStopToGC  ;

# ifdef  LISP2D_DEBUG
// ! to use innerhistory  
# define  debugGCRunning  Lisp2D_debugGCRunning
  extern  volatile  bool  debugGCRunning  ;
# endif  

// ! to _Atomic(bool) ?
# define  flagThreadsShutDown Lisp2D_flagThreadsShutDown
extern  volatile  bool flagThreadsShutDown ;

# include "parray.h"

PArrayStruct  ( ParaLispObject * , PLOP )
# define  PArrayPLOP  Lisp2DPArrayPLOP
  
# define  ListOfPLO  Lisp2DListOfPLO
  
// ! to make struct PointerToArrayOfPLOP{ParaLispObject * (*arr)[ ]};
  
ParaLispObject * ListOfPLO ( PArray ( PLOP ) ) ;

# include "stcl/classc.h"

# define  SetProp2  Lisp2D_SetProp2
// !? remove argument stcl
void  SetProp2  ( ParaLispObject *  , ParaLispObject  * , ParaLispObject  * ,
  ParaLispObject  * , StackClusterPrivate * ) ;

# define  GetPropVector Lisp2D_GetPropVector
ParaLispObject  * GetPropVector ( ParaLispObject  * , ParaLispObject  * ) ;

// ? using it ?
# define  GetPropPair Lisp2D_GetPropPair
ParaLispObject  * GetPropPair ( ParaLispObject  const * , ParaLispObject  const * ,
  ParaLispObject  * , StackClusterPrivate  * ) ;

# define  ClassGetStatic  Lisp2D_ClassGetStatic
  ParaLispObject  * ClassGetStatic  ( ParaLispObject const * ) ;

# define    ClassGetVars  Lisp2D_ClassGetVars
ParaLispObject  * ClassGetVars  ( ParaLispObject const * ) ;

# define  ClassGetMethods Lisp2D_ClassGetMethods
ParaLispObject  * ClassGetMethods ( ParaLispObject  const * ) ;

# define  ClassGetParents Lisp2D_ClassGetParents
ParaLispObject  * ClassGetParents ( ParaLispObject  const * ) ;

# ifdef LISP2D_BIMSTAT

# include "statisticsp.h"

# define  IncreaseStat5 Lisp2D_IncreaseStat5
void  IncreaseStat5  ( struct timespec  const * start  , struct  timespec  const * end , struct Lisp2DStatistics  * ) ;

# endif // LISP2D_BIMSTAT

# ifndef  LISP2D_DONTUSEX11

# include "window.h"

# define  isBADColorsCharsFromObjectOrList  Lisp2D_isBADColorsCharsFromObjectOrList
bool  isBADColorsCharsFromObjectOrList(ParaLispObject  *listornumberp, tUCharRGB *, StackClusterPrivate * ) ;

# endif // LISP2D_DONTUSEX11
  
// ones starting in main()
# define  Constr  Lisp2D_Constr
StackClusterPrivate  * Constr  ( void ) ;

# define  IsConstLockGC Lisp2D_IsConstLockGC
bool  IsConstLockGC ( StackClusterPrivate  * , ParaLispObject * x  ) ;

# define  HasConstLink  Lisp2D_HasConstLink
  void  HasConstLink  ( StackClusterPrivate  * , ParaLispObject * x  ) ;
  
# include "deque/type-byte.h"
  
# define  isBADWCharPushToByteDeque Lisp2D_isBADWCharPushToByteDeque
// wchar -> bytedeque += {codes}
bool  isBADWCharPushToByteDeque ( wchar_t i , Deque ( Byte ) * y ) ;

# include "string/type.h"

# define  BadString Lisp2D_BadString
void  BadString ( StackClusterPrivate  * , PLOStringPub  * x  ) ;

# ifdef  LISP2D_BIMSTAT

# define  CalcDT  Lisp2D_CalcDT
long  double  CalcDT  (struct timespec start, struct  timespec end) ;

# endif

# define  bindefclassForMain  Lisp2D_bindefclassForMainvVJ3
void  bindefclassForMain  ( StackClusterPrivate * ) ;

# include "charstring/type.h"

// wchar_t const* -> String(Char)
# define  isBADReadWCharToCharString  Lisp2D_isBADReadWCharToCharString
bool  isBADReadWCharToCharString  ( wchar_t volatile const * , String ( Char ) * ) ;

# define  isBADReadWCharArrayToByteDeque  Lisp2D_isBADReadWCharArrayToByteDeque
// wchar_t[] -> bytedeque
bool  isBADReadWCharArrayToByteDeque ( wchar_t volatile const * , Deque ( Byte )  * )  ;

# include "stat/type.h"
# define  array_mode_symbol_size  Lisp2D_array_mode_symbol_size
enum { array_mode_symbol_size  = 12 } ;
# include "stat/struct.h"
# define  arrayp_mode_symbol Lisp2D_arrayp_mode_symbol
extern  ModePLOSymbolP const ( * const arrayp_mode_symbol ) [ ] ;

# define  InitArrayModeSymbol Lisp2D_InitArrayModeSymbol
void  InitArrayModeSymbol ( void  ) ;

// string -> wstring
# define  isBADReadStringToOneWChar Lisp2D_isBADReadStringToOneWChar
bool  isBADReadStringToOneWChar ( char  const * xend ,
  char  const * * i1 , wchar_t * const yp ) ;

# include "widestring.h"
  
// string -> wstring
# define  isBADReadCStringToWString2  Lisp2D_isBADReadCStringToWString2
bool  isBADReadCStringToWString2 ( String ( Char ) const * ,
  String ( WideChar ) * ) ;
  
# define  memsetv Lisp2D_memsetv
void volatile * memsetv ( void volatile * const s , int const c , size_t n  ) ;

# define  frees Lisp2D_frees
void  frees ( void  volatile  * const s , int const c , size_t  n ) ;

# include "map.h"

// -- treeSymbolsLess --

LISP2DMAPCOMPTYPE ( treeSymbolsLessType , PLOSymbol * )
LISP2DMAPNODETYPE ( treeSymbolsLessType )
LISP2DMAPNODE ( treeSymbolsLessType , PLOSymbol * , uint8_t )
LISP2DMAPSTACKTYPE  ( treeSymbolsLessType )
LISP2DMAPSTACK  ( treeSymbolsLessType )
LISP2DMAPPUB  ( treeSymbolsLessType )
LISP2DMAPPRI  ( treeSymbolsLessType , PLOSymbol * )

# define  treeSymbols_pub Lisp2D_treeSymbols_pub
extern  MapPub  ( treeSymbolsLessType ) * const treeSymbols_pub ;

// # define  treeSymbols_fun  Lisp2D_treeSymbols_fun
// int treeSymbols_fun  ( PLOSymbol const * , PLOSymbol const * ) ;

LISP2DPROTOSTACKPUSHBYVALUE ( StackMapNodetreeSymbolsLessType , MapNode ( treeSymbolsLessType ) )
LISP2DPROTOSTACKPUSHATVALUE ( StackMapNodetreeSymbolsLessType , MapNode ( treeSymbolsLessType ) )
LISP2DMAPPUBFINDPROTO ( treeSymbolsLessType , PLOSymbol * )
LISP2DPROTOSTACKCAT ( StackMapNodetreeSymbolsLessType , MapNode ( treeSymbolsLessType ) )
LISP2DMAPPUBINSERTPROTO ( treeSymbolsLessType )
inline  LISP2DDECLAREMAPSTACKINIT ( treeSymbolsLessType )
inline  LISP2DPRIFROMMAPPUBPROTO ( treeSymbolsLessType )
inline  LISP2DMAPPUBINITDECLARE ( treeSymbolsLessType )
LISP2DPROTOSTACKPUSHFRONTVALUE  ( StackMapNodetreeSymbolsLessType , MapNode ( treeSymbolsLessType ) )
LISP2DPROTOSTACKAT ( StackMapNodetreeSymbolsLessType , MapNode ( treeSymbolsLessType ) )
LISP2DPROTOMAPSTACKDESTR ( treeSymbolsLessType )
LISP2DMAPPUBDESTRPROTO ( treeSymbolsLessType )
LISP2D_PROTO_MAP_STACK_FREE  ( treeSymbolsLessType )
inline  LISP2DCONSTPRIFROMMAPPUBPROTO ( treeSymbolsLessType )
LISP2DMAPPUBSIZEDECL ( treeSymbolsLessType )
LISP2DMAPPUBCATDECL ( treeSymbolsLessType )
LISP2DPROTOSTACKCLEAR ( StackMapNodetreeSymbolsLessType )
LISP2DMAPPUBCLEARDECLARE ( treeSymbolsLessType )

// -- setTypeSymbolName --

LISP2DMAPCOMPTYPE ( setTypeSymbolNameType , uint8_t )
LISP2DMAPNODETYPE ( setTypeSymbolNameType )
LISP2DMAPNODE ( setTypeSymbolNameType , uint8_t , PLOSymbol * )
LISP2DMAPSTACKTYPE  ( setTypeSymbolNameType )
LISP2DMAPSTACK  ( setTypeSymbolNameType )
LISP2DMAPPUB  ( setTypeSymbolNameType )
LISP2DMAPPRI  ( setTypeSymbolNameType , uint8_t )

# define  setTypeSymbolNameType_pub Lisp2D_setTypeSymbolNameType_pub
extern  MapPub  ( setTypeSymbolNameType ) * const setTypeSymbolNameType_pub ;

# define  setTypeSymbolName_fun  Lisp2D_setTypeSymbolName_fun
int setTypeSymbolName_fun  ( uint8_t , uint8_t ) ;

LISP2DPROTOSTACKPUSHBYVALUE ( StackMapNodesetTypeSymbolNameType , MapNode ( setTypeSymbolNameType ) )
LISP2DPROTOSTACKPUSHATVALUE ( StackMapNodesetTypeSymbolNameType , MapNode ( setTypeSymbolNameType ) )
LISP2DMAPPUBFINDPROTO ( setTypeSymbolNameType , uint8_t )
LISP2DPROTOSTACKCAT ( StackMapNodesetTypeSymbolNameType , MapNode ( setTypeSymbolNameType ) )
LISP2DMAPPUBINSERTPROTO ( setTypeSymbolNameType )

inline  LISP2DDECLAREMAPSTACKINIT ( setTypeSymbolNameType )
inline  LISP2DPRIFROMMAPPUBPROTO ( setTypeSymbolNameType )
inline  LISP2DMAPPUBINITDECLARE ( setTypeSymbolNameType )
LISP2DPROTOSTACKPUSHFRONTVALUE ( StackMapNodesetTypeSymbolNameType , MapNode ( setTypeSymbolNameType ) )
LISP2DPROTOSTACKAT ( StackMapNodesetTypeSymbolNameType , MapNode ( setTypeSymbolNameType ) )
LISP2DPROTOMAPSTACKDESTR ( setTypeSymbolNameType )
LISP2D_PROTO_MAP_STACK_FREE ( setTypeSymbolNameType )
LISP2DMAPPUBDESTRPROTO ( setTypeSymbolNameType )
inline  LISP2DCONSTPRIFROMMAPPUBPROTO ( setTypeSymbolNameType )
LISP2DMAPPUBSIZEDECL ( setTypeSymbolNameType )
LISP2DMAPPUBCATDECL ( setTypeSymbolNameType )
inline  LISP2DPROTOSTACKCLEAR ( StackMapNodesetTypeSymbolNameType )
inline  LISP2DMAPPUBCLEARDECLARE ( setTypeSymbolNameType )

// -- seterrnotosymbol --
LISP2DMAPCOMPTYPE ( errnotosymbol , int )
LISP2DMAPNODETYPE ( errnotosymbol )
LISP2DMAPNODE ( errnotosymbol , int , PLOSymbol * )
LISP2DMAPSTACKTYPE  ( errnotosymbol )
LISP2DMAPSTACK  ( errnotosymbol )
LISP2DMAPPUB  ( errnotosymbol )
LISP2DMAPPRI  ( errnotosymbol , int )

# define  seterrnotosymbol_pub Lisp2D_seterrnotosymbol_pub
extern  MapPub  ( errnotosymbol ) * const seterrnotosymbol_pub ;

# define  seterrnotosymbol_fun  Lisp2D_seterrnotosymbol_fun
int seterrnotosymbol_fun  ( int , int ) ;

LISP2DPROTOSTACKPUSHBYVALUE ( StackMapNodeerrnotosymbol , MapNode ( errnotosymbol ) )
LISP2DPROTOSTACKPUSHATVALUE ( StackMapNodeerrnotosymbol , MapNode ( errnotosymbol ) )
LISP2DMAPPUBFINDPROTO ( errnotosymbol , int )
LISP2DPROTOSTACKCAT ( StackMapNodeerrnotosymbol , MapNode ( errnotosymbol ) )
LISP2DMAPPUBINSERTPROTO ( errnotosymbol )

inline  LISP2DDECLAREMAPSTACKINIT ( errnotosymbol )
inline  LISP2DPRIFROMMAPPUBPROTO ( errnotosymbol )
inline  LISP2DMAPPUBINITDECLARE ( errnotosymbol )
LISP2DPROTOSTACKPUSHFRONTVALUE ( StackMapNodeerrnotosymbol , MapNode ( errnotosymbol ) )
LISP2DPROTOSTACKAT ( StackMapNodeerrnotosymbol , MapNode ( errnotosymbol ) )
LISP2DPROTOMAPSTACKDESTR ( errnotosymbol )
LISP2DMAPPUBDESTRPROTO ( errnotosymbol )
LISP2D_PROTO_MAP_STACK_FREE ( errnotosymbol )
inline  LISP2DCONSTPRIFROMMAPPUBPROTO ( errnotosymbol )
LISP2DMAPPUBSIZEDECL ( errnotosymbol )
LISP2DMAPPUBCATDECL ( errnotosymbol )
inline  LISP2DPROTOSTACKCLEAR ( StackMapNodeerrnotosymbol )
inline  LISP2DMAPPUBCLEARDECLARE ( errnotosymbol )

# include "listplo/type.h"

# define  list_global_atomsc Lisp2D_list_global_atomsc
extern  Lisp2D_List ( PLO ) * const list_global_atomsc  ;

typedef struct  Lisp2D_functionboolcharp  functionboolcharp ;

enum  {
  type_functionisBADReadStringToOneWChar  = 0 ,
  type_functionisBADReadCharToWChar
} ;

typedef bool  ( * functionboolcharp_Funp  ) ( functionboolcharp  * , char  * ) ;
  
extern  functionboolcharp_Funp  functionboolcharp_arr_Funp  [ ] ;

struct  Lisp2D_functionboolcharp {
  int type  ;
} ;

bool  functionboolcharp_Fun ( functionboolcharp  * p , char  * cp ) ;
void  functionboolcharp_Init  ( functionboolcharp * me , int t ) ;

# define  isBADReadWCharUniversal Lisp2D_isBADReadWCharUniversal
bool  isBADReadWCharUniversal ( char  FirstByte  ,
  functionboolcharp * isBADNextByte , wchar_t * wcharResultp ) ;
  
bool  functionisBADReadStringToOneWChar_Fun ( functionboolcharp  * , char  * ) ;

typedef struct  functionisBADReadCharToWChar  functionisBADReadCharToWChar  ;
  
# include "streamc.h"

struct  functionisBADReadCharToWChar  {
  functionboolcharp base  ;
  StreamType metype  ;
  Stream * sp ;
} ;

functionisBADReadCharToWChar * fromFunctionboolcharpToFunctionisBADReadCharToWChar ( functionboolcharp * p ) ;

void  functionisBADReadCharToWChar_Init ( functionisBADReadCharToWChar * ,
  StreamType const metype0 , Stream * s ) ;
      
bool  functionisBADReadCharToWChar_Fun ( functionboolcharp  * , char  * ) ;  
  
# ifdef LISP2D_DEBUG
  extern  size_t  Lisp2D_statMallocPLOComplexPri  ;
  extern  size_t  Lisp2D_statFreePLOComplexPri  ;
  extern  size_t  Lisp2D_statMallocPLOCons  ;
  extern  size_t  Lisp2D_statFreePLOCons  ;
# endif
  
# include "stcl/inline.h"

# endif // LISP2D_SHAREDC_H
