// Signal
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_SIGNALL_H
# define  LISP2D_SIGNALL_H
# include "define.h"
# include <stddef.h> // size_t

# ifdef  LISP2D_CONSTRSTAT

# include <stdlib.h>
  # define  PLOSignal_constrstat  Lisp2D_PLOSignal_constrstat
  extern  _Atomic ( size_t ) PLOSignal_constrstat  ;
# define  PLOSignal_constrstat_Value  Lisp2D_PLOSignal_constrstat_Value
size_t  PLOSignal_constrstat_Value  ( void ) ;

# define  PLOSignal_constrstat_Inc  Lisp2D_PLOSignal_constrstat_Inc
void  PLOSignal_constrstat_Inc  ( void ) ;

# endif // LISP2D_CONSTRSTAT

# include "plo/struct.h"

# define  PLOSignal_staticClassDef  Lisp2D_PLOSignal_staticClassDef
ParaLispObject  * PLOSignal_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOSignal_staticClassParents  Lisp2D_PLOSignal_staticClassParents
ParaLispObject  * PLOSignal_staticClassParents  ( ParaLispObject const * ) ;

# define  PLOSignal_staticTypeOf  Lisp2D_PLOSignal_staticTypeOf
ParaLispObject  * PLOSignal_staticTypeOf ( ParaLispObject const * _ ) ;

# define  s_PLOSignal Lisp2D_s_PLOSignal
# define  PLOSignal Lisp2D_PLOSignal

# include "queue-voidp.h"
# include "mutex2/type.h"
# include "mutex2/struct.h"

typedef struct  s_PLOSignal PLOSignal ;

struct  s_PLOSignal {
  ParaLispObject  plo ;
  size_t  sended ;
  Queue ( VoidP ) stclpqueueC ;
  Mutex2  mutexc  ;
} ;

# define  PLOSignal_Destr Lisp2D_PLOSignal_Destr
void  PLOSignal_Destr ( PLOSignal * ) ;
  
# define  PLOSignal_Init  Lisp2D_PLOSignal_Init
void  PLOSignal_Init ( PLOSignal * ) ;

# include "plostream/type.h"

# define  PLOSignal_staticCoutToInterpret Lisp2D_PLOSignal_staticCoutToInterpret
void  PLOSignal_staticCoutToInterpret ( ParaLispObject const * ,
  PLOStream  const * , bool   , Vector  ( StackPLOP ) * )  ;
  
# define  PLOSignal_staticCoutToHuman Lisp2D_PLOSignal_staticCoutToHuman
void  PLOSignal_staticCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;
  
# define  PLOSignal_staticisBADCopyPrivate  Lisp2D_PLOSignal_staticisBADCopyPrivate
bool  PLOSignal_staticisBADCopyPrivate ( ParaLispObject const * , ParaLispObject  * * resultp  ) ;
  
# define  PLOSignal_Send  Lisp2D_PLOSignal_Send
void  PLOSignal_Send  ( PLOSignal * ) ;
  
# include "stcl/classc.h"

# define  PLOSignal_isOkGetSignal Lisp2D_PLOSignal_isOkGetSignal
bool  PLOSignal_isOkGetSignal ( PLOSignal * , StackClusterPrivate * ) ;
  
# define  ParaLispObjectToPLOSignal Lisp2DParaLispObjectToPLOSignal
inline  PLOSignal * ParaLispObjectToPLOSignal ( ParaLispObject * const p ) {
  return (  PLOSignal * ) ( p  ->  vaddr . addr . p ) ;
}

# define  PLOSignal_staticDestr Lisp2D_PLOSignal_staticDestr
void PLOSignal_staticDestr  ( ParaLispObject * ) ;

# define  Signalp Lisp2D_Signalp
inline  bool  Signalp ( ParaLispObject const * const xp  ) {
  return  ParaLispObject_Type ( xp  ) ==  TypeGlobalListMemberPLOSignal ;
}
  
# define  IsNotSignal Lisp2D_IsNotSignal
bool  IsNotSignal ( StackClusterPrivate  * , ParaLispObject  * ) ;

# define  bimsignalsend Lisp2Dbimsignalsend2
FuncBining  bimsignalsend ;

# define  bimsignalwait Lisp2Dbimsignalwait2
FuncBining  bimsignalwait ;

# define  bimnilsignalp Lisp2Dbimnilsignalp2
FuncBining  bimnilsignalp ;

# include "stcl/inline.h"

# endif // LISP2D_SIGNALL_H
