// Lisp2D - Socket internet server/user inline's body
// ©2023 by Alex Glebe
# ifndef  LISP2D_SOCKET_INLINE_H
# define  LISP2D_SOCKET_INLINE_H

inline  bool  SocketP ( ParaLispObject const * const xp  ) {
  return  ParaLispObject_Type ( xp  ) ==  TypeGlobalListMemberPLOSocket ;
}

# include "socket/private.h"

inline  void  PLOSocket_SetType ( PLOSocket * const me , int const x ) {
  PLOSocketPriFromPub ( me  ) -> intDomainType  = x  ;
}

inline  void  PLOSocket_SetDescriptor ( PLOSocket * const me , int const x ) {
  PLOSocketPriFromPub ( me  ) -> descriptor  = x ;
}

inline  void  PLOSocket_ClearDescriptor ( PLOSocket * const me ) {
  PLOSocketPriFromPub ( me  ) -> descriptor = - 1 ;
}

inline  void  PLOSocket_SetUSIntDomain  ( PLOSocket * const me , unsigned short int const x  ) {
  PLOSocketPriFromPub ( me  ) -> usintdomain  = x  ;
}

inline  unsigned  short int PLOSocket_USIntDomain ( PLOSocket const * const me ) {
  return PLOSocketCPriFromCPub  ( me  ) -> usintdomain  ;
}

inline  int PLOSocket_Descriptor  ( PLOSocket const * const me ) {
  return PLOSocketCPriFromCPub  ( me  ) -> descriptor ;
}

inline  PLOSocket const * ParaLispObjectToPLOSocketConst ( ParaLispObject const * const p ) {
  return p  ->  vaddr . addr . p ;
}

inline  PLOSocket * ParaLispObjectToPLOSocket ( ParaLispObject * const p ) {
  return p  ->  vaddr . addr . p ;
}

# include "socket/inlinepri.h"

# endif // LISP2D_SOCKET_INLINE_H
