// Socket private
// ©2023 by Alex Glebe

# ifndef  LISP2D_SOCKET_PRIVATE_H
# define  LISP2D_SOCKET_PRIVATE_H

# include "socket/type.h"

# define  PLOSocket_Destr Lisp2D_PLOSocket_Destr
void  PLOSocket_Destr ( PLOSocketPri  * me  ) ;

# include <netdb.h> // struct protoent

# define  ProtoEntToList  Lisp2D_ProtoEntToList
// returns list(number name alias .. alias) or nil  
ParaLispObject  * ProtoEntToList(struct protoent  * const strprot2p, StackClusterPrivate * const stclp ) ;
  
# define  bimsocketread22 Lisp2D_bimsocketread22
// socket read #[buf] [size [{string-flag}]]
// returns byte-received | string
TaskForThread bimsocketread22(StackClusterPrivate  * const stclpp , void  * * bufp ) ;

# define  bimsocketopen22 Lisp2D_bimsocketopen22
void bimsocketopen22(StackClusterPrivate * const stclpp ,int cie, wchar_t const * * wc) ;

# define  bimsocketclose22  Lisp2D_bimsocketclose22
void   bimsocketclose22( StackClusterPrivate  * stclpp , wchar_t const * * wc,int intErrnoClose) ;

# define  isBADWriteAnalyseMode Lisp2D_isBADWriteAnalyseMode
bool  isBADWriteAnalyseMode(StackClusterPrivate * , ParaLispObject * listModep, int  * flagsp)  ;
  
# include "socket/structpri.h"

# define  PLOSocketPriFromPub Lisp2D_PLOSocketPriFromPub
inline PLOSocketPri * PLOSocketPriFromPub ( PLOSocket * ) ;
# define  PLOSocketCPriFromCPub Lisp2D_PLOSocketCPriFromCPub
inline PLOSocketPri const * PLOSocketCPriFromCPub ( PLOSocket const * ) ;

# include "deque/type-byte.h"

# define  voidp_cast_dequebytep Lisp2D_voidp_cast_dequebytep
inline  Deque ( Byte  ) * voidp_cast_dequebytep ( void * ) ;

# endif // LISP2D_SOCKET_PRIVATE_H
