// Lisp2D - Socket internet server/user
// ©2015-23 by Alex Glebe
# ifndef  LISP2D_SOCKET_PUBLIC_H
# define  LISP2D_SOCKET_PUBLIC_H

# include "plostream/type.h"

# define  PLOSocket_staticCoutToHuman Lisp2D_PLOSocket_staticCoutToHuman
void  PLOSocket_staticCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector(StackPLOP)  * h ) ;

# define  PLOSocket_staticCoutToInterpret Lisp2D_PLOSocket_staticCoutToInterpret
void  PLOSocket_staticCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector(StackPLOP)  * h ) ;

# include <arpa/inet.h> // SOMAXCONN
  
// Maximum queue length specifiable by listen.  
# define  Lisp2D_SocketMaxConnections SOMAXCONN
# define  SocketMaxConnections  Lisp2D_SocketMaxConnections

# include "taskforthread.h" // FuncBining
  
FuncBining Lisp2Dbimnilsocketp2   ;  
FuncBining Lisp2Dbimnilopenprotoent2  ;
  FuncBining Lisp2Dbimnilcloseprotoent2   ;
  FuncBining Lisp2Dbimnilgetprotoent2   ;
    FuncBining  Lisp2Dbimsocketsocket2   ;
  FuncBining  Lisp2Dbimsocketopen2   ;
  FuncBining  Lisp2Dbimsocketclose2  ;
  FuncBining  Lisp2Dbimsocketconnect2  ;
  FuncBining  Lisp2Dbimsocketbind  ;
  FuncBining  Lisp2Dbimsocketlisten  ;
  FuncBining  Lisp2Dbimsocketaccept2   ;
  FuncBining  Lisp2Dbimsocketread2   ;
  FuncBining  Lisp2Dbimsocketwrite2  ;
  FuncBining Lisp2Dbimconssocketselect   ;
  FuncBining Lisp2Dbimnilsocketselect  ;
  FuncBining Lisp2Dbimsocketdescriptor   ;

# define  PLOSocket_staticTypeOf  Lisp2D_PLOSocket_staticTypeOf
ParaLispObject  * PLOSocket_staticTypeOf ( ParaLispObject const *  ) ;
  
# define  PLOSocket_staticClassDef  Lisp2D_PLOSocket_staticClassDef
ParaLispObject  * PLOSocket_staticClassDef  ( ParaLispObject const *  ) ;
  
# define  PLOSocket_staticClassParents  Lisp2D_PLOSocket_staticClassParents
ParaLispObject  * PLOSocket_staticClassParents  ( ParaLispObject const *  ) ;  

# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# define  PLOSocket_constrstat  Lisp2D_PLOSocket_constrstat
extern  _Atomic ( size_t  ) PLOSocket_constrstat ;

# define  PLOSocket_constrstatValue Lisp2D_PLOSocket_constrstatValue
size_t  PLOSocket_constrstatValue ( void  ) ;

# define  PLOSocket_constrstatInc Lisp2D_PLOSocket_constrstatInc
void  PLOSocket_constrstatInc ( void  ) ;

# endif // LISP2D_CONSTRSTAT

# define  PLOSocket_staticDestr Lisp2D_PLOSocket_staticDestr
void PLOSocket_staticDestr  ( ParaLispObject * me ) ;

# define  SocketP Lisp2D_SocketP
inline  bool  SocketP ( ParaLispObject const * ) ;
# define  IsNotSocket Lisp2D_IsNotSocket
bool  IsNotSocket ( StackClusterPrivate  * , ParaLispObject * ) ;

# include "socket/type.h"

# define  PLOSocket_SetType Lisp2D_PLOSocket_SetType
inline  void  PLOSocket_SetType ( PLOSocket * , int ) ;
# define  PLOSocket_SetDescriptor Lisp2D_PLOSocket_SetDescriptor
inline  void  PLOSocket_SetDescriptor ( PLOSocket * , int ) ;
# define  PLOSocket_ClearDescriptor Lisp2D_PLOSocket_ClearDescriptor
inline  void  PLOSocket_ClearDescriptor ( PLOSocket * ) ;
# define  PLOSocket_SetUSIntDomain  Lisp2D_PLOSocket_SetUSIntDomain
inline  void  PLOSocket_SetUSIntDomain  ( PLOSocket * , unsigned short int ) ;
# define  PLOSocket_USIntDomain Lisp2D_PLOSocket_USIntDomain
inline  unsigned  short int PLOSocket_USIntDomain ( PLOSocket const * ) ;
# define  PLOSocket_Descriptor  Lisp2D_PLOSocket_Descriptor
inline  int PLOSocket_Descriptor  ( PLOSocket const * ) ;
# define  ParaLispObjectToPLOSocketConst Lisp2DParaLispObjectToPLOSocketConst
inline  PLOSocket const * ParaLispObjectToPLOSocketConst ( ParaLispObject const * ) ;
# define  ParaLispObjectToPLOSocket Lisp2DParaLispObjectToPLOSocket
inline  PLOSocket * ParaLispObjectToPLOSocket ( ParaLispObject * ) ;
# define  PLOSocket_InitD Lisp2D_PLOSocket_InitD
void  PLOSocket_InitD ( PLOSocket * , int ) ;
# define  PLOSocket_Init  Lisp2D_PLOSocket_Init
void PLOSocket_Init ( PLOSocket * ) ;

# define  PLOSocket_isBADConnectPort  Lisp2D_PLOSocket_isBADConnectPort
bool  PLOSocket_isBADConnectPort  ( PLOSocket * me ,
  uint16_t  port  , wchar_t volatile const * addr, int  * localerrorp , int * intErrorp ) ;

# define  PLOSocket_isBADConnectPath  Lisp2D_PLOSocket_isBADConnectPath
bool  PLOSocket_isBADConnectPath ( PLOSocket * me ,
  wchar_t volatile const * addr , int  * localerrorp , int  * aierrorp ) ;

# endif // LISP2D_SOCKET_PUBLIC_H
