// Lisp2D - Stack (small OR great)
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_STACKDEFINE_H
# define  LISP2D_STACKDEFINE_H

# include <stdio.h>
# include <wchar.h>
# include <stddef.h> // size_t
# include <string.h> // memcpy
# include <locale.h>
# include <stdlib.h>  // realloc
# include <iso646.h>  // and_eq ...
# include <setjmp.h>
# include <stdint.h> // SIZE_MAX
# include <stdbool.h>
# include "excc.h"
    
//# pragma  GCC warning "to increase alone to alone[2]"
//# pragma  GCC warning "to add isvalid , isconst , ismove"
//# pragma  GCC warning "memorysize to data . alone to : uint8_t alone[sizeof(STACKT)] , no operator= only memcpy.
// Big code only one for all."

// x.ismove = true ;
// to make Construct(&me,&x) => me{std::move(x)}
// to Destructor(&x) twice
    
// ! to make struct Iterator : with * ++ --

/* if size == 0 or 1 then alone \
     else heap.data = memory with memorysize >= 2 \
     memorysize/4 < size <= memorysize */    
    
// ! to add bool live

// ! to directory : type struct public private .. .h

# define  LISP2DSTACKSTRUCTTYPE(  STACKN  ) \
  typedef struct sVector  ( STACKN  ) Vector  ( STACKN  ) ; \
  typedef struct  VectorPrivate ( STACKN  ) VectorP ( STACKN  ) ;

# define LISP2DSTACKSTRUCT(  STACKN  , STACKT  ) \
struct  VectorPrivate ( STACKN  ) { \
  union { \
    struct {  \
      STACKT * data ; \
      size_t  memorysize ; \
    } heap ;  \
    STACKT  alone ; \
  } val ; \
  size_t  size ;  \
  bool  flagsecure  ; \
} ; \
struct sVector  ( STACKN  ) {  \
  struct  VectorPrivate ( STACKN  ) privat ; \
} ; \
inline  STACKT const * VectorCFront  ( STACKN  ) ( Vector  ( STACKN  )  const * const me ) { \
  struct  VectorPrivate ( STACKN  ) const * const s = & ( me -> privat ) ; \
  return (  ( s -> size >= 2UL )  ? \
    ( s ->  val . heap  . data  ) : \
    ( & ( s ->  val . alone ) ) ) ; \
}  \
inline  STACKT * VectorFront  ( STACKN  ) ( Vector  ( STACKN  ) * const s ) { \
  struct  VectorPrivate ( STACKN  ) * const mep = & ( s -> privat ) ; \
  return  ( mep->size >= 2UL ) ? (    mep->val.heap. data  ) :  \
    & mep->val.alone ; \
}  \
inline  STACKT const * VectorCBegin  ( STACKN  ) ( Vector ( STACKN  ) const * const s ) { \
  struct  VectorPrivate(STACKN) const * const mep = & ( s -> privat ) ; \
  return (( mep->size >= 2UL )  ? mep->val.heap.data  : (& mep->val.alone)); \
} \
inline  STACKT * VectorBegin  ( STACKN  ) ( Vector  ( STACKN  )  * const s ) { \
  struct  VectorPrivate(STACKN) * const mep = & ( s -> privat ) ; \
  return  (( mep->size >= 2UL ) ? mep->val.heap.data  : (& mep->val.alone)) ; \
}  \
inline  size_t  VectorSizeCopy  ( STACKN  )  ( Vector  ( STACKN  ) const * const s ) { \
  return s -> privat.size ; \
} \
inline  size_t const  * VectorSizeLink  ( STACKN  ) ( Vector  ( STACKN  ) const * const s ) { \
  return & (  s ->  privat  . size  ) ; \
} \
inline  bool  VectorEmpty ( STACKN  ) ( Vector  ( STACKN  ) const * const s ) { \
  return (  s ->  privat  . size ==  0  ) ; \
} \
/* for Garbage Collection purpose */ \
inline  size_t  Vector_MemorySizeCopy ( STACKN  ) ( Vector  ( STACKN  ) const * const s ) { \
  if  ( s ->  privat  . size >= 2 ) \
    return s -> privat  . val . heap  . memorysize ; \
  return  1 ; \
}
  
# define  Lisp2DVector( STACKN  ) Lisp2DVector  ##  STACKN  ##  Ttbz
# define  Vector  Lisp2DVector

# define  Lisp2D_VectorP( STACKN  ) Lisp2D_VectorP_  ##  STACKN
# define  VectorP  Lisp2D_VectorP

# define  Lisp2D_sVector( STACKN  ) Lisp2D_sVector_  ##  STACKN
# define  sVector  Lisp2D_sVector

# define  Lisp2DVectorPrivate( STACKN  ) Lisp2D ##  STACKN  ##  PrivatewxL4
# define  VectorPrivate  Lisp2DVectorPrivate
  
# define  Lisp2DVectorCFront( STACKN  ) Lisp2D_  ##  STACKN  ##  _CFront
# define  VectorCFront  Lisp2DVectorCFront  
  
# define  Lisp2DVectorFront( STACKN  ) Lisp2D ##  STACKN  ##  Front
# define  VectorFront  Lisp2DVectorFront
  
# define  Lisp2DVectorCBegin( STACKN  ) Lisp2D_  ##  STACKN  ##  _CBegin
# define  VectorCBegin  Lisp2DVectorCBegin  
  
# define  Lisp2DVectorBegin( STACKN  ) Lisp2D ##  STACKN  ##  Begin
# define  VectorBegin  Lisp2DVectorBegin
  
# define  Lisp2DVectorSizeCopy( STACKN  ) Lisp2D  ##  STACKN  ##  SizeCopy
# define  VectorSizeCopy  Lisp2DVectorSizeCopy
  
# define  Lisp2DVectorSizeLink( STACKN  ) Lisp2D  ##  STACKN  ##  SizeLink
# define  VectorSizeLink  Lisp2DVectorSizeLink
  
# define  Lisp2DVectorEmpty( STACKN  ) Lisp2D ##  STACKN  ##  Empty
# define  VectorEmpty  Lisp2DVectorEmpty

# define  Lisp2D_Vector_MemorySizeCopy( STACKN  ) \
  Lisp2D_ ##  STACKN  ## _MemorySizeCopy
# define  Vector_MemorySizeCopy  Lisp2D_Vector_MemorySizeCopy

# define  Lisp2DVectorInit(STACKN)  Lisp2D  ##  STACKN  ##  InithAPk
# define  VectorInit  Lisp2DVectorInit
  
# define LISP2DDECLARESTACKCONSTRUCTORDEFAULT( STACKN   )  \
void VectorInit ( STACKN  ) ( Vector  ( STACKN  ) * , bool ) ;

# define LISP2DSTACKCONSTRUCTORDEFAULT( STACKN   )  \
void VectorInit ( STACKN  ) ( Vector  ( STACKN  ) * const me  , bool const flagsecure ) { \
  struct  VectorPrivate ( STACKN  ) * const mep = & ( me -> privat ) ; \
  mep -> size = 0UL ; \
  mep -> flagsecure = flagsecure ; \
}

# define  Lisp2DVectorInitOne(  STACKN  )  Lisp2D ##  STACKN  ##  InitOnejmne
# define  VectorInitOne  Lisp2DVectorInitOne  
  
# define LISP2DDECLARESTACKCONSTRONE( STACKN  , STACKT )  \
void VectorInitOne  ( STACKN  ) ( Vector  ( STACKN  ) * , STACKT , bool )  ;
  
# define LISP2DSTACKCONSTRONE( STACKN  , STACKT )  \
void VectorInitOne  ( STACKN  ) ( Vector  ( STACKN  ) * const me , STACKT const x , bool const flagsecure ) { \
  struct  VectorPrivate ( STACKN  ) * const mep = & ( me -> privat ) ; \
  mep -> val . alone = x ; \
  mep -> size = 1UL ; \
  mep -> flagsecure = flagsecure ; \
}

# define  Lisp2DVectorInitMove( STACKN  )  Lisp2D  ##  STACKN  ##  InitMoved4NC
# define  VectorInitMove  Lisp2DVectorInitMove
  
# define LISP2DDECLARESTACKCONSTRUCTORMOVE( STACKN  , STACKT )  \
void  VectorInitMove(  STACKN  )  ( Vector ( STACKN  ) * to , Vector  ( STACKN  ) * from ) ;

# define LISP2DSTACKCONSTRUCTORMOVE( STACKN  , STACKT )  \
void  VectorInitMove ( STACKN  ) ( Vector  ( STACKN  ) * const restrict to , \
  Vector  ( STACKN  ) * const restrict from ) { \
  if ( to == from ) \
    return  ; \
  struct  VectorPrivate ( STACKN  ) * const restrict mep = & ( to -> privat ) ; \
  struct  VectorPrivate ( STACKN  ) * const restrict xp = & ( from -> privat ) ; \
  mep -> size = xp -> size ;  \
  xp  ->  size  = 0UL ; \
  if  ( mep ->  size  >=  2UL  ) { \
    mep ->  val . heap  . memorysize = xp ->  val . heap  . memorysize ; \
    xp ->  val . heap  . memorysize = 0 ; \
    mep ->  val . heap  . data = xp ->  val . heap  . data ; \
    xp ->  val . heap  . data = 0 ; \
  } else \
    if ( mep  ->  size == 1UL ) \
      mep ->  val . alone = xp  ->  val . alone ; \
  mep ->  flagsecure = xp -> flagsecure ; \
}

# define  Lisp2DVectorBackCopy( STACKN  )  Lisp2D  ##  STACKN  ##  BackCopy7qXs
# define  VectorBackCopy  Lisp2DVectorBackCopy
  
# define LISP2DPROTOSTACKBACKCOPY( STACKN  , STACKT )  \
STACKT  VectorBackCopy( STACKN  )  ( Vector ( STACKN  ) const * )  ;
    
# define LISP2DSTACKBACKCOPY( STACKN  , STACKT )  \
STACKT  VectorBackCopy(STACKN) ( Vector(STACKN) const * const me ) { \
  struct  VectorPrivate(STACKN) const * const mep = & ( me -> privat ) ; \
  return *  ( ( ( mep -> size >= 2UL )  ? mep -> val . heap  . data  :  \
    ( & mep -> val . alone ) ) + ( mep -> size ) - 1UL ) ; \
}

# define  Lisp2DVectorCEnd(STACKN)  Lisp2D  ##  STACKN  ##  CEndjqwU
# define  VectorCEnd  Lisp2DVectorCEnd
  
# define LISP2DPROTOSTACKCEND( STACKN  , STACKT )  \
STACKT const * VectorCEnd(STACKN) ( Vector(STACKN)  const * ) ;  

# define LISP2DSTACKCEND( STACKN  , STACKT )  \
STACKT const * VectorCEnd ( STACKN  ) ( Vector  ( STACKN  ) const * const me ) { \
  struct  VectorPrivate ( STACKN  ) const * const mep = & ( me -> privat ) ; \
  return ( ( mep -> size >= 2UL ) ? \
    mep -> val . heap . data :  \
    ( & mep -> val . alone ) ) + (mep -> size ) ; \
}

# define  Lisp2D_Vector_FrontCopy(  STACKN  ) Lisp2D ##  STACKN  ##  FrontCopy
# define  Vector_FrontCopy  Lisp2D_Vector_FrontCopy

# define LISP2DPROTOSTACKFRONTCOPY( STACKN  , STACKT )  \
STACKT  Vector_FrontCopy ( STACKN ) ( Vector ( STACKN )  const * ) ;
  
# define LISP2DSTACKFRONTCOPY( STACKN  , STACKT )  \
STACKT  Vector_FrontCopy ( STACKN ) ( Vector  ( STACKN  )  const * const me ) { \
  struct  VectorPrivate(STACKN) const * const mep = & ( me -> privat ) ; \
  if ( mep  ->  size >= 2UL ) \
    return * mep ->  val.heap.data ;  \
  return mep  ->  val.alone ; \
}

# define  Lisp2DVectorAtCopy( STACKN  )  Lisp2D ##  STACKN  ##  AtCopy
# define  VectorAtCopy  Lisp2DVectorAtCopy

# define LISP2DPROTOSTACKATCOPY( STACKN  , STACKT )  \
STACKT  VectorAtCopy ( STACKN ) ( Vector  ( STACKN  ) const * , size_t  ) ;
  
# define LISP2DSTACKATCOPY( STACKN  , STACKT )  \
STACKT  VectorAtCopy ( STACKN )  ( Vector  ( STACKN  )  const * const me , size_t  const i ) { \
  struct  VectorPrivate ( STACKN  ) const * const mep = & ( me -> privat ) ; \
  if ( i >= mep  ->  size ) { \
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & \
      L"VectorAtCopy:i >= mep  ->  size" ; \
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
  } \
  return  ( ( mep -> size >= 2UL )  ? \
    mep ->  val . heap  . data  : \
    ( & mep ->  val . alone ) ) [ i ] ; \
}

# define  Lisp2DVectorAt( STACKN  ) Lisp2D  ##  STACKN  ##  At
# define  VectorAt  Lisp2DVectorAt

# define LISP2DPROTOSTACKAT( STACKN  , STACKT )  \
STACKT  * VectorAt  ( STACKN  ) ( Vector  ( STACKN  ) * , size_t )  ;
  
# define LISP2DSTACKAT( STACKN  , STACKT )  \
STACKT  * VectorAt  ( STACKN  )  ( Vector ( STACKN  ) * const s  , size_t  const i ) { \
  struct  VectorPrivate ( STACKN  ) * const mep = & ( s -> privat ) ; \
  if ( i >= mep  ->  size ) { \
    Lisp2DExceptionStringGlobal . str = (wchar_t const(*)[])& \
      L"VectorAt:i >= mep  ->  size" ; \
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
  } \
  return  ( ( mep ->  size >= 2UL ) ? \
    mep ->  val . heap  . data  : \
    ( & mep ->  val . alone ) )  + i  ; \
}

# define  Lisp2D_Vector_Pop(  STACKN  ) Lisp2D_Vector_  ##  STACKN  ##  _Pop
# define  VectorPop  Lisp2D_Vector_Pop
  
# define LISP2DPROTOSTACKPOP( STACKN )  \
void  VectorPop ( STACKN  ) ( Vector  ( STACKN  ) * ) ;  
  
# define LISP2DSTACKPOP( STACKN  , STACKT , VOLAT )  \
void  VectorPop ( STACKN  ) ( Vector  ( STACKN  ) * const s ) {  \
  struct  VectorPrivate ( STACKN  ) * const mep = & ( s -> privat ) ; \
  if  ( ( mep ->  size  ) >= 3UL  ) { \
    --  ( mep ->  size  ) ; \
    if  ( ( ( mep ->  size  ) <<  2U ) <=  (mep->val.heap.memorysize)  ) { \
      size_t  newmems ;  \
      if  ( ( mep ->  size  ) ==  2UL  )  \
        newmems = 3UL ;  \
      else \
        newmems = ( ( mep ->  size  ) <<  1U  ) ; \
      { STACKT VOLAT * const datanew = realloc ( ( STACKT * ) ( mep ->  val . heap  . data ) , \
          sizeof  ( STACKT  )  * newmems  ) ; \
        if  ( not datanew ) \
          return ; \
        mep ->  val . heap  . data = datanew  ; \
      } \
      mep ->  val . heap  . memorysize  = newmems ; \
    } \
    return ; \
  } \
  if  ( mep ->  size  ==  2UL ) { \
    { STACKT VOLAT const last = * ( mep ->  val . heap  . data  ) ; \
      Vector_Free ( STACKN ) ( mep ) ; \
      mep ->  val . alone = last ; \
    } \
    mep ->  size = 1UL ; \
    return ; \
  } \
  mep ->  size  = 0UL ; \
}

# define  Lisp2DVectorClear(  STACKN  ) Lisp2D  ##  STACKN  ##  Clear
# define  VectorClear Lisp2DVectorClear

# define  LISP2DPROTOSTACKCLEAR(  STACKN  ) \
void  VectorClear ( STACKN ) ( Vector ( STACKN  ) * ) ;
  
# define  LISP2DSTACKCLEAR(  STACKN , STACKT ) \
void  VectorClear ( STACKN ) ( Vector ( STACKN  ) * const s ) { \
  struct  VectorPrivate ( STACKN  ) * const mep = & ( s -> privat ) ; \
  if  ( mep ->  size >= 2UL )  \
    Vector_Free ( STACKN ) ( mep ) ; \
  mep -> size = 0UL  ; \
}  

// ! to make Move ?

# define  Lisp2D_Vector_Swap( STACKN  ) Lisp2D  ##  STACKN  ##  Swap
# define  Vector_Swap Lisp2D_Vector_Swap
  
# define  LISP2DPROTOSTACKSWAP(  STACKN , STACKT ) \
void  Vector_Swap ( STACKN ) ( Vector  ( STACKN  ) *  , Vector  ( STACKN  ) * ) ;
  
# define  LISP2DSTACKSWAP(  STACKN , STACKT ) \
void  Vector_Swap ( STACKN  ) ( Vector  ( STACKN  ) * const sx , \
  Vector  ( STACKN  ) * const sy  ) { \
  struct  VectorPrivate ( STACKN  ) * const x = & sx -> privat ; \
  struct  VectorPrivate ( STACKN  ) * const y = & sy -> privat ; \
  if  ( x not_eq y  ) { \
    if  ( x -> size >= 2UL )  { \
      if  ( y -> size >= 2UL )  { \
        { STACKT * const  tmpdata = y -> val  . heap  . data ; \
          y -> val  . heap  . data  = x -> val  . heap  . data  ; \
          x -> val  . heap  . data = tmpdata  ; \
        } \
        { size_t const  tmpmemsize = y -> val . heap  . memorysize ; \
          y -> val  . heap  . memorysize = x -> val . heap  . memorysize  ; \
          x -> val  . heap  . memorysize = tmpmemsize ; \
        } \
      } else { \
        STACKT const  yval = y ->  val . alone ; \
        y -> val  . heap  . data  = x -> val  . heap  . data ;  \
        y -> val  . heap  . memorysize  = x -> val  . heap  . memorysize ; \
        x ->  val . alone = yval ; \
      } \
    } else { \
      if( y -> size >= 2UL )  { \
        STACKT const  xval = x  ->  val . alone ; \
        x -> val  . heap  . data  = y -> val  . heap  . data ;  \
        x -> val  . heap  . memorysize  = y -> val  . heap  . memorysize ; \
        y ->  val . alone = xval ; \
      } else { \
        if  ( x -> size == 1UL  ) { \
          if  ( y -> size == 1UL  ) { \
            STACKT const  xval = x  ->  val . alone ; \
            x ->  val . alone = y ->  val . alone ; \
            y ->  val . alone = xval ; \
          } else \
            y ->  val . alone = x ->  val . alone ; \
        } else  \
          if  ( y -> size == 1UL  ) \
            x ->  val . alone = y ->  val . alone ; \
      } \
    } \
    size_t const  tmpsize = y -> size ; \
    y -> size = x -> size ;  \
    x -> size = tmpsize ; \
  } \
}
  
# define  Lisp2D_Vector_Destr(  STACKN  ) Lisp2D_Vector_  ##  STACKN  ##  _Destr
# define  Vector_Destr Lisp2D_Vector_Destr
  
# define  LISP2DPROTOSTACKDESTRUCTOR(  STACKN  ) void Vector_Destr ( STACKN  ) ( Vector  ( STACKN  ) * )  ;

# define  Vector_secure_byte  Lisp2D_Vector_secure_byte
enum  { Vector_secure_byte  = 0xff } ;

# define  LISP2DSTACKDESTRUCTOR(  STACKN , STACKT ) \
void  Vector_Destr  ( STACKN  ) ( Vector  ( STACKN  ) * const me  ) { \
  VectorP ( STACKN  ) * const s = & ( me -> privat ) ; \
  if  ( s ->  size >= 2UL ) \
    Vector_Free ( STACKN ) ( s ) ; \
  if  ( s -> flagsecure  ) \
    memsetv ( s , Vector_secure_byte , sizeof ( * s ) ) ; \
}

# define  Lisp2D_Vector_Free(  STACKN  ) Lisp2D_Vector_  ##  STACKN  ##  _Free
# define  Vector_Free Lisp2D_Vector_Free

# define  LISP2D_PROTO_STACK_FREE(  STACKN  ) void Vector_Free ( STACKN  ) ( VectorP  ( STACKN  ) * )  ;

# define  LISP2D_STACK_FREE(  STACKN , STACKT ) \
void  Vector_Free ( STACKN  ) ( VectorP  ( STACKN  ) * const s ) { \
  if  ( s -> flagsecure  ) \
    frees ( s  ->  val . heap  . data , Vector_secure_byte  , s ->  val . heap  . memorysize  * sizeof  ( STACKT  ) ) ; \
  else  \
    free  ( ( STACKT * ) ( s ->  val . heap  . data ) ) ; \
}

# define  Lisp2D_Vector_Resize1(  STACKN  ) Lisp2D  ##  STACKN  ##  Resize1
# define  Vector_Resize1  Lisp2D_Vector_Resize1
    
# define LISP2DPROTOSTACKRESIZE1(  STACKN  )  \
void  Vector_Resize1  ( STACKN  ) ( Vector(STACKN) * ) ;
  
# define LISP2DSTACKRESIZE1(  STACKN  , STACKT , VOLAT )  \
void  Vector_Resize1  ( STACKN  ) ( Vector  ( STACKN  ) * const me ) { \
  struct  VectorPrivate ( STACKN  ) * const s = & ( me -> privat ) ; \
  switch  ( s ->  size  ) { \
  case 0UL : \
    s ->  size = 1U ; \
    return ; \
  case 1UL : \
    return ; \
  default : \
    { STACKT VOLAT  const tmp = * (  s ->  val . heap  . data  ) ; \
      Vector_Free ( STACKN ) ( s ) ; \
      s ->  val . alone = tmp ; \
    } \
    s ->  size = 1UL ; \
  } \
}

# define  Lisp2D_Vector_Resize(  STACKN  ) Lisp2D ##  STACKN  ##  Resize_ExcMem
# define  Vector_Resize  Lisp2D_Vector_Resize
  
# define LISP2DPROTOSTACKRESIZE(  STACKN  )  \
void  Vector_Resize ( STACKN  ) ( Vector  ( STACKN  ) * , size_t ) ;
  
# define LISP2DSTACKRESIZE(  STACKN  , STACKT , VOLAT )  \
void  Vector_Resize ( STACKN  ) ( Vector  ( STACKN  ) * const me , size_t const  newsize ) { \
  struct  VectorPrivate ( STACKN  ) * const s = & ( me -> privat ) ; \
  switch  ( newsize ) {  \
  case  0 : \
    Lisp2D  ##  STACKN  ##  Clear ( me ) ;  \
    return; \
  case  1 :  \
    if  ( s ->  size == 0UL ) {  \
      s ->  size = 1U ;  \
      return ; \
    } \
    if  ( s ->  size == 1UL )  \
      return ; \
    { STACKT VOLAT const  tmp = * ( s ->  val.heap.data ) ;  \
      Vector_Free ( STACKN ) ( s ) ; \
      s ->  val . alone = tmp ; \
    } \
    s ->  size = 1UL ; \
    return ; \
  default :  \
    if ( ( SIZE_MAX / sizeof  ( STACKT ) ) < newsize ) {  \
      Lisp2DExcOutOfMemoryGlobal . value =  \
        L"Vector_Resize:( SIZE_MAX / sizeof  ( STACKT ) ) < newsize" ; \
      longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
    } \
    bool flagdouble ; \
    if ( ( ( SIZE_MAX / sizeof  ( STACKT ) ) >> 1U ) < newsize )  \
      flagdouble = false ; \
    else \
      flagdouble = true ; \
    if ( s  ->  size == 0 ) {  \
      { STACKT  VOLAT * const datanew = aligned_alloc ( _Alignof  ( STACKT  ) , \
          ( flagdouble ? \
            ( ( sizeof ( STACKT ) * newsize  ) * 2 ) : \
            ( sizeof ( STACKT ) * newsize ) ) ) ; \
        if  ( not datanew ) { \
          Lisp2DExcOutOfMemoryGlobal . value = L"Vector_Resize:1.aligned_alloc" ; \
          longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
        } \
        s ->  val . heap  . data  = datanew ; \
      } \
      s ->  val . heap  . memorysize  = ( flagdouble ? \
        ( newsize << 1U ) : \
        newsize ) ;  \
      s ->  size  = newsize ; \
      return ; \
    } \
    if ( s  ->  size == 1UL ) {  \
      { STACKT VOLAT const tmp = s  ->  val  . alone ;  \
        { STACKT  VOLAT * const datanew = aligned_alloc ( _Alignof  ( STACKT  ) , \
            ( flagdouble ? \
              ( ( sizeof ( STACKT ) * newsize  ) * 2 ) : \
              ( sizeof ( STACKT ) * newsize ) ) ) ; \
          if  ( not datanew ) {  \
            Lisp2DExcOutOfMemoryGlobal . value = L"Vector_Resize:2.aligned_alloc" ; \
            longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
          } \
          s ->  val . heap  . data  = datanew ; \
        } \
        * ( s ->  val . heap  . data ) = tmp ; \
      } \
      s ->  val . heap  . memorysize  = ( flagdouble ? \
        ( newsize << 1U ) : \
        newsize ) ;  \
      s ->  size  = newsize ; \
      return ; \
    } \
    if  ( s ->  val . heap  . memorysize < newsize  ) { \
      { STACKT VOLAT * const  datanew = realloc  ( ( STACKT * ) ( s ->  val . heap  . data ) ,  \
          flagdouble ? \
          ( ( sizeof  ( STACKT  ) * newsize )  <<  1U ) : \
          ( sizeof  ( STACKT ) * newsize ) ) ; \
        if  ( not datanew ) {  \
          Lisp2DExcOutOfMemoryGlobal . value = L"Vector_Resize:1.realloc" ; \
          longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
        } \
        s ->  val . heap  . data  = datanew ; \
      } \
      s ->  size  = newsize ;  \
      s ->  val . heap  . memorysize  = ( flagdouble ?  \
        ( newsize  <<  1U  ) : \
        newsize ) ; \
      return  ; \
    } \
    if  ( s ->  val . heap  . memorysize < (  newsize  <<  2U  ) ) {  \
      s->size  = newsize ;  \
      return ; \
    } \
    /*  newsize * 4 <= memorysize < size * 4 */ \
    { STACKT VOLAT * const  datanew = realloc  ( ( STACKT * ) ( s ->  val . heap  . data ) , \
        flagdouble ? \
        ( ( sizeof  ( STACKT  ) * newsize )  <<  1U ) : \
        ( sizeof  ( STACKT ) * newsize ) ) ; \
      if  ( datanew == NULL ) { \
        Lisp2DExcOutOfMemoryGlobal . value = L"Vector_Resize:2.realloc" ; \
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
      } \
      s ->  val . heap  . data  = datanew ; \
    } \
    s ->  size  = newsize ; \
    s ->  val . heap  . memorysize  = ( flagdouble ?  \
      ( newsize  <<  1U  ) : \
      newsize ) ; \
  } \
}

# define  Lisp2D_Vector_ResizeFill(  STACKN  ) \
  Lisp2D_ ##  STACKN  ##  _ResizeFill
# define  Vector_ResizeFill  Lisp2D_Vector_ResizeFill
  
# define LISP2DPROTOSTACKRESIZEFILL(  STACKN  , STACKT  )  \
void  Vector_ResizeFill ( STACKN  ) ( Vector  ( STACKN  ) * , size_t , STACKT ) ;
  
# define LISP2DSTACKRESIZEFILL(  STACKN  , STACKT  )  \
void  Vector_ResizeFill ( STACKN  ) ( Vector  ( STACKN  ) * const me , \
  size_t const newsize , STACKT const val ) { \
  struct  VectorPrivate ( STACKN  ) * const s = & ( me -> privat ) ; \
  size_t  const oldsize = s -> size ; \
  Vector_Resize ( STACKN  ) ( me , newsize ) ;  \
  if ( newsize > oldsize ) { \
    if ( newsize == 1 ) \
      s -> val . alone = val ; \
    else  { \
      STACKT  * i = s ->  val . heap  . data  + oldsize ; \
      STACKT const * e = s ->  val . heap  . data  + newsize ; \
      do { \
        * i = val ; \
        ++  i ; \
      } while ( i not_eq e ) ; \
    } \
  } \
}

// ! doesn't check array limit

# define  Vector_EltAddr( STACKN  ) Lisp2D_  ##  STACKN  ##  _EltAddr
  
# define LISP2DPROTOSTACKELTADDR(  STACKN  , STACKT )  \
STACKT *  Vector_EltAddr  ( STACKN  ) ( Vector ( STACKN  ) * , size_t ) ;
  
# define LISP2DSTACKELTADDR(  STACKN  , STACKT )  \
STACKT *  Vector_EltAddr  ( STACKN  ) ( Vector  ( STACKN  ) * const me ,  \
  size_t  const index ) { \
  struct  VectorPrivate ( STACKN  ) * const s = & ( me -> privat ) ; \
  if ( s  ->  size <= 1UL ) \
    return  & s ->  val . alone  ; \
  return  ( s ->  val . heap  . data  ) + index ; \
}

# define  Vector_CEltAddr( STACKN  ) Lisp2D_  ##  STACKN  ##  _CEltAddr
  
# define LISP2DPROTOSTACKCELTADDR(  STACKN  , STACKT )  \
STACKT const * Vector_CEltAddr  ( STACKN  ) ( Vector ( STACKN  ) const * , size_t ) ;
  
# define LISP2DSTACKCELTADDR(  STACKN  , STACKT )  \
STACKT const *  Vector_CEltAddr  ( STACKN  ) ( Vector  ( STACKN  ) const * const me ,  \
  size_t  const index ) { \
  struct  VectorPrivate ( STACKN  ) const * const s = & ( me -> privat ) ; \
  if ( s  ->  size <= 1UL ) \
    return  & s ->  val . alone  ; \
  return  ( s ->  val . heap  . data  ) + index ; \
}

# define  Vector_EltCopy( STACKN  ) Lisp2D  ##  STACKN  ##  EltCopy
  
# define LISP2DPROTOSTACKELTCOPY(  STACKN  , STACKT )  \
STACKT Vector_EltCopy( STACKN  ) ( Vector(STACKN) const * , size_t ) ;
  
# define LISP2DSTACKELTCOPY(  STACKN  , STACKT )  \
STACKT Vector_EltCopy( STACKN  ) ( Vector(STACKN) const * const me ,  \
  size_t const index ) { \
  struct  VectorPrivate(STACKN) const * const s = ( & ( me -> privat ) ) ; \
  if ( s->size <= 1UL ) \
    return s->val . alone  ; \
  return ( * ( (s->val.heap.data)  + index  ) ) ; \
}

# define LISP2DPROTOSTACKREPLACETOPBYVALUE( STACKN  , STACKT  )  \
void  Lisp2D  ##  STACKN  ##  ReplaceTopByValue  (Vector(STACKN) * , STACKT ) ;  
  
# define LISP2DSTACKREPLACETOPBYVALUE( STACKN  , STACKT  )  \
void  Lisp2D  ##  STACKN  ##  ReplaceTopByValue  ( Vector  ( STACKN  ) * const me  , STACKT x ) { \
  struct  VectorPrivate(STACKN) * const s = ( & ( me -> privat ) ) ; \
  if ( s->size <= 1UL ) \
    s->val . alone = x ; \
  else \
    s->val.heap.data  [ (s->size) - 1UL  ] = x ; \
}
    
# define  Lisp2D_Vector_ReplaceTopByValue(  STACKN  ) \
  Lisp2D  ##  STACKN  ##  ReplaceTopByValue
# define  Vector_ReplaceTopByValue  Lisp2D_Vector_ReplaceTopByValue

# define  Lisp2D_Vector_PushByValue(  STACKN  ) \
 Lisp2D  ##  STACKN  ##  PushByValue
# define  Vector_PushByValue  Lisp2D_Vector_PushByValue

# define LISP2DPROTOSTACKPUSHBYVALUE(  STACKN  , STACKT  )  \
void  Vector_PushByValue ( STACKN  ) ( Vector ( STACKN  ) * , STACKT ) ;
  
# define LISP2DSTACKPUSHBYVALUE(  STACKN  , STACKT , VOLAT )  \
void  Vector_PushByValue ( STACKN  ) ( Vector ( STACKN  ) * const me , STACKT VOLAT const  x ) { \
  struct  VectorPrivate ( STACKN  ) * const s = & ( me -> privat ) ; \
  if  ( s ->  size  == 0UL ) \
    s ->  val . alone = x ;  \
  else { \
    if ( s  ->  size == 1UL ) { \
      { STACKT  VOLAT * const datanew = aligned_alloc ( _Alignof  ( STACKT  ) , sizeof  ( STACKT  ) * 4 ) ; \
        if  ( not datanew ) { \
          Lisp2DExcOutOfMemoryGlobal . value =  \
            L"Lisp2D_Vector_PushByValue:aligned_alloc:datanew == NULL" ; \
          longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
        } \
        ( * datanew ) = s ->  val . alone ; \
        s ->  val . heap  . data = datanew  ; \
      } \
      ( * ( s ->  val . heap  . data + 1UL ) ) = x ; \
      s ->  val . heap  . memorysize  = 4UL ; \
    } else { \
      if  ( s ->  size ==  s  ->  val . heap  . memorysize ) { \
        /* 2/2 -> 3/6 \
          3/3 -> 4/8 */ \
        size_t  news = ( s  ->  size + 1UL  ) <<  1U ; \
        if  ( news < s  ->  val . heap  . memorysize ) { \
          /* may be impossible */ \
          news  = s ->  val . heap  . memorysize + 1UL ;  \
          if  ( news  ==  0 ) /* may be impossible */ { \
            Lisp2DExcOutOfMemoryGlobal . value = \
              L"Lisp2D_Vector_PushByValue:news  ==  0" ; \
            longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
          } \
        } \
        { STACKT VOLAT * const  datanew = realloc ( ( STACKT * ) ( s ->  val . heap  . data ) , \
            sizeof  ( STACKT  )  * news ) ; \
          if  ( datanew == NULL ) { \
            Lisp2DExcOutOfMemoryGlobal . value =  \
              L"Lisp2D_Vector_PushByValue:realloc:datanew == NULL" ; \
            longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
          } \
          s ->  val . heap  . data = datanew  ; \
        } \
        s ->  val . heap  . memorysize  = news  ; \
      }  \
      s ->  val . heap  . data  [ s ->  size  ] = x ; \
    } \
  } \
  ++  ( s  ->  size ) ; \
}
  
# define LISP2DPROTOSTACKSET(  STACKN  , STACKT  )  \
void  Lisp2D  ##  STACKN  ##  Set ( Vector(STACKN) * , Vector(STACKN) const * ) ;
  
# define LISP2DSTACKSET(  STACKN  , STACKT , VOLAT )  \
void  Lisp2D  ##  STACKN  ##  Set ( Vector ( STACKN  ) * const restrict me , \
  Vector  ( STACKN  ) const * const restrict x ) { \
  if  ( me ==  x )  \
    return ; \
  VectorP ( STACKN  ) * const restrict s = & ( me -> privat ) ; \
  VectorP ( STACKN  ) const * const restrict xs = & ( x -> privat ) ; \
  bool  flagmakenew = false ; \
  bool  flagfreedata = false ; \
  if  ( s ->  size >= 2UL ) { \
    if  ( xs -> size >= 2UL ) { \
      if  ( ( xs -> size  > s->val.heap.memorysize  ) or \
        ( ( xs -> size <<  2U ) <= s->val.heap.memorysize  ) ) { \
        flagmakenew = true  ; \
        flagfreedata = true ; \
      } \
    } else  { \
      /* x is empty or alone */  \
      Vector_Free ( STACKN ) ( s ) ; \
      if ( xs -> size == 1UL ) {  \
        s ->  val . alone = xs  ->  val . alone ; \
        s ->  size  = 1U  ; \
      } else \
        s ->  size  = 0UL ; \
      return ; \
    } \
  } else { \
    /* this is empty or alone */  \
    if  ( xs -> size  == 0UL) { \
      s ->  size = 0UL;  \
      return ;  \
    } \
    if  ( xs -> size  == 1UL) { \
      s ->  val . alone = xs -> val . alone ; \
      s ->  size  = 1UL ; \
      return ; \
    } \
    flagmakenew = true  ; \
  } \
  if  ( flagmakenew ) {  \
    size_t  newsize = ( xs -> size  ) * 2 ; \
    if  ( newsize  < xs -> size )  /* may be impossible */ \
      newsize = xs -> size ; \
TryAgain0 :  \
    if ( ( SIZE_MAX / sizeof  ( STACKT ) ) < newsize ) { \
      if  ( newsize <= xs -> size ) { \
        Lisp2DExcOutOfMemoryGlobal . value = L"Lisp2D_Vector_Set:very big size" ; \
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
      } \
      newsize = xs -> size ; \
      goto TryAgain0 ; \
    } \
    STACKT VOLAT * newdata ; \
TryAgain :  \
    newdata = aligned_alloc ( _Alignof  ( STACKT  ) , sizeof  ( STACKT  ) * newsize ) ; \
    if  ( not newdata) { \
      if  ( newsize <= xs ->  size  ) { \
        Lisp2DExcOutOfMemoryGlobal . value =  \
          L"Lisp2D_Vector_Set:aligned_alloc ( sizeof  ( STACKT  )  * newsize )" ; \
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
      } \
      newsize = xs -> size ; \
      goto TryAgain ; \
    } \
    if  ( flagfreedata  ) \
      Vector_Free ( STACKN ) ( s ) ; \
    s ->  val . heap  . data = newdata ; \
    s ->  val . heap  . memorysize = newsize ; \
  } \
  memcpy  ( ( STACKT * ) ( s ->  val . heap  . data ) , ( STACKT * ) ( xs -> val . heap  . data ) , \
    sizeof  ( STACKT  ) * ( xs -> size  ) ) ; \
  s ->  size  = xs -> size ; \
}

# define  Lisp2DVectorSet(  STACKN  ) Lisp2D  ##  STACKN  ##  Set
# define  VectorSet Lisp2DVectorSet

# define  Lisp2D_Vector_PopValue( STACKN  ) Lisp2D  ##  STACKN  ##  PopValue
# define  Vector_PopValue Lisp2D_Vector_PopValue

# define LISP2DPROTOSTACKPOPVALUE( STACKN  , STACKT  )  \
STACKT  Lisp2D  ##  STACKN  ##  PopValue  ( Vector(STACKN) * ) ;
  
// pop & returns rvalue was top
# define LISP2DSTACKPOPVALUE( STACKN  , STACKT  )  \
STACKT  Lisp2D  ##  STACKN  ##  PopValue  ( Vector(STACKN) * const me ) {  \
  struct  VectorPrivate(STACKN) * s = ( & ( me -> privat ) ) ; \
  if  ( s->size > 2UL  ) { \
    -- (s->size) ; \
    STACKT  result = (  (s->val.heap.data)  [ s->size ] ) ; \
    /* ! if first take result then : ask for <  \
     ! if take result later : ask for <=  \
     size >= 1 */ \
    if  ( ( (s->size)  <<  2U ) <=  (s->val.heap.memorysize)  ) { \
      /* /4 = protection from next Push \
       /2 = half an array */  \
      /* 2/8 -> 2/4 \
       3/12 -> 3/6 */ \
      size_t  newmems = ( (s->size) <<  1U  ) ; \
      /* make small place for an array */ /* wait for another chance */ \
      { STACKT *  const datanew = realloc ( ( STACKT  * ) ( s  ->  val . heap  . data ) , sizeof  ( STACKT  )  * newmems ) ; \
        if  ( datanew ) { \
          s ->  val . heap  . data = datanew  ; \
          s ->  val . heap  . memorysize  = newmems ; \
        } \
      } \
    } \
    return  result ; \
  } \
  if  ( s->size == 2UL ) {  \
    /* will be one */   \
    STACKT const result = (  * ( s->val.heap.data + 1UL ) ) ;  \
    { STACKT const last = ( * ( s ->  val . heap  . data  ) ) ; \
      Vector_Free ( STACKN ) ( s ) ; \
      s ->  val . alone  = last ; \
    } \
    s->size  = 1UL ;  \
    return  result ; \
  } \
  if  ( s->size == 1UL ) \
    /* was last */   \
    s ->  size  = 0 ; \
  return  s ->  val . alone ; \
}

# define  Lisp2D_Vector_PopToSize(  STACKN  ) Lisp2D  ##  STACKN  ##  PopToSize
# define  Vector_PopToSize  Lisp2D_Vector_PopToSize

# define LISP2DPROTOSTACKPOPTOSIZE(  STACKN  , STACKT  )  \
void  Vector_PopToSize ( STACKN ) ( Vector ( STACKN  ) * me , size_t newsize ) ;
  
# define LISP2DSTACKPOPTOSIZE(  STACKN  , STACKT  )  \
void  Vector_PopToSize ( STACKN ) ( Vector ( STACKN  ) * const me , size_t const newsize  ) { \
  VectorP ( STACKN  ) * s = & ( me -> privat ) ; \
  if  ( newsize  ==  0UL  ) { \
    if  ( s ->  size  ==  0UL )  \
      return  ; \
    if  ( s ->  size  >=  2UL )  \
      Vector_Free ( STACKN ) ( s ) ; \
    s ->  size  = 0UL ;  \
    return  ; \
  } \
  if  ( newsize > s ->  size ) { \
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & \
      L"Lisp2D_Vector_PopToSize: newsize > s ->  size" ; \
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
  } \
  if  ( newsize  ==  1UL  ) { \
    if  ( s ->  size  ==  1UL )  \
      return  ; \
    { STACKT const last = * ( s  ->  val . heap  . data  ) ;  \
      Vector_Free ( STACKN ) ( s ) ; \
      s ->  val . alone  = last ; \
    } \
    s ->  size  = 1UL ;  \
    return  ; \
  } \
  if  ( s ->  val . heap  . memorysize >= ( newsize  <<  2U  ) ) { \
    /* 1/4 -> 1/2 \
     2/8 -> 2/3 \
     3/12 -> 3/6 */ \
    size_t  memsizenew = ( newsize  <<  1U  ) ; \
    STACKT * datanew  ; \
TryAgain  : \
    datanew = realloc ( s->val.heap.data , \
      sizeof  ( STACKT  )  * memsizenew  ) ; \
    if ( datanew == NULL ) { \
      if  ( memsizenew > newsize ) { \
        memsizenew = newsize ; \
        goto TryAgain ; \
      } \
/* ! to agree for big memory allocation ? */  \
      Lisp2DExcOutOfMemoryGlobal . value = L"Lisp2D_Vector_PopToSize:" ; \
      longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
    } \
    s ->  val . heap  . data  = datanew ;  \
    s ->  val . heap  . memorysize  = memsizenew ; \
  } \
  s ->  size  = newsize ; \
}  

# define  Lisp2D_Vector_ConstrCopy( STACKN  ) Lisp2D  ##  STACKN  ##  ConstructorCopy
# define  Vector_ConstrCopy Lisp2D_Vector_ConstrCopy

// ! to remove

# define  Lisp2DVectorConstrCopy( STACKN  ) Lisp2D  ##  STACKN  ##  ConstructorCopy
# define  VectorConstrCopy Lisp2DVectorConstrCopy

// ^ to remove

# define LISP2DPROTOSTACKCONSTRUCTORCOPY(  STACKN )  \
void  Lisp2D  ##  STACKN  ##  ConstructorCopy ( \
  Vector  ( STACKN  ) * , Vector  ( STACKN  ) const * ) ;
  
# define LISP2DSTACKCONSTRUCTORCOPY(  STACKN  , STACKT  )  \
void  Lisp2D  ##  STACKN  ##  ConstructorCopy ( Vector  ( STACKN  ) * const me , \
  Vector  ( STACKN  ) const *  const x ) { \
  struct  VectorPrivate ( STACKN  ) *  const s = & ( me -> privat ) ; \
  struct  VectorPrivate ( STACKN  ) const *  const xs = & ( x -> privat ) ; \
  s ->  size = xs ->  size ; \
  s ->  flagsecure = xs ->  flagsecure ; \
  if  ( s ->  size  ==  0UL  ) \
    return ;  \
  if  ( s ->  size  ==  1UL  ) { \
    s ->  val . alone = xs  ->  val . alone ; \
    return ; \
  } \
  size_t newmemsize = s ->  size *  2 ; \
TryAgain : \
  s ->  val . heap  . data  = aligned_alloc ( _Alignof  ( STACKT  ) , sizeof  ( STACKT  ) * newmemsize ) ; \
  if  ( not s ->  val . heap  . data ) { \
    if  ( newmemsize > s  ->  size ) { \
      newmemsize = s  ->  size ; \
      goto  TryAgain ; \
    } \
    s ->  size = 0 ; \
    Lisp2DExcOutOfMemoryGlobal . value = L"Lisp2DStackConstructorCopy:" ; \
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
  } \
  s ->  val . heap  . memorysize = newmemsize ; \
  memcpy  ( ( STACKT * ) ( s ->  val . heap  . data ) , ( STACKT * ) ( xs  -> val  . heap  . data ) , \
    s ->  size * sizeof ( STACKT  ) ) ; \
}
  
# define LISP2DPROTOSTACKISEQ( STACKN  , STACKT  )  \
bool  Lisp2D  ##  STACKN  ##  isEq ( Vector(STACKN) const * , Vector(STACKN) const * ) ;
  
# define LISP2DSTACKISEQ( STACKN  , STACKT  )  \
bool  Lisp2D  ##  STACKN  ##  isEq ( Vector ( STACKN  ) const * const me , \
  Vector  ( STACKN  ) const * const x ) { \
  if ( me == x ) \
    return true ; \
  struct  VectorPrivate ( STACKN  ) const * const s = ( & ( me -> privat ) ) ; \
  struct  VectorPrivate ( STACKN  ) const * const xs = ( & ( x -> privat ) ) ; \
  if  ( s->size not_eq  (  xs -> size  ) ) \
    return  false ;  \
  if  ( s->size == 0UL ) \
    return true ; \
  if ( s->size == 1UL ) \
    return memcmp  ( ( STACKT * ) ( &  s ->  val . alone ) , ( STACKT * ) ( & xs -> val.alone ) , \
      sizeof ( STACKT  ) ) ==  0  ; \
  return  memcmp  ( ( STACKT * ) ( s->val.heap.data ) , ( STACKT * ) ( xs -> val.heap.data ) , \
    s ->  size * sizeof ( STACKT  ) ) ==  0 ; \
}
  
# define LISP2DPROTOSTACKPUSHFRONTVALUE(  STACKN  , STACKT  )  \
void  VectorPushFrontValue ( STACKN ) ( Vector  ( STACKN  ) * , STACKT ) ;
  
# define LISP2DSTACKPUSHFRONTVALUE(  STACKN  , STACKT , VOLAT )  \
void  VectorPushFrontValue ( STACKN ) ( Vector  ( STACKN  ) * const me , STACKT const x ) {  \
  struct  VectorPrivate ( STACKN  ) * const s = & ( me -> privat ) ; \
  if  ( s ->  size  ==  0UL ) { \
    s ->  val . alone = x ; \
    s ->  size  = 1UL  ; \
    return  ; \
  } \
  if  ( s ->  size  ==  1UL  ) { \
    STACKT VOLAT * datanew ; \
    size_t memsizenew = 4UL ; \
TryAgain : \
    datanew = aligned_alloc ( _Alignof  ( STACKT  ) , sizeof  ( STACKT  ) * memsizenew ) ; \
    if  ( not datanew ) { \
      if ( memsizenew  == 4UL ) { \
        memsizenew = 2UL ; \
        goto TryAgain ; \
      } \
      Lisp2DExcOutOfMemoryGlobal . value = \
        L"StackPushFrontValue:aligned_alloc ( sizeof  ( STACKT  )" \
        L" * memsizenew )" ; \
      longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
    } \
    * ( datanew + 1UL ) = s ->  val . alone ; \
    s ->  val . heap  . data  =  datanew ; \
    s ->  val . heap  . memorysize  = memsizenew ; \
  } else { \
    if  ( s ->  size ==  s  ->  val . heap  . memorysize ) {  \
      /* was full*/ \
      size_t  newmems  = ( s  ->  size + 1UL  ) <<  1U ; \
      STACKT VOLAT * datanew ;  \
TryAgain2 :  \
      datanew = realloc ( ( STACKT * ) ( s ->  val . heap  . data ) , \
        sizeof  ( STACKT  )  * newmems ) ; \
      if  ( datanew == NULL ) { \
        if  ( newmems  == ( ( s  ->  size + 1UL  ) <<  1U ) ) { \
          newmems  = s  ->  size + 1UL ; \
          goto TryAgain2 ; \
        } \
        Lisp2DExcOutOfMemoryGlobal . value =  \
          L"StackPushFrontValue:realloc ( s->val.heap.data ," \
          L"sizeof  ( STACKT  )  * newmems )" ; \
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
      } \
      s ->  val . heap  . data  = datanew ;  \
      s ->  val . heap  . memorysize  = newmems  ; \
    } \
    memmove ( ( STACKT * ) ( s ->  val . heap  . data  + 1UL ) , ( STACKT * ) ( s ->  val . heap  . data ) , \
      s ->  size * sizeof ( STACKT  ) ) ; \
  } \
  ++  ( s ->  size  ) ; \
  * ( s ->  val . heap  . data  ) = x ; \
}

# define  Lisp2DVectorPushFrontValue( STACKN  ) Lisp2D ##  STACKN  ##  PushFrontValue
# define  VectorPushFrontValue Lisp2DVectorPushFrontValue
  
# define LISP2DPROTOSTACKPUSHATVALUE(  STACKN  , STACKT  )  \
void  Lisp2D  ##  STACKN  ##  PushAtValue ( Vector  ( STACKN  ) * , size_t , STACKT ) ;
  
# define LISP2DSTACKPUSHATVALUE(  STACKN  , STACKT  )  \
void  Lisp2D  ##  STACKN  ##  PushAtValue ( Vector  ( STACKN  ) * const me , \
  size_t const indexto , STACKT const x ) {  \
  struct  VectorPrivate ( STACKN  ) * const s = & ( me -> privat ) ; \
  if  ( s ->  size  ==  0UL ) { \
    if ( indexto not_eq 0 ) { \
      Lisp2DExceptionStringGlobal . str = (wchar_t const(*)[])& \
        L"Lisp2DStackPushAtValue:StackIsEmpty , index not_eq 0" ; \
      longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
    } \
    s ->  val . alone = x ; \
    s ->  size  = 1UL  ; \
    return  ; \
  } \
  if  ( s ->  size  ==  1UL  ) { \
    STACKT * datanew ; \
    size_t memsizenew = 4UL ; \
TryAgain : \
    datanew = aligned_alloc ( _Alignof  ( STACKT  ) , sizeof  ( STACKT  ) * memsizenew ) ; \
    if  ( not datanew ) { \
      if ( memsizenew  == 4UL ) { \
        memsizenew = 2UL ; \
        goto TryAgain ; \
      } \
      Lisp2DExcOutOfMemoryGlobal . value =  \
        L"StackPushAtValue:aligned_alloc ( sizeof  ( STACKT  )  * memsizenew )" ; \
      longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
    } \
    if  ( indexto == 0 )  \
      ( * ( datanew + 1 ) ) = s ->  val . alone ; \
    else  \
      if  ( indexto == 1 )  \
        ( *  datanew ) = s  ->  val . alone ; \
      else {  \
        Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & \
          L"StackPushAtValue:size == 1 , indexto not_eq 0 nor 1" ; \
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
      } \
    s ->  val . heap  . data  =  datanew ; \
    s ->  val . heap  . memorysize  = memsizenew ; \
  } else { \
    if ( indexto > s  ->  size ) { \
      Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & \
        L"Lisp2DStackPushAtValue:index more than size" ; \
      longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
    } \
    if  ( s ->  size ==  s  ->  val . heap  . memorysize ) {  \
      /* was full*/ \
      size_t  newmems  = ( s  ->  size + 1UL  ) <<  1U ; \
      STACKT * datanew ; \
TryAgain2 :  \
      datanew = realloc ( s ->  val . heap  . data , \
        sizeof  ( STACKT  )  * newmems ) ; \
      if  ( datanew == NULL ) { \
        if  ( newmems  == ( s ->  size + 1UL  ) <<  1U ) { \
          newmems  = s  ->  size + 1UL ; \
          goto TryAgain2 ; \
        } \
        Lisp2DExcOutOfMemoryGlobal . value = \
          L"StackPushFrontValue:realloc ( s->val.heap.data , " \
          L"sizeof  ( STACKT  )  * newmems )" ; \
        longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
      } \
      s ->  val . heap  . data  = datanew ; \
      s ->  val . heap  . memorysize  = newmems  ; \
    } \
    memmove ( s ->  val . heap  . data  + indexto + 1UL , \
      s ->  val . heap  . data + indexto ,  \
      ( ( s -> size ) - indexto ) * sizeof ( STACKT  ) ) ; \
  } \
  ++  ( s ->  size  ) ; \
  ( * ( s ->  val . heap  . data + indexto  ) ) = x ; \
}

# define  Lisp2DVectorPushAtValue(  STACKN  ) Lisp2D  ##  STACKN  ##  PushAtValue
# define  VectorPushAtValue Lisp2DVectorPushAtValue

# define  Lisp2D_Vector_InsertFront(  STACKN  ) Lisp2D  ##  STACKN  ##  InsertFront_ExcMem
# define  Vector_InsertFront Lisp2D_Vector_InsertFront

# define LISP2DPROTOSTACKINSERTFRONT(  STACKN  , STACKT  )  \
void  Vector_InsertFront ( STACKN ) ( Vector ( STACKN  ) * , STACKT , size_t ) ;
  
# define LISP2DSTACKINSERTFRONT(  STACKN  , STACKT , VOLAT )  \
void  Vector_InsertFront ( STACKN ) ( \
  Vector ( STACKN  ) * const me , STACKT volatile const x , size_t const n ) { \
  struct  VectorPrivate ( STACKN  ) * const s = & ( me -> privat ) ; \
  switch  ( n ) {  \
  case  0 : \
    return  ;  \
  case  1 : \
    VectorPushFrontValue ( STACKN ) ( me  , x ) ; \
    return ; \
  default : \
    /* n >= 2*/ \
    switch  ( s->size ) { \
    case 0 :  \
      { STACKT VOLAT * datanew ; \
        { size_t memsizenew = ( n * 2 ) ; \
          if ( memsizenew < n ) \
            memsizenew = n ; /* 2n > size_max */ \
TryAgain3 : \
          datanew = aligned_alloc ( _Alignof  ( STACKT  ) , sizeof  ( STACKT  ) * memsizenew ) ; \
          if ( not  datanew ) { \
            if ( memsizenew not_eq n ) { \
              memsizenew = n ; \
              goto TryAgain3 ; \
            } \
            Lisp2DExcOutOfMemoryGlobal . value =  \
              L"Lisp2DStackInsertFront:s=0:datanew = aligned_alloc ( " \
              L"sizeof  ( STACKT  )  * memsizenew )" ; \
            longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
          } \
          s ->  val . heap  . memorysize = memsizenew ; \
        } \
        s ->  val . heap  . data = datanew ; \
      } \
      break ; \
    case 1 : \
      { STACKT VOLAT * datanew ; \
        { size_t memsizenew = ( n + 1UL ) * 2 ; \
          if ( memsizenew < ( n + 1UL ) ) \
            memsizenew = n + 1UL ;  \
          /* 2(n+1) > size_max */ \
TryAgain4 : \
          datanew = aligned_alloc ( _Alignof  ( STACKT  ) , sizeof  ( STACKT  ) * memsizenew ) ; \
          if ( not  datanew ) { \
            if ( memsizenew not_eq (  n + 1UL ) ) { \
              memsizenew = n +  1UL ; \
              goto TryAgain4 ; \
            } \
            Lisp2DExcOutOfMemoryGlobal . value =  \
              L"Lisp2DStackInsertFront:s=1:datanew = aligned_alloc ( " \
              L"sizeof  ( STACKT  )  * memsizenew )" ; \
            longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
          } \
          ( * ( datanew + n ) ) = s ->  val . alone ; \
          s ->  val . heap  . memorysize = memsizenew ; \
        } \
        s ->  val . heap  . data = datanew ; \
      } \
      break ; \
    default : \
      if  ( ( s ->  size  + n ) >  s  ->  val . heap  . memorysize  ) { \
        /* was full*/ \
        STACKT VOLAT * datanew ; \
        { size_t memsizenew = ( n + ( s ->  size  ) ) <<  1U ; \
          if ( memsizenew < ( n + ( s ->  size  ) ) ) \
            memsizenew = n + (  s ->  size  ) ; /* 2(n+s) > size_max */ \
TryAgain5 : \
          datanew = realloc ( ( STACKT * ) ( s ->  val . heap  . data ) , \
            sizeof  ( STACKT  )  * memsizenew ) ; \
          if ( datanew == NULL ) { \
            if ( memsizenew not_eq (  n + ( s ->  size  ) ) ) { \
              memsizenew = n +  ( s ->  size  ) ; \
              goto TryAgain5 ; \
            } \
            Lisp2DExcOutOfMemoryGlobal . value = \
              L"Lisp2DStackInsertFront:datanew = realloc ( "  \
              L"s->val.heap.data ," \
              L" sizeof  ( STACKT  )  * memsizenew )" ; \
            longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeOutOfMemory ) ; \
          } \
          s ->  val . heap  . memorysize = memsizenew ; \
        } \
        s ->  val . heap  . data = datanew ; \
      } \
      memmove ( ( STACKT * ) ( s ->  val . heap  . data  + n ) , ( STACKT * ) ( s ->  val . heap  . data ) , \
        s ->  size * sizeof ( STACKT  ) ) ; \
    } \
    s ->  size  +=  n ; \
    STACKT VOLAT * dataj = s  ->  val . heap  . data ; \
    /* optimization for less checking i<>0 and decreasing --i */ \
    for ( size_t  i = n ; i > 0 ; --  i , ++ dataj  ) \
      ( * dataj ) = x ; \
  } \
}

# define  Lisp2D_Vector_RemoveFront( T ) Lisp2D ##  T ##  RemoveFront
# define  Vector_RemoveFront Lisp2D_Vector_RemoveFront

# define LISP2DPROTOSTACKREMOVEFRONT(  STACKN  , STACKT  )  \
void  Vector_RemoveFront ( STACKN  ) ( Vector  ( STACKN  ) * ,  size_t ) ;

# include "define.h"

# ifdef LISP2D_DEBUG
# define LISP2DREMOVEFRONTCHECKLESSN \
  if  ( s ->  size  <  n ) { \
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & \
      L"Lisp2DStackRemoveFront:s->size < n" ; \
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
  }
# else
# define LISP2DREMOVEFRONTCHECKLESSN
# endif

// #[0 1 2 3 4] remove 2 -> #[2 3 4]   
# define LISP2DSTACKREMOVEFRONT(  STACKN  , STACKT , VOLAT )  \
void  Vector_RemoveFront ( STACKN  ) ( Vector  ( STACKN  ) * const me , size_t const n ) { \
  VectorP ( STACKN  ) * const s = & ( me -> privat ) ; \
  if  ( n ==  0UL ) \
    return  ; \
  /* n > 0 */ \
  LISP2DREMOVEFRONTCHECKLESSN \
  if  ( s ->  size  ==  n  ) { \
    Lisp2D  ##  STACKN  ##  Clear ( me ) ;  \
    return ; \
  } \
  if  ( s->size  ==  ( n + 1UL ) ) {  \
    { STACKT VOLAT const  tmp = ( * ( s->val.heap.data  + n ) ) ; \
      Vector_Free ( STACKN ) ( s ) ; \
      s->val.alone = tmp; \
    } \
    s->size = 1UL ; \
    return ; \
  } \
  size_t  const sizenew = (s->size  - n) ; \
  if  ( s->val.heap.memorysize >= (  sizenew *  4 ) ) {  \
    size_t  memorysizenew = ( sizenew  *  2 ) ; \
    if(memorysizenew < sizenew) \
      memorysizenew = sizenew ; \
    STACKT VOLAT * datanew ; \
TryAgain : \
    datanew = aligned_alloc ( _Alignof  ( STACKT  ) , sizeof  ( STACKT  ) * memorysizenew ) ; \
    if (  not datanew ) { \
      if(memorysizenew not_eq sizenew) {  \
        memorysizenew = sizenew ; \
        goto TryAgain; \
      } \
      memmove ( ( STACKT * ) ( s->val.heap.data ) , ( STACKT * ) ( s->val.heap.data + n ) , \
        sizenew * sizeof ( STACKT  ) ) ; \
    } else { \
      memcpy  ( ( STACKT * ) ( datanew ) , ( STACKT * ) ( s->val.heap.data  + n ) , sizenew * sizeof ( STACKT  ) ) ; \
      Vector_Free ( STACKN ) ( s ) ; \
      s ->  val . heap  . data  = datanew ;  \
      s ->  val . heap  . memorysize  = memorysizenew  ;  \
    } \
  } else \
    memmove ( ( STACKT * ) ( s->val.heap.data ) , ( STACKT * ) ( s->val.heap.data + n ) , \
      sizenew * sizeof ( STACKT  ) ) ; \
  s->size  = sizenew ; \
}

# define  Lisp2D_Vector_EraseInd( T ) Lisp2D_ ##  T ##  _EraseInd
# define  Vector_EraseInd Lisp2D_Vector_EraseInd
  
# define LISP2DPROTOSTACKERASEIND(  STACKN  , STACKT  )  \
void  Vector_EraseInd  ( STACKN ) ( Vector ( STACKN  ) * ,  size_t ) ;      

// #[0 1 2 3 4] eraseind 2 -> #[0 1 3 4] 
# define LISP2DSTACKERASEIND(  STACKN  , STACKT  )  \
void  Vector_EraseInd  ( STACKN ) ( Vector  ( STACKN  ) * const me , size_t const  ind ) { \
  struct  VectorPrivate ( STACKN  ) * const s = & ( me -> privat ) ; \
  if  ( ind >=  s ->  size ) { \
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & \
      L"Lisp2D_Vector_EraseInd:ind >= s -> size" ; \
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
  } \
  if  ( s ->  size  ==  1 ) { \
    s -> size = 0 ; \
    return ; \
  } \
  if  ( s -> size  ==  2 ) { \
    /* erase 0 : alone 1 || erase 1 : alone 0 */ \
    { STACKT const  tmp = s  ->  val . heap  . data  [ ind ? 0 : 1 ] ; \
      Vector_Free ( STACKN ) ( s ) ; \
      s ->  val . alone = tmp ; \
    } \
    s ->  size = 1 ; \
    return ; \
  } \
  size_t  const sizenew = ( s ->  size  - 1 ) ; \
  if  ( s ->  val . heap  . memorysize >= ( sizenew * 4 ) ) {  \
    size_t  memorysizenew = ( sizenew  *  2 ) ; \
    if  ( memorysizenew < sizenew ) \
      memorysizenew = sizenew ; \
    STACKT * datanew ; \
TryAgain : \
    datanew = aligned_alloc ( _Alignof  ( STACKT  ) , sizeof  ( STACKT  ) * memorysizenew ) ; \
    if ( not datanew  ) { \
      if  ( memorysizenew not_eq sizenew  ) {  \
        memorysizenew = sizenew ; \
        goto TryAgain ; \
      } \
      memmove ( s ->  val . heap  . data + ind ,  \
        s  ->  val . heap  . data + ind + 1 , \
        ( sizenew - ind ) * sizeof ( STACKT  ) ) ; \
    } else { \
      memcpy  ( datanew , s ->  val . heap  . data , \
        ind * sizeof ( STACKT  ) ) ; \
      memcpy  ( datanew + ind , s ->  val . heap  . data + ind + 1 , \
        ( sizenew - ind ) * sizeof ( STACKT  ) ) ; \
      Vector_Free ( STACKN ) ( s ) ; \
      s ->  val . heap  . data  = datanew ;  \
      s ->  val . heap  . memorysize  = memorysizenew  ; \
    } \
  } else \
    memmove ( s ->  val . heap  . data + ind ,  \
      s  ->  val . heap  . data + ind + 1 , \
      ( sizenew - ind ) * sizeof ( STACKT  ) ) ;  \
  s ->  size  = sizenew ; \
}

# define  Lisp2D_Vector_CBack( STACKN  ) Lisp2D_  ##  STACKN  ##  _CBack
# define  Vector_CBack Lisp2D_Vector_CBack

# define LISP2DPROTOSTACKCBACK(  STACKN  , STACKT  )  \
STACKT const * Vector_CBack ( STACKN ) ( Vector ( STACKN ) const * ) ;

# define LISP2DSTACKCBACK(  STACKN  , STACKT  )  \
STACKT const * Vector_CBack ( STACKN ) ( Vector ( STACKN ) const * const me ) { \
  struct  VectorPrivate(STACKN) const * const mep = ( & ( me -> privat ) ) ; \
  return ((( mep->size >= 2UL )?  \
    mep->val.heap.data: \
    (& mep->val.alone)) + mep->size - 1UL) ; \
}

# define  Lisp2D_Vector_Back( STACKN  ) Lisp2D  ##  STACKN  ##  Back
# define  Vector_Back Lisp2D_Vector_Back
    
# define LISP2DPROTOSTACKBACK(  STACKN  , STACKT  )  \
STACKT * Vector_Back ( STACKN ) ( Vector ( STACKN ) * ) ;
  
# define LISP2DSTACKBACK(  STACKN  , STACKT  )  \
STACKT * Vector_Back ( STACKN ) ( Vector ( STACKN ) * const me ) { \
  struct  VectorPrivate ( STACKN ) * const mep = & ( me -> privat ) ; \
  return (  ( mep ->  size >= 2UL ) ? \
    mep ->  val . heap  . data  : \
    ( & mep ->  val . alone ) ) + mep ->  size - 1UL ; \
}

# define LISP2DPROTOSTACKCREND(  STACKN  , STACKT  )  \
STACKT const * Lisp2D ##  STACKN  ##  CREnd  ( Vector(STACKN) const * ) ;

# define LISP2DSTACKCREND(  STACKN  , STACKT  )  \
STACKT const * Lisp2D ##  STACKN  ##  CREnd  ( Vector(STACKN) const * const s )  { \
  struct  VectorPrivate(STACKN) const * const mep = ( & ( s -> privat ) ) ; \
  return (( mep->size >= 2UL ) ?  \
    (mep->val.heap.data):  \
    & ( mep->val.alone )) - 1UL ; \
}

# define  Lisp2D_Vector_CRBegin(  STACKN  ) Lisp2D_  ##  STACKN  ##  _CRBegin
# define  Vector_CRBegin Lisp2D_Vector_CRBegin

# define  LISP2DPROTOSTACKCRBEGIN(  STACKN  , STACKT  ) \
STACKT  const * Vector_CRBegin  ( STACKN  ) ( Vector  ( STACKN  ) const * ) ;

# define  LISP2DSTACKCRBEGIN( STACKN  , STACKT  ) \
STACKT  const * Vector_CRBegin  ( STACKN  ) ( Vector  ( STACKN  ) const * const s ) { \
  struct  VectorPrivate ( STACKN  ) const * const mep = & ( s ->  privat  ) ; \
  return  ( ( mep ->  size  >=  2UL ) ? \
    mep ->  val . heap  . data  : \
    ( & mep ->  val . alone ) ) + ( mep ->  size  ) - 1UL ; \
}

# define LISP2DPROTOSTACKCAT(  STACKN  , STACKT  )  \
STACKT const *  Lisp2D  ##  STACKN  ##  CAt ( Vector  ( STACKN  )  const *  , size_t  ) ;

# define LISP2DSTACKCAT(  STACKN  , STACKT  )  \
STACKT const *  Lisp2D  ##  STACKN  ##  CAt ( \
  Vector  ( STACKN  )  const * const me , size_t  const i ) { \
  struct  VectorPrivate ( STACKN  ) const * const mep = & ( me -> privat ) ; \
  if ( i >= mep  ->  size ) { \
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & \
      L"VectorCAt:i >= mep  ->  size" ; \
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
  } \
  return  ( ( mep -> size >= 2UL )  ? \
    mep ->  val . heap  . data  : \
    ( & mep ->  val . alone ) ) + i  ; \
}
  
# define  Lisp2DVectorCAt(STACKN) Lisp2D  ##  STACKN  ##  CAt
# define  VectorCAt Lisp2DVectorCAt

# define  Lisp2DVectorEnd(  STACKN  ) Lisp2D ##  STACKN  ##  End
# define  VectorEnd Lisp2DVectorEnd

# define LISP2DPROTOSTACKEND(  STACKN  , STACKT  )  \
STACKT * VectorEnd ( STACKN )  ( Vector(STACKN) * ) ;

# define LISP2DSTACKEND(  STACKN  , STACKT  )  \
STACKT * VectorEnd ( STACKN ) ( Vector(STACKN) * const s ) { \
  struct  VectorPrivate(STACKN) * const mep = ( & ( s -> privat ) ) ; \
  return (( mep->size >= 2UL )? \
    mep->val.heap.data: \
    (& mep->val.alone)) + (mep->size)  ; \
}

# define LISP2DPROTOSTACKRBEGIN(  STACKN  , STACKT  )  \
STACKT * Lisp2D ##  STACKN  ##  RBegin ( struct Lisp2D  ##  STACKN * ) ;

# define LISP2DSTACKRBEGIN(  STACKN  , STACKT  )  \
STACKT * Lisp2D ##  STACKN  ##  RBegin ( struct Lisp2D  ##  STACKN * const  s ) { \
  struct  VectorPrivate ( STACKN  ) * const mep = & ( s -> privat ) ; \
  return  ( ( mep ->  size >= 2UL ) ? \
    mep ->  val . heap  . data  : \
    ( & mep ->  val . alone ) ) + ( mep ->  size  ) - 1UL ; \
}
  
# define LISP2DPROTOSTACKREND(  STACKN  , STACKT  )  \
STACKT * Lisp2D ##  STACKN  ##  REnd ( struct Lisp2D  ##  STACKN * ) ;

# define LISP2DSTACKREND(  STACKN  , STACKT  )  \
STACKT * Lisp2D ##  STACKN  ##  REnd ( struct Lisp2D  ##  STACKN * const  s \
  ) { \
  struct  VectorPrivate ( STACKN  ) * const mep = & ( s -> privat ) ; \
  return  ( ( mep ->  size  >=  2UL ) ? mep ->  val . heap  . data  : \
    ( & mep ->  val . alone ) ) - 1UL ; \
}

# endif // LISP2D_STACKDEFINE_H
