// Lisp2D - Stack universal types Private
// ©2019-23 by Alex Glebe

# ifndef LISP2D_STACK_PRIVATE_H
# define LISP2D_STACK_PRIVATE_H

# include <stdint.h>

extern _Thread_local uint8_t * Lisp2DThreadStack ;

# include "stack/type.h"

// Stack pointer begins from bottom address
extern _Thread_local Lisp2DThreadStackPointerType  Lisp2D_thread_stack_sp ;

# include "stack/enum.h"

// size of each types may be in stack
extern Lisp2DThreadStackSizeType  Lisp2DThreadStackTypeSize [ Lisp2DStackTypeSIZE ] ;

// array of destructor for all types (may be NULL )
extern StackDestructorType Lisp2DThreadStackTypeDestructor [ Lisp2DStackTypeSIZE ] ;

# define  uint8pcastLisp2DThreadStackTypeTypep Lisp2D_uint8pcastLisp2DThreadStackTypeTypep
inline  ThreadStackTypeType * uint8pcastLisp2DThreadStackTypeTypep ( uint8_t * ) ;

inline  ThreadStackTypeType * uint8pcastLisp2DThreadStackTypeTypep ( uint8_t * const p ) {
  return  ( ThreadStackTypeType * ) p ;
}

# endif //  LISP2D_STACK_PRIVATE_H
