// Lisp2D - Stat public
// ©2017-23 by Alex Glebe
# ifndef  LISP2D_STAT_INLINE_H
# define  LISP2D_STAT_INLINE_H

# include <sys/types.h>
# include "stat/public.h"
# include "stat/private.h"
# include "stat/structpri.h"

inline  PLOStat * ParaLispObjectToPLOStat ( ParaLispObject * const p ) {
  return & ( (  PLOStatPri * ) ( p  ->  vaddr . addr . p ) ) -> pub ;
}

inline  struct timespec const * PLOStat_CCTime  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_ctim  ) ;
}

inline  struct timespec const * PLOStat_CMTime  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_mtim  ) ;
}

inline  struct timespec const * PLOStat_CATime  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_atim  ) ;
}

inline  blkcnt_t const * PLOStat_CBlocks  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_blocks  ) ;
}

inline  blksize_t const * PLOStat_CBSize  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_blksize  ) ;
}

inline  off_t const * PLOStat_CSize  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_size  ) ;
}

inline  dev_t const * PLOStat_CRDev  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_rdev  ) ;
}

inline  gid_t const * PLOStat_CGID  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_gid  ) ;
}

inline  uid_t const * PLOStat_CUID  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_uid  ) ;
}

inline  nlink_t const * PLOStat_CLinks  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_nlink  ) ;
}

inline  mode_t const * PLOStat_CMode  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_mode  ) ;
}

inline  ino_t const * PLOStat_CInode  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate(me) -> mystat  . st_ino  ) ;
}

inline  dev_t const * PLOStat_CDev  ( PLOStat const * const me ) {
  return  & ( PLOStat_toCPrivate  ( me  ) -> mystat  . st_dev  ) ;
}

# include "plo/public.h"

inline  bool  StatP ( ParaLispObject const * const xp ) {
  return  ParaLispObject_Type ( xp ) == TypeGlobalListMemberPLOStatPri ;
}
# include "stat/inlinepri.h"
# endif // LISP2D_STAT_INLINE_H
