// Lisp2D - Stat public
// ©2017-23 by Alex Glebe
# ifndef  LISP2D_STAT_PUBLIC_H
# define  LISP2D_STAT_PUBLIC_H
# include "plo/struct.h"

# define  PLOStat_staticTypeOf  Lisp2D_PLOStat_staticTypeOf
ParaLispObject  * PLOStat_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOStat_staticClassDef  Lisp2D_PLOStat_staticClassDef
ParaLispObject  * PLOStat_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOStat_staticClassParents  Lisp2D_PLOStat_staticClassParents
ParaLispObject  * PLOStat_staticClassParents  ( ParaLispObject const * ) ;

# include "plostream/type.h"

# define  PLOStat_staticCoutToHuman Lisp2D_PLOStat_staticCoutToHuman
void  PLOStat_staticCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;

# define  PLOStat_staticCoutToInterpret Lisp2D_PLOStat_staticCoutToInterpret
void  PLOStat_staticCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;

# include "stat/type.h"
  
# define  PLOStat_Destr Lisp2D_PLOStat_Destr
void PLOStat_Destr  ( PLOStat * ) ;

# include "taskforthread.h"

FuncBining  Lisp2Dbimstatstat ;
FuncBining  Lisp2Dbimnilstatp ;
FuncBining  Lisp2Dbimstatsetf ;
FuncBining  Lisp2Dbimstatswap ;
FuncBining  Lisp2Dbimstatdevice ;
FuncBining  Lisp2Dbimstatrdevice ;
FuncBining  Lisp2Dbimstatinode  ;
FuncBining  Lisp2Dbimstatpermissions  ;
FuncBining  Lisp2Dbimstatfiletype ;
FuncBining  Lisp2Dbimstatlinks ;
FuncBining  Lisp2Dbimstatuid ;
FuncBining  Lisp2Dbimstatgid ;
FuncBining  Lisp2Dbimstattotalsize ;
FuncBining  Lisp2Dbimstatblocksize ;
FuncBining  Lisp2Dbimstatblocks ;
FuncBining  Lisp2Dbimstataccesstime ;
FuncBining  Lisp2Dbimstatmodifytime ;
FuncBining  Lisp2Dbimstatchangetime ;

# include <sys/stat.h>

// may returns NULL with exception sets
# define  NewStat Lisp2D_NewStat
PLOStat * NewStat ( StackClusterPrivate  * , struct stat const * ) ; 

# define  IsNotStat Lisp2D_IsNotStat
bool  IsNotStat ( ParaLispObject * , StackClusterPrivate * ) ;

# define  PLOStat_InitStruct  Lisp2D_PLOStat_InitStruct
void  PLOStat_InitStruct  (  PLOStat * , struct stat const * ) ;
# define  PLOStat_Init  Lisp2D_PLOStat_Init
void  PLOStat_Init ( PLOStat * ) ;

# define  PLOStat_staticDestr Lisp2D_PLOStat_staticDestr
void  PLOStat_staticDestr  ( ParaLispObject * me ) ;
# define  ParaLispObjectToPLOStat Lisp2DParaLispObjectToPLOStat
inline  PLOStat * ParaLispObjectToPLOStat ( ParaLispObject * ) ;
# define  PLOStat_CCTime  Lisp2D_PLOStat_CCTime
inline  struct timespec const * PLOStat_CCTime  ( PLOStat const * ) ;
# define  PLOStat_CMTime  Lisp2D_PLOStat_CMTime
inline  struct timespec const * PLOStat_CMTime  ( PLOStat const * ) ;
# define  PLOStat_CATime  Lisp2D_PLOStat_CATime
inline  struct timespec const * PLOStat_CATime  ( PLOStat const * ) ;
# define  PLOStat_CBlocks Lisp2D_PLOStat_CBlocks
inline  blkcnt_t const * PLOStat_CBlocks  ( PLOStat const * ) ;
# define  PLOStat_CBSize  Lisp2D_PLOStat_CBSize
inline  blksize_t const * PLOStat_CBSize  ( PLOStat const * ) ;
# define  PLOStat_CSize Lisp2D_PLOStat_CSize
inline  off_t const * PLOStat_CSize  ( PLOStat const * ) ;
# define  PLOStat_CRDev Lisp2D_PLOStat_CRDev
inline  dev_t const * PLOStat_CRDev  ( PLOStat const * ) ;
# define  PLOStat_CGID  Lisp2D_PLOStat_CGID
inline  gid_t const * PLOStat_CGID  ( PLOStat const * ) ;
# define  PLOStat_CUID  Lisp2D_PLOStat_CUID
inline  uid_t const * PLOStat_CUID  ( PLOStat const * ) ;
# define  PLOStat_CLinks  Lisp2D_PLOStat_CLinks
inline  nlink_t const * PLOStat_CLinks  ( PLOStat const * ) ;
# define  PLOStat_CMode Lisp2D_PLOStat_CMode
inline  mode_t const * PLOStat_CMode  ( PLOStat const * ) ;
# define  PLOStat_CInode  Lisp2D_PLOStat_CInode
inline  ino_t const * PLOStat_CInode  ( PLOStat const * ) ;
# define  PLOStat_CDev  Lisp2D_PLOStat_CDev
inline  dev_t const * PLOStat_CDev  ( PLOStat const * ) ;
# define  PLOStat_Swap  Lisp2D_PLOStat_Swap
void  PLOStat_Swap  ( PLOStat * , PLOStat * ) ;
# define  PLOStat_SetCopy Lisp2D_PLOStat_SetCopy
void  PLOStat_SetCopy ( PLOStat * , PLOStat const * ) ;
# define  PLOStat_SetValue  Lisp2D_PLOStat_SetValue
void  PLOStat_SetValue ( PLOStat * , struct stat const * ) ;
# define  StatP Lisp2D_StatP
inline  bool  StatP ( ParaLispObject const * ) ;

# endif // LISP2D_STAT_PUBLIC_H
