// Lisp2D - Statistics private
// ©2023 by Alex Glebe

# ifndef  LISP2D_STATISTICSP_H
# define  LISP2D_STATISTICSP_H
# include "atomic_mutex.h"
// private definition - Don't look

struct  Lisp2DStatisticsSection {
  long  double  sumx  ;  // sum(x)
  long  double  sumx2 ; // sum(x^2) 
  
// ! to atomic w/o Lock  
  size_t  count ; // count of inserted data
  
} ;

struct  Lisp2DStatisticsSectionGlobal {
  struct  Lisp2DStatisticsSection s ;
  long  double  average ; // Sum(x)/n
  long  double  deviation ; // Sqrt(Sum((x-M)^2)/(n-1))  
} ;

# include "define.h"

# ifdef LISP2D_DEBUG
  enum  Lisp2DStatisticsState { Lisp2DStatisticsNotConstructed = 666 ,
    Lisp2DStatisticsLive = 777 , Lisp2DStatisticsDestructed = 999 ,
  } ;
# endif
  
typedef struct  Lisp2DStatistics Lisp2D_Statistics_t ;
typedef Lisp2D_Statistics_t Statistics_t  ;
  
struct  Lisp2DStatistics  {
  struct  Lisp2DStatisticsSectionGlobal globalStat ; //{ { 0 , 0 , 0 } ,  0 ,  0 } ;
  size_t  sizeset ; // limit of sections
  struct  Lisp2DStatisticsSection * sectionsStat ;
  long  double  ( * lderfp  ) [ ] ; // size of lderf = (sizeset - 1)
  
  Lisp2D_atomic_mutex amutex  ;
  
# ifdef LISP2D_DEBUG
  enum  Lisp2DStatisticsState flagConstructed ;
# endif
} ;

# endif // LISP2D_STATISTICSP_H
