// Lisp2D - StackCluster
// ©2003-23 by Alex Glebe

# ifndef  LISP2D_STCL_CLASSC_H
# define  LISP2D_STCL_CLASSC_H
# include <stddef.h>
# include "define.h"
# include "plo/struct.h"
# include "stack-addrforreturn.h"
# include "mutex.h"
# include "stclhistory/inline.h"
# include "consatomic/public.h"
# include "taskforthread.h"

# define  TaskRun StackCluster_TaskRun
# define  TaskTerminate StackCluster_TaskTerminate
# define  TaskWaitSonsAlmost  StackCluster_TaskWaitSonsAlmost
# define  TaskWaitSons  StackCluster_TaskWaitSons
# define  TaskWaitUnLock2 StackCluster_TaskWaitUnLock2
# define  TaskWaitSignal  StackCluster_TaskWaitSignal
# define  TaskPause StackCluster_TaskPause
# ifndef  LISP2D_DONTUSEX11    
# define  TaskWinWaitEvent  StackCluster_TaskWinWaitEvent
# endif
# define  TaskWaitSystemTask  StackCluster_TaskWaitSystemTask
# define  TaskWaitExtraThread StackCluster_TaskWaitExtraThread
enum { TaskRun , TaskTerminate , TaskWaitSonsAlmost
    /* not in queue yet */  , TaskWaitSons  ,
    // !? to remove    
    TaskWaitUnLock2 , TaskWaitSignal  , TaskPause ,
# ifndef  LISP2D_DONTUSEX11    
    TaskWinWaitEvent  ,
# endif    
// ! To remove big count of Tasks: make only one: TaskWaitExtraThread
    TaskWaitSystemTask  ,
    TaskWaitExtraThread  ,
}  ;
      
# ifdef  LISP2D_BIMSTAT
# define  averageStackClustermutex_TaskStatFast_Value Lisp2D_averageStackClustermutex_TaskStatFast_Value
size_t  averageStackClustermutex_TaskStatFast_Value ( void ) ;
# define  averageStackClustermutex_TaskStatFast_Add Lisp2D_averageStackClustermutex_TaskStatFast_Add
void  averageStackClustermutex_TaskStatFast_Add ( size_t  d ) ;
# define  averageStackClustermutex_TaskStatWait_Value  Lisp2D_averageStackClustermutex_TaskStatWait_Value
size_t  averageStackClustermutex_TaskStatWait_Value ( void ) ;
# define  averageStackClustermutex_TaskStatWait_Add  Lisp2D_averageStackClustermutex_TaskStatWait_Add
void  averageStackClustermutex_TaskStatWait_Add ( size_t  d ) ;
# define  averageStackClustermutex_ExceptionStatFast_Value   Lisp2D_averageStackClustermutex_ExceptionStatFast_Value
size_t  averageStackClustermutex_ExceptionStatFast_Value ( void ) ;
# define  averageStackClustermutex_ExceptionStatFast_Add   Lisp2D_averageStackClustermutex_ExceptionStatFast_Add
void  averageStackClustermutex_ExceptionStatFast_Add ( size_t  d ) ;

# define  averageStackClustermutex_ExceptionStatWait_Value    Lisp2D_averageStackClustermutex_ExceptionStatWait_Value
size_t  averageStackClustermutex_ExceptionStatWait_Value ( void ) ;
# define  averageStackClustermutex_ExceptionStatWait_Add    Lisp2D_averageStackClustermutex_ExceptionStatWait_Add
void  averageStackClustermutex_ExceptionStatWait_Add ( size_t  d ) ;

# endif
  
# ifdef LISP2D_CONSTRSTAT
  # include <stdatomic.h>
  # define  StackCluster_constrstat Lisp2D_StackCluster_constrstat
  extern  _Atomic ( size_t  ) StackCluster_constrstat ;
  # define  StackCluster_constrstat_Value Lisp2D_StackCluster_constrstat_Value
  size_t  StackCluster_constrstat_Value ( void  ) ;
  # define  StackCluster_constrstat_Inc Lisp2D_StackCluster_constrstat_Inc
  void  StackCluster_constrstat_Inc ( void  ) ;
# endif

# include "streamc.h"
# include "symbol/type.h"
# include "env/struct.h"
# include "stack-plop.h"
# include "stcl/type.h"
# include "stcl/structpri.h"

# define  StackClusterPrivateInitHistory  Lisp2D_StackClusterPrivateInitHistory
void  StackClusterPrivateInitHistory ( StackClusterPrivate * s , size_t myhs ) ;

# define  new_StackClusterPrivateInitHistory  Lisp2D_new_StackClusterPrivateInitHistory
StackClusterPrivate *  new_StackClusterPrivateInitHistory ( size_t myhs ) ;
  
# define  StackClusterPrivate_Destructor  Lisp2D_StackClusterPrivate_Destructor
void  StackClusterPrivate_Destructor  ( StackClusterPrivate * ) ;

# define  StackClusterPrivateInitPoint  Lisp2D_StackClusterPrivateInitPoint
void  StackClusterPrivateInitPoint ( StackClusterPrivate * s ) ;

# define  new_StackClusterPrivateInitPoint   Lisp2D_new_StackClusterPrivateInitPoint
StackClusterPrivate *  new_StackClusterPrivateInitPoint ( void ) ;

# include "globallistm/inline.h"

# define  GlobalListMemberToStackClusterPrivate Lisp2D_GlobalListMemberToStackClusterPrivate
inline  StackClusterPrivate * GlobalListMemberToStackClusterPrivate  ( GlobalListMember * ) ;

# define  StackClusterPrivate_SetflagCont Lisp2D_StackClusterPrivate_SetflagCont
void  StackClusterPrivate_SetflagCont ( StackClusterPrivate  * , Lisp2DEvalAddrCont2 ) ;

# define  StackClusterPrivate_ClearflagCont Lisp2D_StackClusterPrivate_ClearflagCont
// returns flagCont was here and clear it to zero
Lisp2DEvalAddrCont2 StackClusterPrivate_ClearflagCont  ( StackClusterPrivate  * ) ;
  
# define  StackClusterPrivate_NamespaceProplist  Lisp2D_StackClusterPrivate_NamespaceProplist
ParaLispObject * StackClusterPrivate_NamespaceProplist ( StackClusterPrivate const * )  ;
  
# define  TaskQueuePush Lisp2D_TaskQueuePush
void  TaskQueuePush ( StackClusterPrivate * ) ;  
  
extern  Lisp2DMutex Lisp2DMutexQueueAtomicStClFirstC  ;
extern  Lisp2DMutex Lisp2DMutexQueueAtomicStClLastC  ;

# define  StackClusterPrivate_CreateTask  Lisp2D_StackClusterPrivate_CreateTask
// ! argenv:=env
void  StackClusterPrivate_CreateTask  ( StackClusterPrivate * const st , ParaLispObject * const  iop  )  ;

# define  StackClusterPrivate_EnvNewLevel2  Lisp2D_StackClusterPrivate_EnvNewLevel2
void  StackClusterPrivate_EnvNewLevel2  ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_ListOfEvalHistory   Lisp2D_StackClusterPrivate_ListOfEvalHistory
ParaLispObject  * StackClusterPrivate_ListOfEvalHistory ( StackClusterPrivate * ) ;  
    
# define  StackClusterPrivate_ExceptionSet  Lisp2D_StackClusterPrivate_ExceptionSet
void  StackClusterPrivate_ExceptionSet  ( StackClusterPrivate  *,ParaLispObject * ) ;
  
# define  StackClusterAddrPush  Lisp2D_StackClusterAddrPush
void  StackClusterAddrPush ( StackClusterPrivate * ,  struct Lisp2DAddrForReturn2 ) ;

# define  StackClusterConstructorHistorySize   Lisp2D_StackClusterConstructorHistorySize
StackClusterPrivate * StackClusterConstructorHistorySize  (  size_t myhs ) ;
  
# define  StackClusterPrivate_NewStCl4  Lisp2D_StackClusterPrivate_NewStCl4
StackClusterPrivate  * StackClusterPrivate_NewStCl4  (  StackClusterPrivate  *  ) ;  
  
# define  NewStClOrphan Lisp2DNewStClOrphan
StackClusterPrivate * NewStClOrphan  ( size_t myhs ) ;

# define  isOKTaskQueuePop  Lisp2DisOKTaskQueuePop
bool  isOKTaskQueuePop  ( StackClusterPrivate * * ) ;

# define  SetNamespaceProplist  Lisp2DSetNamespaceProplist
void  SetNamespaceProplist  ( StackClusterPrivate * , ParaLispObject * ) ;

# define  SetResultPlace  Lisp2DSetResultPlace
void  SetResultPlace  ( StackClusterPrivate * , ParaLispObject * * , ParaLispObject  * ) ;

// for : ToRunExtraThread
# define  StackClusterPrivate_StackCleaning Lisp2D_StackClusterPrivate_StackCleaning
TaskForThread StackClusterPrivate_StackCleaning ( StackClusterPrivate  * ) ;  

# define  isOKTaskQueuePopPrivate Lisp2D_isOKTaskQueuePopPrivate
bool  isOKTaskQueuePopPrivate  ( StackClusterPrivate * * )  ;

# define  SetResultErrnoNotLockGC Lisp2D_SetResultErrnoNotLockGC
TaskForThread SetResultErrnoNotLockGC  ( StackClusterPrivate * ) ;  

# define  SetResultErrnoLockGC  Lisp2D_SetResultErrnoLockGC
TaskForThread SetResultErrnoLockGC  ( StackClusterPrivate  * )  ;   

# define  VariableHaveNoLinks Lisp2D_VariableHaveNoLinks
void  VariableHaveNoLinks ( StackClusterPrivate  * , ParaLispObject * v  ) ;

# define  BadStringN Lisp2DBadStringN
  void  BadStringN ( StackClusterPrivate  * ) ;

# define  StackClusterIsBADClearBeforeGarbage   Lisp2DStackClusterIsBADClearBeforeGarbage
bool  StackClusterIsBADClearBeforeGarbage  ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_ObjectDDAssocMethod2   Lisp2D_StackClusterPrivate_ObjectDDAssocMethod2
// returns nullptr | method
ParaLispObject  * StackClusterPrivate_ObjectDDAssocMethod2  ( StackClusterPrivate * , ParaLispObject const *  , PLOSymbol * ) ;

  # define  StackClusterPrivate_Eval2 Lisp2D_StackClusterPrivate_Eval2
// ! to make: StackCluster  & Eval() -> enum Eval()
// ! OR                   -> void Eval(RunningPthArgs  * rpt)
// ! to return different value to pthEval2()
// ! if StackCluster in Queue was again twice:
// ! first Thread: make extraThread, extraThread Push(stcl) in Queue
// ! second Thread: stcl processed and make TaskForManagerToQuit or Run or Else
// ! first Thread: MUST to IGNORE stcl.TaskForManager and get NEXT task from the queue  
TaskForThread StackClusterPrivate_Eval2 ( StackClusterPrivate * ) ;

# define  OutOfMemory Lisp2D_OutOfMemory
void  OutOfMemory ( StackClusterPrivate  * ) ;  

# include "deque/type-wchar.h"

# define  FreeBuf Lisp2D_FreeBuf
void  FreeBuf ( size_t i0  , Deque ( WChar ) * dqbufp ) ;

# define  StackClusterPrivate_LoadObjectS Lisp2D_StackClusterPrivate_LoadObjectS
// ! to read in new thread when wfstream is not nullptr
bool  StackClusterPrivate_LoadObjectS  (StackClusterPrivate *, ParaLispObject * * , Stream  * , Deque ( WChar ) * ) ;

# include "bytedeque/type.h"
  
# define  LoadVectorOfBytes Lisp2D_LoadVectorOfBytesXR_W
bool  LoadVectorOfBytes ( StackClusterPrivate * ,PLOByteDeque  * dqr , Stream * fn , Deque ( WChar ) * dqbuf ) ;

# define  LoadSpace Lisp2DLoadSpace8JZB
bool  LoadSpace ( Stream * fn , Deque ( WChar ) * dqbufp  ) ;    

# define  LoadByte2 Lisp2D_LoadByte2zh0N
bool  LoadByte2 ( StackClusterPrivate * , uint8_t  * chr2 , Stream * fn , Deque ( WChar ) * dqbuf  ) ;

# define  LoadList  Lisp2D_LoadList1oEL
bool  LoadList  ( StackClusterPrivate * , ParaLispObject * * r  , Stream * fn , Deque ( WChar )  * dqbuf  ) ;

# define  LoadAtom  Lisp2DLoadAtomGUuC
bool  LoadAtom  ( StackClusterPrivate * const stclp , ParaLispObject * * r  , Stream * fn , Deque ( WChar ) * dqbuf  ) ;

# define  LoadProgram Lisp2DLoadProgram1x2y
ParaLispObject  * LoadProgram ( StackClusterPrivate *  , Stream  * ) ;

# define  StackClusterPrivate_LoadProgramS  Lisp2D_StackClusterPrivate_LoadProgramS
  // please create new env level
  // returns program: Assoc(main).CCDR
ParaLispObject  * StackClusterPrivate_LoadProgramS  ( StackClusterPrivate *, wchar_t volatile const * nmp ) ;

# define  StackClusterPrivate_CreateTaskForBackquote  Lisp2D_StackClusterPrivate_CreateTaskForBackquote
void  StackClusterPrivate_CreateTaskForBackquote ( StackClusterPrivate * , ParaLispObject  * , Vector ( StackPLOP ) * ) ;

// ! transport to stcl/inline.h
// !! when transfer gcc makes to CALL function
inline  StackClusterPrivate * GlobalListMemberToStackClusterPrivate  ( GlobalListMember * const p ) {
  if  ( GlobalListMemberVirt  ( p ) . type == TypeGlobalListMemberStClPriv  )
    return  ( StackClusterPrivate * ) ( GlobalListMemberVirt  ( p ) . addr . p ) ;
  return  0 ;
}

# endif // LISP2D_STCL_CLASSC_H
