// StackCluster Inline
// (C)2023

# ifndef  LISP2D_STCL_INLINE_H
# define  LISP2D_STCL_INLINE_H

/*
// !! gcc makes to CALL function
# include "globallistm/public.h"

inline  StackClusterPrivate * GlobalListMemberToStackClusterPrivate  ( GlobalListMember * const p ) {
  if  ( GlobalListMemberVirt  ( p ) . type == TypeGlobalListMemberStClPriv  )
    return  ( StackClusterPrivate * ) ( GlobalListMemberVirt  ( p ) . addr  ) ;
  return  0 ;
}

# include "globallistm/inline.h"
*/

# include "stcl/public.h"
# include "stcl/structpri.h"

inline struct  Lisp2DAddrForReturn2  StackClusterPrivate_flagcont  ( StackClusterPrivate const * const s ) {
  return s -> flagcont ;
}

inline  EvalAddrCont2 FlagCont ( StackClusterPrivate const * const stclp ) {
  EvalAddrPrivat const a = StackClusterPrivate_flagcont ( stclp ) . addr ;
  return  Lisp2DEvalAddrValue ( & a . pub ) ;
}

inline struct  Lisp2DStackClusterHistory * StackClusterPrivate_myHistory ( StackClusterPrivate * const s ) {
  return & s -> myHistory2 ;
}

# include "stclhistory.h"

inline bool  isBADResizeHistory  ( StackClusterPrivate  * const stclpp  , size_t  const newsize ) { // returns error
  return  Lisp2DStackClusterHistoryisBADResize ( StackClusterPrivate_myHistory ( stclpp ) , newsize ) ;
}

inline struct  Lisp2DStackClusterHistory const * StackClusterPrivate_myHistoryC ( StackClusterPrivate const * const s ) {
  return & s -> myHistory2 ;
}

inline bool  StackClusterPrivate_wanttobeingarbage ( StackClusterPrivate const * const s ) {
  return s -> wanttobeingarbage ;
}

inline void  StackClusterPrivate_setwanttobeingarbage ( StackClusterPrivate * const s , bool const g ) {
  s -> wanttobeingarbage = g ;
}

inline ParaLispObject  * StackClusterPrivate_exceptionhistory ( StackClusterPrivate const * const s ) {
  return s -> exceptionhistory ;
}

inline void  StackClusterPrivate_setexceptionhistory ( StackClusterPrivate * const s , ParaLispObject  * const eh ) {
  s -> exceptionhistory = eh ;
}

inline ParaLispObject  * StackClusterPrivate_exceptionvalue ( StackClusterPrivate const * const s ) {
  return s -> exceptionvalue ;
}

inline void StackClusterPrivate_setexceptionvalue ( StackClusterPrivate * const s , ParaLispObject  * const ev ) {
  s -> exceptionvalue = ev ;
}

inline bool  StackClusterPrivate_exceptionnotprocessed ( StackClusterPrivate const * const s ) {
  return s -> exceptionnotprocessed ;
}

inline void  StackClusterPrivate_setexceptionnotprocessed ( StackClusterPrivate * const s , bool const x ) {
  s -> exceptionnotprocessed  = x ;
}

inline ParaLispObject  * StackClusterPrivate_result ( StackClusterPrivate const * const s ) {
  return s -> result ;
}

inline ParaLispObject  * * StackClusterPrivate_resultp ( StackClusterPrivate * const s ) {
  return &  s -> result ;
}

inline void  StackClusterPrivate_setresult ( StackClusterPrivate * const s , ParaLispObject  * const v ) {
  s -> result = v ;
}

inline Environment * StackClusterPrivate_envLocal ( StackClusterPrivate * const s ) {
  return  & s ->  envLocal  ;
}

inline Environment const * StackClusterPrivate_envLocalc ( StackClusterPrivate const * const s ) {
  return  & s ->  envLocal  ;
}

inline Environment * StackClusterPrivate_envExternal ( StackClusterPrivate * const s ) {
  return  & s ->  envExternal  ;
}

inline Environment const * StackClusterPrivate_envExternalc ( StackClusterPrivate const  * const s ) {
  return  & s ->  envExternal  ;
}

inline ParaLispObject  * StackClusterPrivate_whole ( StackClusterPrivate const * const s ) {
  return s -> whole ;
}

inline ParaLispObject  * * StackClusterPrivate_wholep ( StackClusterPrivate * const s ) {
  return &  s -> whole ;
}

inline void StackClusterPrivate_setwhole ( StackClusterPrivate * const s , ParaLispObject  * const w ) {
  s -> whole =  w ;
}

inline bool  StackClusterPrivate_flagApplystate ( StackClusterPrivate const  * const s ) {
  return  s -> flagApply ;
}

inline void  StackClusterPrivate_setflagApply ( StackClusterPrivate * const s , bool const f ) {
  s -> flagApply = f ;
}

inline struct  Lisp2DAddrForReturn2  * StackClusterPrivate_flagcontp ( StackClusterPrivate * const s ) {
  return & s -> flagcont ;
}

inline void  StackClusterPrivate_setflagcont ( StackClusterPrivate * const s , struct  Lisp2DAddrForReturn2  * const x ) {
  s -> flagcont = * x ;
}

inline void  StackClusterPrivate_setflagcontv ( StackClusterPrivate * const s , struct  Lisp2DAddrForReturn2  const x ) {
  s -> flagcont = x ;
}

inline void  StackClusterPrivate_setTaskForManager ( StackClusterPrivate * const s , int const f ) {
  s ->  TaskForManager2 = f ;
}

inline int StackClusterPrivate_TaskForManager ( StackClusterPrivate const  * const s ) {
  return  s ->  TaskForManager2 ;
}

inline Vector  ( StackPLOP ) * StackClusterPrivate_stackcproArgp ( StackClusterPrivate * const s ) {
  return  & s ->  stackcproArg  ;
}

inline Vector  ( StackPLOP ) const * StackClusterPrivate_stackcMethodcp  ( StackClusterPrivate const * const s ) {
  return  & s ->  stackcMethod  ;
}

inline Vector  ( StackPLOP ) * StackClusterPrivate_stackcMethodp  ( StackClusterPrivate * const s ) {
  return  & s ->  stackcMethod  ;
}

inline ParaLispObject  * * StackClusterPrivate_resultplace ( StackClusterPrivate const * const s ) {
  return  s -> resultplace ;
}

inline void  StackClusterPrivate_setresultplace ( StackClusterPrivate  * const s , ParaLispObject  * * const x ) {
  s -> resultplace = x ;
}

inline void  StackClusterPrivate_setresultplaceforgc ( StackClusterPrivate  * const s , ParaLispObject  * const x ) {
  s -> resultplaceforgc = x ;
}

inline ParaLispObject  *  StackClusterPrivate_resultplaceforgc ( StackClusterPrivate const * const s ) {
  return s -> resultplaceforgc ;
}

inline Vector  ( StackPLOP ) * StackClusterPrivate_stackcp ( StackClusterPrivate * const s ) {
  return  & s ->  stackc  ;
}

inline Vector  ( StackAddrForReturn  ) * StackClusterPrivate_stackAddrp ( StackClusterPrivate * const s ) {
  return  & s ->  stackAddr  ;
}

inline Vector  ( StackAddrForReturn  ) const * StackClusterPrivate_stackAddrcp ( StackClusterPrivate const * const s ) {
  return  & s ->  stackAddr  ;
}

inline Vector  ( StackPLOP ) * StackClusterPrivate_stackcThisp ( StackClusterPrivate * const s ) {
  return  & s ->  stackcThis  ;
}

inline Vector  ( StackPLOP ) const * StackClusterPrivate_stackcThiscp ( StackClusterPrivate const * const s ) {
  return  & s ->  stackcThis  ;
}

inline void  StackClusterPrivate_sonscountinc ( StackClusterPrivate * const s ) {
  ++  (  s ->  sonscount )  ;
}

inline GlobalListMember *  StackClusterPrivate_globallistmember ( StackClusterPrivate * const s ) {
  return  & s -> base  ;
}

inline void StackClusterPrivate_setscFatherp  ( StackClusterPrivate * const s , StackClusterPrivate * const f ) {
  s -> scFatherp = f ;
}

inline StackClusterPrivate * StackClusterPrivate_scFatherp  ( StackClusterPrivate const * const s ) {
  return  s -> scFatherp ;
}

inline Lisp2DMutex * StackClusterPrivate_mutexExceptionC ( StackClusterPrivate * const s ) {
  return  & s -> mutexExceptionC ;
}

inline Lisp2DMutex * StackClusterPrivate_mutexTask ( StackClusterPrivate * const s ) {
  return  & s -> mutexTask ;
}

inline void  StackClusterPrivate_sethandtoqueue (  StackClusterPrivate * const s , ConsAtomicPointe * const h ) {
  s -> handtoqueue = h ;
}

inline ConsAtomicPointe * * StackClusterPrivate_handtoqueuelink ( StackClusterPrivate * const s ) {
  return & s -> handtoqueue ;
}

inline ConsAtomicPointe * StackClusterPrivate_handtoqueue ( StackClusterPrivate const * const s ) {
  return s -> handtoqueue ;
}

inline void  StackClusterPrivate_Push ( StackClusterPrivate * const stp , ParaLispObject * const xp  ) {
  Vector_PushByValue ( StackPLOP ) ( & stp ->  stackc  , xp ) ;
}

inline ParaLispObject * StackClusterPrivate_PopValue ( StackClusterPrivate * const stp ) {
  return  Lisp2DStackPLOPPopValue  ( & stp ->  stackc  ) ;
}

inline void  StackClusterPrivate_Popn ( StackClusterPrivate * const stp ) {
  VectorPop(StackPLOP) ( & stp ->  stackc  ) ;
}

inline ParaLispObject  * StackClusterPrivate_ThisTop ( StackClusterPrivate * const stp ) {
  return ( ParaLispObject * ) VectorBackCopy  ( StackPLOP ) ( & stp ->  stackcThis  ) ;
}

inline ParaLispObject  * StackClusterPrivate_ArgTop  ( StackClusterPrivate * const stp ) {
  return  VectorBackCopy  ( StackPLOP ) ( & stp ->  stackcproArg  ) ;
}

inline void  StackClusterPrivate_ReplaceArg  ( StackClusterPrivate * const stp , ParaLispObject * const ap ) {
  Lisp2DStackPLOPReplaceTopByValue  ( & stp ->  stackcproArg  , ap ) ;
}

# include "env/public.h"

inline ParaLispObject  * StackClusterPrivate_Env ( StackClusterPrivate const * const stp ) {
  return Environment_Env ( & stp ->  envLocal ) ;
}

inline ParaLispObject  * StackClusterPrivate_ExtEnv  ( StackClusterPrivate const * const stp ) {
  return  Environment_Env ( & stp ->  envExternal ) ;
}

inline void  StackClusterPrivate_EnvCDR  ( StackClusterPrivate * const stp ) {
  Environment_ReleaseLevel  ( & stp ->  envLocal ) ;
}

inline void  StackClusterPrivate_SetEnv  ( StackClusterPrivate * const stp , ParaLispObject * const ep  ) {
  Environment_SetEnv  ( & stp ->  envLocal , ep ) ;
}

inline void  StackClusterPrivate_SetExtEnv ( StackClusterPrivate * const stp , ParaLispObject  * const ep ) {
  Environment_SetEnv  ( & stp ->  envExternal , ep ) ;
}

inline void  StackClusterPrivate_SetEnv3 ( StackClusterPrivate * const stp , ParaLispObject  * const a ,
  ParaLispObject  * const c ) {
  Environment_SetPair ( & stp ->  envLocal , a , c ) ;
}

inline void  StackClusterPrivate_SetResult ( StackClusterPrivate * const stp , ParaLispObject  * const xp ) {
  stp -> result = xp ;
}

# endif //  LISP2D_STCL_INLINE_H
