// Lisp2D - StackCluster struct private
// ©2023 by Alex Glebe

# ifndef  LISP2D_STCL_STRUCTPRI_H
# define  LISP2D_STCL_STRUCTPRI_H

# include "env/struct.h"
# include "stclhistoryp.h"

struct  Lisp2D_s_StackClusterPrivate {
  GlobalListMember base ;
  //stack
  Vector ( StackPLOP ) stackc ;
  // this
  Vector ( StackPLOP ) stackcThis ;
  // method
  Vector ( StackPLOP ) stackcMethod ;
  // arguments
  Vector ( StackPLOP ) stackcproArg ;
  // env=((lock . #()|nil) .. (lock . #()|nil))
  Environment envLocal  ;
  // !! envExternal -- don't change (only with NAMESPACE)
  // !! rename envExternal -> envNameSpace
  Environment envExternal ;
  _Atomic ( size_t ) sonscount ;
  ParaLispObject  * result ;
  // place for result
  // v[0 .. i .. n-1] -> &v[i]
  ParaLispObject  * * resultplace ;
  // v[0 .. i .. n-1] -> &v
  ParaLispObject  * resultplaceforgc ;
  //virtual address of returning
  Vector ( StackAddrForReturn  ) stackAddr ;
  //parent of current task
  StackClusterPrivate * scFatherp ;
  // ! to make *father for FORKREGION (never nullptr)
  //interrupted task must be continued from the middle
  struct  Lisp2DAddrForReturn2  flagcont  ;
  ParaLispObject  * whole ;
  // !? to dismiss: mutexTask

  Lisp2DMutex mutexTask ;

// ! to rewrite to new version ...

  // !! to do: class Exception(mutex,val,his,flagprocessed)

  Lisp2DMutex mutexExceptionC ;

  // nil or atom or list or else
  ParaLispObject  * exceptionvalue ;
  // list
  ParaLispObject  * exceptionhistory ;
  struct  Lisp2DStackClusterHistory myHistory2  ;
  ConsAtomicPointe * handtoqueue ;
  int TaskForManager2 ;
  bool  wanttobeingarbage ;
  // true - exist ahead, false - working or processed or wasnot
  bool  exceptionnotprocessed ;
  bool  flagApply ;
} ;

# endif // LISP2D_STCL_STRUCTPRI_H
