// Lisp2D Thread's History
// (C)2019-23
# ifndef  LISP2D_STCLHISTORYP_H
# define  LISP2D_STCLHISTORYP_H
// private

# include "define.h"

typedef struct  Lisp2DStackClusterHistoryStep StackClusterHistoryStep ;
typedef struct  Lisp2DStackClusterHistory Lisp2D_tStackClusterHistory ;

struct  Lisp2DStackClusterHistoryStep {
  void  * This ;
  void  * Meth ; // may have nullptr
  void  * Arg ; // may have nullptr
# ifdef  LISP2D_DEBUGENV
  void  * Env ;
  void  * EnvExt ;
# endif  
} ;  

# ifdef LISP2D_DEBUG  
enum  Lisp2DStackClusterHistoryState  { Lisp2DStackClusterHistoryNotConstructed = 666 , Lisp2DStackClusterHistoryLive = 777 ,
  Lisp2DStackClusterHistoryDestructed = 999 , } ;
# endif  

struct  Lisp2DStackClusterHistory {
  StackClusterHistoryStep  * history ; // array of struct's
  // without Passage  
  size_t  sizeMemory  ; // size of a vectors
  size_t  indexPush ;  // destination to push 0 .. memorysize-1
# ifdef LISP2D_DEBUG
  enum  Lisp2DStackClusterHistoryState state ;
# endif
  bool  isFull  ; // all vectors are full
  bool  haveLostData  ; // was >memorySize elements
} ;

# endif // LISP2D_STCLHISTORYP_H
