// Lisp2D - String (char OR wide)
// ©2019-23 by Alex Glebe

# ifndef  LISP2D_STRINGDEFINE_H
# define  LISP2D_STRINGDEFINE_H

# define  LISP2D_STRING_TYPE( CHARN  ) \
struct sString  ( CHARN ) ; \
typedef struct sString  ( CHARN ) String  ( CHARN ) ;

# define LISP2DSTRINGSTRUCT( CHARN  ) \
struct sString  ( CHARN ) { \
  Vector  ( CHARN ) arr ;  \
} ;

# define  Lisp2DString( CHARN ) Lisp2DString  ##  CHARN ##  VMzS
# define  String  Lisp2DString

# define  Lisp2D_sString( CHARN ) Lisp2D_sString  ##  CHARN
# define  sString  Lisp2D_sString

# define  Lisp2D_String_Init( CHARN ) Lisp2DString  ##  CHARN ##  Init
# define  String_Init Lisp2D_String_Init

# define LISP2D_STRING_INIT_DECL( CHARN )  \
void String_Init ( CHARN ) ( String  ( CHARN ) * , bool ) ;

// ZERO = L'\0' or '\0'
# define LISP2DSTRINGINIT( CHARN , ZERO )  \
void String_Init ( CHARN ) ( String  ( CHARN ) * const me , bool const flagsecure ) { \
  VectorInitOne ( CHARN ) ( & me  ->  arr  , ZERO , flagsecure ) ; \
}

// CHART = wchar_t or char
# define LISP2DPROMOSTRINGCONSTRCSTR( CHARN , CHART )  \
void Lisp2DString ##  CHARN ##  ConstrCStr ( String  ( CHARN ) * me , CHART const * str , bool ) ;
# define  StringConstrCStr  Lisp2DStringConstrCStr
# define  Lisp2DStringConstrCStr( T ) Lisp2DString  ##  T ##  ConstrCStr

// FUNLEN = wcslen OR strlen
# define LISP2DSTRINGCONSTRCSTR( CHARN , CHART , VOLAT , FUNLEN )  \
void Lisp2DString ##  CHARN ##  ConstrCStr ( String  ( CHARN ) * const me , CHART VOLAT const * const str , bool const flagsecure ) { \
  Vector  ( CHARN ) * const parr = & me  ->  arr  ; \
  VectorInit  ( CHARN ) ( parr , flagsecure ) ; \
  size_t const arrs = FUNLEN  ( ( CHART const * ) str ) + 1UL ; \
  Vector_Resize ( CHARN ) ( parr , arrs ) ; \
  memcpy  ( ( CHART * ) ( VectorBegin ( CHARN ) ( parr ) ) , ( CHART const * ) str , arrs * sizeof ( CHART ) ) ; \
}

# define  Lisp2D_String_ConstrCopy( CHARN ) Lisp2DString  ##  CHARN ##  ConstrCopy
# define  String_ConstrCopy Lisp2D_String_ConstrCopy
  
// CHART = wchar_t or char
# define LISP2DPROMOSTRINGCONSTRCOPY( CHARN )  \
void String_ConstrCopy ( CHARN ) ( String  ( CHARN ) * , String  ( CHARN ) const * ) ;

# define LISP2DSTRINGCONSTRCOPY( CHARN )  \
void String_ConstrCopy ( CHARN ) ( String  ( CHARN ) * const me , \
  String  ( CHARN ) const * const x ) { \
  VectorConstrCopy ( CHARN ) ( & me  ->  arr , & x  ->  arr  ) ; \
}

# define  Lisp2D_String_ConstrMove( CHARN ) Lisp2DString  ##  CHARN ##  ConstrMove
# define  String_ConstrMove Lisp2D_String_ConstrMove

// CHART = wchar_t or char
# define LISP2DPROMOSTRINGCONSTRMOVE( CHARN )  \
void Lisp2DString ##  CHARN ##  ConstrMove ( String ( CHARN ) * me , String  ( CHARN ) * x ) ;

# define LISP2DSTRINGCONSTRMOVE( CHARN )  \
void Lisp2DString ##  CHARN ##  ConstrMove ( String ( CHARN ) * const me , \
  String  ( CHARN ) * const x ) { \
  VectorInitMove  ( CHARN ) ( & me  ->  arr  , & x  ->  arr  ) ; \
}

// FullLength :
// L"абв" => 4
// L"1" => 2
// L"" => 1
# define String_ConstrCStrFullLength( CHARN )  Lisp2DString ##  CHARN ##  ConstrCStrFullLength

# define LISP2DPROMOSTRINGCONSTRCSTRMEMSIZE( CHARN , CHART )  \
void  String_ConstrCStrFullLength ( CHARN ) ( String ( CHARN ) * me , \
  CHART const * str , size_t  FullLength , bool flagsecure ) ;
  
# define LISP2DSTRINGCONSTRCSTRMEMSIZE( CHARN , CHART , VOLAT )  \
void  String_ConstrCStrFullLength ( CHARN ) ( String ( CHARN ) * const me , \
  CHART const * const str , size_t const FullLength , bool const flagsecure ) { \
  Vector  ( CHARN ) * const parr = & me  ->  arr  ; \
  VectorInit  ( CHARN ) ( parr , flagsecure ) ; \
  Vector_Resize ( CHARN ) ( parr , FullLength ) ; \
  memcpy  ( ( CHART * ) VectorBegin ( CHARN ) ( parr ) , str , FullLength * sizeof  ( CHART ) ) ; \
}

# define  String_ConstrFillChar  Lisp2D_String_ConstrFillChar
# define  Lisp2D_String_ConstrFillChar(  CHARN ) \
  Lisp2D_String_  ##  CHARN ##  _ConstrFillChar
    
# define LISP2DPROMOSTRINGCONSTRFILLCHAR( CHARN , CHART )  \
void String_ConstrFillChar  ( CHARN ) ( String  ( CHARN ) * me , size_t  count , CHART ch , bool flagsecure ) ;
  
# define LISP2DSTRINGCONSTRFILLCHAR( CHARN , CHART )  \
void String_ConstrFillChar  ( CHARN ) ( String  ( CHARN ) * const me , \
  size_t const count , CHART const ch , bool const flagsecure ) { \
  Vector  ( CHARN ) * const parr = & me  ->  arr  ; \
  VectorInit  ( CHARN ) ( parr , flagsecure ) ; \
  Vector_Resize ( CHARN ) ( parr , count  + 1 ) ; \
  CHART * i = VectorBegin ( CHARN ) ( parr )  ; \
  CHART const * const e = VectorCEnd ( CHARN ) ( parr ) - 1 ; \
  while ( i < e ) { \
    ( * i ) = ch  ; \
    ++  i ; \
  } \
}

# define  StringDestr  Lisp2DStringDestr
# define  Lisp2DStringDestr( T ) Lisp2DString  ##  T ##  Destr

# define LISP2DPROMOSTRINGDESTR( CHARN )  \
void StringDestr  ( CHARN ) ( String  ( CHARN ) * )  ;
  
# define LISP2DSTRINGDESTR( CHARN )  \
void StringDestr  ( CHARN ) ( String ( CHARN ) * const me ) { \
  Vector_Destr  ( CHARN ) ( & me  ->  arr  ) ; \
}

# define  StringCStr  Lisp2DStringCStr
# define  Lisp2DStringCStr( T ) Lisp2DString  ##  T ##  CStr

# define LISP2D_STRING_CSTR_DECL( CHARN , CHART )  \
CHART const * StringCStr ( CHARN ) ( String ( CHARN ) const * ) ;

// CHART = wchar_t or char
# define LISP2DSTRINGCSTR( CHARN , CHART )  \
CHART const * StringCStr ( CHARN ) ( String ( CHARN ) const * const me ) { \
  return VectorCBegin ( CHARN ) ( & me  ->  arr  ) ; \
}

# define  StringCArr  Lisp2DStringCArr
# define  Lisp2DStringCArr( T ) Lisp2DString  ##  T ##  CArr
# define LISP2DSTRINGCARR_DECL( CHARN , ARRT )  \
ARRT  StringCArr ( CHARN ) ( String ( CHARN ) const * const me ) ;
// CHART = wchar_t or char
# define LISP2DSTRINGCARR( CHARN , CHART , ARRT )  \
ARRT  StringCArr ( CHARN ) ( String ( CHARN ) const * const me ) { \
  return ( ARRT ) { ( CHART const ( * ) [ ] ) VectorCBegin  ( CHARN ) ( & me  ->  arr ) } ; \
}

# define  Lisp2D_String_Begin(  CHARN ) Lisp2D_String_  ##  CHARN ##  _Begin
# define  String_Begin Lisp2D_String_Begin
  
// CHART = wchar_t or char
# define LISP2DSTRINGBEGIN_DECL( CHARN , CHART )  \
CHART * String_Begin  ( CHARN ) ( String  ( CHARN ) * me ) ;

# define LISP2DSTRINGBEGIN( CHARN , CHART )  \
CHART * String_Begin  ( CHARN ) ( String  ( CHARN ) * const me ) { \
  return VectorBegin  ( CHARN ) ( & me  ->  arr  ) ; \
}

# define  Lisp2D_String_CBegin(  CHARN ) Lisp2DString ##  CHARN ##  CBegin
# define  String_CBegin Lisp2D_String_CBegin

// CHART = wchar_t or char
# define LISP2DSTRINGCBEGIN( CHARN , CHART )  \
CHART const * String_CBegin ( CHARN ) ( String ( CHARN ) const * const me ) { \
  return VectorCBegin ( CHARN ) ( & me  ->  arr  ) ; \
}

# define LISP2D_STRING_CBEGIN_DECL( CHARN , CHART )  \
CHART const * String_CBegin ( CHARN ) ( String ( CHARN ) const * ) ;

# define  Lisp2D_String_CEnd(  CHARN ) Lisp2DString ##  CHARN ##  CEnd
# define  String_CEnd Lisp2D_String_CEnd

// points to zero '\0' or L'\0'
# define  LISP2D_STRING_CEND_DECL(  CHARN , CHART ) \
CHART const * String_CEnd ( CHARN ) ( String  ( CHARN ) const * ) ;

# define LISP2DSTRINGCEND( CHARN , CHART )  \
CHART const * String_CEnd ( CHARN ) ( String  ( CHARN ) const * const me ) { \
  return VectorCEnd ( CHARN )  ( & me  ->  arr  ) - 1UL ; \
}

# define  Lisp2D_String_AddChar(  CHARN ) Lisp2D_String_  ##  CHARN ##  _AddChar
# define  String_AddChar  Lisp2D_String_AddChar
  
// CHART = wchar_t or char
# define LISP2DPROMOSTRINGADDCHAR( CHARN , CHART )  \
void String_AddChar ( CHARN ) ( String  ( CHARN ) * me , CHART c ) ;

// ZERO = L'\0' or '\0'
# define LISP2DSTRINGADDCHAR( CHARN , CHART , ZERO )  \
void String_AddChar ( CHARN ) ( String  ( CHARN ) * const me , CHART volatile const c ) { \
  Vector  ( CHARN ) * const parr = & me  ->  arr  ; \
  Vector_PushByValue  ( CHARN ) ( parr , ZERO ) ; \
  ( * VectorAt  ( CHARN )  ( parr , VectorSizeCopy  ( CHARN ) ( parr  ) - 2UL ) ) = c ; \
}
  
# define  Lisp2D_String_Empty( CHARN ) Lisp2D_String_  ##  CHARN ##  _Empty
# define  String_Empty  Lisp2D_String_Empty

# define LISP2DSTRINGEMPTY( CHARN )  \
bool String_Empty ( CHARN ) ( String  ( CHARN ) const * const me ) { \
  return VectorSizeCopy ( CHARN ) ( & me  ->  arr  ) <= 1UL ; \
}

# define LISP2D_STRING_EMPTY_DECL( CHARN )  \
bool String_Empty ( CHARN ) ( String  ( CHARN ) const * ) ;

# define  String_Size(  CHARN ) Lisp2DString  ##  CHARN ##  Size
  
# define LISP2DSTRINGSIZE( CHARN )  \
size_t String_Size  (  CHARN ) ( String ( CHARN ) const * const me ) { \
  return VectorSizeCopy ( CHARN ) ( & me  ->  arr  ) - 1UL ; \
}

# define LISP2D_STRING_SIZE_DECL( CHARN )  \
size_t String_Size  (  CHARN ) ( String ( CHARN ) const * ) ;

# define  String_EltCopy( CHARN ) Lisp2DString  ##  CHARN ##  EltCopy
  
# define LISP2DSTRINGELTCOPY( CHARN , CHART )  \
CHART String_EltCopy  ( CHARN ) ( String  ( CHARN ) const * const me , size_t const  ind ) { \
  return Vector_EltCopy ( CHARN ) ( & me  ->  arr  , ind ) ; \
}

# define LISP2D_STRING_ELTCOPY_DECL( CHARN , CHART )  \
CHART String_EltCopy  ( CHARN ) ( String  ( CHARN ) const * , size_t ind ) ;

# define  StringEltCAddr(  CHARN ) Lisp2DString ##  CHARN ##  EltCAddr6013
  
# define LISP2DSTRINGELTCADDR_DECL( CHARN , CHART )  \
CHART const * StringEltCAddr  (  CHARN ) ( String ( CHARN ) const * me , size_t ind ) ;

# define LISP2DSTRINGELTCADDR( CHARN , CHART )  \
CHART const * StringEltCAddr  (  CHARN ) ( String(CHARN) const * const me , size_t ind ) { \
  return VectorCAt  ( CHARN ) ( & me  ->  arr  , ind ) ; \
}

# define  StringEltAddr(  CHARN ) Lisp2D_String_  ##  CHARN ##  _EltAddr
  
# define LISP2DSTRINGELTADDR_DECL( CHARN , CHART )  \
CHART * StringEltAddr (  CHARN ) ( String ( CHARN ) * me , size_t ind ) ;

# define LISP2DSTRINGELTADDR( CHARN , CHART )  \
CHART * StringEltAddr (  CHARN ) ( String ( CHARN ) * const me , size_t const  ind ) { \
  return VectorAt ( CHARN ) ( & me  ->  arr  , ind ) ; \
}

# define  StringAddString( CHARN )  Lisp2DString  ##  CHARN ##  AddString
  
# define LISP2DPROMOSTRINGADDSTRING( CHARN )  \
void StringAddString  ( CHARN ) ( String  ( CHARN ) * const me , \
  String  ( CHARN ) const * const from ) ;

// CHART = wchar_t or char
# define LISP2DSTRINGADDSTRING( CHARN , CHART , ZERO )  \
void  StringAddString  ( CHARN ) ( String  ( CHARN ) * const me , \
  String  ( CHARN ) const * const from  ) { \
  Vector  ( CHARN ) * const marr = & me  ->  arr  ; \
  size_t const ms = VectorSizeCopy  ( CHARN ) ( marr ) ; \
  if ( me == from ) { \
    size_t const ns = ms + ms - 1U ; \
    Vector_Resize ( CHARN ) ( marr , ns ) ; \
    ( * VectorAt  ( CHARN )  ( marr , ns - 1U ) ) = ZERO ; \
    memcpy  ( ( CHART * ) VectorAt  ( CHARN )  ( marr , ms - 1U ) , \
      ( CHART const * ) ( VectorCBegin  ( CHARN ) ( marr ) ) , sizeof(CHART) * ( ms - 1U ) ) ; \
  } else { \
    Vector  ( CHARN ) const * const farr = & from  ->  arr  ; \
    size_t const fs = VectorSizeCopy(CHARN)  ( farr ) ; \
    Vector_Resize ( CHARN ) ( marr , ms + fs - 1U ) ; \
    memcpy ( ( CHART * ) VectorAt  ( CHARN )  ( marr , ms - 1U ) , \
      ( CHART const * ) ( VectorCBegin  ( CHARN ) ( farr ) ) , sizeof ( CHART ) * fs ) ; \
  } \
}
  
# define  StringAddCharArray( CHARN )  Lisp2DString ##  CHARN ##  AddCharArray
  
# define LISP2DPROMOSTRINGADDCHARARRAY( CHARN , CHART )  \
void StringAddCharArray ( CHARN ) ( String(CHARN) * const me , CHART const * const from ) ;

// CHART = wchar_t or char
// FUNLEN = wcslen OR strlen
# define LISP2DSTRINGADDCHARARRAY( CHARN , CHART , VOLAT , FUNLEN )  \
void StringAddCharArray ( CHARN ) ( String  ( CHARN ) * const me , CHART VOLAT const * const from ) { \
  Vector(CHARN) * const marr = & me  ->  arr  ; \
  size_t const ms = VectorSizeCopy(CHARN)  ( marr ) ; \
  CHART VOLAT const * const mybegin = VectorCBegin  ( CHARN ) ( marr ) ; \
  if ( (mybegin <= from) and (from < mybegin + ms) ) { \
    size_t  const indexfrom = (size_t)( from - mybegin ) ; \
    size_t const diffs = ms - 1U - indexfrom ; \
    size_t const ns = ms + diffs ; \
    Vector_Resize ( CHARN ) ( marr , ns ) ; \
    /* ! mybegin, from is not valid */ \
    ( * VectorAt  ( CHARN )  ( marr , ns - 1U ) ) = 0 ; \
    memcpy ( ( CHART * ) VectorAt  ( CHARN )  ( marr , ms - 1U ) , \
      ( CHART const * ) ( VectorCBegin  ( CHARN )  ( marr ) + indexfrom ) , sizeof  ( CHART ) * diffs ) ; \
  } else { \
    size_t const fs = FUNLEN ( ( CHART const * ) from ) ; \
    Vector_Resize ( CHARN ) ( marr , ms + fs ) ; \
    memcpy ( ( CHART * ) VectorAt  ( CHARN )  ( marr , ms - 1U ),  \
      ( CHART const * ) from , sizeof ( CHART ) * ( fs + 1UL ) ) ; \
  } \
}

# define  StringSetArray( CHARN )  Lisp2DString ##  CHARN ##  SetArray
  
# define LISP2DPROMOSTRINGSETARRAY( CHARN , CHART )  \
void StringSetArray ( CHARN ) ( String  ( CHARN ) * me , CHART const * from ) ;

// CHART = wchar_t or char
# define LISP2DSTRINGSETARRAY( CHARN , CHART , VOLAT , FUNLEN )  \
void StringSetArray ( CHARN ) ( String ( CHARN ) * const me , CHART VOLAT const * const from ) { \
  Vector  ( CHARN ) * const marr = & me  ->  arr  ; \
  size_t const ms = VectorSizeCopy  ( CHARN ) ( marr ) ; \
  CHART VOLAT * const mybegin = VectorBegin ( CHARN ) ( marr ) ; \
  size_t const fs = FUNLEN ( ( CHART const * ) from ) ; \
  if ( (  mybegin <= from ) and ( from < mybegin + ms ) ) { \
    memmove ( ( CHART * ) mybegin , ( CHART const * ) from , fs + 1UL ) ; \
    Vector_Resize ( CHARN ) ( marr , fs + 1UL ) ; \
  } else { \
    Vector_Resize ( CHARN ) ( marr , fs + 1UL ) ; \
    memcpy ( ( CHART * ) ( VectorBegin  ( CHARN ) ( marr ) ) , \
      ( CHART const * ) from , sizeof ( CHART ) * ( fs + 1UL ) ) ; \
  } \
}

# define  StringSet( CHARN )  Lisp2D_String_ ## CHARN ## _Set
      
# define LISP2DPROMOSTRINGSET( CHARN )  \
void StringSet( CHARN ) ( String(CHARN) * me , String(CHARN) const * you ) ;
      
# define LISP2DSTRINGSET( CHARN )  \
void StringSet( CHARN ) ( String(CHARN) * const me , \
  String(CHARN) const * const you ) { \
  Vector(CHARN) * const parr = & me  ->  arr  ; \
  Vector(CHARN) const * const yarr = & you ->  arr ; \
  VectorSet(CHARN)(parr,yarr); \
}
      
# define  StringClear( CHARN )  Lisp2D_String  ##  CHARN ##  Clear
      
# define LISP2DPROMOSTRINGCLEAR( CHARN )  \
void StringClear( CHARN ) ( String  ( CHARN ) * ) ;

# define LISP2DSTRINGCLEAR( CHARN , ZERO )  \
void StringClear  ( CHARN ) ( String  ( CHARN ) * const me ) { \
  Vector  ( CHARN ) * const parr = & me  ->  arr  ; \
  Vector_Resize1  ( CHARN ) ( parr  ) ; \
  ( * VectorAt  ( CHARN ) ( parr , 0 ) ) = ZERO ; \
}

# define  StringResize( CHARN )  Lisp2D_String_ ## CHARN ## _Resize
  
# define LISP2DPROMOSTRINGRESIZE( CHARN , CHART )  \
void StringResize ( CHARN ) ( String  ( CHARN ) * , size_t , CHART ) ;
  
// CHART = wchar_t or char
// CHARZ = '\00' or L'\00' or any
# define LISP2DSTRINGRESIZE( CHARN , CHART , CHARZ )  \
void StringResize ( CHARN ) ( String  ( CHARN ) * const me , \
  size_t const newsize , CHART const ch ) { \
  Vector  ( CHARN ) * const marr = & me  ->  arr ; \
  size_t const vs = VectorSizeCopy(CHARN)  ( marr ) ; \
  size_t const ns = newsize + 1 ; \
  if ( vs < ns ) { \
    Vector_Resize ( CHARN ) ( marr , ns ) ; \
    CHART * j = VectorAt  ( CHARN )  ( marr , vs ? vs - 1 : 0 ) ; \
    while ( j < VectorAt  ( CHARN )  ( marr , newsize ) ) { \
      ( * j ) = ch ; \
      ++ j ; \
    } \
    ( * j ) = CHARZ ; \
  } else if ( vs > ns ) { \
    Vector_Resize ( CHARN ) ( marr , ns ) ; \
    ( * VectorAt  ( CHARN )  ( marr , newsize ) ) = CHARZ ; \
  } \
}

# define  StringSwap( CHARN )  Lisp2D_String_ ## CHARN ## _Swap
  
# define LISP2DPROMOSTRINGSWAP( CHARN )  \
void StringSwap( CHARN ) ( String(CHARN) * , String(CHARN) * ) ;

# define LISP2DSTRINGSWAP( CHARN )  \
void StringSwap ( CHARN ) ( String  ( CHARN ) * const me , String ( CHARN ) * const you ) { \
  if ( me not_eq you ) \
    Vector_Swap ( CHARN ) ( & me  ->  arr , & you  ->  arr ) ; \
}

# define  StringReplace( CHARN )  Lisp2D_String_ ## CHARN ## _Replace

# define LISP2DPROMOSTRINGREPLACE( CHARN )  \
void StringReplace  ( CHARN ) ( String  ( CHARN ) * me , size_t index , \
  size_t  length  , String  ( CHARN ) const * str ) ;

# define LISP2DSTRINGREPLACE( CHARN , CHART )  \
void StringReplace  ( CHARN ) ( String  ( CHARN ) * const me , size_t const index , \
  size_t  length  , String  ( CHARN ) const * const str ) { \
  if ( me not_eq str ) { \
    size_t const strsize = String_Size  ( CHARN ) ( str ) ; \
    size_t const oldmysize = String_Size  (  CHARN )  ( me  ) ; \
    if ( index > oldmysize ) { \
      Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & \
        L"StringReplace:index > oldmysize" ; \
      longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
    } \
    if ( index + length > oldmysize ) \
      length = oldmysize - index ; \
    Vector  ( CHARN ) * const parr = & me  ->  arr  ; \
    if  ( length  < strsize ) { \
      Vector_Resize ( CHARN ) ( parr , \
        oldmysize + strsize - length  + 1 ) ; /* + '\00' */ \
      memmove  (  \
        ( CHART * ) ( VectorAt  ( CHARN ) ( parr , index + strsize ) ) , \
        ( CHART * ) ( VectorAt  ( CHARN ) ( parr , index + length ) ) , \
        ( oldmysize - index - length +  1 ) * sizeof ( CHART ) ) ; /* + '\00' */ \
    } else if ( length  > strsize ) { \
      memmove  (  \
        ( CHART * ) ( VectorAt  ( CHARN ) ( parr , index + strsize ) ) , \
        ( CHART * ) ( VectorAt  ( CHARN ) ( parr , index + length ) ) , \
        ( oldmysize - index - length +  1 ) * sizeof ( CHART ) ) ; /* + '\00' */ \
      Vector_Resize ( CHARN ) ( parr , \
        oldmysize + strsize - length  + 1 ) ; /* + '\00' */ \
    } \
    Vector  ( CHARN ) const * const sarr = & str ->  arr  ;  \
    memcpy  ( \
      ( CHART * ) ( VectorAt  ( CHARN )  ( parr , index ) ) , \
      ( CHART const * ) ( VectorCBegin ( CHARN ) ( sarr ) ) , \
      strsize * sizeof ( CHART ) ) ; \
  } \
}
    
# define  StringReplaceChars( CHARN )  Lisp2D_String_ ## CHARN ## _ReplaceChars

# define LISP2DPROMOSTRINGREPLACECHARS( CHARN , CHART )  \
void StringReplaceChars  ( CHARN ) ( String  ( CHARN ) * me , \
  size_t index , size_t  length  , size_t count , CHART ch ) ;

# define LISP2DSTRINGREPLACECHARS( CHARN , CHART , VOLAT )  \
void StringReplaceChars ( CHARN ) ( String  ( CHARN ) * const me , \
  size_t const index , size_t  length  , size_t const count , CHART VOLAT const ch ) { \
  Vector  ( CHARN ) * const parr = & me  ->  arr  ; \
  size_t const oldmysize = String_Size  (  CHARN )  ( me  ) ; \
  if ( index > oldmysize ) { \
    Lisp2DExceptionStringGlobal . str = ( wchar_t const ( * ) [ ] ) & \
      L"StringReplaceChars:index > oldmysize" ; \
    longjmp ( * Lisp2DJBglobal , Lisp2DExcTypeString ) ; \
  } \
  if ( index + length > oldmysize ) \
    length = oldmysize - index ; \
  if  ( length  < count ) { \
    Vector_Resize ( CHARN ) ( parr , \
      oldmysize + count - length  + 1 ) ; /* + '\00' */ \
    memmove  (  \
      ( CHART * ) VectorAt  ( CHARN ) ( parr , index + count ) , \
      ( CHART * ) VectorAt  ( CHARN ) ( parr , index + length ) , \
      ( oldmysize - index - length +  1 ) * sizeof ( CHART ) ) ; /* + '\00' */ \
  } else if ( length  > count ) { \
    memmove  (  \
      ( CHART * ) VectorAt  ( CHARN ) ( parr , index + count ) , \
      ( CHART * ) VectorAt  ( CHARN ) ( parr , index + length ) , \
      ( oldmysize - index - length +  1 ) * sizeof ( CHART ) ) ; /* + '\00' */ \
    Vector_Resize ( CHARN ) ( parr , \
      oldmysize + count - length  + 1 ) ; /* + '\00' */ \
  } \
  CHART VOLAT * ind = VectorAt  ( CHARN ) ( parr  , index ) ; \
  CHART VOLAT const * const indend = VectorAt  ( CHARN ) ( parr  , index + count ) ; \
  while ( ind < indend ) { \
    ( * ind ) = ch ; \
    ++  ind ; \
  } \
}
    
# endif // LISP2D_STRINGDEFINE_H
