// Lisp2D - String inline public
// ©2023 by Alex Glebe

# ifndef  LISP2D_STRING_INLINE_H
# define  LISP2D_STRING_INLINE_H

inline  String  ( WideChar  ) * voidpcaststringwcharp ( void * const p ) {
  return ( String  ( WideChar  ) * ) p ;
}

inline  bool  PLOString_More ( PLOStringPub const * const xp , PLOStringPub const * const yp ) {
  return PLOString_Less ( yp  , xp  ) ;
}

# include "string/private.h"
# include "string/struct.h"

inline  void PLOString_Clear ( PLOStringPub * const me ) {
  PLOStringPri * const mep = StringPub_cast_StringPri ( me ) ;
  StringClear ( WideChar )  ( & mep -> value ) ;
}

inline  String  ( WideChar  ) const * PLOString_CValue ( PLOStringPub const * const me ) {
  PLOStringPri const * const mep = StringPub_cast_StringPriConst ( me ) ;
  return  & mep -> value ;
}

inline  String  ( WideChar  ) * PLOString_Value2 ( PLOStringPub * const me ) {
  PLOStringPri * const mep = StringPub_cast_StringPri ( me ) ;
  return  & mep -> value ;
}

inline  wchar_t volatile const * PLOString_CStr ( PLOStringPub const * const me ) {
  PLOStringPri const * const mep = StringPub_cast_StringPriConst ( me ) ;
  return  StringCStr  ( WideChar  ) ( & mep -> value ) ;
}

inline  void PLOString_ResizeLet  ( PLOStringPub * const me , size_t const s  , wchar_t volatile const c ) {
  PLOStringPri * const mep = StringPub_cast_StringPri ( me ) ;
  StringResize  ( WideChar  ) ( & mep -> value , s , c ) ;
}

inline  PLOStringPub const * ParaLispObjectToPLOStringConst ( ParaLispObject const * p ) {
  return & ( ( ( PLOStringPri const * ) ( p  ->  vaddr . addr . p ) ) -> pub ) ;
}

inline  PLOStringPub * ParaLispObjectToPLOString ( ParaLispObject * const p ) {
  return & ( ( ( PLOStringPri * ) ( p  ->  vaddr . addr . p ) ) -> pub ) ;
}

# include "string/inlinepri.h"

# endif // LISP2D_STRING_INLINE_H
