// Lisp2D - String public
// ©2006-23 by Alex Glebe
# ifndef  LISP2D_STRING_PUBLIC_H
# define  LISP2D_STRING_PUBLIC_H
# include "define.h"

# ifdef  LISP2D_CONSTRSTAT
# include <stdlib.h>
size_t  PLOString_constrstatValue ( void  ) ;

void  PLOString_constrstatInc ( void  ) ;

# endif // LISP2D_CONSTRSTAT

# include "string/type.h"

// returns new PLOString or exception
# define  PLOString_New Lisp2D_PLOString_New
PLOStringPub * PLOString_New ( void ) ;

// returns new PLOString or exception
# define  PLOString_NewCopyPLOString  Lisp2D_PLOString_NewCopyPLOString
PLOStringPub * PLOString_NewCopyPLOString ( PLOStringPub * ) ;

# include <stddef.h>

// returns new PLOString or exception
# define  PLOString_NewCopy Lisp2D_PLOString_NewCopy
PLOStringPub * PLOString_NewCopy ( wchar_t volatile const *  ) ;

// returns new PLOString or exception
# define  PLOString_NewWChar Lisp2D_PLOString_NewWChar
PLOStringPub * PLOString_NewWChar ( wchar_t ) ;

# include "widestring.h"

// returns new PLOString or exception
# define  PLOString_NewMoveString Lisp2D_PLOString_NewMoveString
PLOStringPub * PLOString_NewMoveString ( String  ( WideChar ) * ) ;

# include "parray.h"

# define  PLOString_NewCopyArr  Lisp2D_PLOString_NewCopyArr
PLOStringPub * PLOString_NewCopyArr ( PArray_wchar_c ) ;

# define  PLOString_NewStrBeg Lisp2D_PLOString_NewStrBeg
PLOStringPub * PLOString_NewStrBeg ( PLOStringPub  const * vp , size_t indexfirst ) ;

# define  s_PLOString_NewStrBegEnd  Lisp2D_s_PLOString_NewStrBegEnd
# define  t_PLOString_NewStrBegEnd  Lisp2D_t_PLOString_NewStrBegEnd
typedef struct  s_PLOString_NewStrBegEnd  t_PLOString_NewStrBegEnd  ;
struct  s_PLOString_NewStrBegEnd  {
  PLOStringPub  const * const vp ;
  size_t const  indexfirst ;
  size_t const  indexend  ;
} ;

# define  PLOString_NewStrBegEnd Lisp2D_PLOString_NewStrBegEnd
PLOStringPub * PLOString_NewStrBegEnd ( t_PLOString_NewStrBegEnd ) ;

# include "plo/struct.h"
  
# define  PLOString_staticDestr Lisp2D_PLOString_staticDestr
void PLOString_staticDestr  ( ParaLispObject * ) ;

# define  PLOString_Eq  Lisp2D_PLOString_Eq
bool  PLOString_Eq  ( PLOStringPub const * , PLOStringPub const * ) ;

# define  PLOString_NotEq  Lisp2D_PLOString_NotEq
bool  PLOString_NotEq  ( PLOStringPub const * , PLOStringPub const * ) ;

# define  PLOString_staticTypeOf  Lisp2D_PLOString_staticTypeOf
ParaLispObject  * PLOString_staticTypeOf ( ParaLispObject const *  ) ;

# define  PLOString_staticClassDef  Lisp2D_PLOString_staticClassDef
ParaLispObject  * PLOString_staticClassDef  ( ParaLispObject const *  ) ;

# define  PLOString_staticClassParents  Lisp2D_PLOString_staticClassParents
ParaLispObject  * PLOString_staticClassParents  ( ParaLispObject const *  ) ;

# define  PLOString_staticisBADCopyPrivate  Lisp2D_PLOString_staticisBADCopyPrivate
bool  PLOString_staticisBADCopyPrivate ( ParaLispObject const * me , ParaLispObject  * * resultp  ) ;

# include "plostream/type.h"

# define  PLOString_staticCoutToHuman Lisp2D_PLOString_staticCoutToHuman
void  PLOString_staticCoutToHuman ( ParaLispObject const * me , PLOStream  const * s ,
  bool flag2pprinted  , Vector  ( StackPLOP ) * h ) ;

# define  PLOString_staticCoutToInterpret Lisp2D_PLOString_staticCoutToInterpret
void  PLOString_staticCoutToInterpret ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector  ( StackPLOP )  *  h ) ;

# define  PLOString_SetCStr Lisp2D_PLOString_SetCStr
void  PLOString_SetCStr ( PLOStringPub * me , wchar_t const * ws ) ;

# define  PLOStringMoveString Lisp2D_PLOStringMoveString
void  PLOStringMoveString ( PLOStringPub * me , String ( WideChar ) * ws ) ;

# define  PLOString_Addws Lisp2D_PLOString_Addws
void  PLOString_Addws ( PLOStringPub  * , wchar_t volatile const * )  ;

# define  Stringp Lisp2D_Stringp
bool  Stringp ( ParaLispObject  const * ) ;

# define  PLOString_Add Lisp2D_PLOString_Add
void PLOString_Add ( PLOStringPub  * mep , PLOStringPub  const * xp ) ;

# define  PLOString_Less  Lisp2D_PLOString_Less
bool  PLOString_Less ( PLOStringPub const * , PLOStringPub  const * ) ;

# include "char/type.h"

# define  PLOStringAddPLOChar Lisp2D_PLOStringAddPLOChar
void  PLOStringAddPLOChar ( PLOStringPub  * , PLOCharPub  const * ) ;

# include "plocomplex/type.h"
# include "taskforthread.h" // StackClusterPrivate

# define  PLOString_AssignSubSeq  Lisp2D_PLOString_AssignSubSeq
void PLOString_AssignSubSeq  ( PLOStringPub * , PLOStringPub  *  , PLOComplex  * , PLOComplex  * , StackClusterPrivate  * ) ;
  
# define  PLOString_AssignSubSeqEnd Lisp2D_PLOString_AssignSubSeqEnd
void PLOString_AssignSubSeqEnd  ( PLOStringPub * , PLOStringPub  * , PLOComplex  * , StackClusterPrivate  * ) ;

# include "string/type.h"
# include "plo/struct.h"

# define  ParaLispObjectToPLOString Lisp2DParaLispObjectToPLOString
inline  PLOStringPub * ParaLispObjectToPLOString ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOStringConst Lisp2DParaLispObjectToPLOStringConst
inline  PLOStringPub const * ParaLispObjectToPLOStringConst ( ParaLispObject const * ) ;
# define  PLOString_Resize  Lisp2D_PLOString_Resize
void PLOString_Resize  ( PLOStringPub * , size_t ) ;
# define  PLOString_ResizeLet Lisp2D_PLOString_ResizeLet
inline  void PLOString_ResizeLet  ( PLOStringPub * , size_t , wchar_t ) ;
# define  PLOString_Set Lisp2D_PLOString_Set
void  PLOString_Set ( PLOStringPub * , PLOStringPub const * ) ;
# define  PLOString_CStr  Lisp2D_PLOString_CStr
inline  wchar_t volatile const * PLOString_CStr ( PLOStringPub const * ) ;
# define  PLOString_Value2  Lisp2D_PLOString_Value2
inline  String  ( WideChar  ) * PLOString_Value2 ( PLOStringPub * ) ;
# define  PLOString_CValue  Lisp2D_PLOString_CValue
inline  String  ( WideChar  ) const * PLOString_CValue ( PLOStringPub const * ) ;
# define  PLOString_Swap  Lisp2D_PLOString_Swap
void  PLOString_Swap  ( PLOStringPub * , PLOStringPub * ) ;

# define  PLOString_Clear Lisp2D_PLOString_Clear
inline  void PLOString_Clear ( PLOStringPub * ) ;
# define  sPLOString_Replace  Lisp2D_sPLOString_Replace
struct  sPLOString_Replace {
  PLOStringPub * const me ;
  size_t const index ;
  size_t const  length  ;
  PLOStringPub const * const str ;
} ;
# define  PLOString_Replace Lisp2D_PLOString_Replace
void  PLOString_Replace ( struct  sPLOString_Replace const * ) ;
# define  PLOString_More  Lisp2D_PLOString_More
inline  bool  PLOString_More ( PLOStringPub const * , PLOStringPub const * ) ;
# define  PLOString_LessEq  Lisp2D_PLOString_LessEq
bool  PLOString_LessEq  ( PLOStringPub  const * , PLOStringPub const * ) ;
# define  PLOString_MoreEq  Lisp2D_PLOString_MoreEq
bool  PLOString_MoreEq ( PLOStringPub  const * , PLOStringPub const * ) ;
# define  voidpcaststringwcharp Lisp2D_voidpcaststringwcharp
inline  String  ( WideChar  ) * voidpcaststringwcharp ( void * ) ;

# include "string/inline.h"

# endif // LISP2D_STRING_PUBLIC_H
