// Lisp2D - Symbol
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_SYMBOLC_H
# define  LISP2D_SYMBOLC_H
# include "define.h"
# ifdef  LISP2D_CONSTRSTAT  
# include <stdatomic.h>
# endif
# include "plo/struct.h"
# include "widestring.h"
# include "parray.h"
# include "symbol/type.h"

// ! to replace to symbol/struct.h

// symbol is const any time
struct sLisp2DPLOSymbol {
  ParaLispObject  plo ;
  String  ( WideChar  )  value  ;
} ;

# define  PLOSymbolAddConstrStatFunc  Lisp2DPLOSymbolAddConstrStatFunc
void  PLOSymbolAddConstrStatFunc  ( void  ) ;  

# define  PLOSymbolConstrStatValue  Lisp2DPLOSymbolConstrStatValue
size_t  PLOSymbolConstrStatValue  ( void  ) ;  

# ifdef  LISP2D_CONSTRSTAT  
# define  PLOSymbolconstrstat Lisp2DPLOSymbolconstrstat
extern  _Atomic  ( size_t  ) PLOSymbolconstrstat  ;
# endif

# ifdef  LISP2D_CONSTRSTAT  
  # define  Lisp2DPLOSymbolAddConstrStat  ++  PLOSymbolconstrstat  ;
# else
  # define  Lisp2DPLOSymbolAddConstrStat
# endif
  
# define  PLOSymbolAddConstrStat  Lisp2DPLOSymbolAddConstrStat

# include "plo/public.h"

# define  PLOSymbolInit Lisp2DPLOSymbolInit
inline  void PLOSymbolInit ( PLOSymbol * me ) ;

# define  PLOSymbolDestr Lisp2DPLOSymbolDestr
void  PLOSymbolDestr ( PLOSymbol * me ) ;

# define  PLOSymbolConstrWCharArray Lisp2DPLOSymbolConstrWCharArray
void  PLOSymbolConstrWCharArray ( PLOSymbol * me , PArray_wchar_c c ) ;

# define  PLOSymbolConstrWCharStringMove Lisp2DPLOSymbolConstrWCharStringMove
void  PLOSymbolConstrWCharStringMove ( PLOSymbol * , String  ( WideChar  )  * ) ;

// ! to rename PLOSymbolConstrWCharStringCopy_Exc

# define  PLOSymbolConstrWCharStringCopy Lisp2DPLOSymbolConstrWCharStringCopy
inline  void PLOSymbolConstrWCharStringCopy ( PLOSymbol * me , String  ( WideChar  )  const * xp ) ;

# define  ParaLispObjectToPLOSymbol Lisp2DParaLispObjectToPLOSymbol
inline  PLOSymbol * ParaLispObjectToPLOSymbol ( ParaLispObject * p ) ;

# define  PLOSymbolstaticDestr  Lisp2DPLOSymbolstaticDestr
void  PLOSymbolstaticDestr  ( ParaLispObject * me ) ;

# define  PLOSymbolCValue Lisp2DPLOSymbolCValue
inline  String  ( WideChar  ) const * PLOSymbolCValue ( PLOSymbol const * s ) ;
  
# define  PLOSymbolTypeOf Lisp2DPLOSymbolTypeOf
ParaLispObject  * PLOSymbolTypeOf ( ParaLispObject const * ) ;  

extern  PLOSymbol plosaccess  , plosagain ;
extern  PLOSymbol plosapp ;
extern  PLOSymbol ploarg  , plosasync ;
extern  PLOSymbol plosate , plosbackquote ;
extern  PLOSymbol plosbadf  , plosbif ;
extern  PLOSymbol plosblock ;
# define  plosboolean Lisp2Dplosboolean
extern  PLOSymbol plosboolean , plosbusy  ;
# ifndef LISP2D_DONTUSEX11
extern  PLOSymbol plosbuttonpress , plosbuttonrelease ;
# endif
extern  PLOSymbol plosbytedeque ;
extern  PLOSymbol ploschar  , ploscharacter ;
extern  PLOSymbol ploscloexec ;
extern  PLOSymbol ploscomma , ploscomplex ;
# ifndef LISP2D_DONTUSEX11
extern  PLOSymbol plosconfigurenotify ;
# endif
extern  PLOSymbol ploscons  ;
extern  PLOSymbol ploandconst , ploscreat ;
extern  PLOSymbol ploscur , plosdata  ;
extern  PLOSymbol plosdestaddrreq ;
extern  PLOSymbol plosdir , plosdirect  ;
extern  PLOSymbol plosdirectory , plosdquote  ;
extern  PLOSymbol plosdsync ;
extern  PLOSymbol plose , plosend ;
extern  PLOSymbol plosenv , plosenvironmentlayer ;
extern  PLOSymbol ploerroroutput  , plosexcl  ;
extern  PLOSymbol plosexist , plosfalse ;
extern  PLOSymbol plosfault , plosfbig  ;
extern  PLOSymbol plosfifo  , ploshole  ;
extern  PLOSymbol plosin  , plosintr  ;
extern  PLOSymbol plosinout , plosinval ;
extern  PLOSymbol plosio  , plosisdir ;
# ifndef LISP2D_DONTUSEX11
extern  PLOSymbol ploskeypress  , ploskeyrelease ;
# endif
extern  PLOSymbol plolambdaw  , plolambdanotmod2  ;
extern  PLOSymbol ploslargefile , ploslink  ;
extern  PLOSymbol ploslock  , plosloop  ;
extern  PLOSymbol plomacronotmod  ;
extern  PLOSymbol plosmain  , plomain ;
extern  PLOSymbol plosmfile , plosmlink ;
extern  PLOSymbol plosnametoolong , plosndelay  ;
extern  PLOSymbol plosnfile ;
extern  PLOSymbol plosnil , plosnoatime ;
extern  PLOSymbol plosnoctty  , plosnodev ;
extern  PLOSymbol plosnoent ;
extern  PLOSymbol plosnofollow  , plosnomem ;
extern  PLOSymbol plosnonblock  , plosnospc ;
extern  PLOSymbol plosnosys , plosnotdir  ;
extern  PLOSymbol plosnotempty  , plosnotty ;
extern  PLOSymbol plosnull  , plosnxio  ;
extern  PLOSymbol plosopnotsupp , plosout ;
extern  PLOSymbol plosoutofmemory ,plosoverflow  ;
extern  PLOSymbol plospath  , plosperm  ;
extern  PLOSymbol plospi  , plospipe  ;
extern  PLOSymbol plosquestion  , plosquote2  ;
extern  PLOSymbol plosregular ;
extern  PLOSymbol ploandrest  , plosrgrp  ;
extern  PLOSymbol plosrofs  , plosroth  ;
extern  PLOSymbol plosrusr  , plosrwxgrp  ;
extern  PLOSymbol plosrwxoth  ;
extern  PLOSymbol plosrwxusr  , plossgid  ;
extern  PLOSymbol plossignal  ;
extern  PLOSymbol plossocket  , plosspipe ;
extern  PLOSymbol plossrch  , plostandardinput  ;
extern  PLOSymbol plostandardoutput , plosstat  ;
extern  PLOSymbol plosstd ;
# define  plosstream  Lisp2Dplosstream
extern  PLOSymbol plosstream  , plosstring  ;
extern  PLOSymbol plossuid  , plossvtx  ;
extern  PLOSymbol plossymbol  , plossync  ;
extern  PLOSymbol plossystemclass ;
extern  PLOSymbol plosthis  , plosthreepoints ;
extern  PLOSymbol plostime  , plostmpfile ;
extern  PLOSymbol plostrue1 , plostrunc ;
extern  PLOSymbol plostxtbsy  , plosUnquoteSplicing ;
extern  PLOSymbol plosvector  , ploswgrp  ;
extern  PLOSymbol ploandwhole ;
# ifndef LISP2D_DONTUSEX11
extern  PLOSymbol ploswindow  , ploswindowclose ;
# endif
extern  PLOSymbol ploswoth  , ploswouldblock  ;
extern  PLOSymbol ploswusr  , plosxdev  ;
extern  PLOSymbol plosxgrp  ;
extern  PLOSymbol plosxoth  , plosxusr  ;

// ! to make all symbols Static

# define  ploclassdefsymbol Lisp2Dploclassdefsymbol
extern  ParaLispObject  *   ploclassdefsymbol ;
# define  ploclassparentssymbol Lisp2Dploclassparentssymbol
extern  ParaLispObject  *   ploclassparentssymbol ;
// temporary list for GC
# define  GlobalListOfSymbolsGarbage  Lisp2DGlobalListOfSymbolsGarbage
extern  GlobalList  GlobalListOfSymbolsGarbage  ;

# define  PLOSymbolClassDef Lisp2DPLOSymbolClassDef
ParaLispObject  * PLOSymbolClassDef  ( ParaLispObject const * ) ;  

# define  PLOSymbolClassParents Lisp2DPLOSymbolClassParents
ParaLispObject  * PLOSymbolClassParents  ( ParaLispObject const * ) ;  

# define  ParaLispObjectToPLOSymbolConst Lisp2DParaLispObjectToPLOSymbolConst
inline  PLOSymbol const * ParaLispObjectToPLOSymbolConst ( ParaLispObject const * p ) ;

# define  PLOSymbolEqualP Lisp2DPLOSymbolEqualP
bool  PLOSymbolEqualP ( PLOSymbol  const * mep , PLOSymbol  const * xp ) ;  

# define  PLOSymbolEqualWCharArray  Lisp2DPLOSymbolEqualWCharArray
bool  PLOSymbolEqualWCharArray ( PLOSymbol  const * mep , PArray_wchar_c x ) ;
  
# define  PLOSymbolLessP  Lisp2DPLOSymbolLessP
bool  PLOSymbolLessP  ( PLOSymbol const * mep , PLOSymbol  const * xp ) ;  
  
// < -1 : == 0 : > +1
# define  PLOSymbolCompareP Lisp2D_PLOSymbolCompareP
int PLOSymbolCompareP ( PLOSymbol * , PLOSymbol * ) ;

# define  PLOSymbolMoreP  Lisp2DPLOSymbolMoreP
inline  bool  PLOSymbolMoreP ( PLOSymbol const * xp , PLOSymbol  const * yp  ) ;

# define  PLOSymbolLessEqP  Lisp2DPLOSymbolLessEqP
bool  PLOSymbolLessEqP  ( PLOSymbol  const * xp  , PLOSymbol  const * yp  ) ;
  
# define  PLOSymbolMoreEqP  Lisp2DPLOSymbolMoreEqP
bool  PLOSymbolMoreEqP  ( PLOSymbol  const * xp  , PLOSymbol  const * yp ) ;
  
# define  SymbolP Lisp2DSymbolP
bool  SymbolP ( ParaLispObject  const * ) ;  
  
# define  NameSpaceDef  Lisp2DNameSpaceDef
typedef struct  Lisp2DsNameSpaceDef  NameSpaceDef ;
struct  Lisp2DsNameSpaceDef  {
  PLOSymbol * name  ;
  ParaLispObject  * var ;
  ParaLispObject  * prop  ;
} ;

# define  PLOSymbolDeclareForGC Lisp2DPLOSymbolDeclareForGC
// Lock's not used
void  PLOSymbolDeclareForGC ( ParaLispObject * ) ;  

# include "stcl/classc.h"

# define  IsNotSymbol Lisp2D_IsNotSymbol
bool  IsNotSymbol ( StackClusterPrivate  * , ParaLispObject * ) ;

FuncBining Lisp2Dbimnilsymbolp2  ;
FuncBining  Lisp2Dbimnilgensym2 ;
FuncBining Lisp2Dbimsymbolplus2 ;
  FuncBining Lisp2Dbimsymbolequal2 ;
  FuncBining Lisp2Dbimsymbolstring2 ;
  FuncBining Lisp2Dbimsymbolproperties2 ;
  FuncBining Lisp2Dbimsymbolset2 ;
  FuncBining Lisp2Dbimsymboldefmethod2 ;
  FuncBining Lisp2Dbimsymboldefmacro2 ;
  FuncBining Lisp2Dbimsymbolboundp2 ;
  FuncBining Lisp2Dbimsymboldefclass2 ;
  FuncBining Lisp2Dbimsymbolnotequal2 ;
  FuncBining Lisp2Dbimsymbolless3;
  FuncBining Lisp2Dbimsymbolmore3;
  FuncBining Lisp2Dbimsymbollessoreq3;
  FuncBining Lisp2Dbimsymbolmoreoreq3;
  FuncBining Lisp2Dbimsymbolmin2 ;
  FuncBining Lisp2Dbimsymbolmax2 ;
  FuncBining Lisp2Dbimsymbolletset2 ;
  FuncBining Lisp2Dbimsymbolnamespace2 ;
  FuncBining Lisp2Dbimsymboldefvar2 ;
  FuncBining Lisp2Dbimsymboldefstatic2 ;
  FuncBining Lisp2Dbimsymbolconst  ;
  FuncBining Lisp2Dbimsymbolunconst  ;
  FuncBining Lisp2Dbimsymbolconstp   ;

# define  isBADSetVar Lisp2D_isBADSetVar
bool  isBADSetVar ( NameSpaceDef * , PLOSymbol * , ParaLispObject  * , StackClusterPrivate  * ,  bool  ) ;

# define  SymbolFromIntErrno  Lisp2D_SymbolFromIntErrno
PLOSymbol * SymbolFromIntErrno  ( int ) ;

//# include <errno.h>

# define  SymbolErrno Lisp2D_SymbolErrno
PLOSymbol * SymbolErrno  ( void ) ;

// symbol is not defined
// returns exception if memory out
# define  NameSpaceDefine  Lisp2D_NameSpaceDefine
void NameSpaceDefine ( PLOSymbol  *  ) ;

// returns true when EnvironmentLayer not exist OR symbol have Const link

# define  NameSpaceAssoc  Lisp2D_NameSpaceAssoc
NameSpaceDef  * NameSpaceAssoc  ( PLOSymbol  *  ) ;

# include "plostream/type.h"

# define  PLOSymbolCoutToInterpret  Lisp2DCoutToInterpret
void  PLOSymbolCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector(StackPLOP)  * h ) ;      

# define  PLOSymbolCoutToHuman  Lisp2DPLOSymbolCoutToHuman
void  PLOSymbolCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * , bool flag2pprinted  , Vector(StackPLOP)  * his ) ;

# define  toLower Lisp2D_toLower
void  toLower ( size_t  strs  , wchar_t volatile * strp  ) ;

# define  SymbolAddConstString  Lisp2D_SymbolAddConstString
ParaLispObject  * SymbolAddConstString ( String ( WideChar ) const * ) ;

# define  SymbolAddMoveString Lisp2D_SymbolAddMoveString
ParaLispObject  * SymbolAddMoveString ( String ( WideChar ) * ) ;

LISP2DSTACKSTRUCTTYPE ( NameSpaceDefC )
LISP2DSTACKSTRUCT ( NameSpaceDefC , NameSpaceDef )
LISP2DPROTOSTACKDESTRUCTOR(  NameSpaceDefC  )
inline  LISP2DDECLARESTACKCONSTRUCTORDEFAULT ( NameSpaceDefC )
LISP2DPROTOSTACKEND( NameSpaceDefC , NameSpaceDef )
LISP2DPROTOSTACKAT( NameSpaceDefC , NameSpaceDef )
LISP2DPROTOSTACKPUSHBYVALUE( NameSpaceDefC , NameSpaceDef )
LISP2DPROTOSTACKPUSHATVALUE( NameSpaceDefC , NameSpaceDef )
LISP2DPROTOSTACKPUSHFRONTVALUE( NameSpaceDefC , NameSpaceDef )

# define  namespacedefc  Lisp2D_namespacedefc
extern  Vector  ( NameSpaceDefC ) namespacedefc  ;

# define  StringWideCharToSymbol Lisp2DStringWideCharToSymbol
inline  ParaLispObject  * StringWideCharToSymbol ( String ( WideChar ) const * s0p ) ;

# define  PLOSymbolGenTemp  Lisp2D_PLOSymbolGenTemp
PLOSymbol *  PLOSymbolGenTemp ( ParaLispObject * ) ;

inline  PLOSymbol const * ParaLispObjectToPLOSymbolConst ( ParaLispObject const * const p ) {
  return (  PLOSymbol const * ) ( p  ->  vaddr . addr . p ) ;
}

inline  void PLOSymbolInit ( PLOSymbol * const me ) {
  VirtualTypePointer  vtp = { . addr  = { . p = me  } , . type = TypeGlobalListMemberPLOSymbol } ;
  ParaLispObject_InitCVTP ( & me -> plo , true , vtp ) ;
  String_Init ( WideChar  ) ( & me -> value , false ) ;
  PLOSymbolAddConstrStat
}

inline  void PLOSymbolConstrWCharStringCopy ( PLOSymbol * const me , String  ( WideChar  )  const * const xp ) {
  VirtualTypePointer  vtp = { . addr = { . p = me } , . type = TypeGlobalListMemberPLOSymbol } ;
  ParaLispObject_InitCVTP ( & me -> plo , true , vtp ) ;
  String_ConstrCopy ( WideChar ) ( & me -> value , xp  ) ;
  PLOSymbolAddConstrStat
}

inline  PLOSymbol * ParaLispObjectToPLOSymbol ( ParaLispObject * const p ) {
  return (  PLOSymbol * ) ( p  ->  vaddr . addr . p ) ;
}

inline  String  ( WideChar  ) const * PLOSymbolCValue ( PLOSymbol const * const s ) {
  return & s -> value ;
}

inline  bool  PLOSymbolMoreP ( PLOSymbol const * const xp , PLOSymbol  const * const yp  ) {
  return PLOSymbolLessP(yp  , xp) ;
}

inline  LISP2DSTACKCONSTRUCTORDEFAULT ( NameSpaceDefC )

inline  ParaLispObject  * StringWideCharToSymbol ( String ( WideChar ) const * const s0p ) {
  return  SymbolAddConstString ( s0p);
}

# include "stcl/inline.h"

# endif // LISP2D_SYMBOLC_H
