// Lisp2D - Time type
// ©2008-23 by Alex Glebe

# ifndef  LISP2D_TIME_PUBLIC_H
# define  LISP2D_TIME_PUBLIC_H

# include <stddef.h> // size_t
# include "define.h"

# ifdef LISP2D_CONSTRSTAT

# define  PLOTime_constrstat_Inc  Lisp2D_PLOTime_constrstat_Inc
void  PLOTime_constrstat_Inc  ( void  ) ;

# define  PLOTime_constrstat_Val  Lisp2D_PLOTime_constrstat_Val
size_t  PLOTime_constrstat_Val  ( void  ) ;

# endif

# include <stdbool.h>
# include "plo/type.h"

# define  Timep Lisp2D_Timep
bool  Timep ( ParaLispObject const * ) ;

# include "taskforthread.h"
# include "newobject.h"

IsNotTypeTemplDecl  ( time )

# include "time/type.h"
# include <sys/time.h> // struct timespec

# define  PLOTime_Inittimespec  Lisp2D_PLOTime_Inittimespec
void  PLOTime_Inittimespec ( PLOTime * , struct timespec ) ;

FuncBining Lisp2Dbimnilsystime2 ;
  FuncBining  Lisp2Dbimnildaylightp2 ;
  FuncBining  Lisp2Dbimniltimezone2 ;
  FuncBining  Lisp2Dbimniltzname2 ;
  FuncBining  Lisp2Dbimnilsetdaylightp2 ;
  FuncBining  Lisp2Dbimnilsettimezone2 ;
  FuncBining  Lisp2Dbimnilsettzname2 ;
  FuncBining  Lisp2Dbimniltime2 ;
  FuncBining  Lisp2Dbimniltimep2 ;
# define  bimtimesetf Lisp2Dbimtimesetf2
  FuncBining  bimtimesetf  ;
# define  bimtimeswap Lisp2Dbimtimeswap2
  FuncBining  bimtimeswap  ;
  FuncBining  Lisp2Dbimtimeyear2  ;
  FuncBining  Lisp2Dbimtimemonth2 ;
  FuncBining  Lisp2Dbimtimeday2 ;
  FuncBining  Lisp2Dbimtimehour2 ;
  FuncBining  Lisp2Dbimtimeminutes2 ;
  FuncBining  Lisp2Dbimtimeseconds2 ;
  FuncBining  Lisp2Dbimtimeweekday2 ;
  FuncBining  Lisp2Dbimtimeyearday2 ;
  FuncBining  Lisp2Dbimtimedstp2 ;
  FuncBining  Lisp2Dbimtimenumber2 ;
  FuncBining  Lisp2Dbimtimetime2 ;
  FuncBining  Lisp2Dbimtimesetyear2 ;
  FuncBining  Lisp2Dbimtimesetmonth2 ;
  FuncBining  Lisp2Dbimtimesetday2 ;
  FuncBining  Lisp2Dbimtimesethour2 ;
  FuncBining  Lisp2Dbimtimesetminutes2 ;
  FuncBining  Lisp2Dbimtimesetseconds2 ;
  FuncBining  Lisp2Dbimtimestring2 ;
# define  bimtimeeq Lisp2Dbimtimeeq2
  FuncBining  bimtimeeq ;
# define  bimtimenoteq  Lisp2Dbimtimenoteq2
  FuncBining  bimtimenoteq ;
  FuncBining  Lisp2Dbimtimeless3  ;
  FuncBining  Lisp2Dbimtimemore3  ;
  FuncBining  Lisp2Dbimtimelesseq3  ;
  FuncBining  Lisp2Dbimtimemoreeq3  ;
  FuncBining  Lisp2Dbimtimemin  ;
  FuncBining  Lisp2Dbimtimemax  ;

# define  PLOTime_staticTypeOf  Lisp2D_PLOTime_staticTypeOf
ParaLispObject  * PLOTime_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOTime_staticClassDef  Lisp2D_PLOTime_staticClassDef
ParaLispObject  * PLOTime_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOTime_staticClassParents  Lisp2D_PLOTime_staticClassParents
ParaLispObject  * PLOTime_staticClassParents  ( ParaLispObject const * ) ;

# define  PLOTime_Les Lisp2D_PLOTime_Les
bool  PLOTime_Les ( PLOTime const * , PLOTime const * ) ;

# define  PLOTime_staticisBADCopyPrivate  Lisp2D_PLOTime_staticisBADCopyPrivate
bool PLOTime_staticisBADCopyPrivate  ( ParaLispObject const * me , ParaLispObject  * * resultp  ) ;

# include "plostream/type.h"

# define  PLOTime_staticCoutToHuman Lisp2D_PLOTime_staticCoutToHuman
void  PLOTime_staticCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * os , bool , Vector ( StackPLOP ) * ) ;

# define  PLOTime_staticCoutToInterpret Lisp2D_PLOTime_staticCoutToInterpret
void  PLOTime_staticCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const * s , bool   , Vector ( StackPLOP )  * ) ;

# include "plo/struct.h"
# include "time/type.h"

# define  ParaLispObjectToPLOTime Lisp2DParaLispObjectToPLOTime
inline  PLOTime * ParaLispObjectToPLOTime ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOTimeConst Lisp2DParaLispObjectToPLOTimeConst
inline  PLOTime const * ParaLispObjectToPLOTimeConst ( ParaLispObject const * ) ;
# define  PLOTime_Init  Lisp2D_PLOTime_Init
void  PLOTime_Init ( PLOTime * ) ;
# define  PLOTime_InitCopy  Lisp2D_PLOTime_InitCopy
void  PLOTime_InitCopy ( PLOTime * , PLOTime const * ) ;
# define  PLOTime_ValueP Lisp2D_PLOTime_ValueP
inline  struct  timespec const * PLOTime_CValueP ( PLOTime const * ) ;
# define  PLOTime_Value Lisp2D_PLOTime_Value
inline  struct  timespec PLOTime_CValue ( PLOTime const * ) ;
# define  PLOTime_SetValue  Lisp2D_PLOTime_SetValue
inline  void  PLOTime_SetValue  ( PLOTime * , struct  timespec ) ;
# define  PLOTime_SetSec  Lisp2D_PLOTime_SetSec
inline  void  PLOTime_SetSec  ( PLOTime * , time_t ) ;
# define  PLOTime_SetNSec Lisp2D_PLOTime_SetNSec
inline  void  PLOTime_SetNSec ( PLOTime * , long  int ) ;
# define  PLOTime_Set Lisp2D_PLOTime_Set
inline  void  PLOTime_Set ( PLOTime * , PLOTime const * ) ;
# define  PLOTime_Swap  Lisp2D_PLOTime_Swap
inline  void  PLOTime_Swap  ( PLOTime * , PLOTime  * ) ;
# define  PLOTime_Equ Lisp2D_PLOTime_Equ
bool  PLOTime_Equ ( PLOTime  const * , PLOTime  const * ) ;
# define  PLOTime_statDestr Lisp2D_PLOTime_statDestr
inline void PLOTime_statDestr ( PLOTime * ) ;
# define  PLOTime_staticDestr Lisp2D_PLOTime_staticDestr
void PLOTime_staticDestr  ( ParaLispObject * ) ;
# define  PLOTime_NotEqu  Lisp2D_PLOTime_NotEqu
bool  PLOTime_NotEqu ( PLOTime  const * , PLOTime  const * ) ;
# define  PLOTime_Mor Lisp2D_PLOTime_Mor
inline  bool  PLOTime_Mor ( PLOTime const * , PLOTime const * ) ;
# define  PLOTime_LessEq  Lisp2D_PLOTime_LessEq
bool  PLOTime_LessEq ( PLOTime const * , PLOTime const * ) ;
# define  PLOTime_MorEq Lisp2D_PLOTime_MorEq
bool  PLOTime_MorEq  ( PLOTime const * , PLOTime const * ) ;

inline  PLOTime * ParaLispObjectToPLOTime ( ParaLispObject * const p ) {
  return p  ->  vaddr . addr . p ;
}

inline  PLOTime const * ParaLispObjectToPLOTimeConst ( ParaLispObject const * const p ) {
  return p  ->  vaddr . addr . p ;
}

# include "time/public.h"
# include "time/struct.h"
# include "plo/public.h"

inline  struct  timespec const * PLOTime_CValueP ( PLOTime const * const me ) {
  return  & ( me -> tv ) ;
}

inline  struct  timespec PLOTime_CValue ( PLOTime const * const me ) {
  return  me -> tv ;
}

inline  void  PLOTime_SetValue  ( PLOTime * const me , struct  timespec const x ) {
  me -> tv = x  ;
}

inline  void  PLOTime_SetSec  ( PLOTime * const me , time_t const x ) {
  me -> tv . tv_sec  = x ;
}

inline  void  PLOTime_SetNSec ( PLOTime * const me , long  int const x ) {
  me -> tv . tv_nsec = x ;
}

inline  void  PLOTime_Set ( PLOTime * const me , PLOTime const * const xp ) {
  if  ( me  not_eq  xp )
    me -> tv = xp -> tv ;
}

inline  void  PLOTime_Swap  ( PLOTime * const me , PLOTime  * const xp  ) {
  struct  timespec const  swp = me -> tv ;
  me -> tv = xp -> tv ;
  xp -> tv = swp ;
}

inline void PLOTime_statDestr ( PLOTime * const me ) {
  ParaLispObject_staticDestr  ( & me -> pub . plo ) ;
}

inline  bool  PLOTime_Mor ( PLOTime const * const me , PLOTime const * const xp ) {
  return PLOTime_Les ( xp  , me ) ;
}

# endif // LISP2D_TIME_PUBLIC_H
