// ULong private
// © Lisp2D - 2019-23 by Alex Glebe

# ifndef  LISP2D_ULONG_PRIVATE_H
# define  LISP2D_ULONG_PRIVATE_H

# include "define.h"
# include <stddef.h>
# ifdef  LISP2D_CONSTRSTAT
# include <stdatomic.h>
extern  _Atomic ( size_t  ) Lisp2DULongconstrstat ;
# endif

# include "ulong/type.h"
# include "ulong/struct.h"

# define  ULong_Simplify  Lisp2D_ULong_Simplify
void  ULong_Simplify  ( ULong * ) ;
// ! me > l  
# define  ULongAddPrivate Lisp2DULongAddPrivate
void  ULongAddPrivate  ( ULong  *   mep  , ULong  const *  lp  ) ;

# define  t_ULongCutOff Lisp2D_t_ULongCutOff
# define  s_ULongCutOff Lisp2D_s_ULongCutOff
typedef struct  s_ULongCutOff  t_ULongCutOff  ;

struct s_ULongCutOff  {
  ULong * const mep ;
  size_t const intscount  ;
  unsigned  int const bitscount ;
} ;

// cout off low int's count and low bit's count
# define  ULongCutOff Lisp2DULongCutOff
void  ULongCutOff  ( t_ULongCutOff const * ) ;

# define  t_ULongPrivateDivideByOdd Lisp2D_t_ULongPrivateDivideByOdd
# define  s_ULongPrivateDivideByOdd Lisp2D_s_ULongPrivateDivideByOdd
typedef struct s_ULongPrivateDivideByOdd  t_ULongPrivateDivideByOdd ;

struct s_ULongPrivateDivideByOdd  {
  ULong  * const mep  ;
  ULong * const  byp  ;
  ULong * const ostp  ;
} ;

# define  ULongPrivateDivideByOdd Lisp2DULongPrivateDivideByOdd_ExcMem
void  ULongPrivateDivideByOdd ( t_ULongPrivateDivideByOdd const * ) ;



# define  ULongPrivateDivideSmall Lisp2DULongPrivateDivideSmall_ExcMem
void  ULongPrivateDivideSmall ( ULong * mep  , ULong * byp  ,  ULong * ostp ) ;
# define  ULongPrivateDivideBig Lisp2DULongPrivateDivideBig_ExcMem
void  ULongPrivateDivideBig ( ULong * mep  , ULong * byp  ,  ULong * ostp )  ;
void  Lisp2DULongPrivateDivideNormalized_ExcMem  ( ULong * mep  ,  ULong *  byp  , ULong * ostp );
// !!x=x*(x-2)*(x-4)*...*3     x-odd , >2
void Lisp2DULongPrivateFactorial2_ExcMem ( ULong * mep  );

# define  ULongDestr  Lisp2D_ULongDestr
void  ULongDestr  ( ULong * ) ;

// by == 0 -> this:=0
// 3 % 2 => 1
# define  ULongSetRemainderUInt Lisp2DULongSetRemainderUInt
void  ULongSetRemainderUInt ( ULong * myp , unsigned  int l );

# define  bytep_cast_ULong  Lisp2D_bytep_cast_ULong
inline  ULong * bytep_cast_ULong ( uint8_t * ) ;
# define  ULongPub_cast_bytep  Lisp2D_ULongPub_cast_bytep
inline  uint8_t * ULongPub_cast_bytep  ( ULongPub * ) ;
# define  ULong_toPrivate  Lisp2D_ULong_toPrivate
inline  ULong * ULong_toPrivate ( ULongPub * ) ;
# define  ULongPubC_cast_bytep  Lisp2D_ULongPubC_cast_bytep
inline  uint8_t const * ULongPubC_cast_bytep  ( ULongPub const * ) ;
# define  bytepC_cast_ULong  Lisp2D_bytepC_cast_ULong
inline  ULong const * bytepC_cast_ULong ( uint8_t const * ) ;
# define  ULong_toCPrivate  Lisp2D_ULong_toCPrivate
inline  ULong const * ULong_toCPrivate ( ULongPub const * ) ;
# define  voidpcastulongp Lisp2D_voidpcastulongp
inline  ULong * voidpcastulongp ( void * ) ;

inline  ULong * bytep_cast_ULong ( uint8_t * const b ) {
  return  ( ULong * ) b ;
}

inline  uint8_t * ULongPub_cast_bytep  ( ULongPub * const u ) {
  return  ( uint8_t * ) u ;
}

inline  ULong * ULong_toPrivate ( ULongPub * const u ) {
  return  bytep_cast_ULong ( ULongPub_cast_bytep  ( u ) - offsetof ( ULong , pub ) ) ;
}

inline  uint8_t const * ULongPubC_cast_bytep  ( ULongPub const * const uc ) {
  return  ( uint8_t const * ) uc ;
}

inline  ULong const * bytepC_cast_ULong ( uint8_t const * const bc ) {
  return  ( ULong const * ) bc ;
}

inline  ULong const * ULong_toCPrivate ( ULongPub const * const cu ) {
  return  bytepC_cast_ULong ( ULongPubC_cast_bytep  ( cu ) - offsetof ( ULong , pub ) ) ;
}

inline  ULong * voidpcastulongp ( void * const p ) {
  return  ( ULong * ) p ;
}

# endif // LISP2D_ULONG_PRIVATE_H
