// Lisp2D - Vector #()
// ©2011-23 Alex Glebe
# ifndef  LISP2D_VECTOR_PUBLIC_H
# define  LISP2D_VECTOR_PUBLIC_H
# include <stddef.h> // size_t
# include "define.h"

# ifdef LISP2D_CONSTRSTAT
  # ifndef  __cplusplus
    # define  PLOVector_constrstat  Lisp2D_PLOVector_constrstat
    extern  _Atomic  ( size_t  ) PLOVector_constrstat  ;
  # endif
  # define  PLOVector_constrstatCValue  Lisp2D_Vector_constrstatCValue
  size_t  PLOVector_constrstatCValue  ( void  ) ;
  # define  PLOVector_constrstat_Inc  Lisp2D_PLOVector_constrstat_Inc
  void  PLOVector_constrstat_Inc  ( void  ) ;
# endif
  
# ifndef  __cplusplus
  # define  PLOVector_gcvectorslength Lisp2D_PLOVector_gcvectorslength
  extern  _Atomic  ( size_t  ) PLOVector_gcvectorslength  ;
# endif  
    
  # define  PLOVector_gcvectorslength_Inc  Lisp2D_PLOVector_gcvectorslength_Inc
  void  PLOVector_gcvectorslength_Inc  ( void  ) ;
  # define  PLOVector_gcvectorslength_Dec  Lisp2D_PLOVector_gcvectorslength_Dec
  void  PLOVector_gcvectorslength_Dec  ( void  ) ;
  # define  PLOVector_gcvectorslength_Add  Lisp2D_PLOVector_gcvectorslength_Add
  void  PLOVector_gcvectorslength_Add  ( size_t ) ;
  # define  PLOVector_gcvectorslength_Sub  Lisp2D_PLOVector_gcvectorslength_Sub
  void  PLOVector_gcvectorslength_Sub  ( size_t ) ;
  # define  PLOVector_gcvectorslength_CValue \
    Lisp2D_Vector_gcvectorslength_CValue
  size_t  PLOVector_gcvectorslength_CValue  ( void  ) ;
  # define  PLOVector_gcvectorslength_Clear \
    Lisp2D_PLOVector_gcvectorslength_Clear
  void  PLOVector_gcvectorslength_Clear  ( void  ) ;

# include "taskforthread.h"
  
  FuncBining  Lisp2Dbimvectormerge2 ;
  FuncBining  Lisp2Dbimvectorelt2 ;
  FuncBining  Lisp2Dbimvectorsize2 ;
  FuncBining  Lisp2Dbimvectorreverse2 ;
  FuncBining  Lisp2Dbimvectorpush2 ;
# define  bimvectorpop  Lisp2Dbimvectorpop
  FuncBining  bimvectorpop ;
  FuncBining  Lisp2Dbimvectorsubseq2  ;
  FuncBining  Lisp2Dbimvectorresize2  ;
  FuncBining  Lisp2Dbimvectorclear2 ;
  FuncBining  Lisp2Dbimvectorsetelt2 ;
  FuncBining  Lisp2Dbimvectortranspose2 ;
  FuncBining  Lisp2Dbimvectorlist2 ;
  FuncBining  Lisp2Dbimvectorfirst2 ;
  FuncBining  Lisp2Dbimvectorempty2 ;
  FuncBining  Lisp2Dbimvectorinsert2 ;
  FuncBining  Lisp2Dbimvectorsetf2 ;
  FuncBining  Lisp2Dbimvectorfor2 ;
  FuncBining  Lisp2Dbimvectorforcons2 ;
  FuncBining  Lisp2Dbimvectormult2 ;
  FuncBining  Lisp2Dbimvectorvector2 ;
  FuncBining  Lisp2Dbimvectormultsetf2 ;
  FuncBining  Lisp2Dbimvectorswap2 ;
  FuncBining  Lisp2Dbimvectorlast2 ;
  FuncBining  Lisp2Dbimvectormap2 ;
  FuncBining  Lisp2Dbimvectormapc2 ;
  FuncBining  Lisp2Dbimvectorcopymatrix2 ;
  FuncBining Lisp2Dbimnilvectorp2  ;
  FuncBining  Lisp2Dbimnilvector2 ;
  
# include "plostream/type.h"
# include <stdbool.h>
# include "stack-plop.h"
  
# define  PLOVector_staticCoutToInterpret Lisp2D_PLOVector_staticCoutToInterpret
void  PLOVector_staticCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  ,
  Vector  ( StackPLOP ) * h ) ;

# define  PLOVector_staticCoutToHuman Lisp2D_PLOVector_staticCoutToHuman
void  PLOVector_staticCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  ,
  Vector(StackPLOP)  * h ) ;

# define  PLOVector_staticisBADCopyPrivate \
  Lisp2D_PLOVector_staticisBADCopyPrivate
bool  PLOVector_staticisBADCopyPrivate ( ParaLispObject const * me ,
  ParaLispObject  * * resultp  )  ;

# define  PLOVector_staticDeclareForGC  Lisp2D_PLOVector_staticDeclareForGC
void  PLOVector_staticDeclareForGC ( ParaLispObject *  ) ;
  
# define  PLOVector_staticGCDeclareContent \
  Lisp2D_PLOVector_staticGCDeclareContent
void  PLOVector_staticGCDeclareContent ( ParaLispObject *  ) ;
  
# define  PLOVector_staticPushAsNew Lisp2D_PLOVector_staticPushAsNew
ParaLispObject  * PLOVector_staticPushAsNew ( ParaLispObject * me ) ;

# define  PLOVector_staticTypeOf  Lisp2D_PLOVector_staticTypeOf
ParaLispObject  * PLOVector_staticTypeOf ( ParaLispObject const * ) ;
  
# define  PLOVector_staticClassDef  Lisp2D_PLOVector_staticClassDef
ParaLispObject  * PLOVector_staticClassDef  ( ParaLispObject const * ) ;
  
# define  PLOVector_staticClassParents  Lisp2D_PLOVector_staticClassParents
ParaLispObject  * PLOVector_staticClassParents  ( ParaLispObject const *  ) ;

# define  PLOVector_staticDestr Lisp2D_PLOVector_staticDestr
void PLOVector_staticDestr  ( ParaLispObject * ) ;

# include "vector/type.h"

# define  PLOVector_Init  Lisp2D_PLOVector_Init
void  PLOVector_Init ( PLOVector * me )  ;

# define  PLOVector_InitSizeFill  Lisp2D_PLOVector_InitSizeFill
void  PLOVector_InitSizeFill  ( PLOVector * me  ,
  size_t n , ParaLispObject  * initp )  ;

# define  PLOVector_InitSize  Lisp2D_PLOVector_InitSize
void  PLOVector_InitSize  ( PLOVector * me , size_t n ) ;

# define  PLOVector_InitCopy  Lisp2D_PLOVector_InitCopy
void  PLOVector_InitCopy  ( PLOVector * me ,
  PLOVector  const * vp ) ;

# define  PLOVector_InitFirst Lisp2D_PLOVector_InitFirst
void  PLOVector_InitFirst ( PLOVector * me ,
  PLOVector  const * vp , size_t  indexfirst )  ;

# define  PLOVector_InitFirstEnd  Lisp2D_PLOVector_InitFirstEnd
void  PLOVector_InitFirstEnd  ( PLOVector * const me ,
  PLOVector  const * vp , size_t  indexfirst , size_t indexend ) ;

# define  PLOVector_Destr Lisp2D_PLOVector_Destr
void  PLOVector_Destr ( PLOVector * me  ) ;

# define  PLOVector_Push  Lisp2D_PLOVector_Push
void  PLOVector_Push(PLOVector * me , ParaLispObject  * xp )  ;

# define  PLOVector_PushToIndex Lisp2D_PLOVector_PushToIndex
void  PLOVector_PushToIndex(PLOVector * me ,
  ParaLispObject * xp,size_t index , StackClusterPrivate * ) ;

# define  PLOVector_Insert  Lisp2D_PLOVector_Insert
void  PLOVector_Insert  ( PLOVector *  me , size_t  i,
  ParaLispObject  *  xp ) ;

# define  PLOVector_PopLisp Lisp2D_PLOVector_PopLisp
ParaLispObject  * PLOVector_PopLisp(PLOVector * me) ;

# define  PLOVector_PopLispInd Lisp2D_PLOVector_PopLispInd
ParaLispObject  * PLOVector_PopLispInd ( PLOVector * myp , size_t ind ) ;

# define  PLOVector_ResizeFill  Lisp2D_PLOVector_ResizeFill
void  PLOVector_ResizeFill(PLOVector * me ,size_t  n,
  ParaLispObject  * xp) ;

# define  PLOVector_Resize  Lisp2D_PLOVector_Resize
void  PLOVector_Resize(PLOVector * const me , size_t  const n)  ;

# define  PLOVector_isBADCopyStatic Lisp2D_PLOVector_isBADCopyStatic
bool  PLOVector_isBADCopyStatic ( PLOVector const * me ,
  PLOVector  * * resultp ) ;

# define  PLOVector_Set Lisp2D_PLOVector_Set
void  PLOVector_Set(PLOVector * me, PLOVector const * xp) ;

# define  PLOVector_RemProp Lisp2D_PLOVector_RemProp
// returns TRUE or FALSE
ParaLispObject  * PLOVector_RemProp(PLOVector * me ,
  ParaLispObject * sp) ;

# define  PLOVector_Clear Lisp2D_PLOVector_Clear
PLOVector *  PLOVector_Clear(PLOVector * me ) ;

// returns nil | (s . val)
# define  PLOVector_Assoc3  Lisp2D_PLOVector_Assoc3
ParaLispObject * PLOVector_Assoc3 ( PLOVector const * me , ParaLispObject  const * sp )  ;

# define  PLOVector_PushLink  Lisp2D_PLOVector_PushLink
void  PLOVector_PushLink(PLOVector * me , ParaLispObject  * ap ,
  ParaLispObject  * bp , StackClusterPrivate  * stclp ) ;

# define  PLOVector_SetElt  Lisp2D_PLOVector_SetElt
void  PLOVector_SetElt  ( PLOVector * me , size_t i  , ParaLispObject  * xp )  ;

# include "vector/public.h"
# include "plo/struct.h"

# define  ParaLispObjectToPLOVector Lisp2DParaLispObjectToPLOVector
inline  PLOVector * ParaLispObjectToPLOVector ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOVectorConst Lisp2DParaLispObjectToPLOVectorConst
inline  PLOVector const * ParaLispObjectToPLOVectorConst ( ParaLispObject const * ) ;
# define  PLOVector_AddrElt Lisp2D_PLOVector_AddrElt
inline  ParaLispObject  * * PLOVector_AddrElt ( PLOVector * ,  size_t ) ;
# define  PLOVector_Swap  Lisp2D_PLOVector_Swap
inline  void  PLOVector_Swap  ( PLOVector * , PLOVector * ) ;

# define  PLOVector_CValue  Lisp2D_PLOVector_CValue
inline  Vector  ( StackPLOP ) const * PLOVector_CValue ( PLOVector const * ) ;
# define  Vectorp Lisp2D_Vectorp
inline  bool  Vectorp ( ParaLispObject const * ) ;

# include "newobject.h"

IsNotTypeTemplDecl  ( vector  )

inline  PLOVector * ParaLispObjectToPLOVector ( ParaLispObject * const p ) {
  return (  PLOVector * ) ( p  ->  vaddr . addr . p ) ;
}

inline  PLOVector const * ParaLispObjectToPLOVectorConst ( ParaLispObject const * const p ) {
  return (  PLOVector const * ) ( p  ->  vaddr . addr . p ) ;
}

# include "vector/struct.h"

inline  ParaLispObject  * * PLOVector_AddrElt ( PLOVector * const me ,  size_t  const i ) {
  return  Vector_EltAddr  ( StackPLOP ) ( & me  ->  value  , i ) ;
}

inline  void  PLOVector_Swap  ( PLOVector * const  me , PLOVector * const  xp  ) {
  Vector_Swap ( StackPLOP ) ( & me  ->  value  , & xp  ->  value  ) ;
}

inline  Vector  ( StackPLOP ) const * PLOVector_CValue ( PLOVector const * const me ) {
  return & me ->  value  ;
}

# include "plo/public.h"

inline  bool  Vectorp ( ParaLispObject const * const xp  ) {
  return ParaLispObject_Type(xp)==TypeGlobalListMemberPLOVector;
}

# endif // LISP2D_VECTOR_PUBLIC_H
