// Lisp2D - Wide Character String
// ©2019-23 by Alex Glebe
# ifndef  LISP2D_WIDESTRING_H
# define  LISP2D_WIDESTRING_H

# include "stack-widechar.h"
# include "charstring/public.h"

// ! to struct.h
LISP2DSTRINGSTRUCT  ( WideChar )

# include "widestring/type.h"

// ! to public.h
inline  LISP2D_STRING_INIT_DECL ( WideChar )
LISP2DPROMOSTRINGCONSTRCSTR ( WideChar , wchar_t volatile )
LISP2DPROMOSTRINGCONSTRCOPY ( WideChar )
LISP2DPROMOSTRINGCONSTRMOVE ( WideChar )
LISP2DPROMOSTRINGCONSTRCSTRMEMSIZE  ( WideChar , wchar_t )
LISP2DPROMOSTRINGDESTR  ( WideChar  )
inline  LISP2D_STRING_CSTR_DECL ( WideChar , wchar_t volatile )

# include "parray.h"

LISP2DSTRINGCARR_DECL ( WideChar , PArray_wchar_c )
inline  LISP2D_STRING_CBEGIN_DECL ( WideChar , wchar_t volatile )
LISP2D_STRING_CEND_DECL ( WideChar , wchar_t volatile )

LISP2DPROMOSTRINGADDCHAR  ( WideChar , wchar_t )
inline  LISP2D_STRING_EMPTY_DECL  ( WideChar )
inline  LISP2D_STRING_SIZE_DECL ( WideChar )
inline  LISP2D_STRING_ELTCOPY_DECL  ( WideChar , wchar_t )

LISP2DPROMOSTRINGADDSTRING  ( WideChar )

LISP2DPROMOSTRINGADDCHARARRAY ( WideChar , wchar_t volatile )
inline  LISP2DSTRINGELTCADDR_DECL ( WideChar , wchar_t volatile )
inline  LISP2DSTRINGELTADDR_DECL  ( WideChar , wchar_t volatile )

LISP2DPROMOSTRINGCLEAR  ( WideChar  )
LISP2DPROMOSTRINGRESIZE ( WideChar , wchar_t )
LISP2DPROMOSTRINGSWAP ( WideChar )
inline  LISP2DPROMOSTRINGSET  ( WideChar )
LISP2DPROMOSTRINGCONSTRFILLCHAR ( WideChar , wchar_t )
inline  LISP2DSTRINGBEGIN_DECL  ( WideChar , wchar_t volatile )

# define  isBADReadWStringToCString Lisp2DisBADReadWStringToCString
bool  isBADReadWStringToCString ( String  ( WideChar  ) const * , String  ( Char  ) * ) ;
  
LISP2DPROMOSTRINGSETARRAY ( WideChar , wchar_t volatile )
LISP2DPROMOSTRINGREPLACECHARS ( WideChar , wchar_t )
LISP2DPROMOSTRINGREPLACE  ( WideChar )

# define  StackNew_StringWideChar  Lisp2D_StackNew_StringWideChar
String ( WideChar ) * StackNew_StringWideChar ( void  ) ;

# endif // LISP2D_WIDESTRING_H
