// Lisp2D - Window
// ©2019-23
# ifndef  LISP2D_WINDOW_H
# define  LISP2D_WINDOW_H

# ifndef  LISP2D_DONTUSEX11
# include <X11/Xutil.h>

// kill X.h definition
# ifdef  Complex
# undef  Complex
# endif
# ifdef  Bool
# undef  Bool
# endif

# include "pthw.h"
# include "queue-voidp.h"
# include "plo/struct.h"
# include "stcl/classc.h"
# include "condit.h"
extern  Lisp2DCondition Lisp2DsignalWindowsExit ;
extern  Lisp2DMutex2  Lisp2DmutexWindowsExit  ;

// ! to LISP2DMUTEX2 or atomic ?

extern  pthread_mutex_t Lisp2DmutexXDisplay2 ;  // XOpenDisplay, XCloseDisplay

// ! to LISP2DMUTEX2 or atomic ?

extern  pthread_mutex_t Lisp2DmutexCX11  ;

extern  bool  Lisp2DflagMainWaitWindows ;

# include "plo/type.h"
# include "taskforthread.h"

struct  sLisp2DDrawSquare2  {
  int ilx2input ;
  long  double  left ;
  long  double  up ;
  long  double  right  ;
  long  double  down ;
  ParaLispObject  * const cols ;
  StackClusterPrivate  * const pstclp ;
} ; // ! to make restrict in C
  
typedef struct  sLisp2DDrawSquare2 aLisp2DDrawSquare2 ;

typedef 
struct  sIntXY {
  int x ;
  int y ;
  } IntXY ;

typedef
struct  sUCharXY {
  unsigned  char  x ;
  unsigned  char  y ;
} UCharXY ;

typedef struct  UCharRGB  tUCharRGB ;

struct  UCharRGB  {
  unsigned  char  r ;
  unsigned  char  g ;
  unsigned  char  b ;
} ;

typedef
struct sUIntXY  {
  unsigned int x ;
  unsigned int y ;
  } 
UIntXY ;

typedef
struct  sBadUCharRGB  {
  tUCharRGB rgb ;
  bool  isBAD ;
} 
BadUCharRGB ;

# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include <stddef.h>

# ifndef  __cplusplus
# define  PLOWindow_constrstat  PLOWindow_constrstat_pub  
extern  _Atomic ( size_t  ) PLOWindow_constrstat  ;
# undef PLOWindow_constrstat
# endif

# define  PLOWindow_constrstatValue Lisp2D_PLOWindow_constrstatValue
size_t  PLOWindow_constrstatValue ( void  ) ;

# define  PLOWindow_constrstatInc Lisp2D_PLOWindow_constrstatInc
void  PLOWindow_constrstatInc ( void  ) ;
# endif //  LISP2D_CONSTRSTAT

# include <iso646.h>

# define  PLOWindow_alleventmask  Lisp2D_PLOWindow_alleventmask
static  long  int const PLOWindow_alleventmask =
  ExposureMask bitor KeyPressMask  bitor KeyReleaseMask  bitor
  ButtonPressMask bitor ButtonReleaseMask bitor StructureNotifyMask ;

# include "vector-unslongint.h"
  
# define  PLOWindow Lisp2D_PLOWindow
# define  sPLOWindow  Lisp2D_sPLOWindow
typedef struct  sPLOWindow  PLOWindow ;
  
struct  sPLOWindow  {
  uint8_t _ ;
} ;

# define  PLOWindow_pri Lisp2D_PLOWindow_pri
# define  sPLOWindow_pri  Lisp2D_sPLOWindow_pri
typedef struct  sPLOWindow_pri  PLOWindow_pri ;

# include "widestring.h"

struct  sPLOWindow_pri  {

// ! memory error if pub not in start
  //PLOWindow pub ; // 1 byte

  // stand up only one StCl but he is getchars YOURSELF
  //   (buttonqueue may be already empty)
  XEvent  event ; //  192 bytes
  // locks both queues for Events and StackClusters
  pthread_mutex_t mutexQueueStClWaitEvent2 ;  //  40  bytes
  Window  win ;
  // ! display is CONNECTION to X11 (every window - different)
  Display *  dpy ;
  GC  gc ;
// !! to write: mutexMatrixPixel
// Resize  &  WinRedraw -> conflict
  Vector  ( UnsLongInt  ) cmatrixpixel  ;
// Don't take window-size more than UInt  
// ! size_t -> unsigned int -> SShort
  size_t  matrixsizew ;
// ! size_t -> unsigned int     -> SShort
  size_t  matrixsizeh ;
  String  ( WideChar )  cmyname ;
// ! temporary char8
// ! to rewrite code for UTF-8
  String  ( Char )  cmynameutf8 ;
  XImage  * winimage ;
  Queue ( VoidP ) queueEventsC  ;
  Queue ( VoidP ) queueStClPWaitEventC  ;
  XIC xic ;
  Atom  wmDeleteMessage ;
  // ? int -> unsigned int (unsigned short int) SShort ?
  int winwidth ;  // 4 bytes
  int winheight ;
  int colordefaultdepth ;
  ParaLispObject  plo ; // 1 bytes
  bool  flagclose ;
// !!! all functions must use CanDraw() use X-funcs or not
  bool  opened ;
  bool  boolHaveThread ;

// ! memory error if pub not in start
  PLOWindow pub ; // 1 byte

} ;

# define  PLOWindow_isBADTryToGetEvent  Lisp2D_PLOWindow_isBADTryToGetEvent
bool  PLOWindow_isBADTryToGetEvent  ( PLOWindow * , ParaLispObject  * * resp ) ;

# define  PLOWindow_FromMember  Lisp2D_PLOWindow_FromMember
PLOWindow * PLOWindow_FromMember ( GlobalListMember * ) ;

# include "plostream/type.h"

# define  PLOWindow_staticCoutToInterpret Lisp2D_PLOWindow_staticCoutToInterpret
void  PLOWindow_staticCoutToInterpret ( ParaLispObject const *  me ,
  PLOStream  const * , bool flag2pprinted  , Vector(StackPLOP)  *  hi ) ;

# define  PLOWindow_staticCoutToHuman Lisp2D_PLOWindow_staticCoutToHuman
void  PLOWindow_staticCoutToHuman ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector(StackPLOP)  *  h ) ;

// ! to return bool isBAD...
# define  PLOWindow_MakeEvent Lisp2D_PLOWindow_MakeEvent
void  PLOWindow_MakeEvent(PLOWindow * , ParaLispObject * ) ;

// thread manager check events and running task    
// thread manager calls this task  
# define  PLOWindow_isBADEventQueueLockPop  Lisp2D_PLOWindow_isBADEventQueueLockPop
bool  PLOWindow_isBADEventQueueLockPop ( PLOWindow * , StackClusterPrivate  * )  ;

# define  PLOWindow_staticPushAsNew Lisp2D_PLOWindow_staticPushAsNew
ParaLispObject  * PLOWindow_staticPushAsNew ( ParaLispObject * me ) ;

# define  PLOWindow_isBADColorsWithSizeCheck  Lisp2D_PLOWindow_isBADColorsWithSizeCheck
bool  PLOWindow_isBADColorsWithSizeCheck  ( PLOWindow const * , UIntXY  , tUCharRGB * ) ;

# define  PLOWindow_staticGCDeclareContent  Lisp2D_PLOWindow_staticGCDeclareContent
void  PLOWindow_staticGCDeclareContent ( ParaLispObject * )  ;

# define  PLOWindow_staticDeclareForGC  Lisp2D_PLOWindow_staticDeclareForGC
void  PLOWindow_staticDeclareForGC  ( ParaLispObject * ) ;

# define  PLOWindow_isOKOSColor2  Lisp2D_PLOWindow_isOKOSColor2
// ! ..(signed int const * , ..
bool  PLOWindow_isOKOSColor2  ( PLOWindow const * , IntXY ,
  unsigned  long  int * resultp ) ;

# define  PLOWindow_QueryPointer  Lisp2D_PLOWindow_QueryPointer
void  PLOWindow_QueryPointer  ( PLOWindow * me , IntXY * xy )  ;

# define  PLOWindow_DrawPoint Lisp2D_PLOWindow_DrawPoint
// ! UChar -> Byte  
void  PLOWindow_DrawPoint ( PLOWindow * , tUCharRGB , IntXY )  ;

# include "fraction/type.h"

// returns list(r,g,b)
# define  PLOWindow_GetPixel  Lisp2D_PLOWindow_GetPixel
ParaLispObject * PLOWindow_GetPixel (PLOWindow const * ,
  FractionPub  const * xpp, FractionPub  const * ypp) ;

# define  PLOWindow_staticClassParents  Lisp2D_PLOWindow_staticClassParents
ParaLispObject  * PLOWindow_staticClassParents  ( ParaLispObject const * )  ;

# define  PLOWindow_staticClassDef  Lisp2D_PLOWindow_staticClassDef
ParaLispObject  * PLOWindow_staticClassDef  ( ParaLispObject const * )  ;

# define  PLOWindow_staticTypeOf  Lisp2D_PLOWindow_staticTypeOf
ParaLispObject  * PLOWindow_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOWindow_LockFlush Lisp2D_PLOWindow_LockFlush
void  PLOWindow_LockFlush ( PLOWindow const * )  ;

# define  PLOWindow_Flush Lisp2D_PLOWindow_Flush
void  PLOWindow_Flush ( PLOWindow const * )  ;

# define  PLOWindow_GetImage  Lisp2D_PLOWindow_GetImage
XImage  * PLOWindow_GetImage(PLOWindow const * ,IntXY xy,
  UIntXY wh,  unsigned  long  int pm,  int f) ;

# define  PLOWindow_GetAttributes Lisp2D_PLOWindow_GetAttributes
void  PLOWindow_GetAttributes(PLOWindow const * , XWindowAttributes  * ) ;

# define  PLOWindow_Close Lisp2D_PLOWindow_Close
void  PLOWindow_Close ( PLOWindow * ) ;

# define  PLOWindow_Create  Lisp2D_PLOWindow_Create
void  PLOWindow_Create  ( PLOWindow * , UIntXY wh ) ;

# define  PLOWindow_Destr Lisp2D_PLOWindow_Destr
void  PLOWindow_Destr ( PLOWindow_pri * ) ;  

# define  PLOWindow_Init  Lisp2D_PLOWindow_Init
void  PLOWindow_Init  ( PLOWindow_pri * ) ;

// ! UChar -> Byte    
# define  isBADCreateColor  Lisp2D_isBADCreateColor
bool  isBADCreateColor  ( tUCharRGB , int coldep  , unsigned long int  * resultp ) ;  

FuncBining  Lisp2Dbimnilmapwindow2 ;  
  FuncBining  Lisp2Dbimnildisplaysize2   ;
  FuncBining  Lisp2Dbimnildisplaysizemm2   ;
  FuncBining  Lisp2Dbimnilscreencount2   ;
FuncBining Lisp2Dbimnilwindowp2  ;
  FuncBining  Lisp2Dbimwindowclose2 ;
  FuncBining  Lisp2Dbimwindowgetpixel2 ;
  FuncBining  Lisp2Dbimwindowwidth2 ;
  FuncBining  Lisp2Dbimwindowheight2 ;
  FuncBining  Lisp2Dbimwindowpointercoord2 ;
# ifdef  LISP2D_DEBUG  
  FuncBining  Lisp2Dbimwindowsysgetpixel2 ;
# endif  
  FuncBining  Lisp2Dbimwindowmove2  ;
  FuncBining  Lisp2Dbimwindowresize2  ;
  FuncBining  Lisp2Dbimwindowmapresize2 ;
FuncBining  Lisp2Dbimwindowrename2  ;
  FuncBining  Lisp2Dbimwindowopen2  ;
  FuncBining  Lisp2Dbimwindowopenp2 ;
  FuncBining  Lisp2Dbimwindowhide2  ;
  FuncBining  Lisp2Dbimdrawpixel2 ;
# ifdef  LISP2D_DEBUG  
  FuncBining  Lisp2Dbimwindowsysloadfont2 ;
# endif  
  FuncBining  Lisp2Dbimwindowwindow2 ;
  FuncBining  Lisp2Dbimwindowwaitevent2 ;
  FuncBining  Lisp2Dbimwindowcheckevent2  ;
  FuncBining  Lisp2Dbimwindowmakeevent2 ;
  FuncBining  Lisp2Dbimwindowpending2;

# define  GlobalListOfWindows Lisp2DGlobalListOfWindows
  extern  GlobalList  GlobalListOfWindows ;
# define  GlobalListOfWindowsGarbage  Lisp2DGlobalListOfWindowsGarbage
  extern  GlobalList  GlobalListOfWindowsGarbage  ;

# include "newobject.h"

IsNotTypeTemplDecl  ( window  )

typedef  struct  siLoadColor  iLoadColor ;    

struct  siLoadColor {
  unsigned long int const colors  ;
  int const coldep  ;
} ;

typedef  struct  soLoadColor  oLoadColor ;  

struct  soLoadColor {
  unsigned int  rn  ;
  unsigned int rd ;
  unsigned int gn ;
  unsigned int gd ;
  unsigned int bn ;
  unsigned int bd ;
  bool  isBAD ;
  } ;

# define  LoadColor Lisp2D_LoadColor
oLoadColor LoadColor  (iLoadColor);

// ! UChar -> Byte    
// longint -> r:0-255, g:0-255,b:0-255
# define  isBADLoadColor  Lisp2D_isBADLoadColor
bool  isBADLoadColor  ( unsigned long int colors  , tUCharRGB * uc , int coldep  ) ;

# ifndef  __cplusplus
# define  countWindowsThreads2  Lisp2D_countWindowsThreads2
extern  _Atomic  ( size_t  ) countWindowsThreads2  ;
# endif

# define  CountWindowsThreads2  Lisp2D_CountWindowsThreads2
size_t  CountWindowsThreads2(void);

# define  CountWindowsThreads2_Dec  Lisp2D_CountWindowsThreads2_Dec
void  CountWindowsThreads2_Dec(void);

# define  CountWindowsThreads2_Inc  Lisp2D_CountWindowsThreads2_Inc
void  CountWindowsThreads2_Inc(void);

# define  PLOWindow_priv_CreateThread Lisp2D_PLOWindow_priv_CreateThread
void  PLOWindow_priv_CreateThread ( PLOWindow_pri * , UIntXY wh ) ;

# define  PLOWindow_NewMap  Lisp2D_PLOWindow_NewMapD0vA
void PLOWindow_NewMap ( PLOWindow_pri * ,UIntXY wh ) ;

# define  ChooseBetterStyle Lisp2D_ChooseBetterStyle
XIMStyle ChooseBetterStyle  ( XIMStyle , XIMStyle ) ;

# define  PLOWindow_Open  Lisp2D_PLOWindow_OpenzYyK
bool  PLOWindow_Open(PLOWindow * ) ;

# define  PLOWindow_Hide  Lisp2D_PLOWindow_HideBoQK
void PLOWindow_Hide(PLOWindow_pri * )  ;

# define  PLOWindow_Pending Lisp2D_PLOWindow_Pending
void  PLOWindow_Pending ( PLOWindow_pri * me , size_t * resp ) ;
  
# define  PLOWindow_MapResize Lisp2D_PLOWindow_MapResizeQhGe
void  PLOWindow_MapResize(PLOWindow * , UIntXY wh )  ;

# define  PLOWindow_Resize  Lisp2D_PLOWindow_Resize0iIy
void  PLOWindow_Resize(PLOWindow * , UIntXY wh ) ;

# ifdef  LISP2D_DEBUG  

# define  PLOWindow_DrawLine  Lisp2D_PLOWindow_DrawLine0F8Q
void  PLOWindow_DrawLine  ( PLOWindow_pri const * , IntXY xy, IntXY xy2)  ;

# endif // LISP2D_DEBUG

# define  PLOWindow_Move  Lisp2D_PLOWindow_Move
void  PLOWindow_Move(PLOWindow const * ,IntXY ) ;

# include "stcl/public.h"
# include "stcl/inline.h"

# endif // LISP2D_DONTUSEX11
# endif // LISP2D_WINDOW_H
