// Lisp2D - Window
// ©2019-23
# ifndef  LISP2D_WINDOW_INLINE_H
# define  LISP2D_WINDOW_INLINE_H
# ifndef  LISP2D_DONTUSEX11
# include "window/public.h"
# include "window/private.h"

inline  ParaLispObject const * PLOWindow_cplo ( PLOWindow const * const c ) {
  return & PLOWindow_to_cpri  ( c ) ->  plo ;
}

inline  bool  PLOWindow_Opened  ( PLOWindow const * const me ) {
  return  PLOWindow_to_cpri ( me  ) -> opened  ;
}

# include "castb.h"

// ! to return bool isBAD..
inline  void  PLOWindow_SetWindowHeight2  ( PLOWindow * const me , unsigned int const h  ) {
  PLOWindow_to_pri  ( me  ) -> winheight  = uint_cast_int ( h ) ;
}

// ! to return bool isBAD..
inline  void  PLOWindow_SetWindowWidth2 ( PLOWindow * const me , unsigned int const w ) {
  PLOWindow_to_pri  ( me  ) -> winwidth = uint_cast_int ( w ) ;
}

inline  int PLOWindow_Height  ( PLOWindow const * const me ) {
  return  ( ( not ( PLOWindow_to_cpri ( me  ) -> opened ) ) ? 0 :
    PLOWindow_to_cpri ( me  ) -> winheight ) ;
}

inline  int PLOWindow_Width ( PLOWindow const * const me ) {
  return (  ( not  ( PLOWindow_to_cpri  ( me  ) -> opened ) ) ? 0 :
    PLOWindow_to_cpri ( me  ) -> winwidth  ) ;
}

inline  bool  Windowp ( ParaLispObject const * const xp ) {
  return  ParaLispObject_Type ( xp )  ==  TypeGlobalListMemberPLOWindowPri ;
}

inline  Display *  PLOWindow_MyDisplay ( PLOWindow_pri const * const me ) {
  return me -> dpy ;
}

inline  Window  * PLOWindow_MyWindow  ( PLOWindow_pri * const me ) {
  return & me -> win  ;
}

inline  GC  PLOWindow_MyGC2  ( PLOWindow_pri const * const me ) {
  return me -> gc ;
}

inline  int PLOWindow_ColorDefaultDepth ( PLOWindow_pri const * const me ) {
  return  me -> colordefaultdepth ;
}

inline  PLOWindow * ParaLispObjectToPLOWindow ( ParaLispObject * const p ) {
  return & ( ( PLOWindow_pri * ) ( p  ->  vaddr . addr . p ) ) -> pub ;
}

inline  PLOWindow const * ParaLispObjectToPLOWindowConst ( ParaLispObject const * const p ) {
  return & ( ( PLOWindow_pri const * ) ( p  ->  vaddr . addr . p ) ) -> pub ;
}

inline  ParaLispObject * PLOWindow_plo ( PLOWindow * const c ) {
  return & PLOWindow_to_pri ( c ) ->  plo ;
}

inline  size_t  PLOWindow_VectorHeight  ( PLOWindow const * const wp ) {
  return  PLOWindow_to_cpri ( wp  ) -> matrixsizeh ;
}

inline  size_t  PLOWindow_VectorWidth ( PLOWindow const * const wp ) {
  return PLOWindow_to_cpri  ( wp  ) -> matrixsizew  ;
}

# include "window/inlinepri.h"

# endif // LISP2D_DONTUSEX11
# endif // LISP2D_WINDOW_INLINE_H
